/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef ASK_FILE_H
#define	ASK_FILE_H

#include <stdio.h>

#include <xview/xview.h>
#include <xview/panel.h>

#include "str_def.h"
#include "error_constants.h"

struct dir_fn_item_rec
   {
    Panel_item dir_item;
    char *cur_dir;
    char *last_dir;
    int (*open_dir_proc)();
    void *open_dir_proc_arg;

    Panel_item fn_item,same,same_dir;
    char *fn_msg;
    char *cur_fn;
    char *last_fn;
    int (*choose_fn_proc)();
    void *choose_fn_proc_arg;
   };

struct chosen_fn_rec
   {
    char *dir,*fn;
    struct strs_rec more_dir_fns;
    struct strs_rec fns;
   };

struct dir_fn_rec
   {
    unsigned long total_dirs,num_dirs,cur_dir;
    struct chosen_fn_rec **dirs; 
   };

#define ASK_FILE_SETUP_OK 1
#define FREE_UPON_READY_AND_CANCEL 2
#define ASK_FILE_SAVE 4
#define ASK_FILE_LOAD 8
#define ASK_FILE_EDITED 16
struct ask_fn_rec
  {unsigned short status;
   char *title;
   Frame owner,frame;
   Panel panel;
   long num_dirfns;
   struct dir_fn_item_rec *dirfns;

   Panel_item filter_item,num_fn_item,total_fn_item,
              cur_total_fn_item,fns_item,ready_item;
   char *fn_filter;
   struct strs_rec fns;
   int last_chosen_indx,
       many,num_fns,total_fns,cur_total_fns;
   int (*chosen_fn_proc)();
   void *chosen_fn_proc_arg;

   struct dir_fn_rec dir;
   int (*ready_proc)();
   void *ready_proc_arg;
   int (*ask_cancel_proc)();
   void *ask_cancel_proc_arg;
   char *help_fn;
   int is_chdir;

   Panel_item user_item;
   Event user_event;
  };

#define CLEAN_UP_ASK_FILE 0
#define SETUP_ASK_FILE 1
#define GET_ALL_ASK_FILE_PTR 2

struct all_ask_fn_recs
  {
   long num_asks;
   struct ask_fn_rec **asks;
  };

#endif ASK_FILE_H
