/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  This header file creates data in addition to declaring stuff and
should really be an ordinary C source file.
****************************************************************************/


#ifndef MRI_HDR_CONSTANTS_H
#define MRI_HDR_CONSTANTS_H

struct hdr_field_rec
   {
    unsigned long id;
    int how_to_read;
    char *label;
    int has_been_read;
   };

#define INPUT_OUTPUT_FN 0
#define NAME 1
#define SSNUM 2
#define SEX 3
#define AGE 4
#define HEIGHT 5
#define WEIGHT 6
#define DEFAULT_DATA_FN 7
#define DIMX 8
#define DIMY 9
#define PIXEL_DEPTH_BITS 10
#define MAX_SLICES 11
#define NUM_SCANS 12
#define MIN_PIXEL 13
#define MAX_PIXEL 14
#define XPIXEL_SIZE 15
#define YPIXEL_SIZE 16
#define PIXEL_THICKNESS 17 
#define TRANSFORMATION_MATRIX_4_BY_4 18
#define NUM_KIND_OF_IMAGES 19
#define IMAGE_TYPE 20
#define COMMENT 21
#define PLANE_TYPE 22
#define DATE_OF_STUDY 23
#define TIME_OF_STUDY 24
#define PATIENT_ID 25
#define STUDY_NUM 26
#define PATIENT_NUM 27
#define REFERED_BY 28
#define DESCRIPTION 29
#define HOSP_NAME 30
#define SPACING 31
#define TR 32
#define TE 33
#define VAR_USE_STATUS 34
#define UNUSED1 35   
#define UNUSED2 36   
#define UNUSED3 37 
#define UNUSED4 38 
#define UNUSED5 39 
#define UNUSED6 40 
#define UNUSED7 41 
#define END_OF_INPUT 42
#define TOTAL_USER_DEFINED_FIELDS 42
#define TOTAL_FIELDS 43
#define NO_MORE_INPUT 1000

#define RD_TEXT_INPUT 1
#define RD_INT_INPUT 2
#define RD_REAL_INPUT 3
#define RD_MATRIX_INPUT 4
#define RD_NUM_KIND_OF_IMAGES 5
#define RD_TEXT_SEQUENCE 6

/* The following table is actually defined in wr_hdr_bin.c */

extern struct hdr_field_rec mri_hdr_fields[TOTAL_FIELDS];

#endif  /* MRI_HDR_CONSTANTS_H */
