/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef OBJECT_H
#define	OBJECT_H
#include "rect.h"
#include "common.h"

#define ADD_NUM_XY_RECS 50

#define OBJ_INTERNAL_PT 0x0001
#define OBJ_BOUNDARY_PT 0x0002
#define OBJ_DELETED_PT 0x0004
#define OBJ_NEGATIVE_PT 0x0008
#define OBJ_SET_PT 0x000f
#define OBJ_BREAK_PT 0x0010
#define OBJ_BOUNDED_EDGE 0x0020
struct xy_rec 
   {unsigned char status;
    short x,y;
   };

#define RESET_OBJ_STATUS 0
#define OBJ_PTS_XY_SORTED 1
struct object_rec
   {
    unsigned char is_external; /* is_external is used to indicate if this
                                  object o1 is external to the scanned object o2
                                  It is set if any pt in o1 is adjacent to the
                                  boundary of o2 during the negative object
                                  detection.
                               */
    unsigned long id;
    unsigned short status;
    struct int_bound_rec bound;
    unsigned long total_pts,num_pts;
    struct xy_rec *pts;
    struct all_object_rec *excluded_regions;
    unsigned long total_merged_objs,num_merged_objs;
    struct object_rec **merged_objs;
    struct object_rec *owner;
   };

#define ID_IN_255 1
#define ID_255_ALL_USED 2
#define ID_IN_65535 4
#define ID_65535_ALL_USED 8
#define ID_IN_4_BYTES 16
#define ID_4_BYTES_ALL_USED 32
struct all_object_rec
   {
    struct buf_2d_rec *in_2d;
    struct int_bound_rec bound;
    unsigned long lbval,ubval;

    struct buf_2d_rec id_2d;
    unsigned long next_id;
    unsigned short id_status;
    struct object_rec *cur_obj;
    unsigned long total_objs,num_objs;
    struct object_rec **objs;
   };


#endif OBJECT_H
