/******
rect.h - ???
******/
/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef RECT_H
#define	RECT_H

/* The following codes are used in the table inverse_rect_overlap_status,
   which is defined in common.c */
#define RECT_NO_OVERLAP 0
#define RECT_EQUAL 1
#define RECT_CONTAINED 2
#define RECT_CONTAINS 3
#define RECT_OVERLAPS_AT_TL_CORNER 4
#define RECT_OVERLAPS_AT_TL_CORNER_PT 5
#define RECT_OVERLAPS_AT_TR_CORNER 6
#define RECT_OVERLAPS_AT_TR_CORNER_PT 7
#define RECT_OVERLAPS_AT_BR_CORNER 8
#define RECT_OVERLAPS_AT_BR_CORNER_PT 9
#define RECT_OVERLAPS_AT_BL_CORNER 10
#define RECT_OVERLAPS_AT_BL_CORNER_PT 11
#define RECT_OVERLAPS_AT_TOP_EDGE 12
#define RECT_OVERLAPS_AT_TOP 13
#define RECT_OVERLAPS_AT_RIGHT_EDGE 14
#define RECT_OVERLAPS_AT_RIGHT 15
#define RECT_OVERLAPS_AT_BOTTOM_EDGE 16
#define RECT_OVERLAPS_AT_BOTTOM 17
#define RECT_OVERLAPS_AT_LEFT_EDGE 18
#define RECT_OVERLAPS_AT_LEFT 19
#define RECT_OVERLAPS_AT_TL_EDGE 20
#define RECT_OVERLAPS_AT_TR_EDGE 21
#define RECT_OVERLAPS_AT_BR_EDGE 22
#define RECT_OVERLAPS_AT_BL_EDGE 23

#define RECT_OVERLAPS_AT_LT_EDGE 24
#define RECT_OVERLAPS_AT_RT_EDGE 25
#define RECT_OVERLAPS_AT_RB_EDGE 26
#define RECT_OVERLAPS_AT_LB_EDGE 27

extern int inverse_rect_overlap_status[];

struct int_rect_rec
   {
    int left,top;
    int width,height;
   };
/*
struct int_region_rect
   {int win_dimx,win_dimy;
    int dimx,dimy,left,top,right,bottom;
   };
*/
struct int_bound_rec
   {int left,top,right,bottom;
   };

struct short_bound_rec
   {
    short left,top,right,bottom;
   };

struct float_bound_rec
   {
    float left,top,right,bottom;
   };

#define DIM_MAX_AREA 1
#define DIM_FIXED_BOUND 2
#define DIM_FIXED_MAG 3

#define DIM_CENTER_AT_LIMITBOUNDRECT 1
#define DIM_CENTER_AT_POINT 2
#define DIM_OPR_SAME_DIM_MAG_FACTOR 4
#define DIM_OPR_USE_SMALLER_MAG_FACTOR 8
#define DIM_SHRINK 16
struct int_region_rect
   {
/* 
   magrect.left & magrect.top specify the current magnifications of a pixel
       in the x & y directions respectively, starting with 1.
   magrect.width & magrect.height specify the max allowable magnifications
      for both x & y dimensions

   limitboundrect is the rectangle that bounds the image region 
       to be displayed on the screen.  Suppose the image size is [0..255] in 
       both the x & y dimensions, typical values for limitboundrect are
         limitboundrect.left = limitboundrect.top = 0 &
         limitboundrect.width = limitboundrect.height = 255

   bound is the sub image region of limitboundrect currently being displayed
      
   limitrr is the possible screen area in which the image is realized.
   rr.left is the screen x position, & rr.top screen y position.
   rr.width = (bound.right - bound.left + 1) * magrect.left;
   rr.height = (bound.bottom - bound.top + 1) * magrect.top;
   rr is limited by limitrr.
*/
    struct int_rect_rec limitrr,rr;
    struct int_rect_rec magrect,limitboundrect;
    struct int_bound_rec bound;
   };


#endif RECT_H
