/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This header file appears to define various strings that are used in the
GUI interface and must be passed to XView; using the full strings would
make the call even more obscure than it already is.
****************************************************************************/


#ifndef RIA_DEFINE_CONSTANTS_H
#define	RIA_DEFINE_CONSTANTS_H

#define FILE_MENU "FILE MENU"
#define IMAGE_MENU "IMAGE MENU"
#define ROI_MENU "ROI MENU"
#define PIXEL_TYPE_ANALYSIS_STR "PIXEL TYPE ANALYSIS"
#define GA_STR "GA"
#define TA_STR "TA"
#define CA_STR "CA"
#define PIXEL_TYPE_GA_STR "GA = TYPE : GROW REGION - Ctrl G"
#define PIXEL_TYPE_TA_STR "TA = TYPE : THRESHOLDING - Ctrl T"
#define PIXEL_TYPE_CA_STR "CA = COUNT VALUE ANAL - Ctrl C"
#define PIXEL_TYPE_GROW_REGION_ANALYSIS_STR "PIXEL TYPE GROW REGION ANALYSIS"
#define PIXEL_TYPE_PARTITION_ANALYSIS_STR "PIXEL TYPE PARTITION ANALYSIS"
#define CA_OPTIONS_STR "CA OPTIONS... - Sh O"
#define PROCESS_SLICE_SCANS_STR "PROCESS SLICE SCANS...- <> I"

#define SELECT_FNS_MENU "OPEN IMAGE FILES... - <> O"
#define IMAGE_CONTRAST "IMAGE CONTRAST... - U"
#define COLOR_PALLETTES "COLOR PALLETTES - Ctrl F1"
#define DEF_IMAGE_COLOR_SCALE "DEF IMAGE COLOR SCALE - Ctrl F2"
#define NTH_IMAGE_COLOR_SCALE "Nth IMAGE COLOR SCALE - Ctrl F3"

#define IMAGE_VIEW_FILTER "IMAGE VIEW FILTER... - <> G"
#define PIXEL_SELECTION "PIXEL SELECTION... - <> P"
#define GROW_REGION "GROW REGION... - <> T"
#define _3D "3D (INTERPOLATED) - R"
#define _3D_CLOSEST_VALUE "3D (CLOSEST VALUE) - Ctrl R"
#define CURSOR_MODE "CURSORS - Sh ' ' || ' '"
#define MODIFY_IMAGE "MODIFY IMAGE... <> M"
#define RESIZE_IMAGE "RESIZE IMAGE... <> ="
#define REVERSE_IMAGES "REVERSE_IMAGES - <> R"
#define RESIZE_TO_WID_SIZE "RESIZE TO WID SIZE - ="
#define RESIZE_DEFAULT "DEF SIZE & ORIENTATION - Sh ="
#define RESIZE_DEFAULT_SIZE "DEFAULT SIZE - Ctrl Sh ="
#define RESIZE_LAST "LAST SIZE & ORIENTATION - Ctrl <> ="
#define RESIZE_ZOOM_IN "ZOOM IN - Ctrl ="
#define RESIZE_ZOOM_OUT "ZOOM OUT - Ctrl Sh ="

#define PRINT_OR_SAVE_IMAGE "PRINT OR SAVE IMAGE"
#define COLOR_EDITOR "COLOR EDITOR... - Ctrl Sh F9"
#define WINDOW_MENU "WINDOW MENU"
#define QUIT_AND_SAVE_FILE "QUIT AND SAVE FILE - Ctrl Q"
#define EXIT_PROGRAM "QUIT PROGRAM - <> Q"
#define HELP_STR "HELP"

#define MENU_SEPARATOR "   ------   "
#define HDR_SUFFIX ".nhdr"
#define DAT_SUFFIX ".ndat"
#define TXT_SUFFIX ".ntxt"
#define BIN_SUFFIX ".nbin"
#define NPAR_SUFFIX ".npar"
#define NPCO_SUFFIX ".npco"
#define PIXMAP_SUFFIX ".pixmap"
#define COUNT_SUFFIX ".count"
#define NO_ROI_STR "*** NO ROI ***"
#define NO_PIXEL_TYPE_STR "*** NO PIXEL TYPES DEFINED YET ***"
#define IMAGE_ANALYSIS_PROGRAM "IMAGE ANALYSIS"
#define NO_EDITING "NO EDITING !"

#define TISSUE_TYPES_DEFINED "TISSUE TYPES DEFINED"

#define BATCH_FILE_MENU "BATCH IMAGE FILES - Ctrl Sh F9"
#define ABOUT_RIA "ABOUT RIA - Ctrl Sh F10"
#define BEGINNER_HELP "BEGINNER'S GUIDE - Ctrl Sh F11"

#define ABOUT_RIA_FN "about_ria.help"
#define DISPLAY_MENU_HELP_FN "display_menu.help"
#define ANALYSIS_MENU_HELP_FN "analysis_menu.help"
#define GET_DIR_FN_MENU_HELP_FN "get_dir_fn_menu.help"
#define BEGINNER_HELP_FN "beginner_guide.help"
#define COLOR_EDITOR_HELP_FN "color_editor.help"
#define BATCH_HELP_FN "batch.help"
#define TEXT_FORMAT_HELP_FN "text_format.help"
#define PIXEL_SELECTION_HELP_FN "pixel_selection.help"

/* GENERIC WINDOW MENU ITEM STRINGS */
#define SLICE_SELECTION_MENU "SELECT SLICE... - F1"
#define PEN_ENABLED  "PEN ENABLED - F2"
#define PEN_DISABLED "PEN DISABLED - F2"

#define LABEL_ROI_AND_CURVE "LABEL ROI & REGION - N"

#define SHOW_ROI "SHOW SLICE ROIS - F4"
#define SHOW_PIXEL_TYPE_ROI "SHOW PIXEL TYPE LABELS - F3"
#define EDIT_ROI_BOUND "EDIT ROI BOUND...-<> F8"
#define ROI_OPTIONS "MORE ROI OPTIONS"
#define HIGHLIGHT_NEXT_CURVE "NEXT REGION - [Sh] F5/Sh MLEFT"
#define HIGHLIGHT_NEXT_ROI "NEXT ROI - [Sh] F7/Sh MLEFT"
#define EDIT_NEXT_NEW_CURVE "EDIT NEXT NEW REGION - F8"
#define EDIT_SCRATCH "EDIT ***SCRATCH*** - <CR>"
#define ALL_WINS_CUR_ROI "CUR ROI IN ALL WINS - F6"
#define SLICE_RECT "SLICE RECT - Sh F9"
#define DELETE_ROI "DELETE MENU...-<> D"
#define REVERSE_SLICE_ROIS "REVERSE SLICE ROIS...- Ctrl <> R"
#define IMPORT_SLICE_ROIS "IMPORT SLICE ROIS...- Ctrl Sh R"
#define DRAW_LINK "DRAW LINK... - <> \\"
#define DRAW_LINK_WITH_WID "DRAW LINK WITH WID - \\"
#define DELETE_DRAW_LINK_WITH_WID "DELETE DRAW LINK... - |"

#define CO_REGISTER_FILE "CO-REGISTER FILES IN 2D... - <> J"
#define CO_WID_FILE "CO-REGISTER WITH WID FILE - J"
#define UNCO_WID_FILE "UNCO-REGISTER WITH NON-DEFAULT FILE PARAMS - Sh J"
#define SAVE_CO_FILE "SAVE CO-REG FILE PARAMS - M"
#define LOAD_CO_FILE "LOAD CO-REG FILE PARAMS - I"
#define REVERSE_CO_FILE_PARAMS "REVERSE CO-REG FILE PARAMS - Ctrl Sh J"
#define DEF_CO_FILE_PARAMS "DEFAULT CO-REG FILE PARAMS - Ctrl Sh J"

#define BREAKER "BREAKER OPTIONS... - <> B" 
#define BREAKER_ENABLE "ENABLE BREAKER - Ctrl B"
#define BREAKER_LABEL "BREAKER"
#define BREAKER_UNDO_LABEL "BREAKER UNDO"
#define BREAK_IT "BREAK CUR REGION - Sh B"
#define BREAK_UNDO "UNDO - <Undo>"

#define CLIPBOARD "CUT/COPY/PASTE"
#define CUT "CUT - X / CUT"
#define CUT_APPEND "CUT AND APPEND - Sh X / Ctrl CUT"
#define PASTE "PASTE CUR REGION - V"
#define COPY "COPY - C / COPY"
#define COPY_APPEND "COPY AND APPEND - Sh C / Ctrl COPY"
#define CLIPBOARD_FIRST "SHOW CLIPBOARD FIRST - <> F11"
#define CLIPBOARD_LAST "SHOW CLIPBOARD LAST - <> F11"
#define PASTE_ALL "PASTE ALL - Paste"

#define BKG_PIXELS "SET IMAGE BACKGROUND... - B"
#define HISTOGRAM_ROI "HISTOGRAM - F9"
#define HISTOGRAM_OPTIONS "HISTOGRAM OPTIONS...- Ctrl F9"
#define IMPORT_PIXEL_TYPE_MAP "IMPORT PIXEL TYPE MAP"
#define HISTO_CURRENT_SLICE_1D "1D-HISTOGRAM CURRENT SLICE - Ctrl F5"
#define HISTO_ALL_SLICES_1D "1D-HISTOGRAM ALL SLICES - Ctrl F6"
#define HISTO_CURRENT_SLICE "2D-HISTOGRAM CURRENT SLICE - Ctrl F7"
#define HISTO_ALL_SLICES "2D-HISTOGRAM ALL SLICES - Ctrl F8"
#define HISTO_SHOW "SHOW HISTOGRAM - H"
#define HISTO_CLEAR "CLEAR HISTOGRAM - K"
#define PARTITION_PIXEL_TYPES "PARTITION ALL SLICES - F10"
#define SEGMENT_PIXEL_TYPES "SEGMENT ALL SLICES - F10"
#define GROW_REGION_OPTIONS "GROW REGION OPTIONS... - Sh F10"
#define EDITED_PIXEL_TYPES "ROI -> EDITED PIXEL TYPE - Ctrl F1"
#define PARTITIONED_PIXEL_TYPES "ROI -> PARTITIONED - Ctrl F2"

#define ANALYSIS_STR "ANALYZE ALL SLICES... - Sh A"
#define ANALYSIS_CUR_SLICE_STR "ANALYZE CURRENT SLICE - A"
#define PIXEL_TYPE_FORMAT "PIXEL TYPE TEXT FORMAT...- Sh F12"
#define COUNT_FORMAT "COUNT TEXT FORMAT...- Sh F12"
#define OUTPUT_ANALYSIS "OUTPUT ANALYSIS"
#define SAVE_TEXT_TO_FILE "SAVE TEXT FILE - Y"
#define SAVE_THEN_PRINT_TEXT "SAVE THEN PRINT TEXT FILE - Ctrl F10"
#define PRINT_TEXT_TO_WINDOW "DISPLAY TEXT FILE - T"
#define PRINT_ROIS_AND_PIXEL_TYPES "DISPLAY ROIS & PIXEL TYPES - Ctrl M"
#define SHOW_ROI_PIXEL_TYPE "SHOW THE ROI PIXEL TYPE - ,"
#define DONT_SHOW_ROI_PIXEL_TYPE "DON'T SHOW ROI PIXEL TYPE - ,"
#define SHOW_ALL_ROIS_PIXEL_TYPE "SHOW ALL ROI PIXEL TYPES - ."
#define DONT_SHOW_ALL_ROIS_PIXEL_TYPE "DON'T SHOW ALL ROI PIXEL TYPES - ."
#define SHOW_SLICE_PIXEL_TYPE "SHOW SLICE PIXEL TYPE - /"
#define DONT_SHOW_SLICE_PIXEL_TYPE "DON'T SHOW SLICE PIXEL TYPE - /"
#define FILTER_SHOW_TISSUES "FILTER & SHOW TISSUES... - <> N"
#define SHOW_TISSUE_WINS "SHOW TISSUES IN WINDOWS - Sh N"

#define SEGMENT_SLICE "SEGMENT CUR SLICE - F12"

#define SAVE_DATA "SAVE/LOAD DATA... - <> S"
#define ANALYSIS_MENU_HELP "HELP - <Help>"
#define REDEFINE_PIXEL_TYPE_ORDER "PIXEL TYPE PRIORITY... - Sh <> R"
#define OUTPUT_BIN "SAVE IMAGE TYPE BINARY..."

#define SAVE_CUR_WIN_IMAGE "SAVE CUR WINDOW IMAGE - Ctrl P"
/*
#define PRINT_CURRENT_IMAGE "PRINT CURRENT IMAGE - Sh P"
#define PRINT_ALL_IMAGES "PRINT ALL IMAGES"
*/

#define SAVE_DAT_FILE "SAVE .ndat - S"
#define LOAD_FILE_SLICE_ROIS "TRASH & LOAD GIVEN NDAT FILE SLICE ROIS"
#define RELOAD_SLICE_ROIS "TRASH & RELOAD SAME NDAT FILE SLICE ROIS - Ctrl Sh Q"
#define RELOAD_CUR_SLICE_ROIS "TRASH & RELOAD CURRENT SLICE ROIS - Sh <> L"
#define RELOAD_PIXMAP "TRASH & RELOAD .pixmap - Sh <> Q"
#define LOAD_DAT_FILE "TRASH & LOAD FILE DATA - <> L"
#define ENTER_DAT_FN "CHANGE .ndat FILE NAME - <> D"
#define FILE_INFO "INFO - Sh <> I"
#define ENTER_FILE_COMMENT "EDIT FILE COMMENT - <> E"

#define OPTIONS "ANALYZE IMAGE - Sh F1"
#define ALL_ECHO_WINS "ALL ECHO WINDOWS - Sh W"
#define GET_NEW_WINS "GET NEW WINDOWS... - W"
#define DUPLICATE_WINDOW  "DUPLICATE WINDOW - Ctrl W"
#define SLAVE_WINDOW   "SLAVE WIN/POSITIONING - <> M-LEFT"
#define GET_4_WINS "4 WINDOWS - Sh Tab"
#define GET_4_WINS_ALL_ECHOES "4 WINDOWS (ALL ECHOES) - Tab"
#define GET_9_WINS "9 WINDOWS - Sh Q"
#define GET_9_WINS_ALL_ECHOES "9 WINDOWS (ALL ECHOES) - Q"
#define GET_12_WINS "12 WINDOWS - Sh E"
#define GET_12_WINS_ALL_ECHOES "12 WINDOWS (ALL ECHOES) - E"
#define STACK_SLICE_OR_SCAN "STACK SLICE/SCAN - <> Z"
#define MAGNIFY_PIXEL "MAGNIFY PIXEL... - Sh F2"
#define EXIT_DISPLAY_WINDOW "QUIT CURRENT WINDOW... - Ctrl Sh F6"
#define EXIT_MULTIPLE_DISPLAY_WINDOW "QUIT MULTIPLE WINDOWS - Ctrl Sh F7"
#define EXIT_STACK_WINDOWS "QUIT STACK/GROUP WINDOWS - Ctrl Sh F8"

#define DISPLAY_MENU_HELP "HELP Sh <Help>"
#define IMAGE_ENHANCEMENT "IMAGE ENHANCEMENT- <> Y"
#define EDGE_DETECTION "EDGE DETECTION... - <> E"
#define POLARITY "POLARITY"

/* magnify pixel menu items */
#define MAGNIFY_WINDOW "MAGNIFY +2 - <> M-MIDDLE/<> <0..9>"
#define MAGNIFY_SHRINK_WINDOW  "SHRINK -2 - <> M-RIGHT"
#define MAGNIFY_LAST_WINDOW "MAGNIFY TO LAST DIMENSION - ESC"
#define MAGNIFY_DEFAULT_WINDOW "MAGNIFY TO DEFAULT DIMENSION - Ctrl Tab"


/* GENERIC PEN TYPE MENU ITEM STRINGS */
#define PEN_FREE_AND_CLOSED "FREE-HAND POLYGON - F"
#define PEN_FREE_AND_CLOSED_LABEL "<F>FREE-POLYGON"
#define PEN_POLYGON "POLYGON - P"
#define PEN_POLYGON_LABEL "<P>POLYGON"
#define PEN_LINE "LINES - L"
#define PEN_LINE_LABEL "<L>LINE"
#define PEN_FREE "FREE-HAND REGIONS - :"
#define PEN_FREE_LABEL "<:>FREE"
#define PEN_POINT_MODE "POINT MODE - Ctrl ."
#define PEN_POINT_MODE_LABEL "<Ctrl .>POINT"

#define PEN_CIRCLE "CIRCLE - O"
#define PEN_CIRCLE_LABEL "<O>CIRCLE"

#define PEN_ELLIPSE "ELLIPSE - ;"
#define PEN_ELLIPSE_LABEL "<;>ELLIPSE"

#define PEN_RECT "RECTANGLE - ["
#define PEN_RECT_LABEL "<[>RECT"

/* GENERIC DISPLAY OPTION MENU ITEM STRINGS */
#define HIDE_SHOW_ALL_ROIS_OF_CURRENT_SLICE "HIDE/SHOW ALL ROIS - Sh Z"
#define HIDE_ALL_ROIS_OF_CUR_SLICE_BUT_CUR "HIDE/SHOW ALL ROIS BUT CUR- Z"
#define FILL_ROIS "SHADE ROIS - Sh R"
#define DONT_FILL_ROIS "DON'T SHADE ROIS - Sh R"
#define DISPLAY_PEN_ENABLED_LABEL "DISPLAY PEN ENABLED LABEL-Sh <> B"
#define DONT_DISPLAY_PEN_ENABLED_LABEL "DON'T DISPLAY PEN ENABLED LABEL-Sh <> B"
#define DISPLAY_THE_PIXEL_POSITION "DISPLAY THE PIXEL POSITION-Sh <> A"
#define DONT_DISPLAY_THE_PIXEL_POSITION "DON'T DISPLAY THE PIXEL POSITION-Sh <> A"
#define OUT_OF_BOUND_ROIS "OUT OF BOUND ROIS"
#define MAKE_ROI_CONVEX "MAKE CUR ROI CONVEX"

/* GENERIC DELETE_ROI MENU ITEM STRINGS */
#define DELETE_CURRENT_POINT_STR "DELETE CURRENT POINT - DELETE/BACKSPACE"
#define DELETE_CURRENT_CURVE_STR "DELETE CURRENT REGION - Ctrl Sh F1"
#define DELETE_CURRENT_ROI_STR "DELETE CURRENT ROI - Ctrl Sh F2"
#define DELETE_ALL_ROIS_STR "DELETE ALL ROIS - Ctrl Sh F3"
#define DELETE_ALL_FILE_ROIS_STR "DELETE ALL FILE ROIS - Ctrl Sh F4"

#define _3D_FILE_MENU "IMAGE OPTIONS...- N"
#define _3D_IMAGE_OPTIONS "3D IMAGE OPTIONS - N"
#define _3D_MENU "3D PLANE OPTIONS - P"
#define _3D_PLANE_OPTIONS "PLANE OPTIONS... - P"
#define _3D_MORE_PLANE_OPTIONS "MORE PLANE OPTIONS... - I"
#define _3D_RESIZE_IMAGE "RESIZE 3D IMAGE... - `"
#define _3D_CO_REGISTRATION "CO-REGISTRATION... - M"
#define _3D_ROI_TYPE_MENU "3D ROIS & PIXEL TYPES - <> ."
#define _3D_ROIS_PIXEL_TYPES "ROIS & PIXEL TYPES... - <> ,"
#define _3D_SPLIT_ROIS_MENU "3D SPLIT ROIS..."
#define _3D_SPLIT_ROIS "SPLIT ROIS..."
#define _3D_DISPLAY_MENU "3D DISPLAY OPTIONS"
#define _3D_DISPLAY_OPTIONS "DISPLAY OPTIONS..."
#define _3D_SAVE_MENU "SAVE 3D IMAGE... - S"
#define _3D_PARAM_MENU "PARAMETER... -Sh P"

#define _3D_CURSOR_MENU "CURSORS - Sh ' ' || ' '"
#define _3D_CUT_MODE "90 DEGREE CUT"
#define _3D_ANGLE_CUT_MODE "ANGLE CUT"
#define _3D_ROTATE_VERTICAL_MODE "VERTICAL ROTATE"
#define _3D_ROTATE_HORIZONTAL_MODE "HORIZONTAL ROTATE"
#define _3D_ROTATE_MODE "OBSOLUTE ROTATE"

#define _3D_ORIENTATION "ORIENTATION - F11"
#define _3D_0_ROTATION "0 ROT. - R12/Sh-R12"
#define _3D_90_ROTATION "90 ROT. - R8/Sh-R8"
#define _3D_180_ROTATION "180 ROT. - R10/Sh-R10"
#define _3D_270_ROTATION "270 ROT. - R14/Sh-R14"
#define _3D_Y_X_REFLECTION "\\ REFLECTION - R7"
#define _3D_YX_REFLECTION "/ REFLECTION - R9"
#define _3D_NO_REFLECTION "NO REFLECTION - R11"
#define _3D_Y_REFLECTION "| REFLECTION - R13"
#define _3D_X_REFLECTION "--- REFLECTION - R15"
#define FLIP_PLANE_CLOCKWISE "FLIP PLANE CLOCKWISE - -"
#define FLIP_PLANE_ANTI_CLOCKWISE "FLIP PLANE CLOCKWISE - +"

#define _3D_LAST_PLANE "LAST PLANE - Ins"

#define _3D_BUTTON_STR "3D"

#define ANAL "ANAL"
#define WIN "WIN"

#define IMAGE_FUSION_MENU "IMAGE FUSION...-<> F"
#define OVERLAY_IMAGE "OVERLAY IMAGE"
#define OVERLAYED_BY_WID "OVERLAYED BY WID - \'"
#define OVERLAYED_BY_WID_STACK "OVERLAYED BY WID STACK - Ctrl \'"
#define OVERLAYED_BY_ALL_ECHO_WID "OVERLAYED BY ALL ECHO WID - <> \'"
#define OVERLAYED_BY_ALL_ECHO_WID_STACK "OVERLAYED BY ALL ECHO WID STACK - Ctrl <> \'"
#define DELETE_OVERLAY "DELETE OVERLAY - Sh \'"
#define DELETE_OVERLAY_STACK "DELETE OVERLAY STACK - Sh Ctrl \'"
#define SHOW_HIDE_OVERLAY "SHOW/HIDE OVERLAY - Sh <> \'"
#define SHOW_HIDE_OVERLAY_STACK "SHOW/HIDE OVERLAY STACK - Sh Ctrl <> \'"

#define CHANNEL_MENU "CHANNEL TO...-Ctrl<MRIGHT>"
#define IMAGE_HISTOGRAM_WINDOW "HISTOGRAM WINDOW -<> H"
#define MAKE_WINDOW_CURRENT "MAKE WINDOW CURRENT...-Ctrl Y"
#define CLOSE_WIN "CLOSE WINDOW"
#define CLOSE_STACK_WINS "CLOSE STACK WINDOWS"
#define CLOSE_FILE_WINS "CLOSE FILE WINDOWS"
#define OPEN_WIN "OPEN WINDOW"
#define OPEN_STACK_WINS "OPEN STACK WINDOWS"
#define OPEN_FILE_WINS "OPEN FILE WINDOWS"

#define OPERATION_ABORTED "Operation Aborted !!!"
#define PLEASE_WAIT "Please wait !!!"
#define OK "OK !!!"
#define MEMORY_ERR "PROBABLY MEMORY ERROR !!!"
#define GRADIENT "GRADIENT"
#define GRADIENTX "GRADIENT X"
#define GRADIENTY "GRADIENT Y"
#define SEGMENTED " : SEGMENTED"
#define EDITED " : EDITED"
#define PARTITIONED " : PARTITIONED"
#define MARKER " : MARKER"
#define EMPTY " : EMPTY"

#define ALL_SLICES_LABEL "ALL SLICES"
#define ALL_ROIS_LABEL "ALL ROIS"
#define CUR_ROI_LABEL "ROI"
#define CUR_CURVE_LABEL "CUR REGION"

#define TRANS_ROI "MOVE/ROTATE/RESIZE ROI... - <>F1"
#define ALL_SLICES_ITEM_LABEL "ALL SLICES - <>F2"
#define ALL_ROIS_ITEM_LABEL "ALL ROIS - <>F3/M-RIGHT"
#define CUR_ROI_ITEM_LABEL "ROI - <>F4/M-MIDDLE"
#define CUR_CURVE_ITEM_LABEL "CUR REGION - <>F5"
#define SLICE_ROI_PRIOR "<< SLICE ROIS - <>F6"
#define SLICE_ROI_NEXT ">> - <>F7"

#define CURSOR_DEFAULT_LABEL "DEFAULT - KP1"
#define CURSOR_PEN_LABEL "PEN - KP2"
#define CURSOR_DELETE_ROI_MODE "DELETE ROI MODE - KP3"
#define CURSOR_MOVE_ROI_LABEL "MOVE ROI - KP4"
#define CURSOR_RESIZE_ROI_LABEL "RESIZE ROI - KP6"
#define CURSOR_ROTATE_ROI_LABEL "ROTATE ROI - KP5"

#define PIXEL_TYPES_TO_HISTO_ROIS "TYPES TO HISTO-ROIS - Sh T"
#define CUR_SLICE_TYPES_TO_HISTO_ROIS "CUR SLICE TYPES TO HISTO-ROIS - Sh T"
#define ALL_SLICE_TYPES_TO_HISTO_ROIS "ALL SLICE TYPES TO HISTO-ROIS - Sh Y"

#define CUR_ROI_TO_HISTO_ROI "CUR ROI TO HISTO-ROI - Sh H"
#define CUR_ROI_TO_HISTO_POINTS "CUR ROI TO HISTO-ROI POINTS"
#define CUR_ROI_TO_HISTO_CONVEX_REGION "CUR ROI TO HISTO-ROI - CONVEX REGION"
#define CUR_ROI_TO_HISTO_RANGE_REGION "CUR ROI TO HISTO-ROI - RANGE REGION"
#define HISTO_ROI_TO_SLICE_ROI "CUR HISTO ROI TO SLICE-ROI - Ctrl B"

#define WHOLE_SLICE_STR "WHOLE SLICE"
#define CUR_ROI_STR "CUR ROI"
#define CUR_CURVE_STR "CUR REGION"
#define ALL_ROIS_STR "ALL ROIS"
#define VIEW_FILTER_ROI_STR "VIEW FILTER ROI"


#define HISTO_ROI "HISTO-ROI"
#define SLICE_ROI "SLICE-ROI"

#define YES " YES !"
#define NO " NO !"
#define WILL_CONTINUE "WILL CONTINUE !"
#define NON_BACKGROUND "NON-BACKGROUND"
#define HISTO_NON_BACKGROUND "HISTO-NON-BACKGROUND"

#define SLICE_RECT_ROI "SLICE-RECT"

#define _3D_PT1_LABEL "3D-PT1"
#define _3D_PT2_LABEL "3D-PT2"
#define _3D_PT3_LABEL "3D-PT3"

#define ROI_INVISIBLE "ROI-:"

#define NO_OTHER_FILE_WID "NO OTHER FILE WIDs !!!"
#define RECO_REGISTER_WITH_WID "RECO-REGISTER WITH WID"
#define SCRATCH_STR "***SCRATCH***"
#define PIXEL_TYPE_3D_ID "\2PIXEL-TYPES"
#define IMPORT_IMG "IMPORT IMAGE FILES - <> F12"
#define GROW_ROI_LABEL "GROWN-ROI"

/* Changed the following line to a #define, since there was
   no apparent reason to create a variable instead.  -PWH 19990312
   static char *FAILED = " Operation Failed !";  */
#define FAILED  " Operation Failed !"


#define VALUE_ABOUT_RIA 1
#define VALUE_DISPLAY_MENU_HELP 2
#define VALUE_ANALYSIS_MENU_HELP 3
#define VALUE_GET_DIR_FN_MENU_HELP 4
#define VALUE_BEGINNER_HELP 5
#define VALUE_COLOR_EDITOR_HELP 6
#define VALUE_BATCH_HELP 7
#define VALUE_TEXT_FORMAT_HELP_FN 8
#define VALUE_PIXEL_SELECTION_HELP_FN 9

#define VALUE_LABEL_CURVE 1
#define VALUE_INCLUDE_FILE_LABELS 2

#define VALUE_BREAK_IT 1
#define VALUE_BREAK_UNDO 2
#define VALUE_BREAKER_ENABLE 3

#define VALUE_CUT 1
#define VALUE_CUT_OPTION 2
#define VALUE_CUT_APPEND 3
#define VALUE_CUT_APPEND_OPTION 4
#define VALUE_PASTE 5
#define VALUE_COPY 6
#define VALUE_COPY_OPTION 7
#define VALUE_COPY_APPEND 8
#define VALUE_COPY_APPEND_OPTION 9
#define VALUE_CLIPBOARD_FIRST 10
#define VALUE_PASTE_ALL 11

#define VALUE_PRINT_CURRENT_IMAGE 1
#define VALUE_PRINT_ALL_IMAGES 2
#define VALUE_SAVE_CURRENT_WIN_IMAGES 3

#define VALUE_EDITED_PIXEL_TYPES 1
#define VALUE_PARTITIONED_PIXEL_TYPES 2

#define VALUE_SAVE_DAT_FILE 1
#define VALUE_RELOAD_SLICE_ROIS 2
#define VALUE_LOAD_DAT_FILE 3
#define VALUE_FILE_INFO 4
#define VALUE_ENTER_FILE_COMMENT 5
#define VALUE_RELOAD_CUR_SLICE_ROIS 6
#define VALUE_RELOAD_PIXMAP 7

#define VALUE_SAVE_TEXT_TO_FILE 1
#define VALUE_SAVE_THEN_PRINT_TEXT 2
#define VALUE_PRINT_TEXT_TO_WINDOW 3
#define VALUE_PRINT_ROIS_AND_PIXEL_TYPES 4
#define VALUE_FILTER_SHOW_TISSUES 5
#define VALUE_SHOW_TISSUE_WINS 6

#define VALUE_HISTO_CURRENT_SLICE_1D 1
#define VALUE_HISTO_ALL_SLICE_1D 2
#define VALUE_HISTO_CURRENT_SLICE 3
#define VALUE_HISTO_ALL_SLICE 4
#define VALUE_HISTO_SHOW 5
#define VALUE_HISTO_CLEAR 6

#define MAGNIFY_WIN 51
#define MAGNIFY_SHRINK_WIN 54
#define MAGNIFY_LAST_DIM 55
#define MAGNIFY_DEFAULT_DIM 56

#define MIN_MAGNIFY_PIXEL_DIM 1
#define MAX_MAGNIFY_PIXEL_DIM 20

#define VALUE_MAKE_ROI_CONVEX 1000
#define VALUE_OUT_OF_BOUND_ROIS 1001

#define DELETE_CUR_PT 1
#define DELETE_CUR_CURVE 2
#define DELETE_CUR_ROI 3
#define DELETE_EVERY_ROI 4
#define DELETE_FILE_ROIS_BY_LABEL 5
#define DELETE_ALL_FILE_ROIS 6
#define DELETE_CURVE_MODE 7

#define NORTH 0x00000001
#define NORTH_EAST 0x00000003
#define EAST 0x00000002
#define SOUTH_EAST 0x00000006
#define SOUTH 0x00000004
#define SOUTH_WEST 0x0000000c
#define WEST 0x00000008
#define NORTH_WEST 0x00000009
#define SCREEN_CENTER 0x00000010
#define SCREEN_CENTER_AT_BR 0x00000020
#define SCREEN_ORIGIN_AT_TL 0x00000040

#define FUSION_DELETE_FUSION 1
#define FUSION_SHOW 2
#define FUSION_WHICH_WIN 3
#define FUSION_SHOW_SRC 4
#define FUSION_LAST_LEFT_TOP 5
#define FUSION_SWITCHING 6

#define EXTRA_FRAME_STATUS 5000
#define EXTRA_FRAME_SHOW 1
#define EXTRA_FRAME_HIDE 2

#define VALUE_SLICE_ROI_PRIOR 100
#define VALUE_SLICE_ROI_NEXT 101

#define VALUE_CUR_SLICE_TYPES_TO_HISTO_ROIS 0
#define VALUE_ALL_SLICE_TYPES_TO_HISTO_ROIS 1

#define WHOLE_SLICE 0
#define CUR_CURVE 1
#define CUR_ROI 2
#define ALL_ROIS 3
#define IMAGE_FILTER_ROI 4

#define USER_WIN_SETUP 1
#define USER_WIN_FREE_FRAME 2
#define USER_WIN_FREE_STRS 4
#define USER_WIN_FREE_STR_PTRS 8
#define USER_WIN_FREE_STRS_AND_PTR 16
#define USER_WIN_FREE_STR_PTRS_AND_PTR 32


#define HISTO_ROI_POINTS 1
#define HISTO_ROI_CONVEX_REGION 2
#define HISTO_ROI_RANGE_REGION 3


#define OVERLAYED_BY_WID_VALUE 1
#define OVERLAYED_BY_WID_STACK_VALUE 2
#define OVERLAYED_BY_ALL_ECHO_WID_VALUE 3
#define OVERLAYED_BY_ALL_ECHO_WID_STACK_VALUE 4
#define DELETE_OVERLAY_VALUE 5
#define DELETE_OVERLAY_STACK_VALUE 6
#define SHOW_HIDE_OVERLAY_VALUE 7
#define SHOW_HIDE_OVERLAY_STACK_VALUE 8

#define RESIZE_TO_WID_SIZE_VALUE 1
#define RESIZE_ZOOM_IN_VALUE 2
#define RESIZE_ZOOM_OUT_VALUE 3
#define RESIZE_DEFAULT_SIZE_VALUE 4
#define RESIZE_DEFAULT_VALUE 5
#define RESIZE_LAST_VALUE 6

#define CO_WID_FILE_VALUE 1
#define UNCO_WID_FILE_VALUE 2
#define SAVE_CO_FILE_VALUE 3
#define LOAD_CO_FILE_VALUE 4
#define REVERSE_CO_FILE_PARAMS_VALUE 5


#define COREG_CO_VALUE 0
#define COREG_UNCO_VALUE 1
#define COREG_CO_AND_FUSION_VALUE 2
#define COREG_RECO_VALUE 3

#define COREG_UNCO_ALL_GROUP_WIDS_VALUE 4
#define COREG_LOCKED_TO_VALUE 5
#define COREG_UNLOCK_FROM_VALUE 6
#define COREG_UNLOCK_CUR_WID_FROM_ALL_GROUP_WIDS_VALUE 7
#define COREG_LOCK_ALL_COPLANES_VALUE 8
#define COREG_UNLOCK_ALL_COPLANES_VALUE 9
#define COREG_UNLOCK_ALL_GROUP_WIDS_VALUE 10
#define COREG_UNLOCK_ALL_WIDS_VALUE 11

#define COREG_ADJUST_VIEW_AND_COPLANES_ON_VALUE 12
#define COREG_ADJUST_VIEW_AND_COPLANES_OFF_VALUE 13

#define COREG_ADJUST_VIEW_ON_VALUE 14
#define COREG_ADJUST_VIEW_OFF_VALUE 15

#define COREG_UNCO_CUR_WID_FROM_EVERY_GROUP_VALUE 16
#define COREG_UNCO_ALL_WIDS_VALUE 17
#define COREG_UNCO_AND_UNLOCK_ALL_WIDS_VALUE 18

#endif RIA_DEFINE_CONSTANTS_H
