/****************************************************************************
Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/


#ifndef WIN_H
#define	WIN_H

#include "str_def.h"
#include "slice_roi_rec.h"
#include "display_win.h"
#define WIN_REC_ID_DEFINED 1
struct win_rec
   {
    struct all_win_rec *root;
    unsigned short status;
         /* display image */
    unsigned long win_id;
    char *wid;
    unsigned long cur_img;
    unsigned long num_img_bufs;
    struct img_buf_rec **img_bufs;
    struct image_display_window *image_display;
    struct image_display_window *histogram;
   };

struct pallette_rec
   {
    char *color_fn;
    unsigned long total_pallettes,num_pallettes,cur_pallette;
    struct intensity_rec **pallettes;
   };

#define WIN_REC_SAVE_ROI_LABELS 0x0001
#define WIN_REC_SAVE_PIXEL_TYPES 0x0002
#define WIN_REC_SAVE_SEC_ROI_LABELS 0x0004
#define WIN_REC_SAVE_SEC_PIXEL_TYPES 0x0008
/*#define WIN_REC_SAVE_PIXEL_TYPE_PRIORITY 0x0010*/
#define WIN_REC_SAVE_CV_ROI_LABELS 0x0020
#define WIN_REC_SAVE_CV_SEC_ROI_LABELS 0x0040
struct all_win_rec 
   {
    unsigned short status;
    struct prog_rec *prog;
    struct pallette_rec def_color;

    char *roi_label_fn;
    struct strs_rec roi_labels;
    char *sec_roi_label_fn;
    struct strs_rec sec_roi_labels;
    char *cv_roi_label_fn;
    struct strs_rec cv_roi_labels;
    char *cv_sec_roi_label_fn;
    struct strs_rec cv_sec_roi_labels;

    char *pixel_type_fn;
    struct strs_rec pixel_types;
    char *sec_pixel_type_fn;
    struct strs_rec sec_pixel_types;
    char *pixel_type_priority_fn;
    struct strs_rec pixel_type_priority;

/*
  for breaker->prog_status
*/

#define BREAKER_DELETE_CUR_REGION 0x0001
#define BREAKER_COMMON_BOUNDARY 0x0002
#define BREAKER_LABEL_BREAKER_REGION 0x0004
#define BREAKER_DISABLE_BREAKER_AFTER_APPLY 0x0008
    struct slice_roi_rec breaker;
    struct slice_roi_rec clipboard;
    struct draw_mask_rec breaker_mask;
    struct draw_mask_rec clipboard_mask;
    struct image_display_window *breaker_win;
    struct image_display_window *clipboard_win;

    unsigned long total_wins;
    struct win_rec **wins;
   };

#endif WIN_H

