/****************************************************************************
2dbufmoreopr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2dbufmoreopr.c,v 1.9 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <math.h>
#include <stdio.h>
#include <sys/types.h>

#include "common.h"
#include "rect.h"
#include "error_constants.h"
#include "nria_lib.h"

/*
#define PRT1(x)
#define PRINT(x) printf(x);fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define PRINT(x) 
#define TRACE(x)
#define PRT(x)
#define PRT2(x)
#define PRT1(x)
#define PRT3(x)



/* Private functions */
extern void accumulated_pixel_density(unsigned long *pixel_cnts, 
    unsigned long num_pixel_cnts, unsigned long total_pixels, 
    float *accum_pds);
extern double AveragePixelCntValue(unsigned long *pixel_cnts, 
    unsigned long num_pixel_cnts, unsigned long total_pixels);
extern double StdPixelCntValue(unsigned long *pixel_cnts, 
    unsigned long num_pixel_cnts, unsigned long total_pixels);
extern void map_real_to_int_ary(float *real_ary, unsigned char *int_ary, 
    unsigned long num_elems, double min_real, double max_real, 
    unsigned long min_int, unsigned long max_int, unsigned long int_elem_size);
extern int PtsMeanAndSd(double *vals, unsigned long num_vals, double *mean, 
    double *sd);
extern int _2dCntOccurrences(struct buf_2d_rec *_2d, unsigned long *pixel_cnts,
    unsigned long num_pixel_cnts, unsigned long init_num_pixel_cnts, 
    double min_pixel_value, double max_pixel_value, 
    unsigned long *total_pixels);
extern int Count1dOccurrences(struct buf_2d_rec *result, 
    unsigned long result_row_indx, struct buf_2d_rec *src, 
    struct buf_2d_rec *bit_mask, int init_result, unsigned long *total_pixels,
    int re_init_total_pixels);
extern int Count2dOccurrences(struct buf_2d_rec *result, 
    struct buf_2d_rec *echo1, struct buf_2d_rec *echo2, 
    struct buf_2d_rec *bit_mask, int init_result, unsigned long *total_pixels,
    int re_init_total_pixels);
extern int image_enhancement(struct buf_2d_rec **images,
    unsigned long num_images, unsigned long min_pixel_value,
    unsigned long max_pixel_value, 
    unsigned long *transformed_gray_levels);
extern int HistogramEqualization(struct buf_2d_rec **_2ds, 
    unsigned long num_2ds, double min, double max, int use_newminmax, 
    double newmin, double newmax, float **vals, unsigned long *num_vals);
extern int sharpen_2d_by_mask_proc(struct buf_2d_rec *_2d, 
    unsigned long row, unsigned long col, struct buf_2d_rec *result);
extern int sharpen_2d(struct buf_2d_rec *_2d, struct buf_2d_rec *result);
extern int sobel_2d_by_mask_proc(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, struct buf_2d_rec *result);
extern int sobel_2d(struct buf_2d_rec *_2d, struct buf_2d_rec *result);
extern int Gradient2dByMaskProc(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, struct buf_2d_rec *result, int *set_edge_threshold, 
    double *edge_threshold, int *set_edge, double *edge_value, 
    int *set_background, double *background_value);
extern int Gradient2d(struct buf_2d_rec *result, struct buf_2d_rec *src, 
    double edge_threshold, int set_edge, double edge_value, int set_background,
    double background_value);
extern int _2dPtMeanAndSd(struct buf_2d_rec *_2d, unsigned long row, 
    unsigned long col, double *mean, double *sd);
extern int Histogram2d(struct buf_2d_rec *_2d, struct buf_2d_rec *src, 
    unsigned long src_row, unsigned long src_col_start, int use_value, 
    double value, int is_clear_src);
extern int AutoSetHisto1DBuf(struct buf_2d_rec *histo, unsigned long row_indx,
    unsigned long min_bkg_value, unsigned long max_bkg_value, 
    unsigned long *cutoff_start, int is_clear_histo);
extern int AutoSet2dBackground(struct buf_2d_rec *_2d, 
    unsigned long histo_width, unsigned long min_bkg_value, 
    unsigned long max_bkg_value);
extern int CombinePosNeg2d(struct buf_2d_rec *result, struct buf_2d_rec *pos, 
    struct buf_2d_rec *neg);
extern int sharpen_2d_by_mask(struct buf_2d_rec *_2d, 
    unsigned long startleft, unsigned long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, struct buf_2d_rec *result);
extern int Gradient2dByMask(struct buf_2d_rec *_2d, unsigned long startleft, 
    unsigned long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, struct buf_2d_rec *result, 
    double edge_threshold, int set_edge, double edge_value, 
    int set_background, double background_value);
extern int sobel_2d_by_mask(struct buf_2d_rec *_2d, unsigned long startleft, 
    unsigned long starttop, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound, struct buf_2d_rec *result);
extern int GrowRegion(struct buf_2d_rec *_2d, unsigned long starty, 
    unsigned long startx, double lb, double ub, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound_area);
extern int _2dMeanAndSd(struct buf_2d_rec *_2d, struct buf_2d_rec *mask, 
    struct int_bound_rec *bound_area, double *mean, double *sd);
extern int _2dTransitionMap(struct buf_2d_rec *_2d, double lb, double ub, 
    struct buf_2d_rec *mask, struct int_bound_rec *bound_area);



/*-----------------------------------------------------------------------
_2dCntOccurrences - ???

Calculate the pixel value densities for a 2d array...where
the pixel values are in the range of [min_pixel_value,max_pixel_value]
-------------------------------------------------------------------------*/

int
_2dCntOccurrences(_2d,pixel_cnts,num_pixel_cnts,init_num_pixel_cnts,
                   min_pixel_value,max_pixel_value,total_pixels)
 struct buf_2d_rec *_2d;
 unsigned long *pixel_cnts;
 unsigned long num_pixel_cnts,init_num_pixel_cnts;
 double min_pixel_value,max_pixel_value;
 unsigned long *total_pixels;
{
 unsigned long row,col,lcv;
 double value;
 unsigned long val;

 if (init_num_pixel_cnts)
    {for (lcv = 0; lcv < num_pixel_cnts; lcv++)
       pixel_cnts[lcv] = 0;
     *total_pixels = 0;}

 for (row = 0; row < _2d->dimy; row++)
    for (col = 0; col < _2d->dimx; col++)
       {value = _2d->GetVal(_2d,row,col);
        if ((value >= min_pixel_value) && (value <= max_pixel_value))
           {val = (unsigned long) rint(value);
            (pixel_cnts[val])++;
            (*total_pixels)++;}
       }

 TRACE(printf("(*total_pixels) = %d\n",(*total_pixels)))

 return NO_ERROR;
}


/*----------------------------------------------------------------------
Count1dOccurrences - ???
-----------------------------------------------------------------------*/

int
Count1dOccurrences(result,result_row_indx,src,bit_mask,init_result,
                   total_pixels,re_init_total_pixels)
 struct buf_2d_rec *result,*src,*bit_mask;
 int re_init_total_pixels;
 unsigned long result_row_indx,*total_pixels;
{
 unsigned long row,col,lcv,indx;
 long num;
 double val;

 if (result_row_indx >= result->dimy) indx = result->dimy - 1;
   else indx = result_row_indx;
 if (init_result)
    {for (lcv = 0; lcv < result->dimx; lcv++)
        result->SetVal(result,indx,lcv,(double) .0);
    }
 if ((total_pixels != NULL) && re_init_total_pixels) *total_pixels = 0;

 if (bit_mask == NULL)
    {
     for (row = 0; row < src->dimy; row++)
        for (col = 0; col < src->dimx; col++)
           {val = src->GetVal(src,row,col);
            num = (long) floor((double) (val + .5));
            if ((num > 0) && (num < result->dimx))
               {
                Add2dVal(result,indx,num,(double) 1.0);
                if (total_pixels != NULL) (*total_pixels)++;}
           }
    }
  else
    for (row = 0; row < src->dimy; row++)
       for (col = 0; col < src->dimx; )
         if (bit_mask->buf[row][col / 8])
            {if (bit_mask->buf[row][col / 8] & C_which_bit[col % 8])
                {val = src->GetVal(src,row,col);
                 num = (long) floor(val + .5);
                 if ((num > 0) && (num < result->dimx))
                    {Add2dVal(result,indx,num,(double) 1);
                     if (total_pixels != NULL) (*total_pixels)++;}
                }
              col++;}
            else col += 8;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Count2dOccurrences - ???
-----------------------------------------------------------------------*/

int
Count2dOccurrences(result,echo1,echo2,bit_mask,init_result,
                   total_pixels,re_init_total_pixels)
 struct buf_2d_rec *result,*echo1,*echo2,*bit_mask;
 int re_init_total_pixels;
 unsigned long *total_pixels;
{
 unsigned long row,col;
 long num1,num2;
 double val1,val2;

 if (init_result) InitBuf2dRecData(result,(double) .0);
 if ((total_pixels != NULL) && re_init_total_pixels) *total_pixels = 0;
 if (bit_mask == NULL)
    for (row = 0; row < echo1->dimy; row++)
       for (col = 0; col < echo1->dimx; col++)
          {val1 = echo1->GetVal(echo1,row,col);
           num1 = (unsigned long) floor(val1 + .5);
           if ((num1 < 0) || (num1 >= result->dimx)) continue;
           val2 = echo2->GetVal(echo2,row,col);
           num2 = (unsigned long) floor(val2 + .5);
           if ((num2 < 0) || (num2 >= result->dimy)) continue;
           Add2dVal(result,num2,num1,(double) 1.0);
           if (total_pixels != NULL) (*total_pixels)++;}
   else
    for (row = 0; row < echo1->dimy; row++)
       for (col = 0; col < echo1->dimx; )
          if (bit_mask->buf[row][col / 8])
             {if (bit_mask->buf[row][col / 8] & C_which_bit[col % 8])
                 {val1 = echo1->GetVal(echo1,row,col);
                  num1 = (unsigned long) floor(val1 + .5);
                  if ((num1 < 0) || (num1 >= result->dimx))
                     {col++;
                      continue;}
                  val2 = echo2->GetVal(echo2,row,col);
                  num2 = (unsigned long) floor(val2 + .5);
                  if ((num2 < 0) || (num2 >= result->dimy)) 
                     {col++;
                      continue;}
                  Add2dVal(result,num2,num1,(double) 1.0);
                  if (total_pixels != NULL) (*total_pixels)++;
                 }
              col++;
             }
            else col += 8;
 return NO_ERROR;
}


/************************ Beginning of big chopped out section

  -- calculate the pixel value densities for a multi-dimensional 2d array...
   ex. if num_2ds == 1 
          find the pixel densities for a 2d array
          num_pixel_cnts = 256
   ex. if num_2ds == 2
          find the pixel densities for 2-2d arrays
          the combination of the corresponding pixel values from the 2-2d arrays
              forms the index to pixel_cnts
          num_pixel_cnts = 65536
RegionalCntOccurrences(_2ds,num_2ds,pixel_cnts,num_pixel_cnts,
                       init_num_pixel_cnts,
                       min_pixel_value,max_pixel_value,
                       total_pixels,bit_mask)
 struct buf_2d_rec **_2ds;
 unsigned long num_2ds;
 struct buf_2d_rec **pixel_cnts;
 unsigned long num_pixel_cnts,init_num_pixel_cnts;
 double min_pixel_value,max_pixel_value;
 unsigned long *total_pixels;
 struct buf_2d_rec *bit_mask;
{
 unsigned long row,col,lcv,offset,offset1,indx,cnt;
 double value,value1;
 int ok;

 if (init_num_pixel_cnts)
    {for (lcv = 0; lcv < num_pixel_cnts; lcv++)
        InitBuf2dRecData(pixel_cnts[lcv],(double) .0);
     *total_pixels = 0;}

 switch (num_2ds)
    {case 1 : 
        if (bit_mask == NULL)
           for (row = 0; row < _2ds[0]->dimy; row++)
              for (col = 0; col < _2ds[0]->dimx; col++)
                 {value = _2ds[0]->GetVal(_2ds[0],row,col);
                  if ((value >= min_pixel_value) &&
                      (value <= max_pixel_value))
                     {Add2dVal(pixel_cnts[0],0,value,(double) 1.0);
                      (*total_pixels)++;}
                 }
          else
           for (row = 0; row < _2ds[0]->dimy; row++)
              for (col = 0; col < _2ds[0]->dimx; )
                 if (bit_mask->buf[row][col / 8])
                    {
                     if (bit_mask->buf[row][col / 8] & C_which_bit[col % 8])
                        {value = _2ds[0]->GetVal(_2ds[0],row,col);
                         if ((value >= min_pixel_value) &&
                             (value <= max_pixel_value))
                            {Add2dVal(pixel_cnts[0],0,value,(double) 1.0);
                             (*total_pixels)++;}
                        }
                     col++;}
                   else col += 8;

        break;
     case 2 : 
        if (bit_mask == NULL)
           for (row = 0; row < _2ds[0]->dimy; row++)
              for (col = 0; col < _2ds[0]->dimx; col++)
                 {value = _2ds[0]->GetVal(_2ds[0],row,col);
                  value1 = _2ds[1]->GetVal(_2ds[1],row,col);
                  if ((value1 >= min_pixel_value) &&
                      (value1 <= max_pixel_value) &&
                      (value >= min_pixel_value) &&
                      (value <= max_pixel_value))
                     {Add2dVal(pixel_cnts[0],value1,value,(double) 1);
                      (*total_pixels)++;}
                 }
          else
           for (row = 0; row < _2ds[0]->dimy; row++)
              for (col = 0; col < _2ds[0]->dimx; col++)
                 if (bit_mask->buf[row][col / 8])
                    {
                     if (bit_mask->buf[row][col / 8] & C_which_bit[col % 8])
                        {value = _2ds[0]->GetVal(_2ds[0],row,col);
                         value1 = _2ds[1]->GetVal(_2ds[1],row,col);
                         if ((value1 >= min_pixel_value) &&
                             (value1 <= max_pixel_value) &&
                             (value >= min_pixel_value) &&
                             (value <= max_pixel_value))
                            {Add2dVal(pixel_cnts[0],value1,value,(double) 1);
                             (*total_pixels)++;}
                        }
                     col++;
                    }
                   else col += 8;
              break;
    }

}
End of big chopped out section ***********************************/


/*----------------------------------------------------------------------
accumulated_pixel_density - ???
-----------------------------------------------------------------------*/

void
accumulated_pixel_density(pixel_cnts,num_pixel_cnts,total_pixels,accum_pds)
 unsigned long *pixel_cnts;
 unsigned long num_pixel_cnts;
 unsigned long total_pixels;
 float *accum_pds;
{
 unsigned long lcv;
 float total;

 total = (float) total_pixels;
 accum_pds[0] = pixel_cnts[0] / total;
 for (lcv = 1; lcv < num_pixel_cnts; lcv++)
    accum_pds[lcv] = accum_pds[lcv - 1] + pixel_cnts[lcv] / total;
}


/*----------------------------------------------------------------------
AveragePixelCntValue - ???
-----------------------------------------------------------------------*/

double 
AveragePixelCntValue(pixel_cnts,num_pixel_cnts,total_pixels)
 unsigned long *pixel_cnts;
 unsigned long num_pixel_cnts;
 unsigned long total_pixels;
{
 unsigned long lcv;
 float total;

 for (total = 0,lcv = 0; lcv < num_pixel_cnts; lcv++)
    total += (float) (pixel_cnts[lcv] * lcv);
 if (total_pixels == 0) return (double) .0;
 return floor((double) (total / (double) total_pixels + .5));
}


/*----------------------------------------------------------------------
StdPixelCntValue - ???
-----------------------------------------------------------------------*/

double 
StdPixelCntValue(pixel_cnts,num_pixel_cnts,total_pixels)
 unsigned long *pixel_cnts;
 unsigned long num_pixel_cnts;
 unsigned long total_pixels;
{
 unsigned long lcv;
 double ave,std;

 ave = AveragePixelCntValue(pixel_cnts,num_pixel_cnts,total_pixels);
 TRACE(printf("ave = %d\n",ave))
 for (std = .0,lcv = 0; lcv < num_pixel_cnts; lcv++)
    {if (pixel_cnts[lcv] > ave) std += ((double) pixel_cnts[lcv] - ave)  * lcv;
       else std += (ave - (double) pixel_cnts[lcv]) * lcv;
    }
 return floor((double) (std / (double) total_pixels + .5));
}


/*----------------------------------------------------------------------
image_enhancement - ??? 

conditions
 ----------
 1) "image" is an ary of pointer to "struct buf_2d_rec".
 2) min_pixel_value & max_pixel_value are the posible min & max pixel values
    that the image pixel can have.
 3) transformed_gray_levels has a size [0..max_pixel_value - 1] or bigger and
    it contains the result of the transformed gray levels;  it can then be used
    to update the color map of the display window.
-------------------------------------------------------------------------*/

int
image_enhancement(images,num_images,
                       min_pixel_value,max_pixel_value,
                       transformed_gray_levels)
 struct buf_2d_rec **images;
 unsigned long num_images;
 unsigned long min_pixel_value,max_pixel_value;
 unsigned long *transformed_gray_levels;
{
 unsigned long *pixel_cnts;
 unsigned long num_pixel_cnts,lcv,cnt,height;
 unsigned long total_pixels,init_num_pixel_cnts;
 float *accum_pds;
 int err;

 if (min_pixel_value >= max_pixel_value) return BAD_DATA;
 num_pixel_cnts = 0;
 pixel_cnts = NULL;
 if (((err = get_ptr(&pixel_cnts,&num_pixel_cnts,max_pixel_value + 1,
                    (size_t) sizeof(unsigned long))) != NO_ERROR) ||
     ((err = get_ptr(&accum_pds,NULL,num_pixel_cnts,
                    (size_t) sizeof(float))) != NO_ERROR))
    {c_free(pixel_cnts);
     return err;}
 for (init_num_pixel_cnts = 1,lcv = 0; lcv < num_images; lcv++)
    {_2dCntOccurrences(images[lcv],pixel_cnts,num_pixel_cnts,
             init_num_pixel_cnts,
             (double) min_pixel_value,(double) max_pixel_value,
             &total_pixels);
     init_num_pixel_cnts = 0;}

 TRACE(printf("total_pixels = %d\n",total_pixels))
 total_pixels -= pixel_cnts[min_pixel_value];
 pixel_cnts[min_pixel_value] = 0;
 accumulated_pixel_density(pixel_cnts,num_pixel_cnts,total_pixels,accum_pds);
 height = max_pixel_value - min_pixel_value;
 for (lcv = 0; lcv < num_pixel_cnts; lcv++)
    {cnt = min_pixel_value +
        (unsigned long) floor((double)(accum_pds[lcv] * height + .5));
     if (cnt > max_pixel_value) cnt = max_pixel_value;
     transformed_gray_levels[lcv] = cnt;
    }

 c_free(pixel_cnts);
 c_free(accum_pds);
 return NO_ERROR;
}

/*
    {
     for (lcv = 0; lcv < num_2ds; lcv++)
        {_2d = _2ds[lcv];
         MinMax2dValues(_2d,0,(double) .0,(double) .0,&min1,&max1);
         PRT(printf("%d) min1 = %f  max1 = %f\n",lcv,min1,max1))
         if (lcv == 0)
            {newmin = min1;
             newmax = max1;}
           else
            {if (newmin > min1) newmin = min1;
             if (newmax < max1) newmax = max1;}
        }
     val = newmax - newmin;
     for (lcv = 0; lcv <= height; lcv++)
        ptr[lcv] =  newmin + ptr[lcv] * val;
    }
*/


/*----------------------------------------------------------------------
HistogramEqualization - ???
-----------------------------------------------------------------------*/

int
HistogramEqualization(_2ds,num_2ds,min,max,use_newminmax,
                      newmin,newmax,vals,num_vals)
 struct buf_2d_rec **_2ds;
 unsigned long num_2ds,*num_vals;
 double min,max,newmin,newmax;
 int use_newminmax;
 float **vals;
{
 unsigned long height,lcv,row,col,indx;
 struct buf_2d_rec *_2d;
 float *ptr,*ptr1;
 double val,total,min1,max1;
 int err;

 PRT(printf("HistogramEqualization...min = %f   max = %f\n",min,max))
 if (vals != NULL) *vals = NULL;
 if (num_vals != NULL) *num_vals = 0;
 height = (unsigned long) rint(max) - (unsigned long) rint(min) + 1;
 ptr = ptr1 = NULL;
 if ((err = get_ptr(&ptr,NULL,height,sizeof(*ptr))) != NO_ERROR)
    return err;
 if (!use_newminmax &&
     ((err = get_ptr(&ptr1,NULL,height,sizeof(*ptr1))) != NO_ERROR))
    {c_free(ptr);
     return err;}

 PRT(printf("HistogramEqualization...height = %d\n",height))
 height -= 1;
 for (lcv = 0; lcv <= height; lcv++)
    ptr[lcv] = .0;
 total = .0;
 for (lcv = 0; lcv < num_2ds; lcv++)
    {_2d = _2ds[lcv];
     total += (float) (_2d->dimy * _2d->dimx);
     for (row = 0; row < _2d->dimy; row++)
        for (col = 0; col < _2d->dimx; col++)
           {val = _2d->GetVal(_2d,row,col);
            if (val <= min) ptr[0] += 1.0;
              else if (val >= max) ptr[height] += 1.0;
              else
               {indx = (unsigned long) rint(val - min);
                if (indx <= 0) ptr[0] += 1.0;
                  else if (indx >= height) ptr[height] += 1.0;
                  else ptr[indx] += 1.0;
               }
          }
    }
 PRT(printf("...newmin = %f   newmax = %f total = %f\n",
           newmin,newmax,total))
 for (lcv = 0; lcv <= height; lcv++)
    ptr[lcv] = (double) ptr[lcv] / total;
 PRT(printf("1...ptr[height] = %f \n",ptr[height]))

 val = ptr[0];
 for (lcv = 1; lcv <= height; lcv++)
    {val += ptr[lcv];
     ptr[lcv] = val;}

 PRT(printf("2...ptr[height] = %f   height = %d\n",ptr[height],height))
 if (use_newminmax)
    {val = newmax - newmin;
     for (lcv = 0; lcv <= height; lcv++)
        ptr[lcv] =  newmin + ptr[lcv] * val;}
   else
    {val = max - min;
     for (lcv = 0; lcv <= height; lcv++)
        ptr1[lcv] = (float) rint((double) (min + ptr[lcv] * val));
     val = ptr1[0];
     for (lcv = 1; lcv <= height; lcv++)
        {if (val != ptr1[lcv]) break;}
     
     if (lcv > height)
        for (lcv = 0; lcv <= height; lcv++) ptr[lcv] = .0;
       else
        {min1 = ptr1[lcv - 1];
         PRT(printf("new min1 = %f  lcv = %d\n",min1,lcv - 1);)
         val = ptr1[height];
         for (lcv = height - 1; lcv > 0; lcv--)
            {if (val != ptr1[lcv]) break;}
         val = ptr1[lcv + 1] - min1;
         PRT(printf("new max1 = %f  lcv = %d val = %f\n",
             ptr1[lcv + 1],lcv + 1,val);)

         for (lcv = 0; lcv <= height; lcv++)
            ptr[lcv] = min1 + ptr[lcv] * val;
        }
    }
/*
 for (lcv = 0; lcv <= height; lcv++)
    {PRT(printf("%d)   %f\n",lcv,ptr[lcv]))
    }
*/

 PRT(printf("===...ptr[height] = %f\n",ptr[height]))
 for (lcv = 0; lcv < num_2ds; lcv++)
    {_2d = _2ds[lcv];
     for (row = 0; row < _2d->dimy; row++)
        for (col = 0; col < _2d->dimx; col++)
           {val = _2d->GetVal(_2d,row,col);
            if (val <= min) val = ptr[0];
              else if (val >= max) val = ptr[height];
              else
               {indx = (unsigned long) rint(val - min);
                if (indx <= 0) val = ptr[0];
                  else if (val >= height) val = ptr[height];
                  else val = ptr[indx];}
            _2d->SetVal(_2d,row,col,val);
           }
    }
 if (vals != NULL)
    {*vals = ptr;
     if (num_vals != NULL) *num_vals = height + 1;}
   else c_free(ptr);
 for (lcv = 0; lcv < num_2ds; lcv++)
    {_2d = _2ds[lcv];
     MinMax2dValues(_2d,0,(double) .0,(double) .0,&min1,&max1);
     PRT(printf("%d) min1 = %f  max1 = %f\n",lcv,min1,max1))
    }
 PRT(printf("HistogramEqualization...err = %d\n",err))
 c_free(ptr1);
 return err;
}


/*----------------------------------------------------------------------
map_real_to_int_ary - ???
-----------------------------------------------------------------------*/

void
map_real_to_int_ary(real_ary,int_ary,num_elems,min_real,max_real,
                    min_int,max_int,int_elem_size)
 float *real_ary,min_real,max_real;
 unsigned char *int_ary;
 unsigned long num_elems;
 unsigned long min_int,max_int,int_elem_size;
{
 unsigned long lcv;
 float height_real;
 unsigned long height_int;
 unsigned long *ptr_int;
 unsigned short *ptr_short;

 height_real = max_real - min_real;
 height_int = max_int - min_int;
 switch (int_elem_size)
    {case 1 :
              for (lcv = 0; lcv < num_elems; lcv++)
                 int_ary[lcv] =  min_int + ((real_ary[lcv] - min_real) *
                                    height_int / height_real) + .5;
              break;
     case 2 : ptr_short = (unsigned short *) int_ary;
              for (lcv = 0; lcv < num_elems; lcv++)
                 ptr_short[lcv] =  min_int + ((real_ary[lcv] - min_real) *
                                    height_int / height_real) + .5;
              break;
     case 4 : ptr_int = (unsigned long *) int_ary;
              for (lcv = 0; lcv < num_elems; lcv++)
                 ptr_int[lcv] =  min_int + ((real_ary[lcv] - min_real) *
                                    height_int / height_real) + .5;
              break;
    }
}



/*----------------------------------------------------------------------
sharpen_2d_by_mask_proc - ???
-----------------------------------------------------------------------*/

int
sharpen_2d_by_mask_proc(_2d,row,col,result)
 struct buf_2d_rec *_2d,*result;
 unsigned long row,col;
{
 double val,val4,val6,temp;
 unsigned long last_row,last_col;

 last_row = _2d->dimy - 1;
 last_col = _2d->dimx - 1;
 if ((last_row == 0) || (last_col == 0)) return NO_ERROR;
 if ((row < last_row) && (col < last_col))
    {val = _2d->GetVal(_2d,row,col);
     val4 = _2d->GetVal(_2d,row,col + 1);
     val6 = _2d->GetVal(_2d,row + 1,col);
     if (val4 > val) temp = val4 - val;
       else temp = val - val4;
     if (val6 > val) temp = temp + val6 - val;
       else temp = temp + val - val6;
     result->SetVal(result,row,col,temp);
    }
  else if (row == last_row)
   {val = result->GetVal(result,last_row - 1,col);
    result->SetVal(result,row,col,val);
   }
  else
   {val = result->GetVal(result,row,last_col - 1);
    result->SetVal(result,row,col,val);
   }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
sharpen_2d_by_mask - ???
-----------------------------------------------------------------------*/

int
sharpen_2d_by_mask(_2d,startleft,starttop,mask,bound,result)
 struct buf_2d_rec *_2d,*mask,*result;
 unsigned long startleft,starttop;
 struct int_bound_rec *bound;
{
 return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,bound,
                           sharpen_2d_by_mask_proc,result,0,0,0,0,0,0,0,0);

}


/*----------------------------------------------------------------------
sharpen_2d - ???
-----------------------------------------------------------------------*/

int
sharpen_2d(_2d,result)
 struct buf_2d_rec *_2d,*result;
{
 unsigned long row,col,last_row,last_col,last;
 double val,val4,val6,temp;

 last_row = _2d->dimy - 1;
 last_col = _2d->dimx - 1;
 for (row = 0; row < last_row; row++)
    for (col = 0; col < last_col; col++)
       {val = _2d->GetVal(_2d,row,col);
        val4 = _2d->GetVal(_2d,row,col + 1);
        val6 = _2d->GetVal(_2d,row + 1,col);
        if (val4 > val) temp = val4 - val;
          else temp = val - val4;
        if (val6 > val) temp = temp + val6 - val;
          else temp = temp + val - val6;
        result->SetVal(result,row,col,temp);
       }
 if ((last_row > 0) && (last_col > 0))
    {last = last_col - 1;
     for (row = 0; row < last_row; row++)
        {val = result->GetVal(result,row,last);
         result->SetVal(result,row,last_col,val);
        }
     last = last_row - 1;
     for (col = 0; col < _2d->dimx; col++)
        {val = result->GetVal(result,last,col);
         result->SetVal(result,last_row,col,val);
        }
    }
 result->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}


/*----------------------------------------------------------------------
sobel_2d_by_mask_proc - ???
-----------------------------------------------------------------------*/

int
sobel_2d_by_mask_proc(_2d,row,col,result)
 struct buf_2d_rec *_2d,*result;
 unsigned long row,col;
{
 unsigned long last_row,last_col;
 double val1,val2,val3,val4,val5,val6,val7,val8,gx,gy,gx1,gy1;

 last_row = _2d->dimy - 1;
 last_col = _2d->dimx - 1;
 if ((last_row == 0) || (last_col == 0)) return NO_ERROR;
 if (row > 0)
    {
     if (col > 0)
        val1 = _2d->GetVal(_2d,row-1,col-1);
       else val1 = 0;
     val2 = _2d->GetVal(_2d,row-1,col);
     if (col < last_col)
        val3 = _2d->GetVal(_2d,row-1,col+1);
       else val3 = 0;
    }
   else val1 = val2 = val3 = 0;
 if (row < last_row)
    {if (col < last_col)
        val5 = _2d->GetVal(_2d,row+1,col+1);
       else val5 = 0;
     val6 = _2d->GetVal(_2d,row+1,col);
     if (col > 0)
        val7 = _2d->GetVal(_2d,row+1,col-1);
       else val7 = 0;
    }
   else val5 = val7 = val6 = 0;
 if (col < last_col)
    val4 = _2d->GetVal(_2d,row,col+1);
   else val4 = 0;
 if (col > 0)
    val8 = _2d->GetVal(_2d,row,col-1);
   else val8 = 0;
 gx = val7 + 2 * val6 + val5;
 gx1 = val1 + 2 * val2 + val3;
 if (gx > gx1) gx -= gx1;
   else gx = gx1 -gx;

 gy = val3 + 2 * val4 + val5;
 gy1 = val1 + 2 * val8 + val7;
 if (gy > gy1) gy -= gy1;
   else gy = gy1 - gy;

 result->SetVal(result,row,col,gx + gy);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
sobel_2d_by_mask - ???
-----------------------------------------------------------------------*/

int
sobel_2d_by_mask(_2d,startleft,starttop,mask,bound,result)
 struct buf_2d_rec *_2d,*mask,*result;
 unsigned long startleft,starttop;
 struct int_bound_rec *bound;
{
 return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,bound,
                           sobel_2d_by_mask_proc,result,0,0,0,0,0,0,0,0);
}


/*----------------------------------------------------------------------
sobel_2d - ???
-----------------------------------------------------------------------*/

int
sobel_2d(_2d,result)
 struct buf_2d_rec *_2d,*result;
{
 unsigned long row,col,num_rows,num_cols,last;
 double val1,val2,val3,val4,val5,val6,val7,val8,gx,gy,gx1,gy1;

 if ((_2d->dimx <= 1) || (_2d->dimy <= 1)) return CANCEL;

 num_cols = _2d->dimx - 1;
 num_rows = _2d->dimy - 1;

 for (row = 1; row < num_rows; row++)
    for (col = 1; col < num_cols; col++)
       {val1 = _2d->GetVal(_2d,row-1,col-1);
        val2 = _2d->GetVal(_2d,row-1,col);
        val3 = _2d->GetVal(_2d,row-1,col+1);
        val4 = _2d->GetVal(_2d,row,col+1);
        val5 = _2d->GetVal(_2d,row+1,col+1);

        val6 = _2d->GetVal(_2d,row+1,col);
        val7 = _2d->GetVal(_2d,row+1,col-1);
        val8 = _2d->GetVal(_2d,row,col-1);
        gx = val7 + 2 * val6 + val5;
        gx1 = val1 + 2 * val2 + val3;
        if (gx > gx1) gx -= gx1;
          else gx = gx1 - gx;

        gy = val3 + 2 * val4 + val5;
        gy1 = val1 + 2 * val8 + val7;
        if (gy > gy1) gy -= gy1;
          else gy = gy1 - gy;

        result->SetVal(result,row,col,gx + gy);
       }
 for (col = 1; col < num_cols; col++)
    {val4 = _2d->GetVal(_2d,1,col);
     result->SetVal(result,0,col,val4);
    }
 last = num_rows - 1;
 for (col = 1; col < num_cols; col++)
    {val4 = _2d->GetVal(_2d,last,col);
     result->SetVal(result,num_rows,col,val4);
    }

 for (row = 0; row < num_rows; row++)
    {val4 = _2d->GetVal(_2d,row,1);
     result->SetVal(result,row,0,val4);
    }
 last = num_cols - 1;
 for (row = 0; row < num_rows; row++)
    {val4 = _2d->GetVal(_2d,row,last);
     result->SetVal(result,row,num_cols,val4);
    };
 return NO_ERROR;
}



/*----------------------------------------------------------------------
Gradient2dByMaskProc - ???
-----------------------------------------------------------------------*/

int
Gradient2dByMaskProc(_2d,row,col,result,set_edge_threshold,edge_threshold,
                    set_edge,edge_value,set_background,background_value)
 struct buf_2d_rec *_2d,*result;
 unsigned long row,col;
 int *set_edge_threshold,*set_edge,*set_background;
 double *edge_threshold,*edge_value,*background_value;
{
 unsigned long last_row,last_col;
 double val,val1,val2,val3,val4,val5,val6,val7,val8,temp,gx,gy,gx1,gy1;

 last_col = _2d->dimx - 1;
 last_row = _2d->dimy - 1;
 if (row > 0)
    {temp = row-1;
     if (col > 0)
        val1 = _2d->GetVal(_2d,temp,col-1);
       else val1 = 0;
     val2 = _2d->GetVal(_2d,temp,col);
     if (col < last_col)
        val3 = _2d->GetVal(_2d,temp,col+1);
       else val3 = 0;
    }
   else val1 = val2 = val3 = 0;
 /* FIXME!! temp might not be initialized at this point and is used below. */
 if (row < last_row)
    {row = row+1;
     if (col < last_col)
        val5 = _2d->GetVal(_2d,temp,col+1);
       else val5 = 0;
     val6 = _2d->GetVal(_2d,temp,col);
     if (col > 0)
        val7 = _2d->GetVal(_2d,temp,col-1);
       else val7 = 0;
    }
   else val5 = val7 = val6 = 0;
 if (col < last_col)
    val4 = _2d->GetVal(_2d,row,col+1);
   else val4 = 0;
 if (col > 0)
    val8 = _2d->GetVal(_2d,row,col-1);
   else val8 = 0;
 gx = val7 + 2 * val6 + val5;
 gx1 = val1 + 2 * val2 + val3;
 if (gx > gx1) gx -= gx1;
   else gx = gx1 -gx;

 gy = val3 + 2 * val4 + val5;
 gy1 = val1 + 2 * val8 + val7;
 if (gy > gy1) gy -= gy1;
   else gy = gy1 - gy;

 if (*set_edge_threshold)
    {gx += gy;
     if (gx > *edge_threshold)
        {if (*set_edge) val = *edge_value;
           else val = gx;
        }
       else if (*set_background) val = *background_value;
       else val = gx;
    }
   else val = gx + gy;
 result->SetVal(result,row,col,val);
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Gradient2dByMask - ???
-----------------------------------------------------------------------*/

int
Gradient2dByMask(_2d,startleft,starttop,mask,bound,result,
                 edge_threshold,
                 set_edge,edge_value,set_background,background_value)
 struct buf_2d_rec *_2d,*mask,*result;
 unsigned long startleft,starttop;
 struct int_bound_rec *bound;
 int set_edge,set_background;
 double edge_threshold,edge_value,background_value;
{
 int set_edge_threshold;

 if (((_2d->dimx - 1) == 0) || ((_2d->dimy - 1) == 0)) return NO_ERROR;
 set_edge_threshold = set_edge | set_background;
 return process_buf_2d_rec_by_mask(_2d,startleft,starttop,mask,bound,
     Gradient2dByMaskProc,result,&set_edge_threshold,&edge_threshold,&set_edge,
         &edge_value,&set_background,&background_value,0,0);

}


/*----------------------------------------------------------------------
Gradient2d - ???
-----------------------------------------------------------------------*/

int
Gradient2d(result,src,edge_threshold,
                    set_edge,edge_value,set_background,background_value)
 struct buf_2d_rec *result,*src;
 int set_edge,set_background;
 double edge_threshold,edge_value,background_value;
{
 unsigned long row,col,col_minus_1,col_plus_1,row_minus_1,row_plus_1,
              num_rows,num_cols;
 unsigned long set_edge_threshold;
 double gx,gy,gx1,gy1,val;

 if ((src->dimx <= 1) || (src->dimy <= 1)) return CANCEL;
 num_cols = src->dimx - 1;
 num_rows = src->dimy - 1;
 set_edge_threshold = set_edge | set_background;
 for (row = 1; row < num_rows; row++)
    for (col = 1; col < num_cols; col++)
       {col_minus_1 = col - 1;
        col_plus_1 = col + 1;
        row_minus_1 = row - 1;
        row_plus_1 = row + 1;
        gx = src->GetVal(src,row_plus_1,col_minus_1) +
             2 * src->GetVal(src,row_plus_1,col) +
             src->GetVal(src,row_plus_1,col_plus_1);

        gx1 = src->GetVal(src,row_minus_1,col_minus_1) +
             2 * src->GetVal(src,row_minus_1,col) +
             src->GetVal(src,row_minus_1,col_plus_1);

        if (gx > gx1) gx -= gx1;
          else gx = gx1 -gx;

        gy = src->GetVal(src,row_minus_1,col_plus_1) +
             2 * src->GetVal(src,row,col_plus_1) +
             src->GetVal(src,row_plus_1,col_plus_1);

        gy1 = src->GetVal(src,row_minus_1,col_minus_1) +
             2 * src->GetVal(src,row,col_minus_1) +
             src->GetVal(src,row_plus_1,col_minus_1);

        if (gy > gy1) gy -= gy1;
          else gy = gy1 - gy;

        if (set_edge_threshold)
           {gx += gy;
            if (gx > edge_threshold)
               {if (set_edge) val = edge_value;
                  else val = gx;
               }
              else if (set_background) val = background_value;
              else val = gx;
           }
          else val = gx + gy;
        result->SetVal(result,row,col,val);
       }
 for (col = 1; col < num_cols; col++)
    {val = result->GetVal(result,1,col);
     result->SetVal(result,0,col,val);
    }
 for (col = 1; col < num_cols; col++)
    {val = result->GetVal(result,num_rows - 1,col);
     result->SetVal(result,num_rows,col,val);
    }
 for (row = 0; row < num_rows; row++)
    {val = result->GetVal(result,row,1);
     result->SetVal(result,row,0,val);
    }
 for (row = 0; row < num_rows; row++)
    {val = result->GetVal(result,row,num_cols - 1);
     result->SetVal(result,row,num_cols,val);
    }

 return NO_ERROR;
}



/*----------------------------------------------------------------------
list_coord_rec - ???
-----------------------------------------------------------------------*/

struct list_xy_rec
   {unsigned long x,y;
   };

struct list_coord_rec
   {unsigned long num_xys,total_xys;
    struct list_xy_rec *xys;
   };



/*----------------------------------------------------------------------
init_list_coord_rec - ???
-----------------------------------------------------------------------*/

static void
init_list_coord_rec(list)
 struct list_coord_rec *list;
{
 list->num_xys = list->total_xys = 0;
 list->xys = NULL;
}


/*----------------------------------------------------------------------
free_list_coord_rec - ???
-----------------------------------------------------------------------*/

static void
free_list_coord_rec(list)
 struct list_coord_rec *list;
{
 if (list->total_xys > 0) c_free(list->xys);
}


/*----------------------------------------------------------------------
GrowRegion - ???
-----------------------------------------------------------------------*/

int
GrowRegion(_2d,starty,startx,lb,ub,mask,bound_area)
 struct buf_2d_rec *_2d,*mask;
 unsigned long startx,starty;
 double lb,ub;
 struct int_bound_rec *bound_area;
{
 struct list_coord_rec list;
 long row,col,cnt,x,y;
 double val;
 int err;

 InitBuf2dRecData(mask,(double) .0);
 val = _2d->GetVal(_2d,starty,startx);

 TRACE(printf("starty = %d startx = %d val = %f lb = %d ub = %d\n",
        starty,startx,val,lb,ub))

 if ((val < lb) || (val > ub)) return NO_ERROR;
 mask->SetVal(mask,starty,startx,(double) 1.0);
 init_list_coord_rec(&list);
 setup_int_bound_rec(bound_area,_2d->dimx,_2d->dimy,
                     -1,-1);

 err = NO_ERROR;
 x = startx;
 y = starty;
 while (1)
    {for (cnt = 0; cnt < 8; cnt++)
        {row = y + neighbor_Offset[cnt][1];
         if ((row < 0) || (row >= _2d->dimy)) continue;
         col = x + neighbor_Offset[cnt][0];
         if ((col < 0) || (col >= _2d->dimx)) continue;
         if (mask->GetVal(mask,row,col) != .0)
            continue;
         val = _2d->GetVal(_2d,row,col);
         if ((val < lb) || (val > ub)) continue;
         mask->SetVal(mask,row,col,(double) 1.0);
         if (list.num_xys == list.total_xys)
            {if ((err = get_ptr(&(list.xys),&(list.total_xys),100,
                   (size_t) sizeof(*(list.xys)))) != NO_ERROR)
                break;}
         list.xys[list.num_xys].x = col;
         list.xys[list.num_xys].y = row;
         list.num_xys += 1;
         if (bound_area->left > col) bound_area->left = col;
         if (bound_area->right < col) bound_area->right = col;
         if (bound_area->top > row) bound_area->top = row;
         if (bound_area->bottom < row) bound_area->bottom = row;
        }
     if (list.num_xys == 0) break;
     list.num_xys -= 1;
     x = list.xys[list.num_xys].x;
     y = list.xys[list.num_xys].y;
    }
 free_list_coord_rec(&list);
 return err;
}


/*----------------------------------------------------------------------
PtsMeanAndSd - ???
-----------------------------------------------------------------------*/

int
PtsMeanAndSd(vals,num_vals,mean,sd)
 double *vals,*mean,*sd;
 unsigned long num_vals;
{
 long cnt;
 double sxx,total,dval;

 for (sxx = .0,total = .0,cnt = 0; cnt < num_vals; cnt++)
    {
     dval = vals[cnt];
     sxx +=  dval * dval;
     total += dval;
    }
 *mean = total / (double) num_vals;

 if (num_vals == 1) *sd = 0;
   else
    {total = total * total / (double) num_vals;
     total = (sxx - total) / (double) (num_vals - 1.0);
     *sd = sqrt(total);
    }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
_2dPtMeanAndSd - ???
-----------------------------------------------------------------------*/

int
_2dPtMeanAndSd(_2d,row,col,mean,sd)
 struct buf_2d_rec *_2d;
 unsigned long row,col;
 double *mean,*sd;
{
 long cnt,x,y;
 double val,sxx,total,num_vals;

 for (num_vals = 0,sxx = .0,total = .0,cnt = 0; cnt < 8; cnt++)
    {y = row + neighbor_Offset[cnt][1];
     if ((y < 0) || (y >= _2d->dimy)) continue;
     x = col + neighbor_Offset[cnt][0];
     if ((x < 0) || (x >= _2d->dimx)) continue;
     val = _2d->GetVal(_2d,y,x);
     sxx += val * val;
     total += val;
     num_vals += 1.0;
    }
 val = _2d->GetVal(_2d,row,col);
 sxx += val * val;
 total += val;
 num_vals += 1.0;
 *mean = total / num_vals;
 if (num_vals == 1) *sd = 0;
   else
    {total = total * total / num_vals;
     total = (sxx - total) / (num_vals - 1);
     *sd = sqrt(total);
    }
/*
 printf("*mean = %f  sd = %f\n",*mean,*sd);
*/
 return NO_ERROR;
}


/*----------------------------------------------------------------------
_2dMeanAndSd - ???
-----------------------------------------------------------------------*/

int
_2dMeanAndSd(_2d,mask,bound_area,mean,sd)
 struct buf_2d_rec *_2d,*mask;
 struct int_bound_rec *bound_area;
 double *mean,*sd;
{
 long row,col;
 double total,sxx,dval,num_vals;
 struct int_bound_rec bound,bound1;

 /* printf("_2dMeanAndSd...\n");*/
 if (bound_area == NULL)
     setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
   else
    {setup_int_bound_rec(&bound1,0,0,_2d->dimx - 1,_2d->dimy - 1);
     TRACE(printf("_2dMeanAndSd...bound_area\n");pr_int_bound_rec(bound_area))
     valid_bound(bound_area,&bound1,&(bound.left),&(bound.right),
                 &(bound.top),&(bound.bottom));
     TRACE(pr_int_bound_rec(&bound))
    }

 for (num_vals = 0,sxx = total = .0,row = bound.top; row <= bound.bottom; row++)
    for (col = bound.left; col <= bound.right; col++)
       {if ((mask == NULL) ||
            (mask->GetVal(mask,row,col) != .0))
           {dval = _2d->GetVal(_2d,row,col);
            sxx +=  dval * dval;
            total += dval;
            num_vals += 1.0;}
       }
 if (num_vals == 0.0)
    {*mean = 0;
     *sd = 0;}
   else
    {
     *mean = (total / num_vals);
     if (num_vals == 1) *sd = .0;
       else
        {total = total * total / num_vals;
         total = (sxx - total) / (num_vals - 1);
         *sd = sqrt(total);
        }
    }
 /*printf("mean = %.2f   sd = %.2f\n",*mean,*sd);*/
 return NO_ERROR;
}


/*----------------------------------------------------------------------
_2dTransitionMap - ???
-----------------------------------------------------------------------*/

int
_2dTransitionMap(_2d,lb,ub,mask,bound_area)
 struct buf_2d_rec *_2d,*mask;
 double lb,ub;
 struct int_bound_rec *bound_area;
{
 long row,col;
 double val;
 struct int_bound_rec bound,bound1;

 if (bound_area == NULL)
     setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
   else
    {setup_int_bound_rec(&bound1,0,0,_2d->dimx - 1,_2d->dimy - 1);
     valid_bound(bound_area,&bound1,&(bound.left),&(bound.right),
                 &(bound.top),&(bound.bottom));}
 for (row = bound.top; row <= bound.bottom; row++)
    for (col = bound.left; col <= bound.right; col++)
       {if ((mask == NULL) ||
            (mask->GetVal(mask,row,col) != .0))
           {val = _2d->GetVal(_2d,row,col);
            if (val < lb) val = lb - val;
              else if (val > ub) val -= ub;
              else val = 0;
            _2d->SetVal(_2d,row,col,val);
           }
       }
 return NO_ERROR;
}


/*----------------------------------------------------------------------
Histogram2d - ???
-----------------------------------------------------------------------*/

int
Histogram2d(_2d,src,src_row,src_col_start,use_value,value,is_clear_src)
 struct buf_2d_rec *_2d,*src;
 unsigned long src_row,src_col_start;
 int use_value,is_clear_src;
 double value;
{
 unsigned long row,col,start,last;
 double val,min,max,ratio,diff;

 if ((_2d->dimy == 0) || (_2d->dimx == 0) || 
     (_2d->dimx < src->dimx)) return CANCEL;
 min = max = src->GetVal(src,src_row,src_col_start);
 for (col = src_col_start + 1; col < src->dimx; col++)
    {val = src->GetVal(src,src_row,col);
     if (val < min) min = val;
     if (val > max) max = val;}
 diff = max - min;
 last = _2d->dimy - 1;
 PRT1(printf("Histogram2d min = %f max = %f last = %d src_col_start = %d src_row = %d\n",min,max,last,src_col_start,src_row);)
 for (col = src_col_start; col < src->dimx; col++)
    {
     val = src->GetVal(src,src_row,col);
     if (is_clear_src) 
        src->SetVal(src,src_row,col,(double) .0);
     if (diff == .0) start = last;
       else
        {ratio = (val - min) * (double) last / diff;
         start = last - (long) floor(ratio);}
     if (use_value) val = value;
     PRT(printf("col = %d start = %d val = %f min = %f max = %f\n",
            col,start,val,min,max);)
     for (row = start; row <= last; row++)
        _2d->SetVal(_2d,row,col,val);
    }
 return NO_ERROR;  
}


/*----------------------------------------------------------------------
AutoSetHisto1DBuf - ???
-----------------------------------------------------------------------*/

int
AutoSetHisto1DBuf(histo,row_indx,min_bkg_value,max_bkg_value,cutoff_start,
                  is_clear_histo)
 struct buf_2d_rec *histo;
 unsigned long row_indx,min_bkg_value,max_bkg_value,*cutoff_start;
 int is_clear_histo;
{
 unsigned long lcv,cnt,last;
 double val,val1;
 int is_done;

 if (max_bkg_value < histo->dimx) last = max_bkg_value;
   else last = histo->dimx - 1;
 for (lcv = min_bkg_value; lcv <= last; lcv++)
    {val = histo->GetVal(histo,row_indx,lcv);
     for (is_done = 0,cnt = lcv + 2; cnt < histo->dimx; cnt++)
        {val1 = histo->GetVal(histo,row_indx,cnt);
         if (val < val1) 
            {is_done = 1;
             break;}
        }
     if (is_done) break;
    }
 if ((lcv > 0) && is_clear_histo)
    for (cnt = 0; cnt < lcv; cnt++)
       histo->SetVal(histo,row_indx,cnt,(double) .0);
 if (cutoff_start != NULL) *cutoff_start = lcv;
 return NO_ERROR;  
}


/*----------------------------------------------------------------------
AutoSet2dBackground- ???
-----------------------------------------------------------------------*/

int
AutoSet2dBackground(_2d,histo_width,min_bkg_value,max_bkg_value)
 struct buf_2d_rec *_2d;
 unsigned long histo_width,min_bkg_value,max_bkg_value;
{
 struct buf_2d_rec histo,temp;
 unsigned long depth,lcv,row,col,indx;
 double fval,min,max;
 int err;

 depth = find_num_bytes_needed(_2d->dimx * _2d->dimy);
 init_buf_2d_rec(&histo);
 init_buf_2d_rec(&temp);
 if (((err = copy_buf_2d_rec(&temp,_2d)) == NO_ERROR) &&
     ((err = SetupBuf2dRec(&histo,histo_width,1,depth,1)) == NO_ERROR))
    {
     Scale2dPixels(&temp,&temp,(double) .0,(double) (histo_width - 1),
          0,(double) .0,(double) .0,0);
     for (row = 0; row < temp.dimy; row++)
        for (col = 0; col < temp.dimx; col++)
           {fval = temp.GetVal(&temp,row,col);
            indx = (unsigned long) (fval + .5);
            Add2dVal(&histo,0,indx,(double) 1.0);
           }
     AutoSetHisto1DBuf(&histo,0,min_bkg_value,max_bkg_value,&lcv,0);
     if (lcv > 0)
        {SelectAssign2d(&temp,&temp,0x00000510,
             (double) .0,(double) lcv,(double) 1.0,(double) 0.0,
               NULL,0,0);
         MinMax2dValues(_2d,0,(double) 0.0,(double) 0.0,&min,&max);

         SelectAssign2d(_2d,&temp,0x00000104,
             (double) 0.0,(double) 0.0,(double) .0,(double) 0.0,
               NULL,0,0);
         PRT1(printf("after...temp = %d _2d = %d\n",
                   CntValBuf2dRec(&temp,(double) 0),
                   CntValBuf2dRec(_2d,(double) 0)))
        }
    }

 free_buf_2d_rec(&temp);
 free_buf_2d_rec(&histo);
 return err;
}


/*----------------------------------------------------------------------
CombinePosNeg2d - ???
-----------------------------------------------------------------------*/

int
CombinePosNeg2d(result,pos,neg)
 struct buf_2d_rec *result,*pos,*neg;
{
 struct buf_2d_rec _2d;
 double minval,maxval,val;
 unsigned long depth,type4,row,col;
 int err;

 PRT3(printf("...CombinePosNeg2d\n"))
 if (!is_same_buf_2d_rec_data_size(pos,neg)) return CANCEL;
 if ((pos->status4 & BUF_VALUE_DOUBLE) || (neg->status4 & BUF_VALUE_DOUBLE))
    {type4 = BUF_VALUE_DOUBLE;
     depth = 8 * sizeof(double);}
   else if ((pos->status4 & BUF_VALUE_FLOAT) ||
            (neg->status4 & BUF_VALUE_FLOAT))
    {type4 = BUF_VALUE_FLOAT;
     depth = 8 * sizeof(float);}
   else
    {
     MinMax2d(pos,0,(double) .0,(double) .0);
     PRT3(printf("CombinePosNeg2d...pos minval = %f maxval = %f\n",
                 pos->minval,pos->maxval))
     PRT3(MinMax2dValues(pos,0,(double) .0,(double) .0,&min4,&max4);
         printf("pos min4 = %f max4 = %f\n",min4,max4))

     MinMax2d(neg,0,(double) .0,(double) .0);
     PRT3(printf("...neg minval = %f maxval = %f\n",
                 neg->minval,neg->maxval))
     PRT3(MinMax2dValues(neg,0,(double) .0,(double) .0,&min4,&max4);
         printf("neg min4 = %f max4 = %f\n",min4,max4))

     if (-neg->minval > -neg->maxval)
        minval = -neg->maxval;
       else minval = -neg->minval;
     if (minval < pos->maxval) maxval = pos->maxval;
       else
        {maxval = minval;
         minval = pos->maxval;}
     depth = GetDepthNeeded(minval,maxval,&type4);
     PRT3(printf("...depth = %d minval = %f maxval = %f type4 = %x\n",
                 depth,minval,maxval,type4))
     if (depth < neg->pixel_depth) depth = neg->pixel_depth;
    }
 PRT3(printf("CombinePosNeg2d...depth = %d\n",depth))
 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,pos->dimx,pos->dimy,depth,type4)) != NO_ERROR)
    return err;
 for (row = 0; row < pos->dimy; row++)
    for (col = 0; col < pos->dimx; col++)
       {val = neg->GetVal(neg,row,col);
        if (val != .0)
           {_2d.SetVal(&_2d,row,col,-val);
           }
          else
           {val = pos->GetVal(pos,row,col);
            _2d.SetVal(&_2d,row,col,val);
           }
       }
 if (is_same_buf_2d_rec_data_size(result,&_2d)) 
    {err = copy_buf_2d_rec_content(result,&_2d);
     PRT3(printf("same_size...result...err = %d\n",err))
     PRT3(pr_buf_2d_rec(&_2d))
     free_buf_2d_rec(&_2d);}
   else
    {free_buf_2d_rec(result);
     *result = _2d;}
 PRT3(printf("result...\n"))
 PRT3(pr_buf_2d_rec(result))
 PRT3(MinMax2dValues(result,0,(double) .0,(double) .0,&min4,&max4);
         printf("result min4 = %f max4 = %f\n",min4,max4))
 PRT3(printf("CombinePosNeg2d......err = %d\n\n",err))
 return err;
}
