/****************************************************************************
2dbufxtraopr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 2dbufxtraopr.c,v 1.8 1999/07/07 18:01:05 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <math.h>
#include <stdio.h>

#include <sys/types.h>
#include <sys/timeb.h>

#include "common.h"
#include "rect.h"
#include "error_constants.h"
#include "nria_lib.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)


/* Private functions */
extern int SetupMaskRec(struct mask_rec *mask, struct buf_2d_rec *_2d, 
    double lb, double ub);
extern int Smooth2d(struct buf_2d_rec *_2d, long num_neighbors);
extern double Resampled2dVal(struct buf_2d_rec *_2d, double dx, double dy);
extern int Resize2dUnitAndDimXY(struct buf_2d_rec *dst, 
    struct buf_2d_rec *src, double dustartx, double dustarty, int use_dunitxy,
    double dunitx, double dunity, int use_ddimxy, unsigned long ddimx,
    unsigned long ddimy, double sunitx, double sunity, double min_unitxy,
    double max_unitxy, unsigned long min_dimxy, unsigned long max_dimxy,
    float *new_unitx, float *new_unity, unsigned long *new_dimx,
    unsigned long *new_dimy);
extern int ResizeBuf2dRec(struct buf_2d_rec *dst, struct buf_2d_rec *src,
    unsigned long ddimx, unsigned long ddimy, struct matrix_2d_rec *to_src);



/*-------------------------------------------------------------------------
init_mask_rec - ???
-------------------------------------------------------------------------*/

void
init_mask_rec(mask)
 struct mask_rec *mask;
{
 init_buf_2d_rec(&(mask->_2d));
 mask->total_pixels = 0;
}


/*-------------------------------------------------------------------------
free_mask_rec1 - ???
-------------------------------------------------------------------------*/

void
free_mask_rec1(mask)
 struct mask_rec *mask;
{
 free_buf_2d_rec(&(mask->_2d));
 init_mask_rec(mask);
}


/*-------------------------------------------------------------------------
cp_mask_rec - ???
-------------------------------------------------------------------------*/

int
cp_mask_rec(dst,src)
 struct mask_rec *dst,*src;
{
 struct buf_2d_rec tmp;
 int err;

 init_buf_2d_rec(&tmp);
 if ((err = copy_buf_2d_rec(&tmp,&(src->_2d))) != NO_ERROR)
    {free_buf_2d_rec(&tmp);
     return err;}
 free_mask_rec1(dst);
 dst->_2d = tmp;
 dst->total_pixels = src->total_pixels;
 return err;
}


/*-------------------------------------------------------------------------
SetupMaskRec - ???
-------------------------------------------------------------------------*/

int
SetupMaskRec(mask,_2d,lb,ub)
 struct mask_rec *mask;
 struct buf_2d_rec *_2d;
 double lb,ub;
{
 int err;

 if ((err = SetupBuf2dRec(&(mask->_2d),_2d->dimx,_2d->dimy,1,0)) == NO_ERROR)
    err = _2dToBitMask(&(mask->_2d),_2d,lb,ub);
 return err;
}



 /* if set_inc_val != 0 then the members
                                             are set to *inc_val */
/*********************************
 Start large commented-out section
 *********************************
find_byte_members(_2d,dimx,dimy,members,num_members,
                  set_inc_val,inc_val,set_ex_val,ex_val)
 unsigned char **_2d;
 unsigned long dimx,dimy;
 unsigned char *members;
 unsigned long num_members;
 unsigned char set_inc_val,set_ex_val;
 unsigned char inc_val,ex_val;
{
 unsigned long row,col,cnt,max_members;

 max_members = num_members * 2;
 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx;col++)
       {for (cnt = 0; cnt < max_members; cnt += 2)
           if ((_2d[row][col] >= members[cnt]) &&
               (_2d[row][col] <= members[cnt + 1]))
              {if (set_inc_val) _2d[row][col] = inc_val;
               break;}
        if ((cnt == max_members) && set_ex_val) _2d[row][col] = ex_val;
       }
}
*************************/

/*
  "members" has "num_members" pairs of values --- members[cnt] & memebrs[cnt+1]
  describe the range of values to be considered members...
  if (set_inc_val) then the new values for members will be "inc_val"
     else the member values remain the same....
  if (set_ex_val) then the new values for non members will be "ex_val"
     else the non member values remain the same....
*/
 /* if set_inc_val != 0 then the members
                                             are set to *inc_val */
/***************************
find_short_members(_2d,dimx,dimy,members,num_members,
                   set_inc_val,inc_val,set_ex_val,ex_val)
 unsigned short **_2d;
 unsigned long dimx,dimy;
 unsigned short *members;
 unsigned long num_members;
 unsigned char set_inc_val,set_ex_val;
 unsigned short inc_val,ex_val;
{
 unsigned long row,col,cnt,max_members;

 TRACE(printf("inc_val = %d ex_val = %d\n",(int)inc_val,(int)ex_val))
 max_members = num_members * 2;
 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx;col++)
       {for (cnt = 0; cnt < max_members; cnt += 2)
           if ((_2d[row][col] >= members[cnt]) &&
               (_2d[row][col] <= members[cnt + 1]))
              {if (set_inc_val) _2d[row][col] = inc_val;
               break;}
        if ((cnt == max_members) && set_ex_val) _2d[row][col] = ex_val;
       }

}
*******************************/
/* if set_inc_val != 0 then the members
                                             are set to *inc_val */
/* the member and non-member values */
/***********************************
find_int_members(_2d,dimx,dimy,members,num_members,
                  set_inc_val,inc_val,set_ex_val,ex_val)
 unsigned long **_2d;
 unsigned long dimx,dimy;
 unsigned long *members;
 unsigned long num_members;
 unsigned char set_inc_val,set_ex_val; 
 unsigned int inc_val,ex_val; 
{
 unsigned long row,col,cnt,max_members;

 max_members = num_members * 2;
 for (row = 0; row < dimy; row++)
    for (col = 0; col < dimx;col++)
       {for (cnt = 0; cnt < max_members; cnt += 2)
           if ((_2d[row][col] >= members[cnt]) &&
               (_2d[row][col] <= members[cnt + 1]))
              {if (set_inc_val) _2d[row][col] = inc_val;
               break;}
        if ((cnt == max_members) && set_ex_val) _2d[row][col] = ex_val;
       }
}
*********************************/
/* if set_inc_val != 0 then the members
                                             are set to *inc_val */
 /* the member and non-member values */
/**********************************
find_members(_2d,members,num_members,
             set_inc_val,inc_val,set_ex_val,ex_val)
 struct buf_2d_rec *_2d;
 unsigned char *members;
 unsigned long num_members;
 unsigned char set_inc_val,set_ex_val; 
 unsigned char *inc_val,*ex_val;
{
 if (!(set_inc_val || set_ex_val)) return;

 switch (_2d->pixel_depth)
    {case 8 : 
        find_byte_members(_2d->buf,_2d->dimx,_2d->dimy,
             members,num_members,set_inc_val,*inc_val,set_ex_val,*ex_val);
        return NO_ERROR;;
     case 16 : 
        find_short_members(_2d->buf,_2d->dimx,_2d->dimy,
             members,num_members,set_inc_val,
             *((unsigned short *) inc_val),set_ex_val,
             *((unsigned short *) ex_val));
        return NO_ERROR;
     case 32 : 
        find_int_members(_2d->buf,_2d->dimx,_2d->dimy,
              members,num_members,set_inc_val,
             *((unsigned int *) inc_val),set_ex_val,
             *((unsigned int *) ex_val));
        return NO_ERROR;;
     default : return CANCEL;
    }
}
************************************/

/***********************************
pack_2d_bit_pixel_to_bytes(dest_2d,source_2d)
 struct buf_2d_rec *dest_2d,*source_2d;
{
 int err;
 unsigned long lcv,row,col,num_bits,bit_indx,bit_col_indx;

 if ((err = SetupBuf2dRec(dest_2d,source_2d->dimx,source_2d->dimy,
                             (unsigned long) 8,0)) != NO_ERROR) return err;

 for (row = 0; row < dest_2d->dimy; row++)
    for (col = 0; col < dest_2d->dimx; )
       {if (col + 8 > dest_2d->dimx) num_bits = dest_2d->dimx - col;
           num_bits = 8;
        for (bit_col_indx = col / 8,bit_indx = 0; bit_indx < num_bits; 
                                       bit_indx++,col++)
           {
            if (source_2d->buf[row][bit_col_indx] & C_which_bit[bit_indx])
               dest_2d->buf[row][col] = 1;
              else dest_2d->buf[row][col] = 0;
           }
        }
 return NO_ERROR;

}

pack_2d_short_pixel_to_bytes(dest_2d,source_2d)
 struct buf_2d_rec *dest_2d,*source_2d;
{
 int err;
 unsigned long lcv,row,col;
 unsigned short *short_ptr;

 if ((err = SetupBuf2dRec(dest_2d,source_2d->dimx,source_2d->dimy,
                             (unsigned long) 8,0)) != NO_ERROR)
    return err;

 for (row = 0; row < dest_2d->dimy; row++)
    for (short_ptr = (unsigned short *) source_2d->buf[row],col = 0; 
         col < dest_2d->dimx; col++)
       dest_2d->buf[row][col] = short_ptr[col];

 return NO_ERROR;
}

pack_2d_int_pixel_to_bytes(dest_2d,source_2d)
 struct buf_2d_rec *dest_2d,*source_2d;
{
 int err;
 unsigned long lcv,row,col;
 unsigned int *int_ptr;

 if ((err = SetupBuf2dRec(dest_2d,source_2d->dimx,source_2d->dimy,
                             (unsigned long) 8,0)) != NO_ERROR)
    return err;

 for (row = 0; row < dest_2d->dimy; row++)
    for (int_ptr = (unsigned int *) source_2d->buf[row],col = 0; 
         col < dest_2d->dimx; col++)
       dest_2d->buf[row][col] = int_ptr[col];

 return NO_ERROR;
}

pack_2d_pixel_to_bytes(_2d_bytes,_2d)
 struct buf_2d_rec *_2d_bytes,*_2d;
{
 TRACE(printf("pack_2d_pixel_to_bytes...= %d\n",(int) _2d->pixel_depth))
 
 switch (_2d->pixel_depth)
     {
      case 8 : 
          return copy_buf_2d_rec(_2d_bytes,_2d);
      case 1 : return pack_2d_bit_pixel_to_bytes(_2d_bytes,_2d);
      case 16 : return pack_2d_short_pixel_to_bytes(_2d_bytes,_2d);
      case 32 : return pack_2d_int_pixel_to_bytes(_2d_bytes,_2d);
      default : return CANCEL;
     }
 TRACE(printf("bad data...end\n"))
 
}
*****************************************
End large commented-out section
*****************************************/



/*-------------------------------------------------------------------------
Smooth2dValue - ???
-------------------------------------------------------------------------*/

double 
Smooth2dValue(
    struct buf_2d_rec *_2d,
    unsigned long row,
    unsigned long col,
    long num_neighbors)
{
 long last_row,next_row,last_col,next_col,num;
 double val;

 val = 0;
 last_row = row - 1;
 last_col = col - 1;
 next_row = row + 1;
 next_col = col + 1;
 num = 0;
 if (row > 0)
    {if (col > 0)
        {val = _2d->GetVal(_2d,last_row,last_col);
         num += 1;}
     if (num_neighbors == 16)
        {val += 2 * _2d->GetVal(_2d,last_row,col);
         num += 2;}
       else
        {val += _2d->GetVal(_2d,last_row,col);
         num += 1;}
     if (col < (_2d->dimx - 1))
        {val += _2d->GetVal(_2d,last_row,next_col);
         num += 1;}
    }
 if (col > 0)
    if (num_neighbors == 16)
       {val += 2 * _2d->GetVal(_2d,row,last_col);
        num += 2;}
      else
       {val += _2d->GetVal(_2d,row,last_col);
        num += 1;}
   
 if (num_neighbors == 9)
    {val += _2d->GetVal(_2d,row,col);
     num += 1;}
   else if (num_neighbors == 16)
    {val += 4 * _2d->GetVal(_2d,row,col);
     num += 4;}

 if (col < (_2d->dimx - 1))
    if (num_neighbors == 16)
       {val += 2 * _2d->GetVal(_2d,row,next_col);
        num += 2;}
      else 
       {val += _2d->GetVal(_2d,row,next_col);
        num += 1;}

 if (row < (_2d->dimy - 1))
    {if (col > 0)
        {val += _2d->GetVal(_2d,next_row,last_col);
         num += 1;}
     if (num_neighbors == 16)
        {val += 2 * _2d->GetVal(_2d,next_row,col);
         num += 2;}
       else 
        {val += _2d->GetVal(_2d,next_row,col);
         num += 1;}

     if (col < (_2d->dimx - 1))
        {val += _2d->GetVal(_2d,next_row,next_col);
         num += 1;}
    }
 val = floor((double) ((double) val / (double) num + .5));
 return val;
}



/*-------------------------------------------------------------------------
Smooth2d - ???

 num_neighbors == 9 then 9 neighrbors
 num_neighbors == 8 then 8 neighrbors
-------------------------------------------------------------------------*/

int
Smooth2d(_2d,num_neighbors)
 struct buf_2d_rec *_2d;
 long num_neighbors;
{
 struct buf_2d_rec buf;
 double val;
 unsigned long row,col,last_row,next_row,last_col,next_col,right,bottom;
 int err;

 PRT(printf("Smooth2d...num_neighbors = %d\n",num_neighbors))
 init_buf_2d_rec(&buf);
 if ((err = SetupBuf2dRec(&buf,_2d->dimx,_2d->dimy,_2d->pixel_depth,
            _2d->status4 & BUF_VALUE_TYPE)) != NO_ERROR) 
    return err;
 PRT(printf("Smooth2d..._2d & buf\n"))
 PRT(pr_buf_2d_rec(_2d))
 PRT(pr_buf_2d_rec(buf))
 last_row = 0;
 next_row = 2;
 right = _2d->dimx - 1;
 bottom = _2d->dimy - 1;
 for (row = 1; row < bottom; )
    {last_col = 0;
     next_col = 2;
     for (col = 1; col < right; )
        {val = _2d->GetVal(_2d,last_row,last_col);
         if (num_neighbors == 16)
            val += 2 * _2d->GetVal(_2d,last_row,col);
           else val += _2d->GetVal(_2d,last_row,col);
         val += _2d->GetVal(_2d,last_row,next_col);
         if (num_neighbors == 16)
            val += 2 * _2d->GetVal(_2d,row,last_col);
           else val += _2d->GetVal(_2d,row,last_col);
         if (num_neighbors == 9)
            val += _2d->GetVal(_2d,row,col);
           else if (num_neighbors == 16)
            val += 4 * _2d->GetVal(_2d,row,col);
         if (num_neighbors == 16)
            val += 2 * _2d->GetVal(_2d,row,next_col);
           else val += _2d->GetVal(_2d,row,next_col);
         val += _2d->GetVal(_2d,next_row,last_col);
         if (num_neighbors == 16)
            val += 2 * _2d->GetVal(_2d,next_row,col);
           else val += _2d->GetVal(_2d,next_row,col);
         val += _2d->GetVal(_2d,next_row,next_col);
         val = (long) floor((double) ((double) val / (double) num_neighbors + .5));
         buf.SetVal(&buf,row,col,val);
         last_col = col;
         col = next_col;
         next_col += 1;
        }         
     
     last_row = row;
     row = next_row;
     next_row += 1;
    }
 for (col = 0; col < _2d->dimx; col++)
    {val = Smooth2dValue(_2d,0,col,num_neighbors);
     buf.SetVal(&buf,0,col,val);
    }
 for (row = 0; row < _2d->dimy; row++)
    {val = Smooth2dValue(_2d,row,0,num_neighbors);
     buf.SetVal(&buf,row,0,val);
    }
 for (col = 0; col < _2d->dimx; col++)
    {val = Smooth2dValue(_2d,bottom,col,num_neighbors);
     buf.SetVal(&buf,bottom,col,val);
    }
 for (row = 0; row < _2d->dimy; row++)
    {val = Smooth2dValue(_2d,row,right,num_neighbors);
     buf.SetVal(&buf,row,right,val);
    }
 PRT(printf("Smooth2d...end\n"))

 memcpy(_2d->buf[0],buf.buf[0],buf.total_bytes);
 free_buf_2d_rec(&buf);
 _2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
Resampled2dVal - ???
-------------------------------------------------------------------------*/

double 
Resampled2dVal(_2d,dx,dy)
 struct buf_2d_rec *_2d;
 double dx,dy;
{
 double fx,fy,disx,disy,fval,val;
 double ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 long tx,ty,nx,ny;

 fy = floor(dy);
 ty = (long) fy;
 fx = floor(dx);
 tx = (long) fx;
 if ((tx < 0) || (tx >= _2d->dimx) || (ty < 0) || (ty >= _2d->dimy))
    return (double) .0;
 disx = dx - fx;
 disy = dy - fy;
 disx_disy = disx * disy;
 disx_ndisy = disx - disx_disy;
 ndisx_disy = disy - disx_disy;
 ndisx_ndisy = 1 - disx - ndisx_disy;

 nx = tx + 1;
 ny = ty + 1;
 val = _2d->GetVal(_2d,ty,tx);
 fval = ndisx_ndisy * val;
 if (nx < _2d->dimx)
    {if ((val = _2d->GetVal(_2d,ty,nx)) != 0)
        fval += disx_ndisy * val;
     if (ny < _2d->dimy)
        {if ((val = _2d->GetVal(_2d,ny,nx)) != 0)
            fval += disx_disy * val;
        }
    }
 if (ny < _2d->dimy)
    {if ((val = _2d->GetVal(_2d,ny,tx)) != 0)
        fval += ndisx_disy * val;
    }
 return fval;
}


/*-------------------------------------------------------------------------
Resize2dUnitAndDimXY - ???
-------------------------------------------------------------------------*/

int
Resize2dUnitAndDimXY(dst,src,dustartx,dustarty,use_dunitxy,dunitx,dunity,
                     use_ddimxy,ddimx,ddimy,sunitx,sunity,
                     min_unitxy,max_unitxy,min_dimxy,max_dimxy,
                     new_unitx,new_unity,new_dimx,new_dimy)
 struct buf_2d_rec *dst,*src;
 float dustartx,dustarty,dunitx,dunity,sunitx,sunity,
       min_unitxy,max_unitxy,*new_unitx,*new_unity;
 unsigned long ddimx,ddimy,min_dimxy,max_dimxy,*new_dimx,*new_dimy;
 int use_dunitxy,use_ddimxy;
{
 double temp;

 *new_unitx = dunitx;
 *new_unity = dunity;
 if (use_dunitxy)
    {if (*new_unitx < min_unitxy) *new_unitx = min_unitxy;
       else if (*new_unitx > max_unitxy) *new_unitx = max_unitxy;
     if (*new_unity < min_unitxy) *new_unity = min_unitxy;
       else if (*new_unity > max_unitxy) *new_unity = max_unitxy;
    }
 *new_dimx = ddimx;
 *new_dimy = ddimy;
 if (use_ddimxy)
    {if (*new_dimx < min_dimxy) *new_dimx = min_dimxy;
       else if (*new_dimx > max_dimxy) *new_dimx = max_dimxy;
     if (*new_dimy < min_dimxy) *new_dimy = min_dimxy;
       else if (*new_dimy > max_dimxy) *new_dimy = max_dimxy;
    }
 if (use_ddimxy && use_dunitxy) return NO_ERROR;
 if (use_dunitxy)
    {temp = (sunitx * src->dimx - dustartx) / *new_unitx;
     *new_dimx = (unsigned long) rint(temp);
     temp = (sunity * src->dimy - dustarty) / *new_unity;
     *new_dimy = (unsigned long) rint(temp);
     if (*new_dimx < min_dimxy) *new_dimx = min_dimxy;
       else if (*new_dimx > max_dimxy) *new_dimx = max_dimxy;
     if (*new_dimy < min_dimxy) *new_dimy = min_dimxy;
       else if (*new_dimy > max_dimxy) *new_dimy = max_dimxy;
    }
 if (use_ddimxy)
    {*new_unitx = (sunitx * src->dimx - dustartx) / *new_dimx;
     *new_unitx = (sunity * src->dimy - dustarty) / *new_dimy;
     if (*new_unitx < min_unitxy) *new_unitx = min_unitxy;
       else if (*new_unitx > max_unitxy) *new_unitx = max_unitxy;
     if (*new_unity < min_unitxy) *new_unity = min_unitxy;
       else if (*new_unity > max_unitxy) *new_unity = max_unitxy;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
ResizeBuf2dRec - ???
-------------------------------------------------------------------------*/

int
ResizeBuf2dRec(dst,src,ddimx,ddimy,to_src)
 struct buf_2d_rec *dst,*src;
 unsigned long ddimx,ddimy;
 struct matrix_2d_rec *to_src;
{
 double fval,val,fx,fy,stx,sty,sx,sy;
 double disx,disy,ndisx_ndisy,disx_ndisy,ndisx_disy,disx_disy;
 long tx,ty,nx,ny;
 unsigned long x,y;
 int err;
 PRT1(struct timeb the_time;)

 PRT1(printf("ResizeBuf2dRec...dst = %u dst->buf = %u src = %u\n",
        dst,dst->buf,src))
 PRT1(printf("...dimx = %d dimy = %d \n",ddimx,ddimy))
 if (ddimx == 0) return 1;
 if (ddimy == 0) return 2;
 if ((err = SetupBuf2dRec(dst,ddimx,ddimy,src->pixel_depth,
              src->status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    {free_buf_2d_rec(dst);
     return err;
    }

 PRT1(printf("ResizeBuf2dRec dst->status4 = %x\n",dst->status4))
 PRT1(pr_buf_2d_rec(dst))
 PRT1(pr_buf_2d_rec(src))
 PRT1(ftime(&the_time))
 PRT1(printf("ResizeBuf2dRec sec = %d  msecs = %d\n",
         (int) the_time.time,the_time.millitm))
 stx = to_src->buf[0][2];
 sty = to_src->buf[1][2];
 for (y = 0; y < ddimy; y++)
    {sy = sty;
     sx = stx;
     for (x = 0; x < ddimx; x++,sx += to_src->buf[0][0],sy += to_src->buf[1][0])
        {if ((sx < .0) || (sx >= src->dimx) ||
             (sy < .0) || (sy >= src->dimy))
            dst->SetVal(dst,y,x,(double) .0);
           else
            {
             fy = floor(sy);
             ty = (long) fy;
             fx = floor(sx);
             tx = (long) fx;
             disx = sx - fx;
             disy = sy - fy;
             disx_disy = disx * disy;
             
             ndisx_disy = disy - disx_disy;
             ndisx_ndisy = 1 - disx - ndisx_disy;

             nx = tx + 1;
             ny = ty + 1;
             val = src->GetVal(src,ty,tx);
             fval = ndisx_ndisy * val;
             if (nx < src->dimx)
                {
                 if ((val = src->GetVal(src,ty,nx)) != 0)
                    {disx_ndisy = disx - disx_disy;
                     fval += disx_ndisy * val;
                    }
                 if (ny < src->dimy)
                    if ((val = src->GetVal(src,ny,nx)) != 0)
                       {fval += disx_disy * val;
                       }
                }
             if (ny < src->dimy)
                if ((val = src->GetVal(src,ny,tx)) != 0)
                   {fval += ndisx_disy * val;
                   }
             dst->SetVal(dst,y,x,fval);
            }
        }
     stx += to_src->buf[0][1];
     sty += to_src->buf[1][1];
    }
 dst->status4 |= BUF_DATA_VALID;
 if (src->status4 & BUF_MIN_MAX_COMPUTED)
    {dst->minval = src->minval;
     dst->maxval = src->maxval;
     dst->status4 |= BUF_MIN_MAX_COMPUTED;
     PRT1(printf("ResizeBuf2dRec MIN_MAX_COMPUTED minval = %f maxval = %f\n",src->minval,src->maxval))
    }
 if (src->status4 & BUF_MIN_MAX_SET)
    {dst->minval_set = src->minval_set;
     dst->maxval_set = src->maxval_set;
     dst->status4 |= BUF_MIN_MAX_SET;
     PRT1(printf("ResizeBuf2dRec BUF_MIN_MAX_SET minval_set = %f maxval_set = %f\n",src->minval_set,src->maxval_set))
    }
 PRT1(ftime(&the_time))
 PRT1(printf("ResizeBuf2dRec sec = %d  msecs = %d  end\n\n",
         (int) the_time.time,the_time.millitm))
 PRT1(MinMax2dValues(src,0,(double) .0,(double) .0,&fx,&fy);
     printf("ResizeBuf2dRec src min4 = %f max4 = %f\n",fx,fy))
 PRT1(MinMax2dValues(dst,0,(double) .0,(double) .0,&fx,&fy);
     printf("ResizeBuf2dRec dst min4 = %f max4 = %f\n",fx,fy))

 return NO_ERROR;
}

