/****************************************************************************
edge.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

The header edge.h contains the appropriate declarations for these tables.
****************************************************************************/

static const char rcsid[] = "$Id: edge.c,v 1.2 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";


unsigned char _EdgeBit[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
unsigned char _EdgeBit012 = 0x07;
unsigned char _EdgeBit234 = 0x1c;
unsigned char _EdgeBit456 = 0x70;
unsigned char _EdgeBit670 = 0xc1;

unsigned long _LONG_BITS[] = 
    {0x00000001,0x00000002,0x00000004,0x00000008,
     0x00000010,0x00000020,0x00000040,0x00000080,
     0x00000100,0x00000200,0x00000400,0x00000800,
     0x00001000,0x00002000,0x00004000,0x00008000,
     0x00010000,0x00020000,0x00040000,0x00080000,
     0x00100000,0x00200000,0x00400000,0x00800000,
     0x01000000,0x02000000,0x04000000,0x08000000,
     0x10000000,0x20000000,0x40000000,0x80000000
    };

unsigned long _OR_SIGNED_EXTENDED_BITS[] = 
    {0xfffffffe,0xfffffffc,0xfffffff8,0xfffffff0,
     0xffffffe0,0xffffffc0,0xffffff80,0xffffff00,
     0xfffffe00,0xfffffc00,0xfffff800,0xfffff000,
     0xffffe000,0xffffc000,0xffff8000,0xffff0000,
     0xfffe0000,0xfffc0000,0xfff80000,0xfff00000,
     0xffe00000,0xffc00000,0xff800000,0xff000000,
     0xfe000000,0xfc000000,0xf8000000,0xf0000000,
     0xe0000000,0xc0000000,0x80000000,0x00000000,
    };

unsigned char _EdgeReversePosi[] = {4,5,6,7,0,1,2,3};
unsigned char _EdgeGroupIndxs[8][2] = 
            {{1,7},{0,2},{1,3}, {2,4},{3,5},{4,6}, {5,7},{6,0}};
int _EdgeOffset[8][2] = {{-1,-1},{ 0,-1},{ 1,-1},
                        { 1, 0},{ 1, 1},{ 0, 1},
                        {-1, 1},{-1, 0}};
char _EdgeOffsetToPosi[3][3] = {{0,1,2},{ 7,0,3},{6,5,4}};
unsigned char _EdgeDoneBits = 0x87;

/*
float _EdgeDistanceWeights[2] = {1.0,1.0};
float _EdgeDistance[2] = {1.0,1.0};
*/

float _EdgeDistanceWeights[2] = {.7017,1.0};
float _EdgeDistance[2] = {1.4142,1.0};

/*  this _EdgeCounts[0...255] has the count of 1-bits for #0 to #255.
    It is used to represent the edge connections of the center pixel
    and its neighbors in a 3 * 3 matrix;  the bit connections for
    representing different edges are as follows :-
           1        2      4
           128    PIXEL    8        (bits are denoted in decimal numbers)
           64      32     16

  _EdgeCounts is defined to be constants to speed up the computation
  of object outline detection.
*/
unsigned char _EdgeCounts[] = {
      0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 
      2, 3, 2, 3, 3, 4, 1, 2, 2, 3, 
      2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 
      4, 5, 1, 2, 2, 3, 2, 3, 3, 4, 
      2, 3, 3, 4, 3, 4, 4, 5, 2, 3, 
      3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 
      4, 5, 5, 6, 1, 2, 2, 3, 2, 3, 
      3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
      2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 
      4, 5, 4, 5, 5, 6, 2, 3, 3, 4, 
      3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 
      5, 6, 3, 4, 4, 5, 4, 5, 5, 6, 
      4, 5, 5, 6, 5, 6, 6, 7, 1, 2, 
      2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 
      3, 4, 4, 5, 2, 3, 3, 4, 3, 4, 
      4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
      2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 
      4, 5, 4, 5, 5, 6, 3, 4, 4, 5, 
      4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 
      6, 7, 2, 3, 3, 4, 3, 4, 4, 5, 
      3, 4, 4, 5, 4, 5, 5, 6, 3, 4, 
      4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 
      5, 6, 6, 7, 3, 4, 4, 5, 4, 5, 
      5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
      4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 
      6, 7, 6, 7, 7, 8};


/*  this _EdgeFirstNonZeroBit[0...255] has the position of the first 1-bit
    encountered in the 1-bits to edge connection representation.
    Please refer to edge_counts defined above for the understanding
    of the 1-bits to edge connection representation

    Note that the first element 0 (for edge 0 == no edge connections)
    is not considered at all in the computations.

    _EdgeFirstNonZeroBit[0...255] speeds up the computation.
*/

unsigned char _EdgeFirstNonZeroBit[] = {
      0, 0, 1, 0, 2, 0, 1, 0, 3, 0, 
      1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 
      2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 
      1, 0, 5, 0, 1, 0, 2, 0, 1, 0, 
      3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 
      1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 
      2, 0, 1, 0, 6, 0, 1, 0, 2, 0, 
      1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 
      4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 
      1, 0, 2, 0, 1, 0, 5, 0, 1, 0, 

      2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 
      1, 0, 4, 0, 1, 0, 2, 0, 1, 0, 
      3, 0, 1, 0, 2, 0, 1, 0, 7, 0, 
      1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 
      2, 0, 1, 0, 4, 0, 1, 0, 2, 0, 
      1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 
      5, 0, 1, 0, 2, 0, 1, 0, 3, 0, 

      1, 0, 2, 0, 1, 0, 4, 0, 1, 0, 
      2, 0, 1, 0, 3, 0, 1, 0, 2, 0, 
      1, 0, 6, 0, 1, 0, 2, 0, 1, 0, 
      3, 0, 1, 0, 2, 0, 1, 0, 4, 0, 
      1, 0, 2, 0, 1, 0, 3, 0, 1, 0, 
      2, 0, 1, 0, 5, 0, 1, 0, 2, 0, 
      1, 0, 3, 0, 1, 0, 2, 0, 1, 0, 
      4, 0, 1, 0, 2, 0, 1, 0, 3, 0, 
      1, 0, 2, 0, 1, 0};


unsigned char _SimplifyEdge[][2] =
   {
     /* 0) 0x0    0 0 0 0 0 0 0 0 */     {0},
     /* 1) 0x1    0 0 0 0 0 0 0 1 */     {0},
     /* 2) 0x2    0 0 0 0 0 0 1 0 */     {0},
     /* 3) 0x3    0 0 0 0 0 0 1 1 */     {1, 0xfe},
     /* 4) 0x4    0 0 0 0 0 1 0 0 */     {0},
     /* 5) 0x5    0 0 0 0 0 1 0 1 */     {0},
     /* 6) 0x6    0 0 0 0 0 1 1 0 */     {1,  0xfd},
     /* 7) 0x7    0 0 0 0 0 1 1 1 */     {1,  0xfc},
     /* 8) 0x8    0 0 0 0 1 0 0 0 */     {0, },
     /* 9) 0x9    0 0 0 0 1 0 0 1 */     {0, },
     /* 10) 0xa    0 0 0 0 1 0 1 0 */     {1,0xfd},
     /* 11) 0xb    0 0 0 0 1 0 1 1 */     {1,  0xfc},
     /* 12) 0xc    0 0 0 0 1 1 0 0 */     {1,  0xfb},
     /* 13) 0xd    0 0 0 0 1 1 0 1 */     {1,  0xf7},
     /* 14) 0xe    0 0 0 0 1 1 1 0 */     {1,  0xf9},
     /* 15) 0xf    0 0 0 0 1 1 1 1 */     {1,  0xf8},

     /* 16) 0x10    0 0 0 1 0 0 0 0 */     {0, },
     /* 17) 0x11    0 0 0 1 0 0 0 1 */     {0,},
     /* 18) 0x12    0 0 0 1 0 0 1 0 */     {0,},
     /* 19) 0x13    0 0 0 1 0 0 1 1 */     {1,  0xfe},
     /* 20) 0x14    0 0 0 1 0 1 0 0 */     {0, },
     /* 21) 0x15    0 0 0 1 0 1 0 1 */     {0, },
     /* 22) 0x16    0 0 0 1 0 1 1 0 */     {1,0xfb},
     /* 23) 0x17    0 0 0 1 0 1 1 1 */     {1,0xfb},
     /* 24) 0x18    0 0 0 1 1 0 0 0 */     {1,0xf7},
     /* 25) 0x19    0 0 0 1 1 0 0 1 */     {0,0xf7},
     /* 26) 0x1a    0 0 0 1 1 0 1 0 */     {0,0xf5},
     /* 27) 0x1b    0 0 0 1 1 0 1 1 */     {0,0xf4},
     /* 28) 0x1c    0 0 0 1 1 1 0 0 */     {1,0xf3},
     /* 29) 0x1d    0 0 0 1 1 1 0 1 */     {1,0xf7},
     /* 30) 0x1e    0 0 0 1 1 1 1 0 */     {1,0xf1},
     /* 31) 0x1f    0 0 0 1 1 1 1 1 */     {1,0xf0},
     /* 32) 0x20    0 0 1 0 0 0 0 0 */     {0,},
     /* 33) 0x21    0 0 1 0 0 0 0 1 */     {0,},
     /* 34) 0x22    0 0 1 0 0 0 1 0 */     {0,},
     /* 35) 0x23    0 0 1 0 0 0 1 1 */     {1,0xfe},
     /* 36) 0x24    0 0 1 0 0 1 0 0 */     {0,},
     /* 37) 0x25    0 0 1 0 0 1 0 1 */     {0,},
     /* 38) 0x26    0 0 1 0 0 1 1 0 */     {1,0xfd},
     /* 39) 0x27    0 0 1 0 0 1 1 1 */     {1,0xfc},
     /* 40) 0x28    0 0 1 0 1 0 0 0 */     {0, 0xf7},
     /* 41) 0x29    0 0 1 0 1 0 0 1 */     {0, 0xf7},
     /* 42) 0x2a    0 0 1 0 1 0 1 0 */     {0, 0xf5},
     /* 43) 0x2b    0 0 1 0 1 0 1 1 */     {1,0xf4},
     /* 44) 0x2c    0 0 1 0 1 1 0 0 */     {1,0xf3},
     /* 45) 0x2d    0 0 1 0 1 1 0 1 */     {1,0xf7},
     /* 46) 0x2e    0 0 1 0 1 1 1 0 */     {1,0xf1},
     /* 47) 0x2f    0 0 1 0 1 1 1 1 */     {1,0xf0},
     /* 48) 0x30    0 0 1 1 0 0 0 0 */     {1,0xef},
     /* 49) 0x31    0 0 1 1 0 0 0 1 */     {1,0xef},
     /* 50) 0x32    0 0 1 1 0 0 1 0 */     {1,0xef},
     /* 51) 0x33    0 0 1 1 0 0 1 1 */     {1,0xee},
     /* 52) 0x34    0 0 1 1 0 1 0 0 */     {1,0xef},
     /* 53) 0x35    0 0 1 1 0 1 0 1 */     {1,0xef},
     /* 54) 0x36    0 0 1 1 0 1 1 0 */     {1,0xeb},
     /* 55) 0x37    0 0 1 1 0 1 1 1 */     {1,0xec},
     /* 56) 0x38    0 0 1 1 1 0 0 0 */     {1,0xe7},
     /* 57) 0x39    0 0 1 1 1 0 0 1 */     {1,0xe7},
     /* 58) 0x3a    0 0 1 1 1 0 1 0 */     {1,0xe5},
     /* 59) 0x3b    0 0 1 1 1 0 1 1 */     {1,0xe4},
     /* 60) 0x3c    0 0 1 1 1 1 0 0 */     {1,0xe3},
     /* 61) 0x3d    0 0 1 1 1 1 0 1 */     {1,0xe3},
     /* 62) 0x3e    0 0 1 1 1 1 1 0 */     {1,0xe1},
     /* 63) 0x3f    0 0 1 1 1 1 1 1 */     {1,0xe0},
     /* 64) 0x40    0 1 0 0 0 0 0 0 */     {0,},
     /* 65) 0x41    0 1 0 0 0 0 0 1 */     {0},
     /* 66) 0x42    0 1 0 0 0 0 1 0 */     {0},
     /* 67) 0x43    0 1 0 0 0 0 1 1 */     {1,0xfe},
     /* 68) 0x44    0 1 0 0 0 1 0 0 */     {0},
     /* 69) 0x45    0 1 0 0 0 1 0 1 */     {0},
     /* 70) 0x46    0 1 0 0 0 1 1 0 */     {1,0xfb},
     /* 71) 0x47    0 1 0 0 0 1 1 1 */     {1,0xfc},
     /* 72) 0x48    0 1 0 0 1 0 0 0 */     {0},
     /* 73) 0x49    0 1 0 0 1 0 0 1 */     {0},
     /* 74) 0x4a    0 1 0 0 1 0 1 0 */     {0,0xfb},
     /* 75) 0x4b    0 1 0 0 1 0 1 1 */     {1,0xfc},
     /* 76) 0x4c    0 1 0 0 1 1 0 0 */     {1,0xfb},
     /* 77) 0x4d    0 1 0 0 1 1 0 1 */     {1,0xf7},
     /* 78) 0x4e    0 1 0 0 1 1 1 0 */     {1,0xf9},
     /* 79) 0x4f    0 1 0 0 1 1 1 1 */     {1,0xf8},
     /* 80) 0x50    0 1 0 1 0 0 0 0 */     {0,},
     /* 81) 0x51    0 1 0 1 0 0 0 1 */     {0,},
     /* 82) 0x52    0 1 0 1 0 0 1 0 */     {0,},
     /* 83) 0x53    0 1 0 1 0 0 1 1 */     {1,0xfe},
     /* 84) 0x54    0 1 0 1 0 1 0 0 */     {0},
     /* 85) 0x55    0 1 0 1 0 1 0 1 */     {0},
     /* 86) 0x56    0 1 0 1 0 1 1 0 */     {1,0xfb},
     /* 87) 0x57    0 1 0 1 0 1 1 1 */     {1,0xfc},
     /* 88) 0x58    0 1 0 1 1 0 0 0 */     {1,0xf7},
     /* 89) 0x59    0 1 0 1 1 0 0 1 */     {1,0xf7},
     /* 90) 0x5a    0 1 0 1 1 0 1 0 */     {1,0xf7},
     /* 91) 0x5b    0 1 0 1 1 0 1 1 */     {1,0xf6},
     /* 92) 0x5c    0 1 0 1 1 1 0 0 */     {1,0xf3},
     /* 93) 0x5d    0 1 0 1 1 1 0 1 */     {1,0xf3},
     /* 94) 0x5e    0 1 0 1 1 1 1 0 */     {1,0xf1},
     /* 95) 0x5f    0 1 0 1 1 1 1 1 */     {1,0xf0},
     /* 96) 0x60    0 1 1 0 0 0 0 0 */     {1,0xdf},
     /* 97) 0x61    0 1 1 0 0 0 0 1 */     {1,0xdf},
     /* 98) 0x62    0 1 1 0 0 0 1 0 */     {1,0xdf},
     /* 99) 0x63    0 1 1 0 0 0 1 1 */     {1,0xde},
     /* 100) 0x64    0 1 1 0 0 1 0 0 */     {1,0xdf},
     /* 101) 0x65    0 1 1 0 0 1 0 1 */     {1,0xdf},
     /* 102) 0x66    0 1 1 0 0 1 1 0 */     {1,0xdb},
     /* 103) 0x67    0 1 1 0 0 1 1 1 */     {1,0xdc},
     /* 104) 0x68    0 1 1 0 1 0 0 0 */     {1,0xd7},
     /* 105) 0x69    0 1 1 0 1 0 0 1 */     {1,0xd7},
     /* 106) 0x6a    0 1 1 0 1 0 1 0 */     {1,0xd5},
     /* 107) 0x6b    0 1 1 0 1 0 1 1 */     {1,0xd4},
     /* 108) 0x6c    0 1 1 0 1 1 0 0 */     {1,0xd3},
     /* 109) 0x6d    0 1 1 0 1 1 0 1 */     {1,0xd3},
     /* 110) 0x6e    0 1 1 0 1 1 1 0 */     {1,0xd1},
     /* 111) 0x6f    0 1 1 0 1 1 1 1 */     {1,0xd0},
     /* 112) 0x70    0 1 1 1 0 0 0 0 */     {1,0xcf},
     /* 113) 0x71    0 1 1 1 0 0 0 1 */     {1,0xcf},
     /* 114) 0x72    0 1 1 1 0 0 1 0 */     {1,0xcf},
     /* 115) 0x73    0 1 1 1 0 0 1 1 */     {2,0xce},
     /* 116) 0x74    0 1 1 1 0 1 0 0 */     {1,0xcf},
     /* 117) 0x75    0 1 1 1 0 1 0 1 */     {1,0xcf},
     /* 118) 0x76    0 1 1 1 0 1 1 0 */     {1,0xcd},
     /* 119) 0x77    0 1 1 1 0 1 1 1 */     {1,0xcc},
     /* 120) 0x78    0 1 1 1 1 0 0 0 */     {1,0xc7},
     /* 121) 0x79    0 1 1 1 1 0 0 1 */     {1,0xc7},
     /* 122) 0x7a    0 1 1 1 1 0 1 0 */     {1,0xc5},
     /* 123) 0x7b    0 1 1 1 1 0 1 1 */     {1,0xc4},
     /* 124) 0x7c    0 1 1 1 1 1 0 0 */     {1,0xc3},
     /* 125) 0x7d    0 1 1 1 1 1 0 1 */     {1,0xc7},
     /* 126) 0x7e    0 1 1 1 1 1 1 0 */     {1,0xc1},
     /* 127) 0x7f    0 1 1 1 1 1 1 1 */     {1,0xc0},
     /* 128) 0x80    1 0 0 0 0 0 0 0 */     {0,},
     /* 129) 0x81    1 0 0 0 0 0 0 1 */     {0},
     /* 130) 0x82    1 0 0 0 0 0 1 0 */     {0,},
     /* 131) 0x83    1 0 0 0 0 0 1 1 */     {1,0xfe},

     /* 132) 0x84    1 0 0 0 0 1 0 0 */     {0},
     /* 133) 0x85    1 0 0 0 0 1 0 1 */     {0},
     /* 134) 0x86    1 0 0 0 0 1 1 0 */     {1,0xfd},
     /* 135) 0x87    1 0 0 0 0 1 1 1 */     {1,0xfc},
     /* 136) 0x88    1 0 0 0 1 0 0 0 */     {0},
     /* 137) 0x89    1 0 0 0 1 0 0 1 */     {0},
     /* 138) 0x8a    1 0 0 0 1 0 1 0 */     {1,0xfd},
     /* 139) 0x8b    1 0 0 0 1 0 1 1 */     {1,0xfc},
     /* 140) 0x8c    1 0 0 0 1 1 0 0 */     {1,0xfb},
     /* 141) 0x8d    1 0 0 0 1 1 0 1 */     {1,0xf7},
     /* 142) 0x8e    1 0 0 0 1 1 1 0 */     {1,0xf9},
     /* 143) 0x8f    1 0 0 0 1 1 1 1 */     {1,0xf8},
     /* 144) 0x90    1 0 0 1 0 0 0 0 */     {0},
     /* 145) 0x91    1 0 0 1 0 0 0 1 */     {0},
     /* 146) 0x92    1 0 0 1 0 0 1 0 */     {0},
     /* 147) 0x93    1 0 0 1 0 0 1 1 */     {1,0xfe},
     /* 148) 0x94    1 0 0 1 0 1 0 0 */     {0},
     /* 149) 0x95    1 0 0 1 0 1 0 1 */     {0},
     /* 150) 0x96    1 0 0 1 0 1 1 0 */     {1,0xfb},
     /* 151) 0x97    1 0 0 1 0 1 1 1 */     {1,0xfb},
     /* 152) 0x98    1 0 0 1 1 0 0 0 */     {1,0xf7},
     /* 153) 0x99    1 0 0 1 1 0 0 1 */     {1,0xf7},
     /* 154) 0x9a    1 0 0 1 1 0 1 0 */     {1,0xf5},
     /* 155) 0x9b    1 0 0 1 1 0 1 1 */     {1,0xf4},
     /* 156) 0x9c    1 0 0 1 1 1 0 0 */     {1,0xf3},
     /* 157) 0x9d    1 0 0 1 1 1 0 1 */     {1,0xf7},
     /* 158) 0x9e    1 0 0 1 1 1 1 0 */     {1,0xf1},
     /* 159) 0x9f    1 0 0 1 1 1 1 1 */     {1,0xf0},
     /* 160) 0xa0    1 0 1 0 0 0 0 0 */     {0,0xdf},
     /* 161) 0xa1    1 0 1 0 0 0 0 1 */     {1,0xdf},
     /* 162) 0xa2    1 0 1 0 0 0 1 0 */     {1,0xdf},
     /* 163) 0xa3    1 0 1 0 0 0 1 1 */     {1,0xde},
     /* 164) 0xa4    1 0 1 0 0 1 0 0 */     {1,0xdf},
     /* 165) 0xa5    1 0 1 0 0 1 0 1 */     {1,0xdf},
     /* 166) 0xa6    1 0 1 0 0 1 1 0 */     {1,0xdd},
     /* 167) 0xa7    1 0 1 0 0 1 1 1 */     {1,0xdc},
     /* 168) 0xa8    1 0 1 0 1 0 0 0 */     {1,0xd7},
     /* 169) 0xa9    1 0 1 0 1 0 0 1 */     {1,0xd7},
     /* 170) 0xaa    1 0 1 0 1 0 1 0 */     {1,0x55},
     /* 171) 0xab    1 0 1 0 1 0 1 1 */     {1,0x54},
     /* 172) 0xac    1 0 1 0 1 1 0 0 */     {1,0xd3},
     /* 173) 0xad    1 0 1 0 1 1 0 1 */     {1,0xd7},
     /* 174) 0xae    1 0 1 0 1 1 1 0 */     {1,0xd1},
     /* 175) 0xaf    1 0 1 0 1 1 1 1 */     {1,0xd0},
     /* 176) 0xb0    1 0 1 1 0 0 0 0 */     {1,0xcf},
     /* 177) 0xb1    1 0 1 1 0 0 0 1 */     {1,0xcf},
     /* 178) 0xb2    1 0 1 1 0 0 1 0 */     {1,0xcf},
     /* 179) 0xb3    1 0 1 1 0 0 1 1 */     {1,0xce},
     /* 180) 0xb4    1 0 1 1 0 1 0 0 */     {1,0xcf},
     /* 181) 0xb5    1 0 1 1 0 1 0 1 */     {1,0xcf},
     /* 182) 0xb6    1 0 1 1 0 1 1 0 */     {1,0xcd},
     /* 183) 0xb7    1 0 1 1 0 1 1 1 */     {1,0xcc},
     /* 184) 0xb8    1 0 1 1 1 0 0 0 */     {1,0xc7},
     /* 185) 0xb9    1 0 1 1 1 0 0 1 */     {1,0xc7},
     /* 186) 0xba    1 0 1 1 1 0 1 0 */     {1,0xc5},
     /* 187) 0xbb    1 0 1 1 1 0 1 1 */     {1,0xc4},
     /* 188) 0xbc    1 0 1 1 1 1 0 0 */     {1,0xc3},
     /* 189) 0xbd    1 0 1 1 1 1 0 1 */     {2,0xc3},
     /* 190) 0xbe    1 0 1 1 1 1 1 0 */     {1,0xc1},
     /* 191) 0xbf    1 0 1 1 1 1 1 1 */     {1,0xc0},
     /* 192) 0xc0    1 1 0 0 0 0 0 0 */     {1,0xbf},
     /* 193) 0xc1    1 1 0 0 0 0 0 1 */     {1,0xbf},
     /* 194) 0xc2    1 1 0 0 0 0 1 0 */     {1,0xbf},
     /* 195) 0xc3    1 1 0 0 0 0 1 1 */     {1,0xbe},
     /* 196) 0xc4    1 1 0 0 0 1 0 0 */     {1,0xbf},
     /* 197) 0xc5    1 1 0 0 0 1 0 1 */     {1,0xbf},
     /* 198) 0xc6    1 1 0 0 0 1 1 0 */     {1,0xbd},
     /* 199) 0xc7    1 1 0 0 0 1 1 1 */     {1,0xbc},
     /* 200) 0xc8    1 1 0 0 1 0 0 0 */     {1,0xbf},
     /* 201) 0xc9    1 1 0 0 1 0 0 1 */     {1,0xbf},
     /* 202) 0xca    1 1 0 0 1 0 1 0 */     {1,0xbd},
     /* 203) 0xcb    1 1 0 0 1 0 1 1 */     {1,0xbc},
     /* 204) 0xcc    1 1 0 0 1 1 0 0 */     {1,0xbb},
     /* 205) 0xcd    1 1 0 0 1 1 0 1 */     {1,0xbb},
     /* 206) 0xce    1 1 0 0 1 1 1 0 */     {1,0xb9},
     /* 207) 0xcf    1 1 0 0 1 1 1 1 */     {1,0xb8},
     /* 208) 0xd0    1 1 0 1 0 0 0 0 */     {1,0xbf},
     /* 209) 0xd1    1 1 0 1 0 0 0 1 */     {1,0xbf},
     /* 210) 0xd2    1 1 0 1 0 0 1 0 */     {1,0xbf},
     /* 211) 0xd3    1 1 0 1 0 0 1 1 */     {1,0xbe},
     /* 212) 0xd4    1 1 0 1 0 1 0 0 */     {1,0xbf},
     /* 213) 0xd5    1 1 0 1 0 1 0 1 */     {1,0xbf},
     /* 214) 0xd6    1 1 0 1 0 1 1 0 */     {1,0xbd},
     /* 215) 0xd7    1 1 0 1 0 1 1 1 */     {1,0xbc},
     /* 216) 0xd8    1 1 0 1 1 0 0 0 */     {1,0xb7},
     /* 217) 0xd9    1 1 0 1 1 0 0 1 */     {1,0xb7},
     /* 218) 0xda    1 1 0 1 1 0 1 0 */     {1,0xb5},
     /* 219) 0xdb    1 1 0 1 1 0 1 1 */     {1,0xb4},
     /* 220) 0xdc    1 1 0 1 1 1 0 0 */     {1,0xb3},
     /* 221) 0xdd    1 1 0 1 1 1 0 1 */     {1,0xb3},
     /* 222) 0xde    1 1 0 1 1 1 1 0 */     {1,0xb1},
     /* 223) 0xdf    1 1 0 1 1 1 1 1 */     {1,0xb0},
     /* 224) 0xe0    1 1 1 0 0 0 0 0 */     {1,0x9f},
     /* 225) 0xe1    1 1 1 0 0 0 0 1 */     {1,0x9f},
     /* 226) 0xe2    1 1 1 0 0 0 1 0 */     {1,0x9f},
     /* 227) 0xe3    1 1 1 0 0 0 1 1 */     {1,0x9e},
     /* 228) 0xe4    1 1 1 0 0 1 0 0 */     {1,0x9f},
     /* 229) 0xe5    1 1 1 0 0 1 0 1 */     {1,0x9f},
     /* 230) 0xe6    1 1 1 0 0 1 1 0 */     {1,0x9d},
     /* 231) 0xe7    1 1 1 0 0 1 1 1 */     {1,0x9c},
     /* 232) 0xe8    1 1 1 0 1 0 0 0 */     {1,0x97},
     /* 233) 0xe9    1 1 1 0 1 0 0 1 */     {1,0x97},
     /* 234) 0xea    1 1 1 0 1 0 1 0 */     {1,0x95},
     /* 235) 0xeb    1 1 1 0 1 0 1 1 */     {1,0x94},
     /* 236) 0xec    1 1 1 0 1 1 0 0 */     {1,0x93},
     /* 237) 0xed    1 1 1 0 1 1 0 1 */     {1,0x93},
     /* 238) 0xee    1 1 1 0 1 1 1 0 */     {1,0x91},
     /* 239) 0xef    1 1 1 0 1 1 1 1 */     {1,0x90},
     /* 240) 0xf0    1 1 1 1 0 0 0 0 */     {1,0x8f},
     /* 241) 0xf1    1 1 1 1 0 0 0 1 */     {1,0x8f},
     /* 242) 0xf2    1 1 1 1 0 0 1 0 */     {1,0x8f},
     /* 243) 0xf3    1 1 1 1 0 0 1 1 */     {1,0x8e},
     /* 244) 0xf4    1 1 1 1 0 1 0 0 */     {1,0x8f},
     /* 245) 0xf5    1 1 1 1 0 1 0 1 */     {1,0x8f},
     /* 246) 0xf6    1 1 1 1 0 1 1 0 */     {1,0x8d},
     /* 247) 0xf7    1 1 1 1 0 1 1 1 */     {1,0x8c},
     /* 248) 0xf8    1 1 1 1 1 0 0 0 */     {1,0x87},
     /* 249) 0xf9    1 1 1 1 1 0 0 1 */     {1,0x87},
     /* 250) 0xfa    1 1 1 1 1 0 1 0 */     {1,0x85},
     /* 251) 0xfb    1 1 1 1 1 0 1 1 */     {1,0x84},
     /* 252) 0xfc    1 1 1 1 1 1 0 0 */     {1,0x83},
     /* 253) 0xfd    1 1 1 1 1 1 0 1 */     {1,0x83},
     /* 254) 0xfe    1 1 1 1 1 1 1 0 */     {1,0x81},
     /* 255) 0xff    1 1 1 1 1 1 1 1*/     {1, 0}
   };

unsigned char _0Edge[][9] = {
      /* 0) 0    0 0 0 0 0 0 0 0 */     {8, 0,1,2,3,4,5,6,7},
      /* 1) 1    0 0 0 0 0 0 0 1 */     {7,   1,2,3,4,5,6,7},
      /* 2) 2    0 0 0 0 0 0 1 0 */     {7, 0,  2,3,4,5,6,7},
      /* 3) 3    0 0 0 0 0 0 1 1 */     {6,     2,3,4,5,6,7},
      /* 4) 4    0 0 0 0 0 1 0 0 */     {7, 0,1,  3,4,5,6,7},
      /* 5) 5    0 0 0 0 0 1 0 1 */     {6,   1,  3,4,5,6,7},
      /* 6) 6    0 0 0 0 0 1 1 0 */     {6, 0,    3,4,5,6,7},
      /* 7) 7    0 0 0 0 0 1 1 1 */     {5,       3,4,5,6,7},
      /* 8) 8    0 0 0 0 1 0 0 0 */     {7, 0,1,2,  4,5,6,7},
      /* 9) 9    0 0 0 0 1 0 0 1 */     {6,   1,2,  4,5,6,7},
      /* 10) a    0 0 0 0 1 0 1 0 */     {6, 0,  2,  4,5,6,7},
      /* 11) b    0 0 0 0 1 0 1 1 */     {5,     2,  4,5,6,7},
      /* 12) c    0 0 0 0 1 1 0 0 */     {6, 0,1,    4,5,6,7},
      /* 13) d    0 0 0 0 1 1 0 1 */     {5,   1,    4,5,6,7},
      /* 14) e    0 0 0 0 1 1 1 0 */     {5, 0,      4,5,6,7},
      /* 15) f    0 0 0 0 1 1 1 1 */     {4,         4,5,6,7},
      /* 16) 10    0 0 0 1 0 0 0 0 */     {7, 0,1,2,3,  5,6,7},
      /* 17) 11    0 0 0 1 0 0 0 1 */     {6,   1,2,3,  5,6,7},
      /* 18) 12    0 0 0 1 0 0 1 0 */     {6, 0,  2,3,  5,6,7},
      /* 19) 13    0 0 0 1 0 0 1 1 */     {5,     2,3,  5,6,7},
      /* 20) 14    0 0 0 1 0 1 0 0 */     {6, 0,1,  3,  5,6,7},
      /* 21) 15    0 0 0 1 0 1 0 1 */     {5,   1,  3,  5,6,7},
      /* 22) 16    0 0 0 1 0 1 1 0 */     {5, 0,    3,  5,6,7},
      /* 23) 17    0 0 0 1 0 1 1 1 */     {4,       3,  5,6,7},
      /* 24) 18    0 0 0 1 1 0 0 0 */     {6, 0,1,2,    5,6,7},
      /* 25) 19    0 0 0 1 1 0 0 1 */     {5,   1,2,    5,6,7},
      /* 26) 1a    0 0 0 1 1 0 1 0 */     {5, 0,  2,    5,6,7},
      /* 27) 1b    0 0 0 1 1 0 1 1 */     {4,     2,    5,6,7},
      /* 28) 1c    0 0 0 1 1 1 0 0 */     {5, 0,1,      5,6,7},
      /* 29) 1d    0 0 0 1 1 1 0 1 */     {4,   1,      5,6,7},
      /* 30) 1e    0 0 0 1 1 1 1 0 */     {4, 0,        5,6,7},
      /* 31) 1f    0 0 0 1 1 1 1 1 */     {3,           5,6,7},
      /* 32) 20    0 0 1 0 0 0 0 0 */     {7, 0,1,2,3,4,  6,7},
      /* 33) 21    0 0 1 0 0 0 0 1 */     {6,   1,2,3,4,  6,7},
      /* 34) 22    0 0 1 0 0 0 1 0 */     {6, 0,  2,3,4,  6,7},
      /* 35) 23    0 0 1 0 0 0 1 1 */     {5,     2,3,4,  6,7},
      /* 36) 24    0 0 1 0 0 1 0 0 */     {6, 0,1,  3,4,  6,7},
      /* 37) 25    0 0 1 0 0 1 0 1 */     {5,   1,  3,4,  6,7},
      /* 38) 26    0 0 1 0 0 1 1 0 */     {5, 0,    3,4,  6,7},
      /* 39) 27    0 0 1 0 0 1 1 1 */     {4,       3,4,  6,7},
      /* 40) 28    0 0 1 0 1 0 0 0 */     {6, 0,1,2,  4,  6,7},
      /* 41) 29    0 0 1 0 1 0 0 1 */     {5,   1,2,  4,  6,7},
      /* 42) 2a    0 0 1 0 1 0 1 0 */     {5, 0,  2,  4,  6,7},
      /* 43) 2b    0 0 1 0 1 0 1 1 */     {4,     2,  4,  6,7},
      /* 44) 2c    0 0 1 0 1 1 0 0 */     {5, 0,1,    4,  6,7},
      /* 45) 2d    0 0 1 0 1 1 0 1 */     {4,   1,    4,  6,7},
      /* 46) 2e    0 0 1 0 1 1 1 0 */     {4, 0,      4,  6,7},
      /* 47) 2f    0 0 1 0 1 1 1 1 */     {3,         4,  6,7},
      /* 48) 30    0 0 1 1 0 0 0 0 */     {6, 0,1,2,3,    6,7},
      /* 49) 31    0 0 1 1 0 0 0 1 */     {5,   1,2,3,    6,7},
      /* 50) 32    0 0 1 1 0 0 1 0 */     {5, 0,  2,3,    6,7},
      /* 51) 33    0 0 1 1 0 0 1 1 */     {4,     2,3,    6,7},
      /* 52) 34    0 0 1 1 0 1 0 0 */     {5, 0,1,  3,    6,7},
      /* 53) 35    0 0 1 1 0 1 0 1 */     {4,   1,  3,    6,7},
      /* 54) 36    0 0 1 1 0 1 1 0 */     {4, 0,    3,    6,7},
      /* 55) 37    0 0 1 1 0 1 1 1 */     {3,       3,    6,7},
      /* 56) 38    0 0 1 1 1 0 0 0 */     {5, 0,1,2,      6,7},
      /* 57) 39    0 0 1 1 1 0 0 1 */     {4,   1,2,      6,7},
      /* 58) 3a    0 0 1 1 1 0 1 0 */     {4, 0,  2,      6,7},
      /* 59) 3b    0 0 1 1 1 0 1 1 */     {3,     2,      6,7},
      /* 60) 3c    0 0 1 1 1 1 0 0 */     {4, 0,1,        6,7},
      /* 61) 3d    0 0 1 1 1 1 0 1 */     {3,   1,        6,7},
      /* 62) 3e    0 0 1 1 1 1 1 0 */     {3, 0,          6,7},
      /* 63) 3f    0 0 1 1 1 1 1 1 */     {2,             6,7},
      /* 64) 40    0 1 0 0 0 0 0 0 */     {7, 0,1,2,3,4,5,  7},
      /* 65) 41    0 1 0 0 0 0 0 1 */     {6,   1,2,3,4,5,  7},
      /* 66) 42    0 1 0 0 0 0 1 0 */     {6, 0,  2,3,4,5,  7},
      /* 67) 43    0 1 0 0 0 0 1 1 */     {5,     2,3,4,5,  7},
      /* 68) 44    0 1 0 0 0 1 0 0 */     {6, 0,1,  3,4,5,  7},
      /* 69) 45    0 1 0 0 0 1 0 1 */     {5,   1,  3,4,5,  7},
      /* 70) 46    0 1 0 0 0 1 1 0 */     {5, 0,    3,4,5,  7},
      /* 71) 47    0 1 0 0 0 1 1 1 */     {4,       3,4,5,  7},
      /* 72) 48    0 1 0 0 1 0 0 0 */     {6, 0,1,2,  4,5,  7},
      /* 73) 49    0 1 0 0 1 0 0 1 */     {5,   1,2,  4,5,  7},
      /* 74) 4a    0 1 0 0 1 0 1 0 */     {5, 0,  2,  4,5,  7},
      /* 75) 4b    0 1 0 0 1 0 1 1 */     {4,     2,  4,5,  7},
      /* 76) 4c    0 1 0 0 1 1 0 0 */     {5, 0,1,    4,5,  7},
      /* 77) 4d    0 1 0 0 1 1 0 1 */     {4,   1,    4,5,  7},
      /* 78) 4e    0 1 0 0 1 1 1 0 */     {4, 0,      4,5,  7},
      /* 79) 4f    0 1 0 0 1 1 1 1 */     {3,         4,5,  7},
      /* 80) 50    0 1 0 1 0 0 0 0 */     {6, 0,1,2,3,  5,  7},
      /* 81) 51    0 1 0 1 0 0 0 1 */     {5,   1,2,3,  5,  7},
      /* 82) 52    0 1 0 1 0 0 1 0 */     {5, 0,  2,3,  5,  7},
      /* 83) 53    0 1 0 1 0 0 1 1 */     {4,     2,3,  5,  7},
      /* 84) 54    0 1 0 1 0 1 0 0 */     {5, 0,1,  3,  5,  7},
      /* 85) 55    0 1 0 1 0 1 0 1 */     {4,   1,  3,  5,  7},
      /* 86) 56    0 1 0 1 0 1 1 0 */     {4, 0,    3,  5,  7},
      /* 87) 57    0 1 0 1 0 1 1 1 */     {3,       3,  5,  7},
      /* 88) 58    0 1 0 1 1 0 0 0 */     {5, 0,1,2,    5,  7},
      /* 89) 59    0 1 0 1 1 0 0 1 */     {4,   1,2,    5,  7},
      /* 90) 5a    0 1 0 1 1 0 1 0 */     {4, 0,  2,    5,  7},
      /* 91) 5b    0 1 0 1 1 0 1 1 */     {3,     2,    5,  7},
      /* 92) 5c    0 1 0 1 1 1 0 0 */     {4, 0,1,      5,  7},
      /* 93) 5d    0 1 0 1 1 1 0 1 */     {3,   1,      5,  7},
      /* 94) 5e    0 1 0 1 1 1 1 0 */     {3, 0,        5,  7},
      /* 95) 5f    0 1 0 1 1 1 1 1 */     {2,           5,  7},
      /* 96) 60    0 1 1 0 0 0 0 0 */     {6, 0,1,2,3,4,    7},
      /* 97) 61    0 1 1 0 0 0 0 1 */     {5,   1,2,3,4,    7},
      /* 98) 62    0 1 1 0 0 0 1 0 */     {5, 0,  2,3,4,    7},
      /* 99) 63    0 1 1 0 0 0 1 1 */     {4,     2,3,4,    7},
      /* 100) 64    0 1 1 0 0 1 0 0 */     {5, 0,1,  3,4,    7},
      /* 101) 65    0 1 1 0 0 1 0 1 */     {4,   1,  3,4,    7},
      /* 102) 66    0 1 1 0 0 1 1 0 */     {4, 0,    3,4,    7},
      /* 103) 67    0 1 1 0 0 1 1 1 */     {3,       3,4,    7},
      /* 104) 68    0 1 1 0 1 0 0 0 */     {5, 0,1,2,  4,    7},
      /* 105) 69    0 1 1 0 1 0 0 1 */     {4,   1,2,  4,    7},
      /* 106) 6a    0 1 1 0 1 0 1 0 */     {4, 0,  2,  4,    7},
      /* 107) 6b    0 1 1 0 1 0 1 1 */     {3,     2,  4,    7},
      /* 108) 6c    0 1 1 0 1 1 0 0 */     {4, 0,1,    4,    7},
      /* 109) 6d    0 1 1 0 1 1 0 1 */     {3,   1,    4,    7},
      /* 110) 6e    0 1 1 0 1 1 1 0 */     {3, 0,      4,    7},
      /* 111) 6f    0 1 1 0 1 1 1 1 */     {2,         4,    7},
      /* 112) 70    0 1 1 1 0 0 0 0 */     {5, 0,1,2,3,      7},
      /* 113) 71    0 1 1 1 0 0 0 1 */     {4,   1,2,3,      7},
      /* 114) 72    0 1 1 1 0 0 1 0 */     {4, 0,  2,3,      7},
      /* 115) 73    0 1 1 1 0 0 1 1 */     {3,     2,3,      7},
      /* 116) 74    0 1 1 1 0 1 0 0 */     {4, 0,1,  3,      7},
      /* 117) 75    0 1 1 1 0 1 0 1 */     {3,   1,  3,      7},
      /* 118) 76    0 1 1 1 0 1 1 0 */     {3, 0,    3,      7},
      /* 119) 77    0 1 1 1 0 1 1 1 */     {2,       3,      7},
      /* 120) 78    0 1 1 1 1 0 0 0 */     {4, 0,1,2,        7},
      /* 121) 79    0 1 1 1 1 0 0 1 */     {3,   1,2,        7},
      /* 122) 7a    0 1 1 1 1 0 1 0 */     {3, 0,  2,        7},
      /* 123) 7b    0 1 1 1 1 0 1 1 */     {2,     2,        7},
      /* 124) 7c    0 1 1 1 1 1 0 0 */     {3, 0,1,          7},
      /* 125) 7d    0 1 1 1 1 1 0 1 */     {2,   1,          7},
      /* 126) 7e    0 1 1 1 1 1 1 0 */     {2, 0,            7},
      /* 127) 7f    0 1 1 1 1 1 1 1 */     {1,               7},
      /* 128) 80    1 0 0 0 0 0 0 0 */     {7, 0,1,2,3,4,5,6  },
      /* 129) 81    1 0 0 0 0 0 0 1 */     {6,   1,2,3,4,5,6  },
      /* 130) 82    1 0 0 0 0 0 1 0 */     {6, 0,  2,3,4,5,6  },
      /* 131) 83    1 0 0 0 0 0 1 1 */     {5,     2,3,4,5,6  },
      /* 132) 84    1 0 0 0 0 1 0 0 */     {6, 0,1,  3,4,5,6  },
      /* 133) 85    1 0 0 0 0 1 0 1 */     {5,   1,  3,4,5,6  },
      /* 134) 86    1 0 0 0 0 1 1 0 */     {5, 0,    3,4,5,6  },
      /* 135) 87    1 0 0 0 0 1 1 1 */     {4,       3,4,5,6  },
      /* 136) 88    1 0 0 0 1 0 0 0 */     {6, 0,1,2,  4,5,6  },
      /* 137) 89    1 0 0 0 1 0 0 1 */     {5,   1,2,  4,5,6  },
      /* 138) 8a    1 0 0 0 1 0 1 0 */     {5, 0,  2,  4,5,6  },
      /* 139) 8b    1 0 0 0 1 0 1 1 */     {4,     2,  4,5,6  },
      /* 140) 8c    1 0 0 0 1 1 0 0 */     {5, 0,1,    4,5,6  },
      /* 141) 8d    1 0 0 0 1 1 0 1 */     {4,   1,    4,5,6  },
      /* 142) 8e    1 0 0 0 1 1 1 0 */     {4, 0,      4,5,6  },
      /* 143) 8f    1 0 0 0 1 1 1 1 */     {3,         4,5,6  },
      /* 144) 90    1 0 0 1 0 0 0 0 */     {6, 0,1,2,3,  5,6  },
      /* 145) 91    1 0 0 1 0 0 0 1 */     {5,   1,2,3,  5,6  },
      /* 146) 92    1 0 0 1 0 0 1 0 */     {5, 0,  2,3,  5,6  },
      /* 147) 93    1 0 0 1 0 0 1 1 */     {4,     2,3,  5,6  },
      /* 148) 94    1 0 0 1 0 1 0 0 */     {5, 0,1,  3,  5,6  },
      /* 149) 95    1 0 0 1 0 1 0 1 */     {4,   1,  3,  5,6  },
      /* 150) 96    1 0 0 1 0 1 1 0 */     {4, 0,    3,  5,6  },
      /* 151) 97    1 0 0 1 0 1 1 1 */     {3,       3,  5,6  },
      /* 152) 98    1 0 0 1 1 0 0 0 */     {5, 0,1,2,    5,6  },
      /* 153) 99    1 0 0 1 1 0 0 1 */     {4,   1,2,    5,6  },
      /* 154) 9a    1 0 0 1 1 0 1 0 */     {4, 0,  2,    5,6  },
      /* 155) 9b    1 0 0 1 1 0 1 1 */     {3,     2,    5,6  },
      /* 156) 9c    1 0 0 1 1 1 0 0 */     {4, 0,1,      5,6  },
      /* 157) 9d    1 0 0 1 1 1 0 1 */     {3,   1,      5,6  },
      /* 158) 9e    1 0 0 1 1 1 1 0 */     {3, 0,        5,6  },
      /* 159) 9f    1 0 0 1 1 1 1 1 */     {2,           5,6  },
      /* 160) a0    1 0 1 0 0 0 0 0 */     {6, 0,1,2,3,4,  6  },
      /* 161) a1    1 0 1 0 0 0 0 1 */     {5,   1,2,3,4,  6  },
      /* 162) a2    1 0 1 0 0 0 1 0 */     {5, 0,  2,3,4,  6  },
      /* 163) a3    1 0 1 0 0 0 1 1 */     {4,     2,3,4,  6  },
      /* 164) a4    1 0 1 0 0 1 0 0 */     {5, 0,1,  3,4,  6  },
      /* 165) a5    1 0 1 0 0 1 0 1 */     {4,   1,  3,4,  6  },
      /* 166) a6    1 0 1 0 0 1 1 0 */     {4, 0,    3,4,  6  },
      /* 167) a7    1 0 1 0 0 1 1 1 */     {3,       3,4,  6  },
      /* 168) a8    1 0 1 0 1 0 0 0 */     {5, 0,1,2,  4,  6  },
      /* 169) a9    1 0 1 0 1 0 0 1 */     {4,   1,2,  4,  6  },
      /* 170) aa    1 0 1 0 1 0 1 0 */     {4, 0,  2,  4,  6  },
      /* 171) ab    1 0 1 0 1 0 1 1 */     {3,     2,  4,  6  },
      /* 172) ac    1 0 1 0 1 1 0 0 */     {4, 0,1,    4,  6  },
      /* 173) ad    1 0 1 0 1 1 0 1 */     {3,   1,    4,  6  },
      /* 174) ae    1 0 1 0 1 1 1 0 */     {3, 0,      4,  6  },
      /* 175) af    1 0 1 0 1 1 1 1 */     {2,         4,  6  },
      /* 176) b0    1 0 1 1 0 0 0 0 */     {5, 0,1,2,3,    6  },
      /* 177) b1    1 0 1 1 0 0 0 1 */     {4,   1,2,3,    6  },
      /* 178) b2    1 0 1 1 0 0 1 0 */     {4, 0,  2,3,    6  },
      /* 179) b3    1 0 1 1 0 0 1 1 */     {3,     2,3,    6  },
      /* 180) b4    1 0 1 1 0 1 0 0 */     {4, 0,1,  3,    6  },
      /* 181) b5    1 0 1 1 0 1 0 1 */     {3,   1,  3,    6  },
      /* 182) b6    1 0 1 1 0 1 1 0 */     {3, 0,    3,    6  },
      /* 183) b7    1 0 1 1 0 1 1 1 */     {2,       3,    6  },
      /* 184) b8    1 0 1 1 1 0 0 0 */     {4, 0,1,2,      6  },
      /* 185) b9    1 0 1 1 1 0 0 1 */     {3,   1,2,      6  },
      /* 186) ba    1 0 1 1 1 0 1 0 */     {3, 0,  2,      6  },
      /* 187) bb    1 0 1 1 1 0 1 1 */     {2,     2,      6  },
      /* 188) bc    1 0 1 1 1 1 0 0 */     {3, 0,1,        6  },
      /* 189) bd    1 0 1 1 1 1 0 1 */     {2,   1,        6  },
      /* 190) be    1 0 1 1 1 1 1 0 */     {2, 0,          6  },
      /* 191) bf    1 0 1 1 1 1 1 1 */     {1,             6  },
      /* 192) c0    1 1 0 0 0 0 0 0 */     {6, 0,1,2,3,4,5    },
      /* 193) c1    1 1 0 0 0 0 0 1 */     {5,   1,2,3,4,5    },
      /* 194) c2    1 1 0 0 0 0 1 0 */     {5, 0,  2,3,4,5    },
      /* 195) c3    1 1 0 0 0 0 1 1 */     {4,     2,3,4,5    },
      /* 196) c4    1 1 0 0 0 1 0 0 */     {5, 0,1,  3,4,5    },
      /* 197) c5    1 1 0 0 0 1 0 1 */     {4,   1,  3,4,5    },
      /* 198) c6    1 1 0 0 0 1 1 0 */     {4, 0,    3,4,5    },
      /* 199) c7    1 1 0 0 0 1 1 1 */     {3,       3,4,5    },
      /* 200) c8    1 1 0 0 1 0 0 0 */     {5, 0,1,2,  4,5    },
      /* 201) c9    1 1 0 0 1 0 0 1 */     {4,   1,2,  4,5    },
      /* 202) ca    1 1 0 0 1 0 1 0 */     {4, 0,  2,  4,5    },
      /* 203) cb    1 1 0 0 1 0 1 1 */     {3,     2,  4,5    },
      /* 204) cc    1 1 0 0 1 1 0 0 */     {4, 0,1,    4,5    },
      /* 205) cd    1 1 0 0 1 1 0 1 */     {3,   1,    4,5    },
      /* 206) ce    1 1 0 0 1 1 1 0 */     {3, 0,      4,5    },
      /* 207) cf    1 1 0 0 1 1 1 1 */     {2,         4,5    },
      /* 208) d0    1 1 0 1 0 0 0 0 */     {5, 0,1,2,3,  5    },
      /* 209) d1    1 1 0 1 0 0 0 1 */     {4,   1,2,3,  5    },
      /* 210) d2    1 1 0 1 0 0 1 0 */     {4, 0,  2,3,  5    },
      /* 211) d3    1 1 0 1 0 0 1 1 */     {3,     2,3,  5    },
      /* 212) d4    1 1 0 1 0 1 0 0 */     {4, 0,1,  3,  5    },
      /* 213) d5    1 1 0 1 0 1 0 1 */     {3,   1,  3,  5    },
      /* 214) d6    1 1 0 1 0 1 1 0 */     {3, 0,    3,  5    },
      /* 215) d7    1 1 0 1 0 1 1 1 */     {2,       3,  5    },
      /* 216) d8    1 1 0 1 1 0 0 0 */     {4, 0,1,2,    5    },
      /* 217) d9    1 1 0 1 1 0 0 1 */     {3,   1,2,    5    },
      /* 218) da    1 1 0 1 1 0 1 0 */     {3, 0,  2,    5    },
      /* 219) db    1 1 0 1 1 0 1 1 */     {2,     2,    5    },
      /* 220) dc    1 1 0 1 1 1 0 0 */     {3, 0,1,      5    },
      /* 221) dd    1 1 0 1 1 1 0 1 */     {2,   1,      5    },
      /* 222) de    1 1 0 1 1 1 1 0 */     {2, 0,        5    },
      /* 223) df    1 1 0 1 1 1 1 1 */     {1,           5    },
      /* 224) e0    1 1 1 0 0 0 0 0 */     {5, 0,1,2,3,4      },
      /* 225) e1    1 1 1 0 0 0 0 1 */     {4,   1,2,3,4      },
      /* 226) e2    1 1 1 0 0 0 1 0 */     {4, 0,  2,3,4      },
      /* 227) e3    1 1 1 0 0 0 1 1 */     {3,     2,3,4      },
      /* 228) e4    1 1 1 0 0 1 0 0 */     {4, 0,1,  3,4      },
      /* 229) e5    1 1 1 0 0 1 0 1 */     {3,   1,  3,4      },
      /* 230) e6    1 1 1 0 0 1 1 0 */     {3, 0,    3,4      },
      /* 231) e7    1 1 1 0 0 1 1 1 */     {2,       3,4      },
      /* 232) e8    1 1 1 0 1 0 0 0 */     {4, 0,1,2,  4      },
      /* 233) e9    1 1 1 0 1 0 0 1 */     {3,   1,2,  4      },
      /* 234) ea    1 1 1 0 1 0 1 0 */     {3, 0,  2,  4      },
      /* 235) eb    1 1 1 0 1 0 1 1 */     {2,     2,  4      },
      /* 236) ec    1 1 1 0 1 1 0 0 */     {3, 0,1,    4      },
      /* 237) ed    1 1 1 0 1 1 0 1 */     {2,   1,    4      },
      /* 238) ee    1 1 1 0 1 1 1 0 */     {2, 0,      4      },
      /* 239) ef    1 1 1 0 1 1 1 1 */     {1,         4      },
      /* 240) f0    1 1 1 1 0 0 0 0 */     {4, 0,1,2,3        },
      /* 241) f1    1 1 1 1 0 0 0 1 */     {3,   1,2,3        },
      /* 242) f2    1 1 1 1 0 0 1 0 */     {3, 0,  2,3        },
      /* 243) f3    1 1 1 1 0 0 1 1 */     {2,     2,3        },
      /* 244) f4    1 1 1 1 0 1 0 0 */     {3, 0,1,  3        },
      /* 245) f5    1 1 1 1 0 1 0 1 */     {2,   1,  3        },
      /* 246) f6    1 1 1 1 0 1 1 0 */     {2, 0,    3        },
      /* 247) f7    1 1 1 1 0 1 1 1 */     {1,       3        },
      /* 248) f8    1 1 1 1 1 0 0 0 */     {3, 0,1,2          },
      /* 249) f9    1 1 1 1 1 0 0 1 */     {2,   1,2          },
      /* 250) fa    1 1 1 1 1 0 1 0 */     {2, 0,  2          },
      /* 251) fb    1 1 1 1 1 0 1 1 */     {1,     2          },
      /* 252) fc    1 1 1 1 1 1 0 0 */     {2, 0,1            },
      /* 253) fd    1 1 1 1 1 1 0 1 */     {1,   1            },
      /* 254) fe    1 1 1 1 1 1 1 0 */     {1, 0              },
      /* 255) ff    1 1 1 1 1 1 1 1 */     {0,                }
    };

   
