/****************************************************************************
fftmain.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  fft.c and fft_main.c were quite similar but not identical before
I started revising fft.c.  It appears that they might be two different
versions of the same file, but there isn't any indication which is the
valid version.  -PWH 19990310
****************************************************************************/

static const char rcsid[] = "$Id: fft_main.c,v 1.5 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>
#include <math.h>

#include "typedef.h"
#include "fft.h"
#include "error_constants.h"
#include "common.h"
#include "nria_lib.h"


/*
cc -o fft_main fft_main.c  $lib/math_opr.o  $lib/str.o $lib/ptr_and_dim.o \
    $lib/2d_buf_opr.o  $lib/2d_buf_extra_opr.o \
    $lib/rd_wr_buf_2d_rec.o -lm
cc -c fft_main.c
csh lfft_main.com
*/
/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)
/*
multiply_ft_by_val(ary,num_elems,val)
divide_ft_by_val(ary,num_elems,val)
multiply_complex(dest,src1,src2)
shift_fft_to_center(ary,num_elems)
shift_fft_back_to_origin(ary,num_elems)
perform_fft(ary,num_elems,num_bits)
magnitude_ft(ary,num_elems)
conjugate_1d_ft(ary,num_elems)
inverse_fft(ary,num_elems,num_bits)
setup_fft_2d(fft_2d,_2d)
shift_fft_2d_to_center(fft)
get_fft_2d_col(fft_col,fft_2d,col)
save_fft_2d_col(fft_col,fft_2d,col)
fft_2d(fft)
conjugate_fft_2d(fft)
inverse_fft_2d(fft)
magnitude_fft_2d_to_float_2d(_2d,fft)
assign_fft_2d_to_int_2d(_2d,fft)
assign_float_2d_to_int_2d(_2d,fl_2d)
assign_magnitude_fft_2d_to_int_2d(_2d,fft)
pr_complex_rec(ary,num_elems)
pr_fft_2d(fft)

precondition_ideal_filter_fft_2d(fft,cut_off_freq,is_lowpass)
ideal_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius)
butterworth_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,order)
exponential_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,order)
trapezoidal_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,lb_cut_off_freq)
filter_fft_2d(fft,cut_off_freq,is_lowpass,precond_proc,filter_proc,arg)
*/
unsigned long num_bit_values();

rd_2d(fn,_2d)
 char *fn;
 struct buf_2d_rec *_2d;
{
 FILE *fid;
 int err;

 if ((fid = fopen(fn,"r")) == NULL) 
    {printf("rd_2d...read err = %d...\n",err);
     return FILE_ACCESS_ERROR;}
 err = rd_buf_2d_rec(fid,_2d);
 printf("rd_2d...\n");
 fclose(fid);
 return err;

}

wr_2d(fn,_2d)
 char *fn;
 struct buf_2d_rec *_2d;
{
 FILE *fid;
 int err;
 struct buf_2d_rec _2d1;
 long row,col;

 if ((fid = fopen(fn,"w")) == NULL) 
    {printf("wr_2d...write err = %d...\n",err);
     return FILE_ACCESS_ERROR;}

 err = wr_buf_2d_rec(fid,_2d);
 printf("wr_2d...\n");
 fclose(fid);
 return err;

}

reverse_bit_order(ary,num_elems,num_bits)
 struct complex_rec *ary;
 unsigned long num_elems,num_bits;
{
 long half_max,last;
 long cnt,lcv,next,loop,val;
 struct complex_rec temp;

 half_max = num_elems / 2;
 last = num_elems - 1;
 for (lcv = 1; lcv < half_max; lcv++)
    {val = 0;
     for (next = lcv,cnt = 0; cnt < num_bits; cnt++)
        {val <<= 1;
         if (next & 1) val |= 1;
         next >>= 1;
         if (next == 0) break;
        }
     val <<= (num_bits - cnt - 1);
     temp = ary[lcv];
     ary[lcv] = ary[val];
     ary[val] = temp;
    }
}


multiply_ft_by_val(ary,num_elems,val)
 struct complex_rec *ary;
 unsigned long num_elems;
 float val;
{
 unsigned long lcv;

 for (lcv = 0; lcv < num_elems; lcv++)
    {ary[lcv].r *= val;
     ary[lcv].i *= val;}
}

divide_ft_by_val(ary,num_elems,val)
 struct complex_rec *ary;
 unsigned long num_elems;
 float val;
{
 unsigned long lcv;

 for (lcv = 0; lcv < num_elems; lcv++)
    {ary[lcv].r /= val;
     ary[lcv].i /= val;}
}

multiply_complex(dest,src1,src2)
 struct complex_rec *dest,*src1,*src2;
{
 float temp;

 temp = src1->r * src2->r - src1->i * src2->i;
 dest->i = src1->r * src2->i + src1->i * src2->r;
 dest->r = temp;
}

shift_fft_to_center(ary,num_elems)
 struct complex_rec *ary;
 unsigned long num_elems;
{
 long lcv;

 for (lcv = 1; lcv < num_elems; lcv += 2)
    {ary[lcv].r = -ary[lcv].r;
     ary[lcv].i = -ary[lcv].i;}

}

shift_fft_back_to_origin(ary,num_elems)
 struct complex_rec *ary;
 unsigned long num_elems;
{
 long lcv;

 for (lcv = 0; lcv < num_elems; lcv += 2)
    {ary[lcv].r = -ary[lcv].r;
     ary[lcv].i = -ary[lcv].i;}

}

perform_fft(ary,num_elems,num_bits)
 struct complex_rec *ary;
 unsigned long num_elems,num_bits;
{
 static float pi = 3.141593;
 long next_max,next_half_max,half_max,last,temp_next,temp_lcv;
 long cnt,lcv,next,loop,val;
 struct complex_rec temp,temp1,temp2;
 float max_fl;

 printf("perform_fft num_elems = %d   num_bits = %d\n",num_elems,num_bits);
 half_max = num_elems / 2;
 last = num_elems - 1;
 next = 1;
 for (lcv = 1; lcv <= last; lcv++)
    {if (lcv < next)
        {
         temp_next = next - 1;
         temp_lcv = lcv - 1;
         temp = ary[temp_lcv];
         ary[temp_lcv] = ary[temp_next];
         ary[temp_next] = temp;
        }
     
     for (cnt = half_max; cnt < next;)
        {
         next -= cnt;
         cnt /= 2;}
     next += cnt;
    }
 
 for (loop = 0; loop < num_bits; loop++)
    {next_max = num_bit_values(loop + 1);
     next_half_max = next_max / 2;
     temp1.r = 1.0;
     temp1.i = .0;
     temp2.r = (float) cos((double) (pi / (float) next_half_max));
     temp2.i = (float) -sin((double) (pi / (float) next_half_max));
     for (next = 0; next < next_half_max; next++)
        {
         for (lcv = next; lcv < num_elems; lcv += next_max)
            {cnt = lcv + next_half_max;
             multiply_complex(&temp,&(ary[cnt]),&temp1);
             ary[cnt].r =  ary[lcv].r - temp.r;
             ary[cnt].i =  ary[lcv].i - temp.i;

             ary[lcv].r =  ary[lcv].r + temp.r;
             ary[lcv].i =  ary[lcv].i + temp.i;
            }
         multiply_complex(&temp1,&temp1,&temp2);
        }
    }
 divide_ft_by_val(ary,num_elems,(float) num_elems);

}

magnitude_fft(ary,num_elems)
 struct complex_rec *ary;
 unsigned long num_elems;
{
 unsigned long lcv;
 
 for (lcv = 0; lcv < num_elems; lcv++)
    ary[lcv].r = (float) sqrt((double) ((ary[lcv].r * ary[lcv].r) +
                                        (ary[lcv].i * ary[lcv].i)) );
}

conjugate_1d_ft(ary,num_elems)
 struct complex_rec *ary;
 unsigned long num_elems;
{
 unsigned long lcv;

 for (lcv = 0; lcv < num_elems; lcv++)
     {ary[lcv].r = -ary[lcv].r;
/*
      ary[lcv].i = -ary[lcv].i;
*/
     }

}

inverse_fft(ary,num_elems,num_bits)
 struct complex_rec *ary;
 unsigned long num_elems,num_bits;
{
 conjugate_1d_ft(ary,num_elems);
 perform_fft(ary,num_elems,num_bits);
 multiply_ft_by_val(ary,num_elems,(float) num_elems);
 conjugate_1d_ft(ary,num_elems);
}

setup_fft_2d(fft_2d,_2d)
 struct buf_2d_rec *fft_2d,*_2d;
{
 unsigned long row,col;
 double sval;
 struct complex_rec *fft;

 if (_2d->status4 & BUF_VALUE_SIGNED)
    {for (row = 0; row < _2d->dimy; row++)
        {fft = (struct complex_rec *) fft_2d->buf[row];
         for (col = 0; col < _2d->dimx; col++)
            {sval = _2d->GetVal(_2d,row,col);
             fft[col].r = (float) sval;
             fft[col].i = .0;
            }
        }
    }
   else
    {printf("not signed...\n");
     for (row = 0; row < _2d->dimy; row++)
        {fft = (struct complex_rec *) fft_2d->buf[row];
         for (col = 0; col < _2d->dimx; col++)
            {sval = _2d->GetVal(_2d,row,col);
             fft[col].r = (float) sval;
             fft[col].i = .0;
            }
        }
     get_fft_2d_min_max(fft_2d);
     printf("not signed...end\n");
    }
 return NO_ERROR;
}

shift_fft_2d_to_center(fft)
 struct buf_2d_rec *fft;
{
 unsigned long row,col;
 struct complex_rec *fft1;
 unsigned long start_bit;

 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col += 1)
        if ((row + col) % 2)
           {
            fft1[col].r = -fft1[col].r;
            fft1[col].i = -fft1[col].i;
           }
    }
 return NO_ERROR;
}

get_fft_2d_col(fft_col,fft_2d,col)
 struct buf_2d_rec *fft_col,*fft_2d;
 unsigned long col;
{
 unsigned long row,start_bit;
 struct complex_rec *fft1,*fft2;

 for (row = 0; row < fft_2d->dimy; row++)
    {fft1 = (struct complex_rec *) get_1d_buf_addr(fft_2d->buf[row],
                      col,fft_2d->pixel_depth,&start_bit);

     fft2 = (struct complex_rec *) get_1d_buf_addr(fft_col->buf[0],
                      row,fft_col->pixel_depth,&start_bit);
     memcpy(fft2,fft1,sizeof(*fft1));
    }
}

save_fft_2d_col(fft_col,fft_2d,col)
 struct buf_2d_rec *fft_col,*fft_2d;
 unsigned long col;
{
 unsigned long row,start_bit;
 struct complex_rec *fft1,*fft2;

 for (row = 0; row < fft_2d->dimy; row++)
    {fft1 = (struct complex_rec *) get_1d_buf_addr(fft_2d->buf[row],
                      col,fft_2d->pixel_depth,&start_bit);
     fft2 = (struct complex_rec *) get_1d_buf_addr(fft_col->buf[0],
                      row,fft_2d->pixel_depth,&start_bit);
     memcpy(fft1,fft2,sizeof(*fft1));
    }
}

fft_2d(fft)
 struct buf_2d_rec *fft;
{
 unsigned long row,col;
 long num_xbits,num_ybits;
 struct buf_2d_rec fft_col;
 int err;

 TRACE(printf(":fft_2d(fft)...\n"))
 num_xbits = find_num_bits_needed(fft->dimx);
 if (num_bit_values(num_xbits) > fft->dimx)
    num_xbits -= 1;
 if (num_xbits <= 0) return CANCEL;

 num_ybits = find_num_bits_needed(fft->dimy);
 if (num_bit_values(num_ybits) > fft->dimy)
    num_xbits -= 1;
 if (num_ybits <= 0) return CANCEL;
 init_buf_2d_rec(&fft_col);
 if ((err = SetupBuf2dRec(&fft_col,fft->dimy,1,
        (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR)
    return err;
 TRACE(printf("row fft_2d...\n"))
 for (row = 0; row < fft->dimy; row++)
    {
     perform_fft(fft->buf[row],fft->dimx,num_xbits);

     multiply_ft_by_val(fft->buf[row],fft->dimx,(float) fft->dimx);
    }
 printf(" fft_2d...after row\n");
 get_fft_2d_min_max(fft);

 for (col = 0; col < fft->dimx; col++)
    {get_fft_2d_col(&fft_col,fft,col);
     perform_fft(fft_col.buf[0],fft_col.dimx,num_ybits);
     save_fft_2d_col(&fft_col,fft,col);
    }
 TRACE(printf("col fft_2d...end\n"))
 free_buf_2d_rec(&fft_col);
 return NO_ERROR;
}

conjugate_fft_2d(fft)
 struct buf_2d_rec *fft;
{
 unsigned long row,col;
 struct complex_rec *fft1;

 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
       {
        fft1[col].r = -fft1[col].r;
       }
    }

}

inverse_fft_2d(fft)
 struct buf_2d_rec *fft;
{
 int err;

 TRACE(printf("inverse_fft_2d...\n"))
 printf("inverse_fft_2d..ininitial.\n");
 get_fft_2d_min_max(fft);

 conjugate_fft_2d(fft);
 printf("inverse_fft_2d..conjugate_fft_2d.\n");
 get_fft_2d_min_max(fft);

 TRACE(printf("inverse_fft_2d...conjugate_fft_2d\n"))
 TRACE(pr_fft_2d(fft))

 if ((err = fft_2d(fft)) != NO_ERROR) return err;
 printf("inverse_fft_2d...fft_2d\n");
 get_fft_2d_min_max(fft);

 conjugate_fft_2d(fft);
 TRACE(printf("inverse_fft_2d...end\n"))
 printf("conjugate_fft_2d...fft_2d\n");
 get_fft_2d_min_max(fft);

 return NO_ERROR;
}

magnitude_fft_2d_to_float_2d(_2d,fft)
 struct buf_2d_rec *_2d,*fft;
{
 unsigned long row,col;
 struct complex_rec *fft1;
 float *mag;

 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     mag = (float *) _2d->buf[row];
     for (col = 0; col < fft->dimx; col++)
       {
        mag[col] = (float) sqrt((double) ((fft1[col].r * fft1[col].r) +
                               (fft1[col].i * fft1[col].i)));
       }
    }
 return NO_ERROR;
}

get_fft_2d_min_max(fft)
 struct buf_2d_rec *fft;
{
 unsigned long row,col;
 float min,max;
 struct complex_rec *fft1;

 fft1 = (struct complex_rec *) fft->buf[0];
 min = fft1[0].r;
 max = min;
 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
       {if (min > fft1[col].r) min = fft1[col].r;
        if (max < fft1[col].r) max = fft1[col].r;
       }
    }
 printf("min = %f   max = %f\n",min,max);

}

assign_fft_2d_to_int_2d(_2d,fft)
 struct buf_2d_rec *_2d,*fft;
{
 unsigned long row,col;
 long minval,maxval,val,new_height;
 struct complex_rec *fft1;
 float min,max,height,ratio;

 fft1 = (struct complex_rec *) fft->buf[0];
 min = fft1[0].r;
 max = min;
 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
       {if (min > fft1[col].r) min = fft1[col].r;
        if (max < fft1[col].r) max = fft1[col].r;
       }
    }
 printf("min = %f   max = %f\n",min,max);
 if (min < .0)
    {for (row = 0; row < fft->dimy; row++)
       {fft1 = (struct complex_rec *) fft->buf[row];
        for (col = 0; col < fft->dimx; col++)
           fft1[col].r += -min;
       }
    max += -min;
    min = .0;}
 printf("min = %f   max = %f\n",min,max);
/*
 get_2d_buf_default_min_max(_2d,&minval,&maxval);
*/
 minval = (long) floor((double) (min + .5));
 maxval = (long) floor((double) (max + .5));

 height = max - min;
 printf("min = %f   max = %f   minval = %d   maxval = %d\n",
       min,max,minval,maxval);
 if (height == 0)
    {for (row = 0; row < _2d->dimy; row++)
        for (col = 0; col < fft->dimx; col++)
           _2d->SetVal(_2d,row,col,(double) .0);
     return 0;}
 new_height = maxval - minval;
 ratio = (float) new_height / height;

 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
        {if (fft1[col].r <= min) val = minval;
           else if (fft1[col].r >= max) val = maxval;
           else val = minval + 
                 (long) ceil((double)((fft1[col].r - min) * ratio));
         _2d->SetVal(_2d,row,col,(double) val);
        }
    }

 _2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 get_min_max_2d_buf(_2d);
 printf("min = %f   max = %f   minval = %f   maxval = %f\n",
       min,max,_2d->minval,_2d->maxval);

 return NO_ERROR;
}

assign_float_2d_to_int_2d(_2d,fl_2d)
 struct buf_2d_rec *_2d,*fl_2d;
{
 unsigned long row,col,minval,maxval,val,new_height;
 float *fl;
 float min,max,height,ratio;

 min = (float) pow(2,31);
 max = -min;
 for (row = 0; row < fl_2d->dimy; row++)
    {fl = (float *) fl_2d->buf[row];
     for (col = 0; col < fl_2d->dimx; col++)
       {if (min > fl[col]) min = fl[col];
        if (max < fl[col]) max = fl[col];
       }
    }
 get_2d_buf_default_min_max(_2d,&minval,&maxval);
 height = max - min;
 new_height = maxval - minval;
 ratio = (float) new_height / height;

 for (row = 0; row < fl_2d->dimy; row++)
    {fl = (float *) fl_2d->buf[row];
     for (col = 0; col < fl_2d->dimx; col++)
        {if (fl[col] <= min) val = minval;
           else if (fl[col] >= max) val = maxval;
           else val = minval + 
                 (long) ceil((double)((fl[col] - min) * ratio));
         _2d->SetVal(_2d,row,col,(double) val);
        }
    }
 return NO_ERROR;
}

assign_magnitude_fft_2d_to_int_2d(_2d,fft)
 struct buf_2d_rec *_2d,*fft;
{
 struct buf_2d_rec mag_2d;
 int err;

 init_buf_2d_rec(&mag_2d);
 TRACE(printf("assign_magnitude_fft_2d_to_int_2d...\n"))
 if ((err = SetupBuf2dRec(&mag_2d,fft->dimx,fft->dimy,
       (size_t) (8 * sizeof(float)),0)) != NO_ERROR) return err;
 magnitude_fft_2d_to_float_2d(&mag_2d,fft);
 assign_float_2d_to_int_2d(_2d,&mag_2d);
 free_buf_2d_rec(&mag_2d);
 TRACE(printf("assign_magnitude_fft_2d_to_int_2d...end\n"))
 return err;
}

pr_complex_rec(ary,num_elems)
 struct complex_rec *ary;
 unsigned long num_elems;
{
 unsigned long lcv;
 
 printf("\npr_complex_rec...\n");
 for (lcv = 0; lcv < num_elems; lcv++)
    printf("%d) %f   %f\n",lcv,ary[lcv].r,ary[lcv].i);
 printf("pr_complex_rec...end\n\n");

}

pr_fft_2d(fft)
 struct buf_2d_rec *fft;
{
 unsigned long row,col;
 struct complex_rec *fft1;

 printf("\npr_fft_2d...\n\n");
 for (row = 0; row < fft->dimy; row++)
    {fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
        printf("%d/%d) %f   %f\n",row,col,fft1[col].r,fft1[col].i);
     printf("\n");
    }
 printf("pr_fft_2d...end\n\n");
}

precondition_ideal_filter_fft_2d(fft,cut_off_freq,is_lowpass)
 struct buf_2d_rec *fft;
 float cut_off_freq;
 int is_lowpass;
{
 unsigned long row,col;
 struct complex_rec *fft1;
 long x,y,centerx,centery;
 float radius;

 centerx = fft->dimx / 2;
 centery = fft->dimx / 2;
 radius = (float) sqrt((double) ((centerx * centerx) + (centery * centery)));
 if (is_lowpass)
    {if (cut_off_freq >= radius) return NO_ERROR;
    }
   else if (cut_off_freq >= radius)
    {for (row = 0; row < fft->dimy; row++)
        {fft1 = (struct complex_rec *) fft->buf[row];
         for (col = 0; col < fft->dimx; col++)
            {fft1[col].r = .0;
             fft1[col].i = .0;
            }
        }
     return NO_ERROR;
    }
 return CANCEL;
}

ideal_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius)
 struct complex_rec *comp;
 float cut_off_freq,radius;
 int is_lowpass;
{
 if (is_lowpass)
    {if (radius <= cut_off_freq) return NO_ERROR;
    }
   else if (radius >= cut_off_freq) return NO_ERROR;
 comp->r = .0;
 comp->i = .0;
 return NO_ERROR;
}

butterworth_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,order)
 struct complex_rec *comp;
 float cut_off_freq,radius;
 int is_lowpass;
 int *order;
{
 double coefficient;

 if (is_lowpass)
    coefficient = (double) (radius / cut_off_freq);
   else 
    coefficient = (double) (cut_off_freq / radius);
 coefficient = 1.0 + pow(coefficient,(double) 2 * (*order));
 coefficient = 1 / coefficient;
 comp->r = (float) (comp->r * coefficient);
 comp->i = (float) (comp->i * coefficient);
 return NO_ERROR;
}

exponential_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,order)
 struct complex_rec *comp;
 float cut_off_freq,radius;
 int is_lowpass;
 int *order;
{
 double coefficient;

 if (is_lowpass)
    coefficient = (double) (radius / cut_off_freq);
   else 
    coefficient = (double) (cut_off_freq / radius);
 coefficient = -.347 * pow(coefficient,(double) 2 * (*order));
 coefficient = exp(coefficient);

 comp->r = (float) (comp->r * coefficient);
 comp->i = (float) (comp->i * coefficient);
 return NO_ERROR;
}

trapezoidal_filter_fft_2d(comp,cut_off_freq,is_lowpass,radius,lb_cut_off_freq)
 struct complex_rec *comp;
 float cut_off_freq,radius;
 int is_lowpass;
 float *lb_cut_off_freq;
{
 double coefficient;

 if (is_lowpass)
    {if (radius < cut_off_freq) return NO_ERROR;
     if (radius > *lb_cut_off_freq)
        {comp->r = .0;
         comp->i = .0;
         return NO_ERROR;}
    }
   else 
    {if (radius > cut_off_freq) return NO_ERROR;
     if (radius < *lb_cut_off_freq)
        {comp->r = .0;
         comp->i = .0;
         return NO_ERROR;}
    }
 coefficient = (double) ((radius - *lb_cut_off_freq) /
               (cut_off_freq - *lb_cut_off_freq));

 comp->r = (float) (comp->r * coefficient);
 comp->i = (float) (comp->i * coefficient);
 return NO_ERROR;
}

filter_fft_2d(fft,cut_off_freq,is_lowpass,precond_proc,filter_proc,arg1)
 struct buf_2d_rec *fft;
 float cut_off_freq;
 int is_lowpass;
 int (*precond_proc)();
 int (*filter_proc)();
 void *arg1;
{
 unsigned long row,col;
 long x,y,centerx,centery;
 float radius;
 struct complex_rec *fft1;

 if (!is_lowpass)
    if (cut_off_freq == .0) return NO_ERROR;
 if (precond_proc != NULL)
    if (precond_proc(fft,cut_off_freq,is_lowpass) == NO_ERROR)
       return NO_ERROR;
 for (row = 0; row < fft->dimy; row++)
    {y = row - centery;
     fft1 = (struct complex_rec *) fft->buf[row];
     for (col = 0; col < fft->dimx; col++)
        {x = col - centerx;
         radius = (float) sqrt((double) ((x * x) + (y * y)));
         filter_proc(&(fft1[col]),cut_off_freq,is_lowpass,radius,arg1);
        }
    }
 return NO_ERROR;
}



/*
main()
{
#define NUM 8
#define NUM1 8
 static struct complex_rec ary[NUM] = {{2,0},{3,0},{4,0},{4,0},
                                       {1,0},{5,0},{3,0},{7,0}};
 static struct complex_rec inv[NUM] = {{-2,0},{-3,0},{-4,0},{-4,0},
                                       {1,0},{5,0},{3,0},{7,0}};
 static long data[NUM1][NUM1] = {{2,3,4,4,2,3,4,4},
                                 {7,2,4,9,7,2,4,9},
                                 {2,5,4,4,2,5,4,4},
                                 {8,3,6,4,8,3,6,4}} ;
 struct complex_rec *ary1;
 unsigned long total,lcv,row,val;
 struct buf_2d_rec _2d,fft_2d_ary;
 int err;


 init_buf_2d_rec(&_2d);
 init_buf_2d_rec(&fft_2d_ary);

 if ((err = rd_2d("_2d.dat",&_2d)) != NO_ERROR)
    {printf("rd_2d err = %d\n",err);
     exit(err);
    }

 if ((err = SetupBuf2dRec(&fft_2d_ary,_2d.dimx,_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR)
    exit(err);

 if ((err = setup_fft_2d(&fft_2d_ary,&_2d)) != NO_ERROR)
    {printf("fft_2d err = %d\n",err);
     exit(err);
    }

 shift_fft_2d_to_center(&fft_2d_ary);
 err = fft_2d(&fft_2d_ary);

 printf("\n\n....inverse fft_2d...\n");fflush(stdout);

 inverse_fft_2d(&fft_2d_ary);

 printf("\n\n....shift_fft_2d_to_center fft_2d...\n");fflush(stdout);
 shift_fft_2d_to_center(&fft_2d_ary);
 get_fft_2d_min_max(&fft_2d_ary);

 assign_fft_2d_to_int_2d(&_2d,&fft_2d_ary);


 wr_2d("_2d.dat",&_2d);

}

*/
/*
main()
{
#define NUM 16
#define NUM1 8
#define NUM_BITS 3
 static long data[NUM] = {2,3,4,4,2,3,4,4,
                          7,2,4,9,7,2,4,9};
 struct complex_rec *ary1;
 unsigned long total,lcv,row,val;
 struct buf_2d_rec _2d,fft_2d_ary;
 int err;

 total = 0;
 get_ptr_memory(&ary1,&total,NUM1,sizeof(struct complex_rec),&err);
 if (err) exit(1);
 for (lcv = 0; lcv < NUM1; lcv++)
    {ary1[lcv].r = (float) data[lcv];
     ary1[lcv].i = 0;}

 printf("initial...\n");
 pr_complex_rec(ary1,NUM1);

 shift_fft_to_center(ary1,NUM1);
 printf("shift_fft_to_center...\n");
 pr_complex_rec(ary1,NUM1);

 perform_fft(ary1,NUM1,NUM_BITS);
 printf("fft...\n");
 pr_complex_rec(ary1,NUM1);

 conjugate_1d_ft(ary1,NUM1);
 printf("after performing conjugate_1d_ft...\n");
 pr_complex_rec(ary1,NUM1);

 perform_fft(ary1,NUM1,NUM_BITS);
 printf("after fft...\n");
 pr_complex_rec(ary1,NUM1);

 conjugate_1d_ft(ary1,NUM1);
 printf("after performing cfft onjugate_1d_ft...\n");
 pr_complex_rec(ary1,NUM1);


 shift_fft_to_center(ary1,NUM1);
 printf("shift_fft_to_center...\n");
 pr_complex_rec(ary1,NUM1);

 multiply_ft_by_val(ary1,NUM1,(float) NUM1);
 printf("\n after ultiply ft  by N = %d...\n",NUM1);
 pr_complex_rec(ary1,NUM1);

}
*/
/*
main()
{
#define NUM 8
#define NUM1 8
 static struct complex_rec ary[NUM] = {{2,0},{3,0},{4,0},{4,0},
                                       {1,0},{5,0},{3,0},{7,0}};
 static struct complex_rec inv[NUM] = {{-2,0},{-3,0},{-4,0},{-4,0},
                                       {1,0},{5,0},{3,0},{7,0}};
 static long data[NUM1][NUM1] = {{2,3,4,4,2,3,4,4},
                                 {7,2,4,9,7,2,4,9},
                                 {2,5,4,4,2,5,4,4},
                                 {2,5,4,4,2,5,4,4},
                                 {2,5,4,4,2,5,4,4},
                                 {2,5,4,4,2,5,4,4},
                                 {2,5,4,4,2,5,4,4},
                                 {8,3,6,4,8,3,6,4}} ;
 struct complex_rec *ary1;
 unsigned long total,lcv,row;
 double val;
 struct buf_2d_rec _2d,fft_2d_ary;
 int err;


 init_buf_2d_rec(&_2d);
 init_buf_2d_rec(&fft_2d_ary);
 if ((err = SetupBuf2dRec(&_2d,NUM1,NUM1,8,0)) != NO_ERROR)
    exit(err);
 printf("....1...\n");fflush(stdout);
 for (row = 0; row < NUM1; row++)
    for (lcv = 0; lcv < NUM1; lcv++)
       _2d.buf[row][lcv] = data[row][lcv];

 if ((err = SetupBuf2dRec(&fft_2d_ary,_2d.dimx,_2d.dimy,
              (size_t) (8 * sizeof(struct complex_rec)),0)) != NO_ERROR)
    exit(err);
 if ((err = setup_fft_2d(&fft_2d_ary,&_2d)) != NO_ERROR)
    {printf("fft_2d err = %d\n",err);
     exit(err);
    }
 printf("....pr_buf_2d_rec(&fft_2d_ary)..initial.\n");fflush(stdout);
 pr_fft_2d(&fft_2d_ary);

 shift_fft_2d_to_center(&fft_2d_ary);
 printf("....shift_fft_2d_to_center(&fft_2d_ary)...\n");fflush(stdout);
 pr_fft_2d(&fft_2d_ary);

 err = fft_2d(&fft_2d_ary);

 printf("\n\n....inverse fft_2d...\n");fflush(stdout);

 inverse_fft_2d(&fft_2d_ary);

 printf("\n\n....shift_fft_2d_to_center fft_2d...\n");fflush(stdout);
 shift_fft_2d_to_center(&fft_2d_ary);
 get_fft_2d_min_max(&fft_2d_ary);

 assign_fft_2d_to_int_2d(&_2d,&fft_2d_ary);

 pr_fft_2d(&fft_2d_ary);
 for (row = 0; row < _2d.dimy; row++)
    for (lcv = 0; lcv < _2d.dimx; lcv++)
       {val = _2d->GetVal(_2d,row,lcv);
        printf("***row/col = %d/%d = %f\n",row,lcv,val);
       }

}
*/
