/****************************************************************************
fn.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: fn.c,v 1.6 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>

#include "typedef.h"
#include "error_constants.h"
#include "nria_lib.h"

/* #include "menu_items.h" */


/*
cc -c fn.c
cc -o fn fn.c str.o ptr_and_dim.o
*/


/*
#define PRT(x) x; fflush(stdout);
*/
#define PRT(x)


/*
   DRW 960326: Added these two functions from "fmisc.c" to eliminate that
   solitary object code.  They are used by many programs in the hdr class.

   +   locate_next_str_num(str,indx,is_locate_first)
   +   get_mhcrc_num(fn,mhcrc_num,mhcrc_start)

   These are the original fn.c functions.

   build_fn(str,dirfn,fn,suffix)
   char *locate_suffix(str)
   drop_general_suffix(str,suffix_start_ch)
   drop_suffix(str)
   char *locate_dirfn(str)
   drop_dirfn(str);
   break_fn(the_fn,dirfn,fn,suffix)
   GetNewFn(newfn,fn,newdir,prefix,newsuffix,select)

   */


/*-----------------------------------------------------------------------
locate_next_str_num - ???
-----------------------------------------------------------------------*/

int
locate_next_str_num(str,indx,is_locate_first)
 char *str;
 unsigned int *indx;
 int is_locate_first;
{
 unsigned int len,lcv;

 len = strlen(str);
 for (lcv = 0; lcv < len; lcv++)
    if ((str[lcv] >= '0') && (str[lcv] <= '9'))
       {*indx = lcv;
        return NO_ERROR;
       }
      else if (!is_locate_first) break;
 return NOT_FOUND;
}




/*-----------------------------------------------------------------------
get_mhcrc_num - ???
-----------------------------------------------------------------------*/

int
get_mhcrc_num(fn,mhcrc_num,mhcrc_start)
 char *fn;
 char *mhcrc_num;
 int *mhcrc_start;
{
 int lcv,indx,yes;
 char *str;
 int err;

 if ((err = cp_str(&str,fn)) != NO_ERROR) return err;
 drop_dirfn(str);
 mhcrc_num[0] = '\0';
 for (yes = 0,indx = 0,lcv = 0; str[lcv] != '\0'; lcv++)
    if ((str[lcv] >= '0') && (str[lcv] <= '9'))
       {mhcrc_num[indx++] = str[lcv];
        if (!yes) *mhcrc_start = lcv;
        yes = 1;
       }
      else
       {if (yes) break;
       }
 c_free(str);
 if (indx)
    {mhcrc_num[indx] = '\0';
     return NO_ERROR;}
 return NOT_FOUND;

}


/************************/
#if 0
get_mhcrc_num(fn,mhcrc_num,mhcrc_start)
 char *fn;
 char *mhcrc_num;
 int *mhcrc_start;
{
 unsigned int first,last,indx,lcv;
 char *str;
 int err;

 if ((err = cp_str(&str,fn)) != NO_ERROR) return err;
 drop_dirfn(str);
 mhcrc_num[0] = '\0';
 if (locate_next_str_num(str,&first,1) == NO_ERROR)
    {last = first;
     while (locate_next_str_num(&(str[last + 1]),&indx,0) == NO_ERROR)
        last = last + 1 + indx;
     for (lcv = 0,indx = first; indx <= last; indx++,lcv++)
        mhcrc_num[lcv] = str[indx];
     mhcrc_num[lcv] = '\0';
     *mhcrc_start = first;
     c_free(str);
     return NO_ERROR;
    }
 c_free(str);
 return NOT_FOUND;

}
#endif
/*****************************/



/*-----------------------------------------------------------------------
build_fn - ???
-----------------------------------------------------------------------*/

int
build_fn(str,dirfn,fn,suffix)
 char **str,*dirfn,*fn,*suffix;
{
 int err;
 char *the_dirfn,*the_fn,*the_suffix,*slash;

 *str = NULL;
 the_dirfn = the_fn = the_suffix = NULL;
 if (((err = cp_str(&the_dirfn,dirfn)) != NO_ERROR) ||
     ((err = cp_str(&the_fn,fn)) != NO_ERROR) ||
     ((err = cp_str(&the_suffix,suffix)) != NO_ERROR))
    {c_free(the_dirfn);
     c_free(the_fn);
     c_free(the_suffix);
     return err;}
 trim_str_blanks(the_dirfn);
 trim_str_blanks(the_fn);
 trim_str_blanks(the_suffix);

 if (get_strlen(the_fn) > 0)
    {if ((the_dirfn == NULL) || (the_dirfn[0] == '\0'))
        slash = "";
       else if ((the_dirfn[0] == '/') && (the_dirfn[1] == '\0')) 
        slash = "";
       else slash = "/";
     if ((err = concat_strs(str,4,the_dirfn,slash,the_fn,the_suffix)) !=
            NO_ERROR)
       {c_free(*str);
        *str = NULL;}
    }
   else err = FILE_NAME_ERROR;
 c_free(the_dirfn);
 c_free(the_fn);
 c_free(the_suffix);
 return err;
}


/*-----------------------------------------------------------------------
locate_suffix - ???
-----------------------------------------------------------------------*/

char *
locate_suffix(str)
 char *str;
{char *ptr;
 size_t len;
 unsigned int cnt;

 if (str == NULL) return NULL;
 len = strlen(str);
 ptr = NULL;
 if (len > 0)
    for (cnt = len - 1; ; cnt--)
       if (str[cnt] == '.')
          {len -= cnt;
           copy_str(&ptr,&(str[cnt]),len);
           break;}
          else if (cnt == 0) break;
 return ptr;
}


/*-----------------------------------------------------------------------
drop_suffix - ???
-----------------------------------------------------------------------*/

int
drop_suffix(str)
 char *str;
{
 size_t len;
 unsigned int cnt;
 
 len = get_strlen(str);
 if (len > 0)
    for (cnt = len - 1; ; cnt--)
       if (str[cnt] == '.')
          {str[cnt] = '\0';
           return NO_ERROR;}
          else if (cnt == 0) return NO_ERROR;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
drop_general_suffix - ???
-----------------------------------------------------------------------*/

int
drop_general_suffix(str,suffix_start_ch)
 char *str;
 char suffix_start_ch;
{
 size_t len;
 unsigned int cnt;
 
 len = get_strlen(str);
 if (len > 0)
    for (cnt = len - 1; ; cnt--)
       if (str[cnt] == suffix_start_ch)
          {str[cnt] = '\0';
           return NO_ERROR;}
          else if (cnt == 0) return NO_ERROR;
 return NO_ERROR;
}



/*-----------------------------------------------------------------------
locate_dirfn - ???

 if (str == NULL) return;
 for (cnt = strlen(str) - 1; ((cnt >= 0) && (str[cnt] != '.')); cnt--);
 if (cnt >= 0) str[cnt] = '\0';
-----------------------------------------------------------------------*/

char *
locate_dirfn(str)
 char *str;
{
 char *ptr;
 size_t len;
 int cnt;

 if ((str == NULL) || (str[0] == '\0')) return NULL;
 if ((str[0] == '/') && (str[1] == '\0'))
    {cp_str(&ptr,str);
     return ptr;}

 len = strlen(str);
 ptr = NULL;
 if (len > 0)
    for (cnt = len - 1; ; cnt--)
       if (str[cnt] == '/')
          {
           copy_str(&ptr,str,cnt);
           break;}
          else if (cnt == 0) break;
 return ptr;
}


/*-----------------------------------------------------------------------
drop_dirfn - ???
-----------------------------------------------------------------------*/

int
drop_dirfn(str)
 char *str;
{
 size_t len;
 unsigned int cnt;
 
 len = get_strlen(str);
 if (len > 0)
    for (cnt = len - 1; ; cnt--)
       if (str[cnt] == '/')
          {len -= cnt - 1;
           if (len > 0) memcpy(str,&(str[cnt + 1]),len);
           return NO_ERROR;}
          else if (cnt == 0) return NO_ERROR;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
break_fn - ???
-----------------------------------------------------------------------*/

int
break_fn(the_fn,dirfn,fn,suffix)
 char *the_fn,**dirfn,**fn,**suffix;
{
 char *str;
 int err;

 *dirfn = *fn = *suffix = NULL;
 if ((err = cp_str(&str,the_fn)) != NO_ERROR) return err;
 trim_str_blanks(str);
 *suffix = locate_suffix(str);
 drop_suffix(str);

 *dirfn = locate_dirfn(str);
 drop_dirfn(str);
 err = cp_str(fn,str);
 c_free(str);

 return err;
}


/*-----------------------------------------------------------------------
GetNewFn - ???
-----------------------------------------------------------------------*/

int
GetNewFn(newfn,fn,newdir,prefix,newsuffix,select)
 char **newfn,*fn,*newdir,*prefix,*newsuffix;
 unsigned long select;
{
 char *fn1,*fn2;
 int err;

 PRT(printf("GetNewFn\n"))
 *newfn = NULL;
 if ((err = cp_str(&fn1,fn)) != NO_ERROR)
    return err;
 if (select & 1) drop_dirfn(fn1);
 if (select & 2) drop_suffix(fn1);
 err = concat_strs(&fn2,2,prefix,fn1);
 c_free(fn1);
 if (err != NO_ERROR) return err;
 c_free(fn1);
 err = build_fn(newfn,newdir,fn2,newsuffix);
 c_free(fn2);
 PRT(printf("GetNewFn *newfn = %s\n",*newfn))
 return err;
}

