/****************************************************************************
math_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: math_opr.c,v 1.8 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>

#include "typedef.h"
#include "nria_lib.h"

/*
#define PRT(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT4(x)



/*--------------------------------------------------------------------------
is_float_0 - ???
--------------------------------------------------------------------------*/

int
is_float_0(fl)
 float fl;
{
 if ((fl >= -TOLERANCE) && (fl <= TOLERANCE)) return 1;
 return 0;
}


/*--------------------------------------------------------------------------
is_double_0 - ???
--------------------------------------------------------------------------*/

int
is_double_0(dou)
 double dou;
{
 if ((dou >= (double) -TOLERANCE) && (dou <= (double) TOLERANCE)) return 1;
 return 0;
}


/*--------------------------------------------------------------------------
DoubleMinMax - ???
--------------------------------------------------------------------------*/

void
DoubleMinMax(min,max)
 double *min,*max;
{
 *min = -.29 * pow((double) 10.0,(double) 38.0);
 *max = .29 * pow((double) 10.0,(double) 38.0);
 printf("min = %g max = %g\n",*min,*max);
}


/*--------------------------------------------------------------------------
float_precision - ???
--------------------------------------------------------------------------*/

double 
float_precision(fl,num_decimals)
 double fl;
 int num_decimals;
{
 char str[70],format[20];
 double num;

/* sprintf(format,"\%%.%df",num_decimals);*/

 sprintf(format,"%%.%df",num_decimals);
 sprintf(str,format,fl);
 sscanf(str,"%lf",&num);
/* printf("float_precision radian = %f num = %f\n",fl,num);*/
 return num;
}


/*--------------------------------------------------------------------------
find_num_bytes_needed - ???
--------------------------------------------------------------------------*/

unsigned long 
find_num_bytes_needed(num)
 unsigned long num;
{
 unsigned long num_bits,num_bytes;

 num_bits = find_num_bits_needed(num);
 num_bytes = num_bits / 8;
 if (num_bits % 8) num_bytes += 1;
 return num_bytes;
}


/*--------------------------------------------------------------------------
num_bit_values - ???
--------------------------------------------------------------------------*/

unsigned long 
num_bit_values(pixel_depth)
 unsigned long pixel_depth;
{
 double fl;

 fl = pow((double) 2.0,(double) pixel_depth);
 return (unsigned long) fl;
}



/*--------------------------------------------------------------------------
find_num_bits_needed - ???
--------------------------------------------------------------------------*/

unsigned long 
find_num_bits_needed(
    unsigned long num)
{
 unsigned long num_bits,big_num;

 num_bits = 1;
 big_num = 2;
 for (;big_num < num;)
    {
     num_bits++;
     big_num *= 2;
    }
 return num_bits;
}



/*--------------------------------------------------------------------------
NumBitsNeeded - ???

if result type4 == 0 then unsigned value
if result type4 == 1 then signed value
if result type4 == 2 then float value
if result type4 == 3 then double value
--------------------------------------------------------------------------*/

unsigned long 
NumBitsNeeded(min,max,type4)
 double min,max;
 unsigned long *type4;
{
 double diff,diff1;
 unsigned long maxval,depth;

 maxval = 0xffffffff;
 diff = max - min + 1;
 diff = rint(diff);
 if (diff > (double) maxval)
    {diff1 = .58 * pow((double) 10.0,(double) 19.0);
     if (diff > diff1) 
        {*type4 = 3;
         return 64;}
     *type4 = 2;
     return 32;
    }
 depth = find_num_bits_needed((unsigned long) diff);

 if ((depth > 0) && (min < .0))
    {*type4 = 1;
     maxval = num_bit_values(depth - 1);
     diff = (double) maxval;
     if (max > diff) depth += 1;
       else if (min <= -diff) depth += 1;
     if (depth > 32) 
        {*type4 = 2;
         return 32;}
    }
   else *type4 = 0;
 return depth;
}


/*--------------------------------------------------------------------------
MinMaxValues - ???

 if      (type4 == 1) is signed
 else if (type4 == 2) is float
 else if (type4 == 3) is double
--------------------------------------------------------------------------*/

void
MinMaxValues(select4,pixel_depth,min,max)
 unsigned long select4;
 unsigned long pixel_depth;
 double *min,*max;
{
 unsigned long num_bits;
 double num;

 if (select4 == 2)
    {num = .29 * pow((double) 10.0,(double) 19.0);
     if (max != NULL) *max = num;
     if (min != NULL) *min = -num;}
   else if (select4 == 3)
    {num = .29 * pow((double) 10.0,(double) 38.0);
     if (max != NULL) *max = num;
     if (min != NULL) *min = -num;}
   else if (pixel_depth == 0)
    {if (min != NULL) *min = 0;
     if (max != NULL) *max = 0;}
   else 
    {if (select4 == 1) num_bits = pixel_depth - 1;
       else num_bits = pixel_depth;
     num = pow((double) 2.0, (double) num_bits);
     if (select4 == 1)
        {if (min != NULL) *min = -num;} 
       else if (min != NULL) *min = 0;
     if (max != NULL) *max = num - 1;
    }
}


/*************************
pixel_depth_signed_min_max(pixel_depth,min,max)
 unsigned long pixel_depth;
 long *min,*max;
{
 unsigned long num;

 if (pixel_depth == 0)
    *min = *max = 0;
   else
    {num = num_bit_values(pixel_depth);
     num = num / 2;
     *max = num - 1;
     *min = num;
     *min = -(*min);}
}

long signed_new_valid_min_max(orig_min,orig_max,pixel_depth,next_min,next_max,
                              new_min,new_max)
 long orig_min,orig_max,pixel_depth,next_min,next_max,*new_min,*new_max;
{
 long min,max;

 if ((next_min < orig_min) || (next_max > orig_max))
    {pixel_depth_signed_min_max(pixel_depth,&min,&max);
     if (next_min < orig_min)
        {if (next_min < min) *new_min = min;
           else *new_min = next_min;}
       else *new_min = orig_min;

     if (next_max > orig_max)
        {if (next_max > max) *new_max = max;
           else *new_max = next_max;}
       else *new_max = orig_max;
    }
   else 
    {*new_min = orig_min;
     *new_max = orig_max;}
}

long unsigned_new_valid_min_max(orig_min,orig_max,pixel_depth,next_min,next_max,
                              new_min,new_max)
 unsigned long orig_min,orig_max,pixel_depth,next_min,
         next_max,*new_min,*new_max;
{
 unsigned long max;

 if ((next_min < orig_min) || (next_max > orig_max))
    {
     max = num_bit_values(pixel_depth);
     if (next_min < orig_min)
        {if (next_min < 0) *new_min = 0;
           else *new_min = next_min;}
       else *new_min = orig_min;

     if (next_max > orig_max)
        {if (next_max > max) *new_max = max;
           else *new_max = next_max;}
       else *new_max = orig_max;
    }
   else 
    {*new_min = orig_min;
     *new_max = orig_max;}
}
******************************/



/*--------------------------------------------------------------------------
degree - ???
--------------------------------------------------------------------------*/

#define RADIAN (double) 3.141592654

double 
degree(radian)
 float radian;
{
 double angle;

 angle = (double)(radian * 180 / RADIAN);
 angle = (float) fmod(angle,(double) 360.0);
 if (angle < .0) angle += (double) 360.0;
 return angle;

}


/*--------------------------------------------------------------------------
degree_1 - ???
--------------------------------------------------------------------------*/

double 
degree_1(radian,num_decimals)
 float radian;
 int num_decimals;
{
 double angle;

 angle = (double)(radian * 180 / RADIAN);
 angle = (float) fmod(angle,(double) 360.0);
 if (angle < .0) angle += (double) 360.0;
 return (double) float_precision(angle,num_decimals);
}


/*--------------------------------------------------------------------------
radian - ???
--------------------------------------------------------------------------*/

double 
radian(degree)
 float degree;
{
 return (double) (degree * RADIAN / 180);

}


/*--------------------------------------------------------------------------
radian_1 - ???
--------------------------------------------------------------------------*/

double 
radian_1(degree,num_decimals)
 float degree;
 int num_decimals;
{
 double dou;

 dou = degree * RADIAN / 180;

 return float_precision(dou,num_decimals);
}


/*--------------------------------------------------------------------------
DegCosRadian - ???
--------------------------------------------------------------------------*/

double 
DegCosRadian(degree)
 float degree;
{
 float angle;
/*
 double dou;
 dou = radian(degree);
 angle = fmod((double) degree,(double) 360.0);
 if (angle < .0) angle = -angle;
 if ((angle > 90.0) && (angle < 270.0)) return -dou;
 return dou;
*/
 angle = (float) fmod((double) degree,(double) 360.0);
 if (angle < .0) angle = 360.0 - angle;
 if (angle > 90.0) 
    if (angle <= 180.0) angle -= 180.0;
      else if (angle <= 270.0)
       {angle -= 180.0;
        angle = -angle;}
      else angle = 360.0 - angle;
 return radian(angle);
}


/*--------------------------------------------------------------------------
acos_to_degree - ???

 assume that -1.0 <= val <= 1.0
--------------------------------------------------------------------------*/

double 
acos_to_degree(val)
 float val;
{
 double temp,temp1,temp2,angle;

 if (val >= 1.0) return 0.0;
 if (val == -1.0) return 180.0;
 if (val == .0) return 90.0;

 temp1 = (double) val;
 temp2 = (double) 1.0 - temp1 * temp1;
 PRT(printf("acos_to_degree val = %.9f temp2 = %.9f\n",val,temp2);)
 temp = Sqrt(temp2);
 PRT4(printf("acos_to_degree temp = %f temp1 = %f temp2 = %f\n",temp, temp1,temp2);)
 temp = Atan2(temp,(double) temp1);

 angle = (double)(temp * 180 / RADIAN);
 PRT4(printf("1 temp = %f angle = %f\n",temp,angle);)
 if (angle < .0) angle += (double) 360.0;
 PRT(printf("1 acos_to_degree angle = %f\n",angle);)
 return angle;
}


/*--------------------------------------------------------------------------
cos_degree - ???
--------------------------------------------------------------------------*/

double 
cos_degree(degree)
 float degree;
{
 return float_precision(cos(radian(degree)),6);
}


/*--------------------------------------------------------------------------
distance - ???
--------------------------------------------------------------------------*/

double 
distance(x1,y1,x2,y2)
 float x1,y1,x2,y2;
{
 float sum;

 x1 = x1 - x2;
 y1 = y1 - y2;
 sum = x1 * x1 + y1 * y1;
 if (is_float_0(sum)) return .0;
 PRT4(printf("distance sum = %f\n",sum);)
 return Sqrt((double) sum);
}


/*--------------------------------------------------------------------------
perpendicular_pt - ???
--------------------------------------------------------------------------*/

void
perpendicular_pt(x1,y1,x2,y2,x3,y3,ptx,pty)
 double x1,y1,x2,y2,x3,y3,*ptx,*pty;
{
 double m,c,c1,x4,y4;

 if (x1 == x2)
    {*ptx = x3;
     *pty = y2;
     return;}
   else if (y1 == y2)
    {*ptx = x2;
     *pty = y3;
     return;}

 m = (y2 - y1) / (x2 - x1);
 c = (y1 + y2 - m * (x1 + x2)) / (double) 2;
 c1 = y3 +  x3 / m;

 x4 = (c1 - c) * m / (m * m + 1);
 y4 = m * x4 + c;
 *ptx = x2 - x4 + x3;
 *pty = y2 - y4 + y3;
}


/*--------------------------------------------------------------------------
round_floats - ???

This function is apparently never used and has been deleted; it used varargs
and would have been difficult to convert.  -PWH 19990405
--------------------------------------------------------------------------*/

#if 0
void
round_floats(va_alist)
 va_dcl
{
 va_list args;
 float *fl;

 va_start(args);
 for (; (fl = va_arg(args, float *)) != NULL; )
    {
     *fl = (float) floor((double) (*fl + .5));
    }
 va_end(args);

}
#endif


/*--------------------------------------------------------------------------
LongRound - ???
--------------------------------------------------------------------------*/

long 
LongRound(num)
 double num;
{
 if (num == .0) return 0;
   else if (num > .0) return (long) (num + .5);
 return (long) (num - .5);
}


/*--------------------------------------------------------------------------
ULongRound - ???
--------------------------------------------------------------------------*/

unsigned long 
ULongRound(num)
 double num;
{
 if (num > .0) return (long) (num + .5);
 return 0;
}



/*--------------------------------------------------------------------------
Sqrt - ???
--------------------------------------------------------------------------*/

double 
Sqrt(num)
 double num;
{
 int sign;
 double num1;

 if (num < .0)
    {num = -num;
     sign = -1;}
   else sign = 1;
 num1 = sqrt(num);
 if (sign < 0) return -num1;
 return num1;

}


/*--------------------------------------------------------------------------
Atan2 - ???
--------------------------------------------------------------------------*/

double 
Atan2(y,x)
 double y,x;
{
 double direction_rad;

 if (y == .0) direction_rad = .0;
   else if (x == .0) 
    {if (y < .0) direction_rad = -RADIAN / 2.0;
       else direction_rad = RADIAN / 2.0;
    }
   else
    {direction_rad = atan2(y,x);}
 return direction_rad;
}


/*--------------------------------------------------------------------------
get_equation - ???
--------------------------------------------------------------------------*/

void 
get_equation(eq,x1,y1,x2,y2)
 float eq[3],x1,y1,x2,y2;
{
 eq[0] = y1 - y2;
 eq[1] = x2 - x1;
 eq[2] = -(eq[0] * x1 + eq[1] * y1);
}	


/*--------------------------------------------------------------------------
fn_xy - ???
--------------------------------------------------------------------------*/

float 
fn_xy(eq,x,y)
 float eq[3],x,y;
{
 return(eq[0] * x + eq[1] * y + eq[2]);
}


/*--------------------------------------------------------------------------
get_2d_member_sign - ???
--------------------------------------------------------------------------*/

short 
get_2d_member_sign(eq,x,y)
 float eq[3],x,y;
{
 float temp;

 temp = fn_xy(eq,x,y);
 if (temp < 0.0) return(-1);
   else if (temp > 0.0) return(1);
   else return(0);
}
