/****************************************************************************
ndat_v3.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME: This very weird library file expects to be able to call various
functions and use various structures that belong to NRIA proper.
Hence the mri_format.h and nria_procedures.h header files are
included.  This is a nasty kluge that ought to be fixed someday.
****************************************************************************/

static const char rcsid[] = "$Id: ndat_v3.c,v 1.13 1999/07/07 18:01:06 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <unistd.h>

#include "mri_format.h"
#include "nria_procedures.h"

#include "nria_lib.h"




/*
 *  ndat_v3.c
 *
 *  Old names:
 *	v3_misc.c, v3_output_opr.c, v3_rd_ria_dat.c, v3_wr_ria_dat.c
 *	v3_rd_wr_pixmap.c, v3_rd_wr_slice_roi_rec.c
 *
 *  Routines for reading in binary file .ndat which contains region
 *    information.
 */


#if 0
#  define TRACE(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT1(x) x; fflush(stdout);
#  define PRT2(x) x; fflush(stdout);
#  define PRT3(x) x; fflush(stdout);
#  define PRT5(x) x; fflush(stdout);
#else
#  define TRACE(x)
#  define PRT(x)
#  define PRT1(x)
#  define PRT2(x)
#  define PRT3(x)
#  define PRT5(x)
#endif          

/*  PWH 19980420:  Moved various routines that depend on XView to the
    file rdir.c, to make it easier to write a non-interactive program
    that reads, modifies, and writes an NDAT file.
    */


/*  DRW: easier to read source  */
#define FREAD_ONE_ITEM(item,fid) \
  fread( &(item), (size_t) sizeof(item), 1, fid )


struct roi_rec *get_roi();
char *UniqueFn();
char *get_prog_dir();
int win_redisplay_all_curves();


/* Functions defined in this file */
extern int rd_output_slice_nums(FILE *fid, unsigned int **slice_nums,
    unsigned int *num_slice_rois);
extern int rd_output_field_offset_rec(FILE *fid,
    struct output_field_offset_rec *offset);
extern int rd_output_hdr_rec(FILE *fid, struct output_hdr_rec *hdr,
    int (*hdr_error_proc)());
extern int rd_output_slice_rois(FILE *fid, struct slice_roi_rec **slice_rois,
    unsigned int actual_total_slice_rois, unsigned int *slice_nums,
    unsigned int num_slice_rois);
extern int rd_histo_pixel_center_recs(FILE *fid,
    struct pixel_center_rec **centers, unsigned int *num_centers,
    struct slice_roi_rec *slice_roi);
extern int rd_histo_bkg_rec(FILE *fid, struct histo_bkg_rec *bkg);
extern int rd_histo_params(FILE *fid, struct histo_params_rec *histo);
extern int rd_pixel_type_cnt_rec(FILE *fid,
    struct pixel_type_cnt_rec *pixel_cnt);
extern int rd_roi_pixel_type_cnts(FILE *fid, struct slice_roi_rec *slice_rois,
    unsigned int num_slice_rois);
extern int rd_pixel_type_params(FILE *fid, struct pixel_type_rec *pixel_type);
extern int rd_text_output_analysis_group_rec(FILE *fid,
    struct text_output_analysis_group_rec *group);
extern int rd_input_text_file_format(FILE *fid,
    struct text_output_analysis_group_rec **groups, unsigned int *num_groups);
extern int rd_output_field_rec(FILE *fid, struct output_field_rec *group);
extern int rd_output_count_field_rec(FILE *fid,
    struct output_count_field_rec *group);
extern int rd_output_count_group_rec(FILE *fid,
    struct output_count_group_rec *count);
extern int rd_output_text_file_format(FILE *fid,
    struct output_text_format_rec *format);
extern int rd_roi_count_anal_rec(FILE *fid, struct roi_count_anal_rec *roi,
    int is_new_format);
extern int rd_slice_count_anal_rec(FILE *fid,
    struct slice_count_anal_rec *slice);
extern int rd_slice_count_anal_recs(FILE *fid,
    struct slice_count_anal_rec **slices, unsigned long *total_slices,
    unsigned long *num_slices);
extern int rd_count_analysis_rec(FILE *fid, struct count_analysis_rec *count);
extern int cp_dat_output_hdr_rec(struct output_hdr_rec *hdr,
    struct output_file_rec *output);
extern int cp_dat_slice_roi_recs(struct slice_roi_rec *slice_rois,
    unsigned int *slice_nums, unsigned int num_slice_rois,
    unsigned int actual_total_slice_rois, struct input_file_rec *file);
extern int cp_nth_slice_roi_rec(struct slice_roi_rec *slice_rois,
    unsigned int *slice_nums, unsigned int num_slice_rois,
    struct input_file_rec *file, long slice_num);
extern int cp_dat_histo_params_rec(struct histo_params_rec *histo,
    struct input_file_rec *file);
extern int cp_dat_pixel_type_rec(struct pixel_type_rec *pixel_type,
    struct input_file_rec *file);
extern int cp_text_output_analysis_group_rec(
   struct text_output_analysis_group_rec *groups, unsigned int num_groups,
    struct input_file_rec *file);
extern void cp_output_text_format_rec(struct output_text_format_rec *format,
    struct input_file_rec *file);
extern void cp_count_analysis_rec(struct count_analysis_rec *count,
    struct input_file_rec *file);
extern void hdr_error_proc(void);
extern int RdNdatFields(FILE *fid, struct output_hdr_rec *hdr,
    struct slice_roi_rec **slice_rois, long *total_slice_rois,
    struct histo_params_rec *histo, struct pixel_type_rec *pixel_type,
    struct text_output_analysis_group_rec **groups, unsigned int *num_groups,
    struct output_text_format_rec *format, struct count_analysis_rec *count);
extern void free_ndat_fields(struct output_hdr_rec *hdr,
    struct slice_roi_rec *slice_rois, long total_slice_rois,
    struct histo_params_rec *histo, struct pixel_type_rec *pixel_type,
    struct text_output_analysis_group_rec *groups, unsigned int num_groups,
    struct output_text_format_rec *format, struct count_analysis_rec *count);
extern int RdTheNdatFields(char *fn, struct output_hdr_rec *hdr,
    struct slice_roi_rec **slice_rois, long *total_slice_rois,
    struct histo_params_rec *histo, struct pixel_type_rec *pixel_type,
    struct text_output_analysis_group_rec **groups, unsigned int *num_groups,
    struct output_text_format_rec *format, struct count_analysis_rec *count);
extern int rd_dat_file(char *fn, struct output_file_rec *output);
extern int rd_dat_file_slice_rois(char *fn, struct input_file_rec *file);
extern int rd_file_slice_roi_rec(char *fn, struct input_file_rec *file,
    long slice_num);
extern int save_slice_roi_rec(char *dir, char *fn,
    struct slice_roi_rec *slice_roi);
extern int Wr2dImage(char *fn, struct buf_2d_rec *_2d, char *img_label,
    char **err_reason, struct hdr_rec *hdr,
    double xpix, double ypix, double zpix);
extern int init_default_output_hdr_info_rec(struct output_hdr_info_rec *info,
    struct input_file_rec *file);
extern void init_output_file_rec(struct output_file_rec *output,
    struct input_file_rec *file);
extern int setup_output_fn(struct output_file_rec *output,
    char *dirfn, char *fn, char *dat_fn_suffix, char *bin_fn_suffix);
extern int change_output_fn(struct output_file_rec *output,
    char *output_fn, char *bin_fn_suffix);
extern int rd_dat_slice_rois(struct output_file_rec *output, int is_rd_all,
    long slice_num);
extern void close_output_file_rec(struct output_file_rec *output);
extern int get_output_fn(struct output_file_rec *output, char **fn);
extern int wr_dat_file(char *fn, struct output_file_rec *output);
extern int check_file_save(struct output_file_rec *output);
extern void set_dat_file_changed(struct input_file_rec *file);
extern void set_dat_file_saved(struct input_file_rec *file, int is_save);
extern void flush_output_save_status(struct output_file_rec *output);
extern void init_pixmap_hdr_rec(struct pixmap_hdr_rec *hdr);
extern void free_pixmap_hdr_rec(struct pixmap_hdr_rec *hdr);
extern void pr_pixmap_hdr_rec(struct pixmap_hdr_rec *hdr);
extern int RdPixmapHdr(char *fn, struct pixmap_hdr_rec *hdr);
extern int RdThePixmapHdr(char *dir, char *fn, char *suffix,
    struct pixmap_hdr_rec *pixmap_hdr);
extern int rd_pixmap_slices(char *fn, struct pixmap_hdr_rec *hdr,
    struct buf_2d_rec **slice_maps, unsigned long num_slice_maps);
extern int rd_pixmap_for_slice_num(char *fn, struct pixmap_hdr_rec *hdr,
    struct buf_2d_rec *slice_map, int slice_num);
extern int wr_updated_pixmap_params(FILE *fid, struct pixmap_hdr_rec *hdr);
extern int wr_pixmap_hdr(char *fn, struct pixmap_hdr_rec *hdr);
extern int WrPixmap(char *fn, struct strs_rec *order,
    struct buf_2d_rec **slice_maps, unsigned long num_slice_maps,
    struct pixmap_hdr_rec *hdr);
extern int is_compatible_pixmap(struct pixel_type_rec *pixel_type,
    long dimx, long dimy);
extern int append_wr_file_pixmap(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, int dimx, int dimy, char **err_reason);
extern int wr_file_pixmap_for_slice_num(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, int dimx, int dimy, long num_slices,
    int slice_map, int slice_num, char **err_reason);
extern int wr_file_pixmap(char *dir, char *fn, char *suffix,
    struct pixel_type_rec *pixel_type, char **err_reason);
extern int v3_rd_curve_rec(FILE *fid, struct curve_rec *curve);
extern int v3_rd_curve_2d_rec(FILE *fid, struct curve_2d_rec *pen);
extern int v3_rd_roi_rec(FILE *fid, struct roi_rec *roi);
extern int v3_rd_slice_roi_rec(FILE *fid, struct slice_roi_rec *slice_roi);
extern int v3_wr_curve_rec(FILE *fid, struct curve_rec *curve);
extern int v3_wr_curve_2d_rec(FILE *fid, struct curve_2d_rec *pen);
extern int v3_wr_roi_rec(FILE *fid, struct roi_rec *roi);
extern int v3_wr_slice_roi_rec(FILE *fid, struct slice_roi_rec *slice_roi);
extern void init_output_hdr_info_rec(struct output_hdr_info_rec *info);
extern void init_output_hdr_rec(struct output_hdr_rec *hdr);
extern void free_output_hdr_info_rec(struct output_hdr_info_rec *info);
extern void free_output_hdr_rec(struct output_hdr_rec *hdr);
extern int wr_output_field_offset_rec(FILE *fid,
    struct output_field_offset_rec *offset);
extern int wr_output_hdr_rec(FILE *fid, struct output_hdr_rec *hdr,
    unsigned long *offset);
extern int wr_output_slice_nums(FILE *fid, unsigned long *slice_nums,
    unsigned long num_slice_rois);
extern int wr_histo_bkg_rec(FILE *fid, struct histo_bkg_rec *bkg);
extern int wr_histo_params(FILE *fid, struct histo_params_rec *histo);
extern int wr_text_output_analysis_group_rec(FILE *fid,
    struct text_output_analysis_group_rec *group);
extern int wr_pixel_type_cnt_rec(FILE *fid,
    struct pixel_type_cnt_rec *pixel_cnt);
extern int wr_pixel_type_params(FILE *fid, struct pixel_type_rec *pixel_type);
extern int wr_input_text_file_format(FILE *fid,
    struct text_output_analysis_group_rec *groups, unsigned long num_groups);
extern int wr_output_field_rec(FILE *fid, struct output_field_rec *group);
extern int wr_output_count_field_rec(FILE *fid,
    struct output_count_field_rec *group);
extern int wr_output_count_group_rec(FILE *fid,
    struct output_count_group_rec *count);
extern int wr_output_text_file_format(FILE *fid,
    struct output_text_format_rec *format);
extern int wr_text_file_format(FILE *fid, struct text_output_rec *text);
extern int wr_roi_count_anal_rec(FILE *fid, struct roi_count_anal_rec *roi);
extern int wr_slice_count_anal_rec(FILE *fid,
    struct slice_count_anal_rec *slice);
extern int wr_slice_count_anal_recs(FILE *fid,
    struct slice_count_anal_rec *slices, unsigned long num_slices);
extern int wr_count_analysis_rec(FILE *fid, struct count_analysis_rec *count);
extern int wr_ria_slice_rois(FILE *fid, struct slice_num_and_roi_rec *slices,
    long num_slices);
extern int setup_slice_nums(struct output_hdr_rec *hdr,
    struct slice_num_and_roi_rec *slices, long num_slices, long total_slices);
extern int wr_ria_dat_file(char *fn, struct output_hdr_rec *hdr,
    struct slice_num_and_roi_rec *slices, long num_slices, long total_slices,
    struct histo_params_rec *histo, struct pixel_type_rec *pixel_type,
    struct text_output_rec *text, struct count_analysis_rec *count);
extern int setup_slice_num_and_roi_rec(struct slice_roi_rec *slice_rois,
    long total_slices, struct slice_num_and_roi_rec **slices,
    long *num_slices);
extern int WrRiaNdatFile(char *fn, struct output_hdr_rec *hdr,
    struct slice_roi_rec *slice_rois, long total_slices,
    struct histo_params_rec *histo, struct pixel_type_rec *pixel_type,
    struct text_output_analysis_group_rec *groups, unsigned long num_groups,
    struct output_text_format_rec *format, struct count_analysis_rec *count);



/*************************************************************************
 *
 *  v3_rd_ria_dat.c
 *
 *************************************************************************/


/*------------------------------------------------------------------------
rd_output_slice_nums - ???
------------------------------------------------------------------------*/

int
rd_output_slice_nums(fid,slice_nums,num_slice_rois)
     FILE *fid;
     unsigned int **slice_nums;
     unsigned int *num_slice_rois;
{
  int err;

  TRACE(printf("rd_output_slice_nums...*num_slice_rois = %d\n",
	       *num_slice_rois));

  if (*num_slice_rois == 0)
    return NO_ERROR;

  if ((err = get_ptr(slice_nums,NULL,*num_slice_rois,
		     (size_t) sizeof(**slice_nums))) != NO_ERROR)
  {
    *num_slice_rois = 0;
    return err;
  }

  if (fread(*slice_nums,(size_t) (sizeof(**slice_nums) * (*num_slice_rois)),
	    1,fid) != 1)
  {
    return READ_ERROR;
  }

  TRACE(printf("rd_output_slice_nums..end\n"));
  
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_output_field_offset_rec - ???
------------------------------------------------------------------------*/

int
rd_output_field_offset_rec(fid,offset)
     FILE *fid;
     struct output_field_offset_rec *offset;
{
  if (fread(&(offset->slice_roi_start),40,1,fid) != 1)
    return READ_ERROR;

  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_output_hdr_rec - ???
------------------------------------------------------------------------*/

int
rd_output_hdr_rec(fid,hdr,hdr_error_proc)
     FILE *fid;
     struct output_hdr_rec *hdr;
     int (*hdr_error_proc)();
{
  int err;

  err = READ_ERROR;
  if ((fread(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
      ((err = rd_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
      ((err = rd_file_strs(fid,&(hdr->rater),1)) == NO_ERROR) &&
      ((err = rd_output_field_offset_rec(fid,&(hdr->offset))) == NO_ERROR))
  {
    if (str_cmp(hdr->id,DAT_ID_V3) != 0)
    {
      printf("Sorry...this ndat file is of version = %s\n",hdr->id);
      printf("     ...version = %s expected !!!\n",DAT_ID_V3);
      return BAD_VERSION;
    }
    return NO_ERROR;
  }

  return err;
}



/*------------------------------------------------------------------------
rd_output_slice_rois - ???
------------------------------------------------------------------------*/

int
rd_output_slice_rois(fid,slice_rois,actual_total_slice_rois,
                     slice_nums,num_slice_rois)
     FILE *fid;
     struct slice_roi_rec **slice_rois;
     unsigned int *slice_nums;
     unsigned int actual_total_slice_rois,num_slice_rois;
{
  unsigned int lcv;
  int err;

  TRACE(printf("rd_output_slice_rois...actual_total_slice_rois = %d num_slice_rois = %d\n",
	       actual_total_slice_rois,num_slice_rois));
  if (num_slice_rois == 0)
    return NO_ERROR;

  if ((err = get_ptr(slice_rois,NULL,actual_total_slice_rois,
		     (size_t) sizeof(struct slice_roi_rec))) != NO_ERROR)
    return err;

  for (lcv = 0; lcv < actual_total_slice_rois; lcv++)
    init_slice_roi_rec(&((*slice_rois)[lcv]));

  for (lcv = 0; lcv < num_slice_rois; lcv++)
  {
    TRACE(printf("reading slice# = %d slice num = %d\n",lcv,slice_nums[lcv]));
    if ((err = v3_rd_slice_roi_rec(fid,&((*slice_rois)[slice_nums[lcv]])))
	!= NO_ERROR)
    {
      return err;
    }
  }
  TRACE(printf("rd_output_slice_rois...end\n"));
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_histo_pixel_center_recs - ???
------------------------------------------------------------------------*/

int
rd_histo_pixel_center_recs(fid,centers,num_centers,slice_roi)
     FILE *fid;
     struct pixel_center_rec **centers;
     unsigned int *num_centers;
     struct slice_roi_rec *slice_roi;
{
  unsigned int lcv;
  char *str1,*str2;
  int err;

  TRACE(printf("rd_histo_pixel_center_recs...\n"));
  err = NO_ERROR;
  if (fread(num_centers,(size_t) sizeof(*num_centers),1,fid) == 1)
  {
    if (*num_centers == 0) return NO_ERROR;
    TRACE(printf("rd_histo_pixel_center_recs...1\n"));

    if ((err = get_ptr(centers,NULL,*num_centers,
		       (size_t) sizeof(struct pixel_center_rec)))
	!= NO_ERROR)
    {
      *num_centers = 0;
      return err;
    }

    for (lcv = 0; lcv < *num_centers; lcv++)
      init_pixel_center_rec(&((*centers)[lcv]));

    TRACE(printf("rd_histo_pixel_center_recs...2\n"));
    for (lcv = 0; lcv < *num_centers; lcv++)
    {
      str1 = str2 = NULL;
      if (((err = rd_file_strs(fid,&str1,1)) != NO_ERROR) ||
	  ((err = rd_file_strs(fid,&str2,1)) != NO_ERROR))
	break;

      if (fread(&((*centers)[lcv]),
		(size_t) sizeof((*centers)[lcv]),1,fid) != 1)
      {
	err = READ_ERROR;
	break;
      }
      (*centers)[lcv].roi_label = str1;
      (*centers)[lcv].segmented_roi_label = str2;
    }
    if (err != NO_ERROR)
    {
      c_free(str1);
      c_free(str2);
    }
    TRACE(printf("rd_histo_pixel_center_recs...err = %d\n",err));
  }
  else
    return READ_ERROR;

  TRACE(printf("return rd_histo_pixel_center_recs...err = %d\n",err));

  return err;
}



/*------------------------------------------------------------------------
rd_histo_bkg_rec - ???
------------------------------------------------------------------------*/

int
rd_histo_bkg_rec(fid,bkg)
     FILE *fid;
     struct histo_bkg_rec *bkg;
{
  int err;

  TRACE(printf("rd_bkgs .........\n"));
  if (fread(&(bkg->num_bkgs),(size_t) sizeof(bkg->num_bkgs),1,fid) != 1)
  {
    bkg->num_bkgs = 0;
    return READ_ERROR;
  }
  TRACE(printf("rd_bkgs num_bkgs = %d\n",bkg->num_bkgs));

  if (bkg->num_bkgs == 0)
    return NO_ERROR;

  if ((err = get_ptr(&(bkg->bkgs),NULL,bkg->num_bkgs,
		     (size_t) sizeof(*(bkg->bkgs)))) != NO_ERROR)
  {
    bkg->num_bkgs = 0;
    return err;
  }

  if (fread(bkg->bkgs,
	    (size_t) (bkg->num_bkgs * sizeof(*(bkg->bkgs))),1,fid) != 1)
  {
    bkg->num_bkgs = 0;
    c_free(bkg->bkgs);
    return READ_ERROR;
  }
  TRACE(printf("rd_bkgs v3_rd_roi_rec\n"));
  err = v3_rd_roi_rec(fid,&(bkg->roi));
  TRACE(printf("rd_bkgs v3_rd_roi_rec err = %d\n",err));
  return err;
}



/*------------------------------------------------------------------------
rd_histo_params - ???
------------------------------------------------------------------------*/

int
rd_histo_params(fid,histo)
     FILE *fid;
     struct histo_params_rec *histo;
{
  int err;

  TRACE(printf("rd_histo_params...1\n"));
  if (fread(&(histo->status2),(size_t) sizeof(histo->status2),1,fid) != 1)
    return READ_ERROR;
  PRT2(printf("rd_histo_params status2 = %x\n",(unsigned long) histo->status2););

  if (histo->status2 & HISTO_TYPE)
  {
    if (((err =
	  v3_rd_slice_roi_rec(fid, &(histo->slice_roi_win_2d.slice_roi)))
	 != NO_ERROR) ||
	((err =
	  v3_rd_slice_roi_rec(fid, &(histo->slice_roi_win_1d.slice_roi)))
	 != NO_ERROR) ||
	((err = rd_histo_bkg_rec(fid,&(histo->bkg))) != NO_ERROR) ||
	((err = rd_strs_rec(fid,&(histo->pixel_type_order))) != NO_ERROR))
      return err;
  }
  else
    err = NO_ERROR;

  if (histo->status2 & HISTO_CNT_1D_VALID)
    err = v3_rd_non_contiguos_buf_2d_rec(fid,&(histo->histo_1d));

  PRT2(printf("rd_histo_params...\n"));
  return err;
}



/*------------------------------------------------------------------------
rd_pixel_type_cnt_rec - ???
------------------------------------------------------------------------*/

int
rd_pixel_type_cnt_rec(fid,pixel_cnt)
     FILE *fid;
     struct pixel_type_cnt_rec *pixel_cnt;
{
  int err;

  TRACE(printf("rd_pixel_type_cnt_rec...begin\n"));
  if ((fread(&(pixel_cnt->status),
	     (size_t) sizeof(pixel_cnt->status),1,fid) != 1) ||
      (fread(&(pixel_cnt->num_pixel_type_cnts),
             sizeof(pixel_cnt->num_pixel_type_cnts),1,fid) != 1))
    return READ_ERROR;
  if ((err = get_ptr(&(pixel_cnt->pixel_type_cnts),NULL,
		     (unsigned int) pixel_cnt->num_pixel_type_cnts,
		     (size_t) sizeof(unsigned int))) != NO_ERROR)
  {
    pixel_cnt->num_pixel_type_cnts = 0;
    return err;
  }
  
  if (fread(pixel_cnt->pixel_type_cnts,
	    (size_t) (pixel_cnt->num_pixel_type_cnts * sizeof(unsigned int)),
            1,fid) != 1)
    return READ_ERROR;
  TRACE(printf("rd_pixel_type_cnt_rec...end\n"));
  
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_roi_pixel_type_cnts - ???
------------------------------------------------------------------------*/

int
rd_roi_pixel_type_cnts(fid,slice_rois,num_slice_rois)
     FILE *fid;
     struct slice_roi_rec *slice_rois;
     unsigned int num_slice_rois;
{
  unsigned int lcv,indx,loop,num_slices,num_rois;
  struct slice_roi_rec *slice_roi;
  struct roi_rec *roi;
  char *str;
  int err;

  TRACE(printf("rd_roi_pixel_type_cnts...begin\n"));
  if (fread(&num_slices,
	    (size_t) sizeof(num_slices),1,fid) != 1) return READ_ERROR;
  if (num_slices == 0) return NO_ERROR;
  TRACE(printf("rd_roi_pixel_type_cnts...num_slices = %d\n",num_slices));
  for (indx = 0; indx < num_slices; indx++)
  {
    if (fread(&lcv,(size_t) sizeof(lcv),1,fid) != 1) return READ_ERROR;
    slice_roi = &(slice_rois[lcv]);
    
    if (fread(&num_rois,
	      (size_t) sizeof(num_rois),1,fid) != 1) return READ_ERROR;
    TRACE(printf("rd_roi_pixel_type_cnts...lcv = %d num_rois = %d\n",lcv,num_rois));
    for (loop = 0; loop < num_rois; loop++)
    {
      if ((err = rd_file_strs(fid,&str,1)) != NO_ERROR) return err;
      roi = get_roi(slice_roi,str);
      c_free(str);
      if (roi == NULL)
      {
	return CANCEL;
      }
      if (roi->user.ptr != NULL) exit_pixel_type_cnt_rec(&(roi->user.ptr));
      init_user_defined_rec(&(roi->user));
      
      roi->user.exit = exit_pixel_type_cnt_rec;
      if ((err = get_ptr(&(roi->user.ptr),NULL,(unsigned int) 1,
			 (size_t) sizeof(struct pixel_type_cnt_rec))) != NO_ERROR)
      {
	free_user_defined_rec(&(roi->user));
	return err;
      }
      
      init_pixel_type_cnt_rec(roi->user.ptr);
      if ((err = rd_pixel_type_cnt_rec(fid,roi->user.ptr)) != NO_ERROR)
      {
	free_user_defined_rec(&(roi->user));
	return err;
      }
    }
    TRACE(printf("rd_roi_pixel_type_cnts...end loop = %d\n",num_rois));
  }
  TRACE(printf("rd_roi_pixel_type_cnts...end\n"));
  
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_pixel_type_params - ???
------------------------------------------------------------------------*/

int
rd_pixel_type_params(fid,pixel_type)
     FILE *fid;
     struct pixel_type_rec *pixel_type;
{
  int err;

  TRACE(printf("rd_pixel_type_params...begin\n"));
  if (fread(&(pixel_type->status),
	    (size_t) sizeof(pixel_type->status),1,fid) != 1)
    return READ_ERROR;
  PRT3(printf("rd_pixel_type_params...pixel_type->status = %x\n",
	      (unsigned long) pixel_type->status));
  if (((err = rd_strs_rec(fid,&(pixel_type->order))) != NO_ERROR) ||
      ((err = rd_file_strs(fid,&(pixel_type->slice_map_data_creation_date),1
			   )) != NO_ERROR) ||
      ((err = v3_rd_buf_2d_rec(fid,&(pixel_type->map))) != NO_ERROR))
    return err;

  if ((pixel_type->order.num_strs > 0) &&
      (pixel_type->map.status4 & BUF_DATA_VALID))
  {
    if (!(pixel_type->status & PIXEL_TYPE_SEGMENTED))
      pixel_type->status |= PIXEL_TYPE_2D_PARTITION;
  }
  TRACE(pr_strs_rec(&(pixel_type->order)));
  TRACE(printf("rd_pixel_type_params...err = %d\n",err));
  return err;
}

/*
   be careful that it is slice_rois[1..actual_total_slice_rois - 1]
   err = rd_roi_pixel_type_cnts(fid,slice_rois,num_slice_rois);
   */



/*------------------------------------------------------------------------
rd_text_output_analysis_group_rec - ???
------------------------------------------------------------------------*/

int
rd_text_output_analysis_group_rec(fid,group)
     FILE *fid;
     struct text_output_analysis_group_rec *group;
{
  unsigned int lcv;
  int err;

  if (fread(&(group->num_rois),(size_t) sizeof(group->num_rois),1,fid) != 1)
    return READ_ERROR;
  if (group->num_rois == 0) return NO_ERROR;

  if ((err = get_ptr(&(group->roi_labels),NULL,group->num_rois,
		     (size_t) sizeof(char *))) != NO_ERROR)
    return err;
  for (lcv = 0; lcv < group->num_rois; lcv++)
    group->roi_labels[lcv] = NULL;

  if ((err = rd_file_strs(fid,group->roi_labels,group->num_rois)) != NO_ERROR)
    return err;

  if (fread(&(group->num_pixel_types),
	    (size_t) sizeof(group->num_pixel_types),1,fid) != 1) return READ_ERROR;
  if (group->num_pixel_types == 0) return NO_ERROR;
  if ((err = get_ptr(&(group->pixel_type_labels),NULL,group->num_pixel_types,
		     (size_t) sizeof(char *))) != NO_ERROR)
    return err;
  for (lcv = 0; lcv < group->num_pixel_types; lcv++)
    group->pixel_type_labels[lcv] = NULL;

  if ((err = rd_file_strs(fid,group->pixel_type_labels,group->num_pixel_types))
      != NO_ERROR) return READ_ERROR;
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_input_text_file_format - ???
------------------------------------------------------------------------*/

int
rd_input_text_file_format(fid,groups,num_groups)
     FILE *fid;
     struct text_output_analysis_group_rec **groups;
     unsigned int *num_groups;
{
  unsigned int lcv;
  int err;

  TRACE(printf("rd_input_text_file_format...begin\n"));
  if (fread(num_groups,(size_t) sizeof(*num_groups),1,fid) != 1)
  {
    *num_groups = 0;
    *groups = NULL;
    return READ_ERROR;
  }
  if (*num_groups <= 0)
  {
    *groups = NULL;
    return NO_ERROR;
  }
  TRACE(printf("rd_input_text_file_format...*num_groups = %d\n",*num_groups));

  if ((err = get_ptr(groups,NULL,(unsigned int) *num_groups,
		     (size_t) sizeof(struct text_output_analysis_group_rec))) != NO_ERROR)
  {
    *num_groups = 0;
    return err;
  }

  for (lcv = 0; lcv < *num_groups; lcv++)
    init_text_output_analysis_group_rec(&((*groups)[lcv]));

  for (lcv = 0; lcv < *num_groups; lcv++)
    if ((err = rd_text_output_analysis_group_rec(fid,&((*groups)[lcv])))
	!= NO_ERROR)
      return err;

  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_output_field_rec - ???
------------------------------------------------------------------------*/

int
rd_output_field_rec(fid,group)
     FILE *fid;
     struct output_field_rec *group;
{
  int err;

  TRACE(printf("rd_output_field_rec...begin\n"));
  if ((fread(&(group->pixel_type_indx),(size_t) sizeof(group->pixel_type_indx),
	     1,fid) != 1) ||
      (fread(&(group->num_roi_indxs),(size_t) sizeof(group->num_roi_indxs),
	     1,fid) != 1))
  {
    group->num_roi_indxs = 0;
    return READ_ERROR;
  }

  TRACE(printf("group->pixel_type_indx = %d group->num_roi_indxs = %d\n",
	       group->pixel_type_indx,group->num_roi_indxs));
  if (group->num_roi_indxs > 0)
  {
    if ((err = get_ptr(&(group->roi_indxs),NULL,group->num_roi_indxs,
		       (size_t) sizeof(*(group->roi_indxs)))) != NO_ERROR)
    {
      group->num_roi_indxs = 0;
      return err;
    }
    if (fread(group->roi_indxs,(size_t) sizeof(*(group->roi_indxs)) *
	      group->num_roi_indxs,1,fid) != 1)
      return READ_ERROR;
  }
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_output_count_field_rec - ???
------------------------------------------------------------------------*/

int
rd_output_count_field_rec(fid,group)
     FILE *fid;
     struct output_count_field_rec *group;
{
  int err;

  if (fread(&(group->num_fields),(size_t) sizeof(group->num_fields),1,fid) != 1)
  {
    group->num_fields = 0;
    return READ_ERROR;
  }
  if (group->num_fields > 0)
  {
    if ((err = get_ptr(&(group->fields),NULL,group->num_fields,
		       (size_t) sizeof(*(group->fields)))) != NO_ERROR)
    {
      group->num_fields = 0;
      return err;
    }
    if (fread(group->fields,(size_t) sizeof(*(group->fields)) *
              group->num_fields,1,fid) != 1)
      return READ_ERROR;
  }
  return NO_ERROR;

}



/*------------------------------------------------------------------------
rd_output_count_group_rec - ???
------------------------------------------------------------------------*/

int
rd_output_count_group_rec(fid,count)
     FILE *fid;
     struct output_count_group_rec *count;
{
  unsigned int lcv;
  int err;

  if (fread(&(count->num_groups),(size_t) sizeof(count->num_groups),1,fid) != 1)
  {
    count->num_groups = 0;
    return READ_ERROR;
  }
  if (count->num_groups > 0)
  {
    if ((err = get_ptr(&(count->groups),NULL,count->num_groups,
		       (size_t) sizeof(*(count->groups)))) != NO_ERROR)
    {
      count->num_groups = 0;
      return err;
    }
    for (lcv = 0; lcv < count->num_groups; lcv++)
      if ((err = rd_output_count_field_rec(fid,&(count->groups[lcv])))
	  != NO_ERROR)
	return err;
  }
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_output_text_file_format - ???
------------------------------------------------------------------------*/

int
rd_output_text_file_format(fid,format)
     FILE *fid;
     struct output_text_format_rec *format;
{
  unsigned int lcv;
  int err;

  TRACE(printf("rd_output_text_file_format...begin\n"));
  if (fread(&(format->status),(size_t) sizeof(format->status),1,fid) != 1)
    return READ_ERROR;
  if (!(format->status & OUT_FORMAT_DEFINED)) 
  {
    TRACE(printf("rd !(status & OUT_FORMAT_DEFINED)\n"));
    free_output_text_format_rec(format);
    return NO_ERROR;
  }
  if ((err = rd_strs_rec(fid,&(format->roi_labels))) != NO_ERROR)
    return err;

  if (format->roi_labels.num_strs > 0)
  {
    if ((err = get_ptr(&(format->roi_nums),NULL,format->roi_labels.num_strs,
		       (size_t) sizeof(*(format->roi_nums)))) != NO_ERROR)
      return err;
    if (fread(format->roi_nums,(size_t) sizeof(*(format->roi_nums)) *
	      format->roi_labels.num_strs,1,fid) != 1)
      return READ_ERROR;
  }

  if ((err = rd_strs_rec(fid,&(format->pixel_type_labels))) != NO_ERROR)
    return err;
  if (format->pixel_type_labels.num_strs > 0)
  {
    if ((err = get_ptr(&(format->pixel_type_nums),NULL,
		       format->pixel_type_labels.num_strs,
		       (size_t) sizeof(*(format->pixel_type_nums))))
	!= NO_ERROR)
      return err;
    if (fread(format->pixel_type_nums,(size_t)
	      sizeof(*(format->pixel_type_nums)) *
	      format->pixel_type_labels.num_strs,1,fid) != 1)
      return READ_ERROR;
  }

  if (fread(&(format->num_groups),
	    (size_t) sizeof(format->num_groups),1,fid) != 1)
    return READ_ERROR;

  if (format->num_groups > 0)
  {
    if ((err = get_ptr(&(format->groups),NULL,format->num_groups,
		       (size_t) sizeof(*(format->groups)))) != NO_ERROR)
    {
      format->num_groups = 0;
      return err;
    }
    for (lcv = 0; lcv < format->num_groups; lcv++)
      if ((err = rd_output_field_rec(fid,&(format->groups[lcv])))
	  != NO_ERROR)
	return err;
  }

  if (fread(&(format->num_slices),(size_t) sizeof(format->num_slices),
	    1,fid) != 1)
    return READ_ERROR;
  if (format->num_slices > 0)
  {
    if ((err = get_ptr(&(format->counts),NULL,format->num_slices,
		       (size_t) sizeof(*(format->counts)))) != NO_ERROR)
    {
      format->num_slices = 0;
      return err;
    }
    for (lcv = 0; lcv < format->num_slices; lcv++)
      if ((err = rd_output_count_group_rec(fid,&(format->counts[lcv])))
	  != NO_ERROR)
	return err;
  }

  if ((fread(&(format->page_num_rows),(size_t) sizeof(format->page_num_rows),
	     1,fid) != 1) ||
      (fread(&(format->page_row_size),(size_t) sizeof(format->page_row_size),
	     1,fid) != 1) ||
      (fread(&(format->num_field_spaces),
	     sizeof(format->num_field_spaces),1,fid) != 1) ||
      (fread(&(format->num_collect_spaces),
	     sizeof(format->num_collect_spaces),1,fid) != 1) ||
      (fread(&(format->xpixel_size),(size_t) sizeof(format->xpixel_size),1,fid)
       != 1) ||
      (fread(&(format->ypixel_size),(size_t) sizeof(format->ypixel_size),1,fid)
       != 1) ||
      (fread(&(format->pixel_thickness),
	     sizeof(format->pixel_thickness),1,fid) != 1) ||
      (fread(&(format->voxel_size),(size_t) sizeof(format->voxel_size),1,fid)
       != 1))
    return READ_ERROR;

  if (format->status & OUT_FORMAT_LT_PERCENT_MEAN)
  {
    PRT5(printf("OUT_FORMAT_LT_PERCENT_MEAN...\n"));
    if (fread(&(format->lt_percent),
	      (size_t) sizeof(format->lt_percent),1,fid) != 1)
      return READ_ERROR;
  }
  if (format->status & OUT_FORMAT_GT_PERCENT_MEAN)
  {
    PRT5(printf("OUT_FORMAT_GT_PERCENT_MEAN...\n"));
    if (fread(&(format->gt_percent),
	      (size_t) sizeof(format->gt_percent),1,fid) != 1)
      return READ_ERROR;
  }
  if (format->status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
  {
    PRT5(printf("OUT_FORMAT_LT_PERCENT_ROI_MEAN...\n"));
    if (fread(&(format->roi_lt_percent),
	      (size_t) sizeof(format->roi_lt_percent),1,fid) != 1)
      return READ_ERROR;
  }
  if (format->status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
  {
    PRT5(printf("OUT_FORMAT_GT_PERCENT_ROI_MEAN...\n"));
    if (fread(&(format->roi_gt_percent),
	      (size_t) sizeof(format->roi_gt_percent),1,fid) != 1)
      return READ_ERROR;
  }

  if (!(format->status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
      (format->status & OUT_FORMAT_UNIT_2D_VALID))
  {
    PRT5(printf("OUT_FORMAT_UNIT_2D_VALID...\n"));
    if (fread(&(format->img_unit),
	      (size_t) sizeof(format->img_unit),1,fid) != 1)
      return READ_ERROR;
  }
  TRACE(printf("rd_output_text_file_format...end\n"));
  return NO_ERROR;
}


/*
   old struct roi_count_anal_rec
   {
     char *label;
     long min,max;
     unsigned long num_pixels;
     double total_counts,sd;
   };
   */


/*------------------------------------------------------------------------
rd_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

int
rd_roi_count_anal_rec(fid,roi,is_new_format)
     FILE *fid;
     struct roi_count_anal_rec *roi;
{
  int err;
  long min,max;

  PRT5(printf("rd_roi_count_anal_rec...\n"));
  if ((err = rd_file_strs(fid,&(roi->label),1)) != NO_ERROR)
    return err;
  if (!is_new_format)
  {
    if ((fread(&min,(size_t) sizeof(min),1,fid) != 1) ||
	(fread(&max,(size_t) sizeof(max),1,fid) != 1))
      return READ_ERROR;
    roi->min = min;
    roi->max = max;
  }
  else
  {
    if ((fread(&(roi->status2),(size_t) sizeof(roi->status2),1,fid) != 1) ||
	(fread(&(roi->min),(size_t) sizeof(roi->min),1,fid) != 1) ||
	(fread(&(roi->max),(size_t) sizeof(roi->max),1,fid) != 1))
      return READ_ERROR;
  }
  if ((fread(&(roi->num_pixels),(size_t) sizeof(roi->num_pixels),1,fid) != 1) ||
      (fread(&(roi->total_counts),(size_t) sizeof(roi->total_counts),1,fid) != 1) ||
      (fread(&(roi->sd),(size_t) sizeof(roi->sd),1,fid) != 1))
    return READ_ERROR;

  if (is_new_format)
    if ((fread(&(roi->cnt_neg_val),
	       (size_t) sizeof(roi->cnt_neg_val),1,fid) != 1) ||
        (fread(&(roi->cnt_smean_min_rej),
	       (size_t) sizeof(roi->cnt_smean_min_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_smean_max_rej),
	       (size_t) sizeof(roi->cnt_smean_max_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_rmean_min_rej),
	       (size_t) sizeof(roi->cnt_rmean_min_rej),1,fid) != 1) ||
        (fread(&(roi->cnt_rmean_max_rej),
	       (size_t) sizeof(roi->cnt_rmean_max_rej),1,fid) != 1) ||
        (fread(&(roi->slice_mean),(size_t) sizeof(roi->slice_mean),1,fid) != 1) ||
        (fread(&(roi->min_smean_threshold),
	       (size_t) sizeof(roi->min_smean_threshold),1,fid) != 1) ||
        (fread(&(roi->max_smean_threshold),
	       (size_t) sizeof(roi->max_smean_threshold),1,fid) != 1) ||
        (fread(&(roi->roi_mean),(size_t) sizeof(roi->roi_mean),1,fid) != 1) ||
        (fread(&(roi->min_rmean_threshold),
	       (size_t) sizeof(roi->min_rmean_threshold),1,fid) != 1) ||
        (fread(&(roi->max_rmean_threshold),
	       (size_t) sizeof(roi->max_rmean_threshold),1,fid) != 1))
      return READ_ERROR;
  PRT5(pr_roi_count_anal_rec(roi););
  /*
     PRT5(printf("min = %f max = %f num_pixels = %d total_counts = %f sd = %f\n",
     roi->min,roi->max,roi->num_pixels,roi->total_counts,roi->sd));
     */
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

int
rd_slice_count_anal_rec(fid,slice)
     FILE *fid;
     struct slice_count_anal_rec *slice;
{
  int err;
  unsigned long lcv,total,temp;
  int is_new_format;

  PRT5(printf("rd_slice_count_anal_rec...\n"));
  free_slice_count_anal_rec(slice);
  if ((fread(&(slice->status1),(size_t) sizeof(slice->status1),1,fid) != 1) ||
      (fread(&(slice->num_rois),(size_t) sizeof(slice->num_rois),1,fid) != 1))
    return READ_ERROR;
  PRT5(printf("rd_slice_count_anal_rec...1\n"));

  if (slice->num_rois == 0) return NO_ERROR;
  if (slice->num_rois > slice->total_rois)
  {
    total = slice->num_rois - slice->total_rois;
    temp = slice->total_rois;
    if ((err = get_ptr(&(slice->rois),&(slice->total_rois),total,
		       (size_t) sizeof(*(slice->rois)))) != NO_ERROR)
    {
      slice->num_rois = 0;
      return err;
    }
  }
  for (lcv = 0; lcv < slice->num_rois; lcv++)
    init_roi_count_anal_rec(&(slice->rois[lcv]));

  is_new_format = slice->status1 & COUNT_NEW_FORMAT;
  for (lcv = 0; lcv < slice->num_rois; lcv++)
    if ((err = rd_roi_count_anal_rec(fid,&(slice->rois[lcv]),
				     is_new_format)) != NO_ERROR)
      return err;
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_slice_count_anal_recs - ???
------------------------------------------------------------------------*/

int
rd_slice_count_anal_recs(fid,slices,total_slices,num_slices)
     FILE *fid;
     struct slice_count_anal_rec **slices;
     unsigned long *total_slices,*num_slices;
{
  unsigned long lcv,total,temp;
  int err;

  PRT5(printf("rd_slice_count_anal_recs...\n"));
  if (fread(num_slices,(size_t) sizeof(*num_slices),1,fid) != 1)
    return WRITE_ERROR;
  PRT5(printf("*num_slices = %d...*total_slices = %d\n",*num_slices,*total_slices));
  if (*num_slices <= 0) return NO_ERROR;
  if (*num_slices > *total_slices)
  {
    total = *num_slices - *total_slices;
    temp = *total_slices;
    if ((err = get_ptr(slices,total_slices,total,
		       (size_t) sizeof(**(slices)))) != NO_ERROR)
    {
      *num_slices = 0;
      return err;
    }
    for (lcv = temp; lcv < *total_slices; lcv++)
      init_slice_count_anal_rec(&((*slices)[lcv]));
  }

  for (lcv = 0; lcv < *num_slices; lcv++)
    if ((err = rd_slice_count_anal_rec(fid,&((*slices)[lcv]))) != NO_ERROR) 
      return err;
  PRT5(printf("rd_slice_count_anal_recs...end\n"));
  return NO_ERROR;
}



/*------------------------------------------------------------------------
rd_count_analysis_rec - ???
------------------------------------------------------------------------*/

int
rd_count_analysis_rec(fid,count)
     FILE *fid;
     struct count_analysis_rec *count;
{
  int err;
  unsigned long lcv;

  PRT5(printf("rd_count_analysis_rec...\n"));
  if (count == NULL) return NO_ERROR;
  if (((err = rd_input_text_file_format(fid,&(count->groups),
					&(count->num_groups))) != NO_ERROR) ||
      ((err =  rd_output_text_file_format(fid,
					  &(count->format))) != NO_ERROR))
    return err;
  if (count->format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
    if (fread(&(count->echo_num),(size_t) sizeof(count->echo_num),1,fid) != 1)
      return READ_ERROR;

  count->out_format_status = count->format.status;
  if (count->out_format_status & OUT_FORMAT_LT_PERCENT_MEAN)
    count->lt_percent = count->format.lt_percent;
  if (count->out_format_status & OUT_FORMAT_GT_PERCENT_MEAN)
    count->gt_percent = count->format.gt_percent;

  if (count->out_format_status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    count->roi_lt_percent = count->format.roi_lt_percent;
  if (count->out_format_status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    count->roi_gt_percent = count->format.roi_gt_percent;
  if (count->out_format_status & OUT_FORMAT_UNIT_2D_VALID)
    count->img_unit = count->format.img_unit;
  if (count->num_slices > 0)
  {
    for (lcv = 0; lcv < count->num_slices; lcv++)
      free_slice_count_anal_rec(&(count->slices[lcv]));
    count->num_slices = 0;
  }
  PRT5(printf("rd_count_analysis_rec...1\n"));

  return rd_slice_count_anal_recs(fid,&(count->slices),
				  &(count->total_slices),&(count->num_slices));
}



/*------------------------------------------------------------------------
cp_dat_output_hdr_rec - ???
------------------------------------------------------------------------*/

int
cp_dat_output_hdr_rec(hdr,output)
     struct output_hdr_rec *hdr;
     struct output_file_rec *output;
{
  free_output_hdr_rec(&(output->hdr));
  memcpy(&(output->hdr),hdr,(size_t) sizeof(struct output_hdr_rec));
  hdr->info.status |= OUTPUT_HDR_INFO_REC_SETUP;
  return NO_ERROR;
}



/*------------------------------------------------------------------------
cp_dat_slice_roi_recs - ???
------------------------------------------------------------------------*/

int
cp_dat_slice_roi_recs(slice_rois,slice_nums,num_slice_rois,
                      actual_total_slice_rois,file)
     struct slice_roi_rec *slice_rois;
     unsigned int *slice_nums,num_slice_rois,actual_total_slice_rois;
     struct input_file_rec *file;
{
  unsigned long add,temp,lcv;
  int err;

  TRACE(printf("cp_dat_slice_roi_recs max = %d num = %d actual_total_slice_rois = %d\n",
	       file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins,
	       actual_total_slice_rois););

  for (lcv = 0; lcv < file->slice_info.max_sroi_wins; lcv++)
    free_slice_roi_rec(&(file->slice_info.sroi_wins[lcv]->slice_roi));
  if (num_slice_rois == 0) return NO_ERROR;

  if (file->slice_info.max_sroi_wins < actual_total_slice_rois)
  {
    add = actual_total_slice_rois - file->slice_info.max_sroi_wins;
    temp = file->slice_info.max_sroi_wins;
    TRACE(printf("max = %d num = %d add = %d actual_total_slice_rois = %d\n",
		 file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins,
		 add,actual_total_slice_rois));
    if ((err = get_handle(&(file->slice_info.sroi_wins),
			  &(file->slice_info.max_sroi_wins),
			  add,
			  (size_t) sizeof(**(file->slice_info.sroi_wins))))
	!= NO_ERROR)
     return err;
   for (lcv = temp; lcv < file->slice_info.max_sroi_wins; lcv++)
     init_slice_roi_win_rec(file->slice_info.sroi_wins[lcv],
			    file->hdr.data_info.dimx,file->hdr.data_info.dimy);
   AssociateSlicesWithSliceRoiWinRecs(&(file->hdr),
				      file->hdr.scans,file->hdr.num_scans,
				      file->slice_info.sroi_wins,file->slice_info.num_sroi_wins);
 }
  for (lcv = 0; lcv < num_slice_rois; lcv++)
  {              
    if (slice_nums[lcv] < file->slice_info.max_sroi_wins)
    {
      file->slice_info.sroi_wins[slice_nums[lcv]]->slice_roi
	= slice_rois[slice_nums[lcv]];
    }
  }
  /*
     for (lcv = 0; lcv < file->slice_info.max_sroi_wins; lcv++)
     printf("cp_dat_slice_roi_recs out %d) %u num_wins = %d\n",lcv,file->slice_info.sroi_wins[lcv],
     file->slice_info.sroi_wins[lcv]->num_wins);
     */
  TRACE(printf("cp_dat_slice_roi_recs...end\n"));
  return NO_ERROR;

}



/*------------------------------------------------------------------------
cp_nth_slice_roi_rec - ???
------------------------------------------------------------------------*/

int
cp_nth_slice_roi_rec(slice_rois,slice_nums,num_slice_rois,file,slice_num)
     struct slice_roi_rec *slice_rois;
     unsigned int *slice_nums,num_slice_rois;
     struct input_file_rec *file;
     long slice_num;
{
  unsigned int lcv;

  PRT1(printf("cp_nth_slice_roi_rec max = %d num = %d\n",
	      file->slice_info.max_sroi_wins,file->slice_info.num_sroi_wins));

  if (slice_num < file->slice_info.max_sroi_wins)
  {
    free_slice_roi_rec(&(file->slice_info.sroi_wins[slice_num]->slice_roi));
    if (num_slice_rois == 0) return NO_ERROR;
    
    for (lcv = 0; lcv < num_slice_rois; lcv++)
    {              
      if (slice_nums[lcv] == slice_num)
      {
	file->slice_info.sroi_wins[slice_num]->slice_roi =
	  slice_rois[slice_num];
	init_slice_roi_rec(&(slice_rois[slice_num]));
	return NO_ERROR;
      }
    }
  }
  PRT1(printf("cp_nth_slice_roi_rec...end\n"));
  return NO_ERROR;
}



/*------------------------------------------------------------------------
cp_dat_histo_params_rec - ???
------------------------------------------------------------------------*/

int
cp_dat_histo_params_rec(histo,file)
     struct histo_params_rec *histo;
     struct input_file_rec *file;
{
  unsigned int num_wins,num_wins1;
  struct image_display_window **wins,**wins1;
  /*
     printf("histo->bkg.num_bkgs = %d\n",histo->bkg.num_bkgs);
     printf("file->hdr.data_info.num_echoes = %d\n",file->hdr.data_info.num_echoes);
     */
  if (histo->bkg.num_bkgs > 0)
  {
    if (((file->hdr.data_info.num_echoes == 1) && 
	 (file->hdr.data_info.num_echoes != histo->bkg.num_bkgs)) ||
	((file->hdr.data_info.num_echoes == 2) && 
	 (histo->bkg.num_bkgs != 4)))
    {
      if (((file->hdr.data_info.num_echoes == 1) &&
	   !(file->histo_params.status2 & HISTO_1D)) ||
	  ((file->hdr.data_info.num_echoes == 2) &&
	   !(file->histo_params.status2 & HISTO_MULTI_D)))
      {
	free_histo_params_rec(histo);
	free_histo_params_rec(&(file->histo_params));
	return NO_ERROR;
      }
      if (file->hdr.data_info.num_echoes == 1) 
	free_histo_pixel_center_rec(histo);
      else
	free_histo_pixel_tissue_type_rec(histo);
      free_histo_bkg_rec(&(histo->bkg));
    }
  }
  /*
     printf("===histo->bkg.num_bkgs = %d\n",histo->bkg.num_bkgs);
     */
  num_wins = file->histo_params.slice_roi_win_2d.num_wins;
  wins = file->histo_params.slice_roi_win_2d.wins;
  num_wins1 = file->histo_params.slice_roi_win_1d.num_wins;
  wins1 = file->histo_params.slice_roi_win_1d.wins;
  file->histo_params.slice_roi_win_2d.num_wins = 0;
  file->histo_params.slice_roi_win_1d.num_wins = 0;
  file->histo_params.slice_roi_win_2d.wins = NULL;
  file->histo_params.slice_roi_win_1d.wins = NULL;

  free_histo_params_rec(&(file->histo_params));

  memcpy(&(file->histo_params),histo,(size_t) sizeof(struct histo_params_rec));
  /*
     printf("===file->histo->bkg.num_bkgs = %d\n",file->histo_params.bkg.num_bkgs);
     */
  file->histo_params.slice_roi_win_2d.num_wins = num_wins;
  file->histo_params.slice_roi_win_2d.wins = wins;
  file->histo_params.slice_roi_win_1d.num_wins = num_wins1;
  file->histo_params.slice_roi_win_1d.wins = wins1;
  file->histo_params.file = file;
  /* file->histo_params.status2 = 
     (unsigned short) file_get_def_histo_type(file); */

  return NO_ERROR;
}



/*------------------------------------------------------------------------
cp_dat_pixel_type_rec - ???
------------------------------------------------------------------------*/

int
cp_dat_pixel_type_rec(pixel_type,file)
     struct pixel_type_rec *pixel_type;
     struct input_file_rec *file;
{
  TRACE(printf("cp_dat_pixel_type_rec...file = %u  pixel_type = %u\n",
	       file,pixel_type));

  free_pixel_type_rec(&(file->pixel_type));
  TRACE(printf("cp_dat_pixel_type_rec...file->pixel_type = %u\n",
	       &(file->pixel_type)));
  memcpy(&(file->pixel_type),pixel_type,
	 (size_t) sizeof(struct pixel_type_rec));
  TRACE(printf("cp_dat_pixel_type_rec...3\n"));

  return NO_ERROR;
}



/*------------------------------------------------------------------------
cp_text_output_analysis_group_rec - ???
------------------------------------------------------------------------*/

int
cp_text_output_analysis_group_rec(groups,num_groups,file)
     struct text_output_analysis_group_rec *groups;
     unsigned int num_groups;
     struct input_file_rec *file;
{
  TRACE(printf("cp_text_output_analysis_group_rec...\n"));
  free_analysis_group_recs(file->text.groups,file->text.num_groups);
  file->text.num_groups = num_groups;
  file->text.groups = groups;
  if (num_groups > 0)
    file->text.status |= TEXT_OUTPUT_FORMAT_SETUP;
  else file->text.status &= ~TEXT_OUTPUT_FORMAT_SETUP;
  TRACE(printf("cp_text_output_analysis_group_rec...end\n"));
  return NO_ERROR;
}



/*------------------------------------------------------------------------
cp_output_text_format_rec - ???
------------------------------------------------------------------------*/

void
cp_output_text_format_rec(format,file)
     struct output_text_format_rec *format;
     struct input_file_rec *file;
{
  free_output_text_format_rec(&(file->text.format));
  TRACE(pr_output_text_format_rec(format););
  file->text.format = *format;
}



/*------------------------------------------------------------------------
cp_count_analysis_rec - ???
------------------------------------------------------------------------*/

void
cp_count_analysis_rec(count,file)
     struct count_analysis_rec *count;
     struct input_file_rec *file;
{
  free_count_analysis_rec(&(file->count));
  file->count = *count;
  file->count.file = file;
}



/*------------------------------------------------------------------------
hdr_error_proc - ???
------------------------------------------------------------------------*/

void
hdr_error_proc()
{
}



/*------------------------------------------------------------------------
RdNdatFields - ???
------------------------------------------------------------------------*/

int
RdNdatFields(fid,hdr,slice_rois,total_slice_rois,histo,pixel_type,
	     groups,num_groups,format,count)
     FILE *fid;
     struct output_hdr_rec *hdr;
     struct slice_roi_rec **slice_rois;
     long *total_slice_rois;
     struct histo_params_rec *histo;
     struct pixel_type_rec *pixel_type;
     struct text_output_analysis_group_rec **groups;
     unsigned int *num_groups;
     struct output_text_format_rec *format;
     struct count_analysis_rec *count;
{
  int err;

  TRACE(printf("RdNdatFields...\n"));
  if ((err = rd_output_hdr_rec(fid,hdr,hdr_error_proc)) != NO_ERROR)
    return err;
  if (slice_rois != NULL)
  {
    fseek(fid,hdr->offset.slice_roi_start,0);
    if ((fread(&(hdr->actual_total_slice_rois),
	       sizeof(hdr->actual_total_slice_rois),1,fid) != 1) ||
	(fread(&(hdr->num_slice_rois),
	       (size_t) sizeof(hdr->num_slice_rois),1,fid) != 1) ||
	((err = rd_output_slice_nums(fid,&(hdr->slice_nums),
				     &(hdr->num_slice_rois))) != NO_ERROR) ||
	((err = rd_output_slice_rois(fid,slice_rois,
				     hdr->actual_total_slice_rois,
				     hdr->slice_nums,hdr->num_slice_rois))
	 != NO_ERROR))
      return err;
    *total_slice_rois = hdr->actual_total_slice_rois;
  }
  TRACE(printf("RdNdatFields...1\n"));
  if ((histo != NULL) && (hdr->offset.histo_params_size > 0))
  {
    fseek(fid,hdr->offset.histo_params_start,0);
    if ((err = rd_histo_params(fid,histo)) != NO_ERROR)
      return err;
  }
  if ((pixel_type != NULL) && (hdr->offset.pixel_type_params_size > 0))
  {
    fseek(fid,hdr->offset.pixel_type_params_start,0);
    if ((err = rd_pixel_type_params(fid,pixel_type)) != NO_ERROR)
      return err;
  }
  TRACE(printf("RdNdatFields...text_format_start = %d text_format_size = %d\n",hdr->offset.text_format_start,
	       hdr->offset.text_format_size));
  if ((format != NULL) && (hdr->offset.text_format_size > 0))
  {
    fseek(fid,hdr->offset.text_format_start,0);
    if ((err = rd_input_text_file_format(fid,groups,num_groups)) !=
	NO_ERROR)
      return err;
    if ((err = rd_output_text_file_format(fid,format)) != NO_ERROR)
      return err;
  }

  PRT5(printf("RdNdatFields...count_start = %d count_size = %d\n",hdr->offset.count_start,hdr->offset.count_size));
  if ((count != NULL) && (hdr->offset.count_size > 0))
  {
    fseek(fid,hdr->offset.count_start,0);
    if ((err = rd_count_analysis_rec(fid,count)) != NO_ERROR)
      return err;
  }

  TRACE(printf("RdNdatFields...err = %d\n",err));
  return NO_ERROR;
}



/*------------------------------------------------------------------------
free_ndat_fields - ???
------------------------------------------------------------------------*/

void
free_ndat_fields(hdr,slice_rois,total_slice_rois,histo,pixel_type,
		 groups,num_groups,format,count)
     struct output_hdr_rec *hdr;
     struct slice_roi_rec *slice_rois;
     long total_slice_rois;
     struct histo_params_rec *histo;
     struct pixel_type_rec *pixel_type;
     struct text_output_analysis_group_rec *groups;
     unsigned int num_groups;
     struct output_text_format_rec *format;
     struct count_analysis_rec *count;
{
  unsigned long lcv;

  if (hdr != NULL) free_output_hdr_rec(hdr);
  if (slice_rois != NULL)
  {
    for (lcv = 0; lcv < total_slice_rois; lcv++)
      free_slice_roi_rec(&(slice_rois[lcv]));
    c_free(slice_rois);
  }
  if (histo != NULL)
    free_histo_params_rec(histo);
  if (pixel_type != NULL)
    free_pixel_type_rec(pixel_type);
  if (groups != NULL)
  {
    free_analysis_group_recs(groups,num_groups);
    c_free(groups);
  }
  if (format != NULL)
    free_output_text_format_rec(format);
  if (count != NULL)
    free_count_analysis_rec(count);
}



/*------------------------------------------------------------------------
RdTheNdatFields - ???
------------------------------------------------------------------------*/

int
RdTheNdatFields(fn,hdr,slice_rois,total_slice_rois,histo,pixel_type,
		groups,num_groups,format,count)
     char *fn;
     struct output_hdr_rec *hdr;
     struct slice_roi_rec **slice_rois;
     long *total_slice_rois;
     struct histo_params_rec *histo;
     struct pixel_type_rec *pixel_type;
     struct text_output_analysis_group_rec **groups;
     unsigned int *num_groups;
     struct output_text_format_rec *format;
     struct count_analysis_rec *count;
{
  FILE *fid;
  int err;

  TRACE(printf("RdTheNdatFields...\n"));
  init_output_hdr_rec(hdr);
  if (slice_rois != NULL)
  {
    *total_slice_rois = 0;
    *slice_rois = NULL;
  }
  if (histo != NULL) init_histo_params_rec(histo,NULL);
  if (pixel_type != NULL) init_pixel_type_rec(pixel_type);
  if (format != NULL)
  {
    *num_groups = 0;
    *groups = NULL;
    init_output_text_format_rec(format);
  }

  if (count != NULL) init_count_analysis_rec(count,NULL);

  TRACE(printf("RdTheNdatFields...fn = %s\n",fn));
  if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
  TRACE(printf("RdTheNdatFields...1\n"));
  fseek(fid,0,0);
  err = RdNdatFields(fid,hdr,slice_rois,total_slice_rois,
		     histo,pixel_type,groups,num_groups,format,count);
  TRACE(printf("RdTheNdatFields...err = %d...end\n",err));
  fclose(fid);
  return err;
}



/*------------------------------------------------------------------------
rd_dat_file - ???
------------------------------------------------------------------------*/

int
rd_dat_file(fn,output)
     char *fn;
     struct output_file_rec *output;
{
  struct output_hdr_rec hdr;
  int err;
  struct slice_roi_rec *slice_rois;
  struct histo_params_rec histo;
  struct pixel_type_rec pixel_type;
  struct text_output_analysis_group_rec *groups;
  unsigned int num_groups,lcv,total_slice_rois;
  struct output_text_format_rec format;
  struct count_analysis_rec count;

  TRACE(printf("rd_dat_file...\n"));
  if (((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
			      &histo,&pixel_type,&groups,
			      &num_groups,&format,&count)) != NO_ERROR) ||
      ((err = cp_dat_slice_roi_recs(slice_rois,hdr.slice_nums,
				    hdr.num_slice_rois,
				    hdr.actual_total_slice_rois,output->file))
       != NO_ERROR))
  {
    TRACE(printf("slice_rois = %d...actual_total_slice_rois = %d\n",
		 slice_rois,hdr.actual_total_slice_rois));
    if (slice_rois != NULL)
    {
      TRACE(printf("rd_dat_file free slice_rois\n"));
      for (lcv = 0; lcv < hdr.actual_total_slice_rois; lcv++)
	free_slice_roi_rec(&(slice_rois[lcv]));
      c_free(slice_rois);
    }

    free_output_hdr_rec(&hdr);
    free_histo_params_rec(&histo);
    TRACE(printf("free_pixel_type_rec...begin\n"));

    free_pixel_type_rec(&pixel_type);
    TRACE(printf("...begin num_groups = %d\n",num_groups));
    for (lcv = 0; lcv < num_groups; lcv++)
      free_text_output_analysis_group_rec(&(groups[lcv]));
    c_free(groups);
    free_output_text_format_rec(&format);
    free_count_analysis_rec(&count);
  }
  else
  {
    TRACE(printf("cp_dat_output_hdr_rec...\n"));
    cp_dat_output_hdr_rec(&hdr,output);
    TRACE(printf("cp_dat_slice_roi_recs...\n"));
    TRACE(printf("cp_dat_histo_params_rec...\n"));
    c_free(slice_rois);
    cp_dat_histo_params_rec(&histo,output->file);
    TRACE(printf("cp_dat_pixel_type_rec...\n"));
    cp_dat_pixel_type_rec(&pixel_type,output->file);
    TRACE(printf("cp_text_output_analysis_group_rec...\n"));
    cp_text_output_analysis_group_rec(groups,num_groups,output->file);
    TRACE(printf("cp_output_text_format_rec...\n"));
    cp_output_text_format_rec(&format,output->file);
    TRACE(printf("cp_output_text_format_rec...end\n"));
    cp_count_analysis_rec(&count,output->file);
    TRACE(printf("cp_count_analysis_rec...end\n"));
  }

  TRACE(printf("rd_dat_file...end err = %d\n",err));
  return err;
}



/*------------------------------------------------------------------------
rd_dat_file_slice_rois - ???
------------------------------------------------------------------------*/

int
rd_dat_file_slice_rois(fn,file)
     char *fn;
     struct input_file_rec *file;
{
  struct output_hdr_rec hdr;
  int err;
  struct slice_roi_rec *slice_rois;
  unsigned int lcv,total_slice_rois;

  if (((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
			      NULL,NULL,NULL,NULL,NULL,NULL)) != NO_ERROR) ||
      ((err = cp_dat_slice_roi_recs(slice_rois,hdr.slice_nums,
				    hdr.num_slice_rois,
				    hdr.actual_total_slice_rois,file))
       != NO_ERROR))
  {
    if (slice_rois != NULL)
    {
      for (lcv = 0; lcv < total_slice_rois; lcv++)
	free_slice_roi_rec(&(slice_rois[lcv]));
    }
  }
  free_output_hdr_rec(&hdr);
  c_free(slice_rois);

  return err;
}



/*------------------------------------------------------------------------
rd_file_slice_roi_rec - ???
------------------------------------------------------------------------*/

int
rd_file_slice_roi_rec(fn,file,slice_num)
     char *fn;
     struct input_file_rec *file;
     long slice_num;
{
  struct output_hdr_rec hdr;
  int err;
  struct slice_roi_rec *slice_rois;
  unsigned int lcv,total_slice_rois;

  PRT1(printf("rd_file_slice_roi_rec...\n"));
  if ((err = RdTheNdatFields(fn,&hdr,&slice_rois,&total_slice_rois,
			     NULL,NULL,NULL,NULL,NULL,NULL)) == NO_ERROR)
    err = cp_nth_slice_roi_rec(slice_rois,hdr.slice_nums,hdr.num_slice_rois,
			       file,slice_num);
  if (slice_rois != NULL)
  {
    for (lcv = 0; lcv < total_slice_rois; lcv++)
      free_slice_roi_rec(&(slice_rois[lcv]));
  }

  free_output_hdr_rec(&hdr);
  c_free(slice_rois);

  return err;
}





#if 0   /******************/
rd_str_value_rec(fid,str_value)
     FILE *fid;
     struct str_value_rec *str_value;
{
  int err;

  if ((err = rd_file_strs(fid,&(str_value->str),1)) != NO_ERROR)
    return err;
  if (fread(&(str_value->value),(size_t) sizeof(str_value->value),1,fid) != 1)
    return READ_ERROR;
  return NO_ERROR;
}

rd_str_value_recs(fid,str_values,num_str_values)
     FILE *fid;
     struct str_value_rec **str_values;
     unsigned long *num_str_values;
{
  unsigned long lcv;
  int err;

  if (fread(num_str_values,(size_t) sizeof(*num_str_values),1,fid) != 1)
    return READ_ERROR;
  if (*num_str_values == 0) return NO_ERROR;

  if ((err = get_ptr(str_values,NULL,*num_str_values,
		     (size_t) sizeof(struct str_value_rec))) != NO_ERROR)
    *num_str_values = 0;
  else
  {
    for (lcv = 0; lcv < *num_str_values; lcv++)
      init_str_value_rec(&((*str_values)[lcv]));
    for (lcv = 0; lcv < *num_str_values; lcv++)
      if ((err = rd_str_value_rec(fid,&((*str_values)[lcv]))) != NO_ERROR)
      {
	free_str_value_rec_ary(*str_values,*num_str_values);
	*str_values = NULL;
	*num_str_values = 0;
	return err;
      }
  }

  return err;
}


/*
 *   might need to compare the current info content with the info to be read
 *   from the input .dat file  in the future
 */

rd_output_hdr_info_rec(fid,info)
     FILE *fid;
     struct output_hdr_info_rec *info;
{
  int err;

  err = READ_ERROR;
  if (((err = rd_file_strs(fid,&(info->dirfn),1)) != NO_ERROR) ||
      ((err = rd_file_strs(fid,&(info->fn),1)) != NO_ERROR) ||
      ((err = rd_file_strs(fid,&(info->hdr_fn_suffix),1)) != NO_ERROR) ||
      ((err = rd_file_strs(fid,&(info->img_fn_suffix),1)) != NO_ERROR) ||
      (fread(&(info->dimx),(size_t) sizeof(info->dimx),1,fid) != 1) ||
      (fread(&(info->dimy),(size_t) sizeof(info->dimy),1,fid) != 1) ||
      (fread(&(info->max_slices),
	     (size_t) sizeof(info->max_slices),1,fid) != 1) ||
      (fread(&(info->pixel_depth_bits),
	     (size_t) sizeof(info->pixel_depth_bits),1,fid) != 1))
    return err;
  TRACE(printf("==> info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
	       info->hdr_fn_suffix,info->img_fn_suffix));
  TRACE(printf("==> info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
	       info->hdr_fn_suffix,info->img_fn_suffix));
  return NO_ERROR;
}

verify_dat_hdr(info,file,hdr_error_proc)
     struct output_hdr_info_rec *info;
     struct input_file_rec *file;
     int (*hdr_error_proc)();
{
  return NO_ERROR;
}
#endif            /*************************/


/*************************************************************************
 *
 *  v3_misc.c
 *
 *************************************************************************/




/*------------------------------------------------------------------------
save_slice_roi_rec - ???
------------------------------------------------------------------------*/

int
save_slice_roi_rec(dir,fn,slice_roi)
 char *dir,*fn;
 struct slice_roi_rec *slice_roi;
{
 char *str;
 struct slice_roi_rec slice_roi1,*slice_roi2;
 FILE *fid;
 int err;

 str = NULL;
 if ((err = concat_strs(&str,3,dir,"/",fn)) == NO_ERROR)
    {slice_roi2 = slice_roi;
/*
     printf("save_slice_roi_rec str = %s\n",str);
*/
     init_slice_roi_rec(&slice_roi1);
     if ((fid = fopen(str,"r")) != NULL)
        {
         if (((err = v3_rd_slice_roi_rec(fid,&slice_roi1)) == NO_ERROR) &&
             ((err = JoinRois(&slice_roi1,slice_roi,0,1.0,1.0,
                    NULL,NULL,NULL)) == NO_ERROR))
            slice_roi2 = &slice_roi1;
         fclose(fid);
        }
     if ((fid = fopen(str,"w")) != NULL)
        {err = v3_wr_slice_roi_rec(fid,slice_roi2);
         fclose(fid);}
/*
     printf("save_slice_roi_rec slice_roi2->num_rois = %d  err = %d\n",
                  slice_roi2->num_rois,err);
*/
     free_slice_roi_rec(&slice_roi1);
    }

 c_free(str);
 return err;
}


/*------------------------------------------------------------------------
Wr2dImage - ???
------------------------------------------------------------------------*/

int
Wr2dImage(fn,_2d,img_label,err_reason,hdr,xpix,ypix,zpix)
 char *fn;
 struct buf_2d_rec *_2d;
 char *img_label,**err_reason;
 struct hdr_rec *hdr;
 float xpix,ypix,zpix;
{
 char *str,*str1;
 FILE *fid;
 int err;
 struct hdr_rec hdr1;
 char **the_labels,*labels[1];
 static unsigned long member_img_label_indxs[] = {0};
 unsigned long type,*indxs;
 struct data_info_rec *info;

 TRACE(printf("Wr2dImage...\n"))
 if (err_reason != NULL) *err_reason = NULL;
 if ((err = concat_strs(&str,2,fn,".info")) != NO_ERROR)
    {if (err_reason != NULL) cp_str(err_reason,"MEMORY ERROR !!!");
     return err;
    }
 if (((err = file_access(str,2,NULL,err_reason)) != NO_ERROR) ||
     ((err = file_access(fn,2,NULL,err_reason)) != NO_ERROR))
    {c_free(str);
     return err;}

 if ((fid = fopen(str,"w")) == NULL) 
    {if (err_reason != NULL) cp_str(err_reason,"FILE ACCESS ERROR !!!");
     c_free(str);
     return FILE_ACCESS_ERROR;}
 clearerr(fid);

 fprintf(fid,"width = %-ld  height = %-ld  depth = %-ld bits\n",
      _2d->dimx,_2d->dimy,_2d->pixel_depth);
 err = ferror(fid);
 fclose(fid);
 if (err != NO_ERROR)
    {if (err_reason != NULL)
        concat_strs(err_reason,2,"WRITE ERROR ON ",str);
     delete_file(str);
     c_free(str);
     return FILE_ACCESS_ERROR;}

 if ((fid = fopen(fn,"w")) == NULL) 
    {if (err_reason != NULL) cp_str(err_reason,"FILE ACCESS ERROR !!!");
     err = FILE_ACCESS_ERROR;}
   else
    {if (fwrite(_2d->buf[0],(size_t) _2d->total_bytes,(size_t) 1,fid) != 1)
        {if (err_reason != NULL)
            concat_strs(err_reason,2,"WRITE ERROR ON ",fn);
         err = WRITE_ERROR;}
     fclose(fid);
     if (err != NO_ERROR) delete_file(fn);
    }
 if (err != NO_ERROR) delete_file(str);
 c_free(str);
 str = str1 = NULL;
 if ((err == NO_ERROR) && (hdr != NULL) &&
     ((err = cp_str(&str,fn)) == NO_ERROR) &&
     ((err = drop_suffix(str)) == NO_ERROR) &&
     ((err = concat_strs(&str1,2,str,".nhdr")) == NO_ERROR))
 {
   init_hdr_rec(&hdr1);
   if ((err = cp_hdr_rec(&hdr1,hdr,1)) == NO_ERROR)
   {
     info = &(hdr1.data_info);
     info->var_use_status &= ~NUM_SCANS_USED;
     info->var_use_status &= ~INPUT_DATA_TYPE;
     type = BufTypeToInputDataType(_2d->status4);
     info->var_use_status |= type;
     info->dimx = _2d->dimx;
     info->dimy = _2d->dimy;
     info->max_scans = 1;
     info->pixel_depth_bits = _2d->pixel_depth;
     info->xpixel_size = xpix;
     info->ypixel_size = ypix;
     info->pixel_thickness = zpix;
     PRT(printf("Wr2dImage xpix = %f ypix = %f zpix = %f\n",
		xpix,ypix,zpix););
     info->spacing = .0;
     info->num_echoes = 1;
     /*MinMax2dValues(_2d,0,(double) .0,(double) .0,
       &(info->min_pixel),&(info->max_pixel));*/
     free_hdr_scan_entry_recs(hdr1.scans,hdr1.num_scans);
     hdr1.num_scans = 0;
     free_hdr_analysis_rec(&(hdr1.analysis));
     indxs = member_img_label_indxs;
     labels[0] = img_label;
     the_labels = labels;
     if (((err = hdr_image_labels(&hdr1,the_labels,indxs)) == NO_ERROR) &&
	 ((err = BuildRiaHdr(&hdr1,0)) == NO_ERROR))
       err = wr_the_hdr(str1,&hdr1);
   }
   free_hdr_rec(&hdr1);
 }
 c_free(str);
 c_free(str1);

 TRACE(printf("Wr2dImage...end\n"))
 return err;
}

#if 0   /************************/
rd_curves(fn,curves,num_curves)
 char *fn;
 struct curve_rec ***curves;
 unsigned long *num_curves;
{
 FILE *fid;
 int err;
 unsigned long lcv,total;

 printf("rd_curves...\n");
 *curves = NULL;
 *num_curves = 0;
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 if (fread(&total,(size_t) sizeof(*num_curves),1,fid) != 1)
    {printf("rd_curves...read err = %d...\n",err);
     fclose(fid);
     return READ_ERROR;
    }

 get_handle_memory(curves,num_curves,(unsigned int) total,
            (size_t) sizeof(struct curve_rec),&err);
 if (err == NO_ERROR)
    {for (lcv = 0; lcv < *num_curves; lcv++)
        init_curve_rec((*curves)[lcv]);
     for (lcv = 0; lcv < *num_curves; lcv++)
        if ((err = rd_curve_rec(fid,(*curves)[lcv])) != NO_ERROR)
           {printf("rd_curves...read err = %d...\n",err);
            break;}
    }
 fclose(fid);
 return err;
}

win_rd_curves(win)
 struct image_display_window *win;
{
 struct curve_rec **curves;
 unsigned long num_curves,lcv;
 struct roi_rec *roi;
 int err;

 printf("rd_curves...win = %u\n",win);
 if ((err = rd_curves("curves.dat",&curves,&num_curves)) != NO_ERROR)
    return err;
 if (win == NULL) return NO_ERROR;
 printf("rd_curves ok...now num_curves = %d %u\n",
            num_curves,win->control.sroi.sroi_win);
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 for (lcv = 0; lcv < num_curves; lcv++)
    {if ((err = append_curve_to_roi_rec(roi,curves[lcv],DRAW_LINE,0,
                  &(win->control.sroi.sroi_win->slice_roi.status))) != 
           NO_ERROR)
       return err;
    }
 if (num_curves > 0) c_free(curves);
 win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
 win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);

 return NO_ERROR;
}

win_rd_curves_pt(win)
 struct image_display_window *win;
{
 struct curve_rec **curves;
 unsigned long num_curves,lcv;
 struct roi_rec *roi;
 int err;

 printf("rd_curves...win = %u\n",win);
 if ((err = rd_curves("curves.dat",&curves,&num_curves)) != NO_ERROR)
    return err;
 if (win == NULL) return NO_ERROR;
 printf("rd_curves ok...now num_curves = %d %u\n",
            num_curves,win->control.sroi.sroi_win);
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 for (lcv = 0; lcv < num_curves; lcv++)
    {if ((err = append_curve_to_roi_rec(roi,curves[lcv],DRAW_POINT,0,
                  &(win->control.sroi.sroi_win->slice_roi.status))) != 
           NO_ERROR)
       return err;
     pr_curve_rec_pts(curves[lcv]);
    }
 if (num_curves > 0) c_free(curves);
 win_execute_proc_to_related_wins(win,win_set_control_pen_type,1,0);
 win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);

 return NO_ERROR;
}

wr_cur_mask(fn,win)
 char *fn;
 struct image_display_window *win;
{
 FILE *fid;
 int err;

 printf("wr_cur_mask...\n");
 if ((fid = fopen(fn,"w")) != NULL)
    {if ((win->data.selection.selected_pixel.status & BUF_DATA_VALID) &&
         (win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d.status & 
                              BUF_DATA_VALID))
        {if ((err = v3_wr_buf_2d_rec(fid,
               &(win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d)
               )) != NO_ERROR)
            printf("wr_cur_mask.DRAW_MASK_PIXEL_SELECTION..write err = %d...\n",err);
           else printf("wr_cur_mask...DRAW_MASK_PIXEL_SELECTION..ok\n");
        }
       else if ((err = v3_wr_buf_2d_rec(fid,
           &(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d))) != NO_ERROR)
        printf("wr_cur_mask...write err = %d...\n",err);
       else printf("wr_cur_mask...ok\n");
     fclose(fid);
    }
   else printf("wr_cur_mask...unable to open the file...\n");

}

win_rd_2d(win)
 struct image_display_window *win;
{
 FILE *fid;
 int err,lcv;
 struct buf_2d_rec _2d;

 init_buf_2d_rec(&_2d);

 if ((err = rd_2d("_2d.dat",&_2d)) != NO_ERROR) exit(err);
 copy_buf_2d_rec_content(&(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d),
               &_2d);
 for (lcv = 0; lcv < win->data.num_draw_masks; lcv++)
    win->data.draw_masks[lcv].paint_status |= PAINTED;
 paint_curves_to_multiple_win(win,
               win->data.draw_masks,win->data.num_draw_masks,0);
 WinCanvas(win,1);
 printf("win_rd_2d...\n");
 free_buf_2d_rec(&_2d);
}

win_wr_2d(win)
 struct image_display_window *win;
{
 wr_2d("_2d.dat",&(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d));
}

wr_curves1(fn,curves,num_curves)
 char *fn;
 struct curve_rec **curves;
 unsigned long num_curves;
{
 FILE *fid;
 int err;
 unsigned long lcv;

 printf("wr_curves...\n");
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 if (fwrite(&num_curves,(size_t) sizeof(num_curves),1,fid) != 1)
    {printf("wr_curves...write err = %d...\n",err);
     fclose(fid);
     return WRITE_ERROR;
    }
 for (lcv = 0; lcv < num_curves; lcv++)
    if ((err = wr_curve_rec(fid,curves[lcv])) != NO_ERROR)
       {printf("wr_curves...write err = %d...\n",err);
        break;}
 fclose(fid);
 return err;
}

win_wr_curves(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;
 int err;

 if (win == NULL) return NO_ERROR;
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 printf("wr_curves...win = %u\n",win);
 if (roi->num_pens > 0)
 if ((err = wr_curves1("curves.dat",roi->pens[0]->curves,
        roi->pens[0]->num_curves)) != NO_ERROR)
    return err;


 return NO_ERROR;
}
#endif        /***********************/



/*************************************************************************
 *
 *  v3_output_opr.c
 *
 *************************************************************************/


/*------------------------------------------------------------------------
init_default_output_hdr_info_rec - ???
------------------------------------------------------------------------*/

int
init_default_output_hdr_info_rec(info,file)
     struct output_hdr_info_rec *info;
     struct input_file_rec *file;
{
  int err;

  if (((err = cp_str(&(info->dirfn),file->dirfn)) != NO_ERROR)
      || ((err = cp_str(&(info->fn),file->fn)) != NO_ERROR)
      || ((err = cp_str(&(info->hdr_fn_suffix),file->hdr_fn_suffix))
	  != NO_ERROR)
      || ((err = cp_str(&(info->img_fn_suffix),file->img_fn_suffix))
	  != NO_ERROR))
  {
    free_output_hdr_info_rec(info);
    return err;
  }
  TRACE(printf("info->dirfn = %s %s %s %s\n",
	       info->dirfn,info->fn,info->hdr_fn_suffix,
	       info->img_fn_suffix));

  info->dimx = file->hdr.data_info.dimx;
  info->dimy = file->hdr.data_info.dimy;
  info->max_slices = file->hdr.data_info.max_scans;
  info->pixel_depth_bits = file->hdr.data_info.pixel_depth_bits;
  info->status |= OUTPUT_HDR_INFO_REC_SETUP;
  return NO_ERROR;
}



/*------------------------------------------------------------------------
init_output_file_rec - ???
------------------------------------------------------------------------*/

void
init_output_file_rec(output,file)
     struct output_file_rec *output;
     struct input_file_rec *file;
{
  output->file = file;
  output->status = FILE_TO_BE_SETUP;
  output->dirfn = NULL;
  output->fn = NULL;
  output->dat_fn_suffix = NULL;
  output->bin_fn_suffix = NULL;
  init_output_hdr_rec(&(output->hdr));
}



/*------------------------------------------------------------------------
setup_output_fn - ???
------------------------------------------------------------------------*/

int
setup_output_fn(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)
     struct output_file_rec *output;
     char *dirfn,*fn;         /* directory fn & fn */
     char *dat_fn_suffix,*bin_fn_suffix;
{
  int err;

  if (((err = str_dealloc_and_cpy(&(output->dirfn),dirfn)) != NO_ERROR) ||
      ((err = str_dealloc_and_cpy(&(output->fn),fn)) != NO_ERROR) ||
      ((err = str_dealloc_and_cpy(&(output->dat_fn_suffix),dat_fn_suffix)) 
       != NO_ERROR))
    err = str_dealloc_and_cpy(&(output->bin_fn_suffix),bin_fn_suffix);
  return err;
}



/*------------------------------------------------------------------------
change_output_fn - ???
------------------------------------------------------------------------*/

int
change_output_fn(output,output_fn,bin_fn_suffix)
     struct output_file_rec *output;
     char *output_fn,*bin_fn_suffix;
{
  char *dirfn,*fn,*suffix;
  int err;

  if ((err = break_fn(output_fn,&dirfn,&fn,&suffix)) != NO_ERROR)
    return err;

  return setup_output_fn(output,dirfn,fn,suffix,bin_fn_suffix);
}



/*------------------------------------------------------------------------
rd_dat_slice_rois - ???
------------------------------------------------------------------------*/

int
rd_dat_slice_rois(output,is_rd_all,slice_num)
     struct output_file_rec *output;
     int is_rd_all;
     long slice_num;
{
  char *fn;
  int err;

  TRACE(printf("rd_dat_slice_rois...\n"));
  if (output->fn == NULL)
  {
    TRACE(printf("No output fn supplied...\n"));
    return FILE_NAME_ERROR;
  }
  if ((err = get_output_fn(output,&fn)) != NO_ERROR)
    return err;
  if (is_rd_all)
    err = rd_dat_file_slice_rois(fn,output->file);
  else
    err = rd_file_slice_roi_rec(fn,output->file,slice_num);
  
  c_free(fn);
  TRACE(printf("rd_dat_slice_rois...end err = %d\n",err));
  return err;
}





/*------------------------------------------------------------------------
close_output_file_rec - ???
------------------------------------------------------------------------*/

void
close_output_file_rec(output)
     struct output_file_rec *output;
{
  TRACE(printf("close_output_file_rec output->dirfn = %s %s %s %s\n",
	       output->dirfn,
	       output->fn,
	       output->dat_fn_suffix,
	       output->bin_fn_suffix));
  c_free(output->dirfn);
  c_free(output->fn);
  c_free(output->dat_fn_suffix);
  c_free(output->bin_fn_suffix);
  TRACE(printf("before free_output_hdr_rec\n"));
  free_output_hdr_rec(&(output->hdr));
  TRACE(printf("after free_output_hdr_rec\n"));
  init_output_file_rec(output,output->file);
  TRACE(printf("close_output_file_rec...done\n"));
}



/*------------------------------------------------------------------------
get_output_fn - ???
------------------------------------------------------------------------*/

int
get_output_fn( output, fn )
     struct output_file_rec *output;
     char **fn;
{
  return build_fn( fn, output->dirfn, output->fn, output->dat_fn_suffix );
}



/*------------------------------------------------------------------------
wr_dat_file - ???
------------------------------------------------------------------------*/

int
wr_dat_file( fn, output )
     char *fn;
     struct output_file_rec *output;
{
  struct output_hdr_rec *hdr;
  struct slice_num_and_roi_rec *slices;
  unsigned long num_slices,lcv,num_sroi_wins;
  int err;
  struct slice_roi_win_rec **sroi_wins;
     
  sroi_wins = output->file->slice_info.sroi_wins;
  num_sroi_wins = output->file->slice_info.num_sroi_wins;
  for (num_slices = 0,lcv = 0; lcv < num_sroi_wins; lcv++)
    if (is_slice_roi_non_empty(&(sroi_wins[lcv]->slice_roi)))
      num_slices += 1;

  if (num_slices == 0)
    slices = NULL;
  else
  {
    lcv = 0;
    if ((err = get_ptr(&slices,&lcv,num_slices,sizeof(*slices))) != NO_ERROR)
      return err;
    for (num_slices = 0,lcv = 0; lcv < num_sroi_wins; lcv++)
    {
      if (is_slice_roi_non_empty(&(sroi_wins[lcv]->slice_roi)))
      {
	slices[num_slices].slice_num = lcv;
	TRACE(printf("%d) sroi_win = %u\n",lcv,sroi_wins[lcv]););
	slices[num_slices++].slice_roi = &(sroi_wins[lcv]->slice_roi);
      }
    }
  }
  TRACE(printf("wr_dat_file...1\n"););
  hdr = &(output->hdr);
  if (output->file->prog != NULL)
    str_dealloc_and_cpy(&(hdr->rater),
			output->file->prog->defaults.whch.rater);
  if (!(hdr->info.status & OUTPUT_HDR_INFO_REC_SETUP))
    err = init_default_output_hdr_info_rec(&(hdr->info), output->file);
  else
    err = NO_ERROR;
  TRACE(printf("wr_dat_file...2\n"););
  if (err == NO_ERROR)
    err = wr_ria_dat_file(fn,hdr,slices,num_slices,
			  output->file->slice_info.num_sroi_wins,
			  &(output->file->histo_params),
			  &(output->file->pixel_type),&(output->file->text),
			  &(output->file->count));
  TRACE(printf("wr_dat_file...1\n"););
  c_free(slices);

  return err;
}


/*------------------------------------------------------------------------
check_file_save - ???
------------------------------------------------------------------------*/

int
check_file_save(output)
     /*
      *  Check to see if the ROI's have changed; if so, we must save.
      *  This includes ROI's on each slice, plus the histogram ROI's
      *    (both 1d and 2d).
      */
     struct output_file_rec *output;
{
  unsigned int lcv;
  struct slice_roi_rec *slice_roi;

  for (lcv = 0; lcv < output->file->hdr.num_scans; lcv++)
  {
    slice_roi =
      &(output->file->hdr.scans[lcv].slice->slice_roi_win->slice_roi);

    if (slice_roi->status & SLICE_ROI_MUST_SAVE)
    {
      output->status |= FILE_CHANGED;
      return NO_ERROR;
    }
  }

  if ((output->file->histo_params.slice_roi_win_1d.slice_roi.status &
       SLICE_ROI_MUST_SAVE) ||
      (output->file->histo_params.slice_roi_win_2d.slice_roi.status &
       SLICE_ROI_MUST_SAVE))
  {
    output->status |= FILE_CHANGED;
  }

  return NO_ERROR;
}




/*------------------------------------------------------------------------
set_dat_file_changed - Signal need to save .ndat file before exiting
------------------------------------------------------------------------*/

void
set_dat_file_changed(file)
     struct input_file_rec *file;
{
  file->output.status |= FILE_CHANGED;
}



/*------------------------------------------------------------------------
set_dat_file_saved - ???
------------------------------------------------------------------------*/

void
set_dat_file_saved( file, is_save )
     struct input_file_rec *file;
     int is_save;
{
  if (is_save)
    file->output.status |= FILE_TO_BE_SAVED;
  else
    file->output.status &= ~FILE_TO_BE_SAVED;
}



/*------------------------------------------------------------------------
flush_output_save_status - Clear all ".ndat to be saved" flags
------------------------------------------------------------------------*/

void
flush_output_save_status( output )
     struct output_file_rec *output;
{
  unsigned int lcv;
  struct slice_roi_win_rec *slice_roi_win;

  for (lcv = 0; lcv < output->file->hdr.num_scans; lcv++)
    output->file->hdr.scans[lcv].slice->slice_roi_win->slice_roi.status &=
      ~SLICE_ROI_MUST_SAVE;
  output->file->histo_params.slice_roi_win_1d.slice_roi.status
    &= ~SLICE_ROI_MUST_SAVE;
  output->file->histo_params.slice_roi_win_2d.slice_roi.status
    &= ~SLICE_ROI_MUST_SAVE;
  slice_roi_win->slice_roi.status &= ~SLICE_ROI_MUST_SAVE;
  output->status &= ~FILE_TO_BE_SAVED;
  output->status &= ~FILE_CHANGED;
}



#if 0    /******************/
/*
 *  Seems to have been obsoleted by WrDatOutput
 */
int
wr_file_dat_output( file, is_quit_file )
     struct input_file_rec *file;
     int is_quit_file;
{
  int err;
  char *fn,*reason;
  Frame *frame;
  
  if (file == NULL)
    return CANCEL;
  get_output_fn(&(file->output),&fn);
  if ((err = file_access(fn,2,NULL,&reason)) != NO_ERROR)
  {
    frame = (Frame *) main_display(2,NULL,0,0);
    ShowMsgStrs(*frame,0,err,0,2,
		"Error writing to the .dat file !!!",
		reason,NULL,0);
  }
  else if ((err = AutoSaveDatOutput(&(file->output),is_quit_file)) != NO_ERROR)
  {
    frame = (Frame *) main_display(2,NULL,0,0);
    ShowMsgStrs(*frame,0,err,0,2,
		"Error writing to the .dat file !!!",
		fn,NULL,0);
  }
  c_free(fn);
  c_free(reason);
  return err;
}

/*
 *  Seems to be old version
 */
int
WrDatOutput(output)
     struct output_file_rec *output;
{
  char *fn;
  int err;

  TRACE(printf("WrDatOutput...output->status = %x\n",(int) output->status));

  if ((err = get_output_fn(output,&fn)) == NO_ERROR)
  {
    if ((err = wr_dat_file(fn,output)) == NO_ERROR)
      output->status |= FILE_READY;
  }
  else
  {
    TRACE(printf("No output fn supplied...\n"));
    c_free(fn);
    return err;
  }

  c_free(fn);
  TRACE(printf("WrDatOutput...end err = %d\n",err));

  return err;
}
#endif           /*******************/




/*************************************************************************
 *
 *  v3_rd_wr_pixmap.c
 *
 *************************************************************************/



/*------------------------------------------------------------------------
init_pixmap_hdr_rec - ???
------------------------------------------------------------------------*/

void
init_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 hdr->id = NULL;
 hdr->status = 0;
 init_strs_rec(&(hdr->order));
 hdr->max_slices = 0;
 hdr->pixmap_start = 0;
 hdr->pixmap_offsets = NULL;
 hdr->num_pixmaps = 0;
}


/*------------------------------------------------------------------------
free_pixmap_hdr_rec - ???
------------------------------------------------------------------------*/

void
free_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 c_free(hdr->id);
 free_strs_rec(&(hdr->order));
 c_free(hdr->pixmap_offsets);
 init_pixmap_hdr_rec(hdr);
}


/*------------------------------------------------------------------------
pr_pixmap_hdr_rec - ???
------------------------------------------------------------------------*/

void
pr_pixmap_hdr_rec(hdr)
 struct pixmap_hdr_rec *hdr;
{
 unsigned long lcv;

 printf("\npr_pixmap_hdr_rec id = %s  status = %lx\n",
           hdr->id,(unsigned long) hdr->status);
 pr_strs_rec(&(hdr->order));
 printf("   dimx = %ld  dimy = %ld  max_slice = %ld num_pixmaps = %ld\n",
     hdr->dimx,hdr->dimy,hdr->max_slices,hdr->num_pixmaps);
 printf("hdr->pixmap_start = %ld\n",hdr->pixmap_start);
 for (lcv = 0; lcv < hdr->max_slices; lcv++)
    {printf("%ld) %ld   ",lcv,hdr->pixmap_offsets[lcv]);
     if (lcv == 10) printf("\n");
    }
 printf("pr_pixmap_hdr_rec end\n");
}


/*------------------------------------------------------------------------
RdPixmapHdr - ???
------------------------------------------------------------------------*/

int
RdPixmapHdr(fn,hdr)
 char *fn;
 struct pixmap_hdr_rec *hdr;
{
 FILE *fid;
 int err;

 free_pixmap_hdr_rec(hdr);
 TRACE(printf("RdPixmapHdr...fn = %s\n",fn))
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 if (((err = rd_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = rd_strs_rec(fid,&(hdr->order))) == NO_ERROR))
    {TRACE(printf("RdPixmapHdr...1\n"))
     if ((fread(&(hdr->status),(size_t) sizeof(hdr->status),1,fid) != 1) ||
        (fread(&(hdr->dimx),(size_t) sizeof(hdr->dimx),1,fid) != 1) ||
        (fread(&(hdr->dimy),(size_t) sizeof(hdr->dimy),1,fid) != 1) ||
        (fread(&(hdr->max_slices),(size_t) sizeof(hdr->max_slices),1,fid) != 1) ||
        (fread(&(hdr->num_pixmaps),(size_t) sizeof(hdr->num_pixmaps),1,fid) != 1) ||
        (fread(&(hdr->pixmap_start),(size_t) sizeof(hdr->pixmap_start),1,fid) != 1))
       {err = READ_ERROR;}
      else if ((err = get_ptr(&(hdr->pixmap_offsets),NULL,hdr->max_slices,
                 (size_t) sizeof(*(hdr->pixmap_offsets)))) == NO_ERROR)
              {TRACE(printf("RdPixmapHdr...2\n"))
               if (fread(hdr->pixmap_offsets,
                 (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets)),1,fid) != 1)
                 {err = READ_ERROR;}
              }
    }         
 TRACE(pr_pixmap_hdr_rec(hdr))
 TRACE(printf("RdPixmapHdr...err = %d\n",err))
 if (err != NO_ERROR)
    free_pixmap_hdr_rec(hdr);
   else
    {TRACE(for (lcv = 0; lcv < hdr->max_slices; lcv++)
              printf("%d) off = %d\n", lcv,hdr->pixmap_offsets[lcv]);
          )
    }
 fclose(fid);
 return err;
}


/*------------------------------------------------------------------------
RdThePixmapHdr - ???
------------------------------------------------------------------------*/

int
RdThePixmapHdr(dir,fn,suffix,pixmap_hdr)
 char *dir,*fn,*suffix;
 struct pixmap_hdr_rec *pixmap_hdr;
{
 int err;
 char *fn1;

 fn1 = NULL;
 if ((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR)
    if (access(fn1,F_OK) != 0)
       {err = FILE_NOT_EXIST;}
      else
       {
        err = RdPixmapHdr(fn1,pixmap_hdr);
       }
 c_free(fn1);
 return err;
}


/*------------------------------------------------------------------------
rd_pixmap_slices - ???
------------------------------------------------------------------------*/

int
rd_pixmap_slices(fn,hdr,slice_maps,num_slice_maps)
 char *fn;
 struct pixmap_hdr_rec *hdr;
 struct buf_2d_rec **slice_maps;
 unsigned long num_slice_maps;
{
 FILE *fid;
 int err=0;
 long lcv,max_slices;

 if ((fid = fopen(fn,"r")) == NULL) err = FILE_ACCESS_ERROR;
 if (num_slice_maps < hdr->max_slices)
    max_slices = num_slice_maps;
   else max_slices = hdr->max_slices;
 TRACE(printf("rd_pixmap_slices...max_slices = %d\n",max_slices))
 for (lcv = 0; lcv < max_slices; lcv++)
    {if (hdr->pixmap_offsets[lcv])
        {
         fseek(fid,hdr->pixmap_offsets[lcv],0);
         TRACE(printf("rd %d) off = %d\n",
                      lcv,hdr->pixmap_offsets[lcv]))

         if ((err = v3_rd_buf_2d_rec(fid,slice_maps[lcv])) != NO_ERROR)
            {free_buf_2d_rec(slice_maps[lcv]);
             break;}
        }
    }
 fclose(fid);
 TRACE(printf("rd_pixmap_slices...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
rd_pixmap_for_slice_num - ???
------------------------------------------------------------------------*/

int
rd_pixmap_for_slice_num(fn,hdr,slice_map,slice_num)
 char *fn;
 struct pixmap_hdr_rec *hdr;
 struct buf_2d_rec *slice_map;
 int slice_num;
{
 int err;
 FILE *fid;

 PRT(printf("rd_pixmap_for_slice_num..slice_num = %d\n",slice_num))
 if (slice_num >= hdr->max_slices) return NOT_FOUND;
 if (hdr->pixmap_offsets[slice_num] == 0) return NOT_FOUND;
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 PRT(printf("rd_pixmap_for_slice_num..2\n"))
 free_buf_2d_rec(slice_map);
 fseek(fid,hdr->pixmap_offsets[slice_num],0);
 if ((err = v3_rd_buf_2d_rec(fid,slice_map)) != NO_ERROR)
    free_buf_2d_rec(slice_map);
 fclose(fid);
 PRT(printf("rd_pixmap_for_slice_num..err = %d slice_map...\n",err))
 PRT(pr_buf_2d_rec(slice_map))
 return err;
}


/*------------------------------------------------------------------------
wr_updated_pixmap_params - ???
------------------------------------------------------------------------*/

int
wr_updated_pixmap_params(fid,hdr)
 FILE *fid;
 struct pixmap_hdr_rec *hdr;
{
 unsigned long size;
 int err;

 fflush(fid);
 fseek(fid,hdr->pixmap_start - sizeof(hdr->num_pixmaps) -
            sizeof(hdr->pixmap_start),0);
 if (fwrite(&(hdr->num_pixmaps),(size_t) sizeof(hdr->num_pixmaps),1,fid) != 1)
    err = WRITE_ERROR;
   else
    {size = (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets));
     fflush(fid);
     fseek(fid,hdr->pixmap_start,0);
     if (fwrite(hdr->pixmap_offsets,size,1,fid) != 1)
        err = WRITE_ERROR;
       else err = NO_ERROR;
    }
 return err;
}


/*------------------------------------------------------------------------
wr_pixmap_hdr - ???
------------------------------------------------------------------------*/

int
wr_pixmap_hdr(fn,hdr)
 char *fn;
 struct pixmap_hdr_rec *hdr;
{
 FILE *fid;
 int err;

 TRACE(printf("wr_pixmap_hdr...0\n"))
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 if (((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_strs_rec(fid,&(hdr->order))) == NO_ERROR))
    if ((fwrite(&(hdr->status),(size_t) sizeof(hdr->status),1,fid) != 1) ||
        (fwrite(&(hdr->dimx),(size_t) sizeof(hdr->dimx),1,fid) != 1) ||
        (fwrite(&(hdr->dimy),(size_t) sizeof(hdr->dimy),1,fid) != 1) ||
        (fwrite(&(hdr->max_slices),(size_t) sizeof(hdr->max_slices),1,fid) != 1) ||
        (fwrite(&(hdr->num_pixmaps),(size_t)
                      sizeof(hdr->num_pixmaps),1,fid) != 1))
       err = WRITE_ERROR;
      else
       {fflush(fid);
        TRACE(printf("wr_pixmap_hdr...1\n"))
        hdr->pixmap_start = ftell(fid) + sizeof(hdr->pixmap_start);
        if ((fwrite(&(hdr->pixmap_start),
                 (size_t) sizeof(hdr->pixmap_start),1,fid) != 1) ||
            (fwrite(hdr->pixmap_offsets,
                 (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets)),1,fid) != 1))
           {err = WRITE_ERROR;}
        TRACE(printf("wr_pixmap_hdr...err = %d\n",err))
       }
 fclose(fid);
 TRACE(printf("wr_pixmap_hdr..1.err = %d\n",err))
 if (err != NO_ERROR) delete_file(fn);
 return err;
}


/*------------------------------------------------------------------------
WrPixmap - ???
------------------------------------------------------------------------*/

int
WrPixmap(fn,order,slice_maps,num_slice_maps,hdr)
 char *fn;
 struct strs_rec *order;
 struct buf_2d_rec **slice_maps;
 unsigned long num_slice_maps;
 struct pixmap_hdr_rec *hdr;
{
 int err,first;
 FILE *fid;
 unsigned long lcv,size,total;

 TRACE(printf("WrPixmap...fn = %s num_slice_maps = %d\n",fn,num_slice_maps))
 if (num_slice_maps == 0) return CANCEL;
 TRACE(printf("WrPixmap...0\n"))
 if ((err = cp_str(&(hdr->id),PIXMAP_V1)) != NO_ERROR) return err;
 if ((err = cp_strs_rec(&(hdr->order),order)) != NO_ERROR) return err;
 hdr->max_slices = num_slice_maps;
 TRACE(printf("WrPixmap...1\n"))
 if ((err = get_ptr(&(hdr->pixmap_offsets),NULL,hdr->max_slices,
                 (size_t) sizeof(*(hdr->pixmap_offsets)))) != NO_ERROR)
    return err;
 TRACE(printf("WrPixmap...2\n"))

 for (first = 1,hdr->num_pixmaps = 0,lcv = 0; lcv < num_slice_maps; lcv++)
    {if ((slice_maps[lcv]->status4 & BUF_NON_EMPTY) && 
         (slice_maps[lcv]->status4 & BUF_DATA_VALID))
        {if (first)
            {hdr->dimx = slice_maps[lcv]->dimx;
             hdr->dimy = slice_maps[lcv]->dimy;
             first = 0;}
           else if ((hdr->dimx != slice_maps[lcv]->dimx) ||
                    (hdr->dimy != slice_maps[lcv]->dimy))
            return CANCEL;
         hdr->num_pixmaps += 1;}
     hdr->pixmap_offsets[lcv] = 0;}
 TRACE(printf("WrPixmap...hdr->num_pixmaps = %d\n",hdr->num_pixmaps))

 if ((err = wr_pixmap_hdr(fn,hdr)) != NO_ERROR)
    {
     return err;}
 TRACE(printf("WrPixmap...4\n"))

 if ((fid = fopen(fn,"r+")) == NULL)
    {
     delete_file(fn);
     return FILE_ACCESS_ERROR;}
 total = (size_t) hdr->max_slices * sizeof(*(hdr->pixmap_offsets));
 size = hdr->pixmap_start + total;
 fseek(fid,size,0);

 TRACE(printf("WrPixmap...ftell(fid) = %d\n",ftell(fid)))
 for (lcv = 0; lcv < num_slice_maps; lcv++)
    {if ((slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
         (slice_maps[lcv]->status4 & BUF_DATA_VALID))
        {hdr->pixmap_offsets[lcv] = ftell(fid);
         TRACE(printf("wr %d) off = %d\n",lcv,hdr->pixmap_offsets[lcv]))
         TRACE(printf("   ");pr_buf_2d_rec(slice_maps[lcv]);)
         if ((err = v3_wr_buf_2d_rec(fid,slice_maps[lcv])) != NO_ERROR)
            {TRACE(printf("WrPixmap wr_buf_2d_rec err = %d\n",err))
             break;}
         fflush(fid);
        }
    }
 if (err == NO_ERROR)
    {
     fseek(fid,hdr->pixmap_start,0);
     if (fwrite(hdr->pixmap_offsets,total,1,fid) != 1)
        err = WRITE_ERROR;
    }
 TRACE(printf("WrPixmap err = %d\n",err))
 fclose(fid);
 if (err != NO_ERROR) delete_file(fn);
 return err;
}


/*------------------------------------------------------------------------
is_compatible_pixmap - ???
------------------------------------------------------------------------*/

int
is_compatible_pixmap(pixel_type,dimx,dimy)
 struct pixel_type_rec *pixel_type;
 long dimx,dimy;
{
 int result;

 cmp_str_arys(pixel_type->order.strs,pixel_type->order.num_strs,
            pixel_type->pixmap_hdr.order.strs,
            pixel_type->pixmap_hdr.order.num_strs,&result);
 if ((result != 0) ||
     (pixel_type->pixmap_hdr.dimx != dimx) ||
     (pixel_type->pixmap_hdr.dimy != dimy))
    return 0;
 return 1;
}


/*------------------------------------------------------------------------
append_wr_file_pixmap - ???
------------------------------------------------------------------------*/

int
append_wr_file_pixmap(dir,fn,suffix,pixel_type,dimx,dimy,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 char **err_reason;
{
  int err,update;
  char *fn1;
  unsigned long lcv,size;
  FILE *fid;
  struct pixmap_hdr_rec *hdr;
  
  TRACE(printf("append_wr_file_pixmap..0\n"));
  if (err_reason != NULL) *err_reason = NULL;
  if (!is_compatible_pixmap(pixel_type,dimx,dimy))
    return wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason);
  TRACE(printf("append_wr_file_pixmap..1\n"));
  
  fn1 = NULL;
  if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
      ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
  {
    size = get_file_size_by_fn(fn1,&err);
    TRACE(printf("append_wr_file_pixmap..fn1 = %s size = %d\n",fn1,size));
    if ((fid = fopen(fn1,"r+")) == NULL)
      err = FILE_ACCESS_ERROR;
    else
    {
      hdr = &(pixel_type->pixmap_hdr);
      for (update = 0,lcv = 0; lcv < pixel_type->num_slice_maps; lcv++)
      {
	if ((pixel_type->slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
	    (pixel_type->slice_maps[lcv]->status4 & BUF_DATA_VALID))
	{
	  if (hdr->pixmap_offsets[lcv] == 0)
	  {
	    hdr->pixmap_offsets[lcv] = size;
	    hdr->num_pixmaps += 1;
	    update = 1;
	  }
	  fseek(fid,hdr->pixmap_offsets[lcv],0);
	  TRACE(printf("%d)..off = %d\n", lcv, hdr->pixmap_offsets[lcv]));
	  if ((err =
	       v3_wr_buf_2d_rec(fid, pixel_type->slice_maps[lcv])) != NO_ERROR)
	  {
	    TRACE(printf("append_wr_file_pixmap..wr_buf_2d_rec = %d\n",err));
	    break;
	  }

	  if (update)
	  {
	    fflush(fid);
	    size = ftell(fid);
	    update = 0;
	  }
	} 
      }

      if (err == NO_ERROR)
	err = wr_updated_pixmap_params(fid,hdr);
      fclose(fid);
    }
  }
  c_free(fn1);
  TRACE(printf("append_wr_file_pixmap..err = %d\n",err));
  return err;
}


/*------------------------------------------------------------------------
wr_file_pixmap_for_slice_num - ???
------------------------------------------------------------------------*/

int
wr_file_pixmap_for_slice_num(dir,fn,suffix,pixel_type,dimx,dimy,
                             num_slices,slice_map,slice_num,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 long num_slices;
 int slice_num;
 char **err_reason;
{
 int err;
 FILE *fid;
 unsigned long size;
 char *fn1;
 struct pixmap_hdr_rec *hdr;

 TRACE(printf("wr_pixmap_for_slice_num..1\n"))
 if (slice_num >= num_slices) return CANCEL;
 if (slice_num >= pixel_type->num_slice_maps) return CANCEL;
 if (!(pixel_type->slice_maps[slice_num]->status4 & BUF_NON_EMPTY) ||
     !(pixel_type->slice_maps[slice_num]->status4 & BUF_DATA_VALID))
    return NO_ERROR;
 if (!is_compatible_pixmap(pixel_type,dimx,dimy) ||
     !(pixel_type->status & PIXEL_TYPE_PIXMAP_HDR_VALID))
    return wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason);

 hdr = &(pixel_type->pixmap_hdr);
 TRACE(printf("wr_pixmap_for_slice_num..2\n"))
 if (hdr->pixmap_offsets[slice_num] == 0)
    {size = get_file_size_by_fn(fn,&err);
     if (err != NO_ERROR) return err;
     hdr->pixmap_offsets[slice_num] = size;
     hdr->num_pixmaps += 1;
    }
 fn1 = NULL;
 if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
     ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
   {if ((fid = fopen(fn1,"r+")) == NULL)
       err = FILE_ACCESS_ERROR;
      else
       {fseek(fid,hdr->pixmap_offsets[slice_num],0);
        err = v3_wr_buf_2d_rec(fid,pixel_type->slice_maps[slice_num]);
        if (err == NO_ERROR) err = wr_updated_pixmap_params(fid,hdr);
        fclose(fid);}
   }
 c_free(fn1);
 TRACE(printf("wr_pixmap_for_slice_num..err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
wr_file_pixmap - ???
------------------------------------------------------------------------*/

int
wr_file_pixmap(dir,fn,suffix,pixel_type,err_reason)
 char *dir,*fn,*suffix;
 struct pixel_type_rec *pixel_type;
 char **err_reason;
{
 int err;
 char *fn1,*fn2;
 struct pixmap_hdr_rec hdr;

 if (err_reason != NULL) *err_reason = NULL;

 TRACE(printf("wr_file_pixmap..1\n"))
 fn1 = fn2 = NULL;
 if (((err = build_fn(&fn1,dir,fn,suffix)) == NO_ERROR) &&
     ((err = file_access(fn1,2,NULL,err_reason)) == NO_ERROR))
    if ((fn2 = UniqueFn("",fn1,"zxzxz")) == NULL) 
       err = CANCEL;
      else if ((err = file_access(fn2,2,NULL,err_reason)) == NO_ERROR)
       {init_pixmap_hdr_rec(&hdr);
        err = WrPixmap(fn2,&(pixel_type->order),
             pixel_type->slice_maps,pixel_type->num_slice_maps,&hdr);
        TRACE(printf("WrPixmap...2.err = %d\n",err))
        if (err == NO_ERROR)
           {if (rename(fn2,fn1) != 0)
               {free_pixmap_hdr_rec(&hdr);
                err = CANCEL;}
              else
               {free_pixmap_hdr_rec(&(pixel_type->pixmap_hdr));
                pixel_type->pixmap_hdr = hdr;
                TRACE(printf("rename to %s\n",fn1))
               }
           }
          else free_pixmap_hdr_rec(&hdr);
       }
 c_free(fn1);
 c_free(fn2);
 TRACE(printf("wr_file_pixmap..err = %d\n",err))
 return err;
}




/*************************************************************************
 *
 *  v3_rd_wr_slice_roi_rec.c
 *
 *************************************************************************/


/*------------------------------------------------------------------------
struct coordinate_xy_rec - ???
------------------------------------------------------------------------*/

struct coordinate_xy_rec
{
  short x,y;
};


/*------------------------------------------------------------------------
v3_rd_curve_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_curve_rec(fid,curve)
 FILE *fid;
 struct curve_rec *curve;
{
 unsigned long lcv;
 short left,top,right,bottom;
 struct coordinate_xy_rec *ptr;
 int err;

 PRT(printf("rd_curve_rec..curve = %u\n",curve))

 if ((fread(&(curve->status),(size_t) sizeof(curve->status),1,fid) != 1) ||
     (fread(&(curve->more_status),(size_t) sizeof(curve->more_status),1,fid) != 1) ||
     (fread(&(curve->num_xys),(size_t) sizeof(curve->num_xys),1,fid) != 1))
    {init_curve_rec(curve);
     return READ_ERROR;}
 PRT1(printf("rd_curve_rec..status = %x more_status = %x num_xys = %d\n",
         curve->status,curve->more_status,curve->num_xys))

 if (!(curve->more_status & CURVE_NEW))
    {if ((fread(&left,(size_t) sizeof(left),1,fid) != 1) ||
         (fread(&top,(size_t) sizeof(top),1,fid) != 1) ||
         (fread(&right,(size_t) sizeof(right),1,fid) != 1) ||
         (fread(&bottom,(size_t) sizeof(bottom),1,fid) != 1) ||
         (fread(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
        {init_curve_rec(curve);
         return READ_ERROR;}
     curve->fl_bound.left = (float) left;
     curve->fl_bound.top = (float) top;
     curve->fl_bound.right = (float) right;
     curve->fl_bound.bottom = (float) bottom;
    }
   else if ((fread(&(curve->fl_bound),
            (size_t) sizeof(curve->fl_bound),1,fid) != 1) ||
           (fread(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
    {init_curve_rec(curve);
     return READ_ERROR;}

 curve->total_xys = curve->num_xys;
 if (curve->num_xys == 0)
    {curve->status &= ~CURVE_MATRIX_IN_USE;
     return NO_ERROR;}
 if ((err = get_ptr(&(curve->xys),NULL,curve->num_xys,
                   (size_t) sizeof(*(curve->xys)))) != NO_ERROR)
    {curve->num_xys = 0;
     curve->total_xys = 0;
     return err;}

 if (!(curve->more_status & CURVE_NEW))
    {if ((err = get_ptr(&ptr,NULL,curve->num_xys,
                   (size_t) sizeof(*ptr))) != NO_ERROR)
        {init_curve_rec(curve);
         return err;}
     if (fread(ptr,(size_t) ((size_t) sizeof(*ptr) *
           curve->num_xys),1,fid) != 1)
        {curve->num_xys = 0;
         curve->status &= ~CURVE_MATRIX_IN_USE;
         c_free(ptr);
         return READ_ERROR;}
     for (lcv = 0; lcv < curve->num_xys; lcv++)
        {curve->xys[lcv].x = (float) ptr[lcv].x;
         curve->xys[lcv].y = (float) ptr[lcv].y;}
     c_free(ptr);
    }
   else if (fread(curve->xys,(size_t) ((size_t) sizeof(*(curve->xys)) *
           curve->num_xys),1,fid) != 1)
    {curve->num_xys = 0;
     curve->status &= ~CURVE_MATRIX_IN_USE;
     return READ_ERROR;}

 if (curve->status & CURVE_MATRIX_IN_USE)
    inverse_2d_matrix(&(curve->inv),&(curve->matrix));

 PRT1(printf("rd_curve_rec..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_rd_curve_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_curve_2d_rec(fid,pen)
 FILE *fid;
 struct curve_2d_rec *pen;
{
 unsigned int total;
 int err;

 TRACE(printf("v3_rd_curve_2d_rec..pen = %u\n",pen))
 init_curve_2d_rec(pen,0);

 if ((fread(&(pen->pen_type),(size_t) sizeof(pen->pen_type),1,fid) != 1) ||
     (fread(&(pen->cur_curve),(size_t) sizeof(pen->cur_curve),1,fid) != 1) ||
     (fread(&(pen->num_curves),(size_t) sizeof(pen->num_curves),1,fid) != 1))
    {init_curve_2d_rec(pen,0);
     return READ_ERROR;}
 if (pen->cur_curve >= pen->num_curves) pen->cur_curve = 0;
 if (pen->num_curves == 0) return NO_ERROR;

 TRACE(printf("v3_rd_curve_2d_rec..pen_type = %d cur_curve = %d num_curves = %d total =  %d\n",
              pen->pen_type,pen->cur_curve,pen->num_curves,pen->total_curves))

 get_handle_memory(&(pen->curves),&(pen->total_curves),pen->num_curves,
         (size_t) sizeof(**(pen->curves)),&err);
 if (err)
    {init_curve_2d_rec(pen,0);
     return err;}
 for (total = 0; total < pen->total_curves; total++)
    init_curve_rec(pen->curves[total]);

 for (total = 0; total < pen->total_curves; total++)
    if ((err = v3_rd_curve_rec(fid,pen->curves[total])) != NO_ERROR)
       return err;

 TRACE(printf("v3_rd_curve_2d_rec...end.\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_rd_roi_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_roi_rec(fid,roi)
 FILE *fid;
 struct roi_rec *roi;
{
 unsigned int total;
 int err;

 TRACE(printf("v3_rd_roi_rec....roi = %u\n",roi))
 if (rd_file_strs(fid,&(roi->label),1) != NO_ERROR)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...1\n"))
 if (fread(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...2\n"))
 if (fread(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) 
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
 TRACE(printf("v3_rd_roi_rec...3\n"))
 if (fread(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
/*
 if ((rd_file_strs(fid,&(roi->label),1) != NO_ERROR) ||
     (fread(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1) ||
     (fread(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) ||
     (fread(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1))
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return READ_ERROR;}
*/
 TRACE(printf("v3_rd_roi_rec....roi->label = %s status = %x num_pens = %d\n",
         roi->label,(unsigned long) roi->status,roi->num_pens);)
 if (roi->cur_pen >= roi->num_pens) roi->cur_pen = 0;
 if (roi->num_pens == 0) return NO_ERROR;
 if ((err = get_handle(&(roi->pens),&(roi->total_pens),roi->num_pens,
              (size_t) sizeof(**(roi->pens)))) != NO_ERROR)
    {c_free(roi->label);
     init_roi_rec(roi,NULL);
     return err;}
 roi->status |= ROI_VISIBLE;
 for (total = 0; total < roi->num_pens; total++)
    init_curve_2d_rec(roi->pens[total],0);

 for (total = 0; total < roi->num_pens; total++)
    {if ((err = v3_rd_curve_2d_rec(fid,roi->pens[total])) != NO_ERROR)
        return err;
    }
 TRACE(printf("v3_rd_roi_rec...end\n"))
 return NO_ERROR;

}



/*------------------------------------------------------------------------
v3_rd_slice_roi_rec - ???
------------------------------------------------------------------------*/

int
v3_rd_slice_roi_rec(fid,slice_roi)
     FILE *fid;
     struct slice_roi_rec *slice_roi;
{
  unsigned int total;
  int err;

  TRACE(printf("v3_rd_slice_roi_rec...slice_roi = %u\n",slice_roi));
  free_slice_roi_rec(slice_roi);
  TRACE(printf("v3_rd_slice_roi_rec...\n"));


  if ((FREAD_ONE_ITEM(slice_roi->status, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->xpixel_size, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->ypixel_size, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->dimx, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->dimy, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->num_rois, fid) != 1) ||
      (FREAD_ONE_ITEM(slice_roi->cur_roi, fid) != 1))
  {
    init_slice_roi_rec(slice_roi);
    return READ_ERROR;
  }

  if (slice_roi->cur_roi >= slice_roi->num_rois)
    slice_roi->cur_roi = 0;

  TRACE(printf("v3_rd_slice_roi_rec(): cur_roi = %d, num_rois = %d\n",
	       slice_roi->cur_roi,slice_roi->num_rois));

  if (slice_roi->num_rois == 0)
    return NO_ERROR;

  get_handle_memory( &(slice_roi->rois),
		    &(slice_roi->total_rois),
		    slice_roi->num_rois,
		    (size_t) sizeof(**(slice_roi->rois)),
		    &err );
  if (err)
  {
    init_slice_roi_rec(slice_roi);
    return err;
  }


  for (total = 0; total < slice_roi->total_rois; total++)
    init_roi_rec(slice_roi->rois[total],NULL);

  for (total = 0; total < slice_roi->total_rois; total++)
  {
    TRACE(printf("reading roi# = %d\n",total));
    if ((err = v3_rd_roi_rec(fid,slice_roi->rois[total])) != NO_ERROR)
    {
      free_slice_roi_rec(slice_roi);
      return err;
    }
  }
  TRACE(printf("***********v3_rd_slice_roi_rec...end."));
  slice_roi->status |= SLICE_ROI_NON_EMPTY;

  return NO_ERROR;
}



/*------------------------------------------------------------------------
v3_wr_curve_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_curve_rec(fid,curve)
 FILE *fid;
 struct curve_rec *curve;
{
 curve->more_status |= CURVE_NEW;
 TRACE(printf("v3_wr_curve_rec..curve->num_xys = %d\n",curve->num_xys))
 if ((fwrite(&(curve->status),(size_t) sizeof(curve->status),1,fid) != 1) ||
     (fwrite(&(curve->more_status),(size_t) sizeof(curve->more_status),1,fid) != 1) ||
     (fwrite(&(curve->num_xys),(size_t) sizeof(curve->num_xys),1,fid) != 1) ||
     (fwrite(&(curve->fl_bound),(size_t) sizeof(curve->fl_bound),1,fid) != 1) ||
     (fwrite(&(curve->matrix),(size_t) sizeof(curve->matrix),1,fid) != 1))
    return WRITE_ERROR;
 if (curve->num_xys == 0) return NO_ERROR;
 if (fwrite(curve->xys,(size_t) (sizeof(*(curve->xys)) *
              curve->num_xys),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("v3_wr_curve_rec..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_wr_curve_2d_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_curve_2d_rec(fid,pen)
 FILE *fid;
 struct curve_2d_rec *pen;
{
 unsigned int total;
 int err;

 TRACE(printf("v3_wr_curve_2d_rec..\n"))
 if ((fwrite(&(pen->pen_type),(size_t) sizeof(pen->pen_type),1,fid) != 1) ||
     (fwrite(&(pen->cur_curve),(size_t) sizeof(pen->cur_curve),1,fid) != 1) ||
     (fwrite(&(pen->num_curves),(size_t) sizeof(pen->num_curves),1,fid) != 1))
     return WRITE_ERROR;
 TRACE(printf("v3_wr_curve_2d_rec..pen_type = %d cur_curve = %d num_curves = %d\n",
              pen->pen_type,pen->cur_curve,pen->num_curves))
 if (pen->num_curves == 0) return NO_ERROR;

 for (total = 0; total < pen->num_curves; total++)
    if ((err = v3_wr_curve_rec(fid,pen->curves[total])) != NO_ERROR)
        return err;
 TRACE(printf("v3_wr_curve_2d_rec..end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
v3_wr_roi_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_roi_rec(fid,roi)
 FILE *fid;
 struct roi_rec *roi;
{
 unsigned int total;
 int err;

 TRACE(printf("v3_wr_roi_rec..\n"))

 if ((wr_file_strs(fid,&(roi->label),1) != NO_ERROR) ||
     (fwrite(&(roi->status),(size_t) sizeof(roi->status),
           1,fid) != 1) ||
     (fwrite(&(roi->cur_pen),(size_t) sizeof(roi->cur_pen),
           1,fid) != 1) ||
     (fwrite(&(roi->num_pens),(size_t) sizeof(roi->num_pens),
           1,fid) != 1))
     return WRITE_ERROR;
 if (roi->num_pens == 0) return NO_ERROR;
 TRACE(printf("v3_wr_roi_rec..\n"))

 for (total = 0; total < roi->num_pens; total++)
    if ((err = v3_wr_curve_2d_rec(fid,roi->pens[total])) != NO_ERROR)
        return err;
 TRACE(printf("v3_wr_roi_rec..end\n"))
 return NO_ERROR;

}


/*------------------------------------------------------------------------
v3_wr_slice_roi_rec - ???
------------------------------------------------------------------------*/

int
v3_wr_slice_roi_rec(fid,slice_roi)
 FILE *fid;
 struct slice_roi_rec *slice_roi;
{
 unsigned int total;
 int err;

 TRACE(printf("v3_wr_slice_roi_rec..7777..slice_roi = %d\n",slice_roi))
 keep_only_non_empty_curves(slice_roi);
 TRACE(printf("v3_wr_slice_roi_rec..88..\n"))

 if (
     (fwrite(&(slice_roi->status),
         (size_t) sizeof(slice_roi->status),1,fid) != 1) ||
     (fwrite(&(slice_roi->xpixel_size),
         (size_t) sizeof(slice_roi->xpixel_size),1,fid) != 1) ||
     (fwrite(&(slice_roi->ypixel_size),
         (size_t) sizeof(slice_roi->ypixel_size),1,fid) != 1) ||
     (fwrite(&(slice_roi->dimx),
         (size_t) sizeof(slice_roi->dimx),1,fid) != 1) ||
     (fwrite(&(slice_roi->dimy),
         (size_t) sizeof(slice_roi->dimy),1,fid) != 1) ||
     (fwrite(&(slice_roi->num_rois),
         (size_t) sizeof(slice_roi->num_rois),1,fid) != 1) ||
     (fwrite(&(slice_roi->cur_roi),
         (size_t) sizeof(slice_roi->cur_roi),1,fid) != 1))
     return WRITE_ERROR;
 TRACE(printf("v3_wr_slice_roi_rec...slice_roi->num_rois = %d",slice_roi->num_rois))

 for (total = 0; total < slice_roi->num_rois; total++)
    {
     if ((err = v3_wr_roi_rec(fid,slice_roi->rois[total])) != NO_ERROR)
        return err;}
 TRACE(printf("v3_wr_slice_roi_rec...end."))
 return NO_ERROR;

}



/*************************************************************************
 *
 *  v3_wr_ria_dat.c
 *
 *************************************************************************/



/*------------------------------------------------------------------------
init_output_hdr_info_rec - ???
------------------------------------------------------------------------*/

void
init_output_hdr_info_rec(info)
 struct output_hdr_info_rec *info;
{
 info->status = 0;
 info->dirfn = NULL;
 info->fn = NULL;
 info->hdr_fn_suffix = NULL;
 info->img_fn_suffix = NULL;

}


/*------------------------------------------------------------------------
init_output_hdr_rec - ???
------------------------------------------------------------------------*/

void
init_output_hdr_rec(hdr)
 struct output_hdr_rec *hdr;
{
 hdr->id = NULL;
 hdr->rater = NULL;
 init_output_hdr_info_rec(&(hdr->info));
 hdr->actual_total_slice_rois = 0;
 hdr->num_slice_rois = 0;
 hdr->slice_nums = NULL;
}


/*------------------------------------------------------------------------
free_output_hdr_info_rec - ???
------------------------------------------------------------------------*/

void
free_output_hdr_info_rec(info)
 struct output_hdr_info_rec *info;
{
 TRACE(printf("info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,info->hdr_fn_suffix,
    info->img_fn_suffix))

 c_free(info->dirfn);
 c_free(info->fn);
 c_free(info->hdr_fn_suffix);
 c_free(info->img_fn_suffix);
 init_output_hdr_info_rec(info);
}


/*------------------------------------------------------------------------
free_output_hdr_rec - ???
------------------------------------------------------------------------*/

void
free_output_hdr_rec(hdr)
 struct output_hdr_rec *hdr;
{
 TRACE(printf("free_output_hdr_rec...end hdr->num_slice_rois = %d\n",
           hdr->num_slice_rois))
 c_free(hdr->id);
 c_free(hdr->rater);
 free_output_hdr_info_rec(&(hdr->info));
 if (hdr->num_slice_rois > 0)
    c_free(hdr->slice_nums);
 init_output_hdr_rec(hdr);

}

/*********************
wr_str_value_rec(fid,str_value)
 FILE *fid;
 struct str_value_rec *str_value;
{
 int err;

 if ((err = wr_file_strs(fid,&(str_value->str),1)) != NO_ERROR)
    return err;
 if (fwrite(&(str_value->value),(size_t) sizeof(str_value->value),1,fid) != 1)
    return WRITE_ERROR;
 return NO_ERROR;
}

wr_str_value_recs(fid,str_values,num_str_values)
 FILE *fid;
 struct str_value_rec *str_values;
 unsigned long num_str_values;
{
 unsigned long lcv;
 int err;

 if (fwrite(&num_str_values,(size_t) sizeof(num_str_values),1,fid) != 1)
    return WRITE_ERROR;
 if (num_str_values == 0) return NO_ERROR;

 for (lcv = 0; lcv < num_str_values; lcv++)
    if ((err = wr_str_value_rec(fid,&(str_values[lcv]))) != NO_ERROR)
       {return err;}
 return NO_ERROR;
}
************************/

/************************
wr_output_hdr_info_rec(fid,info)
 FILE *fid;
 struct output_hdr_info_rec *info;
{
 int err;

 err = WRITE_ERROR;
 if (((err = wr_file_strs(fid,&(info->dirfn),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->fn),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->hdr_fn_suffix),1)) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(info->img_fn_suffix),1)) != NO_ERROR) ||
     (fwrite(&(info->dimx),
              sizeof(info->dimx),1,fid) != 1) ||
     (fwrite(&(info->dimy),
              sizeof(info->dimy),1,fid) != 1) ||
     (fwrite(&(info->max_slices),
              sizeof(info->max_slices),1,fid) != 1) ||
     (fwrite(&(info->pixel_depth_bits),
              sizeof(info->pixel_depth_bits),1,fid) != 1))
    return err;
 TRACE(printf("info->dirfn = %s %s %s %s\n",info->dirfn,info->fn,
       info->hdr_fn_suffix,info->img_fn_suffix))
 return NO_ERROR;
}
******************************/


/*------------------------------------------------------------------------
wr_output_field_offset_rec - ???
------------------------------------------------------------------------*/

int
wr_output_field_offset_rec(fid,offset)
 FILE *fid;
 struct output_field_offset_rec *offset;
{
 if (fwrite(&(offset->slice_roi_start),40,1,fid) != 1)
    return WRITE_ERROR;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_output_hdr_rec - ???
------------------------------------------------------------------------*/

int
wr_output_hdr_rec(fid,hdr,offset)
 FILE *fid;
 struct output_hdr_rec *hdr;
 unsigned long *offset;
{
 int err;

 TRACE(printf("wr_output_hdr_rec...id = %s rater = %s\n",hdr->id,hdr->rater);)
 err = WRITE_ERROR;
 hdr->size = 0;
 if ((hdr->id == NULL) || (str_cmp(hdr->id,DAT_ID_V3) != 0))
    {c_free(hdr->id);
     cp_str(&(hdr->id),DAT_ID_V3);}
 if ((fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
     ((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_file_strs(fid,&(hdr->rater),1)) == NO_ERROR))
    {fflush(fid);
     *offset = ftell(fid);}
   else return err;
 TRACE(printf("wr_output_hdr_rec...3\n");)
 if ((err = wr_output_field_offset_rec(fid,&(hdr->offset))) != NO_ERROR)
   return err;
 fflush(fid);
/*
 hdr->offset.info_start = ftell(fid);
 if ((err = wr_output_hdr_info_rec(fid,&(hdr->info))) == NO_ERROR)
    {fflush(fid);
     hdr->offset.info_size = sizeof(hdr->info);
    }
*/
 TRACE(printf("wr_output_hdr_rec...err = %d\n",err);)
 return err;
}


/*------------------------------------------------------------------------
wr_output_slice_nums - ???
------------------------------------------------------------------------*/

int
wr_output_slice_nums(fid,slice_nums,num_slice_rois)
 FILE *fid;
 unsigned long *slice_nums;
 unsigned long num_slice_rois;
{
 if (num_slice_rois == 0) return NO_ERROR;
 TRACE(printf("wr_output_slice_nums\n"))
 if (fwrite(slice_nums,(size_t) (sizeof(*slice_nums) * num_slice_rois),
              1,fid) != 1)
     return WRITE_ERROR;

 return NO_ERROR;
}


/********************
wr_histo_pixel_center_recs(fid,centers,num_centers)
 FILE *fid;
 struct pixel_center_rec *centers;
 unsigned long num_centers;
{
 unsigned long lcv;
 int err;

  TRACE(printf("wr_histo_pixel_center_recs...\n"))

 if (fwrite(&(num_centers),(size_t) sizeof(num_centers),1,fid) == 1)
    for (lcv = 0; lcv < num_centers; lcv++)
       {if (((err = wr_file_strs(fid,&(centers[lcv].roi_label),1)) !=
                  NO_ERROR) ||
            ((err = wr_file_strs(fid,&(centers[lcv].segmented_roi_label),1)) !=
                  NO_ERROR))
           return err;
        if (fwrite(&(centers[lcv]),(size_t) sizeof(centers[lcv]),1,fid) != 1)
           return err;
       }
   else return WRITE_ERROR;
  TRACE(printf("wr_histo_pixel_center_recs...end\n"))

 return NO_ERROR;
}
********************/



/*------------------------------------------------------------------------
wr_histo_bkg_rec - ???
------------------------------------------------------------------------*/

int
wr_histo_bkg_rec(fid,bkg)
 FILE *fid;
 struct histo_bkg_rec *bkg;
{
 int err;

 TRACE(printf("wr_histo_bkg_rec...bkg->num_bkgs = %d\n",bkg->num_bkgs))
 if (fwrite(&(bkg->num_bkgs),(size_t) sizeof(bkg->num_bkgs),1,fid) != 1)
    return WRITE_ERROR;
 if (bkg->num_bkgs == 0) return NO_ERROR;
 if (fwrite(bkg->bkgs,(size_t) (bkg->num_bkgs * sizeof(*(bkg->bkgs))),1,fid)
           != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_histo_bkg_rec.2..bkg->num_bkgs = %d\n",bkg->num_bkgs))
 TRACE(pr_roi_rec(&(bkg->roi));)

 err = v3_wr_roi_rec(fid,&(bkg->roi));
 TRACE(printf("wr_histo_bkg_rec...err = %d\n",err))
 return err;
}


/*------------------------------------------------------------------------
wr_histo_params - ???
------------------------------------------------------------------------*/

int
wr_histo_params(fid,histo)
 FILE *fid;
 struct histo_params_rec *histo;
{
 int err;
 unsigned short histo_status2;

 TRACE(printf("wr_histo_params..\n"))
 if (histo == NULL) histo_status2 = 0;
   else histo_status2 = histo->status2;
 if (fwrite(&histo_status2,(size_t) sizeof(histo_status2),1,fid) != 1)
    return WRITE_ERROR;

 TRACE(printf("wr_histo_params...\n"))
 if (histo_status2 & HISTO_TYPE)
    {if (((err = v3_wr_slice_roi_rec(fid,&(histo->slice_roi_win_2d.slice_roi)))
              != NO_ERROR) ||
         ((err = v3_wr_slice_roi_rec(fid,&(histo->slice_roi_win_1d.slice_roi)))
              != NO_ERROR) ||
         ((err = wr_histo_bkg_rec(fid,&(histo->bkg))) != NO_ERROR) ||
         ((err = wr_strs_rec(fid,&(histo->pixel_type_order))) == NO_ERROR))
        return err;
    }
   else err = NO_ERROR;
 if (err == NO_ERROR)
    if (histo_status2 & HISTO_CNT_1D_VALID)
       err = v3_wr_non_contiguos_buf_2d_rec(fid,&(histo->histo_1d));
 return err;
}


/*------------------------------------------------------------------------
wr_text_output_analysis_group_rec - ???
------------------------------------------------------------------------*/

int
wr_text_output_analysis_group_rec(fid,group)
 FILE *fid;
 struct text_output_analysis_group_rec *group;
{
 int err;

 if (fwrite(&(group->num_rois),(size_t) sizeof(group->num_rois),1,fid) != 1)
    return WRITE_ERROR;
 if (group->num_rois == 0) return NO_ERROR;
 if ((err = wr_file_strs(fid,group->roi_labels,group->num_rois)) != NO_ERROR)
    return err;

 if (fwrite(&(group->num_pixel_types),(size_t) sizeof(group->num_pixel_types),1,fid)
        != 1) return WRITE_ERROR;
 if (group->num_pixel_types == 0) return NO_ERROR;

 if ((err = wr_file_strs(fid,group->pixel_type_labels,group->num_pixel_types))
        != NO_ERROR) return WRITE_ERROR;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_pixel_type_cnt_rec - ???
------------------------------------------------------------------------*/

int
wr_pixel_type_cnt_rec(fid,pixel_cnt)
 FILE *fid;
 struct pixel_type_cnt_rec *pixel_cnt;
{
 TRACE(printf("wr_pixel_type_cnt_rec...begin\n"))
 if (pixel_cnt->num_pixel_type_cnts == 0) return NO_ERROR;
 if ((fwrite(&(pixel_cnt->status),(size_t) sizeof(pixel_cnt->status),1,fid) != 1) ||
     (fwrite(&(pixel_cnt->num_pixel_type_cnts),
             sizeof(pixel_cnt->num_pixel_type_cnts),1,fid) != 1) ||
     (fwrite(pixel_cnt->pixel_type_cnts,
       (size_t) (pixel_cnt->num_pixel_type_cnts * sizeof(unsigned long)),
            1,fid) != 1))
    return WRITE_ERROR;
 TRACE(printf("wr_pixel_type_cnt_rec...end\n"))
 return NO_ERROR;
}


/***************************
wr_roi_pixel_type_cnts(fid,sroi_wins,num_sroi_wins)
 FILE *fid;
 struct slice_roi_win_rec **sroi_wins;
 unsigned long num_sroi_wins;
{
 unsigned long lcv,cnt,num_slices,num_rois;
 unsigned long next_start,first_slice_start,first_roi_start;
 char first_slice,first_roi;
 struct slice_roi_rec *slice_roi;
 int err;

 TRACE(printf("wr_roi_pixel_type_cnts...begin\n"))
 num_slices = 0;
 fflush(fid);
 first_slice_start = ftell(fid);
 if (fseek(fid,(size_t) sizeof(num_slices),1) != 0) return WRITE_ERROR;
 TRACE(printf("wr_roi_pixel_type_cnts...1\n"))

 for (lcv = 0; lcv < num_sroi_wins; lcv++)
    {
     slice_roi = &(sroi_wins[lcv]->slice_roi);
     for (num_rois = 0,first_roi = 1,cnt = 0; cnt < slice_roi->num_rois; cnt++)
        if (slice_roi->rois[cnt]->user.ptr != NULL)
           {
            if (first_roi)
               {if (fwrite(&lcv,(size_t) sizeof(lcv),1,fid) != 1) return WRITE_ERROR;
     TRACE(printf("wr_roi_pixel_type_cnts...lcv = %d slice_roi->num_rois = %d\n",lcv,
            slice_roi->num_rois))
                num_slices += 1;
                fflush(fid);
                first_roi_start = ftell(fid);
                first_roi = 0;
                if (fwrite(&num_rois,(size_t) sizeof(num_rois),1,fid) != 1)
                   return WRITE_ERROR;
               }
            if (((err = wr_file_strs(fid,&(slice_roi->rois[cnt]->label),1))
                  != NO_ERROR) ||
                ((err = wr_pixel_type_cnt_rec(fid,
                   slice_roi->rois[cnt]->user.ptr)) != NO_ERROR))
               return err;
            num_rois += 1;
           }
     if (first_roi == 0)
        {fflush(fid);
         next_start = ftell(fid);
         fseek(fid,first_roi_start,0);
         if (fwrite(&num_rois,(size_t) sizeof(num_rois),1,fid) != 1) return WRITE_ERROR;
         TRACE(printf("wr_roi_pixel_type_cnts...num_rois = %d\n",num_rois))
         fseek(fid,next_start,0);
        }
    }
 fflush(fid);
 next_start = ftell(fid);
 fseek(fid,first_slice_start,0);
 TRACE(printf("before writing num_slices offset = %d\n",first_slice_start))
 if (fwrite(&num_slices,(size_t) sizeof(num_slices),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_roi_pixel_type_cnts...num_slices = %d\n",num_slices))
 fseek(fid,next_start,0);

 TRACE(printf("wr_roi_pixel_type_cnts...end\n"))
 return NO_ERROR;
}
************************/



/*------------------------------------------------------------------------
wr_pixel_type_params - ???
------------------------------------------------------------------------*/

int
wr_pixel_type_params(fid,pixel_type)
 FILE *fid;
 struct pixel_type_rec *pixel_type;
{
 int err;

 if (pixel_type == NULL) return NO_ERROR;
 PRT(printf("\n\nwr_pixel_type_params...status = %x pixel_type->order.num_strs = %d\n",
     (unsigned long) pixel_type->status,pixel_type->order.num_strs))

 if (pixel_type->order.num_strs == 0) return NO_ERROR;
 if (!(pixel_type->map.status4 & BUF_DATA_VALID)) return NO_ERROR;

 if (fwrite(&(pixel_type->status),
           (size_t) sizeof(pixel_type->status),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_pixel_type_params...order map\n"))
 if (((err = wr_strs_rec(fid,&(pixel_type->order))) != NO_ERROR) ||
     ((err = wr_file_strs(fid,&(pixel_type->slice_map_data_creation_date),1
            )) != NO_ERROR) ||
     ((err = v3_wr_buf_2d_rec(fid,&(pixel_type->map))) != NO_ERROR))
    return err;

 TRACE(printf("wr_pixel_type_params...err = %d\n",err))
 return err;

}


/*------------------------------------------------------------------------
wr_input_text_file_format - ???
------------------------------------------------------------------------*/

int
wr_input_text_file_format(fid,groups,num_groups)
 FILE *fid;
 struct text_output_analysis_group_rec *groups;
 unsigned long num_groups;
{
 unsigned long lcv;
 int err;

 if (groups == NULL) num_groups = 0;
 if (fwrite(&num_groups,(size_t) sizeof(num_groups),1,fid) != 1)
    return WRITE_ERROR;
 if (num_groups <= 0) return NO_ERROR;

 for (lcv = 0; lcv < num_groups; lcv++)
    if ((err = wr_text_output_analysis_group_rec(fid,&(groups[lcv])))
           != NO_ERROR) 
       return err;
 TRACE(printf("wr_input_text_file_format...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_output_field_rec - ???
------------------------------------------------------------------------*/

int
wr_output_field_rec(fid,group)
 FILE *fid;
 struct output_field_rec *group;
{
 if ((fwrite(&(group->pixel_type_indx),(size_t) sizeof(group->pixel_type_indx),
              1,fid) != 1) ||
     (fwrite(&(group->num_roi_indxs),(size_t) sizeof(group->num_roi_indxs),
              1,fid) != 1))
    return WRITE_ERROR;
 if (group->num_roi_indxs > 0)
    if (fwrite(group->roi_indxs,(size_t) sizeof(*(group->roi_indxs)) *
              group->num_roi_indxs,1,fid) != 1)
       return WRITE_ERROR;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_output_count_field_rec - ???
------------------------------------------------------------------------*/

int
wr_output_count_field_rec(fid,group)
 FILE *fid;
 struct output_count_field_rec *group;
{
 if (fwrite(&(group->num_fields),(size_t) sizeof(group->num_fields),1,fid) != 1)
    return WRITE_ERROR;
 if (group->num_fields > 0)
    if (fwrite(group->fields,(size_t) sizeof(*(group->fields)) *
              group->num_fields,1,fid) != 1)
       return WRITE_ERROR;

 return NO_ERROR;

}


/*------------------------------------------------------------------------
wr_output_count_group_rec - ???
------------------------------------------------------------------------*/

int
wr_output_count_group_rec(fid,count)
 FILE *fid;
 struct output_count_group_rec *count;
{
 unsigned long lcv;
 int err;

 if (fwrite(&(count->num_groups),(size_t) sizeof(count->num_groups),1,fid) != 1)
    return WRITE_ERROR;

 for (lcv = 0; lcv < count->num_groups; lcv++)
    if ((err = wr_output_count_field_rec(fid,&(count->groups[lcv])))
               != NO_ERROR)
       return err;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_output_text_file_format - ???
------------------------------------------------------------------------*/

int
wr_output_text_file_format(fid,format)
 FILE *fid;
 struct output_text_format_rec *format;
{
 unsigned long lcv;
 int err;
 unsigned short status;

 TRACE(printf("wr_output_text_file_format...begin\n"))
 if (format == NULL) status = 0;
   else
    {status = format->status;
     if (format->status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW)
        status &= ~OUT_FORMAT_UNIT_2D_VALID;}

 if (fwrite(&status,(size_t) sizeof(status),1,fid) != 1)
    return WRITE_ERROR;
 TRACE(printf("wr_output_text_file_format...status = %x\n",(unsigned long) status))

 if (!(status & OUT_FORMAT_DEFINED))
    {TRACE(printf("!(status & OUT_FORMAT_DEFINED)\n"))
     return NO_ERROR;}

 if ((err = wr_strs_rec(fid,&(format->roi_labels))) != NO_ERROR)
    return err;
 if (format->roi_labels.num_strs > 0)
    if (fwrite(format->roi_nums,(size_t) sizeof(*(format->roi_nums)) *
              format->roi_labels.num_strs,1,fid) != 1)
       return WRITE_ERROR;

 if ((err = wr_strs_rec(fid,&(format->pixel_type_labels))) != NO_ERROR)
    return err;
 if (format->pixel_type_labels.num_strs > 0)
    if (fwrite(format->pixel_type_nums,
          sizeof(*(format->pixel_type_nums)) *
              format->pixel_type_labels.num_strs,1,fid) != 1)
       return WRITE_ERROR;

 if (fwrite(&(format->num_groups),(size_t) sizeof(format->num_groups),
              1,fid) != 1)
    return WRITE_ERROR;
 for (lcv = 0; lcv < format->num_groups; lcv++)
    if ((err = wr_output_field_rec(fid,&(format->groups[lcv])))
           != NO_ERROR) return err;

 if (fwrite(&(format->num_slices),(size_t) sizeof(format->num_slices),
              1,fid) != 1)
    return WRITE_ERROR;
 for (lcv = 0; lcv < format->num_slices; lcv++)
    if ((err = wr_output_count_group_rec(fid,&(format->counts[lcv])))
           != NO_ERROR) return err;

 if ((fwrite(&(format->page_num_rows),(size_t) sizeof(format->page_num_rows),
              1,fid) != 1) ||
     (fwrite(&(format->page_row_size),(size_t) sizeof(format->page_row_size),
              1,fid) != 1) ||
     (fwrite(&(format->num_field_spaces),
         sizeof(format->num_field_spaces),1,fid) != 1) ||
     (fwrite(&(format->num_collect_spaces),
         sizeof(format->num_collect_spaces),1,fid) != 1) ||
     (fwrite(&(format->xpixel_size),
           (size_t) sizeof(format->xpixel_size),1,fid) != 1) ||
     (fwrite(&(format->ypixel_size),
           (size_t) sizeof(format->ypixel_size),1,fid) != 1) ||
     (fwrite(&(format->pixel_thickness),
         sizeof(format->pixel_thickness),1,fid) != 1) ||
     (fwrite(&(format->voxel_size),
              (size_t) sizeof(format->voxel_size),1,fid) != 1))
    return WRITE_ERROR;
 if (status & OUT_FORMAT_LT_PERCENT_MEAN)
    if (fwrite(&(format->lt_percent),
              (size_t) sizeof(format->lt_percent),1,fid) != 1)
       return WRITE_ERROR;
 if (status & OUT_FORMAT_GT_PERCENT_MEAN)
    if (fwrite(&(format->gt_percent),
              (size_t) sizeof(format->gt_percent),1,fid) != 1)
       return WRITE_ERROR;

 if (status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    if (fwrite(&(format->roi_lt_percent),
              (size_t) sizeof(format->roi_lt_percent),1,fid) != 1)
       return WRITE_ERROR;
 if (status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    if (fwrite(&(format->roi_gt_percent),
              (size_t) sizeof(format->roi_gt_percent),1,fid) != 1)
       return WRITE_ERROR;

 if (!(status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW) &&
     (status & OUT_FORMAT_UNIT_2D_VALID))
    {
     if (fwrite(&(format->img_unit),
              (size_t) sizeof(format->img_unit),1,fid) != 1)
        return READ_ERROR;
    }

 TRACE(printf("wr_output_text_file_format...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_text_file_format - ???
------------------------------------------------------------------------*/

int
wr_text_file_format(fid,text)
 FILE *fid;
 struct text_output_rec *text;
{
 int err;

 if (text == NULL) 
    {if ((err = wr_input_text_file_format(fid,NULL,0)) != NO_ERROR)
        return err;
     return wr_output_text_file_format(fid,NULL);}
   else
    {if ((err = wr_input_text_file_format(fid,text->groups,
              text->num_groups)) != NO_ERROR)
        return err;
     return wr_output_text_file_format(fid,&(text->format));}

}

/*****************
old struct roi_count_anal_rec
   {char *label;
    long min,max;
    unsigned long num_pixels;
    double total_counts,sd;
   };
***********************/


/*------------------------------------------------------------------------
wr_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

int
wr_roi_count_anal_rec(fid,roi)
 FILE *fid;
 struct roi_count_anal_rec *roi;
{
 int err;

 if ((err = wr_file_strs(fid,&(roi->label),1)) != NO_ERROR)
    return err;
 if ((fwrite(&(roi->status2),(size_t) sizeof(roi->status2),1,fid) != 1) ||
     (fwrite(&(roi->min),(size_t) sizeof(roi->min),1,fid) != 1) ||
     (fwrite(&(roi->max),(size_t) sizeof(roi->max),1,fid) != 1) ||
     (fwrite(&(roi->num_pixels),(size_t) sizeof(roi->num_pixels),1,fid) != 1) ||
     (fwrite(&(roi->total_counts),(size_t) sizeof(roi->total_counts),1,fid) != 1) ||
     (fwrite(&(roi->sd),(size_t) sizeof(roi->sd),1,fid) != 1) ||
     (fwrite(&(roi->cnt_neg_val),(size_t) sizeof(roi->cnt_neg_val),1,fid) != 1) ||
     (fwrite(&(roi->cnt_smean_min_rej),
            (size_t) sizeof(roi->cnt_smean_min_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_smean_max_rej),
            (size_t) sizeof(roi->cnt_smean_max_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_rmean_min_rej),
            (size_t) sizeof(roi->cnt_rmean_min_rej),1,fid) != 1) ||
     (fwrite(&(roi->cnt_rmean_max_rej),
            (size_t) sizeof(roi->cnt_rmean_max_rej),1,fid) != 1) ||
     (fwrite(&(roi->slice_mean),(size_t) sizeof(roi->slice_mean),1,fid) != 1) ||
     (fwrite(&(roi->min_smean_threshold),
             (size_t) sizeof(roi->min_smean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->max_smean_threshold),
             (size_t) sizeof(roi->max_smean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->roi_mean),(size_t) sizeof(roi->roi_mean),1,fid) != 1) ||
     (fwrite(&(roi->min_rmean_threshold),
             (size_t) sizeof(roi->min_rmean_threshold),1,fid) != 1) ||
     (fwrite(&(roi->max_rmean_threshold),
             (size_t) sizeof(roi->max_rmean_threshold),1,fid) != 1))
    return WRITE_ERROR;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

int
wr_slice_count_anal_rec(fid,slice)
 FILE *fid;
 struct slice_count_anal_rec *slice;
{
 int err;
 unsigned long lcv;

 slice->status1 |= COUNT_NEW_FORMAT;
 if ((fwrite(&(slice->status1),(size_t) sizeof(slice->status1),1,fid) != 1) ||
     (fwrite(&(slice->num_rois),(size_t) sizeof(slice->num_rois),1,fid) != 1))
    return WRITE_ERROR;

 for (lcv = 0; lcv < slice->num_rois; lcv++)
    if ((err = wr_roi_count_anal_rec(fid,&(slice->rois[lcv]))) != NO_ERROR)
       return err;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_slice_count_anal_recs - ???
------------------------------------------------------------------------*/

int
wr_slice_count_anal_recs(fid,slices,num_slices)
 FILE *fid;
 struct slice_count_anal_rec *slices;
 unsigned long num_slices;
{
 unsigned long lcv;
 int err;

 TRACE(printf("wr_slice_count_anal_recs...num_slices = %d\n",num_slices))
 if (slices == NULL) num_slices = 0;
 if (fwrite(&num_slices,(size_t) sizeof(num_slices),1,fid) != 1)
    return WRITE_ERROR;
 if (num_slices <= 0) return NO_ERROR;
 for (lcv = 0; lcv < num_slices; lcv++)
    if ((err = wr_slice_count_anal_rec(fid,&(slices[lcv]))) != NO_ERROR) 
       return err;
 TRACE(printf("wr_slice_count_anal_rec...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_count_analysis_rec - ???
------------------------------------------------------------------------*/

int
wr_count_analysis_rec(fid,count)
 FILE *fid;
 struct count_analysis_rec *count;
{
 int err;

 if (count == NULL) 
    {if ((err = wr_input_text_file_format(fid,NULL,0)) != NO_ERROR)
        return err;
     if ((err = wr_output_text_file_format(fid,NULL)) != NO_ERROR)
        return err;
     TRACE(printf("wr_count_analysis_rec...after wr_output_text_file_format\n"))
     return wr_slice_count_anal_recs(fid,NULL,0);
    }
   else
    {if ((err = wr_input_text_file_format(fid,count->groups,
              count->num_groups)) != NO_ERROR)
        return err;

     if ((err =  wr_output_text_file_format(fid,
            &(count->format))) != NO_ERROR)
        return err;
     if (count->format.status & OUT_FORMAT_COUNT_CUR_ECHO_ONLY)
        if (fwrite(&(count->echo_num),(size_t) sizeof(count->echo_num),1,fid) != 1)
           return WRITE_ERROR;

     return wr_slice_count_anal_recs(fid,count->slices,
            count->num_slices);
    }
}


/*------------------------------------------------------------------------
wr_ria_slice_rois - ???
------------------------------------------------------------------------*/

int
wr_ria_slice_rois(fid,slices,num_slices)
 FILE *fid;
 struct slice_num_and_roi_rec *slices;
 long num_slices;
{
 unsigned long lcv;
 int err;

 if (num_slices == 0) return NO_ERROR;
 TRACE(printf("wr_ria_slice_rois\n"))
 for (lcv = 0; lcv < num_slices; lcv++)
    {
     if ((err = v3_wr_slice_roi_rec(fid,slices[lcv].slice_roi))
              != NO_ERROR)
       {TRACE(printf("wr_ria_slice_rois err = %d\n",err))
        return err;}
    }
 TRACE(printf("wr_ria_slice_rois...1\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
setup_slice_nums - ???
------------------------------------------------------------------------*/

int
setup_slice_nums(hdr,slices,num_slices,total_slices)
 struct output_hdr_rec *hdr;
 struct slice_num_and_roi_rec *slices;
 long num_slices,total_slices;
{
 unsigned long lcv;
 int err;

 if (hdr->num_slice_rois > 0)
    {c_free(hdr->slice_nums);
     hdr->slice_nums = NULL;}
 hdr->actual_total_slice_rois = total_slices;
 hdr->num_slice_rois = num_slices;
 if (hdr->num_slice_rois == 0) return NO_ERROR;

 if ((err = get_ptr(&(hdr->slice_nums),NULL,hdr->num_slice_rois,
           (size_t) sizeof(*(hdr->slice_nums)))) != NO_ERROR)
    {hdr->num_slice_rois = 0;
     return err;}

 for (lcv = 0; lcv < num_slices; lcv++)
    hdr->slice_nums[lcv] = slices[lcv].slice_num;
 TRACE(printf("setup_slice_nums...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
wr_ria_dat_file - ???
------------------------------------------------------------------------*/

int
wr_ria_dat_file(fn,hdr,slices,num_slices,total_slices,
                histo,pixel_type,text,count)
 char *fn;
 struct output_hdr_rec *hdr;
 struct slice_num_and_roi_rec *slices;
 long num_slices,total_slices;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_rec *text;
 struct count_analysis_rec *count;
{
 FILE *fid;
 unsigned long offset;
 int err;

 TRACE(printf("wr_ria_dat_file...\n");)
 if ((err = setup_slice_nums(hdr,slices,num_slices,total_slices)) !=
            NO_ERROR)
    return err;
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 TRACE(printf("wr_ria_dat_file begin\n"))
 err = NO_ERROR;
 hdr->size = 0;
 if ((hdr->id == NULL) || (str_cmp(hdr->id,DAT_ID_V3) != 0))
    {c_free(hdr->id);
     cp_str(&(hdr->id),DAT_ID_V3);}
 if ((fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1) &&
     ((err = wr_file_strs(fid,&(hdr->id),1)) == NO_ERROR) &&
     ((err = wr_file_strs(fid,&(hdr->rater),1)) == NO_ERROR))
    {fflush(fid);
     offset = ftell(fid);}
   else
    {fclose(fid);
     return err;}
 if ((err = wr_output_field_offset_rec(fid,&(hdr->offset))) == NO_ERROR)
    {fflush(fid);
     hdr->offset.slice_roi_start = ftell(fid);

     TRACE(printf("slice_roi_start = %d\n",
         hdr->offset.slice_roi_start))

     if ((fwrite(&(hdr->actual_total_slice_rois),
                 sizeof(hdr->actual_total_slice_rois),1,fid)  == 1) &&
         (fwrite(&(hdr->num_slice_rois),
               (size_t) sizeof(hdr->num_slice_rois),1,fid) == 1) &&
         (wr_output_slice_nums(fid,hdr->slice_nums,hdr->num_slice_rois) ==
               NO_ERROR))
        {if ((err = wr_ria_slice_rois(fid,slices,num_slices)) == NO_ERROR)
            {fflush(fid);
             hdr->offset.histo_params_start = hdr->offset.slice_roi_size = 
                       ftell(fid);
             hdr->offset.slice_roi_size -= hdr->offset.slice_roi_start;

             if ((err = wr_histo_params(fid,histo)) != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("2wr_ria_dat_file end err = %d\n",err))
                 return err;}

             TRACE(printf("after wr_histo_params...\n"))
             fflush(fid);
             hdr->offset.histo_params_size =
                           hdr->offset.pixel_type_params_start = ftell(fid);
             hdr->offset.histo_params_size -= 
                          hdr->offset.histo_params_start;
             TRACE(printf("histo_params_size = %d\n",
                        hdr->offset.histo_params_size))

             if ((err = wr_pixel_type_params(fid,pixel_type)) != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("&&&wr_ria_dat_file end err = %d\n",err))
                 return err;}
             fflush(fid);

             hdr->offset.pixel_type_params_size =
                           hdr->offset.text_format_start = ftell(fid);
             hdr->offset.pixel_type_params_size -= 
                          hdr->offset.pixel_type_params_start;
             TRACE(printf("pixel_type_params_size = %d\n",
                        hdr->offset.pixel_type_params_size))

             if ((err = wr_text_file_format(fid,text))
                             != NO_ERROR)
                {fclose(fid);
                 TRACE(printf("&&&wr_ria_dat_file end err = %d\n",err))
                 return err;}
             TRACE(printf("wr_text_file_format...end\n"))
             fflush(fid);
             hdr->offset.text_format_size = hdr->offset.count_start = ftell(fid);
             hdr->offset.text_format_size -=
                            hdr->offset.text_format_start;

             TRACE(printf("wr_count_analysis_rec\n"))
             if ((err = wr_count_analysis_rec(fid,count)) != NO_ERROR)
                {c_free(slices);
                 fclose(fid);
                 return err;}
             TRACE(printf("wr_count_analysis_rec...end\n"))
             fflush(fid);
             hdr->offset.count_size = hdr->size = ftell(fid);
             hdr->offset.count_size -= hdr->offset.count_start;

             fseek(fid,0L,0);
             if (fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1)
                {fseek(fid,(size_t) offset,0);
                 err = wr_output_field_offset_rec(fid,&(hdr->offset)); 
                }
               else err = WRITE_ERROR;

            }
        }
    }

 fclose(fid);
 TRACE(printf("wr_ria_dat_file end err = %d\n",err))
 return err;

}


/*------------------------------------------------------------------------
setup_slice_num_and_roi_rec - ???
------------------------------------------------------------------------*/

int
setup_slice_num_and_roi_rec(slice_rois,total_slices,slices,num_slices)
 struct slice_roi_rec *slice_rois;
 struct slice_num_and_roi_rec **slices;
 long total_slices,*num_slices;
{
 unsigned long lcv,cnt;
 int err;

 TRACE(printf("setup_slice_num_and_roi_rec...slice_rois = %u total_slices = %d\n",
             slice_rois,total_slices))
 *num_slices = 0;
 if (slice_rois == NULL) 
    {*slices = NULL;
     return NO_ERROR;}
 for (cnt = 0,lcv = 0; lcv < total_slices; lcv++)
    if (is_slice_roi_non_empty(&(slice_rois[lcv])))
       cnt += 1;
 TRACE(printf("setup_slice_num_and_roi_rec...cnt = %d\n",
             cnt))
 if (cnt == 0)
    *slices = NULL;
   else
    {if ((err = get_ptr(slices,num_slices,cnt,sizeof(**slices))) != NO_ERROR)
        return err;
     for (cnt = 0,lcv = 0; lcv < total_slices; lcv++)
        if (is_slice_roi_non_empty(&(slice_rois[lcv])))
           {(*slices)[cnt].slice_num = lcv;
            (*slices)[cnt++].slice_roi = &(slice_rois[lcv]);}
    }
 TRACE(printf("setup_slice_num_and_roi_rec...end\n"))
 return NO_ERROR;
}


/*------------------------------------------------------------------------
WrRiaNdatFile - ???
------------------------------------------------------------------------*/

int
WrRiaNdatFile(fn,hdr,slice_rois,total_slices,
                histo,pixel_type,groups,num_groups,format,count)
 char *fn;
 struct output_hdr_rec *hdr;
 struct slice_roi_rec *slice_rois;
 long total_slices;
 struct histo_params_rec *histo;
 struct pixel_type_rec *pixel_type;
 struct text_output_analysis_group_rec *groups;
 unsigned long num_groups;
 struct output_text_format_rec *format;
 struct count_analysis_rec *count;
{
 FILE *fid;
 unsigned long offset;
 struct slice_num_and_roi_rec *slices;
 long num_slices;
 int err;

 TRACE(printf("WrRiaNdatFile...\n");)
 if (((err = setup_slice_num_and_roi_rec(slice_rois,total_slices,
                 &slices,&num_slices)) != NO_ERROR) ||
     ((err = setup_slice_nums(hdr,slices,num_slices,total_slices)) != NO_ERROR))
    {c_free(slices);
     return err;}
 TRACE(printf("WrRiaNdatFile...1\n");)

 if ((fid = fopen(fn,"w")) == NULL)
    {c_free(slices);
     return FILE_ACCESS_ERROR;}

 if ((err = wr_output_hdr_rec(fid,hdr,&offset)) != NO_ERROR)
    {c_free(slices);
     fclose(fid);
     return err;}
 TRACE(printf("WrRiaNdatFile...2\n");)

 hdr->offset.slice_roi_start = ftell(fid);
 TRACE(printf("slice_roi_start = %d\n",
         hdr->offset.slice_roi_start))
 err = WRITE_ERROR;
 if ((fwrite(&(hdr->actual_total_slice_rois),
                 sizeof(hdr->actual_total_slice_rois),1,fid) == 1) &&
     (fwrite(&(hdr->num_slice_rois),
               (size_t) sizeof(hdr->num_slice_rois),1,fid) == 1) &&
     ((err = wr_output_slice_nums(fid,hdr->slice_nums,hdr->num_slice_rois)) ==
               NO_ERROR) &&
     ((err = wr_ria_slice_rois(fid,slices,num_slices)) == NO_ERROR))
    {
     fflush(fid);
     hdr->offset.histo_params_start = hdr->offset.slice_roi_size = 
                       ftell(fid);
     hdr->offset.slice_roi_size -= hdr->offset.slice_roi_start;

     if ((err = wr_histo_params(fid,histo)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}

     TRACE(printf("after wr_histo_params...\n"))
     fflush(fid);
     hdr->offset.histo_params_size =
                           hdr->offset.pixel_type_params_start = ftell(fid);
     hdr->offset.histo_params_size -= 
                          hdr->offset.histo_params_start;
     TRACE(printf("histo_params_size = %d\n",
                        hdr->offset.histo_params_size))

     if ((err = wr_pixel_type_params(fid,pixel_type)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);

     hdr->offset.pixel_type_params_size =
                           hdr->offset.text_format_start = ftell(fid);
     hdr->offset.pixel_type_params_size -= 
                          hdr->offset.pixel_type_params_start;
     TRACE(printf("pixel_type_params_size = %d\n",
                        hdr->offset.pixel_type_params_size))

     if (((err = wr_input_text_file_format(fid,groups,num_groups)) != NO_ERROR) ||
         ((err = wr_output_text_file_format(fid,format)) != NO_ERROR))
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);
     hdr->offset.text_format_size = hdr->offset.count_start = ftell(fid);
     hdr->offset.text_format_size -=
                            hdr->offset.text_format_start;
     if ((err = wr_count_analysis_rec(fid,count)) != NO_ERROR)
        {c_free(slices);
         fclose(fid);
         return err;}
     fflush(fid);
     hdr->offset.count_size = hdr->size = ftell(fid);
     hdr->offset.count_size -= hdr->offset.count_start;

     fseek(fid,0L,0);
     if (fwrite(&(hdr->size),(size_t) sizeof(hdr->size),1,fid) == 1)
        {fseek(fid,(size_t) offset,0);
         err = wr_output_field_offset_rec(fid,&(hdr->offset)); 
        }
       else err = WRITE_ERROR;
     }
 c_free(slices);
 fclose(fid);
 TRACE(printf("WrRiaNdatFile end err = %d\n",err))
 return err;

}

