/****************************************************************************
str.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This file has routines to manipulate strings.

FIXME:  The files str.c and strsortnochg.c seem to contain similar but not
quite identical code.  It is not known which version is the correct version,
but I have arbitrarily removed strsortnochg.c from the library.
   -PWH 19990315
****************************************************************************/

static const char rcsid[] = "$Id: str.c,v 1.6 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>

#include "error_constants.h"
#include "str_def.h"
#include "typedef.h"
#include "nria_lib.h"




/*-------------------------------------------------------------------------
sort_str_proc - ???
-------------------------------------------------------------------------*/

int
sort_str_proc(str1,str2)
 char **str1,**str2;
{
 return str_cmp(*str1,*str2);
}


/*-------------------------------------------------------------------------
sort_no_case_str_proc - ???
-------------------------------------------------------------------------*/

int
sort_no_case_str_proc(str1,str2)
 char **str1,**str2;
{
 return no_case_str_cmp(*str1,*str2);
}


/*-------------------------------------------------------------------------
obj_binary_search - ???
-------------------------------------------------------------------------*/

int
obj_binary_search(objs,num_objs,obj_size,search_obj,search_proc,insert_posi)
 unsigned char *objs;
 unsigned long num_objs;
 unsigned long obj_size;
 void *search_obj;
 int (*search_proc)();
 unsigned long *insert_posi;
{
 int low,high,mid,result;

 low = *insert_posi = 0;
 if (num_objs > 0)
    {high = num_objs - 1;
     while (low <= high)
       {mid = (low + high) / 2;
        result = search_proc(search_obj,objs + mid * obj_size);
        if (result == 0)
           {*insert_posi = mid;
            return NO_ERROR;}
          else if (result < 0)
           {*insert_posi = mid;
            high = mid - 1;
           }
          else 
           {
            low = mid + 1;
            *insert_posi = low;
           }
       }
   }
 return NOT_FOUND;
}



/*-------------------------------------------------------------------------
get_strlen - ???

 get the string length of a string str --
     this routine is equivalent to strlen(str) except that 0 is return if
     str = NULL
-------------------------------------------------------------------------*/

size_t 
get_strlen(str)
 char *str;
{
 if (str == NULL) return 0;
    else return strlen(str);
}


/*-------------------------------------------------------------------------
center_str - ???

  max_str_size <= the maximal string memory size
-------------------------------------------------------------------------*/

int
center_str(str,max_str_size)
 char *str;
 unsigned long max_str_size;
{
 unsigned long lcv,len,indx,size,cnt;

 if (str == NULL) return CANCEL;
 len = strlen(str);
 size = max_str_size - 1;
 if (len > size) return NO_ERROR;
 str[size] = '\0';
 if (size == 0) return NO_ERROR;

 indx = size / 2 + len / 2;
 if (len % 2) indx++;
 for (lcv = size; lcv > indx; )
    {lcv--;
     str[lcv] = ' ';}
 for (cnt = len; cnt > 0; )
    {cnt--;
     lcv--;
     str[lcv] = str[cnt];}
 for (cnt = 0; cnt < lcv; cnt++)
    str[cnt] = ' ';
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
blank_in_str - ???
-------------------------------------------------------------------------*/

int
blank_in_str(str,blank_posi)
 char *str;
 unsigned long *blank_posi;
{
 unsigned long lcv,len;

 len = get_strlen(str);
 *blank_posi = 0;
 for (lcv = 0; lcv < len; lcv++)
    if (str[lcv] == ' ')
       {*blank_posi = lcv;
        return NO_ERROR;}
 return NOT_FOUND;
}


/*-------------------------------------------------------------------------
no_blank_in_str - ???
-------------------------------------------------------------------------*/

void
no_blank_in_str(str)
 char *str;
{
 unsigned long lcv,cnt;

 for (cnt = lcv = 0; str[lcv] != '\0'; lcv++)
    if (str[lcv] != ' ')
       str[cnt++] = str[lcv];
 str[cnt] = '\0';
}


/*-------------------------------------------------------------------------
strlen_max - ???

strlen(str) is return if strlen < max_len else max_len is return,
      to indicate the length of a string str. 
-------------------------------------------------------------------------*/

unsigned long 
strlen_max(str,max_len)
 char *str;            /* a string */
 unsigned long max_len; /* the maximum allowable length of the string str */
{
 unsigned long cnt;

 for (cnt = 0; cnt < max_len; cnt++)
    if (str[cnt] == '\0') break;
 return cnt;

}


/*-------------------------------------------------------------------------
set_str_len - ???

set the string length to len
-------------------------------------------------------------------------*/

void
set_str_len(str,len) 
 char *str; /* a string */
 int len;   /* given length to be set */
{
 unsigned long len1;
 unsigned long lcv;

 len1 = get_strlen(str);
 if (len1 < len)
    {
     for (lcv = len1; lcv < len; lcv++)
        str[lcv] = ' ';
    }
 str[len] = '\0';
}


/*-------------------------------------------------------------------------
TrimLeadingStrCh - ???
-------------------------------------------------------------------------*/

void
TrimLeadingStrCh(str,ch)
 char *str,ch;
{
 int cnt;

 if (str == NULL) return;
 for (cnt = 0; str[cnt] == ch; cnt++);

 if (cnt > 0) strcpy(str,&(str[cnt]));
}


/*-------------------------------------------------------------------------
TrimTrailingStrCh - ???
-------------------------------------------------------------------------*/

void
TrimTrailingStrCh(str,ch)
 char *str,ch;
{
 int cnt;

 if (str == NULL) return;
 for (cnt = strlen(str) - 1; ((cnt >= 0) && (str[cnt] == ch)); cnt--);

 cnt += 1;
 str[cnt] = '\0';

}


/*-------------------------------------------------------------------------
trim_str_blanks - ???
-------------------------------------------------------------------------*/

void
trim_str_blanks(str)
 char *str;
{
 TrimLeadingStrCh(str,' ');
 TrimTrailingStrCh(str,' ');
}


/*-------------------------------------------------------------------------
drop_last_element - ???
-------------------------------------------------------------------------*/

void
drop_last_element(str,separator)
 char *str;
 char separator;
{
 unsigned long cnt,len;

 len = strlen(str);
 if (len > 0)
   {for (cnt = len - 1; cnt > 0; cnt--)
       if (str[cnt] == separator)
          break;
    str[cnt] = '\0';
   }
}



/*-------------------------------------------------------------------------
blank_str - ???
-------------------------------------------------------------------------*/

void
blank_str(str,elems)
 char *str;
 unsigned long elems;
{
 unsigned long cnt;

 if (elems - 1 > 0)
    {for (cnt = 0; cnt < elems - 1; cnt++) str[cnt] = ' ';
        str[elems - 1] = '\0';}
   else
    str[0] = '\0';

}


/*-------------------------------------------------------------------------
left_pad_str - ???

if strlen(str) < max_len, pad the left side of the string with character ch
-------------------------------------------------------------------------*/

void
left_pad_str(str,max_len,ch)
 char *str;             /* a string */
 char ch;               /* the character to be used for padding */
 unsigned long max_len;  /* the maximum allowable length of the string str */
{
 unsigned long len,cnt,indx;

 len = strlen_max(str,max_len);
 str[max_len] = '\0';
 if ((len < max_len) && (max_len > 0) && (len > 0))
    {
     for (cnt = max_len - 1,indx = len - 1; ;cnt--,indx--)
        {str[cnt] = str[indx];
         if (indx == 0) break;}
     for (indx = 0;indx < cnt; indx++) str[indx] = ch;}
}


/*-------------------------------------------------------------------------
right_pad_str - ???

if strlen(str) < max_len, pad the right side of the string with character ch
-------------------------------------------------------------------------*/

void
right_pad_str(str,max_len,ch)  
 char *str;             /* a string */
 char ch;               /* the character to be used for padding */
 unsigned long max_len;  /* the maximum allowable length of the string str */
{
 unsigned long len,cnt;

 len = strlen_max(str,max_len);
 str[max_len] = '\0';
 if (len < max_len)
    {
     for (cnt = len; cnt < max_len; cnt++)
        str[cnt] = ch;
     }
}



/*-------------------------------------------------------------------------
copy_str - ???

to copy an "input_str" to a dynamically allocated output string pointed to by "output_str_ptr".  And "output_len" is the length of output_str_ptr.
-------------------------------------------------------------------------*/

int
copy_str(output_str_ptr,input_str,output_len)
 char **output_str_ptr;  /* output - a pointer to a dynamically allocated string
                          */
 char *input_str;       /* the input string */
 size_t output_len;      /* input string length */
{
 size_t len;

 if ((*output_str_ptr = (char *) malloc((size_t) ((output_len + 1) *
                    (size_t) sizeof(char)) )) == NULL)
    {perror("not enough memory for string value...\n");
     return NOT_ENOUGH_MEMORY;}
 len = get_strlen(input_str);
 if (len > output_len) len = output_len;
 strncpy(*output_str_ptr,input_str,len);
 (*output_str_ptr)[len] = '\0';
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cp_str - ???
-------------------------------------------------------------------------*/

int
cp_str(output_str_ptr,input_str)
 char **output_str_ptr;  /* output - a pointer to a dynamically allocated string
                          */
 char *input_str;       /* the input string */
{
 if (input_str == NULL) *output_str_ptr = NULL;
   else return copy_str(output_str_ptr,input_str,(size_t) strlen(input_str));

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
str_ncpy - ???
-------------------------------------------------------------------------*/

int
str_ncpy(output_str,output_len,input_str)
 char *output_str;
 char *input_str;
 int output_len;
{
 int len;

 if (output_len > 0)
    {if (input_str == NULL) output_str[0] = '\0';
       else
        {len = strlen(input_str);
         if (len >= output_len) len = output_len - 1;
         strncpy(output_str,input_str,len);
         output_str[len] = '\0';
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
 - ???

copy "size" # of characters from str2 to str1;  however if str2 is NULL,
   '\0' is assigned to str1[0] to indicate that str1 is of length 0
-------------------------------------------------------------------------*/

void
str_cpy1(str1,str2,size)
 char *str1,*str2;
 size_t size;
{
 if (str2 == NULL) str1[0] = '\0';
   else 
    {
     strncpy(str1,str2,size);
     str1[size] = '\0';}
}


/*-------------------------------------------------------------------------
str_dealloc_and_cpy - ???
-------------------------------------------------------------------------*/

int
str_dealloc_and_cpy(str1,str2)
 char **str1,*str2;
{
 int err;
 char *str;

 if (str2 == NULL)
    {
     if (*str1 != NULL) free(*str1);
     *str1 = NULL;
     return NO_ERROR;}

 if ((err = cp_str(&str,str2)) == NO_ERROR)
    {if (*str1 != NULL) free(*str1);
     *str1 = str;}
 return err;
}


/*-------------------------------------------------------------------------
concat_strs - ???

 concat_strs(&str,5,"1","2","3","4","5");

FIXME:  This function make two passes over its stdarg argments, which 
might or might not be legal and portable.  -PWH 19990405
-------------------------------------------------------------------------*/

int
concat_strs(
    char **str_ptr, /* output - a pointer to a dynamically allocated string */
    int num_strs,
    ...)
{
 va_list args;
 int cnt;
 char *str;       /* an input string */
 unsigned long size, len;

 va_start(args, num_strs);

 size = 0;
 for (cnt = 0; cnt < num_strs; cnt++)
    {str = va_arg(args, char *);
     if (str != NULL)
        size += strlen(str);
    }

 if ((*str_ptr= (char *) malloc((size_t) ((size + 1) *
                                (size_t) sizeof(char)) )) == NULL)
    {printf("not enough memory..from concat_strs...\n");
     return NOT_ENOUGH_MEMORY;}

 (*str_ptr)[0] = '\0';
 if (size > 0) {
     va_start(args, num_strs);
     
     for (size = 0,cnt = 0; cnt < num_strs; cnt++)
        {str = va_arg(args, char *);
         if (str != NULL)
           {len = strlen(str);
            strncat(&((*str_ptr)[size]),str,(size_t) len);
            size += len;}
        }
     va_end(args);
 }

 return NO_ERROR;
}


#if 0    /* Old varargs version */
int
concat_strs(va_alist)
 va_dcl
{
 va_list args;

 char **str_ptr,**dummy;/* output - a pointer to a dynamically allocated string
                          */
 unsigned long num_strs;
 char *str;       /* the input string */
 unsigned long cnt,size,len;

 va_start(args);
 str_ptr = va_arg(args,char **);
 num_strs = (unsigned long) va_arg(args,int);

 for (size = 0,cnt = 0; cnt < num_strs; cnt++)
    {str = va_arg(args, char *);
     if (str != NULL)
        size += strlen(str);
    }

 if ((*str_ptr= (char *) malloc((size_t) ((size + 1) *
                                (size_t) sizeof(char)) )) == NULL)
    {printf("not enough memory..from concat_strs...\n");
     return NOT_ENOUGH_MEMORY;}

 (*str_ptr)[0] = '\0';
 if (size > 0)
    {va_start(args);
     dummy = va_arg(args,char **);
     len = (unsigned long) va_arg(args,int);

     for (size = 0,cnt = 0; cnt < num_strs; cnt++)
        {str = va_arg(args, char *);
         if (str != NULL)
           {len = strlen(str);
            strncat(&((*str_ptr)[size]),str,(size_t) len);
            size += len;}
        }
    }
 va_end(args);
 return NO_ERROR;
}
#endif


/*-------------------------------------------------------------------------
append_strs - ???

FIXME:  This function makes two passes over its stdarg arguments, which
might or might not be legal and portable.  -PWH 19990405
-------------------------------------------------------------------------*/

int
append_strs(
    char **str_ptr,
    int num_strs,
    ...)
{
 va_list args;
 char *tempptr;
 char *str;       /* an input string */

 unsigned long cnt,size,len,len1,total,str_len;
 int err;

 va_start(args, num_strs);
 size = 0;
 for (cnt = 0; cnt < num_strs; cnt++)
    {str = va_arg(args, char *);
     if (str != NULL)
        size += strlen(str);
    }
 va_end(args);

 tempptr = *str_ptr;
 if ((*str_ptr != NULL) && (size == 0)) return NO_ERROR;
 str_len = len1 = get_strlen(*str_ptr);
 if (*str_ptr != NULL)
    {total = size;
     len1 += 1;}
 else total = size + 1;

 get_ptr_memory(str_ptr,&len1,total,1,&err);
 if (err != NO_ERROR) return err;

 if (tempptr == NULL) (*str_ptr)[0] = '\0';
 if (size > 0)
    {va_start(args, num_strs);
     size = str_len;
     for (cnt = 0; cnt < num_strs; cnt++)
        {str = va_arg(args, char *);
         if (str != NULL)
           {len = strlen(str);
            strncat(&((*str_ptr)[size]),str,(size_t) len);
            size += len;}
        }
     va_end(args);
    }

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
con_str_fields - ???
-------------------------------------------------------------------------*/

int
con_str_fields(out_str,strs,num_strs,con_ch)
 char **out_str,**strs;
 unsigned long num_strs;
 char con_ch;
{
 unsigned long cnt,size,*lens;

 if ((lens = (unsigned long *) malloc((size_t) (num_strs *
                                (size_t) sizeof(unsigned long)) )) == NULL)
    {return NOT_ENOUGH_MEMORY;}
 for (size = 0,cnt = 0; cnt < num_strs; cnt++)
    {
     if (strs[cnt] != NULL)
        {lens[cnt] = strlen(strs[cnt]);
         size += lens[cnt];
        }
       else lens[cnt] = 0;
    }

 if ((*out_str= (char *) malloc((size_t) ((size + num_strs) *
                                (size_t) sizeof(char)) )) == NULL)
    {
     return NOT_ENOUGH_MEMORY;}

 (*out_str)[0] = '\0';
 if (size > 0)
    {for (size = 0,cnt = 0; cnt < num_strs; cnt++)
        {if (lens[cnt] > 0)
           {strncat(&((*out_str)[size]),strs[cnt],(size_t) lens[cnt]);
            size += lens[cnt];
            if (cnt != (num_strs - 1))
               (*out_str)[size++] = con_ch;
           }
        }
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_str_ptr - ???

setup_str_ptr("ABCD","CBGH",0);

This function uses varargs and cannot be converted to stdarg without 
changing the calling sequence.  Fortunately, it is never used and has
therefore just been commented out.  -PWH 19990405
-------------------------------------------------------------------------*/

#if 0
char **
setup_str_ptr(va_alist)
 va_dcl
{
 va_list args;
 char **ptr,*temp;
 int cnt;

 va_start(args);
 for (cnt = 0; va_arg(args, char *) != (char *) 0; cnt++)
    {};
 if (cnt == 0) return NULL;
 if ((ptr = (char **) malloc((size_t) (cnt * (size_t) sizeof(char *)) )) 
           == NULL)
    {
     va_end(args);
     return NULL;}
 va_start(args);
 for (cnt = 0; (temp = va_arg(args, char *)) != (char *) 0; cnt++)
    {ptr[cnt] = temp;};
 va_end(args);
 return ptr;
}
#endif


/*-------------------------------------------------------------------------
copy_strs - ???
-------------------------------------------------------------------------*/

int 
copy_strs(outstrs,num_outstrs,instrs,num_instrs)
 char ***outstrs;
 unsigned long *num_outstrs;
 char **instrs;
 unsigned long num_instrs;
{
 size_t temp;

 if ((*outstrs = (char **) malloc((size_t) (num_instrs *
               sizeof(char *)) )) == NULL)
    {*outstrs = NULL;
     *num_outstrs = 0;
     return NOT_ENOUGH_MEMORY;}
   else
    {for (*num_outstrs = 0; *num_outstrs < num_instrs; (*num_outstrs)++)
        {temp = strlen(instrs[*num_outstrs]);
         copy_str(&((*outstrs)[*num_outstrs]),instrs[*num_outstrs],temp);
        }
    }
 return NO_ERROR;
   
}


/*-------------------------------------------------------------------------
delete_strs - ???
-------------------------------------------------------------------------*/

int
delete_strs(ary,elems,strs,num_strs,deallocate_str,status)
 char ***ary; /* modify */
 int *elems;
 char *strs[];
 unsigned long num_strs;
 unsigned char deallocate_str,*status;
{
 char **ptr;
 unsigned char delete;
 int cnt,lcv;
 unsigned int indx;

 *status = 0;
 if (*elems <= 0) return NO_ERROR;
 for (delete = 0,lcv = 0; lcv < num_strs; lcv++)
    {
     if (obj_binary_search(*ary,*elems,
        sizeof(**ary),&(strs[lcv]),sort_str_proc,&indx) == NO_ERROR)
        {if (deallocate_str) free((*ary)[indx]);
         *elems -= 1;
         for (cnt = indx; cnt < *elems; cnt++) (*ary)[cnt] = (*ary)[cnt+1];
         delete = 1;}
       
    }
 if (delete)
    if (*elems > 0)
       {if ((ptr = (char **) malloc((size_t) (*elems *
                      sizeof(char *)) )) == NULL)
           {*status = 1;
            return NOT_ENOUGH_MEMORY;}
          else 
           {for (cnt = 0; cnt < *elems; cnt++) ptr[cnt] = (*ary)[cnt];
            free(*ary);
            *ary = ptr;}
       }
      else free(*ary);

 return NO_ERROR;
}



/*-------------------------------------------------------------------------
no_duplicate_strs - ???

1) assume that the strings are sorted ascendingly;
2) get rid of duplicate strings;
3) if *status == 0 then no error;
      if *status == 1 then not enough memory, ary is unsorted
      if *status == 2 then not enough memory, ary is sorted but its length
                      of memory = val(old(elems)) of (char **) longer than
                                  val(new(elems) of (char **)
-------------------------------------------------------------------------*/

void
no_duplicate_strs(ary,elems,deallocate_str,status)
 char ***ary; /* modify */
 int *elems;
 unsigned char deallocate_str,*status;
{
 char **ptr,*str;
 int cnt,indx;

 *status = 0;
 if (*elems <= 0) return;
 if ((ptr = (char **) malloc((size_t) (*elems * sizeof(char *)) )) != NULL)
    {str = (*ary)[0];
     ptr[0] = (*ary)[0];
     indx = 1;
     for (cnt = 1; cnt < *elems; cnt++)
        if (strcmp(str,(*ary)[cnt]) != 0)
           {ptr[indx] = (*ary)[cnt];
            indx += 1;
            str = (*ary)[cnt];}
          else if (deallocate_str)
            {free((*ary)[cnt]);
            }
     if (indx != *elems)
        {free(*ary);
         if ((*ary = (char **) malloc((size_t) (indx * 
                           sizeof(char *)) )) == NULL)
            {*ary = ptr;
             *status = 2;}
           else
            {for (cnt = 0; cnt < indx; cnt++) (*ary)[cnt] = ptr[cnt];
             free(ptr);}
         *elems = indx;}
    }
   else *status = 1;
}

/*
 if str_binary_search == NO_ERROR, the str is found and insert_posi is its
   array index
  else insert_posi is the array index by which the str can be inserted into
           ary
*/
/*********************
int str_binary_search(ary,elems,str,insert_posi)
 char *ary[];
 unsigned long elems;
 char *str;
 unsigned long *insert_posi;
{
 int low,high,mid,result;

 low = *insert_posi = 0;
 if (elems > 0)
    {high = elems - 1;
     while (low <= high)
       {mid = (low + high) / 2;
        result = str_cmp(str,ary[mid]);
        if (result == 0)
           {*insert_posi = mid;
            return NO_ERROR;}
          else if (result < 0)
           {*insert_posi = mid;
            high = mid - 1;
           }
          else 
           {
            low = mid + 1;
            *insert_posi = low;
           }
       }
   }
 return NOT_FOUND;
}
********************/



/*-------------------------------------------------------------------------
insert_strs - ???
-------------------------------------------------------------------------*/

void
insert_strs(strs,total_slots,num_strs,str,insert_posi)
 char **strs;
 unsigned long total_slots;
 unsigned long *num_strs;
 char *str;
 unsigned long insert_posi;
{
 unsigned long lcv;

 if ((insert_posi < total_slots) && (*num_strs + 1 <= total_slots) &&
     (insert_posi <= *num_strs))
    {for (lcv = *num_strs; lcv > insert_posi; lcv--)
        strs[lcv] = strs[lcv - 1];
     strs[insert_posi] = str;
     *num_strs += 1;}
}


/*-------------------------------------------------------------------------
insert_str_to_sorted_list - ???
-------------------------------------------------------------------------*/

int 
insert_str_to_sorted_list(sorted_strs,num_sorted_strs,str,insert_posi)
 char ***sorted_strs;
 unsigned long *num_sorted_strs;
 char *str;
 unsigned long *insert_posi;
{
 unsigned long temp;
 int err;

 if (obj_binary_search(*sorted_strs,*num_sorted_strs,
        sizeof(**sorted_strs),&str,sort_str_proc,insert_posi)
      == NOT_FOUND)
    {
     get_handle_memory(sorted_strs,num_sorted_strs,(unsigned long) 1,
                     (size_t) sizeof(char *),&err);
     if (err == NO_ERROR)
        {temp = *num_sorted_strs - 1;
         insert_strs(*sorted_strs,*num_sorted_strs,&temp,str,*insert_posi);
         err = NOT_FOUND;}
     return err;
    }
  else return NO_ERROR;
}


/*-------------------------------------------------------------------------
str_cmp - ???
-------------------------------------------------------------------------*/

int
str_cmp(str1,str2)
 char *str1,*str2;
{
 if (str1 == NULL)
    if (str2 == NULL) return 0;
       else return -1;
 if (str2 == NULL)
    if (str1 == NULL) return 0;
       else return 1;

 return strcmp(str1,str2);
}


/*-------------------------------------------------------------------------
upper_case_ch( - ???
-------------------------------------------------------------------------*/

int 
upper_case_ch(ch)
 int ch;
{
 if ((ch >= 'a') && (ch <= 'z'))
    ch = 'A' + ch - 'a';
 return ch;
}


/*-------------------------------------------------------------------------
lower_case_ch - ???
-------------------------------------------------------------------------*/

int 
lower_case_ch(ch)
 int ch;
{
 if ((ch >= 'A') && (ch <= 'Z'))
    ch = 'a' + ch - 'A';
 return ch;
}


/*-------------------------------------------------------------------------
lower_case_str - ???
-------------------------------------------------------------------------*/

int
lower_case_str(str)
 char *str;
{
 unsigned long lcv,len;
 int ch;

 if (str == NULL) return NO_ERROR;
 len = strlen(str);
 for (lcv = 0; lcv < len; lcv++)
    {ch = lower_case_ch((unsigned long) str[lcv]);
     str[lcv] = ch;
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
no_case_str_cmp - ???
-------------------------------------------------------------------------*/

int
no_case_str_cmp(str1,str2)
 char *str1,*str2;
{
 unsigned long lcv,len1,len2;
 int ch1,ch2;

 if (str1 == NULL)
    if (str2 == NULL) return 0;
       else return -1;
 if (str2 == NULL)
    if (str1 == NULL) return 0;
       else return 1;

 len1 = strlen(str1);
 len2 = strlen(str2);
 for (lcv = 0; ((lcv < len1) && (lcv < len2)); lcv++)
    {ch1 = upper_case_ch((int) str1[lcv]);
     ch2 = upper_case_ch((int) str2[lcv]);
     if (ch1 < ch2) return -1;
     if (ch1 > ch2) return 1;}
 if (len1 > len2) return 1;
   else if (len1 < len2) return -1;
 return 0;

}


/*-------------------------------------------------------------------------
string_found - ???
-------------------------------------------------------------------------*/

int 
string_found(ary,elems,str)
 char *ary[];
 int elems;
 char *str;
{
 int low,high,mid,result;

 low = 0;
 high = elems - 1;
 while (low <= high)
   {mid = (low + high) / 2;
    result = strcmp(str,ary[mid]);
    if (result == 0) return mid;
       else if (result < 0) high = mid - 1;
       else low = mid + 1;
   }
 return -1;
}

