/****************************************************************************
strsortnochg.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

FIXME:  The files str.c and strsortnochg.c seem to contain similar but not
quite identical code.  It is not known which version is the correct version,
but I have arbitrarily removed strsortnochg.c from the library.
   -PWH 19990315
****************************************************************************/

static const char rcsid[] = "$Id: strsortnochg.c,v 1.6 1999/07/07 18:01:07 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <sys/types.h>
#include <stdio.h>
#include <varargs.h>
#include <malloc.h>

#include "error_constants.h"
#include "typedef.h"
#include "nria_lib.h"


/*
cc -c str_sort_no_change.c
*/


/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)


/*
   This file has routines to manipulate strings.
5)  size_t get_strlen(str)
center_str(str,max_str_size)
blank_in_str(str,blank_posi)
unsigned int strlen_max(str,max_len)
set_str_len(str,len) 

trim_trailing_str_blanks(str)
trim_leading_str_blanks(str)
trim_str_blanks(str)
drop_last_element(str,separator)
blank_str(str,elems)
left_pad_str(str,max_len,ch)
right_pad_str(str,max_len,ch)


copy_str(output_str_ptr,input_str,input_len)
cp_str(output_str_ptr,input_str)
str_ncpy(output_str,output_len,input_str)
str_cpy1(str1,str2,size)
str_dealloc_and_cpy(str1,str2)
con_str_fields(out_str,strs,num_strs)
concat_strs(va_alist)
char **setup_str_ptr(va_alist)
 int copy_strs(outstrs,num_outstrs,instrs,num_instrs)

delete_strs(ary,elems,strs,num_strs,deallocate_str,status)
delete_str(ary,elems,str,deallocate_str,status)

no_duplicate_strs(ary,elems,deallocate_str,status)
int str_binary_search(ary,elems,str,insert_posi)
insert_strs(strs,total_slots,num_strs,str,insert_posi)
int insert_str_to_sorted_list(sorted_strs,num_sorted_strs,str,insert_posi)
str_cmp(str1,str2)
char upper_case_ch(ch)
char lower_case_ch(ch)
lower_case_str(str)
no_case_str_cmp(str1,str2)
int string_found(ary,elems,str)
*/


/* get the string length of a string str --
     this routine is equivalent to strlen(str) except that 0 is return if
     str = NULL
*/
size_t get_strlen(str)
 char *str;
{
 if (str == NULL) return 0;
    else return strlen(str);
}


/*
  max_str_size <= the maximal string memory size
*/
center_str(str,max_str_size)
 char *str;
 unsigned int max_str_size;
{
 unsigned int lcv,len,indx,size,cnt;

 if (str == NULL) return CANCEL;
 len = strlen(str);
 size = max_str_size - 1;
 if (len > size) return NO_ERROR;
 str[size] = '\0';
 if (size == 0) return NO_ERROR;

 indx = size / 2 + len / 2;
 if (len % 2) indx++;
 for (lcv = size; lcv > indx; )
    {lcv--;
     str[lcv] = ' ';}
 for (cnt = len; cnt > 0; )
    {cnt--;
     lcv--;
     str[lcv] = str[cnt];}
 for (cnt = 0; cnt < lcv; cnt++)
    str[cnt] = ' ';
 return NO_ERROR;
}

blank_in_str(str,blank_posi)
 char *str;
 unsigned int *blank_posi;
{
 unsigned int lcv,len;

 len = get_strlen(str);
 *blank_posi = 0;
 for (lcv = 0; lcv < len; lcv++)
    if (str[lcv] == ' ')
       {*blank_posi = lcv;
        return NO_ERROR;}
 return NOT_FOUND;
}

/* strlen(str) is return if strlen < max_len else max_len is return,
      to indicate the length of a string str. */
unsigned int strlen_max(str,max_len)
 char *str;            /* a string */
 unsigned int max_len; /* the maximum allowable length of the string str */
{
 unsigned int cnt;

 for (cnt = 0; cnt < max_len; cnt++)
    if (str[cnt] == '\0') break;
 return cnt;

}

/* set the string length to len */
set_str_len(str,len) 
 char *str; /* a string */
 int len;   /* given length to be set */
{
 str[len] = '\0';
}

trim_leading_str_blanks(str)
 char *str;
{
 int cnt;

 if (str == NULL) return;
 for (cnt = 0; str[cnt] == ' '; cnt++);

 if (cnt > 0) strcpy(str,&(str[cnt]));
}

trim_trailing_str_blanks(str)
 char *str;
{
 int cnt;

 if (str == NULL) return;
 for (cnt = strlen(str) - 1; ((cnt >= 0) && (str[cnt] == ' ')); cnt--);

 cnt += 1;
 str[cnt] = '\0';

}

trim_str_blanks(str)
 char *str;
{
 trim_leading_str_blanks(str);
 trim_trailing_str_blanks(str);
}

drop_last_element(str,separator)
 char *str;
 char separator;
{
 unsigned int cnt,len;

 len = strlen(str);
 if (len > 0)
   {for (cnt = len - 1; cnt > 0; cnt--)
       if (str[cnt] == separator)
          break;
    str[cnt] = '\0';
   }
}


blank_str(str,elems)
 char *str;
 unsigned int elems;
{
 unsigned int cnt;

 if (elems - 1 > 0)
    {for (cnt = 0; cnt < elems - 1; cnt++) str[cnt] = ' ';
        str[elems - 1] = '\0';}
   else
    str[0] = '\0';

}

/* if strlen(str) < max_len, pad the left side of the string with character ch
*/
left_pad_str(str,max_len,ch)
 char *str;             /* a string */
 char ch;               /* the character to be used for padding */
 unsigned int max_len;  /* the maximum allowable length of the string str */
{
 unsigned int len,cnt,indx;

 len = strlen_max(str,max_len);
 str[max_len] = '\0';
 if ((len < max_len) && (max_len > 0) && (len > 0))
    {
     for (cnt = max_len - 1,indx = len - 1; ;cnt--,indx--)
        {str[cnt] = str[indx];
         if (indx == 0) break;}
     for (indx = 0;indx < cnt; indx++) str[indx] = ch;}
}

/* if strlen(str) < max_len, pad the right side of the string with character ch
*/
right_pad_str(str,max_len,ch)  
 char *str;             /* a string */
 char ch;               /* the character to be used for padding */
 unsigned int max_len;  /* the maximum allowable length of the string str */
{
 unsigned int len,cnt;

 len = strlen_max(str,max_len);
 str[max_len] = '\0';
 if (len < max_len)
    {
     for (cnt = len; cnt < max_len; cnt++)
        str[cnt] = ch;
     }
}


/* to copy an "input_str" to a dynamically allocated output string pointed to by "output_str_ptr".  And "input_len" is the length of input_str.
*/
copy_str(output_str_ptr,input_str,input_len)
 char **output_str_ptr;  /* output - a pointer to a dynamically allocated string
                          */
 char *input_str;       /* the input string */
 size_t input_len;      /* input string length */
{
 if ((*output_str_ptr = (char *) malloc((size_t) ((input_len + 1) *
                    (size_t) sizeof(char)) )) == NULL)
    {perror("not enough memory for string value...\n");
     return NOT_ENOUGH_MEMORY;}
 strncpy(*output_str_ptr,input_str,input_len);
 (*output_str_ptr)[input_len] = '\0';
 return NO_ERROR;
}

cp_str(output_str_ptr,input_str)
 char **output_str_ptr;  /* output - a pointer to a dynamically allocated string
                          */
 char *input_str;       /* the input string */
{
 if (input_str == NULL) *output_str_ptr = NULL;
   else return copy_str(output_str_ptr,input_str,(size_t) strlen(input_str));

 return NO_ERROR;
}

str_ncpy(output_str,output_len,input_str)
 char *output_str;
 char *input_str;
 int output_len;
{

 if (output_len > 0)
    {if (input_str == NULL) output_str[0] = '\0';
       else
        {strncpy(output_str,input_str,output_len - 1);
         output_str[output_len] = '\0';
        }
    }
 return NO_ERROR;
}

/* copy "size" # of characters from str2 to str1;  however if str2 is NULL,
   '\0' is assigned to str1[0] to indicate that str1 is of length 0 */ 
str_cpy1(str1,str2,size)
 char *str1,*str2;
 size_t size;
{
 if (str2 == NULL) str1[0] = '\0';
   else 
    {
     strncpy(str1,str2,size);
     str1[size] = '\0';}
}

str_dealloc_and_cpy(str1,str2)
 char **str1,*str2;
{
 size_t size;
 int err;

 if (*str1 != NULL) 
    free(*str1);
 if (str2 == NULL)
    {*str1 = NULL;
     return NO_ERROR;}

 size = strlen(str2);
 err = copy_str(str1,str2,size);
 return err;
}

/*
 concat_strs(&str,5,"1","2","3","4","5");
*/
concat_strs(va_alist)
 va_dcl
{
 va_list args;

 char **str_ptr,**dummy;/* output - a pointer to a dynamically allocated string
                          */
 unsigned int num_strs;
 char *str;       /* the input string */

 unsigned int cnt,size,len;
 va_start(args);
 str_ptr = va_arg(args,char **);
 num_strs = (unsigned int) va_arg(args,int);

 for (size = 0,cnt = 0; cnt < num_strs; cnt++)
    {str = va_arg(args, char *);
     if (str != NULL)
        size += strlen(str);
    }

 if ((*str_ptr= (char *) malloc((size_t) ((size + 1) *
                                (size_t) sizeof(char)) )) == NULL)
    {printf("not enough memory..from concat_strs...\n");
     return NOT_ENOUGH_MEMORY;}

 (*str_ptr)[0] = '\0';
 if (size > 0)
    {va_start(args);
     dummy = va_arg(args,char **);
     len = (unsigned int) va_arg(args,int);

     for (size = 0,cnt = 0; cnt < num_strs; cnt++)
        {str = va_arg(args, char *);
         if (str != NULL)
           {len = strlen(str);
            strncat(&((*str_ptr)[size]),str,(size_t) len);
            size += len;}
        }
    }
 va_end(args);
 return NO_ERROR;
}

con_str_fields(out_str,strs,num_strs)
 char **out_str,**strs;
 unsigned long num_strs;
{
 unsigned int cnt,size,*lens;

 if ((lens = (unsigned int *) malloc((size_t) (num_strs *
                                (size_t) sizeof(unsigned int)) )) == NULL)
    {return NOT_ENOUGH_MEMORY;}
 for (size = 0,cnt = 0; cnt < num_strs; cnt++)
    {
     if (strs[cnt] != NULL)
        {lens[cnt] = strlen(strs[cnt]);
         size += lens[cnt];
        }
       else lens[cnt] = 0;
    }

 if ((*out_str= (char *) malloc((size_t) ((size + num_strs) *
                                (size_t) sizeof(char)) )) == NULL)
    {
     return NOT_ENOUGH_MEMORY;}

 (*out_str)[0] = '\0';
 if (size > 0)
    {for (size = 0,cnt = 0; cnt < num_strs; cnt++)
        {if (lens[cnt] > 0)
           {strncat(&((*out_str)[size]),strs[cnt],(size_t) lens[cnt]);
            size += lens[cnt];
            if (cnt != (num_strs - 1))
               (*out_str)[size++] = ' ';
           }
        }
    }
 return NO_ERROR;
}

/*
setup_str_ptr("ABCD","CBGH",0);
*/
char **setup_str_ptr(va_alist)
 va_dcl
{
 va_list args;
 char **ptr,*temp;
 int cnt;

 va_start(args);
 for (cnt = 0; va_arg(args, char *) != (char *) 0; cnt++)
    {};
 if (cnt == 0) return NULL;
 if ((ptr = (char **) malloc((size_t) (cnt * (size_t) sizeof(char *)) )) 
           == NULL)
    {
     va_end(args);
     return NULL;}
 va_start(args);
 for (cnt = 0; (temp = va_arg(args, char *)) != (char *) 0; cnt++)
    {ptr[cnt] = temp;};
 va_end(args);
 return ptr;
}

int copy_strs(outstrs,num_outstrs,instrs,num_instrs)
 char ***outstrs;
 unsigned int *num_outstrs;
 char **instrs;
 unsigned int num_instrs;
{
 size_t temp;

 if ((*outstrs = (char **) malloc((size_t) (num_instrs * sizeof(char *))
                  )) == NULL)
    {*outstrs = NULL;
     *num_outstrs = 0;
     return NOT_ENOUGH_MEMORY;}
   else
    {for (*num_outstrs = 0; *num_outstrs < num_instrs; (*num_outstrs)++)
        {temp = strlen(instrs[*num_outstrs]);
         copy_str(&((*outstrs)[*num_outstrs]),instrs[*num_outstrs],temp);
        }
    }
 return NO_ERROR;
   
}

delete_strs(ary,elems,strs,num_strs,deallocate_str,status)
 char ***ary; /* modify */
 int *elems;
 char *strs[];
 unsigned int num_strs;
 unsigned char deallocate_str,*status;
{
 char **ptr;
 unsigned char delete;
 int cnt,lcv;
 unsigned int indx;

 *status = 0;
 if (*elems <= 0) return NO_ERROR;
 for (delete = 0,lcv = 0; lcv < num_strs; lcv++)
    {if (str_binary_search(*ary,*elems,strs[lcv],&indx) == NO_ERROR)
        {if (deallocate_str) free((*ary)[indx]);
         *elems -= 1;
         for (cnt = indx; cnt < *elems; cnt++) (*ary)[cnt] = (*ary)[cnt+1];
         delete = 1;}
       
    }
 if (delete)
    if (*elems > 0)
       {if ((ptr = (char **) malloc((size_t) (*elems *
                   sizeof(char *)) )) == NULL)
           {*status = 1;
            return NOT_ENOUGH_MEMORY;}
          else 
           {for (cnt = 0; cnt < *elems; cnt++) ptr[cnt] = (*ary)[cnt];
            free(*ary);
            *ary = ptr;}
       }
      else free(*ary);

 return NO_ERROR;
}

/*
delete_str(ary,elems,str,deallocate_str,status)
 char ***ary;
 int *elems;
 char *str;
 unsigned char deallocate_str,*status;
{
 char **ptr;
 int cnt;
 unsigned int indx;

 *status = 0;
 if (*elems <= 0) return;

 printf("delete in elems = %d\n",*elems);
 for (cnt = 0; cnt < *elems; cnt++)
    printf("%d) %s\n",cnt,(*ary)[cnt]);
 if (str_binary_search(*ary,*elems,str,&indx) == NO_ERROR)
    {if (deallocate_str) free((*ary)[indx]);
     for (cnt = indx; cnt < *elems - 1; cnt++) (*ary)[cnt] = (*ary)[cnt+1];
     *elems -= 1;
     if (*elems > 0)
        {if ((ptr = (char **) malloc((size_t) (*elems * sizeof(char *))
                  )) == NULL)
           *status = 1;
          else 
           {for (cnt = 0; cnt < *elems; cnt++) ptr[cnt] = (*ary)[cnt];
            free(*ary);
            *ary = ptr;}
        }
       else free(*ary);
    }
 printf("out elems = %d\n",*elems);

}
*/

/* 1) assume that the strings are sorted ascendingly */
/* 2) get rid of duplicate strings */
/* 3) if *status == 0 then no error;
      if *status == 1 then not enough memory, ary is unsorted
      if *status == 2 then not enough memory, ary is sorted but its length
                      of memory = val(old(elems)) of (char **) longer than
                                  val(new(elems) of (char **) */
no_duplicate_strs(ary,elems,deallocate_str,status)
 char ***ary; /* modify */
 int *elems;
 unsigned char deallocate_str,*status;
{
 char **ptr,*str;
 int cnt,indx;

 *status = 0;
 if (*elems <= 0) return;
/*
 printf("duplicate in elems = %d\n",*elems);
*/
 if ((ptr = (char **) malloc((size_t) (*elems * sizeof(char *)) )) != NULL)
    {str = (*ary)[0];
     ptr[0] = (*ary)[0];
     indx = 1;
     for (cnt = 1; cnt < *elems; cnt++)
        if (strcmp(str,(*ary)[cnt]) != 0)
           {ptr[indx] = (*ary)[cnt];
            indx += 1;
            str = (*ary)[cnt];}
          else if (deallocate_str)
            {/* printf("before deallocate_str\n"); */
             free((*ary)[cnt]);
             /* printf("after deallocate_str\n"); */}
     if (indx != *elems)
        {free(*ary);
         if ((*ary = (char **) malloc((size_t) (indx * sizeof(char *))
                     )) == NULL)
            {*ary = ptr;
             *status = 2;}
           else
            {for (cnt = 0; cnt < indx; cnt++) (*ary)[cnt] = ptr[cnt];
             free(ptr);}
         *elems = indx;}
    }
   else *status = 1;
/*
 printf("out elems = %d\n",*elems);
*/
}

/*
 if str_binary_search == NO_ERROR, the str is found and insert_posi is its
   array index
  else insert_posi is the array index by which the str can be inserted into
           ary
*/

int str_binary_search(ary,elems,str,insert_posi)
 char *ary[];
 unsigned int elems;
 char *str;
 unsigned int *insert_posi;
{
 int low,high,mid,result;

 low = *insert_posi = 0;
 if (elems > 0)
    {high = elems - 1;
     while (low <= high)
       {mid = (low + high) / 2;
        result = str_cmp(str,ary[mid]);
        if (result == 0)
           {*insert_posi = mid;
            return NO_ERROR;}
          else if (result < 0)
           {*insert_posi = mid;
            high = mid - 1;
           }
          else 
           {
            low = mid + 1;
            *insert_posi = low;
           }
       }
   }
 return NOT_FOUND;
}

insert_strs(strs,total_slots,num_strs,str,insert_posi)
 char **strs;
 unsigned int total_slots;
 unsigned int *num_strs;
 char *str;
 unsigned int insert_posi;
{
 unsigned int lcv;

 if ((insert_posi < total_slots) && (*num_strs + 1 <= total_slots) &&
     (insert_posi <= *num_strs))
    {for (lcv = *num_strs; lcv > insert_posi; lcv--)
        strs[lcv] = strs[lcv - 1];
     strs[insert_posi] = str;
     *num_strs += 1;}
}

/*----------------------------------------------------------------------
other_insert_str_to_sorted_list - ???

FIXME:  There is a very similar function in str.c; it is not known which
of these is the right version.  In any case, this one has been given a
slightly different name to keep the compiler happy.
-----------------------------------------------------------------------*/

int 
other_insert_str_to_sorted_list(sorted_strs,num_sorted_strs,str,insert_posi)
 char ***sorted_strs;
 unsigned int *num_sorted_strs;
 char *str;
 unsigned int *insert_posi;
{
 unsigned int temp;
 int err;

 if (str_binary_search(*sorted_strs,*num_sorted_strs,str,insert_posi)
      == NOT_FOUND)
    {
     get_handle_memory(sorted_strs,num_sorted_strs,(unsigned int) 1,
                     (size_t) sizeof(char *),&err);
     if (err == NO_ERROR)
        {temp = *num_sorted_strs - 1;
         insert_strs(*sorted_strs,*num_sorted_strs,&temp,str,*insert_posi);
         err = NOT_FOUND;}
     return err;
    }
  else return NO_ERROR;
}

str_cmp(str1,str2)
 char *str1,*str2;
{
 if (str1 == NULL)
    if (str2 == NULL) return 0;
       else return -1;
 if (str2 == NULL)
    if (str1 == NULL) return 0;
       else return 1;

 return strcmp(str1,str2);
}

int upper_case_ch(ch)
 int ch;
{
 if ((ch >= 'a') && (ch <= 'z'))
    ch = 'A' + ch - 'a';
 return ch;
}

int lower_case_ch(ch)
 int ch;
{
 if ((ch >= 'A') && (ch <= 'Z'))
    ch = 'a' + ch - 'A';
 return ch;
}

lower_case_str(str)
 char *str;
{
 unsigned int lcv,len;
 int ch;

 if (str == NULL) return NO_ERROR;
 len = strlen(str);
 for (lcv = 0; lcv < len; lcv++)
    {ch = lower_case_ch((unsigned int) str[lcv]);
     str[lcv] = ch;
    }
 return NO_ERROR;
}

no_case_str_cmp(str1,str2)
 char *str1,*str2;
{
 unsigned int lcv,len1,len2;
 int ch1,ch2;

 if (str1 == NULL)
    if (str2 == NULL) return 0;
       else return -1;
 if (str2 == NULL)
    if (str1 == NULL) return 0;
       else return 1;

 len1 = strlen(str1);
 len2 = strlen(str2);
 for (lcv = 0; ((lcv < len1) && (lcv < len2)); lcv++)
    {ch1 = upper_case_ch((int) str1[lcv]);
     ch2 = upper_case_ch((int) str2[lcv]);
     if (ch1 < ch2) return -1;
     if (ch1 > ch2) return 1;}
 if (len1 > len2) return 1;
   else if (len1 < len2) return -1;
 return 0;

}

int string_found(ary,elems,str)
 char *ary[];
 int elems;
 char *str;
{
 int low,high,mid,result;

 low = 0;
 high = elems - 1;
 while (low <= high)
   {mid = (low + high) / 2;
    result = strcmp(str,ary[mid]);
    if (result == 0) return mid;
       else if (result < 0) high = mid - 1;
       else low = mid + 1;
   }
 return -1;
}

