/****************************************************************************
3d_param_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_param_menu.c,v 1.9 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "buf_3d_rec.h"
#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT14(x) x; fflush(stdout);
#define PRT15(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT1(x)
#define PRT(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT14(x)
#define PRT15(x)



/* ??? */
#define USE_FIRST "USE FIRST PARAM"
#define USE_SECOND "USE SECOND PARAM"

#define CLEAN_UP_PARAM 0
#define SETUP_PARAM 1
#define GET_ALL_PARAM_PTR 2



/*-------------------------------------------------------------------------
struct param_rec - ???
-------------------------------------------------------------------------*/

struct param_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item open_fn,open_dir,save_fn,save_dir;
   };


/*-------------------------------------------------------------------------
struct all_param_recs - ???
-------------------------------------------------------------------------*/

struct all_param_recs
   {
    int num_3ds;
    struct param_rec **_3ds;
   };


/*-------------------------------------------------------------------------
struct plane_param_rec - ???
-------------------------------------------------------------------------*/

struct plane_param_rec
   {
    struct vector_3d_rec base,normal,center,coord_ratio,rotate;
    int which_format,adjust_to_center;
    struct matrix_3d_rec xyztoplane;
   };


/*-------------------------------------------------------------------------
struct co_param_rec - ???
-------------------------------------------------------------------------*/

struct co_param_rec
   {
    struct plane_param_rec p1,p2;
   };



/*-------------------------------------------------------------------------
Local function prototypes
-------------------------------------------------------------------------*/

void init_param_rec(struct param_rec *_3d);
void free_param_rec(struct param_rec *_3d);
void init_all_param_recs(struct all_param_recs *all_3ds);
char *def_npar(struct image_display_window *win, char *dir, int *err,
    int is_last, int is_drop_suffix);
char *win_get_param_def_dir(struct image_display_window *win, int is_open);
int win_plane_npar(struct image_display_window *win, char **dir, char **fn,
    int is_open);
void _3d_param_done_proc(Frame frame);
int SaveNpar(char *dir, char *fn1, char *suffix, Frame frame, int is_replace,
    struct plane_3d_rec *gplane1, struct plane_3d_rec *gplane2,
    int which_format);
int win_save_npar(struct image_display_window *win);
int save_npar_proc(Panel_item item, Event *event);
int win_save_npco(struct image_display_window *win, char *co_wid);
int win_save_which_npco(struct image_display_window *win);
int save_npco_proc(Panel_item item, Event *event);
int open_npco_proc(Panel_item item, Event *event);
int is_same_ratio(double rx1, double ry1, double rz1, double rx2, double ry2,
    double rz2);
int ViewCheckAndResize(struct view_rec *view, int use_dimxy,
    unsigned long dimx, unsigned long dimy, double ratiox, double ratioy,
    double ratioz, int *is_resize);
int win_co_reg_params(struct image_display_window *win, char *wid);
int get_def_dimxy(struct view_rec *view, struct view_rec *view1,
    int *use_dimxy, unsigned long *dimx, unsigned long *dimy);
int open_co_reg_param(struct view_rec *view, char *wid,
    struct co_param_rec *pa);
int rd_params(FILE *fid, struct view_rec *view, Xv_Window window);
int win_open_the_plane(struct image_display_window *win, char *fn, char *dir);
int open_plane(struct param_rec *_3d, char *dir, char *fn);
int win_open_npar(struct image_display_window *win);
int open_npar_proc(Panel_item item, Event *event);
void open_plane_proc(Panel_item item, Event *event);
int win_show_param_fns(struct image_display_window *win, char *dirfn,
    char *fn_patt, int (*action_proc)());
int WinShowCurDirParamFns(struct image_display_window *win, char *fn_patt);
void param_more_proc(Panel_item item, Event *event);
int setup_param_rec(struct param_rec *_3d, struct image_display_window *win);
struct param_rec *find_param_rec(struct all_param_recs *all_3ds,
    struct image_display_window *win);
unsigned long enter_3d_param_menu(struct image_display_window *win,
    int status);



/*-------------------------------------------------------------------------
init_param_rec - ???
-------------------------------------------------------------------------*/

void
init_param_rec(_3d)
 struct param_rec *_3d;
{
 _3d->status = 0;
 _3d->win = NULL;
 _3d->frame  = 0;
}


/*-------------------------------------------------------------------------
free_param_rec - ???
-------------------------------------------------------------------------*/

void
free_param_rec(_3d)
 struct param_rec *_3d;
{
 struct all_param_recs *all_3ds;

 if (_3d->frame != 0)
    {
     destroy_all_subframes(_3d->frame);
     xv_destroy_safe(_3d->frame);}
 all_3ds = (struct all_param_recs *) enter_3d_param_menu(NULL,
            GET_ALL_PARAM_PTR);
 c_free(_3d);
 DropHandleAryPtr(&(all_3ds->_3ds),&(all_3ds->num_3ds),_3d);
}


/*-------------------------------------------------------------------------
init_all_param_recs - ???
-------------------------------------------------------------------------*/

void
init_all_param_recs(all_3ds)
 struct all_param_recs *all_3ds;
{
 all_3ds->num_3ds = 0;
 all_3ds->_3ds = NULL;
}


/*-------------------------------------------------------------------------
def_npar - ???
-------------------------------------------------------------------------*/

char *
def_npar(win,dir,err,is_last,is_drop_suffix)
 struct image_display_window *win;
 char *dir;
 int *err,is_last,is_drop_suffix;
{
 char *str,*str1,*wid,*wid1;
 struct img_buf_rec *img;
 struct view_rec *view;

 PRT(printf("def_npar is_last = %d  \n",
          is_last))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    {*err = CANCEL;
     return NULL;}
 if ((img->cur_slice->slice == NULL) || ((view = img->cur_slice->slice->view) == NULL))
    wid1 = win->owner->wid;
   else wid1 = view->wid;
 str1 = wid = NULL;

 if (((*err = cp_str(&wid,wid1)) == NO_ERROR) &&
     ((*err = lower_case_str(wid)) == NO_ERROR) &&
     ((*err = concat_strs(&str,2,img->file->output.fn,wid))
          == NO_ERROR))
    {PRT(printf("def_npar = str = %s\n",str))
     if (is_last)
        {if ((str1 = LastUniqueFn(dir,str,NPAR_SUFFIX)) == NULL)
           *err = CANCEL;
        }
       else if ((str1 = UniqueFn(dir,str,NPAR_SUFFIX)) == NULL)
        *err = CANCEL;
     if (*err == NO_ERROR)
        {drop_dirfn(str1);
         if (is_drop_suffix) drop_suffix(str1);}
    }
 c_free(wid);
 c_free(str);
 PRT(printf("def_npar final = %s\n",str1))
 return str1;
}


/*-------------------------------------------------------------------------
win_get_param_def_dir - ???
-------------------------------------------------------------------------*/

char *
win_get_param_def_dir(win,is_open)
 struct image_display_window *win;
 int is_open;
{
 struct all_param_recs *all_3ds;
 struct param_rec *_3d;
 struct img_buf_rec *img;
 char *dir;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    {dir = "";
     return dir;}
 if (((all_3ds = (struct all_param_recs *) enter_3d_param_menu(win,
              GET_ALL_PARAM_PTR)) != NULL) &&
     ((_3d = find_param_rec(all_3ds,win)) != NULL))
    {if (is_open) dir = (char *) xv_get(_3d->open_dir,PANEL_VALUE);
       else dir = (char *) xv_get(_3d->save_dir,PANEL_VALUE);}
   else dir = img->file->output.dirfn;
 if (dir == NULL) dir = "";
 PRT(printf("win_get_param_def_dir dir = %s\n",dir))
 return dir;
}


/*-------------------------------------------------------------------------
win_plane_npar - ???
-------------------------------------------------------------------------*/

int
win_plane_npar(win,dir,fn,is_open)
 struct image_display_window *win;
 char **dir,**fn;
 int is_open;
{
 struct all_param_recs *all_3ds;
 struct img_buf_rec *img;
 struct param_rec *_3d;
 int err;
 char *fn1;

 *dir = *fn = NULL;
 fn1 = NULL;
 PRT(printf("_3d_plane_npar is_open = %d\n",is_open))
 if ((all_3ds = (struct all_param_recs *) enter_3d_param_menu(win,
              GET_ALL_PARAM_PTR)) != NULL)
    {
     if ((_3d = find_param_rec(all_3ds,win)) != NULL)
        {fn1 = NULL;
         if (is_open)
           {if ((err = cp_str(dir,
                 (char *) xv_get(_3d->open_dir,PANEL_VALUE))) == NO_ERROR)
               err = cp_str(fn,(char *) xv_get(_3d->open_fn,PANEL_VALUE));
           }
          else if ((err = cp_str(dir,
                 (char *) xv_get(_3d->save_dir,PANEL_VALUE))) == NO_ERROR)
           err = cp_str(fn,(char *) xv_get(_3d->save_fn,PANEL_VALUE));
         return err;
        }
    }
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = cp_str(dir,img->file->output.dirfn)) == NO_ERROR)
    *fn = def_npar(win,*dir,&err,is_open,1);

 return err;
}


/*-------------------------------------------------------------------------
_3d_param_done_proc - ???
-------------------------------------------------------------------------*/

void
_3d_param_done_proc(frame)
 Frame frame;
{
 struct param_rec *_3d;

 _3d = (struct param_rec *)
                     xv_get(frame,WIN_CLIENT_DATA);
 free_param_rec(_3d);
}


/*-------------------------------------------------------------------------
SaveNpar - ???
-------------------------------------------------------------------------*/

int
SaveNpar(dir,fn1,suffix,frame,is_replace,gplane1,gplane2,which_format)
 char *dir,*fn1,*suffix;
 Frame frame;
 int is_replace;
 struct plane_3d_rec *gplane1,*gplane2;
 int which_format;
{
 int err;
 FILE *fid;
 char *thefn;

 PRT(printf("SaveNpar...dir = %s  fn = %s suffix = %s\n",dir,fn1,suffix))
 if ((err = open_output_file(dir,fn1,suffix,
        &thefn,&fid,frame,is_replace)) == NO_ERROR)
    {if ((err = WrPlaneParams(fid,&(gplane1->base),&(gplane1->normal),
          &(gplane1->center),&(gplane1->coord_ratio),
          &(gplane1->rotate),which_format,
          (unsigned long) (gplane1->status & PLANE_ADJUST_TO_CENTER),
          &(gplane1->xyztoplane))) == NO_ERROR)
        if (gplane2 != NULL)
           err = WrPlaneParams(fid,&(gplane2->base),&(gplane2->normal),
                &(gplane2->center),&(gplane2->coord_ratio),
                &(gplane2->rotate),which_format,
                (unsigned long) (gplane2->status & PLANE_ADJUST_TO_CENTER),
                &(gplane2->xyztoplane));
     fclose(fid);
     if (err != NO_ERROR) 
        {notice_prompt(frame,(Event *) NULL,
         NOTICE_MESSAGE_STRINGS,"File WRITE Error !!!",
                "Unable to save the .npar file !!!",0,
         NOTICE_BUTTON_YES,FAILED,0);
         delete_file(thefn);
        }
       else ShowMsgStrs(frame,1,NO_ERROR,2,2,
               thefn,"SAVED !!!",NULL,0);
    }
 c_free(thefn);
 return err;
}


/*-------------------------------------------------------------------------
win_save_npar - ???
-------------------------------------------------------------------------*/

int
win_save_npar(win)
 struct image_display_window *win;
{
 struct all_param_recs *all_3ds;
 struct param_rec *_3d;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *dir,*fn,*thefn,*fn1,*dirfn;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = win_plane_npar(win,&dir,&fn,0)) == NO_ERROR)
    {view = img->cur_slice->slice->view;
     PRT(printf("win_save_npar...dir = %s  fn = %s\n",dir,fn))
     err = SaveNpar(dir,fn,NPAR_SUFFIX,
             win->dwin->frame,0,&(view->gplane),NULL,0);
     if (err == NO_ERROR)
        if (((all_3ds = (struct all_param_recs *) enter_3d_param_menu(win,
              GET_ALL_PARAM_PTR)) != NULL) &&
            ((_3d = find_param_rec(all_3ds,win)) != NULL))
           {dirfn = (char *) xv_get(_3d->save_dir,PANEL_VALUE);
     PRT(printf("win_save_npar...dirfn = %s\n",dirfn))
            if ((fn1 = def_npar(win,dirfn,&err,0,1)) != NULL)
               {thefn = (char *) xv_get(_3d->save_fn,PANEL_VALUE);
     PRT(printf("win_save_npar.2..dirfn = %s\n",thefn))

                xv_set(_3d->open_fn,PANEL_VALUE,thefn,0);
                xv_set(_3d->save_fn,PANEL_VALUE,fn1,0);
                c_free(fn1);}
           }
     PRT(printf("win_save_npar...err = %d\n",err))
    }
 c_free(dir);
 c_free(fn);
 return err;
}


/*-------------------------------------------------------------------------
save_npar_proc - ???
-------------------------------------------------------------------------*/

int
save_npar_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;
 int err;

 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 err = win_save_npar(_3d->win);
 return err;
}


/*-------------------------------------------------------------------------
win_save_npco - ???
-------------------------------------------------------------------------*/

int
win_save_npco(win,co_wid)
 struct image_display_window *win;
 char *co_wid;
{
 struct view_rec *view,*view1;
 struct img_buf_rec *img;
 int err,err1;
 char *str2;
 char *dir,*fn;

 PRT(printf("win_save_npco...co_wid = %s\n",co_wid))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if ((view1 = find_any_view_rec(view->file,co_wid)) == NULL)
    {ShowMsgStrs(win->dwin->frame,0,0,0,3,
               co_wid,"doesn't exist !!!",
               "will not save the co-registered params !!!",NULL,0);
     return CANCEL;
    }
 fn = str2 = NULL;
 if (((dir = win_get_param_def_dir(win,0)) != NULL) &&
     ((err = concat_strs(&str2,3,img->file->output.fn,"-",
            view1->img->file->output.fn)) == NO_ERROR) &&
     ((fn = UniqueFn(dir,str2,NPCO_SUFFIX)) != NULL))
    {drop_suffix(fn);
     drop_dirfn(fn);
     PRT(printf("win_save_npco...dir = %s  fn = %s\n",dir,fn))
     err = SaveNpar(dir,fn,NPCO_SUFFIX,win->dwin->frame,0,
                    &(view->gplane),&(view1->gplane),7);
    }
   else err = CANCEL;
 c_free(fn);
 c_free(str2);

 if (err != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,1,
               "Error occurred when saving the co-registered params !!!",
               NULL,0);
     return err;}
 return err1;
}


/*-------------------------------------------------------------------------
win_save_which_npco - ???
-------------------------------------------------------------------------*/

int
win_save_which_npco(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct strs_rec *wids;
 int err;
 char *str,*dir;

 PRT(printf("win_save_which_npco...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT(printf("win_save_which_npco...1\n"))
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {view = img->cur_slice->slice->view;
     if ((err = co_registered_wids(view,wids,0,1,2)) != NO_ERROR)
        {free_strs_rec_ptrs(wids);
         c_free(wids);}
       else if (wids->num_strs == 1)
        {PRT(printf("win_save_which_npco...0\n"))
         err = win_save_npco(win,wids->strs[0]);
         free_strs_rec_ptrs(wids);
         c_free(wids);
         return err;
        }
       else
        {if (wids->num_strs == 0)
            add_str_ptr_to_strs_rec(wids,"NO CO-REGISTERED PLANE !!!");
         PRT(printf("win_save_which_npco...1\n"))
         dir = win_get_param_def_dir(win,0);
         PRT(printf("win_save_which_npco...dir = %s\n",dir))
         concat_strs(&str,4,win->owner->wid,dir," : ","SAVE .npco WITH");
         err = ShowMenuStrsProc(win->dwin->frame,NULL,str,
                    wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                    win_save_npco,win,1,0,0);
         c_free(str);
        }
     PRT(printf("win_save_which_npco...err = %d\n",err))
    }
 return err;
}


/*-------------------------------------------------------------------------
save_npco_proc - ???
-------------------------------------------------------------------------*/

int
save_npco_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;

 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 return win_save_which_npco(_3d->win);
}


/*-------------------------------------------------------------------------
open_npco_proc - ???
-------------------------------------------------------------------------*/

int
open_npco_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;
 char *dirfn;

 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dirfn = win_get_param_def_dir(_3d->win,1);
 return win_show_param_fns(_3d->win,dirfn,"*.npco",win_open_the_plane);
}


/*-------------------------------------------------------------------------
is_same_ratio - ???
-------------------------------------------------------------------------*/

int
is_same_ratio(rx1,ry1,rz1,rx2,ry2,rz2)
 float rx1,ry1,rz1,rx2,ry2,rz2;
{
 float x1,y1,z1;

 x1 = rx1 - rx2;
 y1 = ry1 - ry2;
 z1 = rz1 - rz2;
 if (x1 < .0) x1 = -x1;
 if (y1 < .0) y1 = -y1;
 if (z1 < .0) z1 = -z1;
 if ((x1 > .000002) || (y1 > .000002) || (z1 > .000002))
    {PRT2(printf("is_same_ratio rx1 = %f ry1 = %f rz1 = %f\n",rx1,ry1,rz1);
         printf("rx2 = %f ry2 = %f rz2 = %f\n",rx2,ry2,rz2);
         printf("x1 = %f y1 = %f z1 = %f\n",x1,y1,z1);)
     return 0;}
 return 1;
}


/*-------------------------------------------------------------------------
ViewCheckAndResize - ???
-------------------------------------------------------------------------*/

int
ViewCheckAndResize(view,use_dimxy,dimx,dimy,ratiox,ratioy,ratioz,is_resize)
 struct view_rec *view;
 int use_dimxy;
 unsigned long dimx,dimy;
 float ratiox,ratioy,ratioz;
 int *is_resize;
{
 struct buf_3d_rec *_3d;
 float x1,y1,z1;
 int err;

 PRT(printf("ViewCheckAndResize...\n");)
 if (view->img->win == NULL) return CANCEL;
 *is_resize = 0;
 if (!is_same_ratio(view->gplane.coord_ratio.x,view->gplane.coord_ratio.y,
         view->gplane.coord_ratio.z,ratiox,ratioy,ratioz))
    {if ((err = find_file_3d(view->img->file,view->id,&_3d)) == NO_ERROR)
        {x1 = _3d->xpixel_size * ratiox;
         y1 = _3d->ypixel_size * ratioy;
         z1 = _3d->zpixel_size * ratioz;
         err = win_resize_voxel_now1(view->img->win->image_display,
              use_dimxy,dimx,dimy,x1,y1,z1);
         *is_resize = 1;
        }
     return err;
    }
 return NO_ERROR;
}

/*-------------------------------------------------------------------------
win_co_reg_params - ???
-------------------------------------------------------------------------*/

int
win_co_reg_params(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct view_rec *view,*co_view;
 struct co_register_rec *co;
 struct img_buf_rec *img;
 int err;
 long indx;

 PRT14(printf("win_co_reg_params...1\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if ((co_view = find_any_view_rec(view->img->file,wid)) == NULL)
    return CANCEL;
/*
 if ((co = find_co_register_rec(view,co_view->wid,&indx,&err,0)) == NULL)
    {PRT14(printf("win_co_reg_params...win_co_register_to_wid\n"))
     return win_co_register_to_wid(win,wid);}
   else
    {run_next_view_proc(view,view_adjust_reco_register,view,co_view,co);
     view->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;
     co_view->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;

     run_next_view_proc(view,DisplayCoRegisteredAdjustedPlanes,1,1);
     clear_all_planes_co_process_status(view,0,1);
     PRT14(printf("win_co_reg_params...DisplayCoRegisteredAdjustedPlanes...end\n"))
     return NO_ERROR;
    }
*/
  if ((err = win_co_register_to_wid(win,wid)) == NO_ERROR)
     {if ((co = find_co_register_rec(view,co_view->wid,&indx,&err,0)) != NULL)
         {run_next_view_proc(view,view_adjust_reco_register,view,co_view,co,
			     0,0,0);
          view->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;
          co_view->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;

          run_next_view_proc(view,DisplayCoRegisteredAdjustedPlanes,1,1,
			     0,0,0,0);
          clear_all_planes_co_process_status(view,0,1);
          PRT14(printf("win_co_reg_params...DisplayCoRegisteredAdjustedPlanes...end\n"))
          err = NO_ERROR;}
    }
 return err;
}


/*-------------------------------------------------------------------------
get_def_dimxy - ???
-------------------------------------------------------------------------*/

int
get_def_dimxy(view,view1,use_dimxy,dimx,dimy)
 struct view_rec *view,*view1;
 int *use_dimxy;
 unsigned long *dimx,*dimy;
{
 
 if ((view->img->_2d.dimx > view1->img->_2d.dimx) &&
     (view->img->_2d.dimy > view1->img->_2d.dimy))
    {*use_dimxy = 1;
     *dimx = view->img->_2d.dimx;
     *dimy = view->img->_2d.dimy;}
   else 
    {*use_dimxy = 0;}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
open_co_reg_param - ???
-------------------------------------------------------------------------*/

int
open_co_reg_param(view,wid,pa)
 struct view_rec *view;
 char *wid;
 struct co_param_rec *pa;
{
 int err,use,is_resize;
 struct view_rec *view1;
 struct image_display_window *win;
 struct plane_param_rec p1;
 static float rx1,ry1,rz1;
 float rx2,ry2,rz2;
 struct buf_3d_rec *_3d1,*_3d2;
 struct strs_rec *wids;
 struct matrix_3d_rec *xyztoplane1,*xyztoplane2;
 int use_dimxy;
 unsigned long dimx,dimy;

 PRT15(printf("open_co_reg_param...view->wid = %s wid = %s\n",view->wid,wid);)
 if (view->img->win == NULL) return CANCEL;
 if (wid == NULL) return CANCEL;
 if (str_cmp(wid,USE_SECOND) == 0) use = 2;
   else if (str_cmp(wid,USE_FIRST) == 0) use = 1;
   else if (str_cmp(wid,NO_OTHER_FILE_WID) == 0) return NO_ERROR;
   else use = 0;

 if (pa->p1.adjust_to_center == 0) pa->p1.adjust_to_center = 2;
 if (pa->p2.adjust_to_center == 0) pa->p2.adjust_to_center = 2;
 if (use)
    {if (use == 2) pa->p1 = pa->p2;
     if (pa->p1.which_format & 8) xyztoplane1 = NULL;
       else xyztoplane1 = &(pa->p1.xyztoplane);
     if (((err = ViewCheckAndResize(view,
             1,view->img->_2d.dimx,view->img->_2d.dimy,pa->p1.coord_ratio.x,
             pa->p1.coord_ratio.y,pa->p1.coord_ratio.z,&is_resize)) != NO_ERROR) ||
         ((err = FormPlane(view,&(pa->p1.base),&(pa->p1.normal),&(pa->p1.center),
               &(pa->p1.rotate),0,pa->p1.adjust_to_center,xyztoplane1))
                != NO_ERROR))
        ShowMsgStrs(view->img->win->image_display->dwin->frame,0,err,0,1,
               "Error occurred when forming the plane !!!",NULL,0);
     return err;
    }
 win = view->img->win->image_display;
 if (((view1 = find_any_view_rec(view->file,wid)) != NULL) &&
     ((err = get_def_dimxy(view,view1,&use_dimxy,&dimx,&dimy)) == NO_ERROR) &&
     ((err = WinUncoRegisterFromWid(win,wid,0)) == NO_ERROR) &&
     (find_file_3d(view->img->file,view->id,&_3d1) == NO_ERROR) &&
     (find_file_3d(view1->img->file,view1->id,&_3d2) == NO_ERROR))
    {rx1 = pa->p1.coord_ratio.x * _3d1->xpixel_size;
     ry1 = pa->p1.coord_ratio.y * _3d1->ypixel_size;
     rz1 = pa->p1.coord_ratio.z * _3d1->zpixel_size;
     rx2 = pa->p2.coord_ratio.x * _3d2->xpixel_size;
     ry2 = pa->p2.coord_ratio.y * _3d2->ypixel_size;
     rz2 = pa->p2.coord_ratio.z * _3d2->zpixel_size;
     PRT(printf("open_co_reg_param...\n");)
     if (!is_same_ratio(rx1,ry1,rz1,rx2,ry2,rz2))
        {p1 = pa->p2;
         pa->p2 = pa->p1;
         pa->p1 = p1;
         rx1 = pa->p1.coord_ratio.x * _3d1->xpixel_size;
         ry1 = pa->p1.coord_ratio.y * _3d1->ypixel_size;
         rz1 = pa->p1.coord_ratio.z * _3d1->zpixel_size;
         rx2 = pa->p2.coord_ratio.x * _3d2->xpixel_size;
         ry2 = pa->p2.coord_ratio.y * _3d2->ypixel_size;
         rz2 = pa->p2.coord_ratio.z * _3d2->zpixel_size;
         if (!is_same_ratio(rx1,ry1,rz1,rx2,ry2,rz2))
            {ShowMsgStrs(win->dwin->frame,0,0,0,4,
                 "Sorry...incompatible co-registered parameter file !!!",
                 "The final voxel sizes for both are not the same !!!",
                 "It might be for different files !!!",
                 "Will abort !!!",NULL,0);
             return CANCEL;}
        }

     PRT(printf("open_co_reg_param...1\n");)
     if (pa->p1.which_format & 8) xyztoplane1 = NULL;
       else xyztoplane1 = &(pa->p1.xyztoplane);
     if (pa->p2.which_format & 8) xyztoplane2 = NULL;
       else xyztoplane2 = &(pa->p2.xyztoplane);

     if (((err = setup_strs_rec(&wids,0,0)) != NO_ERROR) ||
         ((err = ViewCheckAndResize(view,
             use_dimxy,dimx,dimy,pa->p1.coord_ratio.x,
             pa->p1.coord_ratio.y,pa->p1.coord_ratio.z,&is_resize)) != NO_ERROR) ||
         ((err = FormPlane(view,&(pa->p1.base),&(pa->p1.normal),&(pa->p1.center),
               &(pa->p1.rotate),0,pa->p1.adjust_to_center,xyztoplane1))
                != NO_ERROR) ||
         (is_resize && ((err = GroupViewWids(view,wids,1,0)) != NO_ERROR)) ||
         ((err = ViewCheckAndResize(view1,
             use_dimxy,dimx,dimy,pa->p2.coord_ratio.x,
             pa->p2.coord_ratio.y,pa->p2.coord_ratio.z,&is_resize)) != NO_ERROR) ||
         ((err = FormPlane(view1,&(pa->p2.base),&(pa->p2.normal),&(pa->p2.center),
               &(pa->p2.rotate),0,pa->p2.adjust_to_center,xyztoplane2))
                != NO_ERROR) ||
         (is_resize && ((err = GroupViewWids(view1,wids,1,0)) != NO_ERROR)))
        ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Error occurred when forming the plane !!!",
               "Will not co-register !!!",NULL,0);
       else 
        {
         PRT15(printf("open_co_reg_param...wid = %s wid1 = %s\n",
                       view->wid,view1->wid);)

         drop_str_from_strs_rec(wids,view->wid);
         drop_str_from_strs_rec(wids,view1->wid);
         wids->status |= FREE_STRS_REC_PTR;

         err = win_3d_resize_voxel1(win,1,view->img->_2d.dimx,view->img->_2d.dimy,
               &rx1,&ry1,&rz1,wids,win_co_reg_params,
                     win,wid);
         PRT15(printf("open_co_reg_param...wid = %s wid1 = %s\n",view->wid,view1->wid);)
         PRT15(printf("status = %x    %x\n",(unsigned long) view->status,
                  (unsigned long) view1->status))
         return err;
        }        
     if (wids != NULL)
        {free_strs_rec(wids);
         c_free(wids);}
    }
   else ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Internal Error occurred !!!",
               "will not co-register !!!",NULL,0);
 PRT(printf("open_co_reg_param...err = %d\n",err);)
 return err;
}


/*-------------------------------------------------------------------------
rd_params - ???
-------------------------------------------------------------------------*/

int
rd_params(fid,view,window)
 FILE *fid;
 struct view_rec *view;
 Xv_Window window;
{
 int err;
 static struct co_param_rec pa;
 struct strs_rec *wids;
 char *dir,*str;
 struct matrix_3d_rec *xyztoplane1;

 PRT(printf("rd_params...\n");)
 if ((err = RdPlaneParams(fid,&(pa.p1.base),&(pa.p1.normal),
          &(pa.p1.center),&(pa.p1.coord_ratio),
          &(pa.p1.rotate),&(pa.p1.which_format),
          &(pa.p1.adjust_to_center),&(pa.p1.xyztoplane))) == NO_ERROR)
    if (pa.p1.which_format & 4)
       err = RdPlaneParams(fid,&(pa.p2.base),&(pa.p2.normal),
          &(pa.p2.center),&(pa.p2.coord_ratio),
          &(pa.p2.rotate),&(pa.p2.which_format),
          &(pa.p2.adjust_to_center),&(pa.p2.xyztoplane));
 if (err != NO_ERROR)
    notice_prompt(window,(Event *) NULL,
         NOTICE_MESSAGE_STRINGS,"File READ Error !!!",0,
         NOTICE_BUTTON_YES,FAILED,0);
   else if (pa.p1.which_format & 4)
    {
     PRT(printf("rd_params...1\n");)
     if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
        if ((err = AnyViewWids(view->img->file,wids,0,1,0,0,
                     view->group_num)) != NO_ERROR)
           {free_strs_rec_ptrs(wids);
            c_free(wids);}
          else
           {if (wids->num_strs == 0)
               add_str_ptr_to_strs_rec(wids,NO_OTHER_FILE_WID);
            add_str_ptr_to_strs_rec(wids,USE_FIRST);
            add_str_ptr_to_strs_rec(wids,USE_SECOND);
            PRT(printf("rd_params...2\n");)
            dir = win_get_param_def_dir(view->img->win->image_display,0);
            concat_strs(&str,4,view->wid,dir," : ","OPEN .npco WITH");
            PRT(printf("window = %u  rd_params...str = %s\n",window,str);)
            err = ShowMenuStrsProc(window,NULL,str,
                    wids,USER_MENU_FREE_STR_PTRS_AND_PTR,
                    open_co_reg_param,view,1,&pa,0);
            c_free(str);
           }
    }
   else
    {
     PRT(printf("use_which = %d...\n",pa.p1.which_format);)
     PRT(printf("base...\n");pr_vector_3d_rec(&(pa.p1.base)))
     PRT(printf("normal...\n");pr_vector_3d_rec(&(pa.p1.normal)))
     PRT(printf("rotate...\n");pr_vector_3d_rec(&(pa.p1.rotate)))
     if (pa.p1.which_format & 8) xyztoplane1 = NULL;
       else xyztoplane1 = &(pa.p1.xyztoplane);
     err = FormPlane(view,&(pa.p1.base),&(pa.p1.normal),NULL,
            &(pa.p1.rotate),0,0,xyztoplane1);
     PRT4(printf("view xyztoplane...\n");pr_3d_matrix(&(view->gplane.xyztoplane)))
     PRT4(printf("xyztoplane...\n");pr_3d_matrix(&(pa.p1.xyztoplane)))
    }
 return err;
}


/*-------------------------------------------------------------------------
win_open_the_plane - ???
-------------------------------------------------------------------------*/

int
win_open_the_plane(win,fn,dir)
 struct image_display_window *win;
 char *fn,*dir;
{
 FILE *fid;
 char *the_fn,*fn1,*suffix;
 struct img_buf_rec *img;
 struct view_rec *view;
 int err;

 PRT(printf("\nwin_open_the_plane dir = %s  fn = %s\n",dir,fn))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    return CANCEL;
 view = img->cur_slice->slice->view;
 cp_str(&fn1,fn);
 suffix = (char *) locate_suffix(fn1);
 drop_suffix(fn1);
 PRT(printf(" dir = %s  fn1 = %s  suffix = %s\n",dir,fn1,suffix))
 if ((err = open_input_file(dir,fn1,suffix,&the_fn,&fid,win->dwin->frame))
        == NO_ERROR)
    {PRT(printf("the_fn = %s\n",the_fn))
     err = rd_params(fid,view,win->dwin->frame);
     fclose(fid);
    }
 c_free(the_fn);
 c_free(fn1);
 c_free(suffix);
 return err;
}


/*-------------------------------------------------------------------------
open_plane - ???
-------------------------------------------------------------------------*/

int
open_plane(_3d,dir,fn)
 struct param_rec *_3d;
 char *dir,*fn;
{
 int err;

 err = win_open_the_plane(_3d->win,fn,dir);
 return err;
}


/*-------------------------------------------------------------------------
win_open_npar - ???
-------------------------------------------------------------------------*/

int
win_open_npar(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 char *dir,*fn,*str;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = win_plane_npar(win,&dir,&fn,1)) == NO_ERROR)
    {concat_strs(&str,2,fn,NPAR_SUFFIX);
     err = win_open_the_plane(win,str,dir);
     c_free(str);}
 c_free(dir);
 c_free(fn);
 return err;
}


/*-------------------------------------------------------------------------
open_npar_proc - ???
-------------------------------------------------------------------------*/

int
open_npar_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;
 int err;

 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 err = win_open_npar(_3d->win);
 return err;
}


/*-------------------------------------------------------------------------
open_plane_proc - ???
-------------------------------------------------------------------------*/

void
open_plane_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;
 char *fn,*dir;
 int err;

 TRACE(printf("open_plane_proc...\n"))
 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dir = (char *) xv_get(_3d->save_dir,PANEL_VALUE);
 fn = def_npar(_3d->win,dir,&err,1,0);
 ask_files(1,_3d->frame,"INPUT *.npar or *.npco FILEs",
       NULL,1,0,open_plane,_3d,NULL,NULL,1,
       "*.np*",1,0,5,285,NULL,NULL,1,
       dir,NULL,NULL,
       "FN",fn,NULL,NULL
      );
 c_free(fn);
 TRACE(printf("open_plane_proc...end\n"))
}


/*-------------------------------------------------------------------------
win_show_param_fns - ???
-------------------------------------------------------------------------*/

int
win_show_param_fns(win,dirfn,fn_patt,action_proc)
 struct image_display_window *win;
 char *dirfn,*fn_patt;
 int (*action_proc)();
{
 char **fns,*temp,*dir;
 static char *thedirfn = NULL;
 unsigned int num_fns,temp_num_fns;
 unsigned long lcv;
 struct strs_rec *wids;
 Xv_Window window;
 int err;

 PRT6(printf("win_show_param_fns...win = %u fn_patt = %s\n",win,fn_patt))
 PRT6(printf("win_show_param_fns...dirfn = %s\n",dirfn))
 if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,fn_patt,
         NULL,0,0,NULL)) == NO_ERROR)
    {
     PRT6(printf("win_show_param_fns...num_fns = %d\n",num_fns))
     if (num_fns == 0)
        {
         notice_prompt(win->dwin->frame,(Event *) NULL,
               NOTICE_MESSAGE_STRINGS,"Sorry...No file names found for",
                   fn_patt,"in this directory",
                   dirfn,0,
               NOTICE_BUTTON_YES,"OK !",0);
         return NO_ERROR;}

     temp_num_fns = num_fns;
     PRT6(printf("win_show_param_fns...2\n"))
     if (((err = setup_strs_rec(&wids,0,0)) == NO_ERROR) &&
         ((err = add_str_ary_to_strs_rec(wids,fns,temp_num_fns)) == NO_ERROR))
        {if (temp_num_fns != num_fns)
            {if ((err = cp_str(&temp,"Too many fns !!!"))
                     == NO_ERROR)
                if ((err = add_str_ptr_to_strs_rec(wids,temp)) != NO_ERROR)
                   c_free(temp);
            }

         window = canvas_paint_window(win->dwin->frame_canvas.canvas);
         PRT5(printf("wids...1\n"))
         c_free(thedirfn);
         thedirfn = NULL;
         cp_str(&thedirfn,dirfn);
         concat_strs(&dir,3,win->owner->wid,"DIR : ",dirfn);
         PRT7(printf("***dir = %s\n",dir))
         ShowMenuStrsProc(window,NULL,dir,
                    wids,USER_MENU_FREE_STRS_AND_PTR,
                    action_proc,win,1,thedirfn,NULL);
         c_free(dir);
         PRT6(printf("temp_num_fns = %d num_fns = %d dir = %s\n",
                 temp_num_fns,num_fns,dir))
         for (lcv = temp_num_fns; lcv < num_fns; lcv++)
            c_free(fns[lcv]);
         c_free(fns);
        }
       else
        {free_strs_rec(wids);
         free_handle_memory(fns,num_fns);
         c_free(wids);}
    }
 PRT6(printf("win_show_param_fns...err = %d\n",err))
 if (err != NO_ERROR)
    {notice_prompt(win->dwin->frame,(Event *) NULL,
               NOTICE_MESSAGE_STRINGS,"Error occurred when showing !!!",
                   "file names of ",fn_patt,"in this directory",
                   dirfn,0,
               NOTICE_BUTTON_YES,"OK !",0);
    }
 return err;
}


/*-------------------------------------------------------------------------
WinShowCurDirParamFns - ???
-------------------------------------------------------------------------*/

int
WinShowCurDirParamFns(win,fn_patt)
 struct image_display_window *win;
 char *fn_patt;
{
 char *dir,*fn;
 int err;

 PRT6(printf("WinShowCurDirParamFns..\n"))
 if ((err = win_plane_npar(win,&dir,&fn,1)) == NO_ERROR)
    {
     PRT6(printf("dir = %s fn = %s fn_patt = %s\n",dir,fn,fn_patt);)
     win_show_param_fns(win,dir,fn_patt,win_open_the_plane);
    }
 c_free(dir);
 c_free(fn);
 return err;
}


/*-------------------------------------------------------------------------
param_more_proc - ???
-------------------------------------------------------------------------*/

void
param_more_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct param_rec *_3d;

 _3d = (struct param_rec *) xv_get(item,PANEL_CLIENT_DATA);
 notice_prompt(_3d->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
               "*.npar...the plane parameter file",
               "*.npco...the co-registered parameter file",
               ".........It has 2 plane parameters",
               "",
	       "[ & ] - open & close the .npar file",
	       "{ & } - open & close the .npco file",
               ".........to be opened from the list",
              0,
            NOTICE_BUTTON_YES," OK !",
            0);
}


/*-------------------------------------------------------------------------
setup_param_rec - ???
-------------------------------------------------------------------------*/

int
setup_param_rec(_3d,win)
 struct param_rec *_3d;
 struct image_display_window *win;
{
 int row,offset,err;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *str,*str1;
 Rect *rr;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;

 _3d->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              WIN_CLIENT_DATA,_3d,
              0);
 if (_3d->frame == 0)
    {free_param_rec(_3d);
     return ~NO_ERROR;}
 _3d->win = win;
 _3d->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,_3D_PARAM_MENU);
 xv_set(_3d->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,_3d_param_done_proc,
              0);
 c_free(str);
 xv_set(_3d->frame,FRAME_CLOSED,FALSE,0);

 _3d->panel = xv_create(_3d->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);

 if (_3d->panel == 0)
    {free_param_rec(_3d);
     return ~NO_ERROR;}

 row = 5;
 offset = xv_rows(_3d->panel,1) - xv_rows(_3d->panel,0) - 10;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"OPEN .npar or .npco",
	PANEL_NOTIFY_PROC,open_plane_proc,
        XV_X,0,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 xv_create(_3d->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,"MORE...",
        XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	PANEL_NOTIFY_PROC,param_more_proc,
	0);

 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"OPEN .npar-]",
	PANEL_NOTIFY_PROC,open_npar_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 str = "DIR :";
 _3d->open_dir = xv_create(_3d->panel,PANEL_TEXT,
        XV_Y,row,
        PANEL_LABEL_STRING, str,
        PANEL_VALUE_DISPLAY_LENGTH,20,
        PANEL_VALUE_STORED_LENGTH,100,
        PANEL_VALUE,img->file->output.dirfn,
        0);

 row += offset;
 str = "FN:";
 str1 = def_npar(_3d->win,img->file->output.dirfn,&err,1,1);
 _3d->open_fn = xv_create(_3d->panel,PANEL_TEXT,
        XV_X,5,XV_Y,row,
	PANEL_LABEL_STRING, str,
        PANEL_VALUE_DISPLAY_LENGTH,30,
        PANEL_VALUE_STORED_LENGTH,100,
        PANEL_VALUE,str1,
        0);
 c_free(str1);

 row += offset;
 str = "DIR :";
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SAVE .npar-[",
	PANEL_NOTIFY_PROC,save_npar_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 _3d->save_dir = xv_create(_3d->panel,PANEL_TEXT,
                      XV_Y,row,
	              PANEL_LABEL_STRING, str,
                      PANEL_VALUE_DISPLAY_LENGTH,30,
                      PANEL_VALUE_STORED_LENGTH,100,
                      PANEL_VALUE,img->file->output.dirfn,
                      0);
 row += offset;
 str = "FN:";
 str1 = def_npar(_3d->win,img->file->output.dirfn,&err,0,1);
 _3d->save_fn = xv_create(_3d->panel,PANEL_TEXT,
        XV_X,5,XV_Y,row,
	PANEL_LABEL_STRING, str,
        PANEL_VALUE_DISPLAY_LENGTH,30,
        PANEL_VALUE_STORED_LENGTH,100,
        PANEL_VALUE,str1,
        0);
 c_free(str1);

 row += offset;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"SAVE .npco - {",
	PANEL_NOTIFY_PROC,save_npco_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"OPEN .npco - }",
	PANEL_NOTIFY_PROC,open_npco_proc,
        XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);

 row += offset;
 window_fit(_3d->panel);
 rr = (Rect *) xv_get(_3d->panel,XV_RECT);
 xv_set(_3d->panel,XV_WIDTH,rr->r_width - 10,
               XV_HEIGHT,rr->r_height - 10,0);
 window_fit(_3d->frame);
 make_2_wins_adjacent(_3d->frame,win->dwin->frame,0);
 win_set_mouse_at_center(_3d->frame);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_param_rec - ???
-------------------------------------------------------------------------*/

struct param_rec *
find_param_rec(all_3ds,win)
 struct all_param_recs *all_3ds;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_3ds->num_3ds; lcv++)
    if (all_3ds->_3ds[lcv]->win == win)
       return all_3ds->_3ds[lcv];
 return NULL;
}

/*****************
update_param_menu(win)
 struct image_display_window *win;
{
 struct all_param_recs *all_3ds;
 struct param_rec *_3d;

 if ((all_3ds = (struct all_param_recs *) enter_3d_param_menu(win,
              GET_ALL_PARAM_PTR)) != NULL)
    {
     if ((_3d = find_param_rec(all_3ds,win)) != NULL)
        {}
    }
}
****************/



/*-------------------------------------------------------------------------
enter_3d_param_menu - ???
-------------------------------------------------------------------------*/

unsigned long 
enter_3d_param_menu(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_param_recs all_3ds;
 static char first_time = 1;
 int err;
 struct param_rec *_3d;

 err = NO_ERROR;
 if (status == GET_ALL_PARAM_PTR)
     {if (first_time) return 0;
        else return (unsigned long) &all_3ds;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_PARAM)
   {if (!first_time)
       if ((_3d = find_param_rec(&all_3ds,win)) != NULL)
          free_param_rec(_3d);
    return NO_ERROR;}

 if (first_time)
    {init_all_param_recs(&all_3ds);
     first_time = 0;}
   else
    {if ((_3d = find_param_rec(&all_3ds,win)) != NULL)
        {xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         win_set_mouse_at_center(_3d->frame);
         wmgr_top(_3d->frame);
         return NO_ERROR;}
    }

 get_handle_memory(&(all_3ds._3ds),&(all_3ds.num_3ds),1,
     (size_t) sizeof(struct param_rec),&err);
 if (err != NO_ERROR) return err;
 _3d = all_3ds._3ds[all_3ds.num_3ds - 1];
 init_param_rec(_3d);
 if ((err = setup_param_rec(_3d,win)) == NO_ERROR)
    xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return err;
}
