/****************************************************************************
3d_resize.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: 3d_resize.c,v 1.8 1999/07/07 17:41:13 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "buf_3d_rec.h"
#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);

*/
#define TRACE(x)
#define PRT(x)
#define PRT2(x)
#define PRT7(x)
#define PRT8(x)
#define PRT9(x)



/*-------------------------------------------------------------------------
- ???
-------------------------------------------------------------------------*/

#define CLEAN_UP_3D_MENU 0
#define SETUP_3D_MENU 1
#define GET_ALL_3D_MENU_PTR 2



/*-------------------------------------------------------------------------
struct resize_menu_3d_rec - ???
-------------------------------------------------------------------------*/

struct resize_menu_3d_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item apply_to,voxel_wid,def_voxel_msg,cur_voxel_msg,
               xpixel_size,ypixel_size,zpixel_size;
    char *last_wid;
    struct strs_rec resize_wids;
    float resize_xpixel_size,resize_ypixel_size,resize_zpixel_size;
   };


/*-------------------------------------------------------------------------
struct all_resize_menu_3d_recs - ???
-------------------------------------------------------------------------*/

struct all_resize_menu_3d_recs
   {
    int num_3ds;
    struct resize_menu_3d_rec **_3ds;
   };



/*-------------------------------------------------------------------------
Internal function prototypes
-------------------------------------------------------------------------*/
void init_resize_menu_3d_rec(struct resize_menu_3d_rec *_3d);
void free_resize_menu_3d_rec(struct resize_menu_3d_rec *_3d);
void init_all_resize_menu_3d_recs(struct all_resize_menu_3d_recs *all_3ds);
void _3d_resize_done_proc(Frame frame);
int setup_view_window_list(struct img_buf_rec *img, Panel_item item,
    int is_select_all, int which_view, int inc_cur_file, int inc_cur_group,
    int cur_group_num);
int def_voxel_size(struct view_rec *view, float *xpixel_size,
    float *ypixel_size, float *zpixel_size);
int cur_voxel_size(struct view_rec *view, float *xpixel_size,
    float *ypixel_size, float *zpixel_size);
void set_voxel_size(struct resize_menu_3d_rec *_3d, struct view_rec *view,
    int is_def);
void def_voxel_proc(Panel_item item, Event *event);
void resize_group_wids_to_wid_vs_proc(Panel_item item, Event *event);
int win_3d_resize_voxel1(struct image_display_window *win, int use_dimxy,
    unsigned long dimx, unsigned long dimy, float *resize_xpixel_size,
    float *resize_ypixel_size, float *resize_zpixel_size,
    struct strs_rec *resize_wids, int (*conti_proc)(), void *arg1, void *arg2);
int win_resize_group_voxel(struct image_display_window *win, char *wid);
void resize_voxel_proc(Panel_item item, Event *event);
void yz_as_x_proc(Panel_item item, Event *event);
int dp_voxel_msg(struct resize_menu_3d_rec *_3d, char *wid);
void dp_voxel_msg_proc(Panel_item item, char *wid, caddr_t client_data,
    Panel_list_op op, Event *event);
int setup_resize_menu_3d_rec(struct resize_menu_3d_rec *_3d,
    struct image_display_window *win);
struct resize_menu_3d_rec *find_resize_menu_3d_rec(
   struct all_resize_menu_3d_recs *all_3ds, struct image_display_window *win);
int enter_3d_resize_menu(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_resize_menu_3d_rec - ???
-------------------------------------------------------------------------*/

void
init_resize_menu_3d_rec(_3d)
 struct resize_menu_3d_rec *_3d;
{
 _3d->status = 0;
 _3d->win = NULL;
 _3d->frame  = 0;
 _3d->last_wid = NULL;
 init_strs_rec(&(_3d->resize_wids));
}


/*-------------------------------------------------------------------------
free_resize_menu_3d_rec - ???
-------------------------------------------------------------------------*/

void
free_resize_menu_3d_rec(_3d)
 struct resize_menu_3d_rec *_3d;
{
 struct all_resize_menu_3d_recs *all_3ds;

 PRT7(printf("free_resize_menu_3d_rec...\n"))
 c_free(_3d->last_wid);
 free_strs_rec(&(_3d->resize_wids));
 if (_3d->frame != 0) xv_destroy_safe(_3d->frame);
 all_3ds = (struct all_resize_menu_3d_recs *) 
          enter_3d_resize_menu(NULL,GET_ALL_3D_MENU_PTR);
 c_free(_3d);
 DropHandleAryPtr(&(all_3ds->_3ds),&(all_3ds->num_3ds),_3d);
 PRT7(printf("free_resize_menu_3d_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_resize_menu_3d_recs - ???
-------------------------------------------------------------------------*/

void
init_all_resize_menu_3d_recs(all_3ds)
 struct all_resize_menu_3d_recs *all_3ds;
{
 all_3ds->num_3ds = 0;
 all_3ds->_3ds = NULL;
}


/*-------------------------------------------------------------------------
_3d_resize_done_proc - ???
-------------------------------------------------------------------------*/

void
_3d_resize_done_proc(frame)
 Frame frame;
{
 struct resize_menu_3d_rec *_3d;

 _3d = (struct resize_menu_3d_rec *)
                     xv_get(frame,WIN_CLIENT_DATA);
 free_resize_menu_3d_rec(_3d);
}


/*-------------------------------------------------------------------------
setup_view_window_list - ???
-------------------------------------------------------------------------*/

int
setup_view_window_list(img,item,is_select_all,which_view,
                       inc_cur_file,inc_cur_group,cur_group_num)
 struct img_buf_rec *img;
 Panel_item item;
 int is_select_all,which_view,
     inc_cur_file,inc_cur_group,cur_group_num;
{
 int err;
 struct strs_rec wids;

 init_strs_rec(&wids);
 if (which_view == 0)
    err = GroupViewWids(img->cur_slice->slice->view,&wids,0,1);
   else if (which_view == 1)
    err = FileViewWids(img->file,&wids,0,1,inc_cur_group,cur_group_num);
   else
    err = AnyViewWids(img->file,&wids,0,1,
           inc_cur_file,inc_cur_group,cur_group_num);

 if ((err == NO_ERROR) && (wids.num_strs > 0))
    {
     setup_list_items(&wids,item,is_select_all);
    }
 free_strs_rec_ptrs(&wids);
 return err;
}


/*-------------------------------------------------------------------------
def_voxel_size - ???
-------------------------------------------------------------------------*/

int
def_voxel_size(view,xpixel_size,ypixel_size,zpixel_size)
 struct view_rec *view;
 float *xpixel_size,*ypixel_size,*zpixel_size;
{
 struct buf_3d_rec *_3d1;
 int err;

 if ((view == NULL) ||
     ((err = find_file_3d(view->file,view->id,&_3d1)) != NO_ERROR))
    {*xpixel_size = *ypixel_size = *zpixel_size = .0;
     return CANCEL;}
 *xpixel_size = _3d1->xpixel_size;
 *ypixel_size = _3d1->ypixel_size;
 *zpixel_size = _3d1->zpixel_size;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
cur_voxel_size - ???
-------------------------------------------------------------------------*/

int
cur_voxel_size(view,xpixel_size,ypixel_size,zpixel_size)
 struct view_rec *view;
 float *xpixel_size,*ypixel_size,*zpixel_size;
{
 struct buf_3d_rec *_3d1;
 int err;

 if ((view == NULL) ||
     ((err = find_file_3d(view->file,view->id,&_3d1)) != NO_ERROR))
    {*xpixel_size = *ypixel_size = *zpixel_size = .0;
     return CANCEL;}
 *xpixel_size = _3d1->xpixel_size * view->gplane.coord_ratio.x;
 *ypixel_size = _3d1->ypixel_size * view->gplane.coord_ratio.x;
 *zpixel_size = _3d1->zpixel_size * view->gplane.coord_ratio.x;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
set_voxel_size - ???
-------------------------------------------------------------------------*/

void
set_voxel_size(_3d,view,is_def)
 struct resize_menu_3d_rec *_3d;
 struct view_rec *view;
 int is_def;
{
 char str1[40];
 float xpixel_size,ypixel_size,zpixel_size;

 PRT9(printf("set_voxel_size \n"))
 if (is_def)
    def_voxel_size(view,&xpixel_size,&ypixel_size,&zpixel_size);
   else cur_voxel_size(view,&xpixel_size,&ypixel_size,&zpixel_size);
 sprintf(str1,"%-.4f",xpixel_size);
 xv_set(_3d->xpixel_size,PANEL_VALUE,str1,0);
 sprintf(str1,"%-.4f",ypixel_size);
 xv_set(_3d->ypixel_size,PANEL_VALUE,str1,0);
 sprintf(str1,"%-.4f",zpixel_size);
 xv_set(_3d->zpixel_size,PANEL_VALUE,str1,0);
}


/*-------------------------------------------------------------------------
def_voxel_proc - ???
-------------------------------------------------------------------------*/

void
def_voxel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_menu_3d_rec *_3d;
 struct view_rec *view;
 struct img_buf_rec *img;

 _3d = (struct resize_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 if (_3d->last_wid != NULL) 
    view = find_any_view_rec(img->file,_3d->last_wid);
   else view = NULL;
 if (view == NULL) view = img->cur_slice->slice->view;
 set_voxel_size(_3d,view,1);
}

/******************
 PRT9(printf("same_voxel_proc..._3d = %u\n",_3d))
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 PRT9(printf("same_voxel_proc..._3d = %u\n",_3d))
 if (next_selected_item(_3d->apply_to,0,&selected_indx) != NO_ERROR) return NULL;
 PRT9(printf("same_voxel_proc...1\n"))
 if ((str = (char *) xv_get(_3d->apply_to,PANEL_LIST_STRING,
              selected_indx)) == NULL)
    return NULL;
 PRT9(printf("same_voxel_proc str = %s\n",str))
 sscanf(str,"%d",&group_num);
 PRT9(printf("same_voxel_proc...2\n"))
 if ((view = view_with_group_num(img->file,group_num)) != NULL)
    set_voxel_size(_3d,view,0);
*************************/


/*-------------------------------------------------------------------------
resize_group_wids_to_wid_vs_proc - ???
-------------------------------------------------------------------------*/

void
resize_group_wids_to_wid_vs_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_menu_3d_rec *_3d;

 _3d = (struct resize_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 _3d_resize_group_proc(0,0,_3d->win->dwin, _3d->frame,event);
}


/*-------------------------------------------------------------------------
win_3d_resize_voxel1 - ???
-------------------------------------------------------------------------*/

int
win_3d_resize_voxel1(win,use_dimxy,dimx,dimy,resize_xpixel_size,resize_ypixel_size,
                    resize_zpixel_size,resize_wids,conti_proc,arg1,arg2)
 struct image_display_window *win;
 int use_dimxy;
 unsigned long dimx,dimy;
 float *resize_xpixel_size,*resize_ypixel_size,*resize_zpixel_size;
 struct strs_rec *resize_wids;
 int (*conti_proc)();
 void *arg1,*arg2;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 long lcv;

 PRT8(printf("win_3d_resize_voxel...win = %u\n",win))
 PRT8(printf("win_3d_resize_voxel...cur_str = %d\n",resize_wids->cur_str))
 PRT8(printf("use_dimxy = %d...dimx = %d dimy = %d\n",use_dimxy,dimx,dimy))

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 for (lcv = resize_wids->cur_str; lcv < resize_wids->num_strs; lcv++)
    {if ((view = find_any_view_rec(img->file,
            resize_wids->strs[lcv])) == NULL)
        continue;
     if ((view->img == NULL) || (view->img->win == NULL) ||
         (view->img->win->image_display == NULL))
        continue;

     ShowMsgStrs(view->img->win->image_display->dwin->frame,1,NO_ERROR,0,2,
               "Resizing the image voxels...",
               PLEASE_WAIT,win_resize_voxel1,13,win,
               view->img->win->image_display,
               use_dimxy,dimx,dimy,
               resize_xpixel_size,resize_ypixel_size,
               resize_zpixel_size,resize_wids,win_3d_resize_voxel1,
               conti_proc,arg1,arg2);
     PRT8(printf("win_3d_resize_voxel...wid = %s\n",resize_wids->strs[lcv]))
     resize_wids->cur_str = lcv + 1;
     PRT8(printf("win_3d_resize_voxel...cur_str = %d\n",resize_wids->cur_str))
     return NO_ERROR;
    }
 if (resize_wids->status & FREE_STRS_REC_PTR) 
    {PRT8(printf("c_free(resize_wids\n"))
     free_strs_rec(resize_wids);
     c_free(resize_wids);}
   else free_strs_rec(resize_wids);
 if (conti_proc != NULL)
    return conti_proc(arg1,arg2);
   else return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_resize_group_voxel - ???
-------------------------------------------------------------------------*/

int
win_resize_group_voxel(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 static float xpixel_size,ypixel_size,zpixel_size;
 static unsigned long dimx,dimy;
 static struct strs_rec resize_wids;
 static unsigned char first_time = 1;
 int err;

 PRT2(printf("win_resize_group_voxel...win = %u\n",win))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = find_any_view_rec(img->file,wid)) == NULL) return CANCEL;
 if (first_time)
    {first_time = 0;
     init_strs_rec(&resize_wids);}
   else if ((resize_wids.num_strs > 0) &&
            (resize_wids.cur_str < resize_wids.num_strs))
    return NO_ERROR;
   else init_strs_rec(&resize_wids);
 cur_voxel_size(view,&xpixel_size,&ypixel_size,&zpixel_size);
 dimx = view->img->_2d.dimx;
 dimy = view->img->_2d.dimy;
 resize_wids.cur_str = 0;
 view = img->cur_slice->slice->view;
 if ((err = GroupViewWids(view,&resize_wids,1,1)) != NO_ERROR)
    {free_strs_rec(&resize_wids);
     return err;}
   else 
    {
     return win_3d_resize_voxel1(win,1,dimx,dimy,
                    &xpixel_size,&ypixel_size,
                    &zpixel_size,&resize_wids,NULL,NULL,NULL);}
}


/*-------------------------------------------------------------------------
resize_voxel_proc - ???
-------------------------------------------------------------------------*/

void
resize_voxel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_menu_3d_rec *_3d;
 struct img_buf_rec *img;
 char *str1,*str2,*str3;
 int err;

 _3d = (struct resize_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return;
 if ((_3d->resize_wids.num_strs > 0) &&
     (_3d->resize_wids.cur_str < _3d->resize_wids.num_strs))
    return;
 free_strs_rec(&(_3d->resize_wids));
 selected_list_items(&(_3d->resize_wids),_3d->apply_to);
 if (_3d->resize_wids.num_strs == 0)
    {notice_prompt(_3d->win->dwin->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,"No WIDs are selected for resizing !!!",
                                   "Try again !!!",0,
            NOTICE_BUTTON_YES," OK !",
            0);
     return;}

 str1 = (char *) xv_get(_3d->xpixel_size,PANEL_VALUE);
 str2 = (char *) xv_get(_3d->ypixel_size,PANEL_VALUE);
 str3 = (char *) xv_get(_3d->zpixel_size,PANEL_VALUE);
 if ((str1 == NULL) || (str2 == NULL) || (str3 == NULL))
    err = 1;
   else
    {err = 0;
     sscanf(str1,"%f",&(_3d->resize_xpixel_size));
     sscanf(str2,"%f",&(_3d->resize_ypixel_size));
     sscanf(str3,"%f",&(_3d->resize_zpixel_size));
     if ((_3d->resize_xpixel_size < .1) || 
         (_3d->resize_ypixel_size < .1) ||
         (_3d->resize_zpixel_size < .1))
        err = 1;
    }
 if (err == 0) 
    {_3d->resize_wids.cur_str = 0;
     win_3d_resize_voxel1(_3d->win,0,0,0,
            &(_3d->resize_xpixel_size),&(_3d->resize_ypixel_size),
            &(_3d->resize_zpixel_size),&(_3d->resize_wids),NULL,NULL,NULL);
    }
   else 
    notice_prompt(_3d->win->dwin->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,"Bad input voxel size !!!",
                                   "Voxel sizes must be > .1 !!!",
                                   "Please re-enter again !!!",0,
            NOTICE_BUTTON_YES," OK !",
            0);

}


/*-------------------------------------------------------------------------
yz_as_x_proc - ???
-------------------------------------------------------------------------*/

void
yz_as_x_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_menu_3d_rec *_3d;
 char *str1;

 _3d = (struct resize_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 str1 = (char *) xv_get(_3d->xpixel_size,PANEL_VALUE);
 xv_set(_3d->ypixel_size,PANEL_VALUE,str1,0);
 xv_set(_3d->zpixel_size,PANEL_VALUE,str1,0);

}


/*-------------------------------------------------------------------------
dp_voxel_msg - ???
-------------------------------------------------------------------------*/

int
dp_voxel_msg(_3d,wid)
 struct resize_menu_3d_rec *_3d;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 char str[60];
 float xpixel_size,ypixel_size,zpixel_size;

 if ((img = win_rec_cur_img_buf(_3d->win->owner)) == NULL) return CANCEL;
 if ((view = find_any_view_rec(img->file,wid)) != NULL)
    def_voxel_size(view,&xpixel_size,&ypixel_size,&zpixel_size);
 sprintf(str,"%s VOXEL SIZE (VS)...",view->wid);
 xv_set(_3d->voxel_wid,PANEL_LABEL_STRING,str,0);

 sprintf(str,"DEF : X/Y/Z = %-.4f/%-.4f/%-.4f",xpixel_size,ypixel_size,zpixel_size);
 xv_set(_3d->def_voxel_msg,PANEL_LABEL_STRING,str,0);
 cur_voxel_size(view,&xpixel_size,&ypixel_size,&zpixel_size);
 sprintf(str,"CUR : X/Y/Z = %-.4f/%-.4f/%-.4f",xpixel_size,ypixel_size,zpixel_size);
 xv_set(_3d->cur_voxel_msg,PANEL_LABEL_STRING,str,0);

 if (str_cmp(_3d->last_wid,wid) != 0)
    {c_free(_3d->last_wid);
     cp_str(&(_3d->last_wid),wid);}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
dp_voxel_msg_proc - ???
-------------------------------------------------------------------------*/

void
dp_voxel_msg_proc(item,wid,client_data,op,event)
 Panel_item item;
 char *wid;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct resize_menu_3d_rec *_3d;

 _3d = (struct resize_menu_3d_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dp_voxel_msg(_3d,wid);
}


/*-------------------------------------------------------------------------
setup_resize_menu_3d_rec - ???
-------------------------------------------------------------------------*/

int
setup_resize_menu_3d_rec(_3d,win)
 struct resize_menu_3d_rec *_3d;
 struct image_display_window *win;
{
 Cms cms;
 Panel_item item;
 int row,offset;
 struct img_buf_rec *img;
 struct view_rec *view;
 char *str;
 Rect *rr,*rr1;

 PRT(printf("setup_resize_menu_3d_rec...1\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 _3d->frame = xv_create(win->dwin->frame, FRAME,
			/*WIN_DYNAMIC_VISUAL,TRUE,*/
			FRAME_INHERIT_COLORS,TRUE,
			WIN_CLIENT_DATA,_3d,
			0);
 if (_3d->frame == 0)
    {free_resize_menu_3d_rec(_3d);
     return ~NO_ERROR;}
 xv_set(_3d->frame,		/* DRW 19970811  See display_init_free.c */
	WIN_CMS,cms,
	NULL);
 _3d->win = win;
 _3d->dwin = win->dwin;
 PRT(printf("setup_resize_menu_3d_rec...2\n"))
 str = win_rec_win_id_title(win->owner,_3D_RESIZE_IMAGE);
 xv_set(_3d->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,_3d_resize_done_proc,
              0);
 c_free(str);
 xv_set(_3d->frame,FRAME_CLOSED,FALSE,0);

 _3d->panel = xv_create(_3d->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);
 if (_3d->panel == 0)
    {free_resize_menu_3d_rec(_3d);
     return ~NO_ERROR;}

 row = 5;
 offset = xv_rows(_3d->panel,1) - xv_rows(_3d->panel,0) - 10;
 _3d->apply_to = xv_create(_3d->panel,PANEL_LIST,
                  PANEL_LABEL_STRING, "RESIZE WIDs...",
                 PANEL_CHOOSE_ONE,FALSE,
                 PANEL_LIST_DISPLAY_ROWS,3,
                 PANEL_LIST_WIDTH,90,
                 PANEL_LAYOUT,PANEL_VERTICAL,
	          PANEL_NOTIFY_PROC,dp_voxel_msg_proc,
                  PANEL_CLIENT_DATA,_3d,
                  XV_X,5,XV_Y,row,
                   0);
 PRT(printf("setup_resize_menu_3d_rec...3\n"))
 setup_view_window_list(img,_3d->apply_to,0,2,1,1,1);
 PRT(printf("setup_resize_menu_3d_rec...4\n"))
 select_list_str_item(view->wid,_3d->apply_to,1);
 PRT(printf("setup_resize_menu_3d_rec...5\n"))
 cp_str(&(_3d->last_wid),view->wid);

 rr = (Rect *) xv_get(_3d->apply_to,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"ALL",
                   PANEL_NOTIFY_PROC,all_list_proc,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   XV_KEY_DATA,1,&(_3d->apply_to),
                   0);
 rr1 = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(_3d->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"NONE",
                   PANEL_NOTIFY_PROC,none_list_proc,
                   XV_X,rr1->r_left + rr1->r_width + 2,XV_Y,row,
                   XV_KEY_DATA,1,&(_3d->apply_to),
                   0);
 row += offset;
 xv_create(_3d->panel,PANEL_MESSAGE,
 	           PANEL_LABEL_STRING,"Resize group WIDs - <`>",
                  XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   0);
 row += offset;
 PRT(printf("setup_resize_menu_3d_rec...5..1\n"))
 _3d->voxel_wid = xv_create(_3d->panel,PANEL_MESSAGE,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   0);
 row += offset - 5;
 _3d->def_voxel_msg = xv_create(_3d->panel,PANEL_MESSAGE,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   0);
 PRT(printf("setup_resize_menu_3d_rec...5..2\n"))
 row += offset - 5;
 _3d->cur_voxel_msg = xv_create(_3d->panel,PANEL_MESSAGE,
                   XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
                   0);
 PRT(printf("setup_resize_menu_3d_rec...6\n"))
 dp_voxel_msg(_3d,view->wid);
 row = rr->r_top + rr->r_height + 8;
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"RESIZE GROUP CUR WID = VS of WID...",
	PANEL_NOTIFY_PROC,resize_group_wids_to_wid_vs_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DEFAULT vs",
	PANEL_NOTIFY_PROC,def_voxel_proc,
        PANEL_CLIENT_DATA,_3d,
	0);
 row += offset;
 PRT(printf("setup_resize_menu_3d_rec...7\n"))
 item = xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"Y = Z = X",
	PANEL_NOTIFY_PROC,yz_as_x_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 xv_create(_3d->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"RESIZE VOXEL NOW",
	PANEL_NOTIFY_PROC,resize_voxel_proc,
        XV_X,rr->r_left + rr->r_width + 2,XV_Y,row,
        PANEL_CLIENT_DATA,_3d,
	0);
 PRT(printf("setup_resize_menu_3d_rec...8\n"))
 row += offset;
 _3d->xpixel_size = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"VOXEL X =",
        PANEL_VALUE_DISPLAY_LENGTH,7,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_X,5,XV_Y,row,
	0);
 _3d->ypixel_size = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Y =",
        PANEL_VALUE_DISPLAY_LENGTH,7,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_Y,row,
	0);
 _3d->zpixel_size = xv_create(_3d->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"Z =",
        PANEL_VALUE_DISPLAY_LENGTH,7,
        PANEL_VALUE_STORED_LENGTH,15,
        PANEL_CLIENT_DATA,_3d,
        XV_Y,row,
	0);
 set_voxel_size(_3d,view,0);
 PRT(printf("setup_resize_menu_3d_rec...10\n"))
 window_fit(_3d->panel);
 rr = (Rect *) xv_get(_3d->panel,XV_RECT);
 xv_set(_3d->panel,XV_HEIGHT,rr->r_height - 10,XV_WIDTH,rr->r_width - 10,0);
 PRT(printf("setup_resize_menu_3d_rec...11\n"))
           
 window_fit(_3d->frame);
 make_2_wins_adjacent(_3d->frame,win->dwin->frame,0);
 win_set_mouse_at_center(_3d->frame);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_resize_menu_3d_rec - ???
-------------------------------------------------------------------------*/

struct resize_menu_3d_rec *
find_resize_menu_3d_rec(all_3ds,win)
 struct all_resize_menu_3d_recs *all_3ds;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_3ds->num_3ds; lcv++)
    if ((img = win_rec_cur_img_buf(all_3ds->_3ds[lcv]->win->owner)) != NULL)
       if (img->file == f1)
          return all_3ds->_3ds[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
enter_3d_resize_menu - ???
-------------------------------------------------------------------------*/

int
enter_3d_resize_menu(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_resize_menu_3d_recs all_3ds;
 static char first_time = 1;
 int err;
 struct resize_menu_3d_rec *_3d;

 PRT(printf("enter_3d_resize_menu...\n"))
 err = NO_ERROR;
 if (status == GET_ALL_3D_MENU_PTR)
    {if (first_time) return 0;
     return (unsigned long) &all_3ds;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_3D_MENU)
   {if (!first_time)
       if ((_3d = find_resize_menu_3d_rec(&all_3ds,win)) != NULL)
          free_resize_menu_3d_rec(_3d);
    return NO_ERROR;}

 PRT(printf("enter_3d_resize_menu...1\n"))
 if (first_time)
    {init_all_resize_menu_3d_recs(&all_3ds);
     first_time = 0;}
   else
    {if ((_3d = find_resize_menu_3d_rec(&all_3ds,win)) != NULL)
        if (_3d->win == win)
           {xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
            win_set_mouse_at_center(_3d->frame);
            wmgr_top(_3d->frame);
            return NO_ERROR;}
          else free_resize_menu_3d_rec(_3d);
    }
 PRT(printf("enter_3d_resize_menu...2\n"))
 get_handle_memory(&(all_3ds._3ds),&(all_3ds.num_3ds),1,
     (size_t) sizeof(struct resize_menu_3d_rec),&err);
 if (err != NO_ERROR) return err;
 _3d = all_3ds._3ds[all_3ds.num_3ds - 1];
 init_resize_menu_3d_rec(_3d);
 if ((err = setup_resize_menu_3d_rec(_3d,win)) == NO_ERROR)
    xv_set(_3d->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 PRT(printf("enter_3d_resize_menu...3\n"))
 return err;
}
