#include "mri_format.h"

/* 
cc -c v3_misc.c
*/
/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
/*
win_rd_breaker_check(dummy1,dummy2,win1)
save_slice_roi_rec(dir,fn,slice_roi)

rd_curves(fn,curves,num_curves)
win_rd_curves(win)
win_rd_curves_pt(win)
wr_cur_mask(fn,win)
win_rd_2d(win)
win_wr_2d(win)
wr_curves1(fn,curves,num_curves)
win_wr_curves(win)
Wr2dImage(fn,_2d,img_label,err_reason,hdr,xpix,ypix,zpix)
*/
char *get_prog_dir();
int win_redisplay_all_curves();

win_rd_breaker_check(dummy1,dummy2,win1)
 void *dummy1,*dummy2;
 struct display_win_rec *win1;
{
 FILE *fid;
 char *dir,*str;
 struct slice_roi_rec slice_roi1;
 int err;
 struct image_display_window *win;

 win = win1->owner;
 dir = get_prog_dir(win->owner->root->prog);
/*
 printf("win_rd_breaker_check dir = %s\n",dir);
*/
 str = NULL;
 if ((err = concat_strs(&str,3,dir,"/","breaker.check")) == NO_ERROR)
    {/* printf("win_rd_breaker_check str = %s\n",str);*/
     if ((fid = fopen(str,"r")) != NULL)
        {init_slice_roi_rec(&slice_roi1);
         /*printf("win_rd_breaker_check 1 slice_roi = %d\n",
                   win->control.sroi.sroi_win->slice_roi.num_rois);*/
         if (((err = v3_rd_slice_roi_rec(fid,&slice_roi1)) == NO_ERROR) &&
             ((err = JoinRois(&(win->control.sroi.sroi_win->slice_roi),
                      &slice_roi1,0,1.0,1.0,NULL,NULL,NULL)) == NO_ERROR))
            win_execute_proc_to_related_wins(win,win_redisplay_all_curves);
/*
         printf("win_rd_breaker_check 2 slice_roi = %d\n",
                   win->control.sroi.sroi_win->slice_roi.num_rois);
         printf("win_rd_breaker_check err = %d slice_roi1 = %d\n",err,
                   slice_roi1.num_rois);
         pr_slice_roi_rec(&(win->control.sroi.sroi_win->slice_roi));
*/
         free_slice_roi_rec(&slice_roi1);
         fclose(fid);
        }
    }
 c_free(str);
 c_free(dir);
 return err;
}

save_slice_roi_rec(dir,fn,slice_roi)
 char *dir,*fn;
 struct slice_roi_rec *slice_roi;
{
 char *str;
 struct slice_roi_rec slice_roi1,*slice_roi2;
 FILE *fid;
 int err;

 str = NULL;
 if ((err = concat_strs(&str,3,dir,"/",fn)) == NO_ERROR)
    {slice_roi2 = slice_roi;
/*
     printf("save_slice_roi_rec str = %s\n",str);
*/
     init_slice_roi_rec(&slice_roi1);
     if ((fid = fopen(str,"r")) != NULL)
        {
         if (((err = v3_rd_slice_roi_rec(fid,&slice_roi1)) == NO_ERROR) &&
             ((err = JoinRois(&slice_roi1,slice_roi,0,1.0,1.0,
                    NULL,NULL,NULL)) == NO_ERROR))
            slice_roi2 = &slice_roi1;
         fclose(fid);
        }
     if ((fid = fopen(str,"w")) != NULL)
        {err = v3_wr_slice_roi_rec(fid,slice_roi2);
         fclose(fid);}
/*
     printf("save_slice_roi_rec slice_roi2->num_rois = %d  err = %d\n",
                  slice_roi2->num_rois,err);
*/
     free_slice_roi_rec(&slice_roi1);
    }

 c_free(str);
 return err;
}

/*
rd_curves(fn,curves,num_curves)
 char *fn;
 struct curve_rec ***curves;
 unsigned long *num_curves;
{
 FILE *fid;
 int err;
 unsigned long lcv,total;

 printf("rd_curves...\n");
 *curves = NULL;
 *num_curves = 0;
 if ((fid = fopen(fn,"r")) == NULL) return FILE_ACCESS_ERROR;
 if (fread(&total,(size_t) sizeof(*num_curves),1,fid) != 1)
    {printf("rd_curves...read err = %d...\n",err);
     fclose(fid);
     return READ_ERROR;
    }

 get_handle_memory(curves,num_curves,(unsigned_int) total,
            (size_t) sizeof(struct curve_rec),&err);
 if (err == NO_ERROR)
    {for (lcv = 0; lcv < *num_curves; lcv++)
        init_curve_rec((*curves)[lcv]);
     for (lcv = 0; lcv < *num_curves; lcv++)
        if ((err = rd_curve_rec(fid,(*curves)[lcv])) != NO_ERROR)
           {printf("rd_curves...read err = %d...\n",err);
            break;}
    }
 fclose(fid);
 return err;
}

win_rd_curves(win)
 struct image_display_window *win;
{
 struct curve_rec **curves;
 unsigned long num_curves,lcv;
 struct roi_rec *roi;
 int err;

 printf("rd_curves...win = %u\n",win);
 if ((err = rd_curves("curves.dat",&curves,&num_curves)) != NO_ERROR)
    return err;
 if (win == NULL) return NO_ERROR;
 printf("rd_curves ok...now num_curves = %d %u\n",
            num_curves,win->control.sroi.sroi_win);
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 for (lcv = 0; lcv < num_curves; lcv++)
    {if ((err = append_curve_to_roi_rec(roi,curves[lcv],DRAW_LINE,0,
                  &(win->control.sroi.sroi_win->slice_roi.status))) != 
           NO_ERROR)
       return err;
    }
 if (num_curves > 0) c_free(curves);
 win_execute_proc_to_related_wins(win,win_set_control_pen_type,1);
 win_execute_proc_to_related_wins(win,win_redisplay_all_curves);

 return NO_ERROR;
}

win_rd_curves_pt(win)
 struct image_display_window *win;
{
 struct curve_rec **curves;
 unsigned long num_curves,lcv;
 struct roi_rec *roi;
 int err;

 printf("rd_curves...win = %u\n",win);
 if ((err = rd_curves("curves.dat",&curves,&num_curves)) != NO_ERROR)
    return err;
 if (win == NULL) return NO_ERROR;
 printf("rd_curves ok...now num_curves = %d %u\n",
            num_curves,win->control.sroi.sroi_win);
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 for (lcv = 0; lcv < num_curves; lcv++)
    {if ((err = append_curve_to_roi_rec(roi,curves[lcv],DRAW_POINT,0,
                  &(win->control.sroi.sroi_win->slice_roi.status))) != 
           NO_ERROR)
       return err;
     pr_curve_rec_pts(curves[lcv]);
    }
 if (num_curves > 0) c_free(curves);
 win_execute_proc_to_related_wins(win,win_set_control_pen_type,1);
 win_execute_proc_to_related_wins(win,win_redisplay_all_curves);

 return NO_ERROR;
}

wr_cur_mask(fn,win)
 char *fn;
 struct image_display_window *win;
{
 FILE *fid;
 int err;

 printf("wr_cur_mask...\n");
 if ((fid = fopen(fn,"w")) != NULL)
    {if ((win->data.selection.selected_pixel.status & BUF_DATA_VALID) &&
         (win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d.status & 
                              BUF_DATA_VALID))
        {if ((err = v3_wr_buf_2d_rec(fid,
               &(win->data.draw_masks[DRAW_MASK_PIXEL_SELECTION].mask._2d)
               )) != NO_ERROR)
            printf("wr_cur_mask.DRAW_MASK_PIXEL_SELECTION..write err = %d...\n",err);
           else printf("wr_cur_mask...DRAW_MASK_PIXEL_SELECTION..ok\n");
        }
       else if ((err = v3_wr_buf_2d_rec(fid,
           &(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d))) != NO_ERROR)
        printf("wr_cur_mask...write err = %d...\n",err);
       else printf("wr_cur_mask...ok\n");
     fclose(fid);
    }
   else printf("wr_cur_mask...unable to open the file...\n");

}

win_rd_2d(win)
 struct image_display_window *win;
{
 FILE *fid;
 int err,lcv;
 struct buf_2d_rec _2d;

 init_buf_2d_rec(&_2d);

 if ((err = rd_2d("_2d.dat",&_2d)) != NO_ERROR) exit(err);
 copy_buf_2d_rec_content(&(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d),
               &_2d);
 for (lcv = 0; lcv < win->data.num_draw_masks; lcv++)
    win->data.draw_masks[lcv].paint_status |= PAINTED;
 paint_curves_to_multiple_win(win,
               win->data.draw_masks,win->data.num_draw_masks,0);
 WinCanvas(win,1);
 printf("win_rd_2d...\n");
 free_buf_2d_rec(&_2d);
}

win_wr_2d(win)
 struct image_display_window *win;
{
 wr_2d("_2d.dat",&(win->data.draw_masks[DRAW_MASK_CUR_ROI].mask._2d));
}

wr_curves1(fn,curves,num_curves)
 char *fn;
 struct curve_rec **curves;
 unsigned long num_curves;
{
 FILE *fid;
 int err;
 unsigned long lcv;

 printf("wr_curves...\n");
 if ((fid = fopen(fn,"w")) == NULL) return FILE_ACCESS_ERROR;
 if (fwrite(&num_curves,(size_t) sizeof(num_curves),1,fid) != 1)
    {printf("wr_curves...write err = %d...\n",err);
     fclose(fid);
     return WRITE_ERROR;
    }
 for (lcv = 0; lcv < num_curves; lcv++)
    if ((err = wr_curve_rec(fid,curves[lcv])) != NO_ERROR)
       {printf("wr_curves...write err = %d...\n",err);
        break;}
 fclose(fid);
 return err;
}

win_wr_curves(win)
 struct image_display_window *win;
{
 struct roi_rec *roi;
 int err;

 if (win == NULL) return NO_ERROR;
 if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
    {setup_more_rois(&(win->control.sroi.sroi_win->slice_roi),SCRATCH_STR,1);
     if ((roi = (struct roi_rec *) get_cur_roi(
              &(win->control.sroi.sroi_win->slice_roi))) == NULL)
        return ~NO_ERROR;}

 printf("wr_curves...win = %u\n",win);
 if (roi->num_pens > 0)
 if ((err = wr_curves1("curves.dat",roi->pens[0]->curves,
        roi->pens[0]->num_curves)) != NO_ERROR)
    return err;


 return NO_ERROR;
}
*/

Wr2dImage(fn,_2d,img_label,err_reason,hdr,xpix,ypix,zpix)
 char *fn;
 struct buf_2d_rec *_2d;
 char *img_label,**err_reason;
 struct hdr_rec *hdr;
 float xpix,ypix,zpix;
{
 char *str,*str1;
 FILE *fid;
 int err;
 struct hdr_rec hdr1;
 char **the_labels,*labels[1];
 static unsigned long member_img_label_indxs[] = {0};
 unsigned long type,*indxs;
 struct data_info_rec *info;

 TRACE(printf("Wr2dImage...\n"))
 if (err_reason != NULL) *err_reason = NULL;
 if ((err = concat_strs(&str,2,fn,".info")) != NO_ERROR)
    {if (err_reason != NULL) cp_str(err_reason,"MEMORY ERROR !!!");
     return err;
    }
 if (((err = file_access(str,2,NULL,err_reason)) != NO_ERROR) ||
     ((err = file_access(fn,2,NULL,err_reason)) != NO_ERROR))
    {c_free(str);
     return err;}

 if ((fid = fopen(str,"w")) == NULL) 
    {if (err_reason != NULL) cp_str(err_reason,"FILE ACCESS ERROR !!!");
     c_free(str);
     return FILE_ACCESS_ERROR;}
 clearerr(fid);

 fprintf(fid,"width = %-d  height = %-d  depth = %-d bits\n",
      _2d->dimx,_2d->dimy,_2d->pixel_depth);
 err = ferror(fid);
 fclose(fid);
 if (err != NO_ERROR)
    {if (err_reason != NULL)
        concat_strs(err_reason,2,"WRITE ERROR ON ",str);
     delete_file(str);
     c_free(str);
     return FILE_ACCESS_ERROR;}

 if ((fid = fopen(fn,"w")) == NULL) 
    {if (err_reason != NULL) cp_str(err_reason,"FILE ACCESS ERROR !!!");
     err = FILE_ACCESS_ERROR;}
   else
    {if (fwrite(_2d->buf[0],(size_t) _2d->total_bytes,(size_t) 1,fid) != 1)
        {if (err_reason != NULL)
            concat_strs(err_reason,2,"WRITE ERROR ON ",fn);
         err = WRITE_ERROR;}
     fclose(fid);
     if (err != NO_ERROR) delete_file(fn);
    }
 if (err != NO_ERROR) delete_file(str);
 c_free(str);
 str = str1 = NULL;
 if ((err == NO_ERROR) && (hdr != NULL) &&
     ((err = cp_str(&str,fn)) == NO_ERROR) &&
     ((err = drop_suffix(str)) == NO_ERROR) &&
     ((err = concat_strs(&str1,2,str,".nhdr")) == NO_ERROR))
    {init_hdr_rec(&hdr1);
     if ((err = cp_hdr_rec(&hdr1,hdr,1)) == NO_ERROR)
        {info = &(hdr1.data_info);
         info->var_use_status &= ~NUM_SCANS_USED;
         info->var_use_status &= ~INPUT_DATA_TYPE;
         type = BufTypeToInputDataType(_2d->status4);
         info->var_use_status |= type;
         info->dimx = _2d->dimx;
         info->dimy = _2d->dimy;
         info->max_scans = 1;
         info->pixel_depth_bits = _2d->pixel_depth;
         info->xpixel_size = xpix;
         info->ypixel_size = ypix;
         info->pixel_thickness = zpix;
         PRT(printf("Wr2dImage xpix = %f ypix = %f zpix = %f\n",xpix,ypix,zpix))
         info->spacing = .0;
         info->num_echoes = 1;
         /*MinMax2dValues(_2d,0,(double) .0,(double) .0,
               &(info->min_pixel),&(info->max_pixel));*/

         free_hdr_scan_entry_recs(hdr1.scans,hdr1.num_scans);
         hdr1.num_scans = 0;
         free_hdr_analysis_rec(&(hdr1.analysis));
         indxs = member_img_label_indxs;
         labels[0] = img_label;
         the_labels = labels;
         if (((err = hdr_image_labels(&hdr1,the_labels,indxs)) == NO_ERROR) &&
             ((err = BuildRiaHdr(&hdr1,0)) == NO_ERROR))
            err = wr_the_hdr(str1,&hdr1);
        }
     free_hdr_rec(&hdr1);
    }
 c_free(str);
 c_free(str1);

 TRACE(printf("Wr2dImage...end\n"))
 return err;
}

