/****************************************************************************
ask_file.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: ask_file.c,v 1.11 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <stdarg.h>

#include <unistd.h>

#include <sys/types.h>

#include <xview/wmgr.h>

#include "ask_file.h"
#include "menu.h"
#include "nria_procedures.h"

#include <math.h>     /* Placed late to not redefine BITSPERBYTE */

/*
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRINT(x)
#define PRT(x)
#define PRT6(x)


#define MEMORY_ERR "PROBABLY MEMORY ERROR !!!"


/* Functions defined in this file */
void init_dir_fn_item_rec(struct dir_fn_item_rec *dir_fn);
void free_dir_fn_item_rec(struct dir_fn_item_rec *dir_fn);
void init_chosen_fn_rec(struct chosen_fn_rec *chosen);
void free_chosen_fn_rec(struct chosen_fn_rec *chosen);
void init_dir_fn_rec(struct dir_fn_rec *dir);
void free_dir_fn_rec(struct dir_fn_rec *dir);
void init_ask_fn_rec(struct ask_fn_rec *ask);
void free_ask_fn_rec(struct ask_fn_rec *ask);
void init_all_ask_fn_recs(struct all_ask_fn_recs *all_asks);
int chosen_fn_proc(Panel_item item, char *str, int row, Panel_list_op op,
    Event *event);
unsigned long compute_total_fns(struct ask_fn_rec *ask);
int find_chosen_dir(struct ask_fn_rec *ask, char *dir, unsigned long *indx);
struct chosen_fn_rec *find_chosen_fn_rec(struct ask_fn_rec *ask, char *dir,
    char *fn, int *err);
int save_chosen(struct ask_fn_rec *ask);
int error_ask_dirfn(struct ask_fn_rec *ask, int err, unsigned long select);
int setup_dir_fns(struct ask_fn_rec *ask);
void help_proc(Panel_item item, Event *event);
int ask_change_dir(struct ask_fn_rec *ask, char *dir, char *fn);
void dir_info_proc(Panel_item item, Event *event);
int check_dir_valid(Panel_item item, Event *event);
void open_dir_proc(Panel_item item, Event *event);
void no_open_proc(Panel_item item, Event *event);
void same_dir_proc(Panel_item item, Event *event);
void last_dir_proc(Panel_item item, Event *event);
void cur_dir_proc(Panel_item item, Event *event);
void free_ask_fn_rec_it(struct ask_fn_rec *ask, int which);
int ask_cancel_proc(Panel_item item, Event *event);
int ask_done_proc(Frame frame);
int is_chosen_empty(struct ask_fn_rec *ask);
int ready_proc(Panel_item item, Event *event);
void show_num_selected_files(struct ask_fn_rec *ask);
void select_all_proc(Panel_item item, Event *event);
void deselect_all_proc(Panel_item item, Event *event);
void deselect_all_dir_proc(Panel_item item, Event *event);
void setup_dir_fn_item_rec(struct ask_fn_rec *ask, int *row, int offset);
int setup_ask_fn_rec(struct ask_fn_rec *ask, Frame frame, char *title,
    int is_center_frame, int num_fn_lines, int fn_len);
struct ask_fn_rec *find_ask_fn_rec(struct all_ask_fn_recs *all_asks,
    Frame frame, char *title);



/*-------------------------------------------------------------------------
init_dir_fn_item_rec - ???
-------------------------------------------------------------------------*/

void
init_dir_fn_item_rec(dir_fn)
 struct dir_fn_item_rec *dir_fn;
{
 dir_fn->cur_dir = NULL;
 dir_fn->last_dir = NULL;
 dir_fn->open_dir_proc = NULL;
 dir_fn->open_dir_proc_arg = NULL;

 dir_fn->fn_msg = NULL;
 dir_fn->last_fn = NULL;
 dir_fn->cur_fn = NULL;
 dir_fn->choose_fn_proc = NULL;
 dir_fn->choose_fn_proc_arg = NULL;
}


/*-------------------------------------------------------------------------
free_dir_fn_item_rec - ???
-------------------------------------------------------------------------*/

void
free_dir_fn_item_rec(dir_fn)
 struct dir_fn_item_rec *dir_fn;
{
 c_free(dir_fn->cur_dir);
 c_free(dir_fn->last_dir);
 c_free(dir_fn->fn_msg);
 c_free(dir_fn->last_fn);
 c_free(dir_fn->cur_fn);
}


/*-------------------------------------------------------------------------
init_chosen_fn_rec - ???
-------------------------------------------------------------------------*/

void
init_chosen_fn_rec(chosen)
 struct chosen_fn_rec *chosen;
{
 chosen->dir = NULL;
 chosen->fn = NULL;
 init_strs_rec(&(chosen->more_dir_fns));
 init_strs_rec(&(chosen->fns));
}


/*-------------------------------------------------------------------------
free_chosen_fn_rec - ???
-------------------------------------------------------------------------*/

void
free_chosen_fn_rec(chosen)
 struct chosen_fn_rec *chosen;
{
 c_free(chosen->dir);
 c_free(chosen->fn);
 free_strs_rec(&(chosen->more_dir_fns));
 free_strs_rec(&(chosen->fns));
}


/*-------------------------------------------------------------------------
init_dir_fn_rec - ???
-------------------------------------------------------------------------*/

void
init_dir_fn_rec(dir)
 struct dir_fn_rec *dir;
{
 dir->total_dirs = dir->num_dirs = dir->cur_dir = 0;
 dir->dirs = NULL;
}


/*-------------------------------------------------------------------------
free_dir_fn_rec - ???
-------------------------------------------------------------------------*/

void
free_dir_fn_rec(dir)
 struct dir_fn_rec *dir;
{
 unsigned long lcv;

 if (dir->total_dirs > 0)
    {for (lcv = 0; lcv < dir->num_dirs; lcv++)
        free_chosen_fn_rec(dir->dirs[lcv]);
     c_free(dir->dirs);}
}


/*-------------------------------------------------------------------------
init_ask_fn_rec - ???
-------------------------------------------------------------------------*/

void
init_ask_fn_rec(ask)
struct ask_fn_rec *ask;
{
 ask->status = 0;
 ask->title = NULL;
 ask->frame = 0;
 ask->panel = 0;
 ask->num_dirfns = 0;
 ask->dirfns = NULL;
 ask->chosen_fn_proc = NULL;
 ask->chosen_fn_proc_arg = NULL;
 ask->last_chosen_indx = -1;
 ask->total_fns = 0;
 ask->cur_total_fns = 0;
 ask->many = 0;
 ask->fn_filter = NULL;

 init_strs_rec(&(ask->fns));

 init_dir_fn_rec(&(ask->dir));
 ask->ready_proc = NULL;
 ask->ready_proc_arg = NULL;
 ask->ask_cancel_proc = NULL;
 ask->ask_cancel_proc_arg = NULL;
}


/*-------------------------------------------------------------------------
free_ask_fn_rec - ???
-------------------------------------------------------------------------*/

void
free_ask_fn_rec(ask)
struct ask_fn_rec *ask;
{
 long lcv;
 struct all_ask_fn_recs *all_asks;

 TRACE(printf("free_ask_fn_rec...\n"))
 if (ask->frame != 0)
    {win_flush_input(ask->frame);
     xv_destroy(ask->frame);}
 c_free(ask->title);
 free_strs_rec(&(ask->fns));
 c_free(ask->fn_filter);
 for (lcv = 0; lcv < ask->num_dirfns; lcv++)
    free_dir_fn_item_rec(&(ask->dirfns[lcv]));
 free_dir_fn_rec(&(ask->dir));
 c_free(ask);
 all_asks = (struct all_ask_fn_recs *) ask_files(GET_ALL_ASK_FILE_PTR);
 DropHandleAryPtr(&(all_asks->asks),&(all_asks->num_asks),ask);
 TRACE(printf("free_ask_fn_rec...end\n");)
}


/*-------------------------------------------------------------------------
init_all_ask_fn_recs - ???
-------------------------------------------------------------------------*/

void
init_all_ask_fn_recs(all_asks)
 struct all_ask_fn_recs *all_asks;
{
 all_asks->num_asks = 0;
 all_asks->asks = NULL;
}


/*-------------------------------------------------------------------------
chosen_fn_proc - ???
-------------------------------------------------------------------------*/

int
chosen_fn_proc(item,str,row,op,event)
 Panel_item item;
 char *str;
 int row;
 Panel_list_op op;
 Event *event;
{
 struct ask_fn_rec *ask;
 Panel panel;
 int err,doubleclicks;

 TRACE(printf("item = %x op = %d  row = %d str = %s\n",item,op,row,str))
 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 panel = (Panel) xv_get(item,XV_OWNER);
 if (event_shift_is_down(event))
    if (ask->chosen_fn_proc != NULL)
       {
        if ((find_chosen_fn_rec(ask,
             (char *) xv_get(ask->dirfns[0].dir_item,PANEL_VALUE),
             (char *) xv_get(ask->filter_item,PANEL_VALUE),
             &err) == NULL) || (err != NO_ERROR))
           {xv_set(ask->frame,WIN_ALARM,0);
            return err;
           }
        if (ask->dir.cur_dir < ask->dir.num_dirs)
           {if (op) xv_set(item,PANEL_LIST_SELECT,row,0,0);
              else xv_set(item,PANEL_LIST_SELECT,row,1,0);
            if ((err = ask->chosen_fn_proc(ask->chosen_fn_proc_arg,
                ask->dir.dirs[ask->dir.cur_dir],item,str,row,op,event))
                    != NO_ERROR)
               xv_set(ask->frame,WIN_ALARM,0);
            return err;
           }
       }
 ask->status |= ASK_FILE_EDITED;
 if (doubleclicks = double_click(panel,event))
    {TRACE(printf("doubleclicks...\n"))
     xv_set(item,PANEL_LIST_SELECT,row,1,0);
     TRACE(printf("doubleclicks...\n"))
     op = 1;}
 if (op)
    {
     if (ask->many)
        {TRACE(printf("many...last = %d  row = %d\n",
           ask->last_chosen_indx,row))

         if (ask->last_chosen_indx != row) ask->cur_total_fns += 1;
         if (ask->last_chosen_indx != row) ask->total_fns += 1;
         show_num_selected_files(ask);
        }
       else if (ask->last_chosen_indx != row)
        xv_set(item,PANEL_LIST_SELECT,ask->last_chosen_indx,0,0);

     ask->last_chosen_indx = row;
     if (ask->status & ASK_FILE_SAVE)
        {TRACE(printf("ASK_FILE_SAVE...\n"))
         xv_set(ask->dirfns[0].fn_item,PANEL_VALUE,str,0);}

     if (doubleclicks)
        {
         return ready_proc(ask->ready_item,event);
        }
    }
   else if (ask->many)
    {ask->cur_total_fns -= 1;
     ask->total_fns -= 1;
     show_num_selected_files(ask);

    }
   else ask->last_chosen_indx = -1;
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
compute_total_fns - ???
-------------------------------------------------------------------------*/

unsigned long 
compute_total_fns(ask)
 struct ask_fn_rec *ask;
{
 unsigned long lcv,total;

 total = 0;
 for (lcv = 0; lcv < ask->dir.num_dirs; lcv++)
    total += ask->dir.dirs[lcv]->fns.num_strs;
 return total;
}


/*-------------------------------------------------------------------------
find_chosen_dir - ???
-------------------------------------------------------------------------*/

int
find_chosen_dir(ask,dir,indx)
 struct ask_fn_rec *ask;
 char *dir;
 unsigned long *indx;
{
 if ((ask->dir.cur_dir < ask->dir.num_dirs) &&
     (str_cmp(ask->dir.dirs[ask->dir.cur_dir]->dir,dir) == 0))
    {*indx = ask->dir.cur_dir;
     return NO_ERROR;}
   else for (*indx = 0; *indx < ask->dir.num_dirs; *indx += 1)
    if (str_cmp(ask->dir.dirs[*indx]->dir,dir) == 0) return NO_ERROR;
 return CANCEL;
}


/******************************
pr_dir_fn_rec(dir)
 struct dir_fn_rec *dir;
{
 unsigned long lcv,total;

 printf("pr_dir_fn_rec...total = %d num = %d  cur = %d\n",dir->total_dirs,
        dir->num_dirs,dir->cur_dir);
 for (lcv = 0; lcv < dir->num_dirs; lcv++)
    {printf("%d) dir = %s  fn = %s \n",lcv,dir->dirs[lcv]->dir,
           dir->dirs[lcv]->fn);
     pr_strs_rec(&(dir->dirs[lcv]->more_dir_fns));
     pr_strs_rec(&(dir->dirs[lcv]->fns));}
}
***************************/



/*-------------------------------------------------------------------------
find_chosen_fn_rec - ???
-------------------------------------------------------------------------*/

struct chosen_fn_rec *
find_chosen_fn_rec(ask,dir,fn,err)
 struct ask_fn_rec *ask;
 char *dir,*fn;
 int *err;
{
 unsigned long lcv,cnt;
 struct chosen_fn_rec temp;
 int is_add;

 TRACE(printf("\nfind_chosen_fn_rec...dir = %s fn = %s\n",dir,fn))
 TRACE(printf("====ask->dir.num_dirs = %d total = %d  cur_dir = %d\n",ask->dir.num_dirs,ask->dir.total_dirs,ask->dir.cur_dir))

 find_chosen_dir(ask,dir,&lcv);

 TRACE(printf("***lcv = %d ask->dir.num_dirs = %d total = %d  cur_dir = %d\n",lcv,ask->dir.num_dirs,ask->dir.total_dirs,ask->dir.cur_dir))
 is_add = 0;
 if (lcv == ask->dir.num_dirs)
    {if (ask->dir.num_dirs >= ask->dir.total_dirs)
        {
         get_handle_memory(&(ask->dir.dirs),&(ask->dir.total_dirs),4,
              (size_t) sizeof(**(ask->dir.dirs)),err);
         if (*err != NO_ERROR) return NULL;
         for (cnt = ask->dir.num_dirs; cnt < ask->dir.total_dirs; cnt++)
            init_chosen_fn_rec(ask->dir.dirs[cnt]);
        }
     is_add = 1;
    }
 init_chosen_fn_rec(&temp);
 if (((*err = cp_str(&(temp.dir),dir)) != NO_ERROR) ||
      ((*err = cp_str(&(temp.fn),fn)) != NO_ERROR))
    {free_chosen_fn_rec(&temp);
     return NULL;}
 for (cnt = 1; cnt < ask->num_dirfns; cnt++)
    {if (((*err = add_str_to_strs_rec(&(temp.more_dir_fns),
            (char *) xv_get(ask->dirfns[cnt].dir_item,PANEL_VALUE)))
                    != NO_ERROR)  ||
         ((*err = add_str_to_strs_rec(&(temp.more_dir_fns),
                  (char *) xv_get(ask->dirfns[cnt].fn_item,PANEL_VALUE)))
                    != NO_ERROR))
        {free_chosen_fn_rec(&temp);
         return NULL;}
    }
 TRACE(printf("find_chosen_fn_rec...end temp.dir = %s  temp.fn = %s\n",
         temp.dir,temp.fn))
 c_free(ask->dir.dirs[lcv]->dir);
 c_free(ask->dir.dirs[lcv]->fn);
 free_strs_rec(&(ask->dir.dirs[lcv]->more_dir_fns));
 ask->dir.dirs[lcv]->dir = temp.dir;
 ask->dir.dirs[lcv]->fn = temp.fn;
 ask->dir.dirs[lcv]->more_dir_fns = temp.more_dir_fns;

 if (is_add) ask->dir.num_dirs += 1;
 ask->dir.cur_dir = lcv;
 return ask->dir.dirs[lcv];           
}


/*-------------------------------------------------------------------------
save_chosen - ???
-------------------------------------------------------------------------*/

int
save_chosen(ask)
 struct ask_fn_rec *ask;
{
 struct strs_rec chosen;
 struct chosen_fn_rec *cur;
 int err;

 if (!(ask->status & ASK_FILE_EDITED)) return NO_ERROR;
 init_strs_rec(&chosen);
 if ((err = selected_list_items(&chosen,ask->fns_item))
                   != NO_ERROR) 
    {free_strs_rec(&chosen);
     return err;}
 TRACE(printf("save_chosen...chosen.num_strs = %d\n",chosen.num_strs))
 if ((cur = find_chosen_fn_rec(ask,ask->dirfns[0].cur_dir,
                    ask->dirfns[0].cur_fn,&err)) != NULL)
    {free_strs_rec(&(cur->fns));
     if (chosen.num_strs > 0) cur->fns = chosen;
     ask->total_fns = compute_total_fns(ask);
     ask->status &= ~ASK_FILE_EDITED;
    }
   else free_strs_rec(&chosen);
 return err;
}


/*-------------------------------------------------------------------------
error_ask_dirfn - ???
-------------------------------------------------------------------------*/

int
error_ask_dirfn(ask,err,select)
 struct ask_fn_rec *ask;
 int err;
 unsigned long select;
{
 PRT6(printf("error_ask_dirfn....err = %d\n",err))
 if (select)
    ShowMsgStrs(ask->frame,0,err,0,3,
           "AN ERROR OCCURRED WHEN GETTING THE FILENAMES !!!",
           "IT MAY BE ONLY THE DIR/FILE READ PROTECTION ERROR !!!",
           "OR AN INVALID DIRECTORY !!!",
            NULL,0);
   else ShowMsgStrs(ask->frame,0,err,0,4,
           "AN ERROR OCCURRED WHEN GETTING THE FILENAMES !!!",
           "IT MAY BE ONLY THE DIR/FILE READ PROTECTION ERROR !!!",
           "OR AN INVALID DIRECTORY !!!",
            "OR MEMORY ERROR !!!",NULL,0);
 return err;
}


/*-------------------------------------------------------------------------
setup_dir_fns - ???
-------------------------------------------------------------------------*/

int
setup_dir_fns(ask)
 struct ask_fn_rec *ask;
{
 char *tempdir,*tempfn;
 struct strs_rec list;
 char *dir,*fn,**strs;
 unsigned int num_fns;
 int err,stop;
 char str[100];
 struct chosen_fn_rec *cur;

 dir = (char *) xv_get(ask->dirfns[0].dir_item,PANEL_VALUE);
 fn = (char *) xv_get(ask->filter_item,PANEL_VALUE);
 if (((err = cp_str(&tempdir,dir)) != NO_ERROR) ||
     ((err = cp_str(&tempfn,fn)) != NO_ERROR))
    return err;
 trim_str_blanks(tempdir);
 trim_str_blanks(tempfn);
 PRT6(printf("tempdir = %s tempfn = %s\n",tempdir,tempfn))
 init_strs_rec(&list);
 if (((err = get_fns(tempdir,NULL,0,0,NULL,&strs,&num_fns,
             1,tempfn,NULL,NULL,0,NULL)) != NO_ERROR) ||
     ((err = add_str_ptr_ary_to_strs_rec(&list,strs,num_fns)) != NO_ERROR))
    {if (num_fns > 0) deallocate_2d_ary(strs,num_fns);
    }
   else if (strs != NULL) c_free(strs);
 stop = 0;
 PRT6(printf("===setup_dir_fns....err = %d  num_fns = %d\n",err,num_fns))

 while ((err == NO_ERROR) && !stop)
    {if (ask->many)
        {if (((err = save_chosen(ask)) != NO_ERROR) ||
            ((cur = find_chosen_fn_rec(ask,tempdir,tempfn,&err)) == NULL) ||
            ((err = add_sort_no_dup_strs_rec(&list,1,1,&(cur->fns))) !=
                 NO_ERROR))
            break;
         TRACE(printf(".........\n"))
         TRACE(pr_strs_rec(&(cur->fns)))
         ask->cur_total_fns = cur->fns.num_strs;
         show_num_selected_files(ask);
        }
     TRACE(printf("tempdir...1\n"))
     if (((err = cp_str(&dir,tempdir)) != NO_ERROR) ||
         ((err = cp_str(&fn,tempfn)) != NO_ERROR))
        break;
     if (str_cmp(ask->dirfns[0].cur_dir,ask->dirfns[0].last_dir) != 0)
        {c_free(ask->dirfns[0].last_dir);
         cp_str(&(ask->dirfns[0].last_dir),ask->dirfns[0].cur_dir);}

     c_free(ask->dirfns[0].cur_dir);
     c_free(ask->dirfns[0].cur_fn);
     ask->dirfns[0].cur_dir = dir;
     ask->dirfns[0].cur_fn = fn;

     ask->last_chosen_indx = -1;
     delete_all_list_items(ask->fns_item);
     free_strs_rec(&(ask->fns));
     ask->fns = list;

     TRACE(printf("tempdir...2\n"));
     setup_list_items(&(ask->fns),ask->fns_item,0);
     if (ask->many && (cur->fns.num_strs > 0)) 
        select_list_items(&(cur->fns),ask->fns_item);
     if (ask->is_chdir) chdir(dir);
     sprintf(str,"TOTAL fns in cur dir = %ld",ask->fns.num_strs);
     xv_set(ask->num_fn_item,PANEL_LABEL_STRING,str,0);
     TRACE(printf("tempdir...3\n"));
     stop = 1;
    }
 if (err != NO_ERROR)
    {free_strs_rec_ptrs(&list);
     error_ask_dirfn(ask,err,3);
    }
 PRT6(printf("===setup_dir_fns....err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
help_proc - ???
-------------------------------------------------------------------------*/

void
help_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
}


/*-------------------------------------------------------------------------
ask_change_dir - ???
-------------------------------------------------------------------------*/

int
ask_change_dir(ask,dir,fn)
 struct ask_fn_rec *ask;
 char *dir,*fn;
{
 char *chosen_fn;
 int err;

 TRACE(printf("ask_change_dir ask = %u  dir = %s  fn = %s\n",ask,dir,fn))
 if ((err = build_fn(&chosen_fn,dir,fn,"")) == NO_ERROR)
    {
     xv_set(ask->user_item,PANEL_VALUE,chosen_fn,0);
     c_free(chosen_fn);
     if (ask->user_item == ask->dirfns[0].dir_item)
        err = setup_dir_fns(ask);
    }
   else xv_set(ask->frame,WIN_ALARM,0);
 return err;
}


/*-------------------------------------------------------------------------
dir_info_proc - ???
-------------------------------------------------------------------------*/

void
dir_info_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 struct strs_rec *dirs;
 int indx;
 char *dir_fn;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dirs = NULL;
 indx = (int) xv_get(item,XV_KEY_DATA,1);
 dir_fn = (char *) xv_get(ask->dirfns[indx].dir_item,PANEL_VALUE);
 if (valid_dir(dir_fn) != 0)
    {dir_fn = ask->dirfns[indx].cur_dir;
    /* xv_set(ask->frame,WIN_ALARM,0);*/
     error_ask_dirfn(ask,0,1);

     xv_set(item,PANEL_VALUE,dir_fn,0);
    }

 ask->user_event = *event;
 ask->user_item = ask->dirfns[indx].dir_item;
 show_menu_dir_fns(ask->panel,event,dir_fn,dirs,ask_change_dir,ask);
}


/*-------------------------------------------------------------------------
check_dir_valid - ???
-------------------------------------------------------------------------*/

int
check_dir_valid(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int indx;
 char *dir_fn;
 int err;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 indx = (int) xv_get(item,XV_KEY_DATA,1);
 dir_fn = (char *) xv_get(ask->dirfns[indx].dir_item,PANEL_VALUE);

 if ((err = valid_dir(dir_fn)) != 0)
    {error_ask_dirfn(ask,0,1);
     /*xv_set(ask->frame,WIN_ALARM,0);*/
    }
 return err;
}


/*-------------------------------------------------------------------------
open_dir_proc - ???

FIXME:  Probably but not certainly never called for value.  -PWH 19990322
-------------------------------------------------------------------------*/

void
open_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int err;
 unsigned long lcv;

 if ((err = check_dir_valid(item,event)) == NO_ERROR)
    {ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
     if ((err = setup_dir_fns(ask)) != NO_ERROR)
        {xv_set(ask->frame,WIN_ALARM,0);
	return /* err */;}
     for (lcv = 1; lcv < ask->num_dirfns; lcv++)
        if (ask->dirfns[lcv].same != 0)
           {PRT(printf("%d) same = %u\n",lcv,ask->dirfns[lcv].same);)
            if (xv_get(ask->dirfns[lcv].same,PANEL_VALUE) &&
                (ask->dirfns[lcv].same_dir != 0))
               same_dir_proc(ask->dirfns[lcv].same_dir,event);
           }
    }
}


/*-------------------------------------------------------------------------
no_open_proc - ???
-------------------------------------------------------------------------*/

void
no_open_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int indx,err;

 if ((err = check_dir_valid(item,event)) == NO_ERROR)
    {ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
     indx = (int) xv_get(item,XV_KEY_DATA,1);
     if (str_cmp(ask->dirfns[indx].last_dir,ask->dirfns[indx].cur_dir) != 0)
        {c_free(ask->dirfns[indx].last_dir);
         ask->dirfns[indx].last_dir = ask->dirfns[indx].cur_dir;}
       else c_free(ask->dirfns[indx].cur_dir);

     cp_str(&(ask->dirfns[indx].cur_dir),
            (char *) ask->dirfns[indx].dir_item);
    }
}


/*-------------------------------------------------------------------------
same_dir_proc - ???
-------------------------------------------------------------------------*/

void
same_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int indx;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 indx = (int) xv_get(item,XV_KEY_DATA,1);

 if (str_cmp(ask->dirfns[indx].last_dir,ask->dirfns[indx].cur_dir) != 0)
    {c_free(ask->dirfns[indx].last_dir);
     ask->dirfns[indx].last_dir = ask->dirfns[indx].cur_dir;}
   else c_free(ask->dirfns[indx].cur_dir);
 xv_set(ask->dirfns[indx].dir_item,PANEL_VALUE,
          (char *) xv_get(ask->dirfns[0].dir_item,PANEL_VALUE),0);
 cp_str(&(ask->dirfns[indx].cur_dir),
            (char *) xv_get(ask->dirfns[indx].dir_item,PANEL_VALUE));
}


/*-------------------------------------------------------------------------
last_dir_proc - ???

FIXME:  Probably but not certainly never called for value.  -PWH 19990322
-------------------------------------------------------------------------*/

void
last_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int indx;
 char *temp;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 indx = (int) xv_get(item,XV_KEY_DATA,1);
 if ((indx != 0) ||
     str_cmp(ask->dirfns[indx].last_dir,ask->dirfns[indx].cur_dir) != 0)
    {printf("indx = %d  last_dir = %s cur_dir = %s\n",indx,
             ask->dirfns[indx].last_dir,ask->dirfns[indx].cur_dir);
     xv_set(ask->dirfns[indx].dir_item,
             PANEL_VALUE,ask->dirfns[indx].last_dir,0);
     if (indx == 0) {
	 /* return */  open_dir_proc(ask->dirfns[indx].dir_item,event);
	 return; }
     else
        {temp = ask->dirfns[indx].last_dir;
         ask->dirfns[indx].last_dir = ask->dirfns[indx].cur_dir;
         ask->dirfns[indx].cur_dir = temp;}
    }
    
 return /* NO_ERROR */;
}


/*-------------------------------------------------------------------------
cur_dir_proc - ???

FIXME:  Probably but not certainly never called for value.  -PWH 19990322
-------------------------------------------------------------------------*/

void
cur_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int indx;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 indx = (int) xv_get(item,XV_KEY_DATA,1);
 xv_set(ask->dirfns[indx].dir_item,
             PANEL_VALUE,ask->dirfns[indx].cur_dir,0);
 if (indx == 0) {
     /* return */ open_dir_proc(ask->dirfns[indx].dir_item,event);
     return; }
 return /* NO_ERROR */;
}


/*-------------------------------------------------------------------------
free_ask_fn_rec_it - ???
-------------------------------------------------------------------------*/

void
free_ask_fn_rec_it(ask,which)
 struct ask_fn_rec *ask;
 int which;
{
 (void) notify_set_itimer_func((Notify_client) ask,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_ask_fn_rec(ask);
}


/*-------------------------------------------------------------------------
ask_cancel_proc - ???
-------------------------------------------------------------------------*/

int
ask_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int err = NO_ERROR;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (ask->status & ASK_FILE_SETUP_OK)
    if (ask->ask_cancel_proc != NULL)
       err = ask->ask_cancel_proc(ask->ask_cancel_proc_arg);
 if (ask->status & FREE_UPON_READY_AND_CANCEL)
    (void) notify_set_itimer_func((Notify_client) ask,
            (Notify_func) free_ask_fn_rec_it,ITIMER_REAL,
            &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
 else xv_set(ask->frame,WIN_SHOW,FALSE,0);
 return err;
}


/*-------------------------------------------------------------------------
ask_done_proc - ???
-------------------------------------------------------------------------*/

int
ask_done_proc(frame)
 Frame frame;
{
 struct ask_fn_rec *ask;
 int err;

 ask = (struct ask_fn_rec *) xv_get(frame,WIN_CLIENT_DATA);
 err = NO_ERROR;
 if (ask->status & ASK_FILE_SETUP_OK)
    if (ask->ask_cancel_proc != NULL)
       err = ask->ask_cancel_proc(ask->ask_cancel_proc_arg);
 free_ask_fn_rec(ask);
 return err;
}


/*-------------------------------------------------------------------------
is_chosen_empty - ???
-------------------------------------------------------------------------*/

int
is_chosen_empty(ask)
 struct ask_fn_rec *ask;
{
 unsigned long lcv;

 for (lcv = 0; lcv < ask->dir.num_dirs; lcv++)
    if (ask->dir.dirs[lcv]->fns.num_strs > 0) return 0;
 return 1;
}


/*-------------------------------------------------------------------------
ready_proc - ???
-------------------------------------------------------------------------*/

int
ready_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 int err;
 char *dir,*fn;
 unsigned long lcv;

 TRACE(printf("ready_proc...\n"))
 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 for (lcv = 1; lcv < ask->num_dirfns; lcv++)
    if (ask->dirfns[lcv].same != 0)
       {PRT(printf("%d) ready_proc same = %u\n",lcv,ask->dirfns[lcv].same);)
        if (xv_get(ask->dirfns[lcv].same,PANEL_VALUE) &&
            (ask->dirfns[lcv].same_dir != 0))
           same_dir_proc(ask->dirfns[lcv].same_dir,event);
       }

 if (ask->many)
    {if ((err = save_chosen(ask)) != NO_ERROR) return err;
     if (is_chosen_empty(ask))
        {xv_set(ask->frame,WIN_ALARM,0);
         return CANCEL;}
    }
   else if (ask->last_chosen_indx == -1)
    {TRACE(printf("last_chosen_indx == -1\n");)
     if (!(ask->status & ASK_FILE_SAVE))
       {xv_set(ask->frame,WIN_ALARM,0);
        return CANCEL;}
    }
 err = NO_ERROR;
 if (ask->status & ASK_FILE_SETUP_OK)
    if (ask->ready_proc != NULL)
       if (ask->many)
          {xv_set(ask->frame,FRAME_BUSY,TRUE,0);
           err = ask->ready_proc(ask->ready_proc_arg,&(ask->dir));
           xv_set(ask->frame,FRAME_BUSY,FALSE,NULL);
          }
         else
          {TRACE(printf(" last_chosen_indx = %d\n",ask->last_chosen_indx))
           dir = (char *) xv_get(ask->dirfns[0].dir_item,
                               PANEL_VALUE);
           if (ask->status & ASK_FILE_SAVE)
              fn = (char *) xv_get(ask->dirfns[0].fn_item,PANEL_VALUE);
             else fn = (char *) xv_get(ask->fns_item,
                 PANEL_LIST_STRING,ask->last_chosen_indx);
           TRACE(printf("dir = %s  fn = %s\n",dir,fn);)
           if ((dir != NULL) && (fn != NULL))
              {if (get_strlen(fn) > 0)
                  {xv_set(ask->frame,FRAME_BUSY,TRUE,NULL);
                   err = ask->ready_proc(ask->ready_proc_arg,dir,fn);
                   xv_set(ask->frame,FRAME_BUSY,FALSE,NULL);}
                 else
                  {TRACE(printf("empty fn\n");)
                   xv_set(ask->frame,WIN_ALARM,0);
                   return CANCEL;}
              }
          }
 TRACE(printf("done proc...1\n"))
 if (ask->status & FREE_UPON_READY_AND_CANCEL)
    (void) notify_set_itimer_func((Notify_client) ask,
             (Notify_func) free_ask_fn_rec_it,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,(struct itimerval *) 0);
   else xv_set(ask->frame,WIN_SHOW,FALSE,0);
 TRACE(printf("done proc...\n"))
 return err;
}


/*-------------------------------------------------------------------------
show_num_selected_files - ???
-------------------------------------------------------------------------*/

void
show_num_selected_files(ask)
 struct ask_fn_rec *ask;
{
 char str[100];

 if (ask->many)
    {sprintf(str,"TOTAL chosen fns in cur dir = %d",ask->cur_total_fns);
     xv_set(ask->cur_total_fn_item,PANEL_LABEL_STRING,str,0);
     sprintf(str,"TOTAL chosen fns in all dirs = %d",ask->total_fns);
     xv_set(ask->total_fn_item,PANEL_LABEL_STRING,str,0);}
}


/*-------------------------------------------------------------------------
select_all_proc - ???
-------------------------------------------------------------------------*/

void
select_all_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 select_all_list_items(ask->fns_item);
 ask->total_fns = ask->total_fns + ask->fns.num_strs - ask->cur_total_fns;
 ask->cur_total_fns = ask->fns.num_strs;
 ask->status |= ASK_FILE_EDITED;
 show_num_selected_files(ask);
}


/*-------------------------------------------------------------------------
deselect_all_proc - ???
-------------------------------------------------------------------------*/

void
deselect_all_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 unsigned long indx;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 deselect_all_list_items(ask->fns_item);
 if (find_chosen_dir(ask,ask->dirfns[0].cur_dir,&indx) == NO_ERROR)
    free_strs_rec(&(ask->dir.dirs[indx]->fns));
 if (ask->cur_total_fns != 0)
    {ask->status |= ASK_FILE_EDITED;
     ask->total_fns -= ask->cur_total_fns;
     ask->cur_total_fns = 0;
     show_num_selected_files(ask);}
}


/*-------------------------------------------------------------------------
deselect_all_dir_proc - ???
-------------------------------------------------------------------------*/

void
deselect_all_dir_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct ask_fn_rec *ask;
 unsigned long lcv;

 ask = (struct ask_fn_rec *) xv_get(item,PANEL_CLIENT_DATA);
 deselect_all_list_items(ask->fns_item);
 TRACE(printf("deselect_all_dir_proc...\n"))
 for (lcv = 0; lcv < ask->dir.num_dirs; lcv++)
    free_strs_rec(&(ask->dir.dirs[lcv]->fns));
 TRACE(printf("deselect_all_dir_proc...1\n"))
 if ((ask->cur_total_fns != 0) || (ask->total_fns != 0))
    {ask->status |= ASK_FILE_EDITED;
     ask->total_fns = 0;
     ask->cur_total_fns = 0;
     show_num_selected_files(ask);}
}



/*-------------------------------------------------------------------------
setup_dir_fn_item_rec - ???
-------------------------------------------------------------------------*/

void
setup_dir_fn_item_rec( ask, row, offset )
     struct ask_fn_rec *ask;
     int *row,offset;
{
  long lcv;
  char str[100];
  Rect *rr;
  int col;
  Panel_item item;


  for (lcv = 0; lcv < ask->num_dirfns; lcv++)
  {
    xv_create(ask->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"DIR",
	      PANEL_NOTIFY_PROC,dir_info_proc,
	      XV_X,5,XV_Y,*row,
	      PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
	      0);

    ask->dirfns[lcv].dir_item =
      xv_create( ask->panel, PANEL_TEXT,
		 XV_Y,*row,
		 PANEL_VALUE,ask->dirfns[lcv].cur_dir,
		 PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
		 PANEL_VALUE_DISPLAY_LENGTH,25,
		 PANEL_VALUE_STORED_LENGTH,100,
		 0 );

    rr = (Rect *) xv_get(ask->dirfns[lcv].dir_item,XV_RECT);
    col = rr->r_left + rr->r_width;
    if (lcv == 0)
    {
      xv_set(ask->dirfns[lcv].dir_item,
	     PANEL_NOTIFY_PROC,open_dir_proc,0);
      ask->dirfns[lcv].same = 0;
      ask->dirfns[lcv].same_dir = 0;
      item = xv_create(ask->panel,PANEL_BUTTON,
		       PANEL_LABEL_STRING,"OPEN",
		       PANEL_NOTIFY_PROC,open_dir_proc,
		       XV_X,col,XV_Y,*row,
		       PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
		       0);
      rr = (Rect *) xv_get(item,XV_RECT);
      col = rr->r_left + rr->r_width;
    }
    else 
    {
      xv_set(ask->dirfns[lcv].dir_item,PANEL_NOTIFY_PROC,
	     no_open_proc,0);
      ask->dirfns[lcv].same = xv_create(ask->panel,PANEL_CHECK_BOX,
					PANEL_LAYOUT,PANEL_HORIZONTAL,
					XV_X,col,XV_Y,*row,
					PANEL_VALUE,1,
					0);
      rr = (Rect *) xv_get(ask->dirfns[lcv].same,XV_RECT);
      ask->dirfns[lcv].same_dir =
	xv_create(ask->panel,PANEL_BUTTON,
		  PANEL_LABEL_STRING,"SAME",
		  PANEL_NOTIFY_PROC,same_dir_proc,
		  XV_X,rr->r_left + rr->r_width - 15,XV_Y,*row,
		  PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
		  0);
      rr = (Rect *) xv_get(ask->dirfns[lcv].same_dir,XV_RECT);
      col = rr->r_left + rr->r_width;
    }
    item = xv_create(ask->panel,PANEL_BUTTON,
		     PANEL_LABEL_STRING,"CUR",
		     PANEL_NOTIFY_PROC,cur_dir_proc,
		     XV_X,col,XV_Y,*row,
		     PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
		     0);
    rr = (Rect *) xv_get(item,XV_RECT);
    col = rr->r_left + rr->r_width;
    xv_create(ask->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"LAST",
	      PANEL_NOTIFY_PROC,last_dir_proc,
	      XV_X,col,XV_Y,*row,
	      PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
	      0);

    *row += offset;
    if (lcv == 0)
    {
      ask->filter_item = xv_create(ask->panel,PANEL_TEXT,
				   PANEL_NOTIFY_PROC,open_dir_proc,
				   XV_X,5,XV_Y,*row,
				   PANEL_VALUE,ask->fn_filter,
				   PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
				   PANEL_VALUE_DISPLAY_LENGTH,30,
				   PANEL_VALUE_STORED_LENGTH,100,
				   0);
      if (ask->status & ASK_FILE_SAVE)
	xv_set(ask->filter_item,PANEL_LABEL_STRING,"FILTER:",0);
      else
      {
	sprintf( str, "FILTER " );
	if (ask->dirfns[lcv].fn_msg)
	  strcat( str, ask->dirfns[lcv].fn_msg );
	xv_set(ask->filter_item,PANEL_LABEL_STRING,str,0);
      }
      *row += offset;
    }
    if ((lcv != 0) || (ask->status & ASK_FILE_SAVE))
    {
      ask->dirfns[lcv].fn_item =
	xv_create(ask->panel,PANEL_TEXT,
		  PANEL_LABEL_STRING,ask->dirfns[lcv].fn_msg,
		  XV_X,5,XV_Y,*row,
		  PANEL_VALUE,ask->dirfns[lcv].cur_fn,
		  PANEL_CLIENT_DATA,ask,XV_KEY_DATA,1,lcv,
		  PANEL_VALUE_DISPLAY_LENGTH,30,
		  PANEL_VALUE_STORED_LENGTH,100,
		  0);
      *row += offset;
    }
  }
}



/*-------------------------------------------------------------------------
setup_ask_fn_rec - ???
-------------------------------------------------------------------------*/

int
setup_ask_fn_rec(ask,frame,title,is_center_frame,num_fn_lines,fn_len)
     struct ask_fn_rec *ask;
     Frame frame;
     char *title;
     int is_center_frame,num_fn_lines,fn_len;
{
  Panel_item item;
  int row,offset,err,col;
  char *str;
  Rect *rr;

  ask->frame = xv_create(frame, FRAME,
			 /*WIN_DYNAMIC_VISUAL,TRUE,*/
			 FRAME_INHERIT_COLORS,TRUE,
			 WIN_CLIENT_DATA,ask,
			 FRAME_SHOW_LABEL, TRUE,
			 XV_LABEL,title,
			 FRAME_NO_CONFIRM,TRUE,
			 FRAME_CLOSED,FALSE,
			 FRAME_DONE_PROC,ask_done_proc,
			 0);
  if (ask->frame == 0)
  {
    free_ask_fn_rec(ask);
    return ~NO_ERROR;
  }
  ask->panel = xv_create(ask->frame,PANEL,NULL);
  if ((ask->panel == 0)
      || ((err = cp_str(&(ask->title),title)) != NO_ERROR))
  {
    free_ask_fn_rec(ask);
    return ~NO_ERROR;
  }
  ask->owner = frame;
 
  row = 5;
  offset = xv_rows(ask->panel,1) - xv_rows(ask->panel,0) - 10;
  setup_dir_fn_item_rec(ask,&row,offset);
  ask->num_fn_item = xv_create(ask->panel,PANEL_MESSAGE,
			       XV_X,5,XV_Y,row,0);
  if (ask->many)
  {
    row += offset - 7;
    ask->cur_total_fn_item = xv_create(ask->panel,PANEL_MESSAGE,
				       XV_X,5,XV_Y,row,0);
    row += offset - 7;
    ask->total_fn_item = xv_create(ask->panel,PANEL_MESSAGE,
				   XV_X,5,XV_Y,row,0);
  }
  row += offset - 5;
  if (ask->many)
  {
    xv_create(ask->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"DE-SELECT ALL",
	      PANEL_NOTIFY_PROC,deselect_all_proc,
	      XV_X,5,XV_Y,row,
	      PANEL_CLIENT_DATA,ask,
	      0);
    xv_create(ask->panel,PANEL_BUTTON,
	      PANEL_LABEL_STRING,"DE-SELECT ALL DIRS",
	      PANEL_NOTIFY_PROC,deselect_all_dir_proc,
	      XV_Y,row,
	      PANEL_CLIENT_DATA,ask,
	      0);
    row += offset;
  }

  col = 5;
  if (ask->help_fn != NULL)
  {
    item = xv_create(ask->panel,PANEL_BUTTON,
		     PANEL_LABEL_STRING,"HELP",
		     PANEL_NOTIFY_PROC,help_proc,
		     XV_X,col,XV_Y,row,
		     PANEL_CLIENT_DATA,ask,
		     0);
    rr = (Rect *) xv_get(item,XV_RECT);
    col = rr->r_left + rr->r_width;
  }
  if (ask->many)
  {
    item = xv_create(ask->panel,PANEL_BUTTON,
		     PANEL_LABEL_STRING,"SELECT ALL",
		     PANEL_NOTIFY_PROC,select_all_proc,
		     XV_X,col,XV_Y,row,
		     PANEL_CLIENT_DATA,ask,
		     0);
    rr = (Rect *) xv_get(item,XV_RECT);
    col = rr->r_left + rr->r_width;
  }
  
  item =  xv_create(ask->panel,PANEL_BUTTON,
		    PANEL_LABEL_STRING,"CANCEL",
		    PANEL_NOTIFY_PROC,ask_cancel_proc,
		    XV_X,col,XV_Y,row,
		    PANEL_CLIENT_DATA,ask,
		    0);
  rr = (Rect *) xv_get(item,XV_RECT);
  col = rr->r_left + rr->r_width;
  if (ask->status & ASK_FILE_SAVE)
    str = "SAVE";
  else
    str = "READY";
  ask->ready_item = xv_create(ask->panel,PANEL_BUTTON,
			      PANEL_LABEL_STRING,str,
			      PANEL_NOTIFY_PROC,ready_proc,
			      XV_X,col,XV_Y,row,
			      PANEL_CLIENT_DATA,ask,
			      0);

  row += offset - 2;
  ask->fns_item = xv_create(ask->panel,PANEL_LIST,
			    PANEL_LIST_DISPLAY_ROWS,num_fn_lines,
			    PANEL_LAYOUT,PANEL_VERTICAL,
			    PANEL_NOTIFY_PROC,chosen_fn_proc,
			    PANEL_CHOOSE_ONE,FALSE,
			    PANEL_CLIENT_DATA,ask,
			    XV_X,5,XV_Y,row,
			    0);
  if (fn_len == 0)
  {
    window_fit(ask->panel);
    rr = (Rect *) xv_get(ask->panel,XV_RECT);
    xv_set(ask->fns_item,PANEL_LIST_WIDTH,rr->r_width - 35,0);
  }
  else
  {
    xv_set(ask->fns_item,PANEL_LIST_WIDTH,fn_len,0);
    window_fit(ask->panel);
  }

/*
 if ((err = setup_dir_fns(ask)) != NO_ERROR)
    {free_ask_fn_rec(ask);
     return err;}
*/
 rr = (Rect *) xv_get(ask->fns_item,XV_RECT);
 xv_set(ask->panel,XV_HEIGHT,rr->r_top + rr->r_height + 5,0);
 rr = (Rect *) xv_get(ask->panel,XV_RECT);
 xv_set(ask->panel,XV_WIDTH,rr->r_width - 10,0);

 if (is_center_frame)
    {center_frame(ask->frame,1);
     window_fit(ask->frame);
    }
   else
    {window_fit(ask->frame);
     make_2_wins_adjacent(ask->frame,frame,0);}
 win_set_mouse_at_center(ask->frame);
 ask->status |= ASK_FILE_SETUP_OK;

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_ask_fn_rec - ???
-------------------------------------------------------------------------*/

struct ask_fn_rec *
find_ask_fn_rec(all_asks,frame,title)
 struct all_ask_fn_recs *all_asks;
 Frame frame;
 char *title;
{
 int lcv;

 for (lcv = 0; lcv < all_asks->num_asks; lcv++)
    if ((all_asks->asks[lcv]->owner == frame) && 
        (str_cmp(all_asks->asks[lcv]->title,title) == 0))
       return all_asks->asks[lcv];
 return NULL;
}



/*-------------------------------------------------------------------------
ask_files - ???

  ask_files():

  status, parent_frame,
  title, help_fn,
  free_upon_ready_and_cancel,
  is_center_frame,
  ready_proc, ready_proc_arg,
  ask_cancel_proc, ask_cancel_proc_arg,
  is_chdir,
  fn_filter, load_or_save (1=LOAD, 0=SAVE),
  many?, num_fn_lines, fn_len,
  chosen_fn_proc, chosen_fn_proc_arg,
  num_items,
  	[
	cur_dir, open_dir_proc, open_dir_proc_arg,
	fn_msg, cur_fn,
	choose_fn_proc, choose_fn_proc_arg
	]...

FIXME!  This ghastly function has multiple problems and probably needs
to be more or less completely rewritten.  To wit, (1) it sometimes
passes back a pointer as unsigned long and sometimes passes back an
error flag; and (2) it does any of several distinct things depending
on an option arg, apparently with different arguments expected in each
case.  I have already fixed (I hope) a problem where it uses varargs
despite also using xview, which expects stdargs.  -PWH 19990322
-------------------------------------------------------------------------*/

int
ask_files(
    int status,
    ...)
{
  va_list args;

  static struct all_ask_fn_recs all_asks;
  static char first_time = 1;
  int err;
  struct ask_fn_rec *ask;
  Frame frame;
  int num_fn_lines,fn_len,num_items,lcv,
    is_center_frame,free_upon_ready_and_cancel;
  char *str,*title;

  TRACE(printf("ask_files...\n"));
  err = NO_ERROR;
  va_start(args, status);
  if (status == GET_ALL_ASK_FILE_PTR)
  {
    va_end(args);
    if (first_time)
      return 0;
    else
      return (unsigned long) &all_asks;     /* FIXME:  ptr as long */
  }

  frame = va_arg(args,Frame);
  if (status == CLEAN_UP_ASK_FILE)
  {
    title = va_arg(args,char *);
    if (!first_time)
      if ((ask = find_ask_fn_rec(&all_asks,frame,title)) != NULL)
	free_ask_fn_rec(ask);
    va_end(args);
    return NO_ERROR;
  }

  if (first_time)
  {
    init_all_ask_fn_recs( &all_asks );
    first_time = 0;
    title = va_arg(args,char *);
  }
  else
  {
    title = va_arg(args,char *);
    if ((ask = find_ask_fn_rec(&all_asks,frame,title)) != NULL)
      free_ask_fn_rec(ask);
    va_end(args);

#if 0
    {
      TRACE(printf("ask_files...found\n"));
      xv_set(ask->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
      win_set_mouse_at_center(ask->frame);
      wmgr_top(ask->frame);
      va_end(args);
      return NO_ERROR;
    }
#endif
  }

  get_handle_memory(&(all_asks.asks),
		    &(all_asks.num_asks),1,
		    (size_t) sizeof(struct ask_fn_rec),
		    &err);
  if (err != NO_ERROR) {
    va_end(args);
    return err;
  }

  TRACE(printf("ask_files...new\n"));
  ask = all_asks.asks[all_asks.num_asks - 1];
  init_ask_fn_rec(ask);
     
  str = va_arg(args,char *);
  cp_str(&(ask->help_fn),str);
  free_upon_ready_and_cancel = va_arg(args,int);
  is_center_frame = va_arg(args,int);
  if (free_upon_ready_and_cancel)
    ask->status |= FREE_UPON_READY_AND_CANCEL;
  ask->ready_proc = (int (*)()) va_arg(args, void *);
  ask->ready_proc_arg = va_arg(args, void *);
  ask->ask_cancel_proc = (int (*)()) va_arg(args, void *);
  ask->ask_cancel_proc_arg = va_arg(args, void *);
  ask->is_chdir = va_arg(args, int);

  str = va_arg(args,char *);
  cp_str(&(ask->fn_filter),str);
  if (va_arg(args,int))
    ask->status |= ASK_FILE_LOAD;
  else
    ask->status |= ASK_FILE_SAVE;
  ask->many = va_arg(args,int);
  num_fn_lines = va_arg(args,int);
  fn_len = va_arg(args,int);

  ask->chosen_fn_proc = (int (*)()) va_arg(args, void *);
  ask->chosen_fn_proc_arg = va_arg(args, void *);
  TRACE(printf("ask_files...1\n"));

  num_items = va_arg(args,int);
  if (num_items == 0)
    free_ask_fn_rec(ask);
  else 
  {
    get_ptr_memory(&(ask->dirfns),&(ask->num_dirfns),num_items,
		   (size_t) sizeof(*(ask->dirfns)),&err);
    for (lcv = 0; lcv < num_items; lcv++) {
      init_dir_fn_item_rec(&(ask->dirfns[lcv]));
    }

    if (err == NO_ERROR) 
      for (lcv = 0; lcv < num_items; lcv++)
      {
	str = va_arg(args,char *);

	if (valid_dir(str) == 0)
	{
	  if ((err = cp_str(&(ask->dirfns[lcv].cur_dir),str)) != NO_ERROR)
	    break;
	}
	else {
	  str = ask->dirfns[lcv].cur_dir = (char *) getcwd(NULL,256);
	}
	TRACE(printf("ask->dirfns[lcv].cur_dir = %s\n",ask->dirfns[lcv].cur_dir));

	if ((err = cp_str(&(ask->dirfns[lcv].last_dir),str)) != NO_ERROR)
	  break;
	ask->dirfns[lcv].open_dir_proc = (int (*)()) va_arg(args, void *);
	ask->dirfns[lcv].open_dir_proc_arg = va_arg(args, void *);

	str = va_arg(args,char *);
	if ((err = cp_str(&(ask->dirfns[lcv].fn_msg),str)) != NO_ERROR)
	  break;
	str = va_arg(args,char *);
	if ((err = cp_str(&(ask->dirfns[lcv].last_fn),str)) != NO_ERROR)
	  break;
	if ((err = cp_str(&(ask->dirfns[lcv].cur_fn),str)) != NO_ERROR)
	  break;
	ask->dirfns[lcv].choose_fn_proc = (int (*)()) va_arg(args, void *);
	ask->dirfns[lcv].choose_fn_proc_arg = va_arg(args, void *);
      }
    TRACE(printf("ask_files...1\n"));
    if (err != NO_ERROR)
      free_ask_fn_rec(ask);
    else 
    {
      if ((err = setup_ask_fn_rec( ask, frame, title, is_center_frame,
				   num_fn_lines, fn_len )) == NO_ERROR)
      {
	xv_set(ask->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,
	       FRAME_BUSY,FALSE,0);
	setup_dir_fns(ask);
      }
    }
  }

  va_end(args);
  return err;
}
