/****************************************************************************
co_register.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: co_register.c,v 1.9 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
#define PRT15(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT30(x) x; fflush(stdout);
#define PRT16(x) x; fflush(stdout);
#define PRT14(x) x; fflush(stdout);
#define PRT17(x) x; fflush(stdout);
#define PRT18(x) x; fflush(stdout);
#define PRT19(x) x; fflush(stdout);
*/

#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)
#define PRT5(x)
#define PRT4(x)
#define PRT9(x)
#define PRT15(x)
#define PRT11(x)
#define PRT10(x)
#define PRT12(x)
#define PRT30(x)
#define PRT16(x)
#define PRT17(x)
#define PRT18(x)
#define PRT14(x)
#define PRT19(x)



/* Functions defined in this file */
int cp_co_register_rec(struct co_register_rec *dest,
    struct co_register_rec *src);
struct co_register_rec *find_co_register_rec(struct view_rec *view, char *wid,
    long *indx, int *err, int is_new);
struct co_register_rec *first_co_registered_wid(struct view_rec *view);
int co_registered_wids(struct view_rec *view, struct strs_rec *wids,
    int is_cp_str, int is_sorted, int locked_or_reg);
int view_co_registered(struct view_rec *view, struct strs_rec *wids,
    int is_cp_str, int is_sorted, int locked_or_reg);
int group_view_co_registered(struct view_rec *view, struct strs_rec *wids,
    int is_cp_str, int is_sorted, int locked_or_reg);
int co_reg_wid_ptrs_by_file_group(struct strs_rec *wids,
    struct strs_rec *result_wid_ptrs, struct input_file_rec *file, long gnum);
int view_check_cross_registered(struct view_rec *view);
int view_lock_target(struct view_rec *view, struct view_rec *target);
int view_check_locked(struct view_rec *view);
int drop_co_registered_plane(struct view_rec *view, long which);
int AssignCoRegPlaneParams(struct co_register_rec *co,
    struct plane_3d_rec *gplane, struct plane_3d_rec *cogplane, int status);
int win_co_register(struct image_display_window *win, char *wid);
int win_co_register_to_wid(struct image_display_window *win, char *wid);
int win_check_and_co_register_to_wid(struct image_display_window *win,
    char *wid);
int view_unco_register_from_file_group(struct view_rec *view,
    struct input_file_rec *file, long gnum, char *except_wid);
int change_coplane_of_wid(struct view_rec *view, char *old_coplane_of_wid,
    char *new_coplane_of_wid);
int update_coplane_of_wid(struct view_rec *view, char *coplane_of_wid);
int WinUncoRegisterFromWid(struct image_display_window *win, char *wid,
    int is_update_coplane_of_wid);
int UncoRegisterWithAll(struct view_rec *view, int is_unlock_all,
    int is_unco_all, int is_update_coplane_of_wid);
int WinUncoRegisterWithAll(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
int win_unco_register_all_group_wids(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
int win_unco_register_every_wid(struct image_display_window *win,
    int is_unlock_all, int is_unco_all);
int unco_register_file(struct input_file_rec *file);
int view_and_coplane_adjust_mode_on(struct view_rec *view,
    char *coplane_of_wid);
int view_and_coplane_adjust_mode_off(struct view_rec *view,
    char *coplane_of_wid);
int win_wid_and_coplane_adjust_mode_on(struct image_display_window *win);
int win_wid_and_coplane_adjust_mode_off(struct image_display_window *win);
int win_wid_adjust_mode_on(struct image_display_window *win);
int win_wid_adjust_mode_off(struct image_display_window *win);
int pr_xyztoplane(struct view_rec *view);
int view_adjust_reco_register(struct view_rec *view,
    struct view_rec *reg_view, struct view_rec *co_view,
    struct co_register_rec *co);
int view_auto_adjust_reco_register(struct view_rec *view);
int view_lock_coplane_of_wid(struct view_rec *view,
    struct view_rec *main_view);
int view_unlock_coplane_of_wid(struct view_rec *view,
    struct view_rec *main_view);
int win_lock_coplanes_of_wid(struct image_display_window *win);
int win_unlock_coplanes_of_wid(struct image_display_window *win);
int view_co_reg_xyz(struct view_rec *view, double x, double y, double z,
    float *cx, float *cy, float *cz);
void win_xyz_by_co_reg_wid(struct image_display_window *win, char *wid);
int win_move_mouse_to_co_reg_wid(struct image_display_window *win);
int win_co_register_onoff(struct image_display_window *win, int onoff);
int is_view_adjust_mode_on(struct view_rec *view);
int is_3d_win_locked(struct image_display_window *win);
int win_co_registered_wids(struct image_display_window *win,
    struct strs_rec *wids, int is_cp_str, int is_sorted, int locked_or_reg);
int win_co_reg_path_wids(struct image_display_window *win,
    struct strs_rec *wids);
int win_co_plane(struct image_display_window *win, char *reg_wid,
    char *coreg_wid, char *coreg_coplane_wid);
void clear_all_planes_co_process_status(struct view_rec *view,
    int is_fusion_sync, int is_clear);
int CoRegBaseAndNormal(struct matrix_3d_rec *xyztoplane,
    struct matrix_3d_rec *coplanetoxyz, struct vector_3d_rec *base,
    struct vector_3d_rec *normal, struct vector_3d_rec *new_cobase,
    struct vector_3d_rec *new_conormal);
void CoRegisteredMatrix(struct vector_3d_rec *base1,
    struct vector_3d_rec *norm1, struct vector_3d_rec *base2,
    struct vector_3d_rec *norm2, struct matrix_3d_rec *xyztoplane,
    struct matrix_3d_rec *planetoxyz);
int ComputeLockPlane(struct view_rec *view, struct co_register_rec *co,
    struct vector_3d_rec *base, struct vector_3d_rec *normal);
void CoRegisteredParams(struct view_rec *view, struct co_register_rec *co,
    struct vector_3d_rec *base, struct vector_3d_rec *normal,
    unsigned int is_same_group);
int DisplayCoRegisteredPlanes(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock);
int ViewDpUnprocessed(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock);
int DisplayCoRegisteredAdjustedPlanes(struct view_rec *view,
    int is_trigger_co, int is_trigger_lock);
int is_coreg_on_proc(struct view_rec *view);
int DpAllCoRegPlanes(struct view_rec *view, int is_trigger_co,
    int is_trigger_lock, int is_dp_cur, int is_dp_whole_group,
    int is_mv_recoreg);
int WinReDisplayViewGroup(struct image_display_window *win);
int win_valid_fusion_wid_file_group(struct image_display_window *win,
    int co_wid);
int win_reco_register_group(struct image_display_window *win, char *co_wid);
int win_reco_reg_group(struct image_display_window *win, char *co_wid);
int win_reco_register(struct image_display_window *win, char *co_wid);



/*-----------------------------------------------------------------------
cp_co_register_rec - ???
-----------------------------------------------------------------------*/

int
cp_co_register_rec(dest,src)
 struct co_register_rec *dest,*src;
{
 int err;

 *dest = *src;
 dest->wid = dest->coplane_of_wid = NULL;
 if ((err = cp_str(&(dest->wid),src->wid)) != NO_ERROR) return err;
 return cp_str(&(dest->coplane_of_wid),src->coplane_of_wid);
}


/*-----------------------------------------------------------------------
find_co_register_rec - ???
-----------------------------------------------------------------------*/

struct co_register_rec *
find_co_register_rec(view,wid,indx,err,is_new)
 struct view_rec *view;
 char *wid;
 long *indx;
 int *err,is_new;
{
 long lcv;

 *err = NO_ERROR;
 for (lcv = 0; lcv < view->num_cos; lcv++)
    if (str_cmp(view->cos[lcv].wid,wid) == 0)
       {*indx = lcv;
        return &(view->cos[lcv]);}
 if (!is_new) return NULL;
 if (view->num_cos == view->total_cos)
    {if ((*err = get_ptr(&(view->cos),&(view->total_cos),10,
          (size_t) sizeof(*(view->cos)))) != NO_ERROR)
        return NULL;
    }
 init_co_register_rec(&(view->cos[view->num_cos]));
 if ((*err = cp_str(&(view->cos[view->num_cos].wid),wid)) != NO_ERROR)
    return NULL;
 *indx = view->num_cos;
 view->num_cos += 1;
 return &(view->cos[*indx]);
}


/*-----------------------------------------------------------------------
first_co_registered_wid - ???
-----------------------------------------------------------------------*/

struct co_register_rec *
first_co_registered_wid(view)
 struct view_rec *view;
{
 long lcv;

 if (view->status & PLANE_CROSS_REGISTERED)
    for (lcv = 0; lcv < view->num_cos; lcv++)
       if (!(view->cos[lcv].status & LOCKED))
          return &(view->cos[lcv]);
 return NULL;
}


/*-----------------------------------------------------------------------
co_registered_wids - ???
-----------------------------------------------------------------------*/

int
co_registered_wids(view,wids,is_cp_str,is_sorted,locked_or_reg)
 struct view_rec *view;
 struct strs_rec *wids;
 int is_cp_str,is_sorted,locked_or_reg;
{
 long lcv;
 int err;

 for (lcv = 0; lcv < view->num_cos; lcv++)
    {if (view->cos[lcv].status & LOCKED)
        {if (!(locked_or_reg & 1)) continue;}
       else if (!(locked_or_reg & 2)) continue;
     if (is_cp_str)
        err = add_str_to_strs_rec(wids,view->cos[lcv].wid);
       else err = add_str_ptr_to_strs_rec(wids,view->cos[lcv].wid);
     if (err != NO_ERROR) return err;
    }
 if (is_sorted) sort_strs_rec_ascendingly(wids);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_co_registered - ???
-----------------------------------------------------------------------*/

int
view_co_registered(view,wids,is_cp_str,is_sorted,locked_or_reg)
 struct view_rec *view;
 struct strs_rec *wids;
 int is_cp_str,is_sorted,locked_or_reg;
{
 int err,ok;

 if (view->num_cos > 0)
    {ok  = 0;
     if (view->status & PLANE_CROSS_REGISTERED)
        if (locked_or_reg & 2) ok = 1;
     if (view->status & PLANE_LOCKED)
        if (locked_or_reg & 1) ok = 1;
     if (ok)
        if (is_cp_str)
           {if ((err = add_str_to_strs_rec(wids,view->wid)) != NO_ERROR)
               return err;
           }
          else if ((err = add_str_ptr_to_strs_rec(wids,view->wid)) != 
                   NO_ERROR)
           return err;
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
group_view_co_registered - ???
-----------------------------------------------------------------------*/

int
group_view_co_registered(view,wids,is_cp_str,is_sorted,locked_or_reg)
 struct view_rec *view;
 struct strs_rec *wids;
 int is_cp_str,is_sorted,locked_or_reg;
{
 return run_next_view_proc(view,view_co_registered,
             wids,is_cp_str,is_sorted,locked_or_reg,0,0);
}


/*-----------------------------------------------------------------------
co_reg_wid_ptrs_by_file_group - ???
-----------------------------------------------------------------------*/

int
co_reg_wid_ptrs_by_file_group(wids,result_wid_ptrs,file,gnum)
 struct strs_rec *wids,*result_wid_ptrs;
 struct input_file_rec *file;
 long gnum;
{
 struct view_rec *view,*view1;
 long lcv,cnt;
 int err;

 for (cnt = 0; cnt < wids->num_strs; cnt++)
    {if ((view = find_any_view_rec(file,wids->strs[cnt])) != NULL)
        for (lcv = 0; lcv < view->num_cos; lcv++)
           {if ((view1 = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
               if ((view1->group_num == gnum) && (view1->file == file))
                  {if ((err = add_str_ptr_to_strs_rec(result_wid_ptrs,view->wid)) != 
                                   NO_ERROR)
                      return err;
                   break;}
           }
    }
 return err;
}


/*-----------------------------------------------------------------------
view_check_cross_registered - ???
-----------------------------------------------------------------------*/

int
view_check_cross_registered(view)
 struct view_rec *view;
{
 long lcv;
 struct view_rec *view1;

 view->status &= ~PLANE_CROSS_REGISTERED;
 for (lcv = 0; lcv < view->num_cos; lcv++)
    {if ((view1 = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
        if ((view1->group_num != view->group_num) ||
            (view1->file != view->file))
           {view->status |= PLANE_CROSS_REGISTERED;
            break;}
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_lock_target - ???
-----------------------------------------------------------------------*/

int
view_lock_target(view,target)
 struct view_rec *view,*target;
{
 struct co_register_rec *co;
 int err;
 long indx;

 if (view == target) return NO_ERROR;
 PRT30(printf("view_lock_target view = %u target = %u\n",view,target))
 PRT30(printf("view_lock_target view = %s target = %s\n",view->wid,target->wid))
 if ((co = find_co_register_rec(view,target->wid,&indx,&err,0)) != NULL)
    {target->status |= PLANE_LOCKED;
     return 1;}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_check_locked - ???
-----------------------------------------------------------------------*/

int
view_check_locked(view)
 struct view_rec *view;
{
 view->status &= ~PLANE_LOCKED;
 if (view->num_cos == 0) return NO_ERROR;
 run_next_view_proc(view,view_lock_target,view,0,0,0,0,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
drop_co_registered_plane - ???
-----------------------------------------------------------------------*/

int
drop_co_registered_plane(view,which)
 struct view_rec *view;
 long which;
{
 long cnt,temp;
 struct view_rec *view1;

 PRT30(printf("drop_co_registered_plane view = %u\n",view))
 PRT30(printf("drop_co_registered_plane...wid = %s num_cos = %d which = %d\n",
            view->wid,view->num_cos,which))
 if ((which < 0) || (which >= view->num_cos) ||
     (view->num_cos == 0))
    return NO_ERROR;
 free_co_register_rec(&(view->cos[which]));
 temp = view->num_cos - 1;
 for (cnt = which; cnt < temp; cnt++)
    view->cos[cnt] = view->cos[cnt+1];
 view->num_cos = temp;
 if (view->num_cos == 0)
    {view->status &= ~PLANE_REGISTERED_STATUS;
    }
   else if ((view1 = find_any_view_rec(view->file,view->cos[which].wid))
             == NULL)
    {if (view->num_cos > 0) view_check_cross_registered(view);
       else view->status &= ~PLANE_CROSS_REGISTERED;
     if (view->num_cos > 0) view_check_locked(view);
       else view->status &= ~PLANE_LOCKED;
    }
   else if ((view1->group_num != view->group_num) ||
            (view1->file != view->file))
    {
     if (view->num_cos > 0) view_check_cross_registered(view);
       else view->status &= ~PLANE_CROSS_REGISTERED;
    }
   else
    {if (view->num_cos > 0) view_check_locked(view);
       else view->status &= ~PLANE_LOCKED;
    }

 return NO_ERROR;
}

/*************************
sort_view_proc(view1,view2)
 struct view_rec *view1,*view2;
{
 return str_cmp(view1->wid,view2->wid);
}

add_sorted_view(all,total_planes,num_planes,view)
 struct view_rec ***all,*view;
 long *total_planes,*num_planes;
{
 long insert_posi,lcv;

 if (obj_binary_search(*all,*num_planes,sizeof(view),view,
        sort_view_proc,&insert_posi) == NOT_FOUND)
    {if (*num_planes == *total_planes)
        {if ((err = get_ptr(all,total_planes,20,
                (size_t) sizeof(*all))) != NO_ERROR)
            return err;
        }
     for (lcv = *num_planes; lcv > insert_posi; lcv--)
        (*all)[lcv] = (*all)[lcv - 1]
     (*all)[insert_posi] = view;
     *num_planes += 1;
    }
 return NO_ERROR;
}

get_all_co_registered_planes(all,total_planes,num_planes,is_new,view)
 struct view_rec ***all,*view;
 long *total_planes,*num_planes;
 int is_new;
{
 long lcv,cnt,temp;
 int err;
 struct view_rec *next;

 if (is_new)
    {*total_planes = *num_planes = 0;
    }
 if (view->num_cos == 0) return NO_ERROR;
 if ((err = add_sorted_view(all,total_planes,num_planes,view))
       != NO_ERROR)
    return err;
 for (lcv = 0; lcv < view->num_cos; )
    {if ((next = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
        {if (next->status & PLANE_CO_REGISTERED_PROCESSED) 
            {lcv ++;
             continue;}
         if ((err = add_sorted_view(all,total_planes,num_planes,next))
                  != NO_ERROR)
            return err;
         next->status |= PLANE_CO_REGISTERED_PROCESSED;
         if ((next->status & PLANE_CO_REGISTERED) && (next->num_cos > 0))
            if ((err = get_all_co_registered_planes(all,total_planes,
                 num_planes,0,next)) != NO_ERROR)
               break;
         lcv++;
        }
       else drop_co_registered_plane(view,lcv);
    }
    
 return err;
}
****************/


/*****************
 struct view_rec **all;
 long total_planes,num_planes;
 int err;

 clear_all_planes_co_process_status(view,0,0);
 if ((err = get_all_co_registered_planes(&all,&total_planes,
              &num_planes,1,view)) != NO_ERROR)
    {if (total_planes > 0) c_free(all);
     return err;}
 if (num_planes > 0)
    {for (lcv = 0; lcv < num_planes; lcv++)
        all[lcv]->status &= ~PLANE_CO_REGISTERED_PROCESSED;
     err = dp_all_co_registered_planes(all,num_planes,view);
    }
 if (total_planes > 0) c_free(all);
 return err;
}
************************/


/*-----------------------------------------------------------------------
AssignCoRegPlaneParams - ???
-----------------------------------------------------------------------*/

int
AssignCoRegPlaneParams(co,gplane,cogplane,status)
 struct co_register_rec *co;
 struct plane_3d_rec *gplane,*cogplane;
 unsigned short status;
{
 co->status = status;
 co->reg.base = gplane->base;
 co->reg.normal = gplane->normal_cosine;
 PRT1(printf("....base = ");pr_vector_3d_rec(&(gplane->base));)
 PRT1(printf("...reg.base = ");pr_vector_3d_rec(&(co->reg.base));)
 PRT1(printf("...reg.normal = ");pr_vector_3d_rec(&(co->reg.normal));)
 co->reg.xyztoplane = gplane->xyztoplane;
 zrotate_3d_matrix(&(co->reg.xyztoplane),gplane->rotate.z);
 inverse_4d_matrix(&(co->reg.planetoxyz),&(co->reg.xyztoplane));
 co->reg.rotation = gplane->rotate;
 co->reg.rotation.z = .0;
 PRT1(printf("$$$$..xyztoplane = ");pr_3d_matrix(&(co->reg.xyztoplane));)
 PRT1(printf("..planetoxyz = ");pr_3d_matrix(&(co->reg.planetoxyz));)
 PRT1(printf("...rotate.z = %f\n",gplane->rotate.z);)
 PRT1(printf("...co.xyztoplane = ");pr_3d_matrix(&(co->reg.xyztoplane));)

 co->coreg.base = cogplane->base;
 co->coreg.normal = cogplane->normal_cosine;
 PRT1(printf("....coview cobase = ");pr_vector_3d_rec(&(cogplane->base));)
 PRT1(printf("...coreg.base = ");pr_vector_3d_rec(&(co->coreg.base));)
 PRT1(printf("...coreg.normal = ");pr_vector_3d_rec(&(co->coreg.normal));)

 co->coreg.xyztoplane = cogplane->xyztoplane;
 zrotate_3d_matrix(&(co->coreg.xyztoplane),cogplane->rotate.z);
 inverse_4d_matrix(&(co->coreg.planetoxyz),&(co->coreg.xyztoplane));

 co->coreg.rotation = cogplane->rotate;
 co->coreg.rotation.z = .0;
 PRT1(printf("..coreg.xyztoplane = ");pr_3d_matrix(&(co->coreg.xyztoplane));)
 PRT1(printf("..coreg.planetoxyz = ");pr_3d_matrix(&(co->coreg.planetoxyz));)
 PRT1(printf("coreg.rotate.z = %f\n",cogplane->rotate.z);)
 PRT2(printf("...coreg.xyztoplane = ");pr_3d_matrix(&(co->coreg.xyztoplane));)
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_co_register - ???
-----------------------------------------------------------------------*/

int
win_co_register(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 struct co_register_rec *co,*co1;
 int err;
 unsigned short locked;
 long indx,indx1;

 if (wid == NULL) return NO_ERROR;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT18(printf("win_co_register...wid = %s to view wid = %s\n",wid,view->wid))
 err = NO_ERROR;
 if (str_cmp(view->wid,wid) == 0)
    return NO_ERROR;
   else
    {if ((view1 = find_file_view_rec(img->file,wid)) == NULL)
        view1 = find_any_view_rec(img->file,wid);
     if (view1 == NULL) return CANCEL;
     if ((view->group_num != view1->group_num) ||
         (view->file != view1->file))
        {/*view_unco_register_from_file_group(view,
                view1->file,view1->group_num,view1->wid);
         view_unco_register_from_file_group(view1,
                view->file,view->group_num,view->wid);*/
         locked = 0;
        }
       else locked = LOCKED;
     co = NULL;
     if (((co = find_co_register_rec(view,view1->wid,&indx,&err,1)) == NULL) ||
         ((co1 = find_co_register_rec(view1,view->wid,&indx1,&err,1)) == NULL))
        {if (co != NULL) drop_co_registered_plane(view,indx);
        }
       else
        {view->status |= PLANE_CO_REGISTERED;
         view1->status |= PLANE_CO_REGISTERED;
         AssignCoRegPlaneParams(co,&(view->gplane),&(view1->gplane),locked);
         free_ptr(&(co->coplane_of_wid));
         free_ptr(&(co1->coplane_of_wid));
         if (locked == 0)
            {cp_str(&(co->coplane_of_wid),view->wid);
             cp_str(&(co1->coplane_of_wid),view1->wid);}
         PRT18(printf("view->wid = %s num_cos = %d co = %s\n",
               view->wid,view->num_cos,co->coplane_of_wid);)
         PRT18(printf("view1 wid = %s num_cos = %d co = %s\n",
               view1->wid,view1->num_cos,co1->coplane_of_wid);)

         co1->reg = co->coreg;
         co1->coreg = co->reg;
         co1->status &= ~CO_PLANE;
         co->status &= ~CO_PLANE;

         if (locked == 0)
            {PRT11(printf("...win_co_register...locked == 0\n");)
             view->status |= PLANE_CROSS_REGISTERED | PLANE_CROSS_REGISTERED_MAJOR;
             view1->status |= PLANE_CROSS_REGISTERED | PLANE_CROSS_REGISTERED_MAJOR;
            }
           else
            {view->status |= PLANE_LOCKED;
             view1->status |= PLANE_LOCKED;
            }
         PRT11(printf("view->status = %x view1->status = %x\n",
                    (unsigned long) view->status,(unsigned long) view1->status);)
        }
     update_co_register_menu(win);
     if (view1->img->win != NULL)
        update_co_register_menu(view1->img->win->image_display);
    }
 PRT30(printf("...win_co_register...err = %d\n",err);)
 return err;
}


/*-----------------------------------------------------------------------
win_co_register_to_wid - ???
-----------------------------------------------------------------------*/

int
win_co_register_to_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 int err;

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((view = find_any_view_rec(img->file,wid)) == NULL) ||
     (view->img == NULL) || (view->img->win == NULL) ||
     (view->img->win->image_display == NULL) ||
     ((err = win_co_register(view->img->win->image_display,
            img->cur_slice->slice->view->wid)) != NO_ERROR))
    ShowMsgStrs(win->dwin->frame,0,err,0,4,
               "Error occurred when co-registering !!!",
               img->cur_slice->slice->view->wid,"&",
               view->wid,NULL,0);
 return err;
}


/*-----------------------------------------------------------------------
win_check_and_co_register_to_wid - ???
-----------------------------------------------------------------------*/

int
win_check_and_co_register_to_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 float x1,y1,z1,x2,y2,z2;
 struct buf_3d_rec *_3d1,*_3d2;
 int err;
 char str[100],*str1;

 PRT1(printf("win_check_and_co_register_to_wid...wid = %s\n",wid))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 if ((view1 = find_any_view_rec(img->file,wid)) == NULL)
    {ShowMsgStrs(win->dwin->frame,0,err,0,3,
            wid,"doesn't exist !!! ",
            "Will abort !!!",NULL,0);
     return CANCEL;}
 if ((view1->img == NULL) || (view1->img->win == NULL) ||
     (view1->img->win->image_display == NULL) ||
     (find_file_3d(img->file,view->id,&_3d1) != NO_ERROR) ||
     (find_file_3d(view1->img->file,view1->id,&_3d2) != NO_ERROR))
    {ShowMsgStrs(win->dwin->frame,0,0,0,2,
            "An internal error had occured !!!",
            "Will abort !!!",NULL,0);
     return CANCEL;}
 PRT1(printf("_3d1 = %u..._3d2 = %u\n",_3d1,_3d2))
 if (_3d1 != _3d2)  
    {x1 = _3d1->xpixel_size * view->gplane.coord_ratio.x;
     y1 = _3d1->ypixel_size * view->gplane.coord_ratio.y;
     z1 = _3d1->zpixel_size * view->gplane.coord_ratio.z;
    PRT1(printf("1...x1 = %f y1 = %f z1 = %f...\n",x1,y1,z1))
     x2 = _3d2->xpixel_size * view1->gplane.coord_ratio.x;
     y2 = _3d2->ypixel_size * view1->gplane.coord_ratio.y;
     z2 = _3d2->zpixel_size * view1->gplane.coord_ratio.z;
     x1 = x1 - x2;
     y1 = y1 - y2;
     z1 = z1 - z2;
     if (x1 < .0) x1 = -x1;
     if (y1 < .0) y1 = -y1;
     if (z1 < .0) z1 = -z1;
     PRT1(printf("2...x1 = %f y1 = %f z1 = %f...\n",x1,y1,z1))
     if ((x1 > .000002) || (y1 > .000002) || (z1 > .000002))
        {sprintf(str,"%s & %s",view->wid,view1->wid);
         x1 = x1 * y1 * z1;
         x2 = x2 * y2 * z2;
         if (x1 > x2)
            concat_strs(&str1,4,"And, ",view->wid," is bigger than ",
                     view1->wid);
          else
            concat_strs(&str1,4,"And, ",view1->wid," is bigger than ",
                     view->wid);
         ShowMsgStrs(win->dwin->frame,0,0,0,5,
            str,
            "do not have the same voxel size !!!",
            "Please resize the bigger one to the size of the smaller !!!",
            str1,
            "Will not co-register !!!",
            NULL,0);
         c_free(str1);
         return CANCEL;}
    }
 PRT1(printf("win_check_and_co_register_to_wid...1\n"))
 return win_co_register_to_wid(win,wid);
}


/*-----------------------------------------------------------------------
view_unco_register_from_file_group - ???
-----------------------------------------------------------------------*/

int
view_unco_register_from_file_group(view,file,gnum,except_wid)
 struct view_rec *view;
 struct input_file_rec *file;
 long gnum;
 char *except_wid;
{
 struct view_rec *view1;
 long lcv;

 for (lcv = 0; lcv < view->num_cos; lcv++)
    {if ((view1 = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
        if ((view1->group_num == gnum) && (view1->file == file))
           {if ((except_wid == NULL) || 
                (str_cmp(view->cos[lcv].wid,except_wid) != 0))
               {drop_co_registered_plane(view,lcv);
                lcv--;}
           }
    }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
change_coplane_of_wid - ???
-----------------------------------------------------------------------*/

int
change_coplane_of_wid(view,old_coplane_of_wid,new_coplane_of_wid)
 struct view_rec *view;
 char *old_coplane_of_wid,*new_coplane_of_wid;
{
 unsigned long lcv;

 PRT18(printf("change_coplane_of_wid view->wid = %s num_cos = %d old coplane_of_wid = %s  new = %s\n",
             view->wid,view->num_cos,old_coplane_of_wid,new_coplane_of_wid))
 for (lcv = 0; lcv < view->num_cos; lcv++)
    if (str_cmp(view->cos[lcv].coplane_of_wid,old_coplane_of_wid) == 0)
       {PRT18(printf("change_coplane_of_wid replaced\n"))
        str_dealloc_and_cpy(&(view->cos[lcv].coplane_of_wid),new_coplane_of_wid);}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
update_coplane_of_wid - ???
-----------------------------------------------------------------------*/

int
update_coplane_of_wid(view,coplane_of_wid)
 struct view_rec *view;
 char *coplane_of_wid;
{
 unsigned long lcv;

 PRT18(printf("update_coplane_of_wid view->wid = %s num_cos = %d coplane_of_wid = %s\n",
             view->wid,view->num_cos,coplane_of_wid))
 for (lcv = 0; lcv < view->num_cos; lcv++)
    if ((str_cmp(view->cos[lcv].coplane_of_wid,coplane_of_wid) == 0) &&
        (str_cmp(view->wid,coplane_of_wid) != 0))
       {view->cos[lcv].status &= ~CO_PLANE;
        run_next_view_proc(view,change_coplane_of_wid,coplane_of_wid,
			   view->wid,0,0,0,0);
        break;
       }
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
WinUncoRegisterFromWid - ???
-----------------------------------------------------------------------*/

int
WinUncoRegisterFromWid(win,wid,is_update_coplane_of_wid)
 struct image_display_window *win;
 char *wid;
 int is_update_coplane_of_wid;
{
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 struct co_register_rec *co;
 long indx;
 int err,is_coplane_of_wid;

 PRT18(printf("WinUncoRegisterFromWid...win = %u wid = %s is_update_coplane_of_wid = %d\n",
         win,wid,is_update_coplane_of_wid))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view1 = img->cur_slice->slice->view;
 PRT18(printf("WinUncoRegisterFromWid win->wid = %s wid = %s\n",view1->wid,wid))
 if ((view = find_any_view_rec(img->file,wid)) == NULL) 
    {PRT18(printf("WinUncoRegisterFromWid view == NULL view1 = %u\n",view1))
     if ((co = find_co_register_rec(view1,wid,&indx,&err,0)) != NULL)
        {PRT12(printf("drop_co_registered_plane indx = %d\n",indx))
         drop_co_registered_plane(view1,indx);}
     return NO_ERROR;}

 if ((view->img == NULL) || (view->img->win == NULL) ||
     (view->img->win->image_display == NULL)) return CANCEL;
 PRT18(printf("WinUncoRegisterFromWid...2\n"))
 if ((co = find_co_register_rec(view,view1->wid,&indx,&err,0)) != NULL)
    {
     if (is_update_coplane_of_wid &&
         (str_cmp(co->coplane_of_wid,view->wid) == 0))
        is_coplane_of_wid = 1;
       else is_coplane_of_wid = 0;
     PRT18(printf("view->num_cos = %d\n",view->num_cos))
     drop_co_registered_plane(view,indx);
     PRT18(printf("win_unco 1 is_coplane_of_wid = %d indx = %d num_cos = %d\n",
        is_coplane_of_wid,indx,view->num_cos))
     update_co_register_menu(view->img->win->image_display);
     if (is_update_coplane_of_wid && is_coplane_of_wid)
        run_next_view_proc(view,update_coplane_of_wid,view->wid,0,0,0,0,0);
    }

 if ((co = find_co_register_rec(view1,view->wid,&indx,&err,0)) != NULL)
    {
     if (is_update_coplane_of_wid &&
         (str_cmp(co->coplane_of_wid,view1->wid) == 0))
        is_coplane_of_wid = 1;
       else is_coplane_of_wid = 0;
     drop_co_registered_plane(view1,indx);
     PRT18(printf("win_unco update_co_register_menu %s is_coplane_of_wid = %d\n",
           view->wid,is_coplane_of_wid))
     if (view1->img->win != NULL)
        update_co_register_menu(view1->img->win->image_display);
     if (is_update_coplane_of_wid && is_coplane_of_wid)
        run_next_view_proc(view1,update_coplane_of_wid,view1->wid,
			   0,0,0,0,0);
    }
 PRT18(printf("WinUncoRegisterFromWid...err = %d\n",err))
 return err;
}


/*-----------------------------------------------------------------------
UncoRegisterWithAll - ???
-----------------------------------------------------------------------*/

int
UncoRegisterWithAll(view,is_unlock_all,is_unco_all,is_update_coplane_of_wid)
 struct view_rec *view;
 int is_unlock_all,is_unco_all,is_update_coplane_of_wid;
{
 struct view_rec *view1;
 long lcv;

 PRT12(printf("\nUncoRegisterWithAll...unlock = %d unco = %d  num_cos = %d wid = %s\n",is_unlock_all,is_unco_all,view->num_cos,view->wid))
 if (!is_unlock_all && !is_unco_all) return NO_ERROR;

 for (lcv = 0; lcv < view->num_cos; lcv++)
    {PRT12(printf("%d)  1 num_cos = %d\n",lcv,view->num_cos))
     if ((view1 = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
        if ((view1->group_num != view->group_num) ||
            (view1->file != view->file))
           {if (!is_unco_all) continue;}
          else if (!is_unlock_all) continue;
     if (view->img->win != NULL)
        {WinUncoRegisterFromWid(view->img->win->image_display,view->cos[lcv].wid,
              is_update_coplane_of_wid);
         PRT12(printf("%d)  2 num_cos= %d view1 = %u\n",lcv,view->num_cos,view1);
         if (view1 == NULL) printf("view1 == NULL\n");
           else printf("view1->wid = %s\n",view1->wid))
         lcv--;
        }
    }
 PRT12(printf("UncoRegisterWithAll...end...lcv = %d num_cos = %d\n",lcv,view->num_cos))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
WinUncoRegisterWithAll - ???
-----------------------------------------------------------------------*/

int
WinUncoRegisterWithAll(win,is_unlock_all,is_unco_all)
 struct image_display_window *win;
 int is_unlock_all,is_unco_all;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 return UncoRegisterWithAll(view,is_unlock_all,is_unco_all,1);
}


/*-----------------------------------------------------------------------
win_unco_register_all_group_wids - ???
-----------------------------------------------------------------------*/

int
win_unco_register_all_group_wids(win,is_unlock_all,is_unco_all)
 struct image_display_window *win;
 int is_unlock_all,is_unco_all;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT1(printf("win_unco_register_all_group_wids is_unlock_all = %d is_unco_all = %d\n",
           is_unlock_all,is_unco_all))
 view = img->cur_slice->slice->view;
 return run_next_view_proc(view,UncoRegisterWithAll,
                is_unlock_all,is_unco_all,0,0,0,0);
}


/*-----------------------------------------------------------------------
win_unco_register_every_wid - ???
-----------------------------------------------------------------------*/

int
win_unco_register_every_wid(win,is_unlock_all,is_unco_all)
 struct image_display_window *win;
 int is_unlock_all,is_unco_all;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 /* FIXME!! The function UncoRegisterWithAll expects to have 4 arguments
    but run_any_file_views_proc() only provides it with 3: the view and
    the two other arguments given below.  The final argument "0" has
    been removed to placate the compiler, but this is not a true fix,
    just a temporary patch.  -PWH 19990603 */
 return run_any_file_views_proc(view,UncoRegisterWithAll,
				is_unlock_all,is_unco_all/*,0*/);
}


/*-----------------------------------------------------------------------
unco_register_file - ???
-----------------------------------------------------------------------*/

int
unco_register_file(file)
 struct input_file_rec *file;
{
 struct view_rec *view;
 long lcv;

 PRT30(printf("\nwin_unco_register_file...num_views = %d\n",
         file->slice_info.num_views))

 for (lcv = 0; lcv < file->slice_info.num_views; lcv++)
    {view = file->slice_info.views[lcv];
     if (view->num_cos == 0) continue;
     PRT30(printf("%d) wid = %s num_cos = %d\n",
                      lcv,view->wid,view->num_cos);)
     UncoRegisterWithAll(view,0,1,0);
    }
 PRT30(printf("win_unco_register_file...end\n\n"))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_and_coplane_adjust_mode_on - ???
-----------------------------------------------------------------------*/

int
view_and_coplane_adjust_mode_on(view,coplane_of_wid)
 struct view_rec *view;
 char *coplane_of_wid;
{
 long lcv;
 int yes;
/*
 struct view_rec *coplane_view;
 struct image_display_window *win;

 if (((coplane_view = find_view_rec(view,coplane_of_wid)) != NULL) &&
     (coplane_view->img->win != NULL))
     win = view->img->win->image_display;
*/
 if (str_cmp(view->wid,coplane_of_wid) == 0)
    view->status |= PLANE_CO_REG_ADJUST;
   else
    {for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
        {PRT9(printf("%d) view coplane_of_wid = %s coplane_of_wid = %s\n",
                  lcv,view->cos[lcv].coplane_of_wid,coplane_of_wid))
         if (!(view->cos[lcv].status & CO_REG_ADJUST))
            {if (str_cmp(view->cos[lcv].coplane_of_wid,coplane_of_wid) == 0)
                {view->cos[lcv].status |= CO_REG_ADJUST;
                 yes = 1;}
            }
           else yes = 1;
        }
     if (yes)
        {/*
         if ((win != NULL) && (coplane_view->img->file == view->img->file))
            win_co_register_to_wid(win,view->wid);
         */
         view->status |= PLANE_CO_REG_ADJUST;}
       else view->status &= ~PLANE_CO_REG_ADJUST;
    }
 PRT9(printf("view_and_coplane_adjust_mode_on view num_cos = %d wid = %s  coplane_of_wid = %s\n",
               view->num_cos,view->wid,coplane_of_wid))
 PRT9(if (view->status & PLANE_CO_REG_ADJUST)
         printf("it is on...\n");
        else printf("it is off...\n");)
 if ((view->img->win != NULL) && (view->img->win->image_display != NULL))
    {yes = 1;
     win_execute_proc_to_multiple_wins(view->img->win->image_display,
            win_draw_enabled_label,&yes,0,0,0,0);}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_and_coplane_adjust_mode_off - ???
-----------------------------------------------------------------------*/

int
view_and_coplane_adjust_mode_off(view,coplane_of_wid)
 struct view_rec *view;
 char *coplane_of_wid;
{
 long lcv;
 int yes;
/*
 struct view_rec *coplane_view;
 struct image_display_window *win;

 if (((coplane_view = find_view_rec(view,coplane_of_wid)) != NULL) &&
     (coplane_view->img->win != NULL))
     win = view->img->win->image_display;
*/
 if (str_cmp(view->wid,coplane_of_wid) == 0)
    view->status &= ~PLANE_CO_REG_ADJUST;
   else
    {for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
        {PRT9(printf("%d) view coplane_of_wid = %s coplane_of_wid = %s\n",
                  lcv,view->cos[lcv].coplane_of_wid,coplane_of_wid))
         if (view->cos[lcv].status & CO_REG_ADJUST)
            {if (str_cmp(view->cos[lcv].coplane_of_wid,coplane_of_wid) == 0)
                view->cos[lcv].status &= ~CO_REG_ADJUST;
               else yes = 1;
            }
        }
     if (yes) view->status |= PLANE_CO_REG_ADJUST;
       else
        {view->status &= ~PLANE_CO_REG_ADJUST;}
    }
 PRT9(printf("view_and_coplane_adjust_mode_off view num_cos = %d wid = %s  coplane_of_wid = %s\n",
               view->num_cos,view->wid,coplane_of_wid))
 PRT9(if (view->status & PLANE_CO_REG_ADJUST)
         printf("it is on...\n");
        else printf("it is off...\n");)
 if ((view->img->win != NULL) && (view->img->win->image_display != NULL))
    {yes = 1;
     win_execute_proc_to_multiple_wins(view->img->win->image_display,
            win_draw_enabled_label,&yes,0,0,0,0);}
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_wid_and_coplane_adjust_mode_on - ???
-----------------------------------------------------------------------*/

int
win_wid_and_coplane_adjust_mode_on(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 long lcv;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 for (lcv = 0; lcv < view->num_cos; lcv++)
    run_next_view_proc(view,view_and_coplane_adjust_mode_on,
              view->cos[lcv].coplane_of_wid,0,0,0,0,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_wid_and_coplane_adjust_mode_off - ???
-----------------------------------------------------------------------*/

int
win_wid_and_coplane_adjust_mode_off(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 long lcv;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 for (lcv = 0; lcv < view->num_cos; lcv++)
    run_next_view_proc(view,view_and_coplane_adjust_mode_off,
              view->cos[lcv].coplane_of_wid,0,0,0,0,0);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_wid_adjust_mode_on - ???
-----------------------------------------------------------------------*/

int
win_wid_adjust_mode_on(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 view->status |= PLANE_CO_REG_ADJUST;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_wid_adjust_mode_off - ???
-----------------------------------------------------------------------*/

int
win_wid_adjust_mode_off(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 view->status &= ~PLANE_CO_REG_ADJUST;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
pr_xyztoplane - ???
-----------------------------------------------------------------------*/

int
pr_xyztoplane(view)
 struct view_rec *view;
{
 PRT17(printf("view->wid = %s ===xyztoplane \n",view->wid);)
 PRT17(pr_3d_matrix(&(view->gplane.xyztoplane)))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_adjust_reco_register - ???
-----------------------------------------------------------------------*/

int
view_adjust_reco_register(view,reg_view,co_view,co)
 struct view_rec *view,*reg_view,*co_view;
 struct co_register_rec *co;
{
 long lcv,indx;
 int err;
 struct view_rec *view1;
 struct co_register_rec *co1;

 PRT14(printf("view_adjust_reco_register view wid = %s reg_view wid = %s co_view = %s\n",
            view->wid,reg_view->wid,co_view->wid))
 PRT14(printf("view_adjust_reco_register cocoplane_of_wid = %s  num_cos = %d\n",
            co->coplane_of_wid,view->num_cos))

 for (lcv = 0; lcv < view->num_cos; lcv++)
    {PRT14(printf("%d) wid = %s coplane_of_wid = %s\n",lcv,
         view->cos[lcv].wid,view->cos[lcv].coplane_of_wid))
     if (str_cmp(view->cos[lcv].coplane_of_wid,co->coplane_of_wid) == 0)
        {view->more_status |= VIEW_MORE_STATUS_ADJUSTED;
         PRT14(printf("adjusted...wid = %s\n",view->wid))
         AssignCoRegPlaneParams(&(view->cos[lcv]),
                 &(reg_view->gplane),&(co_view->gplane),view->cos[lcv].status);
         if ((view1 = find_any_view_rec(view->img->file,
                    view->cos[lcv].wid)) != NULL)
            {
             view1->more_status |= VIEW_MORE_STATUS_ADJUSTED;
             if ((co1 = find_co_register_rec(view1,view->wid,&indx,&err,0)) != NULL)
                {PRT19(printf("co adjusted...cowid = %s\n",view1->wid))
                 co1->reg = view->cos[lcv].coreg;
                 co1->coreg = view->cos[lcv].reg;
                }
            }
        }
    }
 PRT14(printf("view_adjust_reco_register end\n\n\n"))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_auto_adjust_reco_register - ???
-----------------------------------------------------------------------*/

int
view_auto_adjust_reco_register(view)
 struct view_rec *view;
{
 struct view_rec *co_view;
 unsigned long lcv;
 struct co_register_rec *co;

 PRT17(printf("view_auto_adjust_reco_register....begin\n"))
 for (lcv = 0; lcv < view->num_cos; lcv++)
    {co = &(view->cos[lcv]);
     if (((co_view = find_any_view_rec(view->img->file,
                    view->cos[lcv].wid)) != NULL) &&
         (view->img->file != co_view->img->file))
        run_next_view_proc(view,view_adjust_reco_register,view,
                    co_view,co,0,0,0);
    }
 return NO_ERROR;
}


/****************
view_auto_adjust_reco_register(view,is_cur_group)
 struct view_rec *view;
 int is_cur_group;
{
 struct view_rec *co_view;
 struct list_rec *cur,*next;
 struct view_rec *view1;
 struct strs_rec strs;
 int err;
 unsigned long lcv,indx;
 struct co_register_rec *co;

 cur = &(view->_3d_list);
 next = cur;
 init_strs_rec(&strs);
 do 
    {view1 = next->item;
     for (lcv = 0; lcv < view1->num_cos; lcv++)
        {co = &(view1->cos[lcv]);
         if (FindStrInSortedStrsRec(&strs,co->coplane_of_wid,NULL) == NO_ERROR)
            continue;
         if ((co_view = find_any_view_rec(view1->img->file,
                    view1->cos[lcv].wid)) != NULL)
            {run_next_view_proc(view1,view_adjust_reco_register,view1,
                    co_view,co,0,0,0);
             AddStrToSortedStrsRec(&strs,co->coplane_of_wid,0,1);
             view1->more_status |= VIEW_MORE_STATUS_CHANGED;
            }
        }
     if (is_cur_group) next = next->next;
       else break;
    }
 while (next != cur);
 free_strs_rec(&strs);
 return NO_ERROR;
}
******************/


/*-----------------------------------------------------------------------
view_lock_coplane_of_wid - ???
-----------------------------------------------------------------------*/

int
view_lock_coplane_of_wid(view,main_view)
 struct view_rec *view,*main_view;
{
 long lcv,indx;
 int yes,err;
 struct co_register_rec *co;
 struct image_display_window *win;

 PRT10(printf("view_lock_coplane_of_wid wid = %s main_view = %s\n",view->wid,main_view->wid))
 for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
    view->cos[lcv].status &= ~CO_ALREADY_PROCESSED;
 for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
    {if (view->cos[lcv].status & CO_ALREADY_PROCESSED) continue;
     view->cos[lcv].status |= CO_ALREADY_PROCESSED;
     if (!(view->cos[lcv].status & LOCKED))
        {if (str_cmp(view->cos[lcv].coplane_of_wid,main_view->wid) == 0)
            {if ((view->img->win != NULL) &&
                ((win = view->img->win->image_display) != NULL))
                {win_co_register_to_wid(win,main_view->wid);
                 if ((co = find_co_register_rec(view,main_view->wid,&indx,
                                    &err,0)) != NULL)
                    {yes = 1;
                     PRT10(printf("%d) co->wid = %s co = %s\n",lcv,co->wid,
                                 co->coplane_of_wid))
                     co->status |= CO_ALREADY_PROCESSED;
                     lcv = 0;}
                }
            }
        }
       else yes = 1;
    }
 if (yes) view->status |= PLANE_LOCKED;
   else view->status &= ~PLANE_LOCKED;
 if ((view->img->win != NULL) && (view->img->win->image_display != NULL))
    {yes = 1;
     win_execute_proc_to_multiple_wins(view->img->win->image_display,
            win_draw_enabled_label,&yes,0,0,0,0);}
 PRT10(printf("view_lock_coplane_of_wid end view->num_cos = %d\n\n",view->num_cos))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
view_unlock_coplane_of_wid - ???
-----------------------------------------------------------------------*/

int
view_unlock_coplane_of_wid(view,main_view)
 struct view_rec *view,*main_view;
{
 long lcv;
 int yes;
 struct image_display_window *win;

 PRT10(printf("view_unlock_coplane_of_wid wid = %s main_view = %s\n",view->wid,main_view->wid))
 for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
    view->cos[lcv].status &= ~CO_ALREADY_PROCESSED;
 for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
    {if (view->cos[lcv].status & CO_ALREADY_PROCESSED) continue;
     view->cos[lcv].status |= CO_ALREADY_PROCESSED;
     if (view->cos[lcv].status & LOCKED)
        {if (str_cmp(view->cos[lcv].coplane_of_wid,main_view->wid) == 0)
            {if ((view->img->win != NULL) &&
                 ((win = view->img->win->image_display) != NULL))
                {WinUncoRegisterFromWid(win,main_view->wid,0);
                 /*view->cos[lcv].status &= ~LOCKED;*/
                 PRT10(printf("%d) view->num_cos = %d\n",lcv,view->num_cos))
                 lcv = 0;
                }
            }
           else yes = 1;
         }
    }
 if (yes) view->status |= PLANE_LOCKED;
   else view->status &= ~PLANE_LOCKED;
 if ((view->img->win != NULL) && (view->img->win->image_display != NULL))
    {yes = 1;
     win_execute_proc_to_multiple_wins(view->img->win->image_display,
            win_draw_enabled_label,&yes,0,0,0,0);}
 PRT10(printf("view_unlock_coplane_of_wid end view->num_cos = %d\n\n",view->num_cos))
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_lock_coplanes_of_wid - ???
-----------------------------------------------------------------------*/

int
win_lock_coplanes_of_wid(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view,*main_view;
 struct strs_rec coplane_of_wids;
 long lcv;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 init_strs_rec(&coplane_of_wids);
 PRT10(printf("win_lock_coplanes_of_wid wid = %s num_cos = %d\n",view->wid,view->num_cos))
 for (lcv = 0; lcv < view->num_cos; lcv++)
    if ((view->cos[lcv].coplane_of_wid != NULL) &&
        (view->cos[lcv].coplane_of_wid[0] != '\0'))
       {PRT10(printf("%d) coplane_of_wid = %s\n",lcv,view->cos[lcv].coplane_of_wid))
        if (AddStrPtrToSortedStrsRec(&coplane_of_wids,
                 view->cos[lcv].coplane_of_wid,0,0) == NO_ERROR)
           {PRT10(printf("...not found yet\n"))
            if ((main_view = find_view_rec(view,view->cos[lcv].coplane_of_wid))
                       != NULL)
               {
                if ((err = run_next_view_proc(view,view_lock_coplane_of_wid,
                           main_view,0,0,0,0,0)) != NO_ERROR)
                   break;
               }
           }
       }
 
 PRT10(printf("win_lock_coplanes_of_wid  err = %d\n",err))
 free_strs_rec_ptrs(&coplane_of_wids);
 return err;
}


/*-----------------------------------------------------------------------
win_unlock_coplanes_of_wid - ???
-----------------------------------------------------------------------*/

int
win_unlock_coplanes_of_wid(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view,*main_view;
 struct strs_rec coplane_of_wids;
 long lcv;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 init_strs_rec(&coplane_of_wids);
 PRT10(printf("win_unlock_coplanes_of_wid wid = %s num_cos = %d\n",view->wid,view->num_cos))
 for (lcv = 0; lcv < view->num_cos; lcv++)
    if ((view->cos[lcv].coplane_of_wid != NULL) &&
        (view->cos[lcv].coplane_of_wid[0] != '\0'))
       {PRT10(printf("%d) coplane_of_wid = %s\n",lcv,view->cos[lcv].coplane_of_wid))
        if (AddStrPtrToSortedStrsRec(&coplane_of_wids,
                 view->cos[lcv].coplane_of_wid,0,0) == NO_ERROR)
           {PRT10(printf("...not found yet\n"))
            if ((main_view = find_view_rec(view,view->cos[lcv].coplane_of_wid))
                       != NULL)
               {
                if ((err = run_next_view_proc(view,view_unlock_coplane_of_wid,
                           main_view,0,0,0,0,0)) != NO_ERROR)
                   break;
               }
           }
       }
 
 free_strs_rec_ptrs(&coplane_of_wids);
 PRT10(printf("win_unlock_coplanes_of_wid  err = %d\n",err))
 return err;
}


/*-----------------------------------------------------------------------
view_co_reg_xyz - ???
-----------------------------------------------------------------------*/

int
view_co_reg_xyz(view,x,y,z,cx,cy,cz)
 struct view_rec *view;
 float x,y,z,*cx,*cy,*cz;
{
 struct co_register_rec *co;
 long indx;
 int err;

 PRT8(printf("view_co_reg_xyz view = %u cwid = %s = %d\n",view,
        view->dp_xyz_co_reg_wid,sizeof(*view)))
 if (!(view->more_status & DP_XYZ) && 
     (view->status & PLANE_CROSS_REGISTERED))
    {if (view->dp_xyz_co_reg_wid != NULL)
        {if ((co = find_co_register_rec(view,view->dp_xyz_co_reg_wid,&indx,&err,0))
                       != NULL)
            {PRT8(printf("1 %s...co = %u\n",view->dp_xyz_co_reg_wid,co))
             trans_3d_xyz(&(co->reg.xyztoplane),x,y,z,cx,cy,cz,0);
             PRT8(printf("view_co_reg_xyz NO_ERROR\n"))
             return NO_ERROR;
            }
           else 
            {c_free(view->dp_xyz_co_reg_wid);
             view->dp_xyz_co_reg_wid = NULL;}
        }
     if ((co = first_co_registered_wid(view)) != NULL)
        if ((err = cp_str(&(view->dp_xyz_co_reg_wid),co->wid)) == NO_ERROR)
           {PRT8(printf("2 %s...co = %u\n",view->dp_xyz_co_reg_wid,co))
            trans_3d_xyz(&(co->reg.xyztoplane),x,y,z,cx,cy,cz,0);
            PRT8(printf("3 %s...co = %u\n",view->dp_xyz_co_reg_wid,co))
            PRT8(printf("view_co_reg_xyz NO_ERROR\n"))
            return NO_ERROR;
           }
    }
 PRT8(printf("view_co_reg_xyz CANCEL\n"))
 return CANCEL;
}


/*-----------------------------------------------------------------------
win_xyz_by_co_reg_wid - ???
-----------------------------------------------------------------------*/

void
win_xyz_by_co_reg_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 view = img->cur_slice->slice->view;
 str_dealloc_and_cpy(&(view->dp_xyz_co_reg_wid),wid);
 win_cursor_row_col(win);
}


/*-----------------------------------------------------------------------
win_move_mouse_to_co_reg_wid - ???
-----------------------------------------------------------------------*/

int
win_move_mouse_to_co_reg_wid(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct image_display_window *win1;
 struct view_rec *view,*view1;
 struct co_register_rec *co;
 Rect *rr;
 struct vector_3d_rec pt;
 int err,is_valid;
 long indx,x,y,x1,y1;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT16(printf("win_move_mouse_to_co_reg_wid..dp_xyz_co_reg_wid = %u %s\n",
       view->dp_xyz_co_reg_wid,view->dp_xyz_co_reg_wid))
 if ((view != NULL) &&
     (view->status & PLANE_CROSS_REGISTERED))
    {is_valid = 0;
     co = NULL;
     if (view->dp_xyz_co_reg_wid != NULL)
        {if ((co = find_co_register_rec(view,view->dp_xyz_co_reg_wid,&indx,&err,0))
                       == NULL)
            {c_free(view->dp_xyz_co_reg_wid);
             view->dp_xyz_co_reg_wid = NULL;}
           else if (view->more_status & VIEW_MORE_STATUS_CO_REG_XYZ_VALID)
            is_valid = 1;
        }
     if (((co != NULL) ||
          ((co = first_co_registered_wid(view)) != NULL)) &&
         ((view1 = find_any_view_rec(view->file,co->wid)) != NULL) &&
         (view1->img->win != NULL) &&
         ((win1 = view1->img->win->image_display) != NULL) &&
         (is_valid ||
          ((err = cp_str(&(view->dp_xyz_co_reg_wid),co->wid)) == NO_ERROR)))
        {PRT16(printf("is_valid = %d %s... = %u\n",is_valid,
                view->dp_xyz_co_reg_wid,view->dp_xyz_co_reg_wid))
         rr = (Rect *) xv_get(canvas_paint_window(win->dwin->frame_canvas.canvas),
                WIN_MOUSE_XY);
         x1 = rr->r_left;
         y1 = rr->r_top;
         dwin_screenxy_to_bufxy(win->dwin,&x1,&y1);
         PRT16(printf("...r_left = %d top = %d x1 = %d y1 = %d\n",
               rr->r_left,rr->r_top,x1,y1);)
         if (is_valid) 
            {
             x = (long) (view->co_reg_xyz.x + .5);
             y = (long) (view->co_reg_xyz.y + .5);

             PRT16(printf("x = %d y = %d\n",x,y);)
             PRT16(printf("co_reg_xyz...pt\n");pr_vector_3d_rec(&(view->co_reg_xyz)))
             if ((x != x1) || (y != y1))
                is_valid = 0;
            }
         PRT16(printf("is_valid = %d...x1 = %d y1 = %d\n",
               is_valid,x1,y1);)
         if (!is_valid) 
            {setup_vector_3d_rec(&(view->co_reg_xyz),(float) x1,
                    (float) y1,(float) .0);
             PRT16(printf("reinit co_reg_xyz...pt\n");
                  pr_vector_3d_rec(&(view->co_reg_xyz)))
             view->more_status |= VIEW_MORE_STATUS_CO_REG_XYZ_VALID;}
           else
            {PRT9(printf("unsing old pt...\n"))}
         pt = view->co_reg_xyz;
         PRT16(printf("co_reg_xyz...pt\n");pr_vector_3d_rec(&pt))
         if (win->control.sroi.tolocal != NULL)
            {trans_2d_pt(win->control.sroi.tolocal,pt.x,pt.y,&(pt.x),&(pt.y),0);
             PRT16(printf("tolocal...pt\n");pr_vector_3d_rec(&pt))}

         PlaneXYZToLocalXYZ(&(view->gplane),pt.x,pt.y,pt.z,
             &(pt.x),&(pt.y),&(pt.z),0);
         PRT16(printf("PlaneXYZToLocalXYZ...pt\n");pr_vector_3d_rec(&pt))
         trans_3d_xyz(&(co->reg.xyztoplane),pt.x,pt.y,pt.z,
                &(pt.x),&(pt.y),&(pt.z),0);
         PRT16(printf("xyztoplane...pt\n");pr_vector_3d_rec(&pt))
         trans_3d_xyz(&(co->coreg.planetoxyz),pt.x,pt.y,pt.z,
                &(pt.x),&(pt.y),&(pt.z),0);
         PRT16(printf("coreg.planetoxyz...pt\n");pr_vector_3d_rec(&pt))
	 /* Removed a final argument '0' from the call below, since
	    the called function doesn't expect it.  -PWH 19990312 */
         LocalXYZToPlaneXYZ(&(view1->gplane),pt.x,pt.y,pt.z,
                &(pt.x),&(pt.y),&(pt.z));

         if ((view1->img->win != NULL) &&
             ((win1 = view1->img->win->image_display) != NULL))
         PRT16(printf("LocalXYZToPlaneXYZ...pt\n");pr_vector_3d_rec(&pt))
         if (view->more_status & DP_XYZ)
            {view->more_status &= ~DP_XYZ;
             win_cursor_row_col(win);
            }
         if (win1->control.sroi.localto != NULL)
            {trans_2d_pt(win1->control.sroi.localto,pt.x,pt.y,&(pt.x),&(pt.y),0);
             PRT16(printf("LocalXYZToPlaneXYZ...pt\n");pr_vector_3d_rec(&pt))
            }
         if ((view1->dp_xyz_co_reg_wid == NULL) ||
             (str_cmp(view1->dp_xyz_co_reg_wid,view->wid) != 0))
            {
             str_dealloc_and_cpy(&(view1->dp_xyz_co_reg_wid),view->wid);
             PRT16(printf("new view1 dp_xyz_co_reg_wid = %s... = %u\n",
                view1->dp_xyz_co_reg_wid,view1->dp_xyz_co_reg_wid))}

         view1->co_reg_xyz = pt;
         view1->more_status &= ~DP_XYZ; 
         view1->more_status |= VIEW_MORE_STATUS_CO_REG_XYZ_VALID;
         x = (long) (pt.x + .5);
         y = (long) (pt.y + .5);

         win_move_mouse_to(win1,x,y);
         PRT16(printf("\n\n");)
         return NO_ERROR;
        }
    }
 win_alarm(win->dwin->frame,2);
 PRT9(printf("win_move_mouse_to_co_reg_wid..end\n"))
 return CANCEL;
}


/*-----------------------------------------------------------------------
win_co_register_onoff - ???
-----------------------------------------------------------------------*/

int
win_co_register_onoff(win,onoff)
 struct image_display_window *win;
 int onoff;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT5(printf("win_co_register_onoff...onoff = %d num_cos = %d\n",
        onoff,view->num_cos))
 if (onoff)
    {if (view->num_cos > 0) view->status |= PLANE_CO_REGISTERED;
    }
   else view->status &= ~PLANE_CO_REGISTERED;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
is_view_adjust_mode_on - ???
-----------------------------------------------------------------------*/

int
is_view_adjust_mode_on(view)
 struct view_rec *view;
{
 unsigned long lcv;

 for (lcv = 0; lcv < view->num_cos; lcv++)
    {if (view->cos[lcv].status & CO_REG_ADJUST) return 1;
    }
 return 0;
}


/*-----------------------------------------------------------------------
is_3d_win_locked - ???
-----------------------------------------------------------------------*/

int
is_3d_win_locked(win)
 struct image_display_window *win;
{
 struct roi_rec *cur_roi;
 struct img_buf_rec *img;
 struct view_rec *view,*view1;
 int err,mode;
 long indx;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 view = img->cur_slice->slice->view;

 if (!(view->status & PLANE_REGISTERED_STATUS)) return 0;
 if (view->num_cos == 0) return 0;
 mode = 0;
 if ((cur_roi = get_cur_roi(
          &(win->control.sroi.sroi_win->slice_roi))) != NULL)
    {
     if ((view1 = find_view_rec(view,cur_roi->label)) != NULL) 
        {if (find_co_register_rec(view1,view->wid,&indx,&err,0) != NULL)
            mode |= 1;
        }
    }
 if (view->status & PLANE_CROSS_REGISTERED) mode |= 2;

/*
 if (view->num_cos > 0)
    {
     if (!(view->status & PLANE_CO_REGISTERED)) mode |= 4;
    }
*/
 if (view->status & PLANE_LOCKED) mode |= 8;
 if (view->status & PLANE_CO_REG_ADJUST) mode |= 16;
 PRT3(printf("is_3d_win_locked...vid = %s v1id = %s mode = %d\n",
           view->wid,view1->wid,mode);)
 return mode;
}


/*-----------------------------------------------------------------------
win_co_registered_wids - ???
-----------------------------------------------------------------------*/

int
win_co_registered_wids(win,wids,is_cp_str,is_sorted,locked_or_reg)
 struct image_display_window *win;
 struct strs_rec *wids;
 int is_cp_str,is_sorted,locked_or_reg;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 return co_registered_wids(view,wids,is_cp_str,is_sorted,locked_or_reg);
}


/*-----------------------------------------------------------------------
win_co_reg_path_wids - ???
-----------------------------------------------------------------------*/

int
win_co_reg_path_wids(win,wids)
 struct image_display_window *win;
 struct strs_rec *wids;
{
 struct img_buf_rec *img;
 struct view_rec *view,**views,*next;
 struct strs_rec ids;
 int err,yes,same_group;
 struct input_file_rec **files;
 struct slice_info_rec *slice_info;
 long indx,lcv,cnt,num;
 char *str,*reg_wid,*co_reg_wid;

 PRT4(printf("win_co_reg_path_wids...1\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 files = img->file->prog->input.files;
 view = img->cur_slice->slice->view;
 PRT(printf("win_co_reg_path_wids...2\n"))
 err = NO_ERROR;
 for (indx = 0; indx < img->file->prog->input.num_files; indx++)
    {slice_info = &(files[indx]->slice_info);
     views = slice_info->views;

     for (lcv = 0; lcv < slice_info->num_views; lcv++)
        {PRT(printf("wid = %s num_cos = %d\n",views[lcv]->wid,views[lcv]->num_cos);)
         if ((views[lcv]->group_num == view->group_num) &&
             (views[lcv]->file == view->file))
            same_group = 1;
           else same_group = 0;
         if (!(views[lcv]->status & PLANE_CROSS_REGISTERED_MAJOR))
            {PRT(printf("wid = %s not PLANE_CROSS_REGISTERED_MAJOR\n",view->wid))
             continue;}
         PRT(printf("views[%d]->status = %x\n",lcv,(unsigned long) views[lcv]->status);)
         for (cnt = 0; cnt < views[lcv]->num_cos; cnt++)
            if ((next = find_any_view_rec(view->file,
                               views[lcv]->cos[cnt].wid)) != NULL)
               {
                PRT(printf("sg = %d view wid = %s co wid = %s cos[%d].status = %x\n",
                      same_group,view->wid,next->wid,
                      cnt,(unsigned long) views[lcv]->cos[cnt].status))
                if (views[lcv]->cos[cnt].status & CO_PLANE) 
                   {PRT(printf("CO_PLANE...\n"))
                    continue;}
                yes = 0;
                if (same_group)
                   {
                    if ((next->group_num != view->group_num) ||
                        (next->file != view->file))
                       {reg_wid = views[lcv]->wid;
                        co_reg_wid = views[lcv]->cos[cnt].wid;
                        yes = 1;}
                    }
                  else if ((next->group_num == view->group_num) &&
                           (next->file == view->file))
                   {co_reg_wid = views[lcv]->wid;
                    reg_wid = views[lcv]->cos[cnt].wid;
                    next = views[lcv];
                    yes = 1;}
                PRT(printf("gn1 = %d gn2 = %d f1 = %u f2 = %u yes = %d\n",
                      next->group_num,view->group_num,
                      next->file,view->file,yes))
                if (yes)
                   {init_strs_rec(&ids);
                    if ((err = GroupViewWids(next,&ids,0,0)) == NO_ERROR)
                       for (num = 0; num < ids.num_strs; num++)
                          if ((err = concat_strs(&str,5,reg_wid,
                              "@",co_reg_wid,"@",ids.strs[num])) == NO_ERROR)
                             {if ((err = AddStrPtrToSortedStrsRec(wids,
                                         str,0,0)) != NO_ERROR)
                                 {PRT(printf("AddStrPtrToSortedStrsRec err = %d\n",err))
                                  c_free(str);
                                  if (err == FOUND)
                                     {PRT4(printf("str = %s found\n",str))
                                      err = NO_ERROR;}
                                    else break;
                                 }
                                else
                                 {PRT4(printf("str = %s\n",str))
                                 } 
                             } 
                            else break;
                    free_strs_rec_ptrs(&ids);
                    if (err != NO_ERROR) 
                       {PRT4(printf("win_registered_wid...err = %d\n",err))
                        return err;}
                   }
              }
        }
    }
 PRT(printf("win_co_reg_path_wids...err = %d num_strs = %d\n",err,wids->num_strs))
 return NO_ERROR;
}


/**********************
reg_params(view,coview,base,cobase,dist_from_co,codist_from_co)
 struct view_rec *view,*coview;
 struct vector_3d_rec *base,*cobase;
 float *dist_from_co,*codist_from_co;
{
 struct co_register_rec *co;
 long indx;
 int err;

 if ((co = find_co_register_rec(view,coview->wid,&indx,&err,0)) != NULL)
    {*base = co->base;
     *cobase = co->coreg.base;
     *dist_from_co = co->dist_from_co;
     *codist_from_co = co->codist_from_co;
    }
   else if ((co = find_co_register_rec(coview,view->wid,&indx,&err,0)) != NULL)
    {*base = co->coreg.base;
     *cobase = co->base;
     *dist_from_co = co->codist_from_co;
     *codist_from_co = co->dist_from_co;
    }
 return CANCEL;
}
*********************/


/*-----------------------------------------------------------------------
win_co_plane - ???
-----------------------------------------------------------------------*/

int
win_co_plane(win,reg_wid,coreg_wid,coreg_coplane_wid)
 struct image_display_window *win;
 char *reg_wid,*coreg_wid,*coreg_coplane_wid;
{
 struct img_buf_rec *img;
 struct view_rec *view,*reg_view,*coreg_view,*coreg_coplane_view;
 struct co_register_rec *co,*co1,*co2;
 struct vector_3d_rec base,normal;
 struct matrix_3d_rec mat;
 int err;
 long indx,indx1;

 PRT18(printf("win_same_co...reg_wid = %s coreg_wid = %s coreg_coplane_wid = %s\n",
     reg_wid,coreg_wid,coreg_coplane_wid))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 view = img->cur_slice->slice->view;
 PRT18(printf("view->num_cos = %d\n",view->num_cos))
 co1 = co2 = NULL;
 if (((reg_view = find_view_rec(view,reg_wid)) == NULL) ||
     ((coreg_view = find_any_view_rec(view->file,coreg_wid)) == NULL) ||
     ((coreg_coplane_view = find_view_rec(coreg_view,coreg_coplane_wid)) == NULL) ||
     ((co = find_co_register_rec(reg_view,coreg_wid,&indx,&err,0)) == NULL) ||
      (view->img->win == NULL) ||
      (view->img->win->image_display == NULL) ||
     ((err = win_co_register(view->img->win->image_display,coreg_coplane_wid)) != NO_ERROR) ||
     ((co1 = find_co_register_rec(view,coreg_coplane_wid,&indx,&err,0)) == NULL) ||
     ((co2 = find_co_register_rec(coreg_coplane_view,view->wid,&indx1,&err,0)) == NULL))
    {PRT18(printf("...CANCEL\n"))
     return CANCEL;}
 PRT18(printf("view->num_cos = %d indx = %d coreg_coplane_view->num_cos = %d indx1 = %d\n",
       view->num_cos,indx,coreg_coplane_view->num_cos,indx1))
 PRT18(printf("co1->coplane_of_wid = %s co2->coplane_of_wid = %s\n",
         co1->coplane_of_wid,co2->coplane_of_wid))
 free_ptr(&(co1->coplane_of_wid));
 free_ptr(&(co2->coplane_of_wid));
 cp_str(&(co1->coplane_of_wid),reg_view->wid);
 cp_str(&(co2->coplane_of_wid),coreg_view->wid);
 co1->reg = co->reg;
 co1->coreg = co->coreg;
 co1->status |= CO_PLANE;
 co2->reg = co->coreg;
 co2->coreg = co->reg;
 co2->status |= CO_PLANE;

 view->status |= PLANE_CO_REGISTERED | PLANE_CROSS_REGISTERED;
 coreg_coplane_view->status |= PLANE_CO_REGISTERED | PLANE_CROSS_REGISTERED;

 CoRegBaseAndNormal(&(co->coreg.xyztoplane),&(co->reg.planetoxyz),
            &(coreg_coplane_view->gplane.base),&(coreg_coplane_view->gplane.normal_cosine),
            &base,&normal);
 mult_3d_matrix(&mat,&(co->coreg.planetoxyz),&(co->reg.xyztoplane));
 mult_3d_matrix(&mat,&(coreg_coplane_view->gplane.xyztoplane),&mat);

 PRT10(printf("coreg_coplane_view base...");pr_vector_3d_rec(&(coreg_coplane_view->gplane.base));
      printf("    normal...");pr_vector_3d_rec(&(coreg_coplane_view->gplane.normal_cosine));
      printf("coreg_view base...");pr_vector_3d_rec(&(coreg_view->gplane.base));
      printf("    normal...");pr_vector_3d_rec(&(coreg_view->gplane.normal_cosine));)

 PRT7(printf("reg_view base...");pr_vector_3d_rec(&(reg_view->gplane.base));
      printf("    normal...");pr_vector_3d_rec(&(reg_view->gplane.normal_cosine));
      printf("new base...");pr_vector_3d_rec(base);
      printf("new norm ...");pr_vector_3d_rec(normal);
      printf("dist(regview,base) = %f deg = %f\n",
          vector_distance(&(reg_view->gplane.base),&base),
             degree_angle_vectors(&(reg_view->gplane.normal_cosine),&normal));

      printf("dist(coview,coreg_view) dist = %f deg = %f\n",
             vector_distance(&(coreg_coplane_view->gplane.base),&(coreg_view->gplane.base)),
             degree_angle_vectors(&(coreg_coplane_view->gplane.normal_cosine),
              &(coreg_view->gplane.normal_cosine)));
     printf("\n"))

 view->gplane.status &= ~PLANE_ADJUST_TO_CENTER;
 FormPlaneNoDisplay(view,&base,&normal,NULL,&(coreg_coplane_view->gplane.rotate),0,2,&mat);

 PRT7(printf("after base...");pr_vector_3d_rec(&(view->gplane.base));
          printf(" norm ...");pr_vector_3d_rec(&(view->gplane.normal_cosine));
          printf("\n"))
 PRT9(printf("mat...\n");
      pr_3d_matrix(&mat);
      printf("\nxyztoplane...\n");
      pr_3d_matrix(&(view->gplane.xyztoplane));
      printf("...\n");)
 co1->status |= CO_DONT_PROCESSED;
 err = OutputPlaneData(view,1,1); 
 co1->status &= ~CO_DONT_PROCESSED;
 PRT9(printf("win_same_co...err = %d\n",err))

 return err;
}


/*-----------------------------------------------------------------------
clear_all_planes_co_process_status - ???
-----------------------------------------------------------------------*/

void
clear_all_planes_co_process_status(view,is_fusion_sync,is_clear)
 struct view_rec *view;
 int is_fusion_sync,is_clear;
{
 struct slice_info_rec *slice_info;
 struct input_file_rec **files;
 long lcv;
 long indx;

 files = view->file->prog->input.files;
 for (indx = 0; indx < view->file->prog->input.num_files; indx++)
    {slice_info = &(files[indx]->slice_info);
     for (lcv = 0; lcv < slice_info->num_views; lcv++)
        {slice_info->views[lcv]->status &= ~PLANE_CO_REGISTERED_PROCESSED;
         if (is_clear)
            slice_info->views[lcv]->more_status &= ~VIEW_MORE_STATUS_PROCESSED_STATUS;
         if (is_fusion_sync)
            slice_info->views[lcv]->img->_2d_fusion.status |= FUSION_SYNC;
           else
            slice_info->views[lcv]->img->_2d_fusion.status &= ~FUSION_SYNC;
        }
    }
}


/*-----------------------------------------------------------------------
CoRegBaseAndNormal - ???
-----------------------------------------------------------------------*/

int
CoRegBaseAndNormal(xyztoplane,coplanetoxyz,
                   base,normal,new_cobase,new_conormal)
 struct matrix_3d_rec *xyztoplane,*coplanetoxyz;
 struct vector_3d_rec *base,*normal,*new_cobase,*new_conormal;
{
 struct vector_3d_rec base1,nextpt;

 trans_3d_pt(xyztoplane,base,&base1,0);
 trans_3d_pt(coplanetoxyz,&base1,new_cobase,0);

 add_vectors(&nextpt,base,normal);
 trans_3d_pt(xyztoplane,&nextpt,&nextpt,0);
 trans_3d_pt(coplanetoxyz,&nextpt,&nextpt,0);
 sub_vectors(new_conormal,&nextpt,new_cobase);
 direction_cosine_vector(new_conormal);

/*
 trans_3d_pt(xyztoplane,normal,&nextpt,0);
 trans_3d_pt(coplanetoxyz,&nextpt,new_conormal,0);
*/
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
CoRegisteredMatrix - ???
-----------------------------------------------------------------------*/

void
CoRegisteredMatrix(base1,norm1,base2,norm2,xyztoplane,planetoxyz)
 struct vector_3d_rec *base1,*norm1,*base2,*norm2;
 struct matrix_3d_rec *planetoxyz,*xyztoplane;
{
 struct matrix_3d_rec planetoxyz1,xyztoplane1;

 identity_3d_matrix(&planetoxyz1);
 identity_3d_matrix(xyztoplane);
 Rotate3dMatrixFromAxis(xyztoplane,&planetoxyz1,base1,norm1,.0);
 identity_3d_matrix(planetoxyz);
 identity_3d_matrix(&xyztoplane1);
 Rotate3dMatrixFromAxis(&xyztoplane1,planetoxyz,base2,norm2,.0);
}


/*-----------------------------------------------------------------------
ComputeLockPlane - ???
-----------------------------------------------------------------------*/

int
ComputeLockPlane(view,co,base,normal)
 struct view_rec *view;
 struct co_register_rec *co;
 struct vector_3d_rec *base,*normal;
{
 struct matrix_3d_rec planetoxyz,xyztoplane;
 struct vector_3d_rec base1;

 PRT15(printf("ComputeLockPlane view->wid = %s\n",view->wid)) 
 if (same_direction_vectors(&(co->reg.normal),&(co->coreg.normal)))
    {CoRegisteredMatrix(&(co->reg.base),&(co->reg.normal),&(view->gplane.base),
               &(view->gplane.normal_cosine),&xyztoplane,&planetoxyz);
     CoRegBaseAndNormal(&xyztoplane,&planetoxyz,
              &(co->coreg.base),&(co->coreg.normal),base,normal);
     PRT15(printf("\nComputeLockPlane ****same_direction_vectors....\n");)
    }
   else
    {
/*
     CoRegisteredMatrix(&(co->reg.base),&(co->reg.normal),&(co->reg.base),
               &(view->gplane.normal_cosine),&xyztoplane,&planetoxyz);
     CoRegBaseAndNormal(&xyztoplane,&planetoxyz,
              &(co->coreg.base),&(co->coreg.normal),&base1,normal);  
*/
     CoRegisteredMatrix(&(co->reg.base),&(co->reg.normal),&(co->coreg.base),
               &(co->coreg.normal),&xyztoplane,&planetoxyz);
     CoRegBaseAndNormal(&xyztoplane,&planetoxyz,
            &(view->gplane.base),&(view->gplane.normal_cosine),
            &base1,normal);  

     sub_vectors(base,&(view->gplane.base),&(co->reg.base));
     add_vectors(base,base,&(co->coreg.base));}

 PRT15(printf("new base...");pr_vector_3d_rec(base);
          printf("new norm ...");pr_vector_3d_rec(normal);
          printf("view->gplane.base ...");pr_vector_3d_rec(&(view->gplane.base));
          printf("co->coreg.base ...");pr_vector_3d_rec(&(co->coreg.base));
          printf("vector_distance base & view-base = %f\n",
            vector_distance(&(view->gplane.base),base));

          printf("new dist = %f codist = %f deg = %f\n",
          DistOfPtFromPlane(base,normal,
                   &(view->gplane.base),&sign),
          DistOfPtFromPlane(&(view->gplane.base),&(view->gplane.normal_cosine),
                   base,&sign),
          degree_angle_vectors(&(view->gplane.normal_cosine),normal));

          printf("vector_distance reg.base & coreg.base = %f\n",
            vector_distance(&(co->reg.base),&(co->coreg.base)));
          printf("reg dist = %f codist = %f deg = %f\n",
             DistOfPtFromPlane(&(co->coreg.base),&(co->coreg.normal),
             &(co->reg.base),&sign),
             DistOfPtFromPlane(&(co->reg.base),&(co->reg.normal),
             &(co->coreg.base),&sign),
             degree_angle_vectors(&(co->reg.normal),&(co->coreg.normal)));
          printf("\n");
         )

 return NO_ERROR;
}


/***********************
ComputeLockPlane(view,co,base,normal)
 struct view_rec *view;
 struct co_register_rec *co;
 struct vector_3d_rec *base,*normal;
{
 struct matrix_3d_rec planetoxyz,xyztoplane;
 struct vector_3d_rec base1,base2,andpt1,andpt2,dire2,dire1,v1,base_and,base_and1;
 float len1,len2,len3,len4,line_move_unit_ratio,sindeg,temp;
 int is_and_status,sign;

 if (same_direction_vectors(&(co->reg.normal),&(co->coreg.normal)))
    {CoRegisteredMatrix(&(co->reg.base),&(co->reg.normal),&(view->gplane.base),
               &(view->gplane.normal_cosine),&xyztoplane,&planetoxyz);
     CoRegBaseAndNormal(&xyztoplane,&planetoxyz,
              &(co->coreg.base),&(co->coreg.normal),base,normal);
     PRT15(printf("\nComputeLockPlane ****same_direction_vectors....\n");)
     PRT15(printf("new base...");pr_vector_3d_rec(base);
          printf("new norm ...");pr_vector_3d_rec(normal);
          printf("new dist = %f codist = %f deg = %f\n",
          DistOfPtFromPlane(base,normal,
                   &(view->gplane.base),&sign),
          DistOfPtFromPlane(&(view->gplane.base),&(view->gplane.normal_cosine),
                   base,&sign),
          degree_angle_vectors(&(view->gplane.normal_cosine),normal));

          printf("reg dist = %f codist = %f deg = %f\n",
             DistOfPtFromPlane(&(co->coreg.base),&(co->coreg.normal),
             &(co->reg.base),&sign),
             DistOfPtFromPlane(&(co->reg.base),&(co->reg.normal),&(co->coreg.base),&sign),
             degree_angle_vectors(&(co->reg.normal),&(co->coreg.normal)));
          printf("\n");
         )
     return NO_ERROR;}
 CoRegisteredMatrix(&(co->reg.base),&(co->reg.normal),&(co->reg.base),
               &(view->gplane.normal_cosine),&xyztoplane,&planetoxyz);
 CoRegBaseAndNormal(&xyztoplane,&planetoxyz,
              &(co->coreg.base),&(co->coreg.normal),&base1,normal);  
 PlaneAndLineIntersection(&(co->reg.base),&(view->gplane.normal_cosine),
          &base1,&(view->gplane.normal_cosine),
           &v1,&line_move_unit_ratio,&is_and_status);

 sub_vectors(&dire1,&v1,&(co->reg.base));
 PlaneAndLineIntersection(&base1,normal,&(co->reg.base),&dire1,
           &andpt1,&line_move_unit_ratio,&is_and_status);

 PlaneAndLineIntersection(&base1,normal,&(co->reg.base),normal,
           &base_and,&line_move_unit_ratio,&is_and_status);

 len1 = vector_distance(&base_and,&(co->reg.base));
 len2 = vector_distance(&base_and,&base1);
 temp = len1 * len1 + len2 * len2;
 temp = (float) sqrt(temp);
 if (temp == .0) sindeg = .0;
   else sindeg = len2 / temp;
 PRT15(printf("\nComputeLockPlane len1 = %f len2 = %f  sindeg = %f\n",len1,len2,sindeg);
      printf("base_and...");pr_vector_3d_rec(&base_and);
      printf("co->reg.base...");pr_vector_3d_rec(&(co->reg.base));
      printf("base1...");pr_vector_3d_rec(&base1);
      printf("andpt1...");pr_vector_3d_rec(&andpt1);
     )

 identity_3d_matrix(&planetoxyz);
 identity_3d_matrix(&xyztoplane);
 Rotate3dMatrixFromAxis(&xyztoplane,&planetoxyz,
         &(view->gplane.base),&(view->gplane.normal_cosine),.0);
 trans_3d_pt(&xyztoplane,&andpt1,&v1,0);
 v1.z = .0;
 trans_3d_pt(&planetoxyz,&v1,&andpt2,0);

 PlaneAndLineIntersection(&andpt2,normal,&(view->gplane.base),normal,
           &base_and1,&line_move_unit_ratio,&is_and_status);
 len3 = vector_distance(&base_and1,&(view->gplane.base));
 len4 = len3 * sindeg;
 sub_vectors(&dire2,&andpt2,&base_and1);
 direction_cosine_vector(&dire2);
 mult_vector_with_const(&dire2,len4);
 add_vectors(base,&base_and1,&dire2);

 len1 = vector_distance(base,&(view->gplane.base));
 if (len1 == .0) temp = .0;
   else temp = len4 / len1;
 PRT15(printf("andpt2 dist = %f\n",
          DistOfPtFromPlane(&(view->gplane.base),&(view->gplane.normal_cosine),
              &andpt2,&sign));
      printf("andpt2...");pr_vector_3d_rec(&andpt2);
      printf("base_and1...");pr_vector_3d_rec(&base_and1);
      printf("len3 = %f len4 = %f  sindeg = %f sindeg1 = %f\n",len3,len4,sindeg,temp);
     )

 PRT15(
      sub_vectors(&base2,&base1,&andpt1);
      add_vector_3d(&base2,&andpt2);
      sub_vectors(&dire2,base,&andpt2);
      direction_cosine_vector(&dire1);
      direction_cosine_vector(&dire2);
      printf("base2...");pr_vector_3d_rec(&base2);
      printf("dire1...");pr_vector_3d_rec(&dire1);
      printf("dire2...");pr_vector_3d_rec(&dire2);
      printf("===deg(dire1,dire2 = %f\n",
             degree_angle_vectors(&dire1,&dire2));)

      printf("new base...");pr_vector_3d_rec(base);
          printf("new norm ...");pr_vector_3d_rec(normal);
          printf("old norm ...");pr_vector_3d_rec(&(view->gplane.normal_cosine));
      sub_vectors(&v1,&(co->reg.base),&andpt1);
      add_vector_3d(&v1,&andpt2);

      printf("new dist = %f codist = %f deg = %f\n",
          DistOfPtFromPlane(base,normal,&v1,&sign),
          DistOfPtFromPlane(&(view->gplane.base),&(view->gplane.normal_cosine),
                   &base2,&sign),
          degree_angle_vectors(&(view->gplane.normal_cosine),normal));
      printf("reg dist = %f codist = %f deg = %f\n",
             DistOfPtFromPlane(&base1,normal,&(co->reg.base),&sign),
             DistOfPtFromPlane(&(co->reg.base),&(view->gplane.normal_cosine),&base1,&sign),
             degree_angle_vectors(&(co->reg.normal),&(co->coreg.normal)));
      printf("\n");
     )
 return NO_ERROR;
}
****************/


/*-----------------------------------------------------------------------
CoRegisteredParams - ???
-----------------------------------------------------------------------*/

void
CoRegisteredParams(view,co,base,normal,is_same_group)
 struct view_rec *view;
 struct co_register_rec *co;
 struct vector_3d_rec *base,*normal;
 unsigned int is_same_group;
{

 PRT15(printf("1 wid = %s cowid = %s\n",view->wid,co->wid);
      printf("1 cur base...");pr_vector_3d_rec(&(view->gplane.base));
      printf("1 base ...");pr_vector_3d_rec(&(view->gplane.base));
      printf("1  norm...");pr_vector_3d_rec(&(view->gplane.normal_cosine));
      printf("2 co reg.base...");pr_vector_3d_rec(&(co->reg.base));
      printf("2  reg. norm...");pr_vector_3d_rec(&(co->reg.normal));
      printf("3 co coreg.base...");pr_vector_3d_rec(&(co->coreg.base));
      printf("3   norm...");pr_vector_3d_rec(&(co->coreg.normal));
     )

 if (is_same_group)
    {
     PRT5(printf("is locked...\n"))
     ComputeLockPlane(view,co,base,normal);
    }
   else
    {PRT15(printf("is co_reg...\n"))
     CoRegBaseAndNormal(&(co->reg.xyztoplane),&(co->coreg.planetoxyz),
            &(view->gplane.base),&(view->gplane.normal_cosine),
            base,normal);
     PRT15(printf("CoRegisteredParams new base...");pr_vector_3d_rec(base);
          printf("new norm ...");pr_vector_3d_rec(normal);
          printf("dist(gbase,base) = %f deg = %f\n",
             vector_distance(&(view->gplane.base),base),
             degree_angle_vectors(&(view->gplane.normal_cosine),normal));
          printf("dist(co->reg.base,co->coreg.base) dist = %f deg = %f\n",
             vector_distance(&(co->coreg.base),&(co->reg.base)),
             degree_angle_vectors(&(co->reg.normal),&(co->coreg.normal)));
          printf("\n"))
/*
     PRT15(printf("new base...");pr_vector_3d_rec(base);
          printf("new norm ...");pr_vector_3d_rec(normal);
          printf("dist(gbase,co->base) = %f deg = %f\n",
             vector_distance(&(view->gplane.base),&(co->base)),
             degree_angle_vectors(&(view->gplane.normal_cosine),&(co->normal)));
          printf("dist(base,co->coreg.base) dist = %f deg = %f\n",
             vector_distance(&(co->coreg.base),base),
             degree_angle_vectors(&(co->coreg.normal),normal));
          printf("\n"))
*/

    }
}


/*-----------------------------------------------------------------------
DisplayCoRegisteredPlanes - ???
-----------------------------------------------------------------------*/

int
DisplayCoRegisteredPlanes(view,is_trigger_co,is_trigger_lock)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock;
{
 struct vector_3d_rec base,normal;
 struct view_rec *next;
 struct co_register_rec *co;
 struct matrix_3d_rec mat;
 long lcv;
 int err;

 err = NO_ERROR;
 PRT17(printf("\nDisplayCoRegisteredPlanes...wid = %s num_cos = %d\n",view->wid,view->num_cos);)
 for (lcv = 0; lcv < view->num_cos; lcv++)
    {
     PRT11(printf("===%d) co wid = %s\n",lcv,view->cos[lcv].wid);)
     if ((next = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL)
        {if (next->status & PLANE_CO_REGISTERED_PROCESSED) continue;
         co = &(view->cos[lcv]);
         PRT10(printf("%d) co->status = %x co wid = %s\n",lcv,(unsigned long) co->status,co->wid);)
         if (co->status & CO_DONT_PROCESSED)
            {next->status |= PLANE_CO_REGISTERED_PROCESSED;
             PRT10(printf("...CO_DONT_PROCESSED continue\n");)
             continue;}
         if (co->status & LOCKED)
            {if (!is_trigger_lock) 
                {PRT10(printf("LOCKED...!is_trigger_lock continue\n");)
                 continue;}
            }
           else if (!is_trigger_co) 
            {PRT10(printf("...!is_trigger_co continue\n");)
             continue;}
         CoRegisteredParams(view,co,&base,&normal,
                   (unsigned int) (co->status & LOCKED));
         if (!(co->status & LOCKED))
            {next->gplane.status &= ~PLANE_ADJUST_TO_CENTER;
             mult_3d_matrix(&mat,&(co->reg.planetoxyz),&(co->coreg.xyztoplane));
             mult_3d_matrix(&mat,&(view->gplane.xyztoplane),&mat);
    	     FormPlaneNoDisplay(next,&base,&normal,NULL,&(view->gplane.rotate),
                                0,0,&mat);
             PRT10(printf("!(co->status & LOCKED...\n"))
             PRT10(printf("==..base\n");pr_vector_3d_rec(&base))
             PRT10(printf("normal \n");pr_vector_3d_rec(&normal))
             PRT10(printf("===xyztoplane \n");pr_3d_matrix(&(next->gplane.xyztoplane)))
             PRT10(printf("planetoxyz \n");pr_3d_matrix(&(next->gplane.planetoxyz)))
            }
           else
            {next->gplane.status |= PLANE_ADJUST_TO_CENTER;
    	     FormPlaneNoDisplay(next,&base,&normal,NULL,NULL,0,0,NULL);}
         next->status |= PLANE_CO_REGISTERED_PROCESSED;
         next->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;
         PRT17(printf("BuildAndDisplayPlaneData next wid = %s \n",next->wid);)
         if ((err = BuildAndDisplayPlaneData(next)) != NO_ERROR) break;
         if ((next->status & PLANE_CO_REGISTERED) &&
             (next->num_cos > 0))
            if ((err = DisplayCoRegisteredPlanes(next,
                         is_trigger_co,is_trigger_lock)) != NO_ERROR)
               break;
        }
       else 
        {drop_co_registered_plane(view,lcv);
         view->status |= PLANE_CO_REGISTERED_PROCESSED;
         view->more_status &= ~VIEW_MORE_STATUS_ADJUSTED;
         lcv--;}
    }
 PRT17(printf("DisplayCoRegisteredPlanes...err = %d\n",err);)
 return err;
}


/*-----------------------------------------------------------------------
ViewDpUnprocessed - ???
-----------------------------------------------------------------------*/

int
ViewDpUnprocessed(view,is_trigger_co,is_trigger_lock)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock;
{
 if (view->status & PLANE_CO_REGISTERED_PROCESSED)
    {
     PRT14(printf("ViewDpUnprocessed...done view->wid = %s status = %x\n",
         view->wid,view->status))
     return NO_ERROR;}
 PRT14(printf("ViewDpUnprocessed...view->wid = %s status = %x num_cos = %d\n",view->wid,
       view->status,view->num_cos))
 if (view->num_cos == 0)
    return BuildAndDisplayPlaneData(view);
   else return DisplayCoRegisteredPlanes(view,is_trigger_co,is_trigger_lock);
}


/*-----------------------------------------------------------------------
DisplayCoRegisteredAdjustedPlanes - ???
-----------------------------------------------------------------------*/

int
DisplayCoRegisteredAdjustedPlanes(view,is_trigger_co,is_trigger_lock)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock;
{
 int yes;
 struct view_rec *view1;
 unsigned long lcv;

 if (!(view->more_status & VIEW_MORE_STATUS_ADJUSTED)) return NO_ERROR;
 PRT17(printf("DisplayCoRegisteredAdjustedPlanes...wid = %s more_status = %x\n",
       view->wid,(unsigned long) view->more_status))
 PRT17(printf("is_trigger_co = %d is_trigger_lock = %d\n",
       is_trigger_co,is_trigger_lock))
 for (yes = 0,lcv = 0; lcv < view->num_cos; lcv++)
    if (((view1 = find_any_view_rec(view->file,view->cos[lcv].wid)) != NULL) &&
        !(view1->status & PLANE_CO_REGISTERED_PROCESSED) &&
        (view1->file != view->file))
       {yes = 1;
        PRT17(printf("yes = 1...view1->wid = %s\n",view1->wid))
        break;
       }
 if (yes)
    {view1->status |= PLANE_CO_REGISTERED_PROCESSED;
     view1->img->_2d_fusion.status &= ~FUSION_SYNC;
     return DisplayCoRegisteredPlanes(view1,is_trigger_co,is_trigger_lock);}
   else 
    {view->status |= PLANE_CO_REGISTERED_PROCESSED;
     view->img->_2d_fusion.status &= ~FUSION_SYNC;
     return DisplayCoRegisteredPlanes(view,is_trigger_co,is_trigger_lock);}
}


/*-----------------------------------------------------------------------
is_coreg_on_proc - ???
-----------------------------------------------------------------------*/

int
is_coreg_on_proc(view)
 struct view_rec *view;
{
 struct list_rec *cur,*next;
 struct view_rec *view1;

 next = cur = &(view->_3d_list);
 do 
    {view1 = next->item;
     if (view1->num_cos > 0) return 1;
     next = next->next;}
 while (cur != next);
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
DpAllCoRegPlanes - ???
-----------------------------------------------------------------------*/

int
DpAllCoRegPlanes(view,is_trigger_co,is_trigger_lock,is_dp_cur,is_dp_whole_group,
                 is_mv_recoreg)
 struct view_rec *view;
 int is_trigger_co,is_trigger_lock,is_dp_cur,is_dp_whole_group,is_mv_recoreg;
{
 int err,recoreg;

 PRT17(printf("DpAllCoRegPlanes...is_dp_cur = %d is_dp_whole_group = %d\n",
          is_dp_cur,is_dp_whole_group))
 clear_all_planes_co_process_status(view,1,0);
 err = NO_ERROR;
 if (is_mv_recoreg)
    recoreg = is_coreg_on_proc(view);
   else recoreg = 0;
 if (is_dp_cur && !(view->status & PLANE_CO_REG_ADJUST) && !recoreg)
    {
     if (err == NO_ERROR)
        {PRT14(printf("DpAllCoRegPlanes..BuildAndDisplayPlaneData\n"))
         err = BuildAndDisplayPlaneData(view);
         view->status |= PLANE_CO_REGISTERED_PROCESSED;
         view->more_status |= VIEW_MORE_STATUS_ADJUSTED;
        }
    }
 PRT17(printf("DpAllCoRegPlanes..err = %d..recoreg = %d is_mv_recoreg = %d\n",
        err,recoreg,is_mv_recoreg))
 if (err == NO_ERROR)
    {
     if ((view->status & PLANE_CO_REG_ADJUST) || recoreg)
        {
         err = run_next_view_proc(view,DisplayCoRegisteredAdjustedPlanes,
                    is_trigger_co,is_trigger_lock,0,0,0,0);
        }
       else err = DisplayCoRegisteredPlanes(view,is_trigger_co,is_trigger_lock);
     if ((err == NO_ERROR) && is_dp_whole_group)
        {
         err = run_next_view_proc(view,ViewDpUnprocessed,
                    is_trigger_co,is_trigger_lock,0,0,0,0);
        }
     PRT17(if (is_dp_whole_group || view->status & PLANE_CO_REG_ADJUST)
        run_any_file_views_proc(view,pr_xyztoplane);)
    }

 clear_all_planes_co_process_status(view,0,1);
 PRT10(printf("DpAllCoRegPlanes...err = %d\n",err))
 return err;
}


/*-----------------------------------------------------------------------
WinReDisplayViewGroup - ???
-----------------------------------------------------------------------*/

int
WinReDisplayViewGroup(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view;

 PRT10(printf("WinReDisplayViewGroup.....\n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 /* FIXME!!  Added a final argument 1 below by pure guesswork.  It
    needs to checked if this is right.  -PWH 19990331 */
 return DpAllCoRegPlanes(view,1,1,1,1,1);
}


/*-----------------------------------------------------------------------
win_valid_fusion_wid_file_group - ???
-----------------------------------------------------------------------*/

int
win_valid_fusion_wid_file_group(win,co_wid)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct view_rec *view,*view1;

 if (!(win->type2 & DISPLAY_WINDOW_3D)) return CANCEL;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->_2d_fusion.status & FUSION_METHOD)) return CANCEL;
 if (img->src_wid == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 if ((view1 = find_any_view_rec(img->file,img->src_wid)) == NULL) return CANCEL;
 if ((view1->group_num == view->group_num) &&
     (view1->file == view->file))
    return CANCEL;
 return NO_ERROR;
}


/*-----------------------------------------------------------------------
win_reco_register_group - ???
-----------------------------------------------------------------------*/

int
win_reco_register_group(win,co_wid)
 struct image_display_window *win;
 char *co_wid;
{
 struct strs_rec wids,result_wid_ptrs;
 struct view_rec *view,*view1,*view2,*view3;
 struct co_register_rec *co,*co1,*co2,*co3;
 struct img_buf_rec *img;
 long lcv,cnt,indx,indx1;
 int err;

 PRT10(printf("win_reco_register_group...co_wid = %s\n",co_wid);)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
 if ((view1 = find_any_view_rec(view->file,co_wid)) == NULL) return CANCEL;
 if ((view->group_num == view1->group_num) && 
     (view->file == view1->file))
    return CANCEL;
 PRT10(printf("win_reco_register_group view->wid = %s view1 = %s\n",
                                 view->wid,view1->wid);)
 if (((co = find_co_register_rec(view,co_wid,&indx,&err,0)) == NULL) ||
     ((co1 = find_co_register_rec(view1,view->wid,&indx,&err,0)) == NULL))
    return CANCEL;
 PRT10(printf("win_reco_register_group...3\n");)
 AssignCoRegPlaneParams(co,&(view->gplane),&(view1->gplane),0);
 co1->reg = co->coreg;
 co1->coreg = co->reg;

 init_strs_rec(&wids);
 if ((err = group_view_co_registered(view,&wids,0,1,2)) != NO_ERROR)
    return err;
 init_strs_rec(&result_wid_ptrs);
 if (wids.num_strs > 0)
    if ((err = co_reg_wid_ptrs_by_file_group(&wids,&result_wid_ptrs,
                   view1->file,view1->group_num)) == NO_ERROR)
       {PRT10(printf("before result_wid_ptrs\n");
              pr_strs_rec(result_wid_ptrs))
        drop_str_ptr_from_strs_rec(&result_wid_ptrs,view->wid);
        PRT10(printf("after result_wid_ptrs\n");
              pr_strs_rec(result_wid_ptrs))
       }
 if ((err == NO_ERROR) && (result_wid_ptrs.num_strs > 0))
    {for (cnt = 0; cnt < result_wid_ptrs.num_strs; cnt++)
        {if ((view2 = find_view_rec(view,result_wid_ptrs.strs[cnt])) != NULL)
            for (lcv = 0; lcv < view2->num_cos; lcv++)
               {if ((view3 = find_any_view_rec(view2->file,view2->cos[lcv].wid)) != NULL)
                   if ((view3->group_num == view1->group_num) && 
                       (view3->file == view1->file))
                      {co2 = find_co_register_rec(view2,view3->wid,&indx,&err,0);
                       co3 = find_co_register_rec(view3,view2->wid,&indx1,&err,0);
                       if ((co2 != NULL) && (co3 != NULL))
                          {co2->reg = co->reg;
                           co2->coreg = co->coreg;
                           co3->reg = co1->reg;
                           co3->coreg = co1->coreg;
                           PRT10(printf("view2->wid = %s view3 = %s\n",
                                 view2->wid,view3->wid);)
                          }
                         else
                          {if (co2 != NULL)
                              {drop_co_registered_plane(view2,indx);
                               lcv -= 1;}
                           if (co3 != NULL) drop_co_registered_plane(view3,indx1);}
                      }
               }
        }

    }
 free_strs_rec_ptrs(&wids);
 free_strs_rec_ptrs(&result_wid_ptrs);
 PRT10(printf("win_reco_register_group...5..err = %d\n",err);)

 return err;
}


/*-----------------------------------------------------------------------
win_reco_reg_group - ???
-----------------------------------------------------------------------*/

int
win_reco_reg_group(win,co_wid)
 struct image_display_window *win;
 char *co_wid;
{
 int err;

 if ((err = win_reco_register_group(win,co_wid)) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,3,NO_ERROR,2,2,
               "Error occurred when...",
               "reco-registering the wids...",NULL,0);
    }
 return err;
}


/*-----------------------------------------------------------------------
win_reco_register - ???
-----------------------------------------------------------------------*/

int
win_reco_register(win,co_wid)
 struct image_display_window *win;
 char *co_wid;
{
 int err;
 struct strs_rec wids;
 long lcv;

 PRT10(printf("win_reco_register...co_wid = %s\n",co_wid);)
 if (co_wid == NULL) return CANCEL;
 if (str_cmp(co_wid,RECO_REGISTER_WITH_WID) == 0)
    {init_strs_rec(&wids);
     PRT10(printf("win_reco_register...1\n");)
     if ((err = win_co_registered_wids(win,&wids,0,1,2)) != NO_ERROR)
        {ShowMsgStrs(win->dwin->frame,0,err,0,1,
                 "An error occurred when reco-registering !!!",
                 NULL,0);
         free_strs_rec_ptrs(&wids);
         return err;}
     for (lcv = 0; lcv < wids.num_strs; lcv++)
        if ((err = win_reco_reg_group(win,wids.strs[lcv])) != NO_ERROR)
           break;
     free_strs_rec_ptrs(&wids);
    }
   else err = win_reco_reg_group(win,co_wid);
 if (err != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,3,err,0,2,
                 "An error occurred when reco-registering !!!",
                 "Will continue displaying the group wids !!!",
                 WinReDisplayViewGroup,1,win);
    }
 PRT10(printf("win_reco_register...err = %d\n",err);)

 return err;
}
