/****************************************************************************
color_to_screen.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: color_to_screen.c,v 1.9 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>

#include "ria_global.h"
#include "common.h"
#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT1(x)
#define PRT2(x)
#define PRT5(x)
#define PRT3(x)
#define PRT6(x)
#define PRT4(x)


/* Functions defined in this file */
int PaintCurCurve(struct screen_data_rec *screen,
    struct draw_mask_rec *draw_masks[], unsigned int num_draw_masks,
    struct color_screen_rec *data, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs, unsigned long bkg_color);
int PaintCurvesToScreen(struct screen_data_rec *screen,
    struct draw_mask_rec *draw_masks[], unsigned int num_draw_masks,
    struct color_screen_rec *data, unsigned long *real_color_indxs,
    unsigned long num_real_color_indxs, unsigned long bkg_color);
int win_refresh_screen_data(struct image_display_window *win);
int WinBufScreenData(struct image_display_window *win, struct buf_2d_rec *_2d,
    long left, long top, long right, long bottom,
    struct buf_2d_rec *screen_2d);
int draw_pt_to_screen_buf(struct screen_data_rec *screen,
    struct coord_rec *coords, int pixel_value, unsigned long *real_color_indxs,
    unsigned int num_real_color_indxs,
    struct int_bound_rec *dirty_screen_bound, unsigned short *display_status);
int ErasePtFromScreenBuf(struct screen_data_rec *screen,
    struct coord_rec *coords, struct color_screen_rec *data,
    struct draw_mask_rec *draw_masks[], unsigned int num_masks,
    unsigned long *real_color_indxs, unsigned int num_real_color_indxs,
    int bkg_color, struct int_bound_rec *dirty_screen_bound,
    unsigned short *display_status);



/*------------------------------------------------------------------------
PaintCurCurve - ???
-------------------------------------------------------------------------*/

int
PaintCurCurve(screen,draw_masks,num_draw_masks,data,
                real_color_indxs,num_real_color_indxs,bkg_color)
 struct screen_data_rec *screen;
 struct draw_mask_rec *draw_masks[];
 unsigned int num_draw_masks;
 struct color_screen_rec *data;
 unsigned long *real_color_indxs,num_real_color_indxs,bkg_color;
{
 long row,col,y,lcv,cnt,indx,dimx,num,offset,offsetx,x,
              start_byte,stop_byte,last,num_bufs,lx,ly;
 int (*magnify_pixel)();
 unsigned int left,right,top,bottom,value;
 struct int_bound_rec bound;
 unsigned long vals[8];
 unsigned long loop;
 int start_bit_num,end_bit_num,yes;
 unsigned char cur_curve,cur,or,next,start_bit,end_bit;
 struct color_data_rec **colors;
 struct buf_2d_rec *_2d;

 PRT6(printf("PaintCurCurve\n"))
 if (!(screen->_2d.status4 & BUF_NON_EMPTY)) return CANCEL;
 for (lcv = 0; lcv < num_draw_masks; lcv++)
    if (draw_masks[lcv]->paint_status & PAINTED) break;
 if (lcv == num_draw_masks)
     {
      return NO_ERROR;}
 PRT6(for (lcv = 0; lcv < num_draw_masks; lcv++)
    printf("PaintCurCurve %d) tot = %d\n",lcv,
          cnt_val_buf_2d_rec(&(draw_masks[lcv]->mask._2d),0)))

 GetMagnifyPixelProc(&magnify_pixel,screen->_2d.pixel_depth);
 setup_int_bound_rec(&bound,0,0,draw_masks[0]->mask._2d.dimx - 1,
                     draw_masks[0]->mask._2d.dimy - 1);
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
/*
 setup_int_bound_rec(&bound,left,top,right,bottom);
 setup_int_bound_rec(&bound1,0,0,screen->_2d.dimx - 1,screen->_2d.dimy - 1);
 valid_bound(&bound,&bound1,&left,&right,&top,&bottom);
 PRT3(printf("PaintCurCurve pixel_depth  = %d\n",screen->_2d.pixel_depth))
*/
 PRT2(printf("\n>>>PaintCurCurve...screen->dimension\n"))
 PRT2(pr_int_region_rect(&(screen->dimension));)
 PRT6(printf("l = %d t = %d r = %d b = %d\n",left,top,right,bottom);)
 PRT2(printf("PaintCurCurve...1\n\n"))

 start_byte = left / 8;
 stop_byte = right / 8;

 start_bit_num = left % 8;
 start_bit = C_end_bits[start_bit_num];
 end_bit_num = right % 8;
 end_bit = C_start_bits[end_bit_num];

 dimx = screen->pixel.mask.dimx * 8;
 offsetx = (8 - start_bit_num) * screen->pixel.mask.dimx;

 y = bufy_to_screeny(screen,top);
 if (draw_masks[0]->paint_status & PAINT_SUPERIMPOSE)
    for (loop = 0; loop < 8; loop++)
       vals[loop] = real_color_indxs[draw_masks[0]->pixel_value];

 TRACE(printf("y = %d left = %d right = %d  top = %d  bottom = %d\n",
       y,left,right,top,bottom))
 TRACE(printf("start_byte = %d  stop_byte = %d\n",start_byte,stop_byte))
 PRT6(printf("start_bit = %x end_bit = %x  offx = %d  start_bit_num = %d y = %d\n",
       (unsigned int) start_bit,(unsigned int) end_bit,offsetx,start_bit_num,y))
 PRT2(printf("PaintCurCurve...2\n\n"))
 PRT6(if (draw_masks[0]->paint_status & PAINT_SUPERIMPOSE)
     printf("PaintCurCurve...draw_masks[0]->paint_status & PAINT_SUPERIMPOSE\n\n"))

 last = data->num_color_datas - 1;
 colors = data->color_datas;
 for (row = top; row <= bottom; row++,y += screen->pixel.mask.dimy)
    {offset = offsetx;
     for (x = 0,col = start_byte; col <= stop_byte; col++,x += offset,offset = dimx)

        {if (!(cur_curve = draw_masks[0]->mask._2d.buf[row][col])) continue;
         if (col == stop_byte)
            {cur_curve &= end_bit;
             if (!cur_curve) continue;}
           else if (col == start_byte)
            {cur_curve &= start_bit;
             if (!cur_curve) continue;}

         if (draw_masks[0]->paint_status & PAINT_SUPERIMPOSE)
            {magnify_pixel(screen->_2d.buf,screen->_2d.dimx,
                          screen->_2d.dimy,screen->_2d.pixel_depth,
                          x,y,&(screen->pixel),&(ByteBitOrder[cur_curve]),vals);
             continue;
            }
         for (cur = cur_curve,or = 0,lcv = 1; lcv < num_draw_masks; lcv++)
            if (draw_masks[lcv]->paint_status & PAINT_SUPERIMPOSE)
               {next = draw_masks[lcv]->mask._2d.buf[row][col] & cur;
                next &= ~or;
                if (!next) continue;
                for (loop = 0; loop < ByteBitOrder[next].num1bits; loop++)
                    vals[ByteBitOrder[next].bits[loop]] = 
                           real_color_indxs[draw_masks[lcv]->pixel_value];
                      
                cur &= ~next;
                or |= next;
                if (!cur) break;
               }
         if (cur_curve != or)
            {cur = cur_curve;
             cur &= ~or;
             cnt = col * 8;
             for (loop = 0; loop < ByteBitOrder[cur].num1bits; loop++)
                 {indx = cnt + ByteBitOrder[cur].bits[loop];
                  for (yes = 0,num_bufs = last; ; num_bufs--)
                     {_2d = &(colors[num_bufs]->_2d);
                      if (((ly = (row - _2d->startoffy)) < 0) ||
                          (ly >= (long) _2d->dimy) ||
                          ((lx = (indx - _2d->startoffx)) < 0) ||
                          (lx >= (long) _2d->dimx))
                         {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                          if (num_bufs == 0) break;}
                        else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                                 (num_bufs == 0))
                         {if ((colors[num_bufs]->num_color_indxs > 0) &&
                              (value >= colors[num_bufs]->scale.first) &&
                              ((num = (value - colors[num_bufs]->scale.first)) < 
                               colors[num_bufs]->num_color_indxs))
                             value = colors[num_bufs]->color_indxs[num];
                          yes = 1;
                          break;}
                      }
                  if (!yes) value = bkg_color;
                  vals[ByteBitOrder[cur].bits[loop]] = real_color_indxs[value];
                 }
            }
         if ((col == start_byte) && (start_bit != 0xff))
            {for (cnt = 0,loop = start_bit_num; loop < 8; loop++,cnt++)
                vals[cnt] = vals[loop];
             cur_curve <<= start_bit_num;
            }
         magnify_pixel(screen->_2d.buf,screen->_2d.dimx,
                     screen->_2d.dimy,screen->_2d.pixel_depth,
                     x,y,&(screen->pixel),&(ByteBitOrder[cur_curve]),vals);
        }
    }
 TRACE(printf("((PaintCurCurve...end\n"))
 PRT2(printf("PaintCurCurve...end\n\n"))

 return NO_ERROR;
}


/*------------------------------------------------------------------------
PaintCurvesToScreen - ???
-------------------------------------------------------------------------*/

int
PaintCurvesToScreen(screen,draw_masks,num_draw_masks,data,
                     real_color_indxs,num_real_color_indxs,bkg_color)
 struct screen_data_rec *screen;
 struct draw_mask_rec *draw_masks[];
 unsigned int num_draw_masks;
 struct color_screen_rec *data;
 unsigned long *real_color_indxs,num_real_color_indxs,bkg_color;
{
 long row,col,y,lcv,cnt,indx,dimx,num,offset,offsetx,x,start_byte,stop_byte,
      last,num_bufs,lx,ly;
 int (*magnify_pixel)();
 unsigned int left,right,top,bottom,value;
 struct int_bound_rec bound;
 unsigned long vals[8];
 unsigned long loop;
 unsigned char paint,erase;
 int start_bit_num,yes;
 unsigned char cur,or,next,start_bit,end_bit;
 struct color_data_rec **colors;
 struct buf_2d_rec *_2d;

 PRT6(printf("PaintCurCurve pixel_depth  = %d\n",screen->_2d.pixel_depth))
 if (!(screen->_2d.status4 & BUF_NON_EMPTY)) return CANCEL;
 for (lcv = 0; lcv < num_draw_masks; lcv++)
    {
     if (draw_masks[lcv]->paint_status & PAINTED) break;
    }
 if (lcv == num_draw_masks) return NO_ERROR;
 PRT6(for (lcv = 0; lcv < num_draw_masks; lcv++)
    {printf("PaintCurvesToScreen %d) tot = %d\n",lcv,
          cnt_val_buf_2d_rec(&(draw_masks[lcv]->mask._2d),0));
     pr_buf_2d_rec(&(draw_masks[lcv]->mask._2d));})


 TRACE(printf(">>>PaintCurvesToScreen num_draw_masks = %d\n",num_draw_masks))
 GetMagnifyPixelProc(&magnify_pixel,screen->_2d.pixel_depth);
 setup_int_bound_rec(&bound,0,0,draw_masks[0]->mask._2d.dimx - 1,
                     draw_masks[0]->mask._2d.dimy - 1);
 valid_bound(&(screen->dimension.bound),&bound,&left,&right,&top,&bottom);
 PRT6(printf("=== 1 l = %d t = %d r = %d b = %d\n",left,top,right,bottom);)
/*
 setup_int_bound_rec(&bound,left,top,right,bottom);
 setup_int_bound_rec(&bound1,0,0,screen->_2d.dimx - 1,screen->_2d.dimy - 1);
 valid_bound(&bound,&bound1,&left,&right,&top,&bottom);
*/
 PRT3(printf("\n>>>PaintCurvesToScreen...screen->dimension\n"))
 PRT3(pr_int_region_rect(&(screen->dimension));)


 start_byte = left / 8;
 stop_byte = right / 8;

 start_bit_num = left % 8;
 start_bit = C_end_bits[start_bit_num];
 end_bit = right % 8;
 end_bit = C_start_bits[end_bit];

 dimx = screen->pixel.mask.dimx * 8;
 offsetx = (8 - start_bit_num) * screen->pixel.mask.dimx;

 PRT3(printf("1 ...\n"))
 y = bufy_to_screeny(screen,top);

 PRT3(printf("screen dimx = %d dimy = %d\n",
         screen->pixel.mask.dimx,screen->pixel.mask.dimy))
 PRT3(printf("\ny = %d left = %d right = %d  top = %d  bottom = %d\n",
            y,left,right,top,bottom))
 PRT3(printf("start_byte = %d  stop_byte = %d\n",
           start_byte,stop_byte))
 PRT6(printf("start_bit = %x end_bit = %x  offx = %d  start_bit_num = %d dimx = %d y = %d\n",
     (unsigned int) start_bit,(unsigned int) end_bit,offsetx,start_bit_num,dimx,y))
 PRT3(printf("\nscreen dim = ...\n"))
 PRT3(pr_buf_2d_rec(&(screen->_2d)));
 last = data->num_color_datas - 1;
 colors = data->color_datas;
 for (row = top; row <= bottom; row++,y += screen->pixel.mask.dimy)
    {offset = offsetx;
     for (x = 0,col = start_byte; col <= stop_byte; col++,x += offset,offset = dimx)
        {for (erase = paint = 0,lcv = 0;lcv < num_draw_masks; lcv++)
            {if (cur = draw_masks[lcv]->mask._2d.buf[row][col])
                if (draw_masks[lcv]->paint_status & PAINT_SUPERIMPOSE)
                   paint |= cur;
                  else erase |= cur;
            }
         if (col == stop_byte)
            {paint &= end_bit;
             erase &= end_bit;}
           else if (col == start_byte)
            {paint &= start_bit;
             erase &= start_bit;}
         erase &= ~paint;
         if ((erase == 0) && (paint == 0)) continue;
         if (paint)
            {for (or = 0,lcv = 0;lcv < num_draw_masks; lcv++)
                {if (!(draw_masks[lcv]->paint_status & PAINT_SUPERIMPOSE))
                    continue;
                 cur = draw_masks[lcv]->mask._2d.buf[row][col] & paint;
                 cur &= ~or;
                 if (!cur) continue;
                 for (loop = 0; loop < ByteBitOrder[cur].num1bits; loop++)
                    vals[ByteBitOrder[cur].bits[loop]] = 
                           real_color_indxs[draw_masks[lcv]->pixel_value];
                 or |= cur;
                 if (or == paint) break;
                }
            }
         if (erase)
            {for (cur = erase,or = 0,lcv = 0; lcv < num_draw_masks; lcv++)
                if (draw_masks[lcv]->paint_status & PAINT_SUPERIMPOSE)
                   {next = draw_masks[lcv]->mask._2d.buf[row][col] & cur;
                    next &= ~or;
                    if (!next) continue;
                    for (loop = 0; loop < ByteBitOrder[next].num1bits; loop++)
                       vals[ByteBitOrder[next].bits[loop]] = 
                           real_color_indxs[draw_masks[lcv]->pixel_value];
                    cur &= ~next;
                    or |= next;
                    if (!cur) break;
                   }
             if (erase != or)
                {cur = erase;
                 cur &= ~or;
                 cnt = col * 8;
                 for (loop = 0; loop < ByteBitOrder[cur].num1bits; loop++)
                    {indx = cnt + ByteBitOrder[cur].bits[loop];
                     for (yes = 0,num_bufs = last; ; num_bufs--)
                        {_2d = &(colors[num_bufs]->_2d);
                         if (((ly = (row - _2d->startoffy)) < 0) ||
                             (ly >= (long) _2d->dimy) ||
                             ((lx = (indx - _2d->startoffx)) < 0) ||
                             (lx >= (long) _2d->dimx))
                            {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                                 num_bufs,ly,_2d->startoffy,y);*/
                             if (num_bufs == 0) break;}
                           else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                                    (num_bufs == 0))
                            {if ((colors[num_bufs]->num_color_indxs > 0) &&
                                 (value >= colors[num_bufs]->scale.first) &&
                                 ((num = (value - colors[num_bufs]->scale.first)) < 
                                 colors[num_bufs]->num_color_indxs))
                                value = colors[num_bufs]->color_indxs[num];
                            yes = 1;
                            break;}
                         }
                     if (!yes) value = bkg_color;
                     vals[ByteBitOrder[cur].bits[loop]] = real_color_indxs[value];
                    }
                }
            }
         cur = paint | erase;
/*
         if (col == stop_byte)
            {cur &= end_bit;
             if (!cur) continue;
            }
*/
         if ((col == start_byte) && (start_bit != 0xff))
            {/*cur &= start_bit;
             if (!cur) continue;
             */
             PRT1(printf("cur = %x start_bit_num = %d ",(unsigned long) cur,start_bit_num))
             for (cnt = 0,loop = start_bit_num; loop < 8; loop++,cnt++)
                {
                 vals[cnt] = vals[loop];}
             cur <<= start_bit_num;
             PRT1(printf("  cur = %x\n",(unsigned long) cur))
            }
         magnify_pixel(screen->_2d.buf,screen->_2d.dimx,
                              screen->_2d.dimy,screen->_2d.pixel_depth,
                              x,y,&(screen->pixel),&(ByteBitOrder[cur]),
                              vals);
        }
   }
 PRT3(printf("((PaintCurvesToScreen...end\n"))
 PRT2(printf("PaintCurvesToScreen...end\n\n"))

 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_refresh_screen_data - ???
-------------------------------------------------------------------------*/

int
win_refresh_screen_data(win)
 struct image_display_window *win;
{
 struct color_data_rec **colors;
 struct screen_data_rec *screen;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 Cms cms;

 if (win->data.num_color_datas == 0) return CANCEL;
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 num_real_color_indxs = xv_get(cms,CMS_SIZE);
 PRT4(printf("\nwin_refresh_screen_data num_real_color_indxs = %d\n",num_real_color_indxs))
 PRT1(printf("num_color_indxs = %d\n",win->data.color_data.num_color_indxs))

 screen = &(win->dwin->screen);
 colors = win->data.color_datas;
 PRT4(printf("win_refresh_screen_data num_color_datas = %d\n",win->data.num_color_datas))
 PRT4(for (lcv = 0; lcv < win->data.num_color_datas; lcv++)
    {printf("%d)...id = %d first = %d num_color_indxs = %d\n",
          lcv,colors[lcv]->id,colors[lcv]->scale.first,
         colors[lcv]->num_color_indxs);
          pr_buf_2d_rec(colors[lcv]->_2d);
     MinMax2dValues(&(colors[lcv]->_2d),0,(double) .0,(double) .0,&min4,&max4);
     printf("_2d min4 = %f max4 = %f\n",min4,max4);
    })
 PRT4(printf("win_refresh_screen_data...1\n"))
 PRT1(printf("_2d dimx = %d dimy = %d\n",colors[0]->_2d.dimx,
      colors[0]->_2d.dimy))
 PRT4(printf("screen_2d dimx = %d dimy = %d\n",screen->_2d.dimx,screen->_2d.dimy))
 PRT4(printf("pixel dimx = %d dimy = %d\n",screen->pixel.mask.dimx,screen->pixel.mask.dimy))
 MagnifyTheImage(colors,win->data.num_color_datas,&(win->data.bound),
        screen->_2d.buf,screen->_2d.dimx,screen->_2d.dimy,
        screen->_2d.pixel_depth,&(screen->dimension),&(screen->pixel),
        real_color_indxs,num_real_color_indxs,
        1 + win->intensity->color.num_system_colors);
 
 PRT4(printf("win_refresh_screen_data end\n\n"))
 win->process_status4 |= WIN_SCREEN_DATA_PROCESSED;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
WinBufScreenData - ???
-------------------------------------------------------------------------*/

int
WinBufScreenData(win,_2d,left,top,right,bottom,screen_2d)
 struct image_display_window *win;
 struct buf_2d_rec *_2d,*screen_2d;
 long left,top,right,bottom;
{
 struct screen_data_rec *screen;
 unsigned int num_real_color_indxs;
 unsigned long *real_color_indxs;
 struct int_region_rect dim;
 struct buf_2d_rec temp_2d;
 Cms cms;

 if (win->data.num_color_datas == 0) return CANCEL;
 cms = (Cms) xv_get(win->dwin->frame,WIN_CMS);
 real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 num_real_color_indxs = xv_get(cms,CMS_SIZE);
 screen = &(win->dwin->screen);
 setup_int_bound_rec(&(dim.bound),left,top,right,bottom);
 temp_2d = win->data.color_datas[0]->_2d;
 win->data.color_datas[0]->_2d = *_2d;
 MagnifyTheImage(win->data.color_datas,1,&(dim.bound),
        screen_2d->buf,screen_2d->dimx,screen_2d->dimy,
        screen->_2d.pixel_depth,&dim,&(screen->pixel),
        real_color_indxs,num_real_color_indxs,
        1 + win->intensity->color.num_system_colors);
 win->data.color_datas[0]->_2d = temp_2d;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
draw_pt_to_screen_buf - ???
-------------------------------------------------------------------------*/

int
draw_pt_to_screen_buf(screen,coords,pixel_value,real_color_indxs,
                      num_real_color_indxs,dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 int pixel_value;
 unsigned long *real_color_indxs;
 unsigned int num_real_color_indxs;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
 unsigned int lcv;
 int x,y,yes,x1,y1;
 int (*magnify_pixel)();


 get_magnify_pixel_proc(&magnify_pixel,screen->_2d.pixel_depth);
 TRACE(printf(">>>screen = %u coords->num_pts = %d...dimx = %d  dimy = %d\n",screen,
           coords->num_pts,screen->_2d.dimx,screen->_2d.dimy))
 TRACE(printf("left = %d   top = %d  pixel dimx = %d  dimy = %d\n",
    screen->dimension.bound.left,screen->dimension.bound.top,
    screen->pixel.mask.dimx,screen->pixel.mask.dimy))
 if (*display_status & WIN_SHOW_SCREEN_BOUND) 
    yes = 1;
   else yes = 0;
 for (lcv = 0; lcv < coords->num_pts; lcv++)
    {y1 = coords->pts[lcv].y;
     x1 = coords->pts[lcv].x;
     y = bufy_to_screeny(screen,y1);
     x = bufx_to_screenx(screen,x1);
     if ((x >= 0) && (x < screen->_2d.dimx) &&
         (y >= 0) && (y < screen->_2d.dimy))
        {magnify_pixel(screen->_2d.buf,screen->_2d.dimx,
                   screen->_2d.dimy,screen->_2d.pixel_depth,
                   x,y,&(screen->pixel),real_color_indxs[pixel_value]);
         if (yes)
            {if (dirty_screen_bound->left > x1) dirty_screen_bound->left = x1;
             if (dirty_screen_bound->right < x1) dirty_screen_bound->right = x1;
             if (dirty_screen_bound->top > y1) dirty_screen_bound->top = y1;
             if (dirty_screen_bound->bottom < y1) dirty_screen_bound->bottom = y1;}
           else
            {yes = 1;
             setup_int_bound_rec(dirty_screen_bound,x1,y1,x1,y1);}
        }
    }
 if (yes) *display_status |= WIN_SHOW_SCREEN_BOUND;
 TRACE(printf(">>>draw_pt_to_screen_buf end\n"))

 return NO_ERROR;
}


/*------------------------------------------------------------------------
ErasePtFromScreenBuf - ???
-------------------------------------------------------------------------*/

int
ErasePtFromScreenBuf(screen,coords,data,draw_masks,num_masks,
                     real_color_indxs,num_real_color_indxs,bkg_color,
                     dirty_screen_bound,display_status)
 struct screen_data_rec *screen;
 struct coord_rec *coords;
 struct color_screen_rec *data;
 struct draw_mask_rec *draw_masks[];
 unsigned int num_masks;
 unsigned long *real_color_indxs;
 unsigned int num_real_color_indxs;
 struct int_bound_rec *dirty_screen_bound;
 unsigned short *display_status;
{
  unsigned long lcv,indx,row,col,value,start,end,num,last,num_bufs,lx,ly;
 int x,y,byte_num,bit_num,yes,ok;
 int (*magnify_pixel)();
 static unsigned char _1_bit[] = {0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};
 struct color_data_rec **colors;
 struct buf_2d_rec *_2d;

 get_magnify_pixel_proc(&magnify_pixel,screen->_2d.pixel_depth);
 start = 0;
 end = coords->num_pts;
 TRACE(printf("ErasePtFromScreenBuf num_masks = %d coords->num_pts = %d\n",
     num_masks,coords->num_pts))
 if (*display_status & WIN_SHOW_SCREEN_BOUND) 
    ok = 1;
   else ok = 0;
 last = data->num_color_datas - 1;
 colors = data->color_datas;
/*
 printf("num_masks = %d\n",num_masks);
 for (indx = 0; indx < num_masks; indx++)
    if (draw_masks[indx]->paint_status & PAINT_SUPERIMPOSE)
       printf("%d) mask PAINT_SUPERIMPOSE\n",indx);
*/
 for (lcv = start; lcv < end; lcv++)
    {
     y = coords->pts[lcv].y;
     x = coords->pts[lcv].x;
     row = bufy_to_screeny(screen,y);
     col = bufx_to_screenx(screen,x);
     if ((col >= 0) && (col < screen->_2d.dimx) &&
         (row >= 0) && (row < screen->_2d.dimy))
        {
         for (byte_num = x / 8,bit_num = x % 8,indx = 0; indx < num_masks; indx++)
            if (draw_masks[indx]->paint_status & PAINT_SUPERIMPOSE)
               if (draw_masks[indx]->mask._2d.buf[y][byte_num] & _1_bit[bit_num])
                  {value = draw_masks[indx]->pixel_value;
                   break;}
         yes = 0;
         if (indx == num_masks)
            {for (num_bufs = last; ; num_bufs--)
                 {_2d = &(colors[num_bufs]->_2d);
                  if (((ly = (y - _2d->startoffy)) < 0) ||
                      (ly >= (long) _2d->dimy) ||
                      ((lx = (x - _2d->startoffx)) < 0) ||
                      (lx >= (long) _2d->dimx))
                     {/*printf("%d) ly = %d startoffy = %d y = %d\n",
                             num_bufs,ly,_2d->startoffy,y);*/
                      if (num_bufs == 0) break;}
                    else if ((value = get_1d_buf_value(_2d->buf[ly],lx,
                                       _2d->pixel_depth)) ||
                             (num_bufs == 0))
                     {if ((colors[num_bufs]->num_color_indxs > 0) &&
                          (value >= colors[num_bufs]->scale.first) &&
                          ((num = (value - colors[num_bufs]->scale.first)) < 
                           colors[num_bufs]->num_color_indxs))
                         value = colors[num_bufs]->color_indxs[num];
                      yes = 1;
                      break;}
                  }
            }
         if (!yes) value = bkg_color;
/*
         printf("%d) y=%d/x=%d   %d/%d  value = %d\n",lcv,y,x,row,col,value);
*/
         magnify_pixel(screen->_2d.buf,screen->_2d.dimx,
                   screen->_2d.dimy,screen->_2d.pixel_depth,
                   col,row,&(screen->pixel),real_color_indxs[value]);
         if (ok)
            {if (dirty_screen_bound->left > x) dirty_screen_bound->left = x;
             if (dirty_screen_bound->right < x) dirty_screen_bound->right = x;
             if (dirty_screen_bound->top > y) dirty_screen_bound->top = y;
             if (dirty_screen_bound->bottom < y) dirty_screen_bound->bottom = y;}
           else
            {ok = 1;
             setup_int_bound_rec(dirty_screen_bound,x,y,x,y);}
        }
    }
 if (ok) *display_status |= WIN_SHOW_SCREEN_BOUND;

 return NO_ERROR;
}
