/****************************************************************************
count_analysis_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: count_analysis_rec.c,v 1.7 1999/07/07 17:41:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "text_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)



/* Functions defined in this file */
void init_roi_count_anal_rec(struct roi_count_anal_rec *roi_count);
void free_roi_count_anal_rec(struct roi_count_anal_rec *roi_count);
int setup_roi_count_anal_rec(struct roi_count_anal_rec *roi_count, int label);
void init_slice_count_anal_rec(struct slice_count_anal_rec *slice_count);
void free_slice_count_anal_rec(struct slice_count_anal_rec *slice_count);
void init_count_analysis_rec(struct count_analysis_rec *count,
    struct input_file_rec *file);
void free_count_analysis_rec(struct count_analysis_rec *count);
int setup_slice_count_anal_rec(struct count_analysis_rec *count,
    int slice_num);
void pr_roi_count_anal_rec(struct roi_count_anal_rec *roi_count);
void pr_slice_count_anal_rec(struct slice_count_anal_rec *slice_count);
void pr_count_analysis_rec(struct count_analysis_rec *count);
int RdCountFormat(char *count_format_fn, struct count_analysis_rec *count);
int setup_count_analysis_rec_params(struct count_analysis_rec *count);
int delete_the_count_output(struct count_analysis_rec *count);
int setup_the_count_output_format(struct output_text_format_rec *format,
    struct count_analysis_rec *count, struct unit_2d_rec *unit);
int setup_count_output_format(struct count_analysis_rec *count,
    struct unit_2d_rec *unit);
int copy_count_format_only(struct count_analysis_rec *dst,
    struct count_analysis_rec *src, int option);



/*------------------------------------------------------------------------
init_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

void
init_roi_count_anal_rec(roi_count)
 struct roi_count_anal_rec *roi_count;
{
 roi_count->label = NULL;
 roi_count->status2 = 0;
}


/*------------------------------------------------------------------------
free_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

void
free_roi_count_anal_rec(roi_count)
 struct roi_count_anal_rec *roi_count;
{
 c_free(roi_count->label);
 roi_count->status2 = 0;
}


/*------------------------------------------------------------------------
setup_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

int
setup_roi_count_anal_rec(roi_count,label)
 struct roi_count_anal_rec *roi_count;
{
 int err;

 if ((err = cp_str(&(roi_count->label),label)) != NO_ERROR) return err;
 roi_count->min = 0;
 roi_count->max = -1;
 roi_count->total_counts = roi_count->sd = .0;
 roi_count->num_pixels = roi_count->cnt_neg_val = 0;
 roi_count->cnt_smean_min_rej = roi_count->cnt_smean_max_rej = 0;
 roi_count->cnt_rmean_min_rej = roi_count->cnt_rmean_max_rej = 0;
 roi_count->slice_mean = .0;
 roi_count->min_smean_threshold = roi_count->max_smean_threshold = .0;
 roi_count->roi_mean = .0;
 roi_count->min_rmean_threshold = roi_count->max_rmean_threshold = .0;

 return err;
}


/*------------------------------------------------------------------------
init_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

void
init_slice_count_anal_rec(slice_count)
 struct slice_count_anal_rec *slice_count;
{
 slice_count->status1 = COUNT_NEW_FORMAT;
 slice_count->total_rois = slice_count->num_rois = 0;
 slice_count->rois = NULL;
}


/*------------------------------------------------------------------------
free_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

void
free_slice_count_anal_rec(slice_count)
 struct slice_count_anal_rec *slice_count;
{
 unsigned long lcv;

 slice_count->status1 = 0;
 if (slice_count->total_rois)
    {for (lcv = 0; lcv < slice_count->num_rois; lcv++)
        free_roi_count_anal_rec(&(slice_count->rois[lcv]));
     c_free(slice_count->rois);
     init_slice_count_anal_rec(slice_count);}
}


/*------------------------------------------------------------------------
init_count_analysis_rec - ???
------------------------------------------------------------------------*/

void
init_count_analysis_rec(count,file)
 struct count_analysis_rec *count;
 struct input_file_rec *file;
{
 count->status = 0;
 count->file = file;
 count->text_printing_time = NULL;
 count->text_temp_fn = NULL;
 count->num_groups = 0;
 count->groups = NULL;
 init_output_text_format_rec(&(count->format));
 initial_unit_2d_rec(&(count->img_unit));

 count->out_format_status = count->format.status;
 count->lt_percent = count->format.lt_percent;
 count->roi_lt_percent = count->format.roi_lt_percent;
 count->gt_percent = count->format.gt_percent;
 count->roi_gt_percent = count->format.roi_gt_percent;
 count->total_slices = count->num_slices = 0;
 count->slices = NULL;
}


/*------------------------------------------------------------------------
free_count_analysis_rec - ???
------------------------------------------------------------------------*/

void
free_count_analysis_rec(count)
 struct count_analysis_rec *count;
{
 unsigned long lcv;

 c_free(count->text_printing_time);
 c_free(count->text_temp_fn);
 free_output_text_format_rec(&(count->format));
 if (count->num_groups > 0)
    {free_analysis_group_recs(count->groups,count->num_groups);
     c_free(count->groups);}

 if (count->total_slices > 0)
    {for (lcv = 0; lcv < count->num_slices; lcv++)
        free_slice_count_anal_rec(&(count->slices[lcv]));
     c_free(count->slices);}
 init_count_analysis_rec(count,NULL);
}


/*------------------------------------------------------------------------
setup_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

int
setup_slice_count_anal_rec(count,slice_num)
 struct count_analysis_rec *count;
 int slice_num;
{
 int err;
 unsigned long lcv;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 struct slice_count_anal_rec *slice_count;
 struct text_output_analysis_group_rec *group;
 struct strs_rec labels;

 if (count->total_slices == 0)
    {if ((err = get_ptr(&(count->slices),&(count->total_slices),
           NumberOfSliceCuts(&(count->file->hdr.data_info)),
           (size_t) sizeof(*(count->slices)))) != NO_ERROR) 
        return err;
     for (lcv = 0; lcv < count->total_slices; lcv++)
        init_slice_count_anal_rec(&(count->slices[lcv]));
     count->num_slices = count->total_slices;
    }
 PRT(printf("setup_slice...slices = %u slice_num = %d num_slices = %d total_slices = %d\n",
             count->slices,slice_num,count->num_slices,count->total_slices))
 if (slice_num >= count->num_slices) return CANCEL;
 slice_count = &(count->slices[slice_num]);
 free_slice_count_anal_rec(slice_count);
 PRT4(printf("sroi_wins = %u...\n",
          count->file->slice_info.sroi_wins))
 PRT4(printf("sroi_wins[slice_num] = %d...\n",
          count->file->slice_info.sroi_wins[slice_num]))
 slice_roi = &(count->file->slice_info.sroi_wins[slice_num]->slice_roi);
 PRT(printf("sroi_wins slice_roi = %u\n",slice_roi))
 err = NO_ERROR;
 init_strs_rec(&labels);
 if (count->status & TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS)
    {PRT4(printf("COUNT_ALL...\n"))
     for (lcv = 0; lcv < slice_roi->num_rois; lcv++)
        if (is_roi_non_empty(slice_roi->rois[lcv])) 
           if ((err = AddStrPtrToSortedStrsRec(&labels,
                  slice_roi->rois[lcv]->label,1,1)) != NO_ERROR)
              break;
    }
   else
    {
     group = &(count->groups[0]);
     PRT4(printf("slice_num = %d) setup_slice_count_anal_rec...group->num_rois = %d\n",
           slice_num,group->num_rois))
     PRT3(for (lcv = 0; lcv < group->num_rois; lcv++)
              printf("%d) label = %s\n",lcv,group->roi_labels[lcv]))
     PRT3(printf("slice_roi = %u\n",slice_roi))

     for (lcv = 0; lcv < group->num_rois; lcv++)
        if (((roi = get_roi(slice_roi,group->roi_labels[lcv])) != NULL) &&
            is_roi_non_empty(roi)) 
           {
            if ((err = add_str_ptr_to_strs_rec(&labels,
                       roi->label)) != NO_ERROR)
               break;}
    }
 PRT4(printf("setup_slice_count_anal_rec labels...\n"))
 PRT4(pr_strs_rec(&labels))
 if ((err != NO_ERROR) || (labels.num_strs == 0) ||
     ((err = get_ptr(&(slice_count->rois),&(slice_count->total_rois),
      labels.num_strs,(size_t) sizeof(*(slice_count->rois)))) != NO_ERROR))
    {free_strs_rec_ptrs(&labels);
     return err;}

 PRT(printf("num_strs == 0 total_rois = %d num_rois = %d\n\n",
            slice_count->total_rois,slice_count->num_rois))

 for (lcv = 0; lcv < slice_count->total_rois; lcv++)
    init_roi_count_anal_rec(&(slice_count->rois[lcv]));

 for (lcv = 0; lcv < labels.num_strs; lcv++)
    {if ((err = setup_roi_count_anal_rec(
                &(slice_count->rois[slice_count->num_rois]),
                       labels.strs[lcv])) != NO_ERROR) 
        {free_slice_count_anal_rec(slice_count);
         break;}
     slice_count->num_rois += 1;
    }
 PRT(if (labels.num_strs > 0)
    pr_strs_rec(&labels));
 PRT(printf("err = %d total_rois = %d num_rois = %d\n",err,
            slice_count->total_rois,slice_count->num_rois))
 free_strs_rec_ptrs(&labels);
 return err;
}


/*------------------------------------------------------------------------
pr_roi_count_anal_rec - ???
------------------------------------------------------------------------*/

void
pr_roi_count_anal_rec(roi_count)
 struct roi_count_anal_rec *roi_count;
{
 printf("lab = %s  min = %f  max = %f  total = %.3f num_pixs = %ld  sd = %.3f\n",
      roi_count->label,roi_count->min,roi_count->max,roi_count->total_counts,
      roi_count->num_pixels,roi_count->sd);
 printf("cnt_neg_val = %ld  cnt_smean_min_rej = %ld  cnt_smean_max_rej = %ld\n",
    roi_count->cnt_neg_val,roi_count->cnt_smean_min_rej,roi_count->cnt_smean_max_rej);
 printf("cnt_rmean_min_rej = %ld  cnt_rmean_max_rej = %ld\n",
      roi_count->cnt_rmean_min_rej,roi_count->cnt_rmean_max_rej);
 printf("slice_mean = %f  min = %f max = %f\n",
      roi_count->slice_mean,roi_count->min_smean_threshold,roi_count->max_smean_threshold);
 printf("roi_mean = %f  min = %f max = %f\n",
      roi_count->roi_mean,roi_count->min_rmean_threshold,roi_count->max_rmean_threshold);
}


/*------------------------------------------------------------------------
pr_slice_count_anal_rec - ???
------------------------------------------------------------------------*/

void
pr_slice_count_anal_rec(slice_count)
 struct slice_count_anal_rec *slice_count;
{
 unsigned long lcv;
 
 for (lcv = 0; lcv < slice_count->num_rois; lcv++)
    {printf("...%ld) ",lcv);
     pr_roi_count_anal_rec(&(slice_count->rois[lcv]));}
}


/*------------------------------------------------------------------------
pr_count_analysis_rec - ???
------------------------------------------------------------------------*/

void
pr_count_analysis_rec(count)
 struct count_analysis_rec *count;
{
 unsigned long lcv;

 for (lcv = 0; lcv < count->num_slices; lcv++)
    {printf("pr_count_analysis_rec %ld)\n",lcv);
     pr_slice_count_anal_rec(&(count->slices[lcv]));}
 printf("pr_count_analysis_rec end num_slices = %ld\n",count->num_slices);
}


/*------------------------------------------------------------------------
RdCountFormat - ???
------------------------------------------------------------------------*/

int
RdCountFormat(count_format_fn,count)
 char *count_format_fn;
 struct count_analysis_rec *count;
{
 int err;

 if ((err = RdTextFormat(count_format_fn,
            &(count->groups),&(count->num_groups),&(count->format),1)) 
                     != NO_ERROR)
    {free_analysis_group_recs(count->groups,count->num_groups);
     c_free(count->groups);
     count->num_groups = 0;
     count->groups = NULL;
    }
 if (count->num_groups == 0) 
    count->status |= TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
   else count->status &= ~TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
 return err;
}


/*------------------------------------------------------------------------
setup_count_analysis_rec_params - ???
------------------------------------------------------------------------*/

int
setup_count_analysis_rec_params(count)
 struct count_analysis_rec *count;
{
 if (!(count->status & TEXT_OUTPUT_FORMAT_SETUP) &&
     (count->file->count_format_fn != NULL))
    {
     count->status |= TEXT_OUTPUT_FORMAT_SETUP;
     count->status |= TEXT_OUTPUT_PARAMS_SETUP;
     count->status |= TEXT_OUTPUT_PIXEL_COUNT_ANALYSIS;
     RdCountFormat(count->file->count_format_fn,count);
    }

 return NO_ERROR;
}


/*------------------------------------------------------------------------
delete_the_count_output - ???
------------------------------------------------------------------------*/

int
delete_the_count_output(count)
 struct count_analysis_rec *count;
{
 unsigned long lcv;

 for (lcv = 0; lcv < count->num_slices; lcv++)
    free_slice_count_anal_rec(&(count->slices[lcv]));
 return NO_ERROR;
}


/*------------------------------------------------------------------------
setup_the_count_output_format - ???
------------------------------------------------------------------------*/

int
setup_the_count_output_format(format,count,unit)
 struct count_analysis_rec *count;
 struct unit_2d_rec *unit;
 struct output_text_format_rec *format;
{

 PRT1(printf("setup_the_count_output_format out_format_status = %x\n",
           (unsigned long) count->out_format_status))
 format->pixel_thickness = count->file->hdr.data_info.pixel_thickness;
 format->status &= ~OUT_FORMAT_UNIT_2D_VALID;
 if (count->out_format_status & OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW)
    {format->status |= OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW;}
   else 
    {format->status &= ~OUT_FORMAT_USE_DEFAULT_IMAGE_VIEW;
     if (count->out_format_status & OUT_FORMAT_UNIT_2D_VALID)
        {format->img_unit = count->img_unit;
         format->status |= OUT_FORMAT_UNIT_2D_VALID;
         PRT1(printf("OUT_FORMAT_UNIT_2D_VALID...out_format_status\n"))
        }
       else if (unit != NULL)
        {format->img_unit = *unit;
         format->status |= OUT_FORMAT_UNIT_2D_VALID;
         PRT1(printf("OUT_FORMAT_UNIT_2D_VALID...unit\n"))
        }
    }
 if (format->status & OUT_FORMAT_UNIT_2D_VALID)
    {format->xpixel_size = format->img_unit.unitx;
     format->ypixel_size = format->img_unit.unity;}
   else
    {format->xpixel_size = count->file->hdr.data_info.xpixel_size;
     format->ypixel_size = count->file->hdr.data_info.ypixel_size;}
 format->voxel_size = format->xpixel_size * format->ypixel_size * 
         format->pixel_thickness;

 format->lt_percent = .0;
 format->roi_lt_percent = .0;
 format->gt_percent = .0;
 format->roi_gt_percent = .0;

 if (count->out_format_status & OUT_FORMAT_LT_PERCENT_MEAN)
    format->lt_percent = count->lt_percent;
 if (count->out_format_status & OUT_FORMAT_GT_PERCENT_MEAN)
    format->gt_percent = count->gt_percent;

 if (count->out_format_status & OUT_FORMAT_LT_PERCENT_ROI_MEAN)
    format->roi_lt_percent = count->roi_lt_percent;
 if (count->out_format_status & OUT_FORMAT_GT_PERCENT_ROI_MEAN)
    format->roi_gt_percent = count->roi_gt_percent;

 format->status |= OUT_FORMAT_DEFINED;
 format->status &= ~OUT_FORMAT_COUNT_OPTIONS;
 format->status |= count->out_format_status & OUT_FORMAT_COUNT_OPTIONS;
 return NO_ERROR;

}


/*------------------------------------------------------------------------
setup_count_output_format - ???
------------------------------------------------------------------------*/

int
setup_count_output_format(count,unit)
 struct count_analysis_rec *count;
 struct unit_2d_rec *unit;
{
 struct output_text_format_rec *format,format1;

 format = &(count->format);
 if (!(format->status & OUT_FORMAT_DEFINED))
    setup_the_count_output_format(format,count,unit);
   else
    {format1 = *format;
     setup_the_count_output_format(&format1,count,unit);
     if ((format1.roi_gt_percent != format->roi_gt_percent) ||
         (format1.roi_lt_percent != format->roi_lt_percent) ||
         (format1.gt_percent != format->gt_percent) ||
         (format1.lt_percent != format->lt_percent) ||
         (format1.voxel_size != format->voxel_size) ||
         (format1.xpixel_size != format->xpixel_size) ||
         (format1.ypixel_size != format->ypixel_size) ||
         (format1.status & OUT_FORMAT_COUNT_OPTIONS) !=
         (format->status & OUT_FORMAT_COUNT_OPTIONS))
        delete_the_count_output(count);
     *format = format1;
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
copy_count_format_only - ???
------------------------------------------------------------------------*/

int
copy_count_format_only(dst,src,option)
 struct count_analysis_rec *dst,*src;
 int option;
{
 int err;

 if (src->num_groups == 0) 
    {if (dst->num_groups > 0) 
        {free_analysis_group_recs(dst->groups,dst->num_groups);
         c_free(dst->groups);
         dst->num_groups = 0;
         dst->groups = NULL;
        }
    }
   else if ((err = cp_text_output_analysis_group_recs(
            &(dst->groups),&(dst->num_groups),
            src->groups,src->num_groups,option)) != NO_ERROR)
    return err;
 if (dst->num_groups == 0)
    dst->status |= TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;
   else dst->status &= ~TEXT_OUTPUT_PIXEL_COUNT_ALL_ANALYSIS;

 dst->format.page_num_rows = src->format.page_num_rows;
 dst->format.page_row_size = src->format.page_row_size;
 dst->format.num_field_spaces = src->format.num_field_spaces;
 dst->format.num_collect_spaces = src->format.num_collect_spaces;

 return NO_ERROR;
}
