/****************************************************************************
d_interface.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: d_interface.c,v 1.12 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <X11/X.h>
#include <X11/Xlib.h>

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/cms.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/font.h>
#include <xview/icon.h>
#include <xview/cursor.h>
#include <xview/wmgr.h>

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)



struct win_xy_rec
   {
    struct image_display_window *win;
    int x,y;
   };



/* Funtions defined in this file */
char *win_get_frame_label(struct image_display_window *win);
int win_set_frame_label(struct image_display_window *win);
int set_frame_rel_posi(Frame frame, Frame frame1, int direction);
int dwin_position_window(struct display_win_rec *win, Frame setup_fr_win,
    int direction);
int position_partner_wins(struct image_display_window *win,
    Frame *setup_fr_frame, int *direction);
int make_partner_wins_adjacent(struct image_display_window *win,
    Frame setup_fr_win);
int win_show_window(struct image_display_window *win);
int win_show_multiple_windows(struct image_display_window *win);
int win_show_partner_windows(struct image_display_window *win);
int win_show_partner_windows_proc(struct image_display_window *win, int which);
int win_show_stack_windows(struct image_display_window *win);
int win_show_file_windows(struct image_display_window *win);
int win_close_window(struct image_display_window *win);
int win_close_multiple_windows(struct image_display_window *win);
int win_close_partner_windows(struct image_display_window *win);
int win_close_stack_windows(struct image_display_window *win);
int win_close_file_windows(struct image_display_window *win);
int win_top(struct image_display_window *win);
int win_multiple_win_top(struct image_display_window *win);
int win_make_window_cur(struct image_display_window *win, char *wid);
int WinMoveWindow(struct image_display_window *win, long x, long y);
int WinMoveMultiWindow(struct image_display_window *win, long x, long y);
int WinMultiEchoMoveWindow(struct image_display_window *win, long x, long y);
int WinRelativeMoveListWindows(struct image_display_window *win,
    unsigned long select);
int win_multiple_set_frame_label(struct image_display_window *win);
int win_show_edited(struct image_display_window *win);
int set_win_busy(struct image_display_window *win);
int set_win_not_busy(struct image_display_window *win);
int dwin_screenxy_to_bufxy(struct display_win_rec *disp_win, long *x, long *y);
int dwin_get_coord_xy_from_event(struct display_win_rec *disp_win,
    Event *event, long *x, long *y);
int dwin_get_coord_xy_from_mouse_xy(struct display_win_rec *win,
    long *x, long *y);
int win_move_mouse_to(struct image_display_window *win, long x, long y);
int clear_label_area(struct image_display_window *win,
    struct int_rect_rec *area, int is_clear_label, int clear_status);
int win_action_label(struct image_display_window *win);
int win_draw_enabled_label(struct image_display_window *win,
    int *is_clear_label);
int win_show_pixel_value(struct image_display_window *win, Event *event,
    int x, int y);
int win_display_row_col(struct image_display_window *win,
    int x, int y, int must_draw, int is_clear_label);
int win_cursor_row_col(struct image_display_window *win);
int win_right_angle_dist(struct image_display_window *win,
    int x, int y, int is_clear_label);
int win_is_window_open(struct image_display_window *win);
int win_is_window_open_show(struct image_display_window *win);
int win_real_color_indices(struct image_display_window *win,
    unsigned long **real_color_indxs, unsigned long *num_real_color_indxs);



/*------------------------------------------------------------------------
win_get_frame_label - ???
------------------------------------------------------------------------*/

char *
win_get_frame_label(win)
 struct image_display_window *win;
{
 char *extra_label;

 if (win->type2 & MANY_SLICES_WINDOWS)
    {if (win->status4 & WIN_POS_NEG_ACTIVATION)
        {PRT4(printf("win_get_frame_label = %x\n",
                   win->status4 & WIN_POS_NEG_ACTIVATION);)
         if ((win->status4 & WIN_POS_NEG_ACTIVATION) == WIN_POS_NEG_ACTIVATION)
            extra_label = "+&-VE";
           else if (win->status4 & WIN_NEG_ACTIVATION)
            extra_label = "-VE";
           else extra_label = "+VE";
        }
      else extra_label = NULL;
     return win_rec_get_frame_label(win->owner,extra_label);
    }
   else
    {return win_rec_get_histo_label1(win->owner,win->type2);}

}


/*------------------------------------------------------------------------
win_set_frame_label - ???
------------------------------------------------------------------------*/

int
win_set_frame_label(win)
 struct image_display_window *win;
{
 char *str;

 c_free(win->dwin->frame_label);
 win->dwin->frame_label = win_get_frame_label(win);

 if (win->dwin->frame_label == NULL)
    {str = "";
     xv_set(win->dwin->frame,XV_LABEL,str,0);}
   else
    {str = win->dwin->frame_label;
     xv_set(win->dwin->frame,XV_LABEL, win->dwin->frame_label,0);}
 return NO_ERROR;
}

/*****************
dwin_frame_not_overlapped(dwin)
 struct display_win_rec *dwin;
{
 Rect rr,rr1,screen_rr;
 int top_margin,col_width,lcv,err,indx;
 struct win_rec *win;
 Frame frame;

 win = dwin->owner->owner;
 if (win->root->total_wins == 0)
    {frame = dwin->ancestor;
     top_margin = (int) xv_get(frame,XV_TOP_MARGIN);
     col_width = (int) xv_get(frame,WIN_COLUMN_WIDTH);
     get_win_absolute_area(frame,&rr);
     get_win_absolute_area(win->frame,&rr1);
     rr1.r_left = rr.r_left + col_width;
     rr1.r_top = rr.r_top + top_margin + 5;
     set_win_absolute_area(win->frame,&rr1);
     return NO_ERROR;
    }
 for (lcv = win->root->total_wins;lcv > 0; )
    {lcv--;
     if (win_is_window_open(win->root->wins[lcv]->image_display))
        return win->root->wins[lcv]->image_display;
}
*************************/


/*------------------------------------------------------------------------
set_frame_rel_posi - ???
------------------------------------------------------------------------*/

int
set_frame_rel_posi(frame,frame1,direction)
 Frame frame,frame1;
 int direction;
{
 int x,y,lcv,dir,flag;
 Rect rr,rr1,*rr2;

 TRACE(printf("set_frame_rel_posi frame = %u frame1 = %u\n",frame,frame1))
 rr2 = (Rect *) xv_get(frame1,WIN_SCREEN_RECT);
 TRACE(printf("set_frame_rel_posi 1\n"))
 get_win_absolute_area(frame1,&rr1);
 TRACE(printf("set_frame_rel_posi 2\n"))
 TRACE(printf("direction = %d...screen",direction))TRACE(pr_Rect(rr2))
 TRACE(printf("rel_posi...win")) TRACE(pr_Rect(&rr1))
 if (direction == SCREEN_CENTER)
    {rr1.r_left = (rr2->r_left + rr2->r_width - rr1.r_width) / 2;
     rr1.r_top = (rr2->r_top + rr2->r_height - rr1.r_height) / 2;}
   else if (direction == SCREEN_CENTER_AT_BR)
    {
     rr1.r_left = (rr2->r_left + rr2->r_width) / 2 - rr1.r_width;
     rr1.r_top = (rr2->r_top + rr2->r_height) / 2 - rr1.r_height;
    }
   else if (direction == SCREEN_ORIGIN_AT_TL)
    {rr1.r_left = rr2->r_left;
     rr1.r_top = rr2->r_top;}
   else
    {get_win_absolute_area(frame,&rr);
     TRACE(printf("rr..l = %d t = %d  w = %d  h = %d\n",(int)rr.r_left,(int)rr.r_top,
        (int)rr.r_width,(int)rr.r_height))
     for (lcv = 0; lcv < 4; lcv++)
        {
         if (!direction)
            {rr1.r_left = rr.r_left + 10;
             rr1.r_top = rr.r_top + 15;
             dir = EAST;
            }
           else if (direction == NORTH)
            {rr1.r_left = rr.r_left;
             rr1.r_top = rr.r_top - rr1.r_height;
             dir = EAST;}
           else if (direction == NORTH_EAST)
            {rr1.r_left = rr.r_left + rr.r_width;
             rr1.r_top = rr.r_top - rr1.r_height;
             dir = EAST;}
           else if (direction == EAST)
            {TRACE(printf("EAST...\n"))
             rr1.r_left = rr.r_left + rr.r_width;
             rr1.r_top = rr.r_top;
             dir = SOUTH;}
           else if (direction == SOUTH_EAST)
            {rr1.r_left = rr.r_left + rr.r_width;
             rr1.r_top = rr.r_top + rr.r_height;
             dir = SOUTH;}
           else if (direction == SOUTH)
            {rr1.r_left = rr.r_left;
             rr1.r_top = rr.r_top + rr.r_height;
             dir = WEST;}
           else if (direction == SOUTH_WEST)
            {TRACE(printf("SOUTH_WEST...\n"))
             rr1.r_left = rr.r_left - rr1.r_width;
             rr1.r_top = rr.r_top + rr.r_height;
             dir = WEST;}
           else if (direction == WEST)
              {rr1.r_left = rr.r_left - rr1.r_width;
               rr1.r_top = rr.r_top;
               dir = NORTH;}
             else if (direction == NORTH_WEST)
              {rr1.r_left = rr.r_left - rr1.r_width;
               rr1.r_top = rr.r_top - rr1.r_height;
               dir = NORTH;}
        TRACE(printf("%d) rr1..l = %d t = %d  w = %d  h = %d\n",
              lcv,(int)rr1.r_left,(int)rr1.r_top,
              (int)rr1.r_width,(int)rr1.r_height))
         flag = 0;
         x = rr1.r_left + rr1.r_width;
         if (x < (rr2->r_left + 5)) flag |= 1;
           else if (x > (rr2->r_left + rr2->r_width - 5)) flag |= 2;
         y = rr1.r_top + rr1.r_height;
         if (y < (rr2->r_top + 5)) flag |= 4;
           else if (y > (rr2->r_top + rr2->r_height - 5)) flag |= 4;
         if (!flag) break;
         if ((flag == 1) && (direction == WEST)) direction = SOUTH;
           else if ((flag == 5) && (direction == WEST)) direction = NORTH;
           else direction = dir;
        }
     if (flag)
        {rr1.r_left = rr.r_left + 10;
         rr1.r_top = rr.r_top + 15;
         x = rr1.r_left + rr1.r_width;
         if (x < (rr2->r_left + 5)) rr1.r_left = rr2->r_left;
           else if (x > (rr2->r_left + rr2->r_width - 5)) 
           rr1.r_left = rr2->r_left + rr2->r_width - rr1.r_width;
         y = rr1.r_top + rr1.r_height;
        if (y < (rr2->r_top + 5)) rr1.r_top = rr2->r_top;
          else if (y > (rr2->r_top + rr2->r_height - 5)) 
           rr1.r_top = rr2->r_top + rr2->r_height - rr1.r_height;
        }
      TRACE(printf("rr1 = "))TRACE(pr_Rect(&rr1))
     }
 TRACE(printf("set_frame_rel_posi 6\n"))
 set_win_absolute_area(frame1,&rr1);
 TRACE(printf("set_frame_rel_posi end\n"))
 return direction;
}


/*------------------------------------------------------------------------
dwin_position_window - ???
------------------------------------------------------------------------*/

int
dwin_position_window(win,setup_fr_win,direction)
 struct display_win_rec *win;
 Frame setup_fr_win;
 int direction;
{
 struct image_display_window *last_win;
 Frame frame;
 int lcv;

 if (setup_fr_win != 0) frame = setup_fr_win;
   else
    {frame = 0;
     if (win->owner->num_display_wins > 1)
        {
         for (lcv = (int) win->owner->num_display_wins - 1; lcv >= 0;
                          lcv--)
            if (win->owner->dwins[lcv]->status2 & MASTER_WINDOW)
               {frame = win->owner->dwins[lcv]->frame;
                break;}
        }
    }
 if (frame == 0)
    if ((last_win = win_rec_get_last_open_window1
        (win->owner->owner,win->owner->type2)) != NULL) 
       {TRACE(printf("last open window...\n"))
        frame = last_win->dwin->frame;
       }
      else
       {TRACE(printf("SCREEN_ORIGIN_AT_TL...\n"))
        if (!(win->owner->type2 & DISPLAY_WINDOW_3D)) direction = SCREEN_ORIGIN_AT_TL;
        frame = win->ancestor;}
 return set_frame_rel_posi(frame,win->frame,direction);
}


/*------------------------------------------------------------------------
position_partner_wins - ???
------------------------------------------------------------------------*/

int
position_partner_wins(win,setup_fr_frame,direction)
 struct image_display_window *win;
 Frame *setup_fr_frame;
 int *direction;
{
 int dir;

 TRACE(printf("position_partner_wins..win->dwin = %u.*setup_fr_win = %u  dire = %d\n",win->dwin,*setup_fr_frame,*direction))
 dir = dwin_position_window(win->dwin,*setup_fr_frame,*direction);
 if ((*direction == EAST) && (dir == SOUTH)) *direction = WEST;
   else if ((*direction == WEST) && (dir == SOUTH)) *direction = EAST;
   else if ((*direction == EAST) && (dir == NORTH)) *direction = WEST;
   else if ((*direction == WEST) && (dir == NORTH)) *direction = EAST;

 *setup_fr_frame = win->dwin->frame;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
make_partner_wins_adjacent - ???
------------------------------------------------------------------------*/

int
make_partner_wins_adjacent(win,setup_fr_win)
 struct image_display_window *win;
 Frame setup_fr_win;
{
 struct list_rec *cur,*next,*head;
 struct image_display_window *first,*ptr;

 if ((head = head_list(&(win->partner))) == NULL) return NO_ERROR;
 if (setup_fr_win == 0)
    if ((first = head_item(&(win->partner),0)) != NULL)
       setup_fr_win = first->dwins[0]->frame;
 cur = head;
 first = cur->item;
 make_2_wins_top_down(first->dwins[0]->frame,setup_fr_win,0);
 next = cur->next;
 while ((next != cur) && (next != NULL))
    {ptr = next->item;
     if (ptr->dwins[0]->frame != setup_fr_win)
        {
         make_2_wins_adjacent(ptr->dwins[0]->frame,first->dwins[0]->frame,1);}
     first = ptr;
     next = next->next;
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_show_window - ???
------------------------------------------------------------------------*/

int
win_show_window(win)
 struct image_display_window *win;
{
 if ((win != NULL) && (win->dwin != NULL) && (win->dwin->frame != 0))
    {
     open_close_frame_and_subframes(win->dwin->frame,1);
     show_hide_frame_and_subframes(win->dwin->frame,1);
     wmgr_top(win->dwin->frame);
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_show_multiple_windows - ???
------------------------------------------------------------------------*/

int
win_show_multiple_windows(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_multiple_wins(win,win_show_window,NULL,
					  0,0,0,0);
}


/*------------------------------------------------------------------------
win_show_partner_windows - ???
------------------------------------------------------------------------*/

int
win_show_partner_windows(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_partner_wins(win,win_show_multiple_windows,0,0);
}



/*------------------------------------------------------------------------
win_show_partner_windows_proc - ???
------------------------------------------------------------------------*/

int
win_show_partner_windows_proc(win,which)
     struct image_display_window *win;
     int which;
{
  PRT(printf("win_show_partner_windows_proc...\n"));
  (void) notify_set_itimer_func((Notify_client) win,
				NOTIFY_FUNC_NULL,ITIMER_REAL,
				(struct itimerval *) 0,(struct itimerval *) 0);
  return win_show_partner_windows(win);
}


/*------------------------------------------------------------------------
win_show_stack_windows - ???
------------------------------------------------------------------------*/

int
win_show_stack_windows(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if (win->type2 & DISPLAY_WINDOW_3D)
    {if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
	return CANCEL;
     run_next_view_proc(img->cur_slice->slice->view,open_view_win,
			0,0,0,0,0,0);
    }
 else
     WinRunProcInList(WIN_LIST,win,win_show_partner_windows,0,0,0,0,0,0);

 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_show_file_windows - ???
------------------------------------------------------------------------*/

int
win_show_file_windows(win)
 struct image_display_window *win;
{
 return win_run_proc_to_all_file_wins(win,win_show_multiple_windows,3,0,0,0);
}


/*------------------------------------------------------------------------
win_close_window - ???
------------------------------------------------------------------------*/

int
win_close_window(win)
 struct image_display_window *win;
{
 if ((win != NULL) && (win->dwin != NULL) && (win->dwin->frame != 0))
    open_close_frame_and_subframes(win->dwin->frame,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_close_multiple_windows - ???
------------------------------------------------------------------------*/

int
win_close_multiple_windows(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_multiple_wins(win,win_close_window,NULL,
					  0,0,0,0);
}


/*------------------------------------------------------------------------
win_close_partner_windows - ???
------------------------------------------------------------------------*/

int
win_close_partner_windows(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_partner_wins(win,win_close_multiple_windows,0,0);
}


/*------------------------------------------------------------------------
win_close_stack_windows - ???
------------------------------------------------------------------------*/

int
win_close_stack_windows(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if (win->type2 & DISPLAY_WINDOW_3D)
    {if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
     run_next_view_proc(img->cur_slice->slice->view,close_view_win,
			0,0,0,0,0,0);
    }
 else
     WinRunProcInList(WIN_LIST,win,win_close_multiple_windows,0,0,0,0,0,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_close_file_windows - ???
------------------------------------------------------------------------*/

int
win_close_file_windows(win)
 struct image_display_window *win;
{
 return win_run_proc_to_all_file_wins(win,win_close_window,3,0,0,0);
}


/*------------------------------------------------------------------------
win_top - ???
------------------------------------------------------------------------*/

int
win_top(win)
 struct image_display_window *win;
{
 win_show_window(win);
 top_frame_and_subframes(win->dwin->frame);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_multiple_win_top - ???
------------------------------------------------------------------------*/

int
win_multiple_win_top(win)
 struct image_display_window *win;
{
 win_execute_proc_to_multiple_wins(win,win_top,0,0,0,0,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_make_window_cur - ???
------------------------------------------------------------------------*/

int
win_make_window_cur(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct win_rec *rwin;
 unsigned long start_indx;
 struct input_file_rec *file;
 struct img_buf_rec *img;
 struct image_display_window *win1;
 char *str;
 int err,is_file;

 PRT1(printf("win_make_window_cur...wid = %s\n",wid))
 str = NULL;
 err = CANCEL;
 if ((wid != NULL) && ((err = cp_str(&str,wid)) == NO_ERROR))
    {is_file = 1;
     if ((err = find_sub_str(str,":",&start_indx)) == NO_ERROR)
        if (str[start_indx + 1] == '>') is_file = 0;
     if (is_file) 
        {err = CANCEL;
         if (((img = win_rec_cur_img_buf(win->owner)) != NULL) &&
             ((file = find_file(img->file,str,NULL)) != NULL) &&
             ((win1 = find_file_first_window(file,NULL,0))))
            err = NO_ERROR;
        }
    }
 if (err == NO_ERROR)
   {
    if (!is_file)
       {str[start_indx + 1] = '\0';
        PRT1(printf("win_make_window_cur start_indx = %d str = %s\n",
            start_indx,str))
        if ((rwin = get_win_rec_by_wid_str(win->owner,str)) != NULL)
           {if (rwin->image_display != NULL)
               win_multiple_win_top(rwin->image_display);
            if (rwin->histogram != NULL)
               win_multiple_win_top(rwin->histogram);}
       }
      else win_run_proc_to_all_file_wins(win1,win_multiple_win_top,1,0,0,0);
   }
 c_free(str);
 return err;
}


/*------------------------------------------------------------------------
WinMoveWindow - ???
------------------------------------------------------------------------*/

int
WinMoveWindow(win,x,y)
 struct image_display_window *win;
 long x,y;
{
 Rect rr,*rr1;

 PRT2(printf("WinMoveWindow wid = %s x = %d y = %d\n",win->owner->wid,x,y))
 if (((x == 0) && (y == 0)) || (win->dwin == NULL)) return NO_ERROR;
 if (win->dwin->status2 & MOVE_WINDOW)
    {PRT2(printf("WinMoveWindow....MOVE_WINDOW\n"))
     frame_get_rect(win->dwin->frame,&(win->dwin->win_rect));
     win->dwin->status2 &= ~MOVE_WINDOW;
    }

 PRT2(printf("in l = %d t = %d w = %d h = %d\n",
      win->dwin->win_rect.r_left,win->dwin->win_rect.r_top,
      win->dwin->win_rect.r_width,win->dwin->win_rect.r_height);)

 win->dwin->win_rect.r_left += x;
 win->dwin->win_rect.r_top += y;
 win->dwin->status2 |= WINDOW_WIN_RECT_VALID;
 PRT2(printf("WinMoveWindow l = %d t = %d w = %d h = %d\n",
      win->dwin->win_rect.r_left,win->dwin->win_rect.r_top,
      win->dwin->win_rect.r_width,win->dwin->win_rect.r_height);)
 rr = win->dwin->win_rect;
 rr.r_left -= 5;
 rr.r_top -= 26;
 frame_set_rect(win->dwin->frame,&rr);
 rr1 = (Rect *) xv_get(win->dwin->frame,XV_RECT);
 PRT2(printf("WinMoveWindow rr1 l = %d t = %d w = %d h = %d\n",
      rr1->r_left,rr1->r_top,rr1->r_width,rr1->r_height);)
 return NO_ERROR;
}


/*------------------------------------------------------------------------
WinMoveMultiWindow - ???
------------------------------------------------------------------------*/

int
WinMoveMultiWindow(win,x,y)
 struct image_display_window *win;
 long x,y;
{
 return win_execute_proc_to_multiple_wins(win,WinMoveWindow,x,y,0,0,0);
}


/*------------------------------------------------------------------------
WinMultiEchoMoveWindow - ???
------------------------------------------------------------------------*/

int
WinMultiEchoMoveWindow(win,x,y)
 struct image_display_window *win;
 long x,y;
{
 return WinMultiEchoRunProc(win,WinMoveMultiWindow,x,y);
}


/*------------------------------------------------------------------------
WinRelativeMoveListWindows - ???
------------------------------------------------------------------------*/

int
WinRelativeMoveListWindows(win,select)
 struct image_display_window *win;
 unsigned long select;
{
 Rect rr;
 long x,y;
 int err;

 if (win->dwin->status2 & WINDOW_WIN_RECT_VALID)
    {frame_get_rect(win->dwin->frame,&rr);
     x = rr.r_left - win->dwin->win_rect.r_left;
     y = rr.r_top - win->dwin->win_rect.r_top;
     PRT2(printf("WinRelativeMoveListWindows l = %d t = %d w = %d h = %d\n",
      win->dwin->win_rect.r_left,win->dwin->win_rect.r_top,
      win->dwin->win_rect.r_width,win->dwin->win_rect.r_height);)
     PRT2(printf("rr l = %d t = %d w = %d h = %d\n",
      rr.r_left,rr.r_top,rr.r_width,rr.r_height);)
     win->dwin->status2 &= ~MOVE_WINDOW;
     WinMultiEchoMoveWindow(win,x,y);
     err = WinRunProcInList(select | WIN_DO_NOT_PROCESS_CUR_WIN,
                  win,WinMultiEchoMoveWindow,x,y,0,0,0,0);
/*
     win->dwin->win_rect = rr;
*/
     return err;
    }
 return NO_ERROR;
}

/*******************
check_multiple_frame_sizes(win)
 struct image_display_window *win;
{
 return win_execute_proc_to_multiple_wins(win,check_frame_size);
}

check_frame_size_in_list_proc(win,which)
 struct image_display_window *win;
 int which;
{
 (void) notify_set_itimer_func(win,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 return WinRunProcInList(WIN_LIST,win,check_multiple_frame_sizes);
}
*********************/


/*------------------------------------------------------------------------
win_multiple_set_frame_label - ???
------------------------------------------------------------------------*/

int
win_multiple_set_frame_label(win)
 struct image_display_window *win;
{
 win_execute_proc_to_multiple_wins(win,win_set_frame_label,NULL,0,0,0,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_show_edited - ???
------------------------------------------------------------------------*/

int
win_show_edited(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NO_ERROR;
 win_multiple_set_frame_label(win);
 win->control.sroi.sroi_win->slice_roi.status |= SLICE_ROI_SHOW_EDITED;
 return NO_ERROR;
}


/*------------------------------------------------------------------------
set_win_busy - ???
------------------------------------------------------------------------*/

int
set_win_busy(win)
 struct image_display_window *win;
{
 if ((win->dwin != NULL) && (win->dwin->frame != 0))
    xv_set(win->dwin->frame,FRAME_BUSY,TRUE,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
set_win_not_busy - ???
------------------------------------------------------------------------*/

int
set_win_not_busy(win)
 struct image_display_window *win;
{
 if ((win->dwin != NULL) && (win->dwin->frame != 0))
    xv_set(win->dwin->frame,FRAME_BUSY,FALSE,0);
 return NO_ERROR;
}



/*------------------------------------------------------------------------
dwin_screenxy_to_bufxy - ???
------------------------------------------------------------------------*/

int
dwin_screenxy_to_bufxy( disp_win, x, y )
     struct display_win_rec *disp_win;
     long *x, *y;
{
  unsigned long dimx = 0, dimy = 0;
  long x1 = 0, y1 = 0;
  int err = 0;

  PRT8(printf("dwin_screenxy_to_bufxy 1\n"));
  if ((err = WinColorDataDims( disp_win->owner, &dimx, &dimy, NULL ))
      != NO_ERROR)
    return err;
  PRT8(printf("dwin_screenxy_to_bufxy x = %d y = %d dimx = %d dimy = %d\n",
	      *x,*y,
	      disp_win->screen._2d.dimx,
	      disp_win->screen._2d.dimy));

  if ((*x < 0) || (*x >= (long) disp_win->screen._2d.dimx) ||
      (*y < 0) || (*y >= (long) disp_win->screen._2d.dimy))
    return CANCEL;

  x1 = (long) screenx_to_bufx( &(disp_win->screen), *x, dimx );
  y1 = (long) screeny_to_bufy( &(disp_win->screen), *y, dimy );
  *x = x1;
  *y = y1;

  return NO_ERROR;
}



/*------------------------------------------------------------------------
dwin_get_coord_xy_from_event - ???
------------------------------------------------------------------------*/

int
dwin_get_coord_xy_from_event( disp_win, event, x, y )
     struct display_win_rec *disp_win;
     Event *event;
     long *x, *y;
{
  *x = (long) event_x(event);
  *y = (long) event_y(event);
  return dwin_screenxy_to_bufxy( disp_win, x, y );
}



/*------------------------------------------------------------------------
dwin_get_coord_xy_from_mouse_xy - ???
------------------------------------------------------------------------*/

int
dwin_get_coord_xy_from_mouse_xy(win,x,y)
 struct display_win_rec *win;
 long *x,*y;
{
 unsigned long dimx,dimy;
 Rect *rr;
 int err,left,top;

 if ((err = get_xwin_valid_mouse_xy(win->frame,x,y)) == NO_ERROR)
    {if ((*x < 0) || (*x >= (long) win->screen._2d.dimx) ||
         (*y < 0) || (*y >= (long) win->screen._2d.dimy))
        return CANCEL;
     if ((err = WinColorDataDims(win->owner,&dimx,&dimy,NULL)) != NO_ERROR)
        return err;
     rr = (Rect *) xv_get(win->frame_canvas.canvas,XV_RECT);
     left = (int) xv_get(win->frame_canvas.canvas,XV_X);
     top = (int) xv_get(win->frame_canvas.canvas,XV_Y);
     PRT5(printf("get_coord rect x = %d y = %d l = %d t = %d r = %d b = %d\n",
          *x,*y,left,top,left + rr->r_width - 1,
         top + rr->r_height - 1))

     if ((*x >= left) &&
         (*x < (left + rr->r_width)) &&
         (*y >= top) &&
         (*y < (top + rr->r_height)))
        {*x = *x - left;
         *y = *y - top;
         *x = (unsigned int) screenx_to_bufx(&(win->screen),*x,dimx);
         *y = (unsigned int) screeny_to_bufy(&(win->screen),*y,dimy);
         return NO_ERROR;}
     return CANCEL;}
    else
     {PRT6(printf("dwin_get_coord_xy_from_mouse_xy invalid\n"))
     }
 return err;
}


/*------------------------------------------------------------------------
win_move_mouse_to - ???
------------------------------------------------------------------------*/

int
win_move_mouse_to(win,x,y)
 struct image_display_window *win;
 long x,y;
{
 int err;
 Rect rr1;
 long x1,y1;

 if (!(is_pt_in_int_region_rect(&(win->dwin->screen.dimension),x,y)))
    {
     pt_as_center_or_within_int_region_rect(
             &(win->dwin->screen.dimension),x,y);

     if ((err = WinColorCanvas(win)) != NO_ERROR) return err;
     dwin_set_scrollbar(win->dwin);
    }

 win_display_row_col(win,x,y,1,1);
/*
 x1 = bufx_to_screenx_center(&(win->dwin->screen),x);
 y1 = bufy_to_screeny_center(&(win->dwin->screen),y);
*/
 x1 = bufx_to_screenx(&(win->dwin->screen),x);
 y1 = bufy_to_screeny(&(win->dwin->screen),y);
 PRT7(printf("x1 = %d x = %d   y1 = %d y = %d\n",x1,x,y1,y))
 frame_get_rect(win->dwin->frame,&rr1);
 frame_get_rect(win->dwin->frame,&rr1);
 xv_set(canvas_paint_window(win->dwin->frame_canvas.canvas),WIN_MOUSE_XY,
           x1,y1,0);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
clear_label_area - ???
------------------------------------------------------------------------*/

int
clear_label_area(win,area,is_clear_label,clear_status)
 struct image_display_window *win;
 struct int_rect_rec *area;
 int is_clear_label;
 unsigned short clear_status;
{
 struct display_win_rec *win1;

 if ((win->dwin->display_status & clear_status) || is_clear_label)
    {if ((area->width == 0) || (area->height == 0))
        {win->dwin->display_status &= ~clear_status;
         return NO_ERROR;}
     win1 = win->dwin;
     if (win1->screen.im == NULL)
        {create_image(&(win1->screen.im),win1->dp.dp,win1->dp.screen_num,
           &(win1->screen._2d),win1->screen._2d.pixel_depth);
        }
     if (win1->screen.im != NULL)
        {
         user_write(win1->frame_canvas.canvas,area->left,
           area->top - area->height + 1,
           area->width,area->height+1,GXcopy,
              win1->screen.im,area->left,area->top - area->height + 1);
         win->dwin->display_status &= ~clear_status;
         return NO_ERROR;}
       else return ~NO_ERROR;
     }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_action_label - ???
------------------------------------------------------------------------*/

int
win_action_label(win)
 struct image_display_window *win;
{
 char str[30],*str1;
 int line_height;

 if (win->dwin->display_status & WIN_ACTION_LABEL_PAINTED)
    {clear_label_area(win,&(win->dwin->action_label_area),1,0);
     win->dwin->display_status &= WIN_ACTION_LABEL_PAINTED;}

 if (win->control.display_options & DISPLAY_ACTION_LABEL)
    {
     if (win->control.status & ACTION_LABEL_ON) 
        {if (win->control.status & ACTION_ON_ALL_SLICES)
            sprintf(str,ALL_SLICES_LABEL);
           else str[0] = '\0';
         if (win->control.status & ACTION_ON_ALL_ROIS)
            {if (str[0] != '\0') strcat(str,"/");
             strcat(str,ALL_ROIS_LABEL);}
           else if (win->control.status & ACTION_ON_CUR_ROI)
            {if (str[0] != '\0') strcat(str,"/");
             strcat(str,CUR_ROI_LABEL);}
         str1 = str;
         get_strs_dim(win->dwin->frame_canvas.canvas,&str1,1,
              &(win->dwin->action_label_area.width),
              &(win->dwin->action_label_area.height),&line_height);
         win->dwin->action_label_area.top = line_height;
         win->dwin->action_label_area.left = win->dwin->frame_canvas.width -
                     win->dwin->action_label_area.width;
         user_text(win->dwin->frame_canvas.canvas,NULL,1,
                win->dwin->action_label_area.left,
                win->dwin->action_label_area.top,GXcopy,NULL,str1);
         win->dwin->display_status |= WIN_ACTION_LABEL_PAINTED;
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_draw_enabled_label - ???
------------------------------------------------------------------------*/

int
win_draw_enabled_label(win,is_clear_label)
 struct image_display_window *win;
 int *is_clear_label;
{
 char *str,*str1,*str2,*str3,*label,*roi_inv,*adjust_center,tempch,*ptr,
      lock[60],lock1[60];
 int temp,line_height,is_locked;
 struct slice_roi_rec *slice_roi;
 struct img_buf_rec *img;
#define MAX_LABEL_LEN 50

 clear_label_area(win,&(win->dwin->label_area),
          *is_clear_label,WIN_ROI_LABEL_PAINTED);
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 TRACE(printf("win_draw_enabled_label do = %x s = %x p = %x\n",
 (unsigned int) win->control.display_options,(unsigned int) win->control.status,
         (unsigned int) win->control.pen_type))
 if (win->control.display_options & DISPLAY_ENABLED_LABEL)
    {
     if (win->control.which_cursor == CURSOR_DELETE_ROI)
        str1 = CURSOR_DELETE_ROI_MODE;
       else if (!(win->control.status & DRAW_ENABLED))
        {/* str1 = PEN_DISABLED;*/
         str1 = NULL;}
       else if (win->type2 & HISTOGRAM_1D_WINDOW_DISPLAY_ONLY)
        str1 = NO_EDITING;
       else
        switch (win->control.pen_type)
           {case DRAW_FREE_CLOSED :
               str1 = PEN_FREE_AND_CLOSED_LABEL;
               break;
            case DRAW_POLYGON :
               str1 = PEN_POLYGON_LABEL;
               break;
            case DRAW_LINE:
               str1 = PEN_LINE_LABEL;
               break;
            case DRAW_FREE:
               str1 = PEN_FREE_LABEL;
               break;
            case DRAW_POINT:
               str1 = PEN_POINT_MODE_LABEL;
               break;
            case DRAW_CIRCLE:
               str1 = PEN_CIRCLE_LABEL;
               break;
            case DRAW_ELLIPSE:
               str1 = PEN_ELLIPSE_LABEL;
               break;
            case DRAW_RECT:
               str1 = PEN_RECT_LABEL;
               break;
            default : str1 = NULL;
           }

     if (win_get_cur_slice_roi_rec(win,&slice_roi,&label) != NO_ERROR)
        return CANCEL;
     temp = get_strlen(label);
     if ((temp > MAX_LABEL_LEN) && (label != NULL))
        {tempch = label[MAX_LABEL_LEN];
         label[MAX_LABEL_LEN] = '\0';}
     if (win->status4 & WIN_HIDE_ROIS) roi_inv = ROI_INVISIBLE;
       else roi_inv = NULL;
     if (win->type2 & DISPLAY_WINDOW_3D)
        {
         if (!(img->cur_slice->slice->view->gplane.status & 
                    PLANE_ADJUST_TO_CENTER))
            adjust_center = "-Center:";
           else adjust_center = "";
         if (img->file->slice_info.status & _3D_ORIENTATION_KEY_ENABLED)
            str3 = "F11=Orient.:";
           else if (img->file->slice_info.status & _3D_ABS_FLIP_KEY_ENABLED)
            str3 = "F11=FlipAbs:";
           else str3 = "F11=FlipRel:";

         lock[0] = '\0';
         ptr = lock;
         if ((is_locked = is_3d_win_locked(win)) != 0) 
            {if (is_locked & 1) sprintf(lock,"Locked:");
               else if (is_locked & 8) sprintf(lock,"locked:");
             if (is_locked & 2)
                {sprintf(lock1,"%sCoreg:",ptr);
                 ptr = lock1;}
             if (is_locked & 0x00000010) 
                {if (ptr == lock1)
                    {sprintf(lock,"%sAdjust:",ptr);
                     ptr = lock;}
                   else
                    {sprintf(lock1,"%sAdjust:",ptr);
                     ptr = lock1;}
                }
             }
         concat_strs(&str,5,roi_inv,ptr,adjust_center,str3,label);
        }
       else if (label == NULL)
        {if (str1 == NULL) cp_str(&str,roi_inv);
           else concat_strs(&str,2,roi_inv,str1);
        }
       else 
        {if (str1 == NULL) concat_strs(&str,2,roi_inv,label);
           else concat_strs(&str,4,roi_inv,str1,"/",label);
        }
     if (win->control.which_cursor == CURSOR_MOVE_SUPERIMPOSE)
        {str2 = str;
         if (img->_2d_fusion.status & FUSION_SHOW_ONLY_SRC)
            str1 = "Dst+Src";
           else if (img->status4 & IMAGE_2D_SUPERIMPOSED_READY)
            str1 = "FUSION";
           else str1 = "Dst";
         concat_strs(&str,3,str1,":",str2);
         c_free(str2);
        }
     if (img->unit.status2 & UNIT_2D_IN_USE)
        {str2 = str;
         concat_strs(&str,2,"Resized+Trans:",str2);
         c_free(str2);
        }

     win->dwin->label_area.left = (int) xv_get(win->dwin->frame_canvas.canvas,
                 CANVAS_WIDTH);
     TrimLeadingStrCh(str,' ');
     get_strs_dim(win->dwin->frame_canvas.canvas,&str,1,
              &(win->dwin->label_area.width),
              &(win->dwin->label_area.height),&line_height);
     win->dwin->label_area.width += 5;
     win->dwin->label_area.left = win->dwin->label_area.left - 
                        win->dwin->label_area.width;
/*
     if (win->control.display_options & DISPLAY_ROW_COL_LABEL)
        {if (win->dwin->label_area.left <
                 (win->dwin->row_col_area.left + win->dwin->row_col_area.width))
            {win->dwin->label_area.left =
              win->dwin->row_col_area.left + win->dwin->row_col_area.width + 10;}
        }
*/
     win->dwin->label_area.top = (int) win->dwin->frame_canvas.height - 4;

     if (str != NULL)
        {
         user_text(win->dwin->frame_canvas.canvas,NULL,1,
                win->dwin->label_area.left,
                win->dwin->label_area.top,GXcopy,NULL,str);
         win->dwin->display_status |= WIN_ROI_LABEL_PAINTED;}
     c_free(str);
     if ((temp > MAX_LABEL_LEN) && (label != NULL)) label[MAX_LABEL_LEN] = tempch;
    }
 return NO_ERROR;
}



/*------------------------------------------------------------------------
win_show_pixel_value - ???
------------------------------------------------------------------------*/

int
win_show_pixel_value(win,event,x,y)
     struct image_display_window *win;
     Event *event;
     int x,y;
{
  double value1,value2;
  unsigned long value3;
  char str[70],*str1,*str2;
  struct strs_rec *ptr;
  struct buf_2d_rec *_2d;
  struct view_rec *view;
  struct img_buf_rec *img;
  float nx,nz,ny;
  struct slice_3d_rec *sl;
  int err;

  if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    return CANCEL;
  if ((err = WinGetColorDataVal(win,(unsigned long) x,(unsigned long) y,
				&value2)) != NO_ERROR) 
    return err;
  if ((err = setup_strs_rec(&ptr,0,0)) != NO_ERROR)
    return err;
  PRT3(printf("win_show_pixel_value...\n"));
  _2d = &(img->_2d);
  value1 = _2d->GetVal(_2d,y,x);
  sprintf(str,"[%-d/%-d",y,x);
  concat_strs(&str1,3,"Row/Col = ",str,"]");
  if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
    c_free(str1);

  if (win->type2 & DISPLAY_WINDOW_3D)
  {
    view = img->cur_slice->slice->view;
    PlaneXYZToLocalXYZ(&(view->gplane),(float) x,(float) y,.0,
		       &nx,&ny,&nz,1);
    sprintf(str,"[%-.0f/%-.0f/%-.0f",nx,ny,nz);
    concat_strs(&str1,3,"X/Y/Z = ",str,"]");
    if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
      c_free(str1);

    sl = plane_data_slice_info(view,x,y);
    if ((sl != NULL) && (sl->s1_info != NULL))
    {
      if (sl->s2_info != NULL)
	sprintf(str,"Actual Slice# = %-ld&%-ld",
		sl->s1_info->num,sl->s2_info->num);
      else
	sprintf(str,"Actual Slice# = %-ld",sl->s1_info->num);
      cp_str(&str1,str);
      if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
	c_free(str1);
    }
  }

  sprintf(str,"%-.4f",value1);
  concat_strs(&str1,2,"Pixel Value = ",str);
  if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
    c_free(str1);

  sprintf(str,"%.0f",value2);
  concat_strs(&str1,2,"Color Index = ",str);
  if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
    c_free(str1);

  value3 = win_actual_color_indx(win,(unsigned long) rint(value2));
  sprintf(str,"%ld",value3);
  concat_strs(&str1,2,"Actual Color = ",str);
  if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
    c_free(str1);

  if (win->type2 & DISPLAY_WINDOW_3D)
    str2 = plane_data_pixel_type(view,x,y);
  else
    str2 = win_rec_get_pixel_type_label(win->owner, win->type2,x,y);
  if (str2 != NULL)
  {
    concat_strs(&str1,2,"PIXEL TYPE = ",str2);
    if ((err = add_str_ptr_to_strs_rec(ptr,str1)) != NO_ERROR)
      c_free(str1);
    c_free(str2);
  }

  return ShowMenuStrsProc(canvas_paint_window(win->dwin->frame_canvas.canvas),
			  event,"PIXEL INFO",ptr,USER_MENU_FREE_STRS_AND_PTR,
			  NULL,NULL,0,0,0);
}



/*------------------------------------------------------------------------
win_display_row_col - ???
------------------------------------------------------------------------*/

int
win_display_row_col(win,x,y,must_draw,is_clear_label)
 struct image_display_window *win;
 int x,y,must_draw,is_clear_label;
{
 char str[150],str2[150],*str1[1];
 struct img_buf_rec *img;
 struct view_rec *view;
 float newx,newy,newz;
 int is_label_computed,line_height;
 struct slice_3d_rec *sl;

 win->control.last_cursorx = x;
 win->control.last_cursory = y;

 clear_label_area(win,&(win->dwin->row_col_area),
          is_clear_label,WIN_ROW_COL_PAINTED);

 if (win->control.display_options & DISPLAY_ROW_COL_LABEL)
    {
     if (must_draw)
        {is_label_computed = 0;
         if ((win->type2 & DISPLAY_WINDOW_3D) &&
             ((img = win_rec_cur_img_buf(win->owner)) != NULL) &&
             (img->cur_slice->slice != NULL) &&
             (img->cur_slice->slice->view != NULL))
            {view = img->cur_slice->slice->view;
 
             if (PlaneXYZToLocalXYZ(&(view->gplane),
                    (float) x,(float) y,.0,&newx,&newy,&newz,1) == NO_ERROR)
                {is_label_computed = 1;
                 sl = plane_data_slice_info(view,x,y);
                 sprintf(str,"R%-dC%-d/",y,x);
                 PRT(printf("str = %s view = %u = %d\n",str,view,sizeof(*view));)
                 if (view_co_reg_xyz(view,newx,newy,newz,&newx,&newy,&newz) 
                             == NO_ERROR)
                    {
                     PRT(printf("dp_xyz_co_reg_wid = %u\n",view->dp_xyz_co_reg_wid);)
                     PRT(printf("dp_xyz_co_reg_wid = %s\n",view->dp_xyz_co_reg_wid);)
                     if (view->dp_xyz_co_reg_wid != NULL)
                        strcat(str,view->dp_xyz_co_reg_wid);
                     PRT(printf("str = %s\n",str);)
                     sprintf(str2,"X%-.0fY%-.0fZ%-.0f",newx,newy,newz);
                    }
                   else if ((sl != NULL) && (sl->s1_info != NULL))
                    {
                     if (sl->s2_info != NULL)
                        sprintf(str2,"X%-.0fY%-.0fZ%-.0f/S%-d&%-d",
                          newx,newy,newz,(unsigned int) sl->s1_info->num,
                             (unsigned int) sl->s2_info->num);
                       else
                        sprintf(str2,"X%-.0fY%-.0fZ%-.0f/S%-d",
                          newx,newy,newz,(unsigned int) sl->s1_info->num);
                    }
                   else
                     sprintf(str2,"X%-.0fY%-.0fZ%-.0f",newx,newy,newz);
                 strcat(str,str2);
                }
            }
         if (!is_label_computed) sprintf(str,"Y:%d/X:%d",y,x);

         win->dwin->row_col_area.left = 2;
         str1[0] = str;
         get_strs_dim(win->dwin->frame_canvas.canvas,str1,1,
              &(win->dwin->row_col_area.width),
              &(win->dwin->row_col_area.height),&line_height);
         win->dwin->row_col_area.width += 5;

         win->dwin->row_col_area.top = 	win->dwin->row_col_area.height - 1;
            /*(int) win->dwin->frame_canvas.height - 4;*/

/*
         if (win->control.display_options & DISPLAY_ENABLED_LABEL)
            {if (win->dwin->label_area.left <
                 (win->dwin->row_col_area.left + win->dwin->row_col_area.width))
                {is_clear_label = 1;
                 win_draw_enabled_label(win,&is_clear_label);}
            }
*/
         user_text(win->dwin->frame_canvas.canvas,NULL,1,
                      win->dwin->row_col_area.left,
                      win->dwin->row_col_area.top,GXcopy,NULL,str);

         win->dwin->display_status |= WIN_ROW_COL_PAINTED;
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_cursor_row_col - ???
------------------------------------------------------------------------*/

int
win_cursor_row_col(win)
 struct image_display_window *win;
{
 Rect *rr;

 rr = (Rect *) xv_get(win->dwin->frame,WIN_MOUSE_XY);
 win_display_row_col(win,(int) rr->r_left,(int) rr->r_top,1,1);
 return NO_ERROR;
}


/*------------------------------------------------------------------------
win_right_angle_dist - ???
------------------------------------------------------------------------*/

int
win_right_angle_dist(win,x,y,is_clear_label)
 struct image_display_window *win;
 int x,y,is_clear_label;
{
 char str[60],str2[60],*str1[1];
 double pix,dist;
 int err,line_height;
 long x0,y0,x1,y1;
 struct img_buf_rec *img;

 clear_label_area(win,&(win->dwin->right_angle_label_area),
          is_clear_label,WIN_RIGHT_ANGLE_LABEL_PAINTED);
 if (win->control.display_options & DISPLAY_ROW_COL_LABEL)
    {if ((err = GetCurveLast2LongPts(get_cur_curve(
       &(win->control.sroi.sroi_win->slice_roi)),&x0,&y0,&x1,&y1,
       win->control.sroi.localto))
            != NO_ERROR) return err;
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;

     pix = distance((float) x1,(float) y1,(float) x,(float) y);
     dist = pix * img->file->hdr.data_info.xpixel_size;
     sprintf(str,"%-8.2f",pix);
     TrimTrailingStrCh(str,' ');
     sprintf(str2," PIX | %-8.2f",dist);
     TrimTrailingStrCh(str2,' ');
     strcat(str2," MM");
     strcat(str,str2);

     win->dwin->right_angle_label_area.left = 2;
     str1[0] = str;
     get_strs_dim(win->dwin->frame_canvas.canvas,str1,1,
              &(win->dwin->right_angle_label_area.width),
              &(win->dwin->right_angle_label_area.height),&line_height);
     win->dwin->right_angle_label_area.width += 5;

     win->dwin->right_angle_label_area.top = (int) win->dwin->frame_canvas.height - 4;
/*
               win->dwin->right_angle_label_area.height;
*/
     win->dwin->right_angle_label_area.height += 3;
     user_text(win->dwin->frame_canvas.canvas,NULL,1,
                      win->dwin->right_angle_label_area.left,
                      win->dwin->right_angle_label_area.top,
                    GXcopy,NULL,str);

     win->dwin->display_status |= WIN_RIGHT_ANGLE_LABEL_PAINTED;
    }
 return NO_ERROR;
}



/*------------------------------------------------------------------------
win_is_window_open - ???
------------------------------------------------------------------------*/

int
win_is_window_open(win)
 struct image_display_window *win;
{

 if ((win != NULL) && (win->dwin->frame != 0) &&
     !((int) xv_get(win->dwin->frame,FRAME_CLOSED))) return 1;
   else return 0;
}


/*------------------------------------------------------------------------
win_is_window_open_show - ???
------------------------------------------------------------------------*/

int
win_is_window_open_show(win)
 struct image_display_window *win;
{

 if ((win != NULL) && (win->dwin->frame != 0) &&
     ((int) xv_get(win->dwin->frame,XV_SHOW)) &&
     !((int) xv_get(win->dwin->frame,FRAME_CLOSED))) return 1;
   else return 0;
}


/*------------------------------------------------------------------------
win_real_color_indices - ???
------------------------------------------------------------------------*/

int
win_real_color_indices(win,real_color_indxs,num_real_color_indxs)
 struct image_display_window *win;
 unsigned long **real_color_indxs,*num_real_color_indxs;
{
 unsigned long *temp_real_color_indxs,total,cnt;
 Cms cms;
 int err;

 cms = (Cms) xv_get(win->dwin->frame_canvas.canvas,WIN_CMS);
 temp_real_color_indxs = (unsigned long *) xv_get(cms,CMS_INDEX_TABLE);
 total = xv_get(cms,CMS_SIZE);

 *real_color_indxs = NULL;
 *num_real_color_indxs = 0;
 get_ptr_memory(real_color_indxs,num_real_color_indxs,total,
        (size_t) sizeof(unsigned long),&err);
 if (err == NO_ERROR)
    {for (cnt = 0; cnt < total; cnt++)
        (*real_color_indxs)[cnt] = temp_real_color_indxs[cnt];
     (*real_color_indxs)[0] = temp_real_color_indxs[
                    win->intensity->color.num_system_colors + 3];
    }
 return err;
}
