/****************************************************************************
dp_draw_list.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_draw_list.c,v 1.10 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)



#define CLEANUP_DP 0
#define GET_ALL_DP_PTR 2

struct draw_list_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame owner_frame;
    Frame frame;
    Panel panel;
    Panel_item linkto;
   };

struct all_draw_list_recs
   {
    int num_dps;
    struct draw_list_rec **dps;
   };


/* Functions defined in this file */
void init_draw_list_rec(struct draw_list_rec *dp);
void free_draw_list_rec(struct draw_list_rec *dp);
void init_all_draw_list_recs(struct all_draw_list_recs *all_dps);
void dp_draw_list_done_proc(Frame frame);
int win_is_draw_list_processed(struct image_display_window *win,
    struct list_rec *list);
void win_update_draw_list(struct image_display_window *win,
    struct image_display_window *linkto_win);
int win_add_draw_list(struct image_display_window *win,
    struct image_display_window *linkto_win, int is_update);
int win_drop_draw_list(struct image_display_window *win,
    struct image_display_window *linkto_win, int is_update);
int win_draw_link_with_wid(struct image_display_window *win, char *wid);
int win_delete_draw_link_with_wid(struct image_display_window *win, char *wid);
int WinListDropDrawList(struct image_display_window *win,
    struct image_display_window *linkfrom_win, int is_update, void *dummy3,
    void *dummy4, void *dummy5, void *dummy6, struct list_rec *cur_list);
int win_delete_draw_lists(struct image_display_window *win);
void draw_select_draw_link_items(struct draw_list_rec *dp);
int WinSetDrawLinkParams(struct image_display_window *win,
    struct image_display_window *regwin, unsigned long dummy1,
    unsigned long dummy2, unsigned long dummy3, unsigned long dummy4,
    unsigned long dummy5, struct list_rec *cur_list);
int WinSetDrawLinkCoRegParams(struct image_display_window *win);
int WinDrawListWids(struct image_display_window *win, struct strs_rec *wids,
    int is_recursive);
void draw_wids_proc(Panel_item item, Event *event);
void draw_wid_list_proc(Panel_item item, char *wid, caddr_t client_data,
    Panel_list_op op, Event *event);
void draw_more_commands_proc(Panel_item item, Event *event);
int setup_draw_list_rec(struct draw_list_rec *dp,
    struct image_display_window *win);
struct draw_list_rec *find_draw_list_rec(struct all_draw_list_recs *all_dps,
    struct image_display_window *win);
int enter_dp_draw_list(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_draw_list_rec - ???
-------------------------------------------------------------------------*/

void
init_draw_list_rec(dp)
 struct draw_list_rec *dp;
{
 dp->status = 0;
 dp->frame = 0;
 dp->win = NULL;
}


/*-------------------------------------------------------------------------
free_draw_list_rec - ???
-------------------------------------------------------------------------*/

void
free_draw_list_rec(dp)
 struct draw_list_rec *dp;
{
 struct all_draw_list_recs *all_dps;

 if (dp->frame != 0)
    {
     xv_destroy_safe(dp->frame);
    }
 all_dps = (struct all_draw_list_recs *) enter_dp_draw_list(NULL,
            GET_ALL_DP_PTR);
 c_free(dp);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
}


/*-------------------------------------------------------------------------
init_all_draw_list_recs - ???
-------------------------------------------------------------------------*/

void
init_all_draw_list_recs(all_dps)
 struct all_draw_list_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*-------------------------------------------------------------------------
dp_draw_list_done_proc - ???
-------------------------------------------------------------------------*/

void
dp_draw_list_done_proc(frame)
 Frame frame;
{
 struct draw_list_rec *dp;

 dp = (struct draw_list_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_draw_list_rec(dp);
}


/*-------------------------------------------------------------------------
win_is_draw_list_processed - ???
-------------------------------------------------------------------------*/

int
win_is_draw_list_processed(win,list)
 struct image_display_window *win;
 struct list_rec *list;
{
 struct image_display_window *linkto_win,*win1;
 struct slice_roi_win_rec *sroi_win;
 struct list_rec *next;

 if (win->draw_list.item == NULL) return 0;
 if ((linkto_win = (struct image_display_window *) list->item) != NULL)
    {sroi_win = linkto_win->control.sroi.sroi_win;
     if (sroi_win == win->control.sroi.sroi_win) return 1;
     next = &(win->draw_list);
     next = next->next;
     while (next != list)
        {win1 = (struct image_display_window *) next->item;
         if (win1->control.sroi.sroi_win == sroi_win) return 1;
         next = next->next;
        }
     PRT4(printf("win_is_draw_list_processed not processed yet\n"))
     return 0;
    }
   else return 0;
}


/*-------------------------------------------------------------------------
win_update_draw_list - ???
-------------------------------------------------------------------------*/

void
win_update_draw_list(win,linkto_win)
 struct image_display_window *win,*linkto_win;
{
 struct all_draw_list_recs *all_dps;
 struct draw_list_rec *dp;
 struct list_rec *list;
 char *wid;
 int is_sel;

 if (((all_dps = (struct all_draw_list_recs *) enter_dp_draw_list(NULL,
            GET_ALL_DP_PTR)) != NULL) &&
     ((dp = (struct draw_list_rec *) find_draw_list_rec(all_dps,win)) != NULL) &&
     ((wid = WinRecGetWid(linkto_win->owner,linkto_win->type2)) != NULL))
    {if ((list = find_item(&(win->draw_list),linkto_win,0)) == NULL)
        is_sel = 0;
       else is_sel = 1;
     select_list_str_item(wid,dp->linkto,is_sel);
    }
}


/*-------------------------------------------------------------------------
win_add_draw_list - ???
-------------------------------------------------------------------------*/

int
win_add_draw_list(win,linkto_win,is_update)
 struct image_display_window *win,*linkto_win;
 int is_update;
{
 struct list_rec *list;
 struct img_buf_rec *img,*img1;
 struct file_register_rec *co;
 int err;

 PRT(printf("\nwin_add_draw_list  win = %u linkto_win = %u draw_list.item = %u\n",
           win,linkto_win,win->draw_list.item))

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(linkto_win->owner)) == NULL))
    return CANCEL;
 if (img->file == img1->file) co = NULL;
   else if ((co = find_file_register_rec(img1->file,img->file,NULL,4)) == NULL)
    return CANCEL;

 PRT(printf("win->owner->wid = %s\n",win->owner->wid))
 if (co != NULL)
    {PRT(printf("reg.planetoxyz...\n"))
     PRT(pr_3d_matrix(&(co->co.reg.planetoxyz)))
     PRT(printf("reg.xyztoplane...\n"))
     PRT(pr_3d_matrix(&(co->co.reg.xyztoplane)))
     PRT(printf("reg.base...normal\n"))
     PRT(pr_vector_3d_rec(&(co->co.reg.base)))
     PRT(pr_vector_3d_rec(&(co->co.reg.normal)))}

 if (win->draw_list.item == NULL) list = NULL;
   else list = find_item(&(win->draw_list),linkto_win,0);
 if (list == NULL)
    {if (win->draw_list.item == NULL)
        list = &(win->draw_list);
       else if ((err = get_ptr(&list,NULL,1,sizeof(*list))) != NO_ERROR)
        return err;
       else
        setup_list_rec(list,NULL,NULL,NULL,NULL,NULL);
     list->item = (void *) linkto_win;
     list->item1 = (void *) co;

     if (list != &(win->draw_list))
        add_item_after_cur_list(&(win->draw_list),list);
     if (is_update) win_update_draw_list(win,linkto_win);
    }
 PRT(printf("win_add_draw_list &(win->draw_list) = %u list = %u draw_list.item = %u\n\n",
       &(win->draw_list),list,win->draw_list.item))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_drop_draw_list - ???
-------------------------------------------------------------------------*/

int
win_drop_draw_list(win,linkto_win,is_update)
 struct image_display_window *win,*linkto_win;
 int is_update;
{
 struct list_rec *list;

 PRT4(printf("win_drop_draw_list wid = %s  linkto_wid = %s is_update = %d\n",
         win->owner->wid,linkto_win->owner->wid,is_update))
 if ((win->draw_list.item != NULL) &&
     ((list = find_item(&(win->draw_list),linkto_win,0)) != NULL))
    {delete_item_from_list(list);

     list->item = NULL;
     if (list != &(win->draw_list))
        {c_free(list);
         PRT(printf("win_drop_draw_list c_free item = %u\n",list))}
     PRT4(printf("win_drop_draw_list c_free list = %u draw_list = %u\n",list,
                 &(win->draw_list)))
     if (is_update)
        win_update_draw_list(win,linkto_win);
     return NO_ERROR;
    }
 return CANCEL;
}


/*-------------------------------------------------------------------------
win_draw_link_with_wid - ???
-------------------------------------------------------------------------*/

int
win_draw_link_with_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct win_rec *rwin;
 struct image_display_window *win1;
 struct img_buf_rec *img,*img1;
 int err;

 err = CANCEL;
 if ((wid != NULL) &&
     ((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     ((win1 = rwin->image_display) != NULL) &&
     ((img = win_rec_cur_img_buf(win->owner)) != NULL) &&
     ((img1 = win_rec_cur_img_buf(win1->owner)) != NULL) &&
     ((err = UseCurrentImgRegParams(img,img1)) == NO_ERROR))
    {
     if ((err = win_add_draw_list(win,win1,0)) == NO_ERROR)
       if ((err = win_add_draw_list(win1,win,1)) != NO_ERROR)
          win_drop_draw_list(win,win1,1);}

 if (err != NO_ERROR) win_alarm(win->dwin->frame,2);
 return err;
}


/*-------------------------------------------------------------------------
win_delete_draw_link_with_wid - ???
-------------------------------------------------------------------------*/

int
win_delete_draw_link_with_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct win_rec *rwin;
 struct image_display_window *win1;
 int err;

 err = CANCEL;
 if ((wid != NULL) &&
     ((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     ((win1 = rwin->image_display) != NULL))
    {if ((win_drop_draw_list(win,win1,0) == NO_ERROR) ||
         (win_drop_draw_list(win1,win,1) == NO_ERROR))
        err = NO_ERROR;
    }

 if (err != NO_ERROR) win_alarm(win->dwin->frame,2);
 return err;
}


/*-------------------------------------------------------------------------
WinListDropDrawList - ???
-------------------------------------------------------------------------*/

int
WinListDropDrawList(win,linkfrom_win,is_update,
                        dummy3,dummy4,dummy5,dummy6,cur_list)
 struct image_display_window *win,*linkfrom_win;
 int is_update;
 void *dummy3,*dummy4,*dummy5,*dummy6;
 struct list_rec *cur_list;
{
 PRT4(printf("WinListDropDrawList win = %u  linkfrom_win = %u cur_list = %u\n",
         win,linkfrom_win,cur_list))
 delete_item_from_list(cur_list);
 cur_list->item = NULL;
 if (cur_list != &(linkfrom_win->draw_list))
    {c_free(cur_list);
     PRT(printf("WinListDropDrawList...c_free(cur_list\n"))}
 win_drop_draw_list(win,linkfrom_win,is_update);
 PRT4(printf("WinListDropDrawList end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_delete_draw_lists - ???
-------------------------------------------------------------------------*/

int
win_delete_draw_lists(win)
 struct image_display_window *win;
{
 PRT4(printf("win_delete_draw_lists...win = %u draw_list.item = %u\n",
         win,win->draw_list.item))
 if (win->draw_list.item != NULL)
    {WinRunProcInList(WIN_DRAW_LIST,win,
          WinListDropDrawList,win,1,0,0,0,0);
    }
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
draw_select_draw_link_items - ???
-------------------------------------------------------------------------*/

void
draw_select_draw_link_items(dp)
 struct draw_list_rec *dp;
{
 unsigned long lcv,num_rows;
 struct img_buf_rec *img;
 struct win_rec *rwin;
 struct list_rec *list;
 char *wid;

 if ((img = win_rec_cur_img_buf(dp->win->owner)) == NULL)
     return /*CANCEL*/;
 num_rows = (unsigned long) xv_get(dp->linkto,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rows; lcv++)
    {
     if (((wid = (char *) xv_get(dp->linkto,PANEL_LIST_STRING,lcv)) != NULL) &&
         ((rwin = get_win_rec_by_wid_str(img->win,wid)) != NULL) &&
         (rwin->image_display != NULL))
        {if ((list = find_item(&(dp->win->draw_list),rwin->image_display,0)) != NULL)
            xv_set(dp->linkto,PANEL_LIST_SELECT,lcv,1,0);
        }
    }
}


/*-------------------------------------------------------------------------
WinSetDrawLinkParams - ???
-------------------------------------------------------------------------*/

int
WinSetDrawLinkParams(win,regwin,dummy1,dummy2,dummy3,dummy4,dummy5,cur_list)
 struct image_display_window *win,*regwin;
 unsigned long dummy1,dummy2,dummy3,dummy4,dummy5;
 struct list_rec *cur_list;
{
 struct img_buf_rec *img,*img1;
 struct file_register_rec *fco;

 PRT3(printf("\nWinSetDrawLinkParams win wid = %s wid1 = %s\n",
     win->owner->wid,regwin->owner->wid))
 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(regwin->owner)) == NULL))
    return CANCEL;
 if ((fco = find_file_register_rec(img->file,img1->file,NULL,4)) != NULL)
    {PRT3(printf("WinSetDrawLinkParams fco->co.status = %x\n",
           (unsigned long) fco->co.status))
     cur_list->item1 = fco;
     PRT3(printf("WinSetDrawLinkParams fco .planetoxyz...\n"))
     PRT3(pr_3d_matrix(&(fco->co.reg.planetoxyz)))
     PRT3(printf(" .xyztoplane...\n"))
     PRT3(pr_3d_matrix(&(fco->co.reg.xyztoplane)))
     PRT3(printf("WinSetDrawLinkParams .coregxyztoregxyz...\n"))
     PRT3(pr_2d_matrix(&(fco->coregxyztoregxyz)))
    }
 PRT1(printf("WinSetDrawLinkParams\n\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinSetDrawLinkCoRegParams - ???
-------------------------------------------------------------------------*/

int
WinSetDrawLinkCoRegParams(win)
 struct image_display_window *win;
{
 PRT3(printf("\nWinSetDrawLinkCoRegParams...wid = %s\n",win->owner->wid))
 return WinRunProcInList(WIN_DRAW_LIST,win,WinSetDrawLinkParams,win,NULL,
             NULL,NULL,NULL,NULL);
}


/*-------------------------------------------------------------------------
WinDrawListWids - ???
-------------------------------------------------------------------------*/

int
WinDrawListWids(win,wids,is_recursive)
 struct image_display_window *win;
 struct strs_rec *wids;
 int is_recursive;
{
 int err;

 PRT2(printf("WinDrawListWids is_recursive = %d\n",is_recursive))
 if (FindStrInSortedStrsRec(wids,win->owner->wid,NULL) == NO_ERROR)
    return NO_ERROR;
   else if ((err = AddStrToSortedStrsRec(wids,win->owner->wid,0,0))
               != NO_ERROR)
    return CANCEL;
 if (is_recursive && (win->draw_list.item != NULL))
    err = WinRunProcInList(WIN_DRAW_LIST | WIN_DO_NOT_PROCESS_CUR_WIN,win,
                WinDrawListWids,wids,0,0,0,0,0);
 return err;
}


/*-------------------------------------------------------------------------
draw_wids_proc - ???
-------------------------------------------------------------------------*/

void
draw_wids_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct draw_list_rec *dp;

 dp = (struct draw_list_rec *) xv_get(item,PANEL_CLIENT_DATA);
 delete_all_list_items(dp->linkto);
 WinSetupWindowListItem(dp->win,dp->linkto,0,IMAGE_WINDOWS);
 draw_select_draw_link_items(dp);
}


/*-------------------------------------------------------------------------
draw_wid_list_proc - ???
-------------------------------------------------------------------------*/

void
draw_wid_list_proc(item,wid,client_data,op,event)
 Panel_item item;
 char *wid;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct draw_list_rec *dp;

 PRT4(printf("draw_wid_list_proc op = %d\n",op))
 dp = (struct draw_list_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (op) win_draw_link_with_wid(dp->win,wid);
   else win_delete_draw_link_with_wid(dp->win,wid);
}


/*-------------------------------------------------------------------------
draw_more_commands_proc - ???
-------------------------------------------------------------------------*/

void
draw_more_commands_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct draw_list_rec *dp;

 dp = (struct draw_list_rec *) xv_get(item,PANEL_CLIENT_DATA);
 notice_prompt(dp->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
               "Use the INPUT MOVE/RESIZE/ROTATE cursors",
               "to specify & change the default roi mapping",
               "",
               "| - Draw link with wid",
               "Sh | - Delete draw link with wid",
              0,
            NOTICE_BUTTON_YES," OK !",
            0);
}


/*-------------------------------------------------------------------------
setup_draw_list_rec - ???
-------------------------------------------------------------------------*/

int
setup_draw_list_rec(dp,win)
 struct draw_list_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;

 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 PRT(printf("setup_draw_list_rec...1\n"))
 if (dp->frame == 0)
    {free_draw_list_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,DRAW_LINK);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_draw_list_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 PRT(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_draw_list_rec(dp);
     return CANCEL;}
 row = 0;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 10;
 xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"WIDs",
	PANEL_NOTIFY_PROC,draw_wids_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"More...",
	PANEL_NOTIFY_PROC,draw_more_commands_proc,
        XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset;
 dp->linkto = xv_create(dp->panel,PANEL_LIST,
	PANEL_LABEL_STRING,"LINK TO/FROM",
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_WIDTH,80,
        PANEL_LAYOUT,PANEL_VERTICAL,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,draw_wid_list_proc,
        PANEL_CLIENT_DATA,dp,
                   0);

 WinSetupWindowListItem(dp->win,dp->linkto,0,IMAGE_WINDOWS);
 draw_select_draw_link_items(dp);

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 13,XV_WIDTH,rr->r_width - 15,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_draw_list_rec - ???
-------------------------------------------------------------------------*/

struct draw_list_rec *
find_draw_list_rec(all_dps,win)
 struct all_draw_list_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
enter_dp_draw_list - ???
-------------------------------------------------------------------------*/

int
enter_dp_draw_list(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_draw_list_recs all_dps;
 struct draw_list_rec *dp;
 static char first_time = 1;
 int err;

 PRT(printf("enter_dp_draw_list...0\n"))
 err = NO_ERROR;
 if (first_time)
    {init_all_draw_list_recs(&all_dps);
     first_time = 0;}
 if (status == GET_ALL_DP_PTR)
    {return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEANUP_DP)
   {if ((dp = find_draw_list_rec(&all_dps,win)) != NULL)
       free_draw_list_rec(dp);
    return NO_ERROR;}
 PRT(printf("enter_dp_draw_list...1\n"))
 if ((dp = find_draw_list_rec(&all_dps,win)) != NULL)
    {xv_set(dp->frame,
               XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
     win_set_mouse_at_center(dp->frame);
     wmgr_top(dp->frame);
     return NO_ERROR;}

 PRT(printf("enter_dp_draw_list...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct draw_list_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_draw_list_rec(dp);
 PRT(printf("enter_dp_draw_list...2\n"))
 if ((err = setup_draw_list_rec(dp,win)) == NO_ERROR)
    {PRT(printf("setup_draw_list_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               DRAW_LINK,NULL,0);
 return err;

}

