/****************************************************************************
dp_grow_region_params.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_grow_region_params.c,v 1.10 1999/07/07 17:41:15 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)


#define CLEAN_UP_GA_PARAMS 0
#define SETUP_GA_PARAMS 1
#define GET_ALL_PT_PTR 2

struct grow_region_params_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item option,rois,offset,x_msg;
   };

struct all_grow_region_params_recs
   {
    int num_grs;
    struct grow_region_params_rec **grs;
   };


/* Functions defined in this file */
void init_grow_region_params_rec(struct grow_region_params_rec *gr);
void free_grow_region_params_rec(struct grow_region_params_rec *gr);
void init_all_grow_region_params_recs(
   struct all_grow_region_params_recs *all_grs);
void GA_frame_done_proc(Frame frame);
void GA_option_proc(Panel_item item, int value, Event *event);
int win_def_grow_region_params(struct image_display_window *win);
int setup_grow_region_params_rec(struct grow_region_params_rec *gr,
    struct image_display_window *win);
struct grow_region_params_rec *find_grow_region_params_rec(
   struct all_grow_region_params_recs *all_grs,
    struct image_display_window *win);
int enter_grow_region_params_proc(struct image_display_window *win,
    int status);



/*-------------------------------------------------------------------------
init_grow_region_params_rec - ???
-------------------------------------------------------------------------*/

void
init_grow_region_params_rec(gr)
 struct grow_region_params_rec *gr;
{
 gr->status = 0;
 gr->win = NULL;
 gr->frame = 0;
}


/*-------------------------------------------------------------------------
free_grow_region_params_rec - ???
-------------------------------------------------------------------------*/

void
free_grow_region_params_rec(gr)
 struct grow_region_params_rec *gr;
{
 struct all_grow_region_params_recs *all_grs;

 TRACE(printf("free_grow_region_params_rec...gr->win->dwin = %u\n",gr->win->dwin))
 TRACE(printf("free_grow_region_params_rec...1\n"))
 if (gr->frame != 0)
    {xv_destroy_safe(gr->frame);
     gr->frame = 0;
    }
 c_free(gr);
 all_grs = (struct all_grow_region_params_recs *) 
           enter_grow_region_params_proc(NULL,GET_ALL_PT_PTR);
 DropHandleAryPtr(&(all_grs->grs),&(all_grs->num_grs),gr);
 TRACE(printf("free_grow_region_params_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_grow_region_params_recs - ???
-------------------------------------------------------------------------*/

void
init_all_grow_region_params_recs(all_grs)
 struct all_grow_region_params_recs *all_grs;
{
 all_grs->num_grs = 0;
 all_grs->grs = NULL;
}


/*-------------------------------------------------------------------------
GA_frame_done_proc - ???
-------------------------------------------------------------------------*/

void
GA_frame_done_proc(frame)
 Frame frame;
{
 struct grow_region_params_rec *gr;

 gr = (struct grow_region_params_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_grow_region_params_rec(gr);
}


/*-------------------------------------------------------------------------
GA_option_proc - ???
-------------------------------------------------------------------------*/

void
GA_option_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct grow_region_params_rec *gr;
 struct img_buf_rec *img;

 gr = (struct grow_region_params_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(gr->win->owner)) == NULL)
     return /*CANCEL*/;
 if (value)
    img->file->pixel_type.status &= ~INCOMPATIBLE_TYPE_BY_NEIGHBOR;
   else img->file->pixel_type.status |= INCOMPATIBLE_TYPE_BY_NEIGHBOR;
 img->file->pixel_type.status |= INCOMPATIBLE_TYPE_METHOD_SET;
}


/*-------------------------------------------------------------------------
win_def_grow_region_params - ???
-------------------------------------------------------------------------*/

int
win_def_grow_region_params(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    return CANCEL;
 if (!(img->file->pixel_type.status & INCOMPATIBLE_TYPE_METHOD_SET))
    {if (img->file->hdr.data_info.num_echoes == 1)
        img->file->pixel_type.status |= INCOMPATIBLE_TYPE_BY_NEIGHBOR;
     img->file->pixel_type.status |= INCOMPATIBLE_TYPE_METHOD_SET;}
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
setup_grow_region_params_rec - ???
-------------------------------------------------------------------------*/

int
setup_grow_region_params_rec(gr,win)
 struct grow_region_params_rec *gr;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) 
    {free_grow_region_params_rec(gr);
     return CANCEL;}
 gr->win = win;
 gr->dwin = win->dwin;
 gr->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_grow_region_params_rec...1\n"))
 if (gr->frame == 0)
    {free_grow_region_params_rec(gr);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,GROW_REGION_OPTIONS);
 xv_set(gr->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,GA_frame_done_proc,
              WIN_CLIENT_DATA,gr,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 gr->panel = xv_create(gr->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (gr->panel == 0)
    {free_grow_region_params_rec(gr);
     return CANCEL;}
 row = 2;
 offset = xv_rows(gr->panel,1) - xv_rows(gr->panel,0) - 10;
 xv_create(gr->panel,PANEL_MESSAGE,
       PANEL_LABEL_STRING,"FOR PIXELS WITH 8 INCOMPATIBLE NEIGHBORS",
       XV_X,5,XV_Y,row,
        0);
 row += offset - 8;
 gr->option = xv_create(gr->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"SEGMENT BY NEIGHBOR VALUES",
                                "SEGMENT BY CLOSEST CLUSTER AVERAGE",NULL,
                  XV_X,15,XV_Y,row,
                  PANEL_NOTIFY_PROC,GA_option_proc,
                  PANEL_CLIENT_DATA,gr,
                  0);
 win_def_grow_region_params(win);
 if (img->file->pixel_type.status & INCOMPATIBLE_TYPE_BY_NEIGHBOR)
    xv_set(gr->option,PANEL_VALUE,0,0);
   else xv_set(gr->option,PANEL_VALUE,1,0);
 window_fit(gr->panel);
 rr = (Rect *) xv_get(gr->panel,XV_RECT);
 xv_set(gr->panel,XV_WIDTH,rr->r_width - 10,XV_HEIGHT,rr->r_height - 10,0);
 window_fit(gr->frame);
 make_2_wins_adjacent(gr->frame,win->dwin->frame,0);
 win_set_mouse_at_center(gr->frame);
 xv_set(gr->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}



/*-------------------------------------------------------------------------
find_grow_region_params_rec - ???
-------------------------------------------------------------------------*/

struct grow_region_params_rec *
find_grow_region_params_rec(all_grs,win)
 struct all_grow_region_params_recs *all_grs;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_grs->num_grs; lcv++)
    if (all_grs->grs[lcv]->win == win)
       return all_grs->grs[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
enter_grow_region_params_proc - ???
-------------------------------------------------------------------------*/

int
enter_grow_region_params_proc(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_grow_region_params_recs all_grs;
 struct grow_region_params_rec *gr;
 static char first_time = 1;
 int err;

 TRACE(printf("grow_region_params_rec...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_PT_PTR)
    {if (first_time) return 0;
       else return (unsigned long) &all_grs;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_GA_PARAMS)
   {if (!first_time)
       if ((gr = find_grow_region_params_rec(&all_grs,win)) != NULL)
          free_grow_region_params_rec(gr);
    return NO_ERROR;}
 TRACE(printf("grow_region_params_rec...1\n"))
 if (first_time)
    {init_all_grow_region_params_recs(&all_grs);
     first_time = 0;}
   else
    {if ((gr = find_grow_region_params_rec(&all_grs,win)) != NULL)
        {
         xv_set(gr->frame,
                XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(gr->frame);
         wmgr_top(gr->frame);
         return NO_ERROR;}
    }
 TRACE(printf("grow_region_params_rec...2\n"))
 get_handle_memory(&(all_grs.grs),&(all_grs.num_grs),1,
     (size_t) sizeof(struct grow_region_params_rec),&err);
 if (err != NO_ERROR) return err;
 gr = all_grs.grs[all_grs.num_grs - 1];
 init_grow_region_params_rec(gr);
 TRACE(printf("grow_region_params_rec...2\n"))
 if ((err = setup_grow_region_params_rec(gr,win)) == NO_ERROR)
    {TRACE(printf("setup_grow_region_params_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the grow region params window !!!",NULL,0);
 return err;

}


