/****************************************************************************
dp_resize.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_resize.c,v 1.9 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"


/*
#define PRT(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
#define PRT5(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT4(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT2(x)
#define PRT3(x)
#define PRT4(x)
#define PRT5(x)
#define PRT7(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)
#define PRT11(x)



#define CLEANUP_DP 0
#define GET_ALL_DP_PTR 2

struct resize_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame owner_frame;
    Frame frame;
    Panel panel;
    Panel_item wid,equal_to_wid,def_unitx,def_unity,region,exc,use_orig,
               def_dimx,def_dimy,ustartx,ustarty,unitx,unity,dimx,dimy,
               auto_ratio,endx,endy;
   };

struct all_resize_recs
   {
    int num_dps;
    struct resize_rec **dps;
   };


/* Functions defined in this file */
void init_resize_rec(struct resize_rec *dp);
void free_resize_rec(struct resize_rec *dp);
void init_all_resize_recs(struct all_resize_recs *all_dps);
void dp_resize_done_proc(Frame frame);
int win_cur_item_win_and_img(struct image_display_window *win,
    Panel_item item, struct image_display_window **win1,
    struct img_buf_rec **img);
void resize_wid_def_info(struct resize_rec *dp, Panel_item item);
void resize_wid_info(struct resize_rec *dp, Panel_item item);
void resize_get_wids_proc(Panel_item item, Event *event);
void resize_default_proc(Panel_item item, Event *event);
int WinImageUnitSize(struct image_display_window *win,
    float *xpix, float *ypix, float *zpix,
    unsigned long *dimx, unsigned long *dimy);
int WinScaleViewScreenDimXY(struct image_display_window *win,
    unsigned long dimx, unsigned long dimy, unsigned long use_magxy,
    unsigned long magx, unsigned long magy);
int win_resize_activation_image(struct image_display_window *win,
    struct unit_2d_rec *resize_unit, int is_exc, int region, int use_orig,
    struct buf_2d_rec *result);
int win_resize_regular_image(struct image_display_window *win,
    struct unit_2d_rec *resize_unit, int is_exc, int region, int use_orig,
    struct buf_2d_rec *result);
int WinResizeNewColorMultiCanvas(struct image_display_window *win, int which);
int WinResizeImage(struct image_display_window *win, struct unit_2d_rec *unit,
    int is_exc, int region, int use_orig, int is_magxy11);
int WinSetupResizeImage(struct image_display_window *win, double ustartx,
    double ustarty, double unitx, double unity, unsigned long dimx,
    unsigned long dimy, double angle, int is_exc, int region, int use_orig,
    int is_magxy11);
int WinRotate2dImage(struct image_display_window *win, double angle,
    int is_rel);
int win_resize_to_wid(struct image_display_window *win, char *wid);
int WinResizeDefImgView(struct image_display_window *win);
int WinResizeDefImgSize(struct image_display_window *win);
int WinResizeLastImgSize(struct image_display_window *win);
int win_zoom(struct image_display_window *win, int is_doom_in);
int win_move_img(struct image_display_window *win, double x, double y);
void resize_region_proc(Panel_item item, int value, Event *event);
void resize_wid_now_proc(Panel_item item, Event *event);
int resize_check_dim(struct resize_rec *dp, Panel_item item);
void resize_dim_proc(Panel_item item, char *str, Event *event);
void resize_pixel_dim_proc(Panel_item item, int value, Event *event);
void resize_wid_info_proc(Panel_item item, char *wid, caddr_t client_data,
    Panel_list_op op, Event *event);
void resize_auto_ratio_proc(Panel_item item, int value, Event *event);
void resize_equal_to_wid_proc(Panel_item item, char *wid, caddr_t client_data,
    Panel_list_op op, Event *event);
int setup_resize_rec(struct resize_rec *dp, struct image_display_window *win);
struct resize_rec *find_resize_rec(struct all_resize_recs *all_dps,
    struct image_display_window *win);
int enter_resize_image(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_resize_rec - ???
-------------------------------------------------------------------------*/

void
init_resize_rec(dp)
 struct resize_rec *dp;
{
 dp->status = 0;
 dp->frame = 0;
 dp->win = NULL;
}


/*-------------------------------------------------------------------------
free_resize_rec - ???
-------------------------------------------------------------------------*/

void
free_resize_rec(dp)
 struct resize_rec *dp;
{
 struct all_resize_recs *all_dps;

 if (dp->frame != 0)
    {
     xv_destroy_safe(dp->frame);
    }
 all_dps = (struct all_resize_recs *) enter_resize_image(NULL,
            GET_ALL_DP_PTR);
 c_free(dp);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
}


/*-------------------------------------------------------------------------
init_all_resize_recs - ???
-------------------------------------------------------------------------*/

void
init_all_resize_recs(all_dps)
 struct all_resize_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*-------------------------------------------------------------------------
dp_resize_done_proc - ???
-------------------------------------------------------------------------*/

void
dp_resize_done_proc(frame)
 Frame frame;
{
 struct resize_rec *dp;

 dp = (struct resize_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_resize_rec(dp);
}


/*-------------------------------------------------------------------------
win_cur_item_win_and_img - ???
-------------------------------------------------------------------------*/

int
win_cur_item_win_and_img(win,item,win1,img)
 struct image_display_window *win,**win1;
 Panel_item item;
 struct img_buf_rec **img;
{
 struct win_rec *rwin;
 unsigned long indx;
 char *wid;

 if ((next_selected_item(item,0,&indx) == NO_ERROR) &&
     ((wid = (char *) xv_get(item,PANEL_LIST_STRING,indx)) != NULL) &&
     ((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     ((*win1 = rwin->image_display) != NULL) &&
     ((*img = win_rec_cur_img_buf(rwin)) != NULL))
    return NO_ERROR;
   else return CANCEL;
}


/*-------------------------------------------------------------------------
resize_wid_def_info - ???
-------------------------------------------------------------------------*/

void
resize_wid_def_info(dp,item)
 struct resize_rec *dp;
 Panel_item item;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 char str[40];
 struct image_display_window *win;

 if (win_cur_item_win_and_img(dp->win,item,&win,&img) == NO_ERROR)
    {info = &(img->file->hdr.data_info);
     sprintf(str,"UNIT X = %-.4f\n",info->xpixel_size);
     xv_set(dp->def_unitx,PANEL_LABEL_STRING,str,0);
     sprintf(str,"UNIT Y = %-.4f\n",info->ypixel_size);
     xv_set(dp->def_unity,PANEL_LABEL_STRING,str,0);
     sprintf(str,"DIM X = %-ld\n",info->dimx);
     xv_set(dp->def_dimx,PANEL_LABEL_STRING,str,0);
     sprintf(str,"DIM Y = %-ld\n",info->dimy);
     xv_set(dp->def_dimy,PANEL_LABEL_STRING,str,0);}
   else
    {xv_set(dp->def_unitx,PANEL_LABEL_STRING,"UNIT X =",0);
     xv_set(dp->def_unity,PANEL_LABEL_STRING,"UNIT Y =",0);
     xv_set(dp->def_dimx,PANEL_LABEL_STRING,"DIM X =",0);
     xv_set(dp->def_dimy,PANEL_LABEL_STRING,"DIM Y =",0);
    }
}


/*-------------------------------------------------------------------------
resize_wid_info - ???
-------------------------------------------------------------------------*/

void
resize_wid_info(dp,item)
 struct resize_rec *dp;
 Panel_item item;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 char str[40];
 struct image_display_window *win;
 float ustartx,ustarty,unitx,unity,xpix,ypix,zpix;
 unsigned long dimx,dimy,dimx1,dimy1;
 int err;

 if (win_cur_item_win_and_img(dp->win,item,&win,&img) == NO_ERROR)
    {info = &(img->file->hdr.data_info);
     if ((err = WinImageUnitSize(dp->win,&xpix,&ypix,&zpix,&dimx1,&dimy1))
                  != NO_ERROR) 
	 return /*err*/;
     Get2dUnitInfo(&(img->_2d),&ustartx,&ustarty,&unitx,&unity,&dimx,&dimy,
               .0,.0,xpix,ypix,dimx1,dimy1);
     sprintf(str,"%-.4f\n",ustartx);
     xv_set(dp->ustartx,PANEL_VALUE,str,0);
     sprintf(str,"%-.4f\n",ustarty);
     xv_set(dp->ustarty,PANEL_VALUE,str,0);

     sprintf(str,"%-.4f\n",unitx);
     xv_set(dp->unitx,PANEL_VALUE,str,0);
     sprintf(str,"%-.4f\n",unity);
     xv_set(dp->unity,PANEL_VALUE,str,0);
     PRT7(printf("resize_wid_info dimx = %f dimy = %d\n",dimx,dimy);)
     xv_set(dp->dimx,PANEL_VALUE,img->_2d.dimx,0);
     xv_set(dp->dimy,PANEL_VALUE,img->_2d.dimy,0);
/*
     xv_set(dp->dimx,PANEL_VALUE,img->_2d.dimx,PANEL_MIN_VALUE,1,
                 PANEL_MAX_VALUE,dimx,0);
     xv_set(dp->dimy,PANEL_VALUE,img->_2d.dimy,PANEL_MIN_VALUE,1,
                 PANEL_MAX_VALUE,dimy,0);
*/
    }
   else
    {xv_set(dp->ustartx,PANEL_VALUE,"",0);
     xv_set(dp->ustarty,PANEL_VALUE,"",0);
     xv_set(dp->unitx,PANEL_VALUE,"",0);
     xv_set(dp->unity,PANEL_VALUE,"",0);
     xv_set(dp->dimx,PANEL_VALUE,1,0);
     xv_set(dp->dimy,PANEL_VALUE,1,0);
/*
     xv_set(dp->dimx,PANEL_VALUE,1,PANEL_MIN_VALUE,1,PANEL_MAX_VALUE,2,0);
     xv_set(dp->dimy,PANEL_VALUE,1,PANEL_MIN_VALUE,1,PANEL_MAX_VALUE,2,0);
*/
    }
}


/*-------------------------------------------------------------------------
resize_get_wids_proc - ???
-------------------------------------------------------------------------*/

void
resize_get_wids_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_rec *dp;
 unsigned long indx;
 char *wid;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 wid = NULL;
 if (next_selected_item(dp->wid,0,&indx) == NO_ERROR)
    cp_str(&wid,(char *) xv_get(dp->wid,PANEL_LIST_STRING,indx));
 delete_all_list_items(dp->wid);
 WinSetupWindowListItem(dp->win,dp->wid,1,IMAGE_WINDOWS);
 select_list_str_item(wid,dp->wid,1);
 c_free(wid);
 wid = NULL;
 if (next_selected_item(dp->equal_to_wid,0,&indx) != NO_ERROR)
    cp_str(&wid,(char *) xv_get(dp->equal_to_wid,PANEL_LIST_STRING,indx));
 delete_all_list_items(dp->equal_to_wid);
 WinSetupWindowListItem(dp->win,dp->equal_to_wid,1,IMAGE_WINDOWS);
 select_list_str_item(wid,dp->equal_to_wid,1);
 c_free(wid);
}


/*-------------------------------------------------------------------------
resize_default_proc - ???
-------------------------------------------------------------------------*/

void
resize_default_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_rec *dp;
 struct img_buf_rec *img;
 struct data_info_rec *info;
 char str[40];
 struct image_display_window *win;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (win_cur_item_win_and_img(dp->win,dp->wid,&win,&img) == NO_ERROR)
    {info = &(img->file->hdr.data_info);
     xv_set(dp->ustartx,PANEL_VALUE,".0",0);
     xv_set(dp->ustarty,PANEL_VALUE,".0",0);
     sprintf(str,"%-.4f\n",info->xpixel_size);
     xv_set(dp->unitx,PANEL_VALUE,str,0);
     sprintf(str,"%-.4f\n",info->ypixel_size);
     xv_set(dp->unity,PANEL_VALUE,str,0);
     xv_set(dp->dimx,PANEL_VALUE,info->dimx,0);
     xv_set(dp->dimy,PANEL_VALUE,info->dimy,0);
/*
     xv_set(dp->dimx,PANEL_VALUE,info->dimx,PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,info->dimx,0);
     xv_set(dp->dimy,PANEL_VALUE,info->dimy,PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,info->dimy,0);
*/
    }
}


/*-------------------------------------------------------------------------
WinImageUnitSize - ???
-------------------------------------------------------------------------*/

int
WinImageUnitSize(win,xpix,ypix,zpix,dimx,dimy)
 struct image_display_window *win;
 float *xpix,*ypix,*zpix;
 unsigned long *dimx,*dimy;
{
 struct img_buf_rec *img;
 struct view_rec *view;
 struct buf_3d_rec *_3d;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (win->type2 & DISPLAY_WINDOW_3D)
    {view = img->cur_slice->slice->view;
     if ((err = find_file_3d(img->file,view->id,&_3d)) != NO_ERROR)
        return err;
     if (img->unit.status2 & UNIT_2D_IN_USE)
        {*xpix = img->unit.unitx;
         *ypix = img->unit.unity;
         *dimx = img->_2d.dimx;
         *dimy = img->_2d.dimy;
         PRT11(printf("WinImageUnitSize 1 dimx = %d dimy = %d xpix = %f ypix = %f\n",*dimx,*dimy,*xpix,*ypix))}
       else
        {*xpix = view->gplane.coord_ratio.x * _3d->xpixel_size;
         *ypix = view->gplane.coord_ratio.y * _3d->ypixel_size;
         *dimx = _3d->dimx;
         *dimy = _3d->dimy;
         PRT11(printf("WinImageUnitSize 2 dimx = %d dimy = %d xpix = %f ypix = %f\n",*dimx,*dimy,*xpix,*ypix))}
     *zpix = view->gplane.coord_ratio.z * _3d->zpixel_size;
    }
   else
    {
     if (img->unit.status2 & UNIT_2D_IN_USE)
        {*xpix = img->unit.unitx;
         *ypix = img->unit.unity;
         *dimx = img->_2d.dimx;
         *dimy = img->_2d.dimy;
         PRT11(printf("WinImageUnitSize 3 dimx = %d dimy = %d xpix = %f ypix = %f\n",*dimx,*dimy,*xpix,*ypix))}
       else
        {*xpix = img->file->hdr.data_info.xpixel_size;
         *ypix = img->file->hdr.data_info.ypixel_size;
         *dimx = img->file->hdr.data_info.dimx;
         *dimy = img->file->hdr.data_info.dimy;
         PRT11(printf("WinImageUnitSize 4 dimx = %d dimy = %d xpix = %f ypix = %f\n",*dimx,*dimy,*xpix,*ypix))}
     *zpix = img->file->hdr.data_info.pixel_thickness;
    }
 PRT11(printf("WinImageUnitSize 5 zpix = %f\n",*zpix))

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinScaleViewScreenDimXY - ???
-------------------------------------------------------------------------*/

int
WinScaleViewScreenDimXY(win,dimx,dimy,use_magxy,magx,magy)
 struct image_display_window *win;
 unsigned long dimx,dimy,use_magxy,magx,magy;
{
 PRT7(printf("WinScaleViewScreenDimXY use_magxy = %d magx = %d magy = %d dimx = %d dimy = %d\n",
        use_magxy,magx,magy,dimx,dimy))
 setup_int_bound_rec(&(win->data.bound),0,0,dimx - 1,dimy - 1);
 return ScaleViewScreenDimXY(&(win->dwin->screen),dimx,dimy,
           use_magxy,magx,magy);
}


/*-------------------------------------------------------------------------
win_resize_activation_image - ???
-------------------------------------------------------------------------*/

int
win_resize_activation_image(win,resize_unit,is_exc,region,use_orig,result)
 struct image_display_window *win;
 struct unit_2d_rec *resize_unit;
 int is_exc,region,use_orig;
 struct buf_2d_rec *result;
{
 struct buf_2d_rec *pos,*neg,*_2d,the_2d1,the_2d2,the_2d3;
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct draw_mask_rec mask;
 struct matrix_2d_rec *localto;
 struct int_bound_rec affected,*bound;
 float sunitx,sunity;
 int err,is_normalized;
 unsigned long select,depth;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 info = &(img->file->hdr.data_info);
 err = NO_ERROR;
 init_buf_2d_rec(&the_2d1);
 init_buf_2d_rec(&the_2d2);
 init_buf_2d_rec(&the_2d3);
 if (img->_2d.status4 & BUF_MIN_MAX_SET) is_normalized = 1;
   else is_normalized = 0;
 if (img->cur_slice->partner_slice->echo_num < img->cur_slice->echo_num)
    {pos = &the_2d2;
     neg = &the_2d1;}
   else
    {pos = &the_2d1;
     neg = &the_2d2;}
 PRT7(printf("...win_resize_activation_image..use_orig = %d\n",use_orig))
 if (((err = SetupBuf2dRec(&the_2d1,info->dimx,info->dimy,
         info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&the_2d2,info->dimx,info->dimy,
         info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR) ||
     ((err = RdSliceData(img,img->cur_slice,is_normalized,
                            &the_2d1,0)) != NO_ERROR) ||
     ((err = RdSliceData(img,img->cur_slice->partner_slice,is_normalized,
                            &the_2d2,0)) != NO_ERROR) ||
     ((err = CombinePosNeg2d(&the_2d3,pos,neg)) != NO_ERROR))
    {free_buf_2d_rec(&the_2d1);
     free_buf_2d_rec(&the_2d2);
     free_buf_2d_rec(&the_2d3);
     return err;}
 depth = img->_2d.pixel_depth;
 PRT7(printf("...win_resize_activation_image..use_orig = %d\n",use_orig))
 if (!use_orig)
    {PRT7(printf("...win_resize_activation_image status4 = %x\n",img->status4))
     if (img->unit.status2 & UNIT_2D_IN_USE)
        {if (((err = ResizeBuf2dRec(&the_2d2,&the_2d3,
               img->unit.dimx,img->unit.dimy,&(img->unit.tolocal_mat)))
                  != NO_ERROR) ||
             ((err = SetupBuf2dRec(&the_2d1,the_2d2.dimx,the_2d2.dimy,
               the_2d2.pixel_depth,the_2d2.status4 & BUF_VALUE_TYPE)) != NO_ERROR))
            {free_buf_2d_rec(&the_2d1);
             free_buf_2d_rec(&the_2d2);
             free_buf_2d_rec(&the_2d3);
             return err;}
          if (&the_2d1 == pos)
            {PRT7(printf("select pos...\n"))
             SelectAssign2d(&the_2d1,&the_2d2,
               0x00000402,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
             select = 0;}
           else
            {PRT7(printf("select neg...\n"))
             SelectAssign2d(&the_2d1,&the_2d2,
               0x00000601,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);
             select = 0x00002000;}
          _2d = &the_2d2;
          sunitx = img->unit.unitx;
          sunity = img->unit.unity;
         }
        else
         {_2d = &the_2d3;
          sunitx = info->xpixel_size;
          sunity = info->ypixel_size;}
      if (&the_2d1 == pos) select = 0;
        else select = 0x00002000;
      PRT7(printf("the_2d1 = %u pos = %u...select = %x\n",&the_2d1,pos,select))
      Assign2dByGeneralMask(_2d,&(img->_2d),&the_2d1,select);
      localto = win->control.sroi.localto;
     }
    else
     {localto = NULL;
      _2d = &the_2d3;
      sunitx = info->xpixel_size;
      sunity = info->ypixel_size;}

 PRT7(printf("...sunitx = %f sunity = %f  dimx= %d dimy = %d localto = %u\n",
          sunitx,sunity,_2d->dimx,_2d->dimy,localto))
 if (region)
    {init_draw_mask_rec(&mask);
     if ((err = GetRoiMask(&(win->control.sroi.sroi_win->slice_roi),localto,
             _2d->dimx,_2d->dimy,
             &mask,&affected,region,&(win->image_view_roi))) == NO_ERROR)
        {if (!is_exc)
            {NotBitmap(&(mask.mask._2d),&(mask.mask._2d));
             bound = NULL;}
           else bound = &affected;
         PRT4(printf("win_resize_activation_image...Set2d\n"))
         err = Set2d(_2d,0,0,&(mask.mask._2d),bound,(double) .0);}
     free_draw_mask_rec(&mask);
    }
 PRT7(printf("*****win_resize_activation_image...err = %d\n",err))
 PRT7(printf("_2d = %u the_2d1 = %u the_2d2 = %u the_2d3 = %u\n",
      _2d,&the_2d1,&the_2d2,&the_2d3))
 if (err == NO_ERROR)
    if (((err = ResizeBuf2dRec(&the_2d1,_2d,resize_unit->dimx,
               resize_unit->dimy,&(resize_unit->tolocal_mat))) == NO_ERROR) &&
        ((err = SetupBuf2dRec(result,the_2d1.dimx,
            the_2d1.dimy,depth,the_2d1.status4 & BUF_VALUE_TYPE)) == NO_ERROR) &&
        ((err = win_setup_mask_bufs(win,0,0,result->dimx,result->dimy)) == NO_ERROR))
       {if (&the_2d1 == pos)
           {PRT7(printf("select pos...\n"))
            SelectAssign2d(result,&the_2d1,
               0x00004408,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);}
          else
           {PRT7(printf("select neg...\n"))
            SelectAssign2d(result,&the_2d1,
               0x00000604,(double) .0,(double) .0,(double) .0,(double) .0,
               NULL,0,0);}
       }
 PRT7(printf("win_resize_activation_image...err = %d\n",err))
 free_buf_2d_rec(&the_2d1);
 free_buf_2d_rec(&the_2d2);
 free_buf_2d_rec(&the_2d3);
 return err;
}


/*-------------------------------------------------------------------------
win_resize_regular_image - ???
-------------------------------------------------------------------------*/

int
win_resize_regular_image(win,resize_unit,is_exc,region,use_orig,result)
 struct image_display_window *win;
 struct unit_2d_rec *resize_unit;
 int is_exc,region,use_orig;
 struct buf_2d_rec *result;
{
 struct buf_2d_rec *_2d,the_2d;
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct draw_mask_rec mask;
 struct matrix_2d_rec *localto;
 struct int_bound_rec affected,*bound;
 int err,is_normalized;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 info = &(img->file->hdr.data_info);
 err = NO_ERROR;
 init_buf_2d_rec(&the_2d);
 PRT7(printf("...win_resize_regular_image..use_orig = %d\n",use_orig))
 if (use_orig)
    {
     if (img->_2d.status4 & BUF_MIN_MAX_SET) is_normalized = 1;
       else is_normalized = 0;
 PRT7(printf("*** minval_set = %f maxval_set = %f\n",
            img->_2d.minval_set,img->_2d.maxval_set))
     if (((err = SetupBuf2dRec(&the_2d,info->dimx,info->dimy,
          info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR) ||
         ((err = RdSliceData(img,img->cur_slice,is_normalized,
                            &the_2d,0)) != NO_ERROR))
        {free_buf_2d_rec(&the_2d);
         return err;}
     _2d = &the_2d;
     localto = NULL;
 PRT7(printf("++++ minval_set = %f maxval_set = %f\n",
            img->_2d.minval_set,img->_2d.maxval_set))
    }
   else
    {_2d = &(img->_2d);
     localto = win->control.sroi.localto;}
 if (region)
    {init_draw_mask_rec(&mask);
     if ((err = GetRoiMask(&(win->control.sroi.sroi_win->slice_roi),localto,
             _2d->dimx,_2d->dimy,
             &mask,&affected,region,&(win->image_view_roi))) == NO_ERROR)
        {if (!is_exc)
            {NotBitmap(&(mask.mask._2d),&(mask.mask._2d));
             bound = NULL;}
           else bound = &affected;
         PRT4(printf("win_resize_regular_image...Set2d\n"))
         err = Set2d(_2d,0,0,&(mask.mask._2d),bound,(double) .0);}
     free_draw_mask_rec(&mask);
    }
 PRT7(printf("win_resize_regular_image...err = %d\n",err))
 if (err == NO_ERROR)
    if ((err = ResizeBuf2dRec(result,_2d,resize_unit->dimx,
               resize_unit->dimy,&(resize_unit->tolocal_mat))) == NO_ERROR)
       err = win_setup_mask_bufs(win,0,0,result->dimx,result->dimy);

 free_buf_2d_rec(&the_2d);
 return err;
}


/*-------------------------------------------------------------------------
WinResizeNewColorMultiCanvas - ???
-------------------------------------------------------------------------*/

int
WinResizeNewColorMultiCanvas(win,which)
 struct image_display_window *win;
 int which;
{
 (void) notify_set_itimer_func((Notify_client) win,
             NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 PRT7(printf("WinResizeNewColorMultiCanvas..\n"))
 WinNewColorMultiCanvas(win);
 PRT7(printf("WinResizeNewColorMultiCanvas..end\n"))
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinResizeImage - ???
-------------------------------------------------------------------------*/

int
WinResizeImage(win,unit,is_exc,region,use_orig,is_magxy11)
 struct image_display_window *win;
 struct unit_2d_rec *unit;
 int is_exc,region,use_orig,is_magxy11;
{
 struct unit_2d_rec *resize_unit;
 struct buf_2d_rec new_2d;
 struct img_buf_rec *img;
 struct data_info_rec *info;
 double minval_set,maxval_set;
 unsigned long status4;
 int err;

 PRT7(printf("WinResizeImage...is_exc = %d region = %d use_orig = %d\n",
                    is_exc,region,use_orig))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 info = &(img->file->hdr.data_info);
 init_buf_2d_rec(&new_2d);
 if (unit == NULL) resize_unit = &(img->unit);
   else resize_unit = unit;

 if ((info->var_use_status & POS_NEG_ACTIVATION) && (info->num_echoes == 2))
    err = win_resize_activation_image(win,resize_unit,
                 is_exc,region,use_orig,&new_2d);
   else err = win_resize_regular_image(win,resize_unit,
                 is_exc,region,use_orig,&new_2d);
 PRT7(printf("WinResizeImage...err = %d\n",err))
 if (err == NO_ERROR)
    {

     status4 = img->_2d.status4;
     if (status4 & BUF_MIN_MAX_SET)
        {minval_set = img->_2d.minval_set;
         maxval_set = img->_2d.maxval_set;}

     if ((img->num_dst_wids > 0) &&
         !is_same_buf_2d_rec_dimxy(&(img->_2d),&new_2d))
        win_set_redefine_dst_fusion_params(win);

     free_buf_2d_rec(&(img->_2d));
     img->_2d = new_2d;
     free_buf_2d_rec(&(img->move_2d));
     img->status4 &= ~IMG_MOVE_2D_VALID;

     if (status4 & BUF_MIN_MAX_SET)
        {img->_2d.minval_set = minval_set;
         img->_2d.maxval_set = maxval_set;
         img->_2d.status4 |= BUF_MIN_MAX_SET;
        }
     if (resize_unit != &(img->unit))
        {
         if (img->unit.status2 & UNIT_2D_IN_USE)
            img->last_unit = img->unit;
         img->unit = *resize_unit;}

     win->control.sroi.tolocal = &(img->unit.tolocal_mat);
     win->control.sroi.localto = &(img->unit.localto_mat);
     PRT7(printf("tolocal = %u localto = %u\n",win->control.sroi.tolocal,
                win->control.sroi.localto))
     PRT7(if (img->_2d.status4 & BUF_MIN_MAX_COMPUTED)
         printf(" minval = %f maxval = %f\n",
            img->_2d.minval,img->_2d.maxval))
     PRT7(printf("minval_set = %f maxval_set = %f\n",
            img->_2d.minval_set,img->_2d.maxval_set))

     PRT7(printf("WinResizeImage...localto_mat & tolocal_mat\n"))
     PRT7(pr_2d_matrix(&(img->unit.localto_mat)))
     PRT7(pr_2d_matrix(&(img->unit.tolocal_mat)))

     PRT7(printf("WinResizeImage..img->_2d\n"))
     PRT7(pr_buf_2d_rec(&(img->_2d)))
     win_execute_proc_to_multiple_wins(win,WinScaleViewScreenDimXY,
                         img->_2d.dimx,img->_2d.dimy,is_magxy11,1,1);
     if (win->status4 & FILTER_ON) win_filter_image_data(win);

     (void) notify_set_itimer_func((Notify_client) win,
           (Notify_func) WinResizeNewColorMultiCanvas,
            ITIMER_REAL,&NOTIFY_POLLING_ITIMER,
                           (struct itimerval *) 0);
    }
   else free_buf_2d_rec(&new_2d);
 PRT7(printf("WinResizeImage..end.img->status4 = %x err = %d\n",img->status4,err))

 return err;
}


/*-------------------------------------------------------------------------
WinSetupResizeImage - ???
-------------------------------------------------------------------------*/

int
WinSetupResizeImage(win,ustartx,ustarty,unitx,unity,dimx,dimy,angle,
                    is_exc,region,use_orig,is_magxy11)
 struct image_display_window *win;
 float ustartx,ustarty,unitx,unity;
 unsigned long dimx,dimy;
 float angle;
 int is_exc,region,use_orig,is_magxy11;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct unit_2d_rec resize_unit;
 struct matrix_2d_rec mat,mat1;
 double rad;
 float centerx,centery;
 int err;

 PRT7(printf("WinSetupResizeImage...angle = %f is_exc = %d region = %d use_orig = %d\n",
                    angle,is_exc,region,use_orig))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;

 PRT7(printf("ustartx = %f  ustarty = %f unitx = %f unity = %f dimx = %d dimy = %d\n",
          ustartx,ustarty,unitx,unity,dimx,dimy))
 info = &(img->file->hdr.data_info);
   
 setup_unit_2d_rec(&resize_unit,ustartx,ustarty,
            unitx,unity,dimx,dimy,.0,.0,info->xpixel_size,info->ypixel_size);
 if (img->unit.status2 & UNIT_2D_IN_USE)
    {
     unit_2d_rec_extra_trans_matrix(&mat,&(img->unit));

     PRT7(printf("WinSetupResizeImage...mat\n"))
     PRT7(pr_2d_matrix(&mat))

     assign_2d_translation(&mat,.0,.0);
     centerx = (float) (resize_unit.dimx - 1) / 2.0;
     centery = (float) (resize_unit.dimy - 1) / 2.0;
     setup_translate_2d_matrix(&mat1,-centerx,-centery);
     mult_2d_matrix(&mat,&mat,&mat1);
     translate_2d_matrix(&mat,centerx,centery);
     PRT7(printf("*****...mat\n"))
     PRT7(pr_2d_matrix(&mat))

     mult_2d_matrix(&(resize_unit.localto_mat),&mat,&(resize_unit.localto_mat));
     inverse_2d_matrix(&(resize_unit.tolocal_mat),&(resize_unit.localto_mat));

     PRT7(printf("WinSetupResizeImage...localto_mat\n"))
     PRT7(pr_2d_matrix(&(resize_unit.localto_mat)))
     PRT7(pr_2d_matrix(&(resize_unit.tolocal_mat)))
    }
 if (angle != .0) 
    {rad = radian(angle);
     PRT7(printf("WinSetupResizeImage...====\n"))
     setup_rotate_2d_matrix(&mat,rad);
     PRT7(pr_2d_matrix(&mat))

     centerx = (float) (dimx - 1) / 2.0;
     centery = (float) (dimy - 1) / 2.0;
     setup_rotate_2d_matrix_from_xy(&mat,rad,centerx,centery);
     PRT7(printf("WinSetupResizeImage...after roate mat\n"))
     PRT7(pr_2d_matrix(&mat))
     mult_2d_matrix(&(resize_unit.localto_mat),&mat,&(resize_unit.localto_mat));

     inverse_2d_matrix(&(resize_unit.tolocal_mat),&(resize_unit.localto_mat));
    }
 err = WinResizeImage(win,&resize_unit,is_exc,region,use_orig,is_magxy11);
 PRT7(printf("WinSetupResizeImage...end err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
WinRotate2dImage - ???
-------------------------------------------------------------------------*/

int
WinRotate2dImage(win,angle,is_rel)
 struct image_display_window *win;
 float angle;
 int is_rel;
{
 struct img_buf_rec *img;
 struct matrix_2d_rec mat;
 double rad;
 float centerx,centery,xpix,ypix,zpix;
 unsigned long dimx,dimy;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT7(printf("WinRotate2dImage status4 = %x angle = %f is_rel = %d\n",
         img->status4,angle,is_rel))
 PRT7(if (img->_2d.status4 & BUF_MIN_MAX_COMPUTED)
         printf(" minval = %f maxval = %f\n",
            img->_2d.minval,img->_2d.maxval))
 PRT7(printf(" minval_set = %f maxval_set = %f\n",
            img->_2d.minval_set,img->_2d.maxval_set))
 if (img->unit.status2 & UNIT_2D_IN_USE)
    {
     img->last_unit = img->unit;
     if (!is_rel)
        setup_unit_2d_rec(&(img->unit),img->unit.ustartx,img->unit.ustarty,
            img->unit.unitx,img->unit.unity,img->unit.dimx,img->unit.dimy,
            img->unit.local_ustartx,img->unit.local_ustarty,
            img->unit.local_unitx,img->unit.local_unity);
     rad = radian(angle);
     centerx = (float) (img->unit.dimx - 1) / 2.0;
     centery = (float) (img->unit.dimy - 1) / 2.0;

     PRT7(pr_unit_2d_rec(&(img->unit));
          printf("centerx = %f centery = %f\n",centerx,centery))
     setup_rotate_2d_matrix_from_xy(&mat,rad,centerx,centery);
     mult_2d_matrix(&(img->unit.localto_mat),&mat,&(img->unit.localto_mat));

     inverse_2d_matrix(&(img->unit.tolocal_mat),&(img->unit.localto_mat));
     err = WinResizeImage(win,NULL,0,0,1,0);
    }
   else if ((err = WinImageUnitSize(win,&xpix,&ypix,&zpix,&dimx,&dimy)) == NO_ERROR) 
    err = WinSetupResizeImage(win,.0,.0,xpix,ypix,
         dimx,dimy,angle,0,0,1,0);
 PRT7(printf("WinRotate2dImage..end.err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
win_resize_to_wid - ???
-------------------------------------------------------------------------*/

int
win_resize_to_wid(win,wid)
 struct image_display_window *win;
 char *wid;
{
 struct img_buf_rec *img,*img1;
 struct win_rec *rwin;
 int err;
 struct image_display_window *win1;
 struct unit_2d_rec *unit_ptr,the_unit;

 if (wid == NULL) return CANCEL;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT3(printf("win_resize_to_wid_xy_proc wid =%s\n",wid))
 err = CANCEL;
 if (((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     ((win1 = rwin->image_display) != NULL) &&
     ((img1 = win_rec_cur_img_buf(rwin)) != NULL))
    {GetImgUnit2dRec(img1,&the_unit,&unit_ptr);
     err = WinSetupResizeImage(win,unit_ptr->ustartx,unit_ptr->ustarty,
              unit_ptr->unitx,unit_ptr->unity,unit_ptr->dimx,unit_ptr->dimy,.0,
                      0,0,1,1);
    }
 if (err != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when resizing the window...",
               OPERATION_ABORTED,NULL,0);
 PRT3(printf("win_resize_to_wid err = %d\n",err))
 return err;
}


/*-------------------------------------------------------------------------
WinResizeDefImgView - ???
-------------------------------------------------------------------------*/

int
WinResizeDefImgView(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct buf_2d_rec the_2d;
 int err;

 PRT7(printf("WinResizeDefImgView...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->unit.status2 & UNIT_2D_IN_USE)) return NO_ERROR;
 info = &(img->file->hdr.data_info);
 init_buf_2d_rec(&the_2d);
 PRT7(printf("WinResizeDefImgView...1\n"))
 if (((err = SetupBuf2dRec(&the_2d,info->dimx,info->dimy,
        info->pixel_depth_bits,InputDataTypeToBufType(info))) != NO_ERROR) ||
     ((err = win_setup_mask_bufs(win,0,0,the_2d.dimx,the_2d.dimy)) != NO_ERROR))
    {free_buf_2d_rec(&(img->_2d));
     return err;}
 PRT7(printf("WinResizeDefImgView...2\n"))
 free_buf_2d_rec(&(img->_2d));
 img->_2d = the_2d;
 initial_unit_2d_rec(&(img->unit));
 win->control.sroi.tolocal = NULL;
 win->control.sroi.localto = NULL;
 if ((err = RdSlice(img,0,NULL,0)) != NO_ERROR)
    return err;

 PRT7(printf("WinResizeDefImgView...status4 = %x\n",img->status4))
 win_execute_proc_to_multiple_wins(win,WinScaleViewScreenDimXY,
                         img->_2d.dimx,img->_2d.dimy,0,0,0);
 if (win->status4 & FILTER_ON) win_filter_image_data(win);
 PRT7(printf("WinResizeDefImgView..1.status4 = %x\n",img->status4))

 (void) notify_set_itimer_func((Notify_client) win,
         (Notify_func) WinResizeNewColorMultiCanvas,
         ITIMER_REAL,&NOTIFY_POLLING_ITIMER,
                           (struct itimerval *) 0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
WinResizeDefImgSize - ???
-------------------------------------------------------------------------*/

int
WinResizeDefImgSize(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;

 PRT7(printf("WinResizeDefImgSize...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->unit.status2 & UNIT_2D_IN_USE)) return NO_ERROR;
 info = &(img->file->hdr.data_info);
 return WinSetupResizeImage(win,.0,.0,info->xpixel_size,info->ypixel_size,
         info->dimx,info->dimy,.0,0,0,1,0);
}


/*-------------------------------------------------------------------------
WinResizeLastImgSize - ???
-------------------------------------------------------------------------*/

int
WinResizeLastImgSize(win)
 struct image_display_window *win;
{
 struct unit_2d_rec unit;
 struct img_buf_rec *img;
 int err;

 PRT7(printf("WinResizeLastImgSize...img->status4 = %x\n",img->status4))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->last_unit.status2 & UNIT_2D_IN_USE)) 
    {if (!(img->unit.status2 & UNIT_2D_IN_USE)) return NO_ERROR;
     unit = img->unit;
     if ((err = WinResizeDefImgView(win)) == NO_ERROR)
        {img->last_unit = unit;
        }
     return err;}
 PRT7(printf("WinResizeLastImgSize...1\n"))

 return WinSetupResizeImage(win,img->last_unit.ustartx,img->last_unit.ustarty,
      img->last_unit.unitx,img->last_unit.unity,
      img->last_unit.dimx,img->last_unit.dimy,.0,0,0,1,0);
}


/*-------------------------------------------------------------------------
win_zoom - ???
-------------------------------------------------------------------------*/

int
win_zoom(win,is_doom_in)
 struct image_display_window *win;
 int is_doom_in;
{
 struct img_buf_rec *img;
 unsigned long dimx,dimy,max,min;
 float unitx,unity,ustartx,ustarty,ratio,ratio1;
 struct int_region_rect *dim;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (is_doom_in)
    {dim = &(win->dwin->screen.dimension);
     if (dim->limitrr.width > dim->limitrr.height) max = dim->limitrr.height;
       else max = dim->limitrr.width;
     if (win->dwin->screen.dimension.magrect.left > 
                win->dwin->screen.dimension.magrect.top)
        max /= win->dwin->screen.dimension.magrect.left;
      else max /= win->dwin->screen.dimension.magrect.top;
    }
   else min = 20;

 if (img->unit.status2 & UNIT_2D_IN_USE)
    {if (is_doom_in)
        {dimx = img->unit.dimx * 2;
         dimy = img->unit.dimy * 2;}
       else
        {dimx = img->unit.dimx / 2;
         dimy = img->unit.dimy / 2;}

     ustartx = img->unit.ustartx;
     ustarty = img->unit.ustarty;
    }
   else
    {if (is_doom_in)
        {dimx = img->file->hdr.data_info.dimx * 2;
         dimy = img->file->hdr.data_info.dimy * 2;}
       else
        {dimx = img->file->hdr.data_info.dimx / 2;
         dimy = img->file->hdr.data_info.dimy / 2;}
     ustartx = .0;
     ustarty = .0;}

 if (is_doom_in)
    {if (dimx > max) dimx = max;
     if (dimy > max) dimy = max;}
   else
    {if (dimx < min) dimx = min;
     if (dimy < min) dimy = min;}

 PRT7(printf("win_zoom_in max = %d dimx = %d dimy = %d\n",max,dimx,dimy))
 if (img->unit.status2 & UNIT_2D_IN_USE)
    {ratio = (float) img->unit.dimy / (float) dimy;
     ratio1 = (float) img->unit.dimx / (float) dimx;
     if (ratio > ratio1) ratio = ratio1;
     unitx = img->unit.unitx * ratio;
     unity = img->unit.unity * ratio;
    }
   else
    {ratio = (float) img->file->hdr.data_info.dimy / (float) dimy;
     ratio1 = (float) img->file->hdr.data_info.dimx / (float) dimx;
     if (ratio > ratio1) ratio = ratio1;
     unitx = img->file->hdr.data_info.xpixel_size * ratio;
     unity = img->file->hdr.data_info.ypixel_size * ratio;
    }
 return WinSetupResizeImage(win,ustartx,ustarty,unitx,unity,dimx,dimy,.0,
                    0,0,1,0);
}


/*-------------------------------------------------------------------------
win_move_img - ???
-------------------------------------------------------------------------*/

int
win_move_img(win,x,y)
 struct image_display_window *win;
 float x,y;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct matrix_2d_rec mat;
 int err;
 float ustartx,ustarty,ustartx1,ustarty1,xpix,ypix,zpix;
 unsigned long dimx,dimy;

 PRT8(printf("win_move_img wid = %s x = %f  y = %f\n",win->owner->wid,x,y);)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
    return CANCEL;
 info = &(img->file->hdr.data_info);
 if (!(img->unit.status2 & UNIT_2D_IN_USE))
    {if ((err = WinImageUnitSize(win,&xpix,&ypix,&zpix,&dimx,&dimy)) != NO_ERROR) 
        return err;
     setup_unit_2d_rec(&(img->unit),.0,.0,
            xpix,ypix,dimx,dimy,.0,.0,
            info->xpixel_size,info->ypixel_size);
/*
     setup_unit_2d_rec(&(img->unit),.0,.0,
            info->xpixel_size,info->ypixel_size,info->dimx,info->dimy,.0,.0,
            info->xpixel_size,info->ypixel_size);
*/
     win->control.sroi.tolocal = &(img->unit.tolocal_mat);
     win->control.sroi.localto = &(img->unit.localto_mat);
    }
 setup_translate_2d_matrix(&mat,x,y);
 mult_2d_matrix(&(img->unit.localto_mat),&mat,&(img->unit.localto_mat));
 inverse_2d_matrix(&(img->unit.tolocal_mat),&(img->unit.localto_mat));
 PRT8(printf("win_move_img localto_mat  tolocal_mat\n");
      pr_2d_matrix(&(img->unit.localto_mat));
      pr_2d_matrix(&(img->unit.tolocal_mat));)
 if (!(img->status4 & IMG_MOVE_2D_VALID) || 
     !(img->move_2d.status4 & BUF_NON_EMPTY))
    {
     if ((err = copy_buf_2d_rec(&(img->move_2d),&(img->_2d))) == NO_ERROR)
        {img->status4 |= IMG_MOVE_2D_VALID;
         set_2d_ustart_xy(&(img->move_2d),x,y);}
     PRT5(printf("win_move_img  copy move_2d...err = %d\n",err))
    }
   else if (img->move_2d.status4 & BUF_USTARTXY_VALID)
    {img->move_2d.ustartx += x;
     PRT5(printf("win_move_img  BUF_USTARTXY_VALID\n"))
     img->move_2d.ustarty += y;}
   else set_2d_ustart_xy(&(img->move_2d),x,y);

 if ((img->status4 & IMG_MOVE_2D_VALID) &&
     (img->move_2d.status4 & BUF_NON_EMPTY))
    {ustartx = floor(img->move_2d.ustartx);
     ustartx1 = img->move_2d.ustartx - ustartx;
     ustarty = floor(img->move_2d.ustarty);
     ustarty1 = img->move_2d.ustarty - ustarty;
     PRT5(printf("win_move_img  move move_2d...ustartx = %f ustarty = %f\n",
              img->move_2d.ustartx,img->move_2d.ustarty))
     if ((ustartx1 == 0) && (ustarty1 == 0))
        {InitBuf2dRecData(&(img->_2d),(double) .0);
         PRT9(MinMax2dValues(&(img->_2d),0,(double) .0,(double) .0,&min4,&max4);
                 printf("img->_2d  _2d min4 = %f max4 = %f\n",min4,max4))
         PRT9(printf("win_move_img  move move_2d copy x = %d  y = %d\n",
              (long) ustartx,(long) ustarty))
         CpBuf2dRecByBound(&(img->_2d),0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
            (long) ustartx,(long) ustarty,
             &(img->move_2d),0,0,img->move_2d.dimx - 1,img->move_2d.dimy - 1);}
       else
        {setup_translate_2d_matrix(&mat,img->move_2d.ustartx,img->move_2d.ustarty);
         PRT9(printf("win_move_img  move move_2d ResizeBuf2dRec\n"))
         ResizeBuf2dRec(&(img->_2d),&(img->move_2d),img->_2d.dimx,
                img->_2d.dimy,&mat);}
     PRT9(MinMax2dValues(&(img->move_2d),0,(double) .0,(double) .0,&min4,&max4);
                 printf("move_2d  _2d min4 = %f max4 = %f\n",min4,max4))
     PRT9(pr_buf_2d_rec(&(img->move_2d)))
     PRT9(MinMax2dValues(&(img->_2d),0,(double) .0,(double) .0,&min4,&max4);
                 printf("after img->_2d  _2d min4 = %f max4 = %f\n",min4,max4))
     PRT9(pr_buf_2d_rec(&(img->_2d)))

     PRT8(printf("win_move_img self move...ok\n"))
     err = NO_ERROR;
    }
   else
    {PRT9(printf("win_move_img   RdSlice\n"))
     err = RdSlice(img,0,NULL,0);}

 win->status4 &= ~WIN_COLOR_DATA_UNCHANGED;
 if (err == NO_ERROR) WinNewColorMultiCanvas(win);
 PRT8(if (img->_2d.prog_status2 & BUF_DATA_NEW)
         printf("win_move_img   BUF_DATA_NEW\n");
        else printf("win_move_img   not BUF_DATA_NEW\n");)

 return err;
}


/*-------------------------------------------------------------------------
resize_region_proc - ???
-------------------------------------------------------------------------*/

void
resize_region_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct resize_rec *dp;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0)
    {xv_set(dp->exc,PANEL_VALUE,0,0);
     xv_set(dp->exc,PANEL_INACTIVE,TRUE,0);}
   else xv_set(dp->exc,PANEL_INACTIVE,FALSE,0);

}


/*-------------------------------------------------------------------------
resize_wid_now_proc - ???
-------------------------------------------------------------------------*/

void
resize_wid_now_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct resize_rec *dp;
 struct img_buf_rec *img;
 int region,use_orig,exc,err;
 struct image_display_window *win;
 float ustartx,ustarty,unitx,unity;
 unsigned long dimx,dimy;
 char *str;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 PRT7(printf("resize_wid_now_proc \n");)
 if ((err = win_cur_item_win_and_img(dp->win,dp->wid,&win,&img)) == NO_ERROR)
    {region = (int) xv_get(dp->region,PANEL_VALUE);
     exc = (int) xv_get(dp->exc,PANEL_VALUE);
     use_orig = (int) xv_get(dp->use_orig,PANEL_VALUE);
     str = (char *) xv_get(dp->ustartx,PANEL_VALUE);
     sscanf(str,"%f",&ustartx);
     str = (char *) xv_get(dp->ustarty,PANEL_VALUE);
     sscanf(str,"%f",&ustarty);
     str = (char *) xv_get(dp->unitx,PANEL_VALUE);
     sscanf(str,"%f",&unitx);
     str = (char *) xv_get(dp->unity,PANEL_VALUE);
     sscanf(str,"%f",&unity);
     dimx = (long) xv_get(dp->dimx,PANEL_VALUE);
     dimy = (long) xv_get(dp->dimy,PANEL_VALUE);
     if ((err = WinSetupResizeImage(win,ustartx,ustarty,unitx,unity,dimx,dimy,.0,
                      exc,region,1,1)) != NO_ERROR)
        ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when resizing the window...",
               OPERATION_ABORTED,NULL,0);
    }
   else win_alarm(dp->frame,2);
 PRT7(printf("resize_wid_now_proc err = %d\n",err);)
}


/*-------------------------------------------------------------------------
resize_check_dim - ???
-------------------------------------------------------------------------*/

int
resize_check_dim(dp,item)
 struct resize_rec *dp;
 Panel_item item;
{
 struct img_buf_rec *img;
 struct data_info_rec *info;
 struct image_display_window *win;
 char *str1;
 float ustartx,ustarty,unitx,unity,lastx,lasty,sizex,sizey;
 unsigned long dimx,dimy;

 PRT4(printf("resize_check_dim 1\n"))
 if (win_cur_item_win_and_img(dp->win,item,&win,&img) == NO_ERROR)
    {
     PRT4(printf("resize_check_dim 2\n"))
     if (((str1 = (char *) xv_get(dp->ustartx,PANEL_VALUE)) == NULL) ||
         (sscanf(str1,"%f",&ustartx) != 1) ||
         ((str1 = (char *) xv_get(dp->ustarty,PANEL_VALUE)) == NULL) ||
         (sscanf(str1,"%f",&ustarty) != 1) ||
         ((str1 = (char *) xv_get(dp->unitx,PANEL_VALUE)) == NULL) ||
         (sscanf(str1,"%f",&unitx) != 1) ||
         ((str1 = (char *) xv_get(dp->unity,PANEL_VALUE)) == NULL) ||
         (sscanf(str1,"%f",&unity) != 1))
        {win_alarm(dp->frame,2);
         resize_wid_info(dp,item);
         return CANCEL;}
     info = &(img->file->hdr.data_info);
     sizex = info->dimx * info->xpixel_size;
     sizey = info->dimy * info->ypixel_size;
     dimx = (long) xv_get(dp->dimx,PANEL_VALUE);
     dimy = (long) xv_get(dp->dimy,PANEL_VALUE);
     lastx = ustartx + dimx * unitx;
     lasty = ustarty + dimy * unity;
     PRT4(printf("sizex = %f y = %f dimx = %d y = %d lastx = %f y = %f\n",
          sizex,sizey,dimx,dimy,lastx,lasty))
     PRT4(printf("ustartx = %f y = %f unitx = %f y = %f\n",
          ustartx,ustarty,unitx,unity))
     if ((lastx < .0) || (ustartx >= sizex) ||
         (lasty < .0) || (ustarty >= sizey) ||
         (lastx > 2 * sizex) || (lasty > 2 * sizey))
        {win_alarm(dp->frame,2);
         resize_wid_info(dp,item);
         return CANCEL;}
     return NO_ERROR;
    }
 return CANCEL;
}


/*-------------------------------------------------------------------------
resize_dim_proc - ???
-------------------------------------------------------------------------*/

void
resize_dim_proc(item,str,event)
 Panel_item item;
 char *str;
 Event *event;
{
 struct resize_rec *dp;
 struct img_buf_rec *img;
 struct image_display_window *win;
 struct data_info_rec *info;
 char *str1;
 float unitx,unity,size,sunitx,sunity;
 unsigned long dimx,dimy,num;

 PRT4(printf("resize_dim_proc \n"))
 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 PRT4(printf("resize_dim_proc 1\n"))
/*
 if (resize_check_dim(dp,dp->wid) != NO_ERROR) return;
*/
 if (win_cur_item_win_and_img(dp->win,dp->wid,&win,&img) != NO_ERROR) return;

 PRT4(printf("resize_dim_proc 2\n"))
 info = &(img->file->hdr.data_info);
 str1 = (char *) xv_get(dp->unitx,PANEL_VALUE);
 sscanf(str1,"%f",&unitx);
 str1 = (char *) xv_get(dp->unity,PANEL_VALUE);
 sscanf(str1,"%f",&unity);
 num = (long) xv_get(dp->endx,PANEL_VALUE);
 size = info->dimx * info->xpixel_size / unitx;
 dimx = (long) floor((double) (size + .5));
 if (GetUnitXY(&(img->_2d),&sunitx,&sunity) != NO_ERROR)
    {sunitx = info->xpixel_size;
     sunity = info->ypixel_size;}
 if (dimx <= 1) 
    {num = 1;
     dimx = 2;}
   else num = (long) rint((double) (num * sunitx / unitx));
/*
 xv_set(dp->dimx,PANEL_VALUE,num,PANEL_MAX_VALUE,dimx,0);
*/
 xv_set(dp->dimx,PANEL_VALUE,num,0);

 num = (long) xv_get(dp->endy,PANEL_VALUE);
 size = info->dimy * info->ypixel_size / unity;
 dimy = (long) floor((double) (size + .5));
 if (dimy <= 1)
    {num = 1;
     dimy = 2;}
   else num = (long) rint((double) (num * sunity / unity));
/*
 xv_set(dp->dimy,PANEL_VALUE,num,PANEL_MAX_VALUE,dimy,0);
*/
 xv_set(dp->dimy,PANEL_VALUE,num,0);
 resize_check_dim(dp,dp->wid);
}


/*-------------------------------------------------------------------------
resize_pixel_dim_proc - ???
-------------------------------------------------------------------------*/

void
resize_pixel_dim_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct resize_rec *dp;
 struct img_buf_rec *img;
 struct image_display_window *win;
 struct data_info_rec *info;
 float unitx,unity,sunitx,sunity,fdx,fdy;
 char str[100];
 int dx,dy,temp_int,endx,endy;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
/*
 if (resize_check_dim(dp,dp->wid) != NO_ERROR) return;
*/
 PRT4(printf("resize_dim_proc 1\n"))
 if (win_cur_item_win_and_img(dp->win,dp->wid,&win,&img) != NO_ERROR) return;
 dx = (int) xv_get(dp->dimx,PANEL_VALUE);
 dy = (int) xv_get(dp->dimy,PANEL_VALUE);
 fdx = (float) dx;
 fdy = (float) dy;
 if (xv_get(dp->auto_ratio,PANEL_VALUE))
    {if (item == dp->dimx)
        {fdy = (float)dx * (float) img->file->hdr.data_info.dimy / 
                     (float) img->file->hdr.data_info.dimx;
         temp_int = (int) fdy;
         if (temp_int <= 0)
            {fdy = 1.0;
             temp_int = 1;}
         PRT10(printf("temp_int = %d dy = %d fdy = %f\n",temp_int,dy,fdy))
         if (temp_int != dy)
            {dy = temp_int;
             xv_set(dp->dimy,PANEL_VALUE,dy,0);}
        }
       else
        {fdx = (float) dy * (float) img->file->hdr.data_info.dimx / 
                     (float) img->file->hdr.data_info.dimy;
         temp_int = (int) fdx;
         if (temp_int <= 0) 
            {fdx = 1.0;
             temp_int = 1;}
         PRT10(printf("temp_int = %d dx = %d fdx = %f\n",temp_int,dx,fdx))
         if (temp_int != dx)
            {dx = temp_int;
             xv_set(dp->dimx,PANEL_VALUE,dx,0);}
        }
    }

 endx = (long) xv_get(dp->endx,PANEL_VALUE);
 endy = (long) xv_get(dp->endy,PANEL_VALUE);
 if (GetUnitXY(&(img->_2d),&sunitx,&sunity) != NO_ERROR)
    {info = &(img->file->hdr.data_info);
     sunitx = info->xpixel_size;
     sunity = info->ypixel_size;}
 unitx = endx * sunitx / fdx;
 unity = endy * sunity / fdy;

 sprintf(str,"%.6f",unitx);
 sscanf(str,"%f",&unitx);
 if (unitx < .0) unitx = .000001;
 xv_set(dp->unitx,PANEL_VALUE,str,0);

 sprintf(str,"%.6f",unity);
 sscanf(str,"%f",&unity);
 if (unity < .0) unity = .000001;
 xv_set(dp->unity,PANEL_VALUE,str,0);
 resize_check_dim(dp,dp->wid);
}


/*-------------------------------------------------------------------------
resize_wid_info_proc - ???
-------------------------------------------------------------------------*/

void
resize_wid_info_proc(item,wid,client_data,op,event)
 Panel_item item;
 char *wid;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct resize_rec *dp;

 PRT4(printf("draw_wid_list_proc op = %d\n",op))
 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 resize_wid_def_info(dp,dp->wid);
 resize_wid_info(dp,dp->wid);
}


/*-------------------------------------------------------------------------
resize_auto_ratio_proc - ???
-------------------------------------------------------------------------*/

void
resize_auto_ratio_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct resize_rec *dp;
 int val;

 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0)
     return /*NO_ERROR*/;
 val = (int) xv_get(dp->dimx,PANEL_VALUE);
 resize_pixel_dim_proc(dp->dimx,val,event);
}


/*-------------------------------------------------------------------------
resize_equal_to_wid_proc - ???
-------------------------------------------------------------------------*/

void
resize_equal_to_wid_proc(item,wid,client_data,op,event)
 Panel_item item;
 char *wid;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct resize_rec *dp;

 PRT4(printf("resize_equal_to_wid_proc op = %d\n",op))
 dp = (struct resize_rec *) xv_get(item,PANEL_CLIENT_DATA);
 resize_wid_info(dp,dp->equal_to_wid);
}


/*-------------------------------------------------------------------------
setup_resize_rec - ???
-------------------------------------------------------------------------*/

int
setup_resize_rec(dp,win)
 struct resize_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr,*rr1;
 Panel_item item;
 struct img_buf_rec *img;
 struct data_info_rec *info;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              0);
 PRT(printf("setup_resize_rec...1\n"))
 if (dp->frame == 0)
    {free_resize_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,RESIZE_IMAGE);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_resize_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 PRT(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_resize_rec(dp);
     return CANCEL;}
 row = 2;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 12;
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"RESIZE",
	PANEL_NOTIFY_PROC,resize_wid_now_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"WID",
	PANEL_NOTIFY_PROC,resize_get_wids_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 dp->wid = xv_create(dp->panel,PANEL_LIST,
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_LIST_WIDTH,80,
        PANEL_LAYOUT,PANEL_VERTICAL,
        XV_X,5,XV_Y,rr->r_top + rr->r_height,
	PANEL_NOTIFY_PROC,resize_wid_info_proc,
        PANEL_CLIENT_DATA,dp,
        0);
 item = xv_create(dp->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"WID DEFAULT",
	PANEL_NOTIFY_PROC,resize_default_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,dp,
	0);
 rr1 = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"DIMENSION INFO...",
        XV_X,rr1->r_left + rr1->r_width + 5,XV_Y,row,
	0);
 row += offset - 1;
 item = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"STARTX = .0    ",
        XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
	0);
 rr1 = (Rect *) xv_get(item,XV_RECT);
 xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"STARTY = .0",
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
 row += offset - 6;
 dp->def_unitx = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"UNIT X =",
        XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
	0);
 rr1 = (Rect *) xv_get(dp->def_unitx,XV_RECT);
 dp->def_unity = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"UNIT Y =",
        XV_X,rr1->r_left + rr1->r_width + 60,XV_Y,row,
	0);
 row += offset - 6;
 dp->def_dimx = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"DIM X =",
        XV_X,rr->r_left + rr->r_width + 10,XV_Y,row,
	0);
 rr1 = (Rect *) xv_get(dp->def_dimx,XV_RECT);
 dp->def_dimy = xv_create(dp->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"DIM Y =",
        XV_X,rr1->r_left + rr1->r_width + 60,XV_Y,row,
	0);

 row += offset;
 dp->ustartx = xv_create(dp->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"STARTX",
        PANEL_VALUE_DISPLAY_LENGTH,7,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_dim_proc,
        PANEL_CLIENT_DATA,dp,
	0);
 rr1 = (Rect *) xv_get(dp->ustartx,XV_RECT);
 dp->ustarty = xv_create(dp->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"STARTY",
        PANEL_VALUE_DISPLAY_LENGTH,7,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_dim_proc,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset - 3;
 info = &(img->file->hdr.data_info);
 dp->endx = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"END X",
	PANEL_SLIDER_WIDTH,50,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,info->dimx,
        PANEL_VALUE,info->dimx,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 row += offset;
 dp->endy = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"END Y",
	PANEL_SLIDER_WIDTH,50,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,info->dimy,
        PANEL_VALUE,info->dimy,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);

 row += offset - 3;
 dp->unitx = xv_create(dp->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"NEW UNIT X",
        PANEL_VALUE_DISPLAY_LENGTH,15,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_dim_proc,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset - 3;
 dp->unity = xv_create(dp->panel,PANEL_TEXT,
	PANEL_LABEL_STRING,"NEW UNIT Y",
        PANEL_VALUE_DISPLAY_LENGTH,15,
        PANEL_VALUE_STORED_LENGTH,15,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_dim_proc,
        PANEL_CLIENT_DATA,dp,
	0);
 row += offset - 3;
 dp->dimx = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"NEW DIM X",
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_pixel_dim_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,2000,
	0);
 row += offset;
 dp->dimy = xv_create(dp->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"NEW DIM Y",
	PANEL_SLIDER_WIDTH,50,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_NOTIFY_PROC,resize_pixel_dim_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_MIN_VALUE,1,
        PANEL_MAX_VALUE,2000,
	0);
 row += offset;
 dp->auto_ratio = xv_create(dp->panel,PANEL_CHECK_BOX,
	PANEL_LABEL_STRING,"MAINTAIN RATIO",
        PANEL_CLIENT_DATA,dp,
	PANEL_NOTIFY_PROC,resize_auto_ratio_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);

 rr = (Rect *) xv_get(dp->wid,XV_RECT);
 dp->equal_to_wid = xv_create(dp->panel,PANEL_LIST,
	PANEL_LABEL_STRING,"= WID",
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_LIST_WIDTH,80,
        PANEL_LAYOUT,PANEL_VERTICAL,
        XV_X,5,XV_Y,rr->r_top + rr->r_height,
	PANEL_NOTIFY_PROC,resize_equal_to_wid_proc,
        PANEL_CLIENT_DATA,dp,
        0);

 WinSetupWindowListItem(dp->win,dp->wid,1,IMAGE_WINDOWS);
 WinSetupWindowListItem(dp->win,dp->equal_to_wid,1,IMAGE_WINDOWS);
 if ((str = WinRecGetWid(dp->win->owner,dp->win->type2)) != NULL)
    {select_list_str_item(str,dp->wid,1);
     select_list_str_item(str,dp->equal_to_wid,1);
    }
 resize_wid_def_info(dp,dp->wid);
 resize_wid_info(dp,dp->wid);
 row += offset;
 dp->use_orig = xv_create(dp->panel,PANEL_CHECK_BOX,
                  PANEL_CHOICE_STRINGS,"USE ORIGINAL IMAGE FOR RESIZING",0,
                  PANEL_VALUE,0,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  0);
 row += offset;
 dp->exc = xv_create(dp->panel,PANEL_CHECK_BOX,
                  PANEL_CHOICE_STRINGS,"EXCLUDING",0,
 	          PANEL_VALUE,0,
                  PANEL_INACTIVE,TRUE,
                  XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  0);
 rr1 = (Rect *) xv_get(dp->exc,XV_RECT);
 item = xv_create(dp->panel,PANEL_MESSAGE,
	          PANEL_LABEL_STRING,"RESIZED AREA",
                  XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
                  0);
 row += offset - 8;
 dp->region = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,WHOLE_SLICE_STR,
                           CUR_CURVE_STR,CUR_ROI_STR,
                           ALL_ROIS_STR,VIEW_FILTER_ROI_STR,NULL,
                  PANEL_VALUE,0,
	          PANEL_NOTIFY_PROC,resize_region_proc,
                  XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
                  PANEL_CLIENT_DATA,dp,
                  0);

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 13,XV_WIDTH,rr->r_width - 15,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_resize_rec - ???
-------------------------------------------------------------------------*/

struct resize_rec *
find_resize_rec(all_dps,win)
 struct all_resize_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
enter_resize_image - ???
-------------------------------------------------------------------------*/

int
enter_resize_image(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_resize_recs all_dps;
 struct resize_rec *dp;
 static char first_time = 1;
 int err;

 PRT(printf("enter_resize_image...0\n"))
 err = NO_ERROR;
 if (first_time)
    {init_all_resize_recs(&all_dps);
     first_time = 0;}
 if (status == GET_ALL_DP_PTR)
    {return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEANUP_DP)
   {if ((dp = find_resize_rec(&all_dps,win)) != NULL)
       free_resize_rec(dp);
    return NO_ERROR;}
 PRT(printf("enter_resize_image...1\n"))
 if ((dp = find_resize_rec(&all_dps,win)) != NULL)
    {xv_set(dp->frame,
               XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
     win_set_mouse_at_center(dp->frame);
     wmgr_top(dp->frame);
     return NO_ERROR;}

 PRT(printf("enter_resize_image...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct resize_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_resize_rec(dp);
 PRT(printf("enter_resize_image...2\n"))
 if ((err = setup_resize_rec(dp,win)) == NO_ERROR)
    {PRT(printf("setup_resize_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               RESIZE_IMAGE,NULL,0);
 return err;

}

