/****************************************************************************
dp_trans_roi.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: dp_trans_roi.c,v 1.11 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME: Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



#define CLEAN_UP_TRANS_ROI_OPTIONS 0
#define SETUP_TRANS_ROI_OPTIONS 1
#define GET_ALL_DP_PTR 2

struct dp_trans_roi_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item trans_type,all_slices,which_region,move_offset,
               which,overwrite;
   };

struct all_dp_trans_roi_recs
   {
    int num_dps;
    struct dp_trans_roi_rec **dps;
   };


/* Functions defined in this file */
void init_dp_trans_roi_rec(struct dp_trans_roi_rec *dp);
void free_dp_trans_roi_rec(struct dp_trans_roi_rec *dp);
void init_all_dp_trans_roi_recs(struct all_dp_trans_roi_recs *all_dps);
void dp_trans_rois_frame_done_proc(Frame frame);
void trans_more_proc(Panel_item item, Event event);
void slice_roi_prior_proc(Panel_item item, Event event);
void slice_roi_next_proc(Panel_item item, Event event);
void trans_overwrite_proc(Panel_item item, int value, Event *event);
void trans_apply_proc(Panel_item item, int value, Event *event);
void trans_offset_proc(Panel_item item, int value, Event event);
void trans_show_label_proc(Panel_item item, int value, Event event);
void trans_all_slices_proc(Panel_item item, int value, Event event);
void trans_type_proc(Panel_item item, int value, Event event);
void trans_which_region_proc(Panel_item item, int value, Event event);
void update_dp_trans_roi_params(struct dp_trans_roi_rec *dp);
int setup_dp_trans_roi_rec(struct dp_trans_roi_rec *dp,
    struct image_display_window *win);
struct dp_trans_roi_rec *find_dp_trans_roi_rec(
   struct all_dp_trans_roi_recs *all_dps, struct image_display_window *win);
void update_dp_trans_roi(struct image_display_window *win);
int win_move_group_slice_rois_prior(struct image_display_window *win,
    int offset);
int win_move_cur_slice_rois(struct image_display_window *win, int offset,
    int overwrite);
int win_move_group_slice_rois_next(struct image_display_window *win,
    int offset);
int win_move_slice_rois_prior(struct image_display_window *win);
int win_move_slice_rois_next(struct image_display_window *win);
int enter_dp_trans_roi(struct image_display_window *win, int status);



/*-------------------------------------------------------------------------
init_dp_trans_roi_rec - ???
-------------------------------------------------------------------------*/

void
init_dp_trans_roi_rec(dp)
 struct dp_trans_roi_rec *dp;
{
 dp->status = 0;
 dp->win = NULL;
 dp->frame = 0;
}


/*-------------------------------------------------------------------------
free_dp_trans_roi_rec - ???
-------------------------------------------------------------------------*/

void
free_dp_trans_roi_rec(dp)
 struct dp_trans_roi_rec *dp;
{
 struct all_dp_trans_roi_recs *all_dps;

 if (dp->frame != 0)
    {xv_destroy_safe(dp->frame);
     dp->frame = 0;
    }
 c_free(dp);
 all_dps = (struct all_dp_trans_roi_recs *) 
           enter_dp_trans_roi(NULL,GET_ALL_DP_PTR);
 DropHandleAryPtr(&(all_dps->dps),&(all_dps->num_dps),dp);
 TRACE(printf("free_dp_trans_roi_rec...end\n"))
}


/*-------------------------------------------------------------------------
init_all_dp_trans_roi_recs - ???
-------------------------------------------------------------------------*/

void
init_all_dp_trans_roi_recs(all_dps)
 struct all_dp_trans_roi_recs *all_dps;
{
 all_dps->num_dps = 0;
 all_dps->dps = NULL;
}


/*-------------------------------------------------------------------------
dp_trans_rois_frame_done_proc - ???
-------------------------------------------------------------------------*/

void
dp_trans_rois_frame_done_proc(frame)
 Frame frame;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_dp_trans_roi_rec(dp);
}


/*-------------------------------------------------------------------------
trans_more_proc - ???
-------------------------------------------------------------------------*/

void
trans_more_proc(item,event)
 Panel_item item;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 notice_prompt(dp->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
               "WHEN THE MOVE_ROI CURSOR IS ENABLED...",
               "..1) <>1..9/<Sh><>1..9",
               "--- move forward/backward by 1..9 in the x direction",
               "..2) [<>/<Sh><>] <KEYPAD-digit>",
               "--- move forward/backward by <digit> pixel in the y direction",
               "",
               "WHEN THE SCALE_ROI CURSOR IS ENABLED...",
               "..1) <>1..9/<Sh><>1..9",
               "--- enlarge by 1..9 & shrink to 1/10..9/10",
               "..2) [<>/<Sh><>] <KEYPAD-digit>",
               "--- enlarge & shrink by <digit> * 10% in the x direction",
               "..3) [<><Ctrl>/<Sh><><Ctrl>] <KEYPAD-digit>",
               "--- enlarge & shrink by <digit> * 10% in the y direction",
               "",
               "WHEN THE ROTATE_ROI CURSOR IS ENABLED...",
               "..1) <>1..9/<Sh><>1..9",
               "--- rotate [anti]-clockwise by 1..9 degrees",
               "..2) <>[<Sh>] <KEYPAD-digit>",
               "--- rotate [anti]-clockwise by <digit> * 10 degrees",
              0,
            NOTICE_BUTTON_YES," OK !",
            0);

}


/*-------------------------------------------------------------------------
slice_roi_prior_proc - ???
-------------------------------------------------------------------------*/

void
slice_roi_prior_proc(item,event)
 Panel_item item;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_move_slice_rois_prior(dp->win);
}


/*-------------------------------------------------------------------------
slice_roi_next_proc - ???
-------------------------------------------------------------------------*/

void
slice_roi_next_proc(item,event)
 Panel_item item;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_move_slice_rois_next(dp->win);
}


/*-------------------------------------------------------------------------
trans_overwrite_proc - ???
-------------------------------------------------------------------------*/

void
trans_overwrite_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;
 long lcv;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(dp->win,GET_ALL_DP_PTR)) != NULL)
    for (lcv = 0 ;lcv < all_dps->num_dps; lcv++)
       if (all_dps->dps[lcv] != dp)
          xv_set(all_dps->dps[lcv]->overwrite,PANEL_VALUE,value,0);
}


/*-------------------------------------------------------------------------
trans_apply_proc - ???
-------------------------------------------------------------------------*/

void
trans_apply_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;
 long lcv;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value)
    xv_set(dp->overwrite,PANEL_INACTIVE,FALSE,0);
   else xv_set(dp->overwrite,PANEL_INACTIVE,TRUE,0);
 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(dp->win,GET_ALL_DP_PTR)) != NULL)
    for (lcv = 0 ;lcv < all_dps->num_dps; lcv++)
       if (all_dps->dps[lcv] != dp)
          {if (value)
              {xv_set(all_dps->dps[lcv]->which,PANEL_VALUE,1,0);
               xv_set(all_dps->dps[lcv]->overwrite,PANEL_INACTIVE,FALSE,0);}
             else
              {xv_set(all_dps->dps[lcv]->which,PANEL_VALUE,0,0);
               xv_set(all_dps->dps[lcv]->overwrite,PANEL_INACTIVE,TRUE,0);}
          }

}


/*-------------------------------------------------------------------------
trans_offset_proc - ???
-------------------------------------------------------------------------*/

void
trans_offset_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;
 long lcv;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(dp->win,GET_ALL_DP_PTR)) != NULL)
    for (lcv = 0 ;lcv < all_dps->num_dps; lcv++)
       if (all_dps->dps[lcv] != dp)
          xv_set(all_dps->dps[lcv]->move_offset,PANEL_VALUE,value,0);

}


/*-------------------------------------------------------------------------
trans_show_label_proc - ???
-------------------------------------------------------------------------*/

void
trans_show_label_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value) dp->win->control.display_options |= DISPLAY_ACTION_LABEL;
   else dp->win->control.display_options &= ~DISPLAY_ACTION_LABEL;
 win_execute_proc_to_multiple_wins(dp->win,win_action_label,0,0,0,0,0);     
}


/*-------------------------------------------------------------------------
trans_all_slices_proc - ???
-------------------------------------------------------------------------*/

void
trans_all_slices_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value) dp->win->control.status |= ACTION_ON_ALL_SLICES;
   else dp->win->control.status &= ~ACTION_ON_ALL_SLICES;
 win_execute_proc_to_multiple_wins(dp->win,win_action_label,0,0,0,0,0);     
}


/*-------------------------------------------------------------------------
trans_type_proc - ???
-------------------------------------------------------------------------*/

void
trans_type_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (value == 0) win_select_cursor(dp->win,CURSOR_MOVE_ROI);
   else if (value == 2) win_select_cursor(dp->win,CURSOR_RESIZE_ROI);
   else win_select_cursor(dp->win,CURSOR_ROTATE_ROI);
}


/*-------------------------------------------------------------------------
trans_which_region_proc - ???
-------------------------------------------------------------------------*/

void
trans_which_region_proc(item,value,event)
 Panel_item item;
 int value;
 Event event;
{
 struct dp_trans_roi_rec *dp;

 dp = (struct dp_trans_roi_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dp->win->control.status &= ~ACTION_ON_ALL_ROIS;
 dp->win->control.status &= ~ACTION_ON_CUR_ROI;
 if (value == 0) dp->win->control.status |= ACTION_ON_ALL_ROIS;
   else if (value == 1) dp->win->control.status |= ACTION_ON_CUR_ROI;
 win_execute_proc_to_multiple_wins(dp->win,win_action_label,0,0,0,0,0);     
}


/*-------------------------------------------------------------------------
update_dp_trans_roi_params - ???
-------------------------------------------------------------------------*/

void
update_dp_trans_roi_params(dp)
 struct dp_trans_roi_rec *dp;
{
 int temp;

 if (dp->win->control.status & ACTION_ON_ALL_SLICES)
    xv_set(dp->all_slices,PANEL_VALUE,1,0);
   else xv_set(dp->all_slices,PANEL_VALUE,0,0);
 if (dp->win->control.which_cursor == CURSOR_ROTATE_ROI) temp = 1;
   else if (dp->win->control.which_cursor == CURSOR_RESIZE_ROI) temp = 2;
   else temp = 0;
 xv_set(dp->trans_type,PANEL_VALUE,temp,0);

 if (dp->win->control.status & ACTION_ON_ALL_ROIS)
    temp = 0;
   else if (dp->win->control.status & ACTION_ON_CUR_ROI)
    temp = 1;
   else temp = 2;
 xv_set(dp->which_region,PANEL_VALUE,temp,0);
}


/*-------------------------------------------------------------------------
setup_dp_trans_roi_rec - ???
-------------------------------------------------------------------------*/

int
setup_dp_trans_roi_rec(dp,win)
 struct dp_trans_roi_rec *dp;
 struct image_display_window *win;
{
 char *str;
 int row,offset;
 Rect *rr;
 Panel_item item;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return 0;
 dp->win = win;
 dp->dwin = win->dwin;
 dp->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_dp_trans_roi_rec...1\n"))
 if (dp->frame == 0)
    {free_dp_trans_roi_rec(dp);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,TRANS_ROI);
 xv_set(dp->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,dp_trans_rois_frame_done_proc,
              WIN_CLIENT_DATA,dp,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 dp->panel = xv_create(dp->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (dp->panel == 0)
    {free_dp_trans_roi_rec(dp);
     return CANCEL;}
 row = 2;
 offset = xv_rows(dp->panel,1) - xv_rows(dp->panel,0) - 10;
 item = xv_create(dp->panel,PANEL_MESSAGE,
          PANEL_LABEL_STRING,"MOVE",
          XV_X,2,XV_Y,row + 2,
          0);
 rr = (Rect *) xv_get(item,XV_RECT);
 dp->which = xv_create(dp->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"ALL SLICES",
                           "CUR SLICE",NULL,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
                  PANEL_NOTIFY_PROC,trans_apply_proc,
                  PANEL_CLIENT_DATA,dp,
                  0);
 rr = (Rect *) xv_get(dp->which,XV_RECT);
 dp->overwrite = xv_create(dp->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"OVERWRITE",NULL,
        PANEL_NOTIFY_PROC,trans_overwrite_proc,
        PANEL_VALUE,1,
        PANEL_CLIENT_DATA,dp,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 xv_set(dp->overwrite,PANEL_INACTIVE,TRUE,0);
 row += offset;

 item = xv_create(dp->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"<<-<>F6",
                   PANEL_NOTIFY_PROC,slice_roi_prior_proc,
                   XV_X,15,XV_Y,row,
                   PANEL_CLIENT_DATA,dp,
                   0);

 rr = (Rect *) xv_get(item,XV_RECT);
 dp->move_offset = xv_create(dp->panel,PANEL_SLIDER,
 	           PANEL_LABEL_STRING,"BY",
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                       PANEL_VALUE,1,
                       PANEL_MIN_VALUE,(int) 1,
                       PANEL_MAX_VALUE,
                       win_total_slice_cuts(win->owner),
 	               PANEL_SLIDER_WIDTH,30,
                   PANEL_CLIENT_DATA,dp,
                  PANEL_NOTIFY_PROC,trans_offset_proc,
                       0);
 rr = (Rect *) xv_get(dp->move_offset,XV_RECT);
 xv_create(dp->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,">>-<>F7",
                   PANEL_NOTIFY_PROC,slice_roi_next_proc,
                   XV_X,rr->r_left + rr->r_width+1,XV_Y,row,
                   PANEL_CLIENT_DATA,dp,
                   0);


 row += offset - 4;
 xv_create(dp->panel,PANEL_BUTTON,
 	       PANEL_LABEL_STRING,"MORE...",
               PANEL_NOTIFY_PROC,trans_more_proc,
               XV_X,5,XV_Y,row,
               PANEL_CLIENT_DATA,dp,
               0);

 row += offset - 4;
 item = xv_create(dp->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"SHOW LABEL",NULL,
        PANEL_NOTIFY_PROC,trans_show_label_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
        0);
 if (dp->win->control.display_options & DISPLAY_ACTION_LABEL)
    xv_set(item,PANEL_VALUE,1,0);
   else xv_set(item,PANEL_VALUE,0,0);

 dp->all_slices = xv_create(dp->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,ALL_SLICES_ITEM_LABEL,NULL,
        PANEL_VALUE,0,
        PANEL_NOTIFY_PROC,trans_all_slices_proc,
        PANEL_CLIENT_DATA,dp,
        XV_Y,row,
        0);
 row += offset;
 dp->trans_type = xv_create(dp->panel,PANEL_CHOICE,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,TRUE,
        PANEL_CHOICE_STRINGS,
        CURSOR_MOVE_ROI_LABEL,CURSOR_ROTATE_ROI_LABEL,CURSOR_RESIZE_ROI_LABEL,NULL,
        PANEL_NOTIFY_PROC,trans_type_proc,
        PANEL_CLIENT_DATA,dp,
        XV_X,5,XV_Y,row,
        0);

 rr = (Rect *) xv_get(dp->trans_type,XV_RECT);
 dp->which_region = xv_create(dp->panel,PANEL_CHOICE,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_CHOOSE_ONE,TRUE,
        PANEL_CHOICE_STRINGS,
              ALL_ROIS_ITEM_LABEL,CUR_ROI_ITEM_LABEL,CUR_CURVE_ITEM_LABEL,NULL,
        PANEL_NOTIFY_PROC,trans_which_region_proc,
        PANEL_CLIENT_DATA,dp,
        PANEL_VALUE,2,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 update_dp_trans_roi_params(dp);

 window_fit(dp->panel);
 rr = (Rect *) xv_get(dp->panel,XV_RECT);
 xv_set(dp->panel,XV_HEIGHT,rr->r_height - 13,XV_WIDTH,rr->r_width - 5,0);
 window_fit(dp->frame);
 make_2_wins_adjacent(dp->frame,win->dwin->frame,0);
 win_set_mouse_at_center(dp->frame);
 xv_set(dp->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*-------------------------------------------------------------------------
find_dp_trans_roi_rec - ???
-------------------------------------------------------------------------*/

struct dp_trans_roi_rec *
find_dp_trans_roi_rec(all_dps,win)
 struct all_dp_trans_roi_recs *all_dps;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_dps->num_dps; lcv++)
    if (all_dps->dps[lcv]->win == win) return all_dps->dps[lcv];
 return NULL;
}


/*-------------------------------------------------------------------------
update_dp_trans_roi - ???
-------------------------------------------------------------------------*/

void
update_dp_trans_roi(win)
 struct image_display_window *win;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;

 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(win,GET_ALL_DP_PTR)) != NULL)
    {if ((dp = find_dp_trans_roi_rec(all_dps,win)) != NULL)
        {update_dp_trans_roi_params(dp);
        }
    }
}


/*-------------------------------------------------------------------------
win_move_group_slice_rois_prior - ???
-------------------------------------------------------------------------*/

int
win_move_group_slice_rois_prior(win,offset)
 struct image_display_window *win;
 int offset;
{
 struct img_buf_rec *img;
 long lcv,last;
 struct slice_roi_win_rec **sroi_wins;

 TRACE(printf("win_move_group_slice_rois_prior...win = %u\n",win))
 if ((img = (struct img_buf_rec *) win_rec_cur_img_buf(win->owner)) == NULL) 
    return NO_ERROR;
 if (img->file->slice_info.max_sroi_wins == 0) return NO_ERROR;
 if (offset > img->file->slice_info.max_sroi_wins)
    offset = img->file->slice_info.max_sroi_wins;

 sroi_wins = img->file->slice_info.sroi_wins;
 for (lcv = 0; lcv < offset; lcv++)
    free_slice_roi_rec(&(sroi_wins[lcv]->slice_roi));
 last = img->file->slice_info.max_sroi_wins - 1;

 for (lcv = offset; lcv <= last; lcv++)
    sroi_wins[lcv - offset]->slice_roi = sroi_wins[lcv]->slice_roi;
 if (last != 0)
    {for (lcv = last - offset + 1; lcv <= last; lcv++)
        {init_slice_roi_rec(&(sroi_wins[lcv]->slice_roi));
         setup_slice_roi_rec_dim(&(sroi_wins[lcv]->slice_roi),
            img->file->hdr.data_info.dimx,img->file->hdr.data_info.dimy);}
    }
 img->file->output.status |= FILE_TO_BE_SAVED;
 TRACE(printf("win_move_group_slice_rois_prior...1\n");)
 return win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,1,0,0,0);
}


/*-------------------------------------------------------------------------
win_move_cur_slice_rois - ???
-------------------------------------------------------------------------*/

int
win_move_cur_slice_rois(win,offset,overwrite)
 struct image_display_window *win;
 int offset,overwrite;
{
 struct img_buf_rec *img;
 long cur_slice_num,next_slice_num;
 struct slice_roi_win_rec **sroi_wins;

 PRT(printf("win_move_cur_slice_rois...offset = %d overwrite = %d\n",
             offset,overwrite))
 if ((img = (struct img_buf_rec *) win_rec_cur_img_buf(win->owner)) == NULL) 
    return NO_ERROR;
 if (img->file->slice_info.max_sroi_wins == 0) return NO_ERROR;
 cur_slice_num = img->cur_slice->slice_num;
       /*img->cur_slice->slice->image_type_indx;*/
 next_slice_num = cur_slice_num + offset;
 sroi_wins = img->file->slice_info.sroi_wins;
 PRT(printf("win_move_cur_slice_rois...cur_slice_num = %d next_slice_num = %d\n",
             cur_slice_num,next_slice_num))
 if ((next_slice_num >= 0) && 
     (next_slice_num < img->file->slice_info.max_sroi_wins))
    {if (overwrite)
        {free_slice_roi_rec(&(sroi_wins[next_slice_num]->slice_roi));
         sroi_wins[next_slice_num]->slice_roi = 
                           win->control.sroi.sroi_win->slice_roi;
         win_run_proc_on_slice_roi_wins(sroi_wins[next_slice_num],
                    win_redisplay_all_curves,0,0);
        }
       else
        {JoinRois(&(sroi_wins[next_slice_num]->slice_roi),
              &(win->control.sroi.sroi_win->slice_roi),0,1.0,1.0,
              NULL,NULL,NULL);
         PRT(printf("...JoinRois...num_wins = %d\n",
            sroi_wins[next_slice_num]->num_wins))

         win_run_proc_on_slice_roi_wins(sroi_wins[next_slice_num],
                    win_redisplay_all_curves,0,0);
         free_slice_roi_rec(&(win->control.sroi.sroi_win->slice_roi));
        }
    }
   else free_slice_roi_rec(&(win->control.sroi.sroi_win->slice_roi));
 img->file->output.status |= FILE_TO_BE_SAVED;

 win_run_proc_on_slice_roi_wins(win->control.sroi.sroi_win,
                    win_redisplay_all_curves,0,0);
 return NO_ERROR;
}


/*-------------------------------------------------------------------------
win_move_group_slice_rois_next - ???
-------------------------------------------------------------------------*/

int
win_move_group_slice_rois_next(win,offset)
 struct image_display_window *win;
 int offset;
{
 struct img_buf_rec *img;
 long lcv,last;
 struct slice_roi_win_rec **sroi_wins;

 PRT(printf("win_move_group_slice_rois_next...win = %u\n",win))
 if ((img = (struct img_buf_rec *) win_rec_cur_img_buf(win->owner)) == NULL) 
    return NO_ERROR;
 if (img->file->slice_info.max_sroi_wins == 0) return NO_ERROR;
 if (offset > img->file->slice_info.max_sroi_wins)
    offset = img->file->slice_info.max_sroi_wins;

 sroi_wins = img->file->slice_info.sroi_wins;
 last = img->file->slice_info.max_sroi_wins - 1;
 for (lcv = last - offset + 1; lcv <= last; lcv++)
    free_slice_roi_rec(&(sroi_wins[lcv]->slice_roi));

 for (lcv = last; lcv >= offset; lcv--)
    sroi_wins[lcv]->slice_roi = sroi_wins[lcv - offset]->slice_roi;
 if (last != 0)
    {for (lcv = 0; lcv < offset; lcv++)
        {init_slice_roi_rec(&(sroi_wins[lcv]->slice_roi));
         setup_slice_roi_rec_dim(&(sroi_wins[lcv]->slice_roi),
           img->file->hdr.data_info.dimx,img->file->hdr.data_info.dimy);}
    }
 img->file->output.status |= FILE_TO_BE_SAVED;
 TRACE(printf("win_move_group_slice_rois_next...1\n"))
 return win_run_proc_to_all_file_wins(win,win_redisplay_all_curves,1,0,0,0);
}


/*-------------------------------------------------------------------------
win_move_slice_rois_prior - ???
-------------------------------------------------------------------------*/

int
win_move_slice_rois_prior(win)
 struct image_display_window *win;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;
 int err,offset,apply,overwrite;

 apply = 0;
 overwrite = offset = 1;
 PRT(printf("win_move prior\n"))
 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(win,GET_ALL_DP_PTR)) != NULL)
    {if ((all_dps->num_dps > 0) && ((dp = all_dps->dps[0]) != NULL))
        {offset = (int) xv_get(dp->move_offset,PANEL_VALUE);
         apply = (int) xv_get(dp->which,PANEL_VALUE);
         overwrite = (int) xv_get(dp->overwrite,PANEL_VALUE);
        }
    }
 PRT(printf("win_move prior offset = %d apply = %d overwrite = %d\n",
            offset,apply,overwrite))
 if (apply == 0) err = win_move_group_slice_rois_prior(win,offset);
   else err = win_move_cur_slice_rois(win,-offset,overwrite);
 return err;
}


/*-------------------------------------------------------------------------
win_move_slice_rois_next - ???
-------------------------------------------------------------------------*/

int
win_move_slice_rois_next(win)
 struct image_display_window *win;
{
 struct all_dp_trans_roi_recs *all_dps;
 struct dp_trans_roi_rec *dp;
 int err,offset,apply,overwrite;

 apply = 0;
 overwrite = offset = 1;
 if ((all_dps = (struct all_dp_trans_roi_recs *)
              enter_dp_trans_roi(win,GET_ALL_DP_PTR)) != NULL)
    {if ((all_dps->num_dps > 0) && ((dp = all_dps->dps[0]) != NULL))
        {offset = (int) xv_get(dp->move_offset,PANEL_VALUE);
         apply = (int) xv_get(dp->which,PANEL_VALUE);
         overwrite = (int) xv_get(dp->overwrite,PANEL_VALUE);
        }
    }
 PRT(printf("win_move next offset = %d apply = %d overwrite = %d\n",
            offset,apply,overwrite))
 if (apply == 0) err = win_move_group_slice_rois_next(win,offset);
   else err = win_move_cur_slice_rois(win,offset,overwrite);
 return err;
}


/*-------------------------------------------------------------------------
enter_dp_trans_roi - ???
-------------------------------------------------------------------------*/

int
enter_dp_trans_roi(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_dp_trans_roi_recs all_dps;
 struct dp_trans_roi_rec *dp;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_dp_trans_roi...0\n"))
 err = NO_ERROR;
 if (first_time)
    {init_all_dp_trans_roi_recs(&all_dps);
     first_time = 0;}
 if (status == GET_ALL_DP_PTR)
    {return (unsigned long) &all_dps;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_TRANS_ROI_OPTIONS)
   {if ((dp = find_dp_trans_roi_rec(&all_dps,win)) != NULL)
       free_dp_trans_roi_rec(dp);
    return NO_ERROR;}
 TRACE(printf("enter_dp_trans_roi...1\n"))
 if ((dp = find_dp_trans_roi_rec(&all_dps,win)) != NULL)
    {xv_set(dp->frame,
               XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
     win_set_mouse_at_center(dp->frame);
     wmgr_top(dp->frame);
     return NO_ERROR;}

 TRACE(printf("enter_dp_trans_roi...2\n"))
 get_handle_memory(&(all_dps.dps),&(all_dps.num_dps),1,
     (size_t) sizeof(struct dp_trans_roi_rec),&err);
 if (err != NO_ERROR) return err;
 dp = all_dps.dps[all_dps.num_dps - 1];
 init_dp_trans_roi_rec(dp);
 TRACE(printf("enter_dp_trans_roi...2\n"))
 if ((err = setup_dp_trans_roi_rec(dp,win)) == NO_ERROR)
    {TRACE(printf("setup_dp_trans_roi_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up the window for",
               TRANS_ROI,NULL,0);
 return err;

}

