/****************************************************************************
edge_detector.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: edge_detector.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
*/
#define TRACE(x)



#define CLEAN_UP_EDGE_DETECTOR 0
#define SETUP_EDGE_DETECTOR 1
#define GET_ALL_EDGE_PTR 2

struct edge_detector_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item use_pixel_values,edge_threshold_item,option,edge_value_item,
               load_original,bkg_item,which_region;
    struct buf_2d_rec edge_2d;
    int last_use_which,last_which_region;
   };

struct all_edge_detector_recs
   {
    int num_edges;
    struct edge_detector_rec **edges;
   };


/* Functions defined in this file */
void init_edge_detector_rec(struct edge_detector_rec *edge);
void free_edge_detector_rec(struct edge_detector_rec *edge);
void init_all_edge_detector_recs(struct all_edge_detector_recs *all_edges);
int win_get_cur_slice_gradient(struct image_display_window *win,
    int is_color_data, int edge_threshold, int set_edge_value, int edge_value,
    int set_background_value, int background_value, struct buf_2d_rec *mask,
    struct int_bound_rec *mask_area);
void edge_detector_frame_done_proc(Frame frame);
void edge_use_which_value_proc(Panel_item item, int value, Event *event);
int edge_detect_proc(Panel_item item, Event event);
int edge_threshold_proc(Panel_item item, Event event);
void edge_original_proc(Panel_item item, Event event);
int edge_fusion_proc(Panel_item item, Event event);
void edge_delete_fusion_proc(Panel_item item, Event event);
void edge_hide_fusion_proc(Panel_item item, Event event);
void edge_show_fusion_proc(Panel_item item, Event event);
void edge_quit_proc(Panel_item item, Event event);
int setup_edge_detector_rec(struct edge_detector_rec *edge,
    struct image_display_window *win);
struct edge_detector_rec *find_edge_detector_rec(
   struct all_edge_detector_recs *all_edges, struct image_display_window *win);
struct edge_detector_rec *find_same_edge_file(
   struct all_edge_detector_recs *all_edges, struct image_display_window *win);
struct all_edge_detector_recs *enter_edge_detector
   (struct image_display_window *win, int status);



/*--------------------------------------------------------------------------
init_edge_detector_rec - ???
--------------------------------------------------------------------------*/

void
init_edge_detector_rec(edge)
 struct edge_detector_rec *edge;
{
 edge->status = 0;
 edge->win = NULL;
 edge->frame = 0;
 init_buf_2d_rec(&(edge->edge_2d));
}


/*--------------------------------------------------------------------------
free_edge_detector_rec - ???
--------------------------------------------------------------------------*/

void
free_edge_detector_rec(edge)
 struct edge_detector_rec *edge;
{
 struct all_edge_detector_recs *all_edges;

 if (edge->frame != 0)
    {xv_destroy_safe(edge->frame);
     edge->frame = 0;
    }
 free_buf_2d_rec(&(edge->edge_2d));
 c_free(edge);
 all_edges = enter_edge_detector(NULL, GET_ALL_EDGE_PTR);
 DropHandleAryPtr(&(all_edges->edges),&(all_edges->num_edges),edge);
 TRACE(printf("free_edge_detector_rec...end\n"))
}


/*--------------------------------------------------------------------------
init_all_edge_detector_recs - ???
--------------------------------------------------------------------------*/

void
init_all_edge_detector_recs(all_edges)
 struct all_edge_detector_recs *all_edges;
{
 all_edges->num_edges = 0;
 all_edges->edges = NULL;
}


/*--------------------------------------------------------------------------
win_get_cur_slice_gradient - ???
--------------------------------------------------------------------------*/

int
win_get_cur_slice_gradient(win,is_color_data,
                           edge_threshold,set_edge_value,edge_value,
                           set_background_value,background_value,mask,mask_area)
 struct image_display_window *win;
 int is_color_data;
 int edge_threshold,set_edge_value,edge_value,
                           set_background_value,background_value;
 struct buf_2d_rec *mask;
 struct int_bound_rec *mask_area;
{
 struct img_buf_rec *img;
 struct buf_2d_rec _2d,_2d1,*the_2d;
 int err;
 unsigned long first,num_colors;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;
 TRACE(printf("img min = %d  max = %d\n",img->_2d.min_val,img->_2d.max_val))
 if (is_color_data)
    {the_2d = &(color_data->_2d);
     TRACE(printf("before color_data min_val = %d  max_val = %d\n",
               the_2d->min_val,the_2d->max_val))
     WinMapActualColorData(win,NULL,the_2d);

     TRACE(printf("after color_data min_val = %d  max_val = %d\n",
               the_2d->min_val,the_2d->max_val))
    }    
   else
    the_2d = &(img->_2d);

 init_buf_2d_rec(&_2d);
 init_buf_2d_rec(&_2d1);
 if ((err = copy_buf_2d_rec(&_2d,the_2d)) != NO_ERROR) return err;
 printf("set_edge_value = %d...set_background_value = %d\n",
            set_edge_value,set_background_value);
 if (mask != NULL)
    {
     Gradient2dByMask(&_2d,0,0,mask,mask_area,the_2d,
               (double) edge_threshold,
               set_edge_value,(double) edge_value,
               set_background_value,(double) background_value);
    }
   else
    Gradient2d(the_2d,&_2d,(double) edge_threshold,
                    set_edge_value,(double) edge_value,
                    set_background_value,(double) background_value);

 free_buf_2d_rec(&_2d);
 free_buf_2d_rec(&_2d1);
 the_2d->status4 |= BUF_DATA_GRADIENT;
 if (is_color_data)
    {
     if (!(the_2d->status4 & BUF_MIN_MAX_COMPUTED))
        {the_2d->status4 |= BUF_MIN_MAX_COMPUTED;
         win_first_and_num_colors(win,&first,&num_colors);
         the_2d->minval = (double) first;
         the_2d->maxval = (double) (first + num_colors - 1);}
     if (!(img->_2d.status4 & BUF_MIN_MAX_COMPUTED))
        MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
     if ((err = Scale2dPixels(&(img->_2d),the_2d,
           img->_2d.minval,img->_2d.maxval,
               0,(double) .0,(double) .0,0)) != NO_ERROR)
        return err;
    }    
 TRACE(printf("before...WinNewColorMultiCanvas\n"))
 WinNewColorMultiCanvas(win);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
edge_detector_frame_done_proc - ???
--------------------------------------------------------------------------*/

void
edge_detector_frame_done_proc(frame)
 Frame frame;
{
 struct edge_detector_rec *edge;

 edge = (struct edge_detector_rec *) xv_get(frame,WIN_CLIENT_DATA);
 free_edge_detector_rec(edge);
}


/*--------------------------------------------------------------------------
edge_use_which_value_proc - ???
--------------------------------------------------------------------------*/

void
edge_use_which_value_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct edge_detector_rec *edge;
 int val,edge_val,threshold_val,bkg_val,min,max;
 struct img_buf_rec *img;
 unsigned long first,num_colors;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 val = (int) xv_get(item,PANEL_VALUE);
 
 edge_val = (int) xv_get(edge->edge_value_item,PANEL_VALUE);
 bkg_val = (int) xv_get(edge->bkg_item,PANEL_VALUE);
 threshold_val = (int) xv_get(edge->edge_threshold_item,PANEL_VALUE);
 if (val)
    {
     win_first_and_num_colors(edge->win,&first,&num_colors);
     min = first;
     max = first + num_colors - 1;}
   else
    {if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL)
	return /*CANCEL*/;
     if (!(img->_2d.status4 & BUF_MIN_MAX_COMPUTED))
        MinMax2d(&(img->_2d),0,(double) .0,(double) .0);
     min = (long) img->_2d.minval;
     max = (long) img->_2d.maxval;}
 make_int_in_range(&edge_val,min,max);
 make_int_in_range(&bkg_val,min,max);
 make_int_in_range(&threshold_val,min,max);
 xv_set(edge->edge_threshold_item,
      PANEL_MIN_VALUE,min,PANEL_MAX_VALUE,max,PANEL_VALUE,threshold_val,0);
 xv_set(edge->edge_value_item,
      PANEL_MIN_VALUE,min,PANEL_MAX_VALUE,max,PANEL_VALUE,edge_val,0);
 xv_set(edge->bkg_item,
      PANEL_MIN_VALUE,min,PANEL_MAX_VALUE,max,PANEL_VALUE,bkg_val,0);
}


/*--------------------------------------------------------------------------
edge_detect_proc - ???
--------------------------------------------------------------------------*/

int
edge_detect_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct draw_mask_rec mask;
 struct buf_2d_rec *_2d;
 struct img_buf_rec *img;
 struct int_bound_rec affected;
 int which_region,err;
 int edge_value,edge_threshold,bkg_val,set,use_which;
 unsigned long first,num_colors;
 struct color_data_rec *color_data;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 edge_delete_fusion_proc(item,event);

 which_region = (int) xv_get(edge->which_region,PANEL_VALUE);
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(edge->win)) == NULL) return CANCEL;
 err = NO_ERROR;
 if (which_region)
    {
     init_draw_mask_rec(&mask);
     err = GetRoiMask(&(edge->win->control.sroi.sroi_win->slice_roi),
         edge->win->control.sroi.localto,
         img->_2d.dimx,img->_2d.dimy,&mask,&affected,which_region,
         &(edge->win->image_view_roi));
     _2d = &(mask.mask._2d);
    }
   else _2d = NULL;
 
 use_which = (int) xv_get(edge->use_pixel_values,PANEL_VALUE);
 if ((err == NO_ERROR) && ((int) xv_get(edge->load_original,PANEL_VALUE)))
    {TRACE(printf("edge_detect_proc load_cur_slice...\n"))
     RdSlice(img,0,NULL,0);
     win_first_and_num_colors(edge->win,&first,&num_colors);
     if (use_which)
        err = Scale2dPixels(&(color_data->_2d),&(img->_2d),
                first,first + num_colors - 1,0,(double) .0,(double) .0,0);
    }
 if (err == NO_ERROR)
    {edge_threshold = (int) xv_get(edge->edge_threshold_item,PANEL_VALUE);
     set = (int) xv_get(edge->option,PANEL_VALUE);
     edge_value = (int) xv_get(edge->edge_value_item,PANEL_VALUE);
     bkg_val = (int) xv_get(edge->bkg_item,PANEL_VALUE);

     err = win_get_cur_slice_gradient(edge->win,use_which,
                    edge_threshold,0,edge_value,0,
                    bkg_val,_2d,&affected);
    }

 if (_2d != NULL) free_draw_mask_rec(&mask);
 if (err != NO_ERROR)
    {ShowMsgStrs(edge->win->dwin->frame,0,err,0,2,
          "An error occurred during the edge detection",
          OPERATION_ABORTED,NULL,0);
     free_buf_2d_rec(&(edge->edge_2d));}
   else
    {if (use_which)
        err = copy_buf_2d_rec(&(edge->edge_2d),&(color_data->_2d));
       else
        err = copy_buf_2d_rec(&(edge->edge_2d),&(img->_2d));
     if (err == NO_ERROR)
        {edge->last_use_which = use_which;
         edge->last_which_region = which_region;}
     if (err != NO_ERROR) free_buf_2d_rec(&(edge->edge_2d));
    }
 return err;
}


/*--------------------------------------------------------------------------
edge_threshold_proc - ???
--------------------------------------------------------------------------*/

int
edge_threshold_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct img_buf_rec *img;
 int which_region,err;
 struct draw_mask_rec mask;
 struct buf_2d_rec *_2d;
 struct int_bound_rec affected,*bound;
 long lb,ub,setval,option,edgeval;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (!(edge->edge_2d.status4 & BUF_NON_EMPTY))
    {ShowMsgStrs(edge->win->dwin->frame,0,0,0,2,
          "Please use DETECT to detect the edges first...",
          OPERATION_ABORTED,NULL,0);
     return CANCEL;}
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL) return CANCEL;
 err = NO_ERROR;
 if (edge->last_which_region)
    {
     init_draw_mask_rec(&mask);
     err = GetRoiMask(&(edge->win->control.sroi.sroi_win->slice_roi),
         edge->win->control.sroi.localto,
         img->_2d.dimx,img->_2d.dimy,&mask,&affected,which_region,
         &(edge->win->image_view_roi));
     _2d = &(mask.mask._2d);
     bound = &affected;
    }
   else
    {_2d = NULL;
     bound = NULL;}
 lb = (int) xv_get(edge->edge_threshold_item,PANEL_MIN_VALUE);
 ub = (int) xv_get(edge->edge_threshold_item,PANEL_VALUE);
 option = (int) xv_get(edge->option,PANEL_VALUE);
 edgeval = (int) xv_get(edge->edge_value_item,PANEL_VALUE);
 if (option & 2)
    setval = (int) xv_get(edge->bkg_item,PANEL_VALUE);
   else setval = lb;
 printf("edge_threshold_proc...1\n");
 if ((err = copy_buf_2d_rec_content(&(img->_2d),&(edge->edge_2d))) == NO_ERROR)
    err = SelectSet2d(&(img->_2d),0,0,_2d,bound,
              (double) lb,(double) ub,(double) setval,
               option & 1,(double) edgeval);
 if (_2d != NULL) free_draw_mask_rec(&mask);
 printf("edge_threshold_proc...err = %d\n",err);
 if (err == NO_ERROR) WinNewColorMultiCanvas(edge->win);
 return err;
}


/*--------------------------------------------------------------------------
edge_original_proc - ???
--------------------------------------------------------------------------*/

void
edge_original_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct display_win_rec *dwin;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 dwin = edge->win->dwin;
 edge->win->dwin = edge->dwin;
 WinNewImgMultiCanvas(edge->win);
 edge->win->dwin = dwin;
}


/*--------------------------------------------------------------------------
edge_fusion_proc - ???
--------------------------------------------------------------------------*/

int
edge_fusion_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct buf_2d_rec _2d;
 struct img_buf_rec *img;
 int err;
 unsigned long first,num_colors;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL) return CANCEL;
 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
      img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) == NO_ERROR)
    {if ((err = RdSlice(img,0,&_2d,0)) == NO_ERROR)
        {
         img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
         win_first_and_num_colors(edge->win,&first,&num_colors);

         if ((err = SetupBuf2dRec(&(img->_2d_fusion._2d),
                img->_2d.dimx,img->_2d.dimy,img->_2d.pixel_depth,0)) == NO_ERROR)
            {if ((err = Scale2dPixels(&(img->_2d_fusion._2d),&_2d,first,
                    first + num_colors - 1,0,
                    (double) .0,(double) .0,0)) == NO_ERROR)
                {TRACE(printf("Set2d...\n"))
                 TRACE(printf("img->_2d 0 = %d\n",cnt_val_buf_2d_rec(&(img->_2d),0)))
                 Set2d(&(img->_2d_fusion._2d),0,0,
                      &(img->_2d),NULL,(double) .0);
                 TRACE(printf("_2d_fusion non 0 = %d\n",
                    CntNonValBuf2dRec(&(img->_2d_fusion._2d),(double) 0)))
                 img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
                 img->_2d_fusion.status = METHOD_BY_EDGE_DETECTOR;
                 img->_2d_fusion.dst_bound.left = 0;
                 img->_2d_fusion.dst_bound.top = 0;
                 img->_2d_fusion.dst_bound.right = img->_2d.dimx - 1;
                 img->_2d_fusion.dst_bound.bottom = img->_2d.dimy - 1;

                 img->_2d_fusion.src_bound = img->_2d_fusion.dst_bound;
                 img->_2d_fusion.dstmin = (long) img->_2d.minval;
                 img->_2d_fusion.dstmax = (long) img->_2d.maxval;
                 img->_2d_fusion.srcmin = (long) img->_2d.minval;
                 img->_2d_fusion.srcmax = (long) img->_2d.maxval;
                 img->_2d_fusion._2d.status4 |= BUF_DATA_VALID;
                }
            }
         WinNewColorMultiCanvas(edge->win);
        }
    }

 free_buf_2d_rec(&_2d);
 if (err != NO_ERROR)
    ShowMsgStrs(edge->win->dwin->frame,0,err,0,2,
          "An error occurred when superimposing...",
          OPERATION_ABORTED,NULL,0);
 return err;
}


/*--------------------------------------------------------------------------
edge_delete_fusion_proc - ???
--------------------------------------------------------------------------*/

void
edge_delete_fusion_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct img_buf_rec *img;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL)
     return /*CANCEL*/;
 img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
 if (img->_2d_fusion.status & METHOD_BY_EDGE_DETECTOR)
    {
     img->_2d_fusion.status &= ~METHOD_BY_EDGE_DETECTOR;
     free_buf_2d_rec(&(img->_2d_fusion._2d));
     WinNewColorMultiCanvas(edge->win);
    }
}


/*--------------------------------------------------------------------------
edge_hide_fusion_proc - ???
--------------------------------------------------------------------------*/

void
edge_hide_fusion_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct img_buf_rec *img;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL)
     return /*CANCEL*/;
 if (img->_2d_fusion.status & METHOD_BY_EDGE_DETECTOR)
    {img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
     WinNewColorMultiCanvas(edge->win);
    }
}


/*--------------------------------------------------------------------------
edge_show_fusion_proc - ???
--------------------------------------------------------------------------*/

void
edge_show_fusion_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;
 struct img_buf_rec *img;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(edge->win->owner)) == NULL)
     return /*CANCEL*/;
 if (img->_2d_fusion.status & METHOD_BY_EDGE_DETECTOR)
    {img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
     WinNewColorMultiCanvas(edge->win);
    }
}


/*--------------------------------------------------------------------------
edge_quit_proc - ???
--------------------------------------------------------------------------*/

void
edge_quit_proc(item,event)
 Panel_item item;
 Event event;
{
 struct edge_detector_rec *edge;

 edge = (struct edge_detector_rec *) xv_get(item,PANEL_CLIENT_DATA);
 free_edge_detector_rec(edge);
}


/*--------------------------------------------------------------------------
setup_edge_detector_rec - ???
--------------------------------------------------------------------------*/

int
setup_edge_detector_rec(edge,win)
 struct edge_detector_rec *edge;
 struct image_display_window *win;
{
 char *str;
 int max_color,row,offset;
 Rect *rr;
 Panel_item item;
 unsigned long first,num_colors;

 edge->win = win;
 edge->dwin = win->dwin;
 edge->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              0);
 TRACE(printf("setup_edge_detector_rec...1\n"))
 if (edge->frame == 0)
    {free_edge_detector_rec(edge);
     return CANCEL;}
 str = win_rec_win_id_title(win->owner,EDGE_DETECTION);
 xv_set(edge->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,edge_detector_frame_done_proc,
              WIN_CLIENT_DATA,edge,
              0);
 c_free(str);
 TRACE(printf("ok111.,..."))
 edge->panel = xv_create(edge->frame,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (edge->panel == 0)
    {free_edge_detector_rec(edge);
     return CANCEL;}
 row = 0;
 offset = xv_rows(edge->panel,1) - xv_rows(edge->panel,0) - 10;
 edge->use_pixel_values = xv_create(edge->panel,PANEL_CHOICE_STACK,
                  PANEL_LAYOUT,PANEL_VERTICAL,
                  PANEL_CHOICE_STRINGS,"USE PIXEL VALUES",
                                "USE COLOR VALUES",NULL,
 	          PANEL_VALUE,1,
                  XV_X,5,XV_Y,row,
                  PANEL_NOTIFY_PROC,edge_use_which_value_proc,
                  PANEL_CLIENT_DATA,edge,
                  0);
 row += offset;
 str = "DETECT";
 xv_create(edge->panel,PANEL_BUTTON,
        PANEL_LABEL_STRING,str,
        PANEL_NOTIFY_PROC,edge_detect_proc,
        PANEL_CLIENT_DATA,edge,
        XV_X,5,XV_Y,row,
        0);
 edge->which_region = xv_create(edge->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,"CUR SLICE","CUR CURVE","CUR ROI","ALL ROIS",
                           "VIEW FILTER ROI",NULL,
        PANEL_VALUE,0,
        XV_Y,row,
        0);
 TRACE(printf("ok333.,..."))

 str = "ORIGINAL";
 xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_original_proc,
                   PANEL_CLIENT_DATA,edge,
                   0);

 str = "CANCEL";
 xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_quit_proc,
                   PANEL_CLIENT_DATA,edge,
                   0);

 row += offset;
 edge->load_original = xv_create(edge->panel,PANEL_CHECK_BOX,
        PANEL_CHOICE_STRINGS,"LOAD ORIGINAL BEFORE DETECT",NULL,
        PANEL_VALUE,1,
        XV_X,5,XV_Y,row,
        0);
 row += offset;
 item = xv_create(edge->panel,PANEL_MESSAGE,
 	PANEL_LABEL_STRING,"SUPERIMPOSE ->",
        XV_X,5,XV_Y,row,
        0);
 rr = (Rect *) xv_get(item,XV_RECT);
 str = "ON ORIGINAL";
 item = xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_fusion_proc,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,edge,
                   0);
 str = "DELETE";
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_delete_fusion_proc,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,edge,
                   0);
 str = "HIDE";
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_hide_fusion_proc,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,edge,
                   0);
 str = "SHOW";
 rr = (Rect *) xv_get(item,XV_RECT);
 xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,str,
                   PANEL_NOTIFY_PROC,edge_show_fusion_proc,
                   XV_X,rr->r_left + rr->r_width,XV_Y,row,
                   PANEL_CLIENT_DATA,edge,
                   0);
 row += offset;
 xv_create(edge->panel,PANEL_MESSAGE,
 	PANEL_LABEL_STRING,"You may adjust EDGE THRESHOLD after DETECT...",
        XV_X,10,XV_Y,row,
        0);
 row += offset;
 item = xv_create(edge->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING,"EDGE THRESHOLD",
                   PANEL_NOTIFY_PROC,edge_threshold_proc,
                   XV_X,5,XV_Y,row,
                   PANEL_CLIENT_DATA,edge,
                   0);
 rr = (Rect *) xv_get(item,XV_RECT);

 win_first_and_num_colors(edge->win,&first,&num_colors);
 max_color = first + num_colors - 1;
 edge->edge_threshold_item = xv_create(edge->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,">=",
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_VALUE,first,
	PANEL_MIN_VALUE,(int) first,
	PANEL_MAX_VALUE,(int) max_color,
	PANEL_SLIDER_WIDTH,70,
	0);

 row += offset;
 edge->option = xv_create(edge->panel,PANEL_TOGGLE,
                   PANEL_LABEL_STRING,"OPTION",
                   PANEL_LAYOUT,PANEL_HORIZONTAL,
                   PANEL_CHOICE_STRINGS,"SET EDGE VALUE",
                                        "SET NON-EDGE VALUE",0,
                   PANEL_VALUE,0,
                   XV_X,5,XV_Y,row,
                   0);
 
 row += offset;

 edge->edge_value_item = xv_create(edge->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"SET EDGE VALUE :",
	PANEL_VALUE,max_color,
	PANEL_MIN_VALUE,(int) first,
	PANEL_MAX_VALUE,(int) max_color,
	PANEL_SLIDER_WIDTH,70,
        PANEL_CLIENT_DATA,edge,
        XV_X,0,XV_Y,row,
	0);
 TRACE(printf("setup_edge_detector_rec...4\n"))

 row += offset;
 edge->bkg_item = xv_create(edge->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"SET NON-EDGE VALUE :",
	PANEL_VALUE,(int) first,
	PANEL_MIN_VALUE,(int) first,
	PANEL_MAX_VALUE,(int) max_color,
	PANEL_SLIDER_WIDTH,70,
        PANEL_CLIENT_DATA,edge,
        XV_X,0,
        XV_Y,row,
	0);


 window_fit(edge->panel);
 window_fit(edge->frame);
 make_2_wins_adjacent(edge->frame,win->dwin->frame,0);
 win_set_mouse_at_center(edge->frame);
 xv_set(edge->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
find_edge_detector_rec - ???
--------------------------------------------------------------------------*/

struct edge_detector_rec *
find_edge_detector_rec(all_edges,win)
 struct all_edge_detector_recs *all_edges;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_edges->num_edges; lcv++)
    if (all_edges->edges[lcv]->win == win)
       return all_edges->edges[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
find_same_edge_file - ???
--------------------------------------------------------------------------*/

struct edge_detector_rec *
find_same_edge_file(all_edges,win)
 struct all_edge_detector_recs *all_edges;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_edges->num_edges; lcv++)
    {if ((img = win_rec_cur_img_buf(all_edges->edges[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_edges->edges[lcv];
    }
 return NULL;
}

/*---------------------------------------------------------------------
enter_edge_detector - ???

BEWARE: The pre-19990223 version of this function could return either
NULL, a pointer to an all_edge_detector_recs structure, or an integer
error code.  Since the last two of these cannot be reliably
distinguished and since no one ever seems to check for an error code,
I replaced the error code by NULL.  Of course, it is now impossible to
distinguish between NO_ERROR and NULL (=> error), but I don't think
anyone ever looks at the error code returned.  -PWH
-----------------------------------------------------------------------*/

struct all_edge_detector_recs *
enter_edge_detector(
    struct image_display_window *win,
    int status)
{
 static struct all_edge_detector_recs all_edges;
 struct edge_detector_rec *edge;
 static char first_time = 1;
 int err;

 TRACE(printf("enter_edge_detector...0\n"))
 err = NO_ERROR;
 if (status == GET_ALL_EDGE_PTR)
    {if (first_time) return NULL;
       else return &all_edges;}
  else if (status == CLEAN_UP_EDGE_DETECTOR)
   {if (!first_time)
       if ((edge = find_edge_detector_rec(&all_edges,win)) != NULL)
          free_edge_detector_rec(edge);
    return NO_ERROR;}
 TRACE(printf("enter_edge_detector...1\n"))
 if (first_time)
    {init_all_edge_detector_recs(&all_edges);
     first_time = 0;}
   else
    {if ((edge = find_edge_detector_rec(&all_edges,win)) != NULL)
        {xv_set(edge->frame,XV_SHOW,TRUE,WIN_ALARM,FRAME_CLOSED,FALSE,0);
         win_set_mouse_at_center(edge->frame);
         wmgr_top(edge->frame);
         return NO_ERROR;}
    }
 TRACE(printf("enter_edge_detector...2\n"))
 get_handle_memory(&(all_edges.edges),&(all_edges.num_edges),1,
     (size_t) sizeof(struct edge_detector_rec),&err);
 if (err != NO_ERROR) return NULL;
 edge = all_edges.edges[all_edges.num_edges - 1];
 init_edge_detector_rec(edge);
 TRACE(printf("enter_edge_detector...2\n"))
 if ((err = setup_edge_detector_rec(edge,win)) == NO_ERROR)
    {TRACE(printf("setup_edge_detector_rec...\n"))
    }
   else
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the EDGE DETECTION window !!!",NULL,0);
 return NULL;

}

