/****************************************************************************
file_menu.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: file_menu.c,v 1.10 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/textsw.h>
#include <xview/notify.h>

#include "ask_file.h"
#include "mri_format.h"
#include "nria_procedures.h"

#if 0
#  define TRACE(x) x; fflush(stdout);
#  define PRT(x) x; fflush(stdout);
#  define PRT1(x) x; fflush(stdout);
#  define PRT5(x) x; fflush(stdout);
#  define PRT6(x) x; fflush(stdout);
#  define PRT7(x) x; fflush(stdout);
#  define PRT2(x) x; fflush(stdout);
#else
#  define PRT(x)
#  define TRACE(x)
#  define PRT1(x)
#  define PRT5(x)
#  define PRT6(x)
#  define PRT7(x)
#  define PRT2(x)
#endif



extern struct itimerval ITIMER_ONCE;
#define notify_cancel_itimer( client ) \
	notify_set_itimer_func( (Notify_client) (client), \
				NOTIFY_FUNC_NULL, ITIMER_REAL, NULL, NULL );



/* Functions defined in this file */
void import_image_file_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void import_image_file_from_main_proc(Menu menu, Menu_item item);
void enter_save_dat_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void enter_comment_exit_proc(struct input_file_rec *file, char *comment_fn,
    int is_suceeded);
int setup_enter_file_comment(struct image_display_window *win);
void file_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, int option);
Menu setup_file_info_menu(void);
void color_pallette_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void next_color_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int def_image_color_scale_proc(Menu menu, Menu_item item);
int win_show_def_color_scale_menu(struct image_display_window *win);
void image_color_scale_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event, int option);
void color_editor_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event);
int quit_file(struct input_file_rec *file, int which);
int win_quit_the_file(struct image_display_window *win);
void win_quit_and_save_file_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
void select_cursor_proc(Menu menu, Menu_item item, void *arg, Xv_Window window,
    Event *last_event, long which_cursor);
Menu setup_cursor_menu(void);
Menu gen_cursor_menu_proc(Menu menu, Menu_generate operation);
void display_menu_help_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);
int show_all_file_proc(struct prog_rec *prog, struct chosen_fn_rec *chosen,
    Panel_item item, char *str, int row, Panel_list_op op, Event *event);
void get_fns_menu(Frame frame, int which);
void win_select_fns_menu_proc(Menu menu, Menu_item item, void *arg,
    Xv_Window window, Event *last_event);



/*--------------------------------------------------------------------
import_image_file_proc - ???
--------------------------------------------------------------------*/

void
import_image_file_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 PRT7(printf("import_image_file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 if (win1 == NULL) return;
 PRT7(printf("import_image_file_proc...1\n"))
 win = win1->owner;
 win->dwin = win1;
 PRT7(printf("import_image_file_proc...2\n"))
 enter_import_img_rec(win,1);
}



/*--------------------------------------------------------------------
import_image_file_from_main_proc - ???
--------------------------------------------------------------------*/

void
import_image_file_from_main_proc( menu, item )
     Menu menu;
     Menu_item item;
{
  Frame *main_frame_ptr;

  PRT(printf("import_image_file_from_main_proc...1\n"));
  main_frame_ptr = (Frame *) main_display( 2, NULL, 0, 0 );

  PRT7(printf("...*main_frame_ptr = %u\n",main_frame_ptr));
  /* FIXME:  I'm skeptical of the * in the line below but don't have
     time to chase it down now.  -PWH 19990224 */
  enter_import_img_rec( *main_frame_ptr, 1 );
}


/*-------------------------------------------------------------------
enter_save_dat_proc - ???

NOTE: The pre-19990224 version of this function had an additional
argument option of type int, which was never used.  I have deleted it.
The function was also formerly of type int, which is inconsistent with
all its users; I have changed it to type void.  -PWH
--------------------------------------------------------------------*/

void
enter_save_dat_proc(
    Menu menu,
    Menu_item item,
    void *arg,
    Xv_Window window,
    Event *last_event)
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 TRACE(printf("enter_save_dat_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;

 setup_enter_data_file_rec(win);
 return;
}


/*--------------------------------------------------------------------
enter_comment_exit_proc - ???
--------------------------------------------------------------------*/

void
enter_comment_exit_proc(file,comment_fn,is_suceeded)
 struct input_file_rec *file;
 char *comment_fn;
 int is_suceeded;
{
 FILE *fid;
 size_t amt,size;
 char *ptr,*str;
 int err;
 Frame *frame;

 if (is_suceeded)
    if ((fid = fopen(comment_fn,"r")) != NULL)
       {size = file_size(fid,&err);
        if (err == NO_ERROR)
           {amt = 0;
            if ((err = get_ptr(&ptr,&amt,size,(size_t) sizeof(char))) == NO_ERROR)
               {fseek(fid,0,0);
                if ((err = frd(ptr,(size_t) size,(size_t) 1,fid,&amt)) 
                       != NO_ERROR)
                   {frame = (Frame *) main_display(2,NULL,0,0);
                    concat_strs(&str,2,"File = ",comment_fn);
                    ShowMsgStrs(*frame,0,err,0,3,
                       "An error occured when changing the edited comment !!!",
                       str,"File comment not changed !!!",NULL,0);
                    c_free(str);
                    c_free(ptr);}
                  else
                   {c_free(file->hdr.comment);
                    file->hdr.comment = ptr;
                    file->hdr.comment_size = size;}
                }
           }
        fclose(fid);
       }
 delete_file(comment_fn);
}


/*--------------------------------------------------------------------
setup_enter_file_comment - ???
--------------------------------------------------------------------*/

int
setup_enter_file_comment(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 char *fn,*str1,*str;
 FILE *fid;
 size_t amt;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 str = str1 = fn = NULL;
 if (((err = build_fn(&str,img->file->dirfn,img->file->fn,
                     img->file->hdr_fn_suffix)) != NO_ERROR) ||
     ((err = concat_strs(&str1,2,"EDIT COMMENT - ",str)) != NO_ERROR) ||
     ((err = cp_str(&fn,tmpnam(NULL))) != NO_ERROR))
    {c_free(str);
     c_free(str1);
     c_free(fn);
     return err;}
 err = FILE_ACCESS_ERROR;
 if (((fid = fopen(fn,"w")) != NULL) &&
     ((err = fwr(img->file->hdr.comment,(size_t) img->file->hdr.comment_size,
           (size_t) 1,fid,&amt)) == NO_ERROR))
    {fclose(fid);
     err = enter_edit_file(win->dwin->frame,img->file,str1,fn,1,
          enter_comment_exit_proc,img->file,1);
    }
   else
    {if (err != FILE_ACCESS_ERROR)
        {delete_file(fn);
         fclose(fid);}
     ShowMsgStrs(win->dwin->frame,0,NO_ERROR,0,2,
               "Uable to set up an editor to edit comment...",
               "There might not be enough disk space...!!!",NULL,0);
    }
 c_free(fn);
 c_free(str);
 c_free(str1);

 return err;
}


/*--------------------------------------------------------------------
file_proc - ???

NOTE:  The pre-19990224 version of this function returned int but was
always used in a context insisting on void.  I changed the type.  -PWH
--------------------------------------------------------------------*/

void
file_proc(
    Menu menu,
    Menu_item item,
    void *arg,
    Xv_Window window,
    Event *last_event,
    int option)
{
 int value;
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct img_buf_rec *img;
 int err;
 char *str1,*fn;
 Menu root;
 long slice_num;

 TRACE(printf("file_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     value = option;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     value = (int) xv_get(item,MENU_VALUE);}
     
 if (win1 == NULL) return;
 win = win1->owner;
 win->dwin = win1;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return;
 if ((value == VALUE_LOAD_DAT_FILE) || (value == VALUE_SAVE_DAT_FILE) ||
     (value == VALUE_RELOAD_SLICE_ROIS) || (value == VALUE_RELOAD_PIXMAP) ||
     (value == VALUE_RELOAD_CUR_SLICE_ROIS))
    {
     if ((err = get_output_fn(&(img->file->output),&fn)) != NO_ERROR)
        {
         ShowMsgStrs(win1->frame,0,err,0,1,
               "Bad .dat file name !!!",NULL,0);
         return;
        }
     if (get_strlen(fn) > 60) set_str_len(fn,60);

     if (value == VALUE_SAVE_DAT_FILE)
        {
         ShowMsgStrs(win1->frame,1,NO_ERROR,1,3,
               "Saving the .ndat file",
               fn,PLEASE_WAIT,AutoSaveDatOutput,2,&(img->file->output),0);
        }
       else if (value == VALUE_LOAD_DAT_FILE)
        {ShowMsgStrs(win1->frame,1,NO_ERROR,0,4,
               "Reloading the .ndat file",
               fn,"The new editings are discarded !!!",
               PLEASE_WAIT,win_rd_dat_output,1,win);
        }
       else if (value == VALUE_RELOAD_CUR_SLICE_ROIS)
        {slice_num = img->cur_slice->slice_num;
         ShowMsgStrs(win1->frame,1,NO_ERROR,1,4,
               "Reloading the current slice rois",
               fn,"The new editings are discarded !!!",
               PLEASE_WAIT,rd_file_slice_rois,
               7,img->file,win,NULL,0,1,0,slice_num);
        }
       else if (value == VALUE_RELOAD_PIXMAP)
        {ShowMsgStrs(win1->frame,1,NO_ERROR,0,4,
               "Reloading the .pixmap file",
               fn,"The current pixel type maps are discarded !!!",
               PLEASE_WAIT,win_rd_pixmap,1,win);
        }
       else 
        {
         ShowMsgStrs(win1->frame,1,NO_ERROR,0,4,
               "Reloading rois for all slices from",
               fn,"The roi editings are discarded !!!",
               PLEASE_WAIT,rd_file_slice_rois,7,img->file,win,NULL,0,1,1,0);
        }
     c_free(fn);
    }
   else if (value == VALUE_FILE_INFO)
    {if ((err = file_info(img->file,&fn)) == NO_ERROR)
        {
         str1 = win_rec_win_id_title(win->owner,"FILE INFO");
/*
         enter_display_text_file(win1->frame,1,str1,fn);
*/
         err = enter_edit_file(win->dwin->frame,img->file,
                   str1,fn,0,NULL,NULL,1);
         c_free(str1);
        }
       else ShowMsgStrs(win1->frame,0,err,0,1,
               "An error occured when displaying the FILE INFO !!!",NULL,0);
     if (fn != NULL)
        {delete_file(fn);
         c_free(fn);}
    }
   else if (value == VALUE_ENTER_FILE_COMMENT)
    setup_enter_file_comment(win);
}


/*--------------------------------------------------------------------
setup_file_info_menu - ???
--------------------------------------------------------------------*/

Menu
setup_file_info_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = (Menu) xv_create(0,MENU,
                       MENU_NOTIFY_PROC,file_proc,
                       MENU_STRING_ITEM,SAVE_DAT_FILE,
                           (int) VALUE_SAVE_DAT_FILE,
                       MENU_STRING_ITEM,RELOAD_SLICE_ROIS,
                           (int) VALUE_RELOAD_SLICE_ROIS,
                       MENU_STRING_ITEM,RELOAD_PIXMAP,
                           (int) VALUE_RELOAD_PIXMAP,
                       MENU_STRING_ITEM,LOAD_DAT_FILE,
                           (int) VALUE_LOAD_DAT_FILE,
                       MENU_STRING_ITEM,RELOAD_CUR_SLICE_ROIS,
                           (int) VALUE_RELOAD_CUR_SLICE_ROIS,
                       MENU_STRING_ITEM,FILE_INFO,
                           (int) VALUE_FILE_INFO,
                       MENU_STRING_ITEM,ENTER_FILE_COMMENT,
                           (int) VALUE_ENTER_FILE_COMMENT,
                       0);
 return menu;
}


/*--------------------------------------------------------------------
color_pallette_proc - ???
--------------------------------------------------------------------*/

void
color_pallette_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root,colormenu;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;
 /* FIXME:  Is it legal to call setup_color_pallette_menu with arg 3 = 0? */
 if ((colormenu = setup_color_pallette_menu(2,NULL,0)) != 0)
    {if ((root = (Menu) root_menu(colormenu)) != 0)
        xv_set(root,MENU_CLIENT_DATA,win1,0);
     PRT6(printf("colormenu win1 = %u wid = %s\n",win1,win1->owner->owner->wid);)
     menu_show(colormenu,window,last_event,0);
    }
}


/*--------------------------------------------------------------------
next_color_menu_proc - ???
--------------------------------------------------------------------*/

void
next_color_menu_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;
 Menu_item item1;
 char *scale_label,*intensity_label;

 PRT6(printf("next_color_menu_proc...menu = %u\n",menu))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     PRT6(printf("next_color_menu_proc...root = %u\n",root))
     if ((win1 = (struct display_win_rec *) 
           xv_get(root,XV_KEY_DATA,1000)) == NULL)
        {PRT6(printf("next_color_menu_proc 1000)) == NULL\n"))
         if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
            {window = (Xv_Window) event_window(last_event);
             win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
             PRT5(printf("next_color_menu_proc...win1= %u\n",win1))
            }
           else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         PRT5(printf("next_color_menu_proc...1...win1= %u\n",win1))
        }
     PRT6(printf("next_color_menu_proc win1 = %u\n",win1))
     PRT6(printf("next_color_menu_proc...2 win1 = %u wid = %s\n",win1,win1->owner->owner->wid);)

     win = win1->owner;
     PRT6(printf("next_color_menu_proc...1\n"))
     scale_label = (char *) xv_get(item,MENU_STRING);
     if (item1 = (Menu_item) xv_get(menu,MENU_PARENT))
        intensity_label = (char *) xv_get(item1,MENU_STRING);
       else intensity_label = NULL;
     PRT6(printf("menu = %u scale_label = %s item1 = %u\n",menu,scale_label,item1))
     PRT(printf("intensity_label = %s\n",intensity_label);)
     if ((scale_label != NULL) && (intensity_label != NULL))
        {win_change_color_scale(win,intensity_label,scale_label);
        }
    }
}


/*--------------------------------------------------------------------
def_image_color_scale_proc - ???
--------------------------------------------------------------------*/

int
def_image_color_scale_proc(menu,item)
 Menu menu;
 Menu_item item;
{
 char *scale_label;
 Menu root;
 struct display_win_rec *dwin;
 struct image_display_window *win;

 scale_label = (char *) xv_get(item,MENU_STRING);
 PRT6(printf("def_image_color_scale_proc scale_label = %s\n",scale_label))
 if ((root = (Menu) root_menu(menu)) != 0)
    {
     dwin = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     PRT6(printf("def_image_color_scale_proc root = %u dwin = %u\n",root,dwin))
     if ((dwin != NULL) && ((win = dwin->owner) != NULL))
        return WinSetDefaultColorDataScale(win,scale_label);
    }
 return CANCEL;
}


/*--------------------------------------------------------------------
win_show_def_color_scale_menu - ???
--------------------------------------------------------------------*/

int
win_show_def_color_scale_menu(win)
 struct image_display_window *win;
{
 Menu colormenu,def,menu,root;
 static Event event;

 PRT6(printf("win_show_def_color_scale_menu...\n"))
 /* FIXME:  Is it legal to call setup_color_pallette_menu with arg 3 = 0? */
 if ((colormenu = setup_color_pallette_menu(2,NULL,0)) != 0)
    {
     PRT6(printf("colormenu = %u cur_pallette = %d\n",colormenu,
          win->owner->root->def_color.cur_pallette))
     if (((def = xv_get(colormenu,MENU_NTH_ITEM,
                win->owner->root->def_color.cur_pallette + 2)) != 0) &&
         ((menu = xv_get(def,MENU_PULLRIGHT)) != 0) &&
         ((Xv_pkg *) xv_get(menu,XV_TYPE) == MENU))
        {PRT6(printf("win_show_def_color_scale_menu...1\n"))
         win_cur_event(win->dwin->frame,&event);
         if ((root = (Menu) root_menu(menu)) != 0)
            xv_set(root,MENU_CLIENT_DATA,win->dwin,0);
         
         xv_set(menu,MENU_NOTIFY_PROC,def_image_color_scale_proc,0);
/*
         if (win->data.cur_color_data < win->data.num_color_datas)
            {color_data = win->data.color_datas[win->data.cur_color_data];
             PRT6(printf("color_data = %u cur_color_data = %d\n",color_data,
                      win->data.cur_color_data))
             PRT6(printf("colormenu scale.label = %s\n",color_data->scale.label))
             if ((color_data->scale.label != NULL) &&
                 ((item = xv_find(menu,MENU_STRING,color_data->scale.label,0)) != NULL))
                {PRT6(printf("colormenu MENU_DEFAULT_ITEM item = %u\n",item))
                 xv_set(menu,MENU_DEFAULT_ITEM,item,0);
                }
            }
*/
         menu_show(menu,win->dwin->frame,&event,0);
        }
       else ShowMsgStrs(win->dwin->frame,1,NO_ERROR,1,2,
                   "Sorry...The Color Scale Menu is not accessible !!!",
                   "Please invoke it from the FILE menu",NULL,0);
     PRT6(printf("win_show_def_color_scale_menu...def = %u menu = %u\n",def,menu))
    }
   else ShowMsgStrs(win->dwin->frame,1,NO_ERROR,1,2,
                   "Sorry...The Color Pallette Menu is not accessible !!!",
                   "Please invoke it from the FILE menu",NULL,0);
 return NO_ERROR;
}


/*--------------------------------------------------------------------
image_color_scale_proc - ???
--------------------------------------------------------------------*/

void
image_color_scale_proc(menu,item,arg,window,last_event,option)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 int option;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 struct strs_rec *labels;
 Menu root;
 int err;

 PRT6(printf("image_color_scale_proc...\n"))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else
        {win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
         last_event = NULL;
         window = win1->frame;}
     option = (int) xv_get(item,MENU_VALUE);
    }
 PRT6(printf("image_color_scale_proc...option = %d\n",option))
 win = win1->owner;
 win->dwin = win1;
 if (option == 0)
    {win_show_def_color_scale_menu(win);
    }
   else if ((err = setup_strs_rec(&labels,0,0)) == NO_ERROR)
    {if ((err = WinSetupScaleLabels(win,labels)) == NO_ERROR)
        {labels->cur_str = win->data.cur_color_data;
         ShowMenuStrsProc(window,last_event,"CHOOSE IMAGE & ITS SCALE",
                       labels,USER_MENU_FREE_STR_PTRS_AND_PTR,
                       WinSetCurColorDataByScaleLabel,win,1,1,0);}
      else
       {free_strs_rec_ptrs(labels);
        c_free(labels);}
    }
}


/*--------------------------------------------------------------------
color_editor_proc - ???
--------------------------------------------------------------------*/

void
color_editor_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 enter_color_editor(win,1);
}



/*--------------------------------------------------------------------
quit_file - ???
--------------------------------------------------------------------*/

int
quit_file(file,which)
     struct input_file_rec *file;
     int which;
{
  int err;

  PRT2(printf("quit_file...begin\n"));
  (void) notify_cancel_itimer( file );
  if (file->slice_info.num_views > 0)
    unco_register_file(file);
  err = close_and_delete_file(file,0);
  PRT2(printf("quit_file...end..err = %d\n",err));
  return XV_OK;
}



/*--------------------------------------------------------------------
win_quit_the_file - ???
--------------------------------------------------------------------*/

int
win_quit_the_file(win)
     struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

 PRT2(printf("win_quit_the_file...begin\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->file->slice_info.num_views > 0) unco_register_file(img->file);
 err = close_and_delete_file(img->file,0);
 PRT2(printf("win_quit_the_file...end..err = %d\n",err))
 return err;

}


/*--------------------------------------------------------------------
win_quit_and_save_file_proc - ???

NOTE:  The pre-19990224 version of this function returned an int but
is always used in a context that insists on void.  I have changed the
return type to void.  -PWH
--------------------------------------------------------------------*/

void
win_quit_and_save_file_proc(
    Menu menu,
    Menu_item item,
    void *arg,
    Xv_Window window,
    Event *last_event)
{
 struct display_win_rec *win1;
 struct img_buf_rec *img;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }

 if ((img = win_rec_cur_img_buf(win1->owner->owner)) == NULL) return;
 PRT2(printf("win_quit_and_save_file_proc...begin\n"))
 ShowMsgStrs(win1->frame,1,NO_ERROR,0,2,
               "Quitting the file...",
               PLEASE_WAIT,win_quit_the_file,1,win1->owner);
}



/*--------------------------------------------------------------------
select_cursor_proc - ???
--------------------------------------------------------------------*/

void
select_cursor_proc(menu,item,arg,window,last_event,which_cursor)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
 long which_cursor;
{
 struct display_win_rec *win1;
 static unsigned long cursors[] = 
                {CURSOR_DEFAULT,CURSOR_PEN,CURSOR_DELETE_ROI,
                 CURSOR_MOVE_ROI,CURSOR_ROTATE_ROI,CURSOR_RESIZE_ROI};
 static int num_cursors = 6;
 int lcv;
 Menu root;

 PRT1(printf("select_cursor_proc...which_cursor = %d\n",which_cursor))
 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;
     if (win1->owner->type2 & HISTOGRAM_1D_WINDOW_DISPLAY_ONLY)
        which_cursor = 0;
       else if (which_cursor < 0)
        {which_cursor = -which_cursor - 1;
         if ((which_cursor >= 0) && (which_cursor < num_cursors))
            which_cursor = cursors[which_cursor];
         PRT1(printf("1...which_cursor = %d\n",which_cursor))
        }
       else 
        {if (which_cursor == 0) 
            for (lcv = 0; lcv < num_cursors; lcv++)
               if (cursors[lcv] == win1->owner->control.which_cursor)
                  {if ((last_event != NULL) && event_shift_is_down(last_event))
                      {if (lcv == 0) lcv = num_cursors - 1;
                         else lcv -= 1;}
                     else
                      {lcv += 1;
                       if (lcv == num_cursors) lcv = 0;}
                   which_cursor = cursors[lcv];
                   break;}
        }
    }
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
     if (win1->owner->type2 & HISTOGRAM_1D_WINDOW_DISPLAY_ONLY)
        which_cursor = 0;
       else which_cursor = (long) xv_get(item,MENU_CLIENT_DATA);
    }
 TRACE(printf("select_cursor_proc...1...which_cursor = %d\n",which_cursor))
 win1->owner->dwin = win1;
 win_select_cursor(win1->owner,which_cursor);
}


/*--------------------------------------------------------------------
setup_cursor_menu - ???
--------------------------------------------------------------------*/

Menu 
setup_cursor_menu()
{
 static Menu menu = 0;

 if ((menu == 0) || ((Xv_pkg *) xv_get(menu,XV_TYPE) != MENU))
    menu = xv_create(0,MENU,
        MENU_RELEASE,
        MENU_ITEM,
           MENU_STRING,CURSOR_DEFAULT_LABEL,
           MENU_CLIENT_DATA,CURSOR_DEFAULT,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_PEN_LABEL,
           MENU_CLIENT_DATA,CURSOR_PEN,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_DELETE_ROI_MODE,
           MENU_CLIENT_DATA,CURSOR_DELETE_ROI,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_MOVE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_MOVE_ROI,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_RESIZE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_RESIZE_ROI,0,
        MENU_ITEM,
           MENU_STRING,CURSOR_ROTATE_ROI_LABEL,
           MENU_CLIENT_DATA,CURSOR_ROTATE_ROI,0,
        0);
 return menu;
}


/*--------------------------------------------------------------------
gen_cursor_menu_proc - ???
--------------------------------------------------------------------*/

Menu 
gen_cursor_menu_proc(menu,operation)
 Menu menu;
 Menu_generate operation;
{
 Menu menu1,root;
 struct display_win_rec *win1;
 struct image_display_window *win;
 Event *last_event;
 Xv_Window window;

 TRACE(printf("gen_cursor_menu_proc in...\n"))
 
 switch (operation)
    {
     case MENU_DISPLAY : 
        root = (Menu) root_menu(menu);
        if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
           {window = (Xv_Window) event_window(last_event);
            win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
           }
          else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
        win = win1->owner;
        if (win1->owner->type2 & DISPLAY_WINDOW_3D)
           menu1 = (Menu) setup_3d_cursor_menu();
          else
           {menu1 = setup_cursor_menu();
            xv_set(menu1,
                 MENU_NOTIFY_PROC,select_cursor_proc,0);}

        xv_set(menu,MENU_PULLRIGHT,menu1,0);
    }
 return menu;
}


/*--------------------------------------------------------------------
display_menu_help_proc - ???
--------------------------------------------------------------------*/

void
display_menu_help_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct display_win_rec *win1;
 struct image_display_window *win;
 char *fn;
 Menu root;

 if (menu == 0)
    {win1 = (struct display_win_rec *) arg;}
   else
    {root = (Menu) root_menu(menu);
     if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
        {window = (Xv_Window) event_window(last_event);
         win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
        }
       else win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
    }
 win = win1->owner;
 win->dwin = win1;

 fn = (char *) get_prog_def_fn(win->owner->root->prog,DISPLAY_MENU_HELP_FN);
 enter_display_text_file(win1->frame,1,NULL,fn);
 c_free(fn);

}



/*--------------------------------------------------------------------
show_all_file_proc - ???
--------------------------------------------------------------------*/

int
show_all_file_proc(prog,chosen,item,str,row,op,event)
     struct prog_rec *prog;
     struct chosen_fn_rec *chosen;
     Panel_item item;
     char *str;
     int row;
     Panel_list_op op;
     Event *event;
{
  Panel panel;
  char *reason,*imgfn,*hdrfn,*datfn,*datfn1,*fn,
    *thedatdir,*thedatfn;
  struct strs_rec *ptr;
  int err;


  if (chosen->more_dir_fns.num_strs == 2)
  {
    thedatdir = chosen->more_dir_fns.strs[0];
    thedatfn = chosen->more_dir_fns.strs[1];
  }
  else
    return CANCEL;

  TRACE( printf("thedatfn = %s\n",thedatfn); );
  datfn1 = hdrfn = imgfn = datfn = NULL;
  if ((err = cp_str(&fn,str)) != NO_ERROR)
    return err;
  drop_suffix(fn);
  if ((datfn = get_dat_fn(fn,thedatfn)) == NULL)
  {
    c_free(fn);
    return err;
  }

  if (((err = concat_strs(&hdrfn,3,chosen->dir,"/",str)) == NO_ERROR) &&
      ((err = concat_strs(&imgfn,4,chosen->dir,"/",fn,".img")) == NO_ERROR) &&
      ((err = concat_strs(&datfn1,3,thedatdir,"/",datfn)) == NO_ERROR))
  {
    if (file_access(hdrfn,12,NULL,&reason) != NO_ERROR)
    {
      c_free(hdrfn);
      hdrfn = reason;
    }
    if (file_access(imgfn,12,NULL,&reason) != NO_ERROR)
    {
      c_free(imgfn);
      imgfn = reason;
    }
    if (file_access(datfn1,14,NULL,&reason) != NO_ERROR)
    {
      c_free(datfn1);
      datfn1 = reason;
    }

    panel = (Panel) xv_get(item,XV_OWNER);
    if (((err = setup_strs_rec(&ptr,0,0)) == NO_ERROR) &&
	((err = build_strs_rec(ptr,0,3,hdrfn,imgfn,datfn1)) == NO_ERROR))
      ShowMenuStrsProc(panel,event,"INPUT/OUTPUT FILES",
                       ptr,USER_MENU_FREE_STRS_AND_PTR,NULL,NULL,0,0,0);
    else if (ptr != NULL)
    {
      free_strs_rec(ptr);
      c_free(ptr);
    }
  }
  c_free(hdrfn);
  c_free(imgfn);
  c_free(datfn);
  c_free(datfn1);
  c_free(fn);
  return err;
}



/*--------------------------------------------------------------------
get_fns_menu - ???
--------------------------------------------------------------------*/

void
get_fns_menu( frame, which )
     Frame frame;
     int which;
{
  struct prog_rec *prog;

  prog = (struct prog_rec *) xv_get( frame, WIN_CLIENT_DATA );

  ask_files(1, frame, "Get image, header, and region files",
	    NULL, 1, 1, open_fn_proc, prog, NULL, NULL, 1,
	    prog->defaults.whch.hdr_fn, 1, 1, 10, 0, show_all_file_proc,
	    prog,
	    2,
	    NULL, NULL, NULL,
	    "*.nhdr", prog->defaults.whch.hdr_fn, NULL, NULL,
	    prog->defaults.whch.dat_dir, NULL, NULL,
	    "*.ndat", prog->defaults.whch.dat_fn, NULL, NULL
	    );
}



/*--------------------------------------------------------------------
win_select_fns_menu_proc - ???

NOTE:  The pre-19990224 version of this function returned an int
but is always used in contexts that insist on void.  I have changed
the return type to void.  -PWH
--------------------------------------------------------------------*/

void
win_select_fns_menu_proc(
    Menu menu,
    Menu_item item,
    void *arg,
    Xv_Window window,
    Event *last_event)
{
  struct display_win_rec *win1;
  struct img_buf_rec *img;
  struct prog_rec *prog;
  Frame *frame;
  Menu root;
  char *dir,*datdir;

  if (menu == 0)
  {
    win1 = (struct display_win_rec *) arg;
  }
  else
  {
    root = (Menu) root_menu(menu);
    if ((last_event = (Event *) xv_get(root,MENU_FIRST_EVENT)) != NULL)
    {
      window = (Xv_Window) event_window(last_event);
      win1 = (struct display_win_rec *) xv_get(window,WIN_CLIENT_DATA);
    }
    else
      win1 = (struct display_win_rec *) xv_get(root,MENU_CLIENT_DATA);
  }

  /*  main_display(2,...) = GET_MAIN_DISPLAY  */
  if ((frame = (Frame *) main_display(2,NULL,0,0)) != NULL)
  {
    prog = (struct prog_rec *) xv_get(*frame,WIN_CLIENT_DATA);
    if (win1 != NULL)
    {
      if ((img = win_rec_cur_img_buf(win1->owner->owner)) == NULL)
	return;
      dir = img->file->dirfn;
      datdir = img->file->output.dirfn;
    }
    else
    {
      dir = NULL;
      datdir = prog->defaults.whch.dat_dir;
    }
     
    ask_files( 1, *frame,
	       "GET *.nhdr/*.ndat/*.img FILES", NULL, 1, 1,
	       open_fn_proc, prog, NULL, NULL,

	       1,
	       prog->defaults.whch.hdr_fn, 1,
	       1, 10, 0, show_all_file_proc, prog,

	       2,
	       dir, NULL, NULL,
	       "*.nhdr FN", prog->defaults.whch.hdr_fn, NULL, NULL,
	       datdir, NULL, NULL,
	       "*.ndat FN", prog->defaults.whch.dat_fn, NULL, NULL
	       );
  }
}



/*********************
batch_file_proc(menu,item,arg,window,last_event)
 Menu menu;
 Menu_item item;
 void *arg;
 Xv_Window window;
 Event *last_event;
{
 struct prog_rec *prog;
 struct display_win_rec *win;
 Menu root;

 if (menu == NULL)
    {win = (struct display_win_rec *) arg;
     prog = win->owner->owner->root->prog;
    }
   else prog = (struct prog_rec *) menu_get(item,MENU_CLIENT_DATA);
 enter_batch(prog,1);

}
**********************/
