/****************************************************************************
fill_objects.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: fill_objects.c,v 1.9 1999/07/07 17:41:16 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "object.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)



/* Functions defined in this file */
int fill_all_objs_regions(struct all_object_rec *all_objs, int is_fill_id_2d,
    unsigned long id_2d_val, struct buf_2d_rec *obj_2d, struct buf_2d_rec *_2d,
    unsigned long filled_val);
int fill_all_objs(struct all_object_rec *all_objs, int is_fill_id_2d,
    struct buf_2d_rec *obj_2d, struct buf_2d_rec *_2d,
    unsigned long filled_val);
int fill_all_objs_in_new_2d(struct all_object_rec *all_objs,
    int is_fill_id_2d, struct buf_2d_rec *_2d, unsigned long filled_val);
int fill_all_objs_in_orig_2d(struct all_object_rec *all_objs,
    int is_fill_id_2d, struct buf_2d_rec *_2d, unsigned long filled_val);
int fill_and_get_2d_objs(struct all_object_rec *all_objs, int is_fill_id_2d,
    struct buf_2d_rec *_2d, unsigned long filled_val);
int fill_all_objs_in_2d(struct buf_2d_rec *_2d, unsigned long filled_val);
int NoOverlapCoords(struct int_rect_rec *coord_area,
    struct curve_rec **curves, unsigned long *num_curves,
    struct curve_rec **cur_curves, unsigned long *num_cur_curves,
    struct matrix_2d_rec *localto);
int FillObjRegion(struct all_object_rec *all_objs, int is_fill_id_2d,
    struct curve_rec **curves, unsigned long num_curves,
    struct matrix_2d_rec *localto, struct coord_rec *coords,
    struct buf_2d_rec *_2d, unsigned long filled_val);
int sort_curves_by_bound_proc(const void *curve1, const void *curve2);
int FillCurves(struct curve_rec **curves, unsigned long num_curves,
    struct matrix_2d_rec *localto, struct buf_2d_rec *out_2d,
    unsigned long filled_val, int is_init_out_2d, struct buf_2d_rec *temp_2d,
    struct all_object_rec *all_objs, int is_fill_id_2d, int is_exclusive);
int FillEexclusiveObjRegions(struct curve_rec **curves,
    unsigned long num_curves, struct matrix_2d_rec *localto,
    struct buf_2d_rec *out_2d, unsigned long filled_val, int is_init_out_2d);
int FillROi(struct roi_rec *roi, struct matrix_2d_rec *localto,
    struct buf_2d_rec *out_2d, unsigned long filled_val, int is_init_out_2d,
    int is_exclusive);
int ScanRoiFromBuf(struct slice_roi_rec *slice_roi,
    struct strs_rec *roi_label, struct buf_2d_rec *_2d,
    unsigned long roi_prog_status, int *is_roi_ok);



/*------------------------------------------------------------------------
fill_all_objs_regions - ???
-------------------------------------------------------------------------*/

int
fill_all_objs_regions(all_objs,is_fill_id_2d,id_2d_val,obj_2d,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 unsigned long id_2d_val;
 struct buf_2d_rec *obj_2d,*_2d;
 unsigned long filled_val;
{
 unsigned long lcv,cnt,indx,first,last,next,num,y;
 struct xy_rec *pts;

 TRACE(printf("fill_all_objs_regions...\n"))
 TRACE(pr_all_object_rec(all_objs);)
 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if (all_objs->objs[lcv]->num_pts > 0) sort_xy_rec(all_objs->objs[lcv]);
     pts = all_objs->objs[lcv]->pts;
     for (cnt = 0; cnt < all_objs->objs[lcv]->num_pts; )
        {first = pts[cnt].x;
         next = cnt + 1;
         num = cnt;
         if (next >= all_objs->objs[lcv]->num_pts)
            {cnt = next;
             last = first;}
           else if (pts[cnt].y == pts[next].y)
            {
             for (indx = next; indx < all_objs->objs[lcv]->num_pts; indx++)
                if (pts[cnt].y != pts[indx].y)
                   {indx -= 1;
                    break;}
                  else if ((pts[indx - 1].x + 1) != pts[indx].x)
                   {
                    if (get_1d_buf_value(all_objs->in_2d->buf[pts[indx-1].y],
                       (unsigned long) pts[indx-1].x + 1,
                        all_objs->in_2d->pixel_depth))
                       {
                        indx -= 1;
                        break;
                       }
                    }
             if (indx == all_objs->objs[lcv]->num_pts) indx--;
             last = pts[indx].x;
             cnt = indx + 1;
            }
           else
            {cnt = next;
             last = first;}
         y = pts[num].y;
         if (is_fill_id_2d)
            for (indx = first; indx <= last; indx++)
                set_1d_buf_value(obj_2d->buf[y],indx,
                      obj_2d->pixel_depth,id_2d_val);

         TRACE(printf("%d]->pts[num].y = %d first = %d last = %d\n",lcv,(int) pts[num].y,first,last))
         for (indx = first; indx <= last; indx++)
            {
             set_1d_buf_value(_2d->buf[y],indx,
                      _2d->pixel_depth,filled_val);
            }
         if (indx <= last) cnt = indx;
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
fill_all_objs - ???
-------------------------------------------------------------------------*/

int
fill_all_objs(all_objs,is_fill_id_2d,obj_2d,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 struct buf_2d_rec *obj_2d,*_2d;
 unsigned long filled_val;
{
 unsigned long lcv,cnt,indx,first,last,next,num,y;
 struct xy_rec *pts;
 long id_2d_val;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if (all_objs->objs[lcv]->num_pts > 0) sort_xy_rec(all_objs->objs[lcv]);
     pts = all_objs->objs[lcv]->pts;
     for (cnt = 0; cnt < all_objs->objs[lcv]->num_pts; )
        {first = pts[cnt].x;
         next = cnt + 1;
         num = cnt;
         if (next >= all_objs->objs[lcv]->num_pts)
            {cnt = next;
             last = first;}
           else if (pts[cnt].y == pts[next].y)
            {
             for (indx = next; indx < all_objs->objs[lcv]->num_pts; indx++)
                if (pts[cnt].y != pts[indx].y)
                   {indx -= 1;
                    break;}
                  else if ((pts[indx - 1].x + 1) != pts[indx].x)
                   {
                    if (get_1d_buf_value(all_objs->in_2d->buf[pts[indx-1].y],
                       (unsigned long) pts[indx-1].x + 1,
                        all_objs->in_2d->pixel_depth))
                       {
                        indx -= 1;
                        break;
                       }
                    }
             if (indx == all_objs->objs[lcv]->num_pts) indx--;
             last = pts[indx].x;
             cnt = indx + 1;
            }
           else
            {cnt = next;
             last = first;}
         y = pts[num].y;
         if (is_fill_id_2d)
            for (indx = first; indx <= last; indx++)
               {id_2d_val = all_objs->objs[lcv]->id;
                set_1d_buf_value(obj_2d->buf[y],indx,
                      obj_2d->pixel_depth,id_2d_val);}

         TRACE(printf("%d]->pts[num].y = %d first = %d last = %d\n",lcv,(int) pts[num].y,first,last))
         for (indx = first; indx <= last; indx++)
            {
             set_1d_buf_value(_2d->buf[y],indx,
                      _2d->pixel_depth,filled_val);
            }
         if (indx <= last) cnt = indx;
        }
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
fill_all_objs_in_new_2d - ???
-------------------------------------------------------------------------*/

int
fill_all_objs_in_new_2d(all_objs,is_fill_id_2d,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 struct buf_2d_rec *_2d;
 unsigned long filled_val;
{
 unsigned long lcv,cnt;
 int err;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {for (cnt = 0; cnt < all_objs->objs[lcv]->num_pts; )
        set_1d_buf_value(_2d->buf
                [(unsigned long) all_objs->objs[lcv]->pts[cnt].y],
                (unsigned long) all_objs->objs[lcv]->pts[cnt].x,
                      _2d->pixel_depth,filled_val);

     if (all_objs->objs[lcv]->excluded_regions != NULL)
        if ((err = fill_all_objs_regions(all_objs->objs[lcv]->excluded_regions,
                  is_fill_id_2d,all_objs->objs[lcv]->id,&(all_objs->id_2d),
                  _2d,filled_val)) != NO_ERROR) return err;
    }

 return NO_ERROR;
}


/*------------------------------------------------------------------------
fill_all_objs_in_orig_2d - ???
-------------------------------------------------------------------------*/

int
fill_all_objs_in_orig_2d(all_objs,is_fill_id_2d,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 struct buf_2d_rec *_2d;
 unsigned long filled_val;
{
 unsigned long lcv;
 int err;

 for (lcv = 0; lcv < all_objs->num_objs; lcv++)
    {
     if (all_objs->objs[lcv]->excluded_regions != NULL)
        {
         PRT(printf(" ...excluded_regions != NULL\n"))
         if ((err = fill_all_objs_regions(all_objs->objs[lcv]->excluded_regions,
                  is_fill_id_2d,all_objs->objs[lcv]->id,&(all_objs->id_2d),
                  _2d,filled_val)) != NO_ERROR) return err;
        }
    }

 return NO_ERROR;
}


/*------------------------------------------------------------------------
fill_and_get_2d_objs - ???
-------------------------------------------------------------------------*/

int
fill_and_get_2d_objs(all_objs,is_fill_id_2d,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 struct buf_2d_rec *_2d;
 unsigned long filled_val;
{
 struct int_bound_rec bound;
 int err;

 setup_int_bound_rec(&bound,0,0,_2d->dimx - 1,_2d->dimy - 1);
 err = setup_all_object_rec(all_objs,_2d,NULL,0,&bound,1,1);
 if (err == NO_ERROR) {
     /* Removed final argument "0" below, since the function definition
	does not expect it.  -PWH 19990617 */
     if (((err = detect_all_objs(all_objs,1/*,0*/)) == NO_ERROR) &&
	 ((err = detect_all_sub_objs(all_objs,0,0)) == NO_ERROR))
	 err = fill_all_objs_in_orig_2d(all_objs,is_fill_id_2d,_2d,
					filled_val);
 }
 return err;
}



/*------------------------------------------------------------------------
fill_all_objs_in_2d - ???
-------------------------------------------------------------------------*/

int
fill_all_objs_in_2d(_2d,filled_val)
 struct buf_2d_rec *_2d;
 unsigned long filled_val;
{
 struct all_object_rec all_objs;
 int err;

 init_all_object_rec(&all_objs);
 err = fill_and_get_2d_objs(&all_objs,0,_2d,filled_val);

 free_all_object_rec1(&all_objs,1);
 return err;
}


/*------------------------------------------------------------------------
NoOverlapCoords - ???
-------------------------------------------------------------------------*/

int
NoOverlapCoords(coord_area,curves,num_curves,
                cur_curves,num_cur_curves,localto)
 struct int_rect_rec *coord_area;
 struct curve_rec **curves,**cur_curves;
 unsigned long *num_curves,*num_cur_curves;
 struct matrix_2d_rec *localto;
{
 unsigned long lcv,num,indx;
 struct int_rect_rec rr2,intersected;
 long minx,maxx,miny,maxy;

 *num_cur_curves = 0;
 if (*num_curves == 0) return NO_ERROR;
 if (FindCurveLongMinMax(curves[0],localto,&minx,&maxx,&miny,&maxy,
              (unsigned short) 0,0,0,0) != NO_ERROR)
    return NO_ERROR;
 setup_int_rect_rec(coord_area,minx,miny,maxx - minx + 1,maxy - miny + 1);
 cur_curves[(*num_cur_curves)++] = curves[0];
 curves[0] = NULL;

 if (*num_curves > 1)
    {
     num = *num_curves;

     for (lcv = 1; lcv < num; lcv++)
        {
         if (FindCurveLongMinMax(curves[lcv],localto,&minx,&maxx,&miny,&maxy,
                    (unsigned short) 0,0,0,0) != NO_ERROR)
            continue;
         setup_int_rect_rec(&rr2,minx - 1,miny - 1,maxx - minx + 3,maxy - miny + 3);
         if (get_intersected_rect(coord_area,&rr2,&intersected) == 
                        RECT_NO_OVERLAP) 
            {
             setup_int_rect_rec(&rr2,minx,miny,maxx - minx + 1,maxy - miny + 1);
             cur_curves[(*num_cur_curves)++] = curves[lcv];
             curves[lcv] = NULL;
             combine_rects(coord_area,&rr2);
            }
        }
     for (indx = 0,lcv = 0; lcv < num; lcv++)
        if (curves[lcv] != NULL) curves[indx++] = curves[lcv];
     *num_curves = indx;
    }
   else *num_curves -= 1;
 return NO_ERROR;
}



/*------------------------------------------------------------------------
FillObjRegion - ???
-------------------------------------------------------------------------*/

int
FillObjRegion(all_objs,is_fill_id_2d,curves,num_curves,localto,
              coords,_2d,filled_val)
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 struct curve_rec **curves;
 unsigned long num_curves;
 struct matrix_2d_rec *localto;
 struct coord_rec *coords;
 struct buf_2d_rec *_2d;
 unsigned long filled_val;
{
 unsigned long lcv,cnt,total_pts;
 int err;

 for (cnt = 0; cnt < num_curves; cnt++)
    {
     coords->num_pts = 0;
     all_objs->cur_obj = (struct object_rec *) get_obj(all_objs,
               all_objs->next_id,&err);
     if (err != NO_ERROR) return err;
     PRT(printf("%d) FillObjRegion.curve num = %d..coords num = %d  total_pts = %d\n",
         cnt,(int) curves[cnt]->num_xys,coords->num_pts,coords->total_pts))

     if ((err = DrawInBuf(_2d->buf,0,0,
            _2d->dimx - 1,_2d->dimy - 1,_2d->pixel_depth,
            curves[cnt]->xys,curves[cnt]->num_xys,
           (unsigned int) (curves[cnt]->status & DRAW_MODE),
           &(curves[cnt]->matrix),(int) (curves[cnt]->status & CURVE_MATRIX_IN_USE),
            (long) 1,coords,&total_pts,localto)) != NO_ERROR)
        return err;
     PRT(printf("total_pts = %d\n",total_pts))
     for (lcv = 0; lcv < coords->num_pts; lcv++)
        {
         TRACE(printf("%d) x = %d   y = %d\n",lcv,
             (long) coords->pts[lcv].x,(long) coords->pts[lcv].y))
         if (get_1d_buf_value(all_objs->id_2d.buf
                           [(unsigned long) coords->pts[lcv].y],
                           (unsigned long) coords->pts[lcv].x,
                           all_objs->id_2d.pixel_depth) != 0) 
            continue;
         set_1d_buf_value(all_objs->id_2d.buf
                           [(unsigned long) coords->pts[lcv].y],
                           (unsigned long) coords->pts[lcv].x,
                           all_objs->id_2d.pixel_depth,
                           (unsigned long) all_objs->cur_obj->id);
         if ((err = enter_obj_xy(all_objs->cur_obj,
                           (unsigned short) OBJ_BOUNDARY_PT,
                           (unsigned long) coords->pts[lcv].x,
                           (unsigned long) coords->pts[lcv].y)) != NO_ERROR)
             return err;
        }

    }

/*
 err = fill_all_objs(all_objs,is_fill_id_2d,&(all_objs->id_2d),_2d,filled_val);
*/
 PRT(printf(" FillObjRegion...&&&\n"))
 PRT(pr_all_object_rec(all_objs,0))

 if ((err = detect_all_sub_objs(all_objs,0,0)) == NO_ERROR)
    {
     PRT(printf("after detect_all_sub_objs...&&&\n"))
     PRT(pr_all_object_rec(all_objs,0))

     PRT(printf(" FillObjRegion...fill_all_objs_in_orig_2d _2d = %d in_2d = %d id_2d = %d\n",
                   CntValBuf2dRec(_2d,(double) 0),
                   CntValBuf2dRec(all_objs->in_2d,(double) 0),
                   CntValBuf2dRec(&(all_objs->id_2d),(double) 0)))
     err = fill_all_objs_in_orig_2d(all_objs,is_fill_id_2d,
                          _2d,filled_val);

    }

 TRACE(printf(" FillObjRegion...END...err = %d\n",err))
 return err;
}

/******************
sort_curves_by_bound_proc(curve1,curve2)
 struct curve_rec **curve1,**curve2;
{
 long top,left,right,bottom,top1,left1,right1,bottom1;

 if (FindCurveLongMinMax(*curve1,NULL,&left,&right,&top,&bottom,
        (unsigned short) 0,0,0,0) != NO_ERROR)
    return 1;
 if (FindCurveLongMinMax(*curve2,NULL,&left1,&right1,&top1,&bottom1,
     (unsigned short) 0,0,0,0) != NO_ERROR)
    return 1;
 if (top > top1) return 1;
 if (top < top1) return -1;
 if (left > left1) return 1;
 if (left < left1) return -1;
 return 0;
}
********************/


/*------------------------------------------------------------------------
sort_curves_by_bound_proc - ???
-------------------------------------------------------------------------*/

int
sort_curves_by_bound_proc(curve1,curve2)
 const void *curve1,*curve2;
{
 long top,left,right,bottom,top1,left1,right1,bottom1;

 if (FindCurveLongMinMax(*((struct curve_rec **) curve1),
        NULL,&left,&right,&top,&bottom,
        (unsigned short) 0,0,0,0) != NO_ERROR)
    return 1;
 if (FindCurveLongMinMax(*((struct curve_rec **) curve2),
     NULL,&left1,&right1,&top1,&bottom1,
     (unsigned short) 0,0,0,0) != NO_ERROR)
    return 1;
 if (top > top1) return 1;
 if (top < top1) return -1;
 if (left > left1) return 1;
 if (left < left1) return -1;
 return 0;
}


/*------------------------------------------------------------------------
FillCurves - ???

is_exclusive == 0 then depending on curves
  if (curve->status & CURVE_OR) then or
    else exclusive-or
is_exclusive == 1
  exclusive-or all curves
is_exclusive == 2
  or all curves
-------------------------------------------------------------------------*/

int
FillCurves(curves,num_curves,localto,out_2d,filled_val,is_init_out_2d,
           temp_2d,all_objs,is_fill_id_2d,is_exclusive)
 struct curve_rec **curves;
 unsigned long num_curves;
 struct matrix_2d_rec *localto;
 struct buf_2d_rec *out_2d,*temp_2d;
 unsigned long filled_val;
 int is_init_out_2d;
 struct all_object_rec *all_objs;
 int is_fill_id_2d;
 int is_exclusive;
{
 struct int_bound_rec bound;
 struct int_rect_rec coord_area;
 struct curve_rec **temp_curves,**cur_curves;
 unsigned long num_temp_curves,num_cur_curves;
 struct coord_rec coords;
 int err,is_write;
 unsigned long lcv,cnt;
 struct buf_2d_rec *_2d;
 long minx,maxx,miny,maxy;

 PRT2(printf("FillCurves....out_2d = %u is_init_out_2d = %d\n",
            out_2d,is_init_out_2d))
 PRT2(if (out_2d != NULL) pr_buf_2d_rec(out_2d))
 if (is_init_out_2d) InitBuf2dRecData(out_2d,(double) .0);
 PRT2(printf("FillCurves....out_2d = %d\n",CntValBuf2dRec(out_2d,(double) 0)))
 num_temp_curves = 0;
 if ((err = get_ptr(&(temp_curves),&num_temp_curves,num_curves * 2,
        (size_t) sizeof(*temp_curves))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < num_temp_curves; lcv++)
    temp_curves[lcv] = NULL;

 for (num_temp_curves = lcv = 0; lcv < num_curves; lcv++)
    {
     if ((curves[lcv] != NULL) && (curves[lcv]->num_xys > 0))
        {temp_curves[num_temp_curves++] = curves[lcv];
        }
    }
 PRT2(printf("FillCurves....1\n"))

 num_cur_curves = 0;
 cur_curves = temp_curves + num_curves;
 if (num_temp_curves == 0)
    {c_free(temp_curves);
     return NO_ERROR;}
   else if (num_temp_curves > 2)
    qsort(temp_curves,num_temp_curves,
        (size_t) sizeof(struct curve_rec *),
        sort_curves_by_bound_proc);
 if (is_init_out_2d)
    {is_write = 0;
     _2d = out_2d;}
   else
    {is_write = 1;
     _2d = temp_2d;
    }
 lcv = 0;
 err = NO_ERROR;
 init_coord_rec(&coords);
 PRT1(printf("FillCurves....1\n"))

 do
    {
     if (is_write)
        {if (!(temp_2d->status4 & BUF_NON_EMPTY))
            {if ((err = SetupBuf2dRec(temp_2d,out_2d->dimx,out_2d->dimy,
                        out_2d->pixel_depth,0)) != NO_ERROR)
                break;
            }
         InitBuf2dRecData(temp_2d,(double) .0);
         _2d = temp_2d;
        }
     NoOverlapCoords(&coord_area,
            temp_curves,&num_temp_curves,cur_curves,&num_cur_curves,localto);

     setup_int_bound_rec(&bound,coord_area.left,coord_area.top,
              coord_area.left + coord_area.width - 1,
              coord_area.top + coord_area.height - 1);
     if ((err = setup_all_object_rec(all_objs,_2d,NULL,0,
                    &bound,1,1)) != NO_ERROR)
        break;
     err = FillObjRegion(all_objs,is_fill_id_2d,
                 cur_curves,num_cur_curves,localto,&coords,_2d,filled_val);
     PRT(printf("FillCurves....2\n"))
     PRT(pr_all_object_rec(all_objs,0))
     PRT(printf("FillCurves....3 _2d = %d\n",CntValBuf2dRec(_2d,(double) 0)))
     coords.num_pts = 0;
/*
     printf("num_cur_curves = %d\n",num_cur_curves);
*/
     if (!is_write)
        {
         is_write = 1;}
       else
        {
         for (cnt = 0; cnt < num_cur_curves; cnt++)
            if (FindCurveLongMinMax(cur_curves[cnt],localto,
                   &minx,&maxx,&miny,&maxy,(unsigned short) 0,
                   0,0,0) == NO_ERROR)
               {setup_int_bound_rec(&bound,minx,miny,maxx,maxy);
                PRT1(printf("FillCurves....status = %x\n",
                      (unsigned long) cur_curves[cnt]->status);)
                if ((is_exclusive == 2) || ((is_exclusive == 0) && 
                     (cur_curves[cnt]->status & CURVE_OR)))
                   {PRT1(printf("FillCurves....superimpose = %d\n",
                      (unsigned long) cur_curves[cnt]->status);)
                    superimpose_bitmap_region(out_2d,temp_2d,&bound);}
                  else
                   {PRT1(printf("FillCurves....xor out_2d = %d temp_2d = %d\n",
                      CntValBuf2dRec(out_2d,(double) 0),
                      CntValBuf2dRec(temp_2d,(double) 0));)
              
                    xor_bitmaps_by_bound(out_2d,temp_2d,
                          bound.left,bound.top,bound.right,bound.bottom);}
                PRT1(printf("FillCurves....5\n"))
               }
        }
     lcv++;
    }
 while ((num_temp_curves > 0) && (err == NO_ERROR));
 free_coord_rec(&coords);
 c_free(temp_curves);
 PRT(printf("FillCurves....is_write = %d temp_2d = %u out_2d = %u _2d = %u out_2d = %d\n",is_write,temp_2d,out_2d,_2d,CntValBuf2dRec(out_2d,(double) 0)))

 return err;
}



/*------------------------------------------------------------------------
FillEexclusiveObjRegions - ???
-------------------------------------------------------------------------*/

int
FillEexclusiveObjRegions(curves,num_curves,localto,
                         out_2d,filled_val,is_init_out_2d)
 struct curve_rec **curves;
 unsigned long num_curves;
 struct matrix_2d_rec *localto;
 struct buf_2d_rec *out_2d;
 unsigned long filled_val;
 int is_init_out_2d;
{
 struct buf_2d_rec temp_2d;
 struct all_object_rec all_objs;
 int err;

 init_buf_2d_rec(&temp_2d);
 init_all_object_rec(&all_objs);
 /* FIXME!!  Guessed at the correct value for the final argument
    below.  -PWH 19990412 */
 err = FillCurves(curves,num_curves,localto,
                  out_2d,filled_val,is_init_out_2d,
                  &temp_2d,&all_objs,0,0);
 free_buf_2d_rec(&temp_2d);
 free_all_object_rec1(&all_objs,1);
 return err;

}


/*------------------------------------------------------------------------
FillROi - ???

is_exclusive == 0 then depending on curves
  if (curve->status & CURVE_OR) then or
    else exclusive-or
is_exclusive == 1
  exclusive-or all curves
is_exclusive == 2
  or all curves
-------------------------------------------------------------------------*/

int
FillROi( roi, localto, out_2d, filled_val, is_init_out_2d, is_exclusive )
 struct roi_rec *roi;
 struct matrix_2d_rec *localto;
 struct buf_2d_rec *out_2d;
 unsigned long filled_val;
 int is_init_out_2d,is_exclusive;
{
 unsigned long lcv,cnt,total_pts_drawn;
 struct buf_2d_rec temp_2d;
 struct all_object_rec all_objs;
 int err;
 struct curve_rec **curves,*curve;
 unsigned long num_curves,num_pens;
 struct curve_2d_rec *pen;
 struct coord_rec coords;
 long minx,maxx,miny,maxy;

 init_buf_2d_rec(&temp_2d);
 init_all_object_rec(&all_objs);
 err = NO_ERROR;
 PRT2(printf("FillROi...out_2d = %u localto = %u\n",out_2d,localto))
 init_coord_rec(&coords);
 for (num_pens = num_curves = 0,lcv = 0; lcv < roi->num_pens; lcv++)
    {pen = roi->pens[lcv];
     if (pen != NULL)
        if (pen->pen_type == DRAW_POINT)
           {
            PRT2(printf("%d) DRAW_POINT...num_curves = %d pen_type = %x\n",
                   lcv,pen->num_curves,(unsigned long) pen->pen_type))
            for (cnt = 0; cnt < pen->num_curves; cnt++)
               {curve = pen->curves[cnt];
                coords.num_pts = 0;
                PRT2(printf("cnt = %d) status = %d\n",cnt,
                       (unsigned long) curve->status);)
                if ((err = DrawInBuf(NULL,0,0,
                      out_2d->dimx - 1,out_2d->dimy - 1,out_2d->pixel_depth,
                      curve->xys,curve->num_xys,
                      (unsigned int) pen->pen_type,&(curve->matrix),
                      (int) (curve->status & CURVE_MATRIX_IN_USE),
                      1,&coords,&total_pts_drawn,localto)) != NO_ERROR)
                   return err;
                if ((is_exclusive == 2) || 
                    ((is_exclusive == 0) && (curve->status & CURVE_OR)))
                   set_buf_by_coord_rec(out_2d,&coords,1);
                  else
                   xor_set_buf_by_sorted_coord_rec(out_2d,&coords);
               }
           }
          else
           {
            PRT2(printf("%d)...num_curves = %d pen_type = %x\n",
                   lcv,pen->num_curves,(unsigned long) pen->pen_type))
            num_curves += pen->num_curves;
            curves = pen->curves;
            for (cnt = 0; cnt < pen->num_curves; cnt++)
               {curves[cnt]->status |= pen->pen_type;
                PRT2(printf("==FindCurveLongMinMaxm curves[cnt] = %u\n",curves[cnt]))
                PRT2(printf("==pen->pen_type = %x\n",(unsigned long) pen->pen_type))
                FindCurveLongMinMax(curves[cnt],localto,&minx,&maxx,
                       &miny,&maxy,pen->pen_type,0,0,1);
                PRT2(printf("==FindCurveLongMinMax...\n"))}
            num_pens += 1;}
     }
 PRT2(printf("FillROi...num_curves = %d num_pens = %d\n",num_curves,num_pens))
 free_coord_rec(&coords);
 if (num_curves == 0) return NO_ERROR;

 if (num_pens > 1)
    {
     if ((err = get_ptr(&(curves),NULL,num_curves,
             (size_t) sizeof(*curves))) != NO_ERROR)
         return err;
     for (lcv = 0; lcv < num_curves; lcv++)
        curves[lcv] = NULL;
     for (num_curves = 0,lcv = 0; (lcv < roi->num_pens) && (err == NO_ERROR); 
                              lcv++)
        if ((roi->pens[lcv] != NULL) && 
            (roi->pens[lcv]->pen_type != DRAW_POINT))
           for (cnt = 0; cnt < roi->pens[lcv]->num_curves; cnt++)
              {curves[num_curves] = roi->pens[lcv]->curves[cnt];
               num_curves++;
              }
    }

 PRT2(printf("FillROi...is_init_out_2d = %d\n",is_init_out_2d))
 if (err == NO_ERROR)
    err = FillCurves(curves,num_curves,localto,out_2d,
               filled_val,is_init_out_2d,&temp_2d,&all_objs,0,is_exclusive);
 PRT2(printf("FillROi...3\n"))
 free_buf_2d_rec(&temp_2d);
 free_all_object_rec1(&all_objs,1);
 if (num_pens > 1) c_free(curves);
 return err;
}


/*------------------------------------------------------------------------
ScanRoiFromBuf - ???
-------------------------------------------------------------------------*/

int
ScanRoiFromBuf(slice_roi,roi_label,_2d,roi_prog_status,is_roi_ok)
 struct slice_roi_rec *slice_roi;
 struct strs_rec *roi_label;
 struct buf_2d_rec *_2d;
 unsigned long roi_prog_status;
 int *is_roi_ok;
{
 struct curve_rec **curves;
 unsigned int total_curves,num_curves;
 unsigned short status;
 struct roi_rec *roi;
 int err;

 *is_roi_ok = 0;
 if ((_2d == NULL) || !(_2d->status4 & BUF_NON_EMPTY))
    return NO_ERROR;
 if (((err = scan_objects(_2d,NULL,
                  &curves,&total_curves,&num_curves,1,1)) == NO_ERROR) &&
     (num_curves > 0))
    {if (((err = setup_more_rois(slice_roi,roi_label,0)) == NO_ERROR) &&
         ((roi = get_roi(slice_roi,roi_label)) != NULL))
        {roi->prog_status |= roi_prog_status;
         if ((err = JoinCurvesToRoiRec(roi,curves,num_curves,
              &status,1.0,1.0,NULL,NULL,NULL)) != NO_ERROR)
            delete_roi(slice_roi,roi);
           else *is_roi_ok = 1;
        }
    }
 if (total_curves > 0)
    {if (num_curves > 0) free_curve_recs(curves,num_curves);
     c_free(curves);
    }
 return err;
}

