/****************************************************************************
histo_params_rec.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: histo_params_rec.c,v 1.9 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)



/* Functions defined in this file */
unsigned short file_get_def_histo_type(struct input_file_rec *file);
void init_pixel_center_rec(struct pixel_center_rec *center);
void free_pixel_center_rec(struct pixel_center_rec *center);
void init_histo_pixel_center_rec(struct histo_params_rec *histo);
void free_histo_pixel_center_rec(struct histo_params_rec *histo);
void init_pixel_type_ave_rec(struct pixel_type_ave_rec *type_ave);
void init_pixel_tissue_type_rec(struct pixel_tissue_type_rec *type);
void free_pixel_tissue_type_rec(struct pixel_tissue_type_rec *type);
void free_all_pixel_tissue_type_recs(struct pixel_tissue_type_rec *types,
    unsigned long total_types, unsigned long num_types);
void init_histo_pixel_tissue_type_rec(struct histo_params_rec *histo);
void free_histo_pixel_tissue_type_rec(struct histo_params_rec *histo);
void pr_pixel_tissue_type_rec(struct pixel_tissue_type_rec *type);
void pr_histo_pixel_tissue_type_rec(struct histo_params_rec *histo);
int init_default_histo_bkgs(struct histo_params_rec *histo);
void init_histo_bkg_rec(struct histo_bkg_rec *bkg);
void free_histo_bkg_rec(struct histo_bkg_rec *bkg);
void init_histo_params_rec(struct histo_params_rec *histo,
    struct input_file_rec *file);
void free_histo_params_rec(struct histo_params_rec *histo);
struct buf_2d_rec *GetHistoBuf(struct histo_params_rec *histo,
    int histo_type2);
struct slice_roi_win_rec *GetHistoSliceRoiWinRec(
   struct histo_params_rec *histo, int histo_type2);
int HistoBufReady(struct input_file_rec *file, int histo_type2);
void get_histo_dim(struct histo_params_rec *histo,
    unsigned int *histo_dimx, unsigned int *histo_dimy,
    unsigned int *pixel_depth, int histo_type2);
int setup_histo_params_rec(struct histo_params_rec *histo,
    struct input_file_rec *file, int histo_type2);



/*------------------------------------------------------------------------
file_get_def_histo_type - ???
------------------------------------------------------------------------*/

unsigned short 
file_get_def_histo_type(file)
 struct input_file_rec *file;
{
 if (file->hdr.data_info.num_echoes == 2)
    return HISTO_MULTI_D;
   else return HISTO_1D;
}


/*------------------------------------------------------------------------
init_pixel_center_rec - ???
------------------------------------------------------------------------*/

void
init_pixel_center_rec(center)
 struct pixel_center_rec *center;
{
 center->roi_label = NULL;
 center->segmented_roi_label = NULL;
 center->ave_occurences = center->num_xy_pairs = 0;
 center->avex = center->avey = 0;
}


/*------------------------------------------------------------------------
free_pixel_center_rec - ???
------------------------------------------------------------------------*/

void
free_pixel_center_rec(center)
 struct pixel_center_rec *center;
{
 c_free(center->roi_label);
 c_free(center->segmented_roi_label);
 init_pixel_center_rec(center);
}


/*------------------------------------------------------------------------
init_histo_pixel_center_rec - ???
------------------------------------------------------------------------*/

void
init_histo_pixel_center_rec(histo)
 struct histo_params_rec *histo;
{
 histo->total_centers = histo->num_centers = histo->cur_center = 0;
 histo->centers = NULL;
}


/*------------------------------------------------------------------------
free_histo_pixel_center_rec - ???
------------------------------------------------------------------------*/

void
free_histo_pixel_center_rec(histo)
 struct histo_params_rec *histo;
{
 long lcv;

 if (histo->total_centers > 0)
    {for (lcv = 0; lcv < histo->num_centers; lcv++)
        free_pixel_center_rec(&(histo->centers[lcv]));

     c_free(histo->centers);}
 init_histo_pixel_center_rec(histo);
}


/*------------------------------------------------------------------------
init_pixel_type_ave_rec - ???
------------------------------------------------------------------------*/

void
init_pixel_type_ave_rec(type_ave)
 struct pixel_type_ave_rec *type_ave;
{
 type_ave->x = type_ave->y = 0;
 type_ave->num_freqs = 0;
}


/*------------------------------------------------------------------------
init_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
init_pixel_tissue_type_rec(type)
 struct pixel_tissue_type_rec *type;
{
 type->status = 0;
 type->abs_lb = type->ext_lb = type->actual_lb = 0x7fffffff;
 type->abs_ub = type->ext_ub = type->actual_ub = -1;
 init_pixel_type_ave_rec(&(type->type_ave));
 type->roi_label = type->segmented_roi_label = NULL;
}


/*------------------------------------------------------------------------
free_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
free_pixel_tissue_type_rec(type)
 struct pixel_tissue_type_rec *type;
{
 c_free(type->roi_label);
 c_free(type->segmented_roi_label);
 init_pixel_tissue_type_rec(type);
}


/*------------------------------------------------------------------------
free_all_pixel_tissue_type_recs - ???
------------------------------------------------------------------------*/

void
free_all_pixel_tissue_type_recs(types,total_types,num_types)
 struct pixel_tissue_type_rec *types;
 unsigned long total_types,num_types;
{
 long lcv;

 if (total_types > 0)
    {for (lcv = 0; lcv < num_types; lcv++)
        free_pixel_tissue_type_rec(&(types[lcv]));
     c_free(types);}
}


/*------------------------------------------------------------------------
init_histo_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
init_histo_pixel_tissue_type_rec(histo)
 struct histo_params_rec *histo;
{
 histo->total_types = histo->num_types = histo->cur_type = 0;
 histo->types = NULL;
}


/*------------------------------------------------------------------------
free_histo_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
free_histo_pixel_tissue_type_rec(histo)
 struct histo_params_rec *histo;
{

 free_all_pixel_tissue_type_recs(histo->types,histo->total_types,
          histo->num_types);
 init_histo_pixel_tissue_type_rec(histo);
}


/*------------------------------------------------------------------------
pr_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
pr_pixel_tissue_type_rec(type)
 struct pixel_tissue_type_rec *type;
{
 printf("roi labe = %s  segmented_roi_label = %s\n",
    type->roi_label,type->segmented_roi_label);
}


/*------------------------------------------------------------------------
pr_histo_pixel_tissue_type_rec - ???
------------------------------------------------------------------------*/

void
pr_histo_pixel_tissue_type_rec(histo)
 struct histo_params_rec *histo;
{
 long lcv;

 printf("pr_histo_pixel_tissue_type_rec...num_types = %d total_types = %d\n",
           histo->num_types,histo->total_types);
 for (lcv = 0; lcv < histo->num_types; lcv++)
    pr_pixel_tissue_type_rec(&(histo->types[lcv]));
}


/*------------------------------------------------------------------------
init_default_histo_bkgs - ???
------------------------------------------------------------------------*/

int
init_default_histo_bkgs(histo)
 struct histo_params_rec *histo;
{
 int err;
 long lcv,cnt;

 if (histo->bkg.num_bkgs == 0)
    {if (histo->file->hdr.analysis.num_img_labels == 1) cnt = 1;
       else cnt = histo->file->hdr.analysis.num_img_labels * 2;         
     if ((err = get_ptr(&(histo->bkg.bkgs),&(histo->bkg.num_bkgs),
              cnt,(size_t) sizeof(*(histo->bkg.bkgs)))) != NO_ERROR) 
        return err;
     for (lcv = 0; lcv < cnt; lcv++)
        histo->bkg.bkgs[lcv] = HISTO_START;
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
init_histo_bkg_rec - ???
------------------------------------------------------------------------*/

void
init_histo_bkg_rec(bkg)
 struct histo_bkg_rec *bkg;
{
 bkg->num_bkgs = 0;
 bkg->bkgs = NULL;
 init_roi_rec(&(bkg->roi),NULL);
}


/*------------------------------------------------------------------------
free_histo_bkg_rec - ???
------------------------------------------------------------------------*/

void
free_histo_bkg_rec(bkg)
 struct histo_bkg_rec *bkg;
{
 c_free(bkg->bkgs);
 free_roi_rec(&(bkg->roi));
 init_histo_bkg_rec(bkg);
}


/*------------------------------------------------------------------------
init_histo_params_rec - ???
------------------------------------------------------------------------*/

void
init_histo_params_rec(histo,file)
 struct histo_params_rec *histo;
 struct input_file_rec *file;
{
 histo->file = file;
 if (file != NULL)
    histo->status2 = (unsigned short) file_get_def_histo_type(file);
   else histo->status2 = 0;
 histo->prog_status2 = 0;
 TRACE(printf("init_histo_params_rec...begin\n"))

 init_histo_bkg_rec(&(histo->bkg));

 init_slice_roi_win_rec(&(histo->slice_roi_win_2d),0,0);
 init_slice_roi_win_rec(&(histo->slice_roi_win_1d),0,0);
 init_histo_pixel_center_rec(histo);
 init_histo_pixel_tissue_type_rec(histo);

 init_strs_rec(&(histo->pixel_type_order));

 histo->_2d_status = 0;
 init_buf_2d_rec(&(histo->_2d));
 init_buf_2d_rec(&(histo->map));
 init_buf_2d_rec(&(histo->_2d_1d));
 histo->_1d_status = 0;
 init_buf_2d_rec(&(histo->cnt_1d));
 init_buf_2d_rec(&(histo->histo_1d));
 TRACE(printf("init_histo_params_rec...end\n"))

}


/*------------------------------------------------------------------------
free_histo_params_rec - ???
------------------------------------------------------------------------*/

void
free_histo_params_rec(histo)
 struct histo_params_rec *histo;
{
 TRACE(printf("free_histo_params_rec...begin\n"))
 free_histo_bkg_rec(&(histo->bkg));
 free_buf_2d_rec(&(histo->_2d));
 free_buf_2d_rec(&(histo->map));
 free_buf_2d_rec(&(histo->_2d_1d));
 free_buf_2d_rec(&(histo->cnt_1d));
 free_buf_2d_rec(&(histo->histo_1d));

 free_slice_roi_win_rec(&(histo->slice_roi_win_2d));
 free_slice_roi_win_rec(&(histo->slice_roi_win_1d));
 free_histo_pixel_center_rec(histo);
 free_histo_pixel_tissue_type_rec(histo);

 free_strs_rec(&(histo->pixel_type_order));
 TRACE(printf("free_histo_params_rec...end\n"))

 init_histo_params_rec(histo,histo->file);

}



/*------------------------------------------------------------------------
GetHistoBuf - ???
------------------------------------------------------------------------*/

struct buf_2d_rec *
GetHistoBuf(histo,histo_type2)
 struct histo_params_rec *histo;
 unsigned short histo_type2;
{
 if (histo_type2 == HISTO_MULTI_D)
    return &(histo->_2d);
   else return &(histo->_2d_1d);
}


/*------------------------------------------------------------------------
GetHistoSliceRoiWinRec - ???
------------------------------------------------------------------------*/

struct slice_roi_win_rec *
GetHistoSliceRoiWinRec(histo,histo_type2)
 struct histo_params_rec *histo;
 unsigned short histo_type2;
{
 TRACE(printf("GetHistoSliceRoiWinRec status2 = %x histo_type2 = %x\n",
     (unsigned long) histo->status2,(unsigned long) histo_type2);)
 if (histo_type2 & HISTO_MULTI_D)
    return &(histo->slice_roi_win_2d);
   else 
    return &(histo->slice_roi_win_1d);
}


/*------------------------------------------------------------------------
HistoBufReady - ???
------------------------------------------------------------------------*/

int
HistoBufReady(file,histo_type2)
 struct input_file_rec *file;
 unsigned short histo_type2;
{
 int err;
 struct buf_2d_rec *_2d;

 _2d = (struct buf_2d_rec *) GetHistoBuf(&(file->histo_params),histo_type2);
 if ((_2d == NULL) || !(_2d->status4 & BUF_NON_EMPTY))
    {if ((err = setup_histo_params_rec(&(file->histo_params),
              file,histo_type2)) != NO_ERROR)
        return err;
    }
 return NO_ERROR;
}


/*------------------------------------------------------------------------
get_histo_dim - ???
------------------------------------------------------------------------*/

void
get_histo_dim(histo,histo_dimx,histo_dimy,pixel_depth,histo_type2)
 struct histo_params_rec *histo;
 unsigned int *histo_dimx,*histo_dimy,*pixel_depth;
 unsigned short histo_type2;
{

 TRACE(printf("get_histogram_xy_dim begin...\n"))
 *histo_dimx = 256;
 *histo_dimy = 256;

 if (histo->file == NULL) *pixel_depth = 16;
   else
    {if (!(histo_type2 & HISTO_TYPE)) 
        histo_type2 = file_get_def_histo_type(histo->file);
     if (histo_type2 == HISTO_1D)
        *pixel_depth = 32;
       else
        {*pixel_depth = find_num_bits_needed(histo->file->hdr.data_info.dimx *
                     histo->file->hdr.data_info.dimy);
         if (*pixel_depth % 8) *pixel_depth = ((*pixel_depth / 8) + 1) * 8;}
    }
}


/*------------------------------------------------------------------------
setup_histo_params_rec - ???
------------------------------------------------------------------------*/

int
setup_histo_params_rec(histo,file,histo_type2)
 struct histo_params_rec *histo;
 struct input_file_rec *file;
 unsigned short histo_type2;
{
 unsigned int histo_dimx,histo_dimy,pixel_depth;
 int err;
 struct buf_2d_rec *_2d;

 if (histo_type2 == 0) return CANCEL;
 histo->status2 |= histo_type2;
 histo->file = file;

 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,histo_type2);
 if ((histo_dimx > 0) && (histo_dimy > 0) && (pixel_depth > 0))
    {_2d = GetHistoBuf(histo,histo_type2);
     if ((_2d == NULL) ||
         !(_2d->status4 & BUF_NON_EMPTY) ||
         (_2d->dimx != histo_dimx) || (_2d->dimy != histo_dimy) ||
         (_2d->pixel_depth != pixel_depth))
        {
         err = SetupBuf2dRec(_2d,histo_dimx,histo_dimy,pixel_depth,1);
         PRT(printf("setup_histo_params_rec...SetupBuf2dRec\n"))
        }
       else err = NO_ERROR;
    }
   else err = ABORT;

 return err;
}

