/****************************************************************************
histogram.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: histogram.c,v 1.8 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT2(x)
#define PRT(x)
#define PRT1(x)
#define PRT3(x)



/* Functions defined in this file */
int exclude_bkg_1d_histo(struct histo_params_rec *histo);
int exclude_bkg_2d_histo(struct histo_params_rec *histo,
    struct buf_2d_rec *output_2d);
int is_img_histo_ready(struct img_buf_rec *img, unsigned long dimx,
    unsigned long *indx);
int ComputeHisto1d(struct img_buf_rec *img, struct buf_2d_rec *_2d,
    unsigned long dimx);
int Compute1dHistoBuf(struct img_buf_rec *img, struct buf_2d_rec *mask,
    int is_use_cur_img_2d, unsigned long dimx);
int Get1dHistoBuf(struct buf_2d_rec *output_2d, struct img_buf_rec *img,
    struct buf_2d_rec *mask, int is_use_cur_img_2d);
int get_2d_histo_buf(struct buf_2d_rec *output_2d, struct img_buf_rec *img,
    struct buf_2d_rec *mask);
int GetTheHisto(struct buf_2d_rec *_2d, struct img_buf_rec *img,
    int histo_option, int roi_option, struct draw_mask_rec *mask,
    int is_all_slices, struct roi_rec *image_view_roi, int is_use_cur_img_2d);
int GetHisto(struct buf_2d_rec *_2d, struct img_buf_rec *img,
    int histo_option, int roi_option, struct roi_rec *image_view_roi,
    int is_use_cur_img_2d);
int HistoCurSlice(struct buf_2d_rec *_2d, struct win_rec *win,
    int histo_option, int roi_option, struct roi_rec *image_view_roi,
    int is_use_cur_img_2d);
int get_all_1d_histo(struct buf_2d_rec *output_2d,
    struct histo_params_rec *histo);
int HistoAllSlices(struct buf_2d_rec *_2d, struct win_rec *win,
    int histo_option, int roi_option, struct roi_rec *image_view_roi);
int SetupAllSlicesHisto(struct img_buf_rec *img, int is_normalized,
    struct buf_2d_rec *_2d, int rd_select, int histo_option, int histo_kind);



/*--------------------------------------------------------------------------
exclude_bkg_1d_histo - ???
--------------------------------------------------------------------------*/

int
exclude_bkg_1d_histo(histo)
 struct histo_params_rec *histo;
{
 unsigned long lcv,indx,dimx;

 PRT2(printf("exclude_bkg_1d_histo(....num_bkgs = %d\n",histo->bkg.num_bkgs))
 if (!(histo->cnt_1d.status4 & BUF_NON_EMPTY)) return CANCEL;
 if (histo->bkg.num_bkgs == 0) init_default_histo_bkgs(histo);
 PRT2(printf("exclude_bkg_1d_histo(....histo->cnt_1d\n"))
 PRT2(pr_buf_2d_rec(&(histo->cnt_1d)))
 PRT2(printf("exclude_bkg_1d_histo(....1\n"))
 if (histo->bkg.num_bkgs == 0)
    {if (HISTO_START < histo->cnt_1d.dimx) dimx = HISTO_START;
       else dimx = histo->cnt_1d.dimx;
     for (lcv = 0; lcv < dimx; lcv++)
        histo->cnt_1d.SetVal(&(histo->cnt_1d),0,lcv,(double) .0);}
   else
    {PRT2(printf("exclude_bkg_1 histo->file = %u\n",histo->file))
     PRT2(printf("num_echoes = %d\n",histo->file->hdr.data_info.num_echoes))
     indx = histo->file->hdr.data_info.num_echoes - 1;
     if (histo->bkg.bkgs[indx] < histo->cnt_1d.dimx)
        dimx = histo->bkg.bkgs[indx];
       else dimx = histo->cnt_1d.dimx;
     PRT2(printf("exclude_bkg_1d_histo(....dimx = %d\n",dimx))
     for (lcv = 0; lcv < dimx; lcv++)
        histo->cnt_1d.SetVal(&(histo->cnt_1d),0,lcv,(double) .0);
    }
 histo->cnt_1d.status4 &= ~BUF_MIN_MAX_SET;
 histo->cnt_1d.status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
exclude_bkg_2d_histo - ???
--------------------------------------------------------------------------*/

int
exclude_bkg_2d_histo(histo,output_2d)
 struct histo_params_rec *histo;
 struct buf_2d_rec *output_2d;
{
 unsigned long row,col,dim;
 struct roi_rec *roi;
 struct slice_roi_win_rec *slice_roi_win;
 struct int_bound_rec affected;
 struct draw_mask_rec mask;
 int done;

 if (histo->bkg.num_bkgs == 0) init_default_histo_bkgs(histo);
 PRT3(printf("exclude_bkg_2d_histo histo->bkg.num_bkgs = %d\n",
           histo->bkg.num_bkgs))
 if (histo->bkg.num_bkgs == 0)
    {if (HISTO_START < output_2d->dimx) dim = HISTO_START;
       else dim = output_2d->dimx;
     for (row = 0; row < output_2d->dimy; row++)
        for (col = 0; col < dim; col++)
           output_2d->SetVal(output_2d,row,col,(double) .0);
     if (HISTO_START < output_2d->dimy) dim = HISTO_START;
       else dim = output_2d->dimy;
     for (row = 0; row < dim; row++)
        for (col = 0; col < output_2d->dimx; col++)
           output_2d->SetVal(output_2d,row,col,(double) .0);
    }
   else if (histo->bkg.num_bkgs >= 2)
    {done = 0;
     PRT3(printf("exclude_bkg_2d_histo....1\n"))
     if ((slice_roi_win = GetHistoSliceRoiWinRec(histo,HISTO_MULTI_D)) != NULL)
        {
         PRT3(printf("exclude_bkg_2d_histo....2\n"))
         if ((roi = get_roi(&(slice_roi_win->slice_roi),
                       BACKGROUND_PIXEL_TYPE_STR)) != NULL)
            {
             PRT3(printf("exclude_bkg_2d_histo....3\n"))
             init_draw_mask_rec(&mask);
             if (get_draw_mask_rec(&mask,output_2d->dimx,output_2d->dimy)
                       == NO_ERROR)
                {
                 GetFilledRoiMask(roi,NULL,&mask,&affected);
                 PRT3(printf("exclude_bkg_2d_histo....mask = %d\n",
                           CntValBuf2dRec(&(mask.mask._2d),(double) 0)))
                 Set2d(output_2d,0,0,&(mask.mask._2d),&affected,(double) .0);
                 PRT3(MinMax2dValues(output_2d,0,(double) .0,(double) .0,&min,&max);
                  printf("...exclude_bkg_2d_histo output_2d min = %f max = %f\n",min,max))

                 PRT3(if (output_2d->status4 & BUF_MIN_MAX_COMPUTED)
                         printf("exclude_bkg_2d_histo ..BUF_MIN_MAX_COMPUTED min = %f max = %f\n",
                           output_2d->minval,output_2d->maxval);
                      if (output_2d->status4 & BUF_MIN_MAX_SET)
                         printf("exclude_bkg_2d_histo ..BUF_MIN_MAX_SET min = %f max = %f\n",
                           output_2d->minval_set,output_2d->maxval_set);
                     )

                 done = 1;             
                }
             free_draw_mask_rec(&mask);
            }
        }
     PRT3(printf("exclude_bkg_2d_histo....done = %d\n",done))
     if (!done)
        {for (col = 0; col < histo->bkg.bkgs[0]; col++)
            for (row = 0; row < output_2d->dimy; row++)
               output_2d->SetVal(output_2d,row,col,(double) .0);
         PRT3(printf("exclude_bkg_2d_histo....6\n"))

         for (row = 0; row < histo->bkg.bkgs[1]; row++)
            for (col = 0; col < output_2d->dimx; col++)
               output_2d->SetVal(output_2d,row,col,(double) .0);
         PRT3(printf("exclude_bkg_2d_histo....7\n"))
        }
    }
 PRT3(printf("exclude_bkg_2d_histo....6\n"))
 output_2d->status4 &= ~BUF_MIN_MAX_SET;
 output_2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
is_img_histo_ready - ???
--------------------------------------------------------------------------*/

int
is_img_histo_ready(img,dimx,indx)
 struct img_buf_rec *img;
 unsigned long dimx,*indx;
{
 struct buf_2d_rec *histo_1d;
 unsigned long max_cuts,total;
 unsigned long num;

 max_cuts = NumberOfSliceCuts(&(img->file->hdr.data_info));
 total = max_cuts * img->file->hdr.data_info.num_echoes;
 histo_1d = &(img->file->histo_params.histo_1d);
 num = img->cur_slice->scan_num * total +
         img->cur_slice->echo_num * max_cuts +
         img->cur_slice->slice_num + 1;
 PRT2(printf("histo_ready...num = %d max_cuts = %d   total = %d snum =%d enum = %d scnum = %d\n",
       num,max_cuts,total,img->cur_slice->slice_num,
       img->cur_slice->echo_num,img->cur_slice->scan_num))
 if (indx != NULL) *indx = num;

 if (!(histo_1d->status4 & BUF_NON_EMPTY) || (num >= histo_1d->dimy) ||
      (dimx != histo_1d->dimx) || (histo_1d->buf[num] == NULL))
    return 0;

 return 1;
}


/*--------------------------------------------------------------------------
ComputeHisto1d - ???
--------------------------------------------------------------------------*/

int
ComputeHisto1d(img,_2d,dimx)
 struct img_buf_rec *img;
 struct buf_2d_rec *_2d;
 unsigned long dimx;
{
 unsigned long row_bytes,indx,lcv,depth,min,max,val,total,max_cuts;
 unsigned char *ptr;
 int err;
 struct buf_2d_rec *histo_1d;
 struct data_info_rec *info;

 histo_1d = &(img->file->histo_params.histo_1d);
 info = &(img->file->hdr.data_info);
 depth = find_num_bytes_needed(info->dimx * info->dimy) * 8;
 PRT2(printf("ComputeHisto1d...depth = %d   dimx = %d max_scans = %d\n",depth,dimx,info->max_scans))
 PRT2(pr_buf_2d_rec(histo_1d))
 if ((err = SetupNoncontiguosBuf2dRec(histo_1d,dimx,
       (unsigned long) info->max_scans + 1,depth,0)) != NO_ERROR) 
    return err;
 PRT2(pr_buf_2d_rec(histo_1d)) 

 max_cuts = NumberOfSliceCuts(info);
 total = max_cuts * img->file->hdr.data_info.num_echoes;
 indx = img->cur_slice->scan_num * total +
         img->cur_slice->echo_num * max_cuts +
         img->cur_slice->slice_num + 1;

 if (indx >= histo_1d->dimy) 
    {PRT2(printf("ComputeHisto1d indx = %d CANCEL\n",indx))
     return CANCEL;}
 PRT2(printf("ComputeHisto1d...indx = %d\n",indx))
 if ((ptr = histo_1d->buf[indx]) == NULL)
    {row_bytes = GetRowBytes(histo_1d->dimx,histo_1d->pixel_depth);
     if ((err = get_ptr(&ptr,NULL,row_bytes,(size_t) 1)) != NO_ERROR)
        return err;
     set_1d_buf_value(ptr,0,histo_1d->pixel_depth,indx);
     for (lcv = 1; lcv < histo_1d->dimx; lcv++)
        set_1d_buf_value(ptr,lcv,histo_1d->pixel_depth,0);
     histo_1d->buf[indx] = ptr;
    }

 Scale2dPixels(_2d,_2d,(double) .0,(double) (dimx - 1),
          0,(double) .0,(double) .0,0);
 PRT2(printf("ComputeHisto1d...ptr = %u  _2d = %d\n",ptr,
         CntNonValBuf2dRec(_2d,(double) 0)))

 Count1dOccurrences(histo_1d,indx,_2d,NULL,0,&total,1);
 min = max = get_1d_buf_value(ptr,1,histo_1d->pixel_depth);
 for (lcv = 2; lcv < histo_1d->dimx; lcv++)
    {val = get_1d_buf_value(ptr,lcv,histo_1d->pixel_depth);
     if (min > val) min = val;
     if (max < val) max = val;}
 PRT2(printf("ComputeHisto1d...min = %d  max = %d total = %d\n",min,max,total))
 if (!(histo_1d->status4 & BUF_MIN_MAX_COMPUTED))
    {histo_1d->status4 |= BUF_MIN_MAX_COMPUTED;
     histo_1d->minval = (double) min;
     histo_1d->maxval = (double) max;}
   else 
    {if (histo_1d->minval > (double) min) 
        histo_1d->minval = (double) min;
     if (histo_1d->maxval < (double) max) 
        histo_1d->maxval = (double) max;}

 histo_1d->status4 |= BUF_MIN_MAX_SET;
 histo_1d->minval_set = histo_1d->minval;
 histo_1d->maxval_set = histo_1d->maxval;

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
Compute1dHistoBuf - ???
--------------------------------------------------------------------------*/

int
Compute1dHistoBuf(img,mask,is_use_cur_img_2d,dimx)
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
 int is_use_cur_img_2d;
 unsigned long dimx;
{
 unsigned long lcv,*result,min,max;
 unsigned long minlcv,maxlcv;
 int err;
 struct buf_2d_rec *cnt_1d,*_2d,the_2d;

 PRT(printf("Compute1dHistoBuf...dimx = %d\n",dimx))
 if (dimx <= 1) return CANCEL;
 if (is_use_cur_img_2d) _2d = &(img->_2d);
   else
    {init_buf_2d_rec(&the_2d);
     if ((err = SetupBuf2dRec(&the_2d,img->_2d.dimx,img->_2d.dimy,
           img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
        return err;
     if (((err = RdSlice(img,1,&the_2d,0)) != NO_ERROR) ||
         !(the_2d.status4 & BUF_DATA_VALID))
        {free_buf_2d_rec(&the_2d);
         return CANCEL;}
     _2d = &the_2d;
    }

 cnt_1d = &(img->file->histo_params.cnt_1d);
 TRACE(pr_buf_2d_rec(cnt_1d))
 if ((err = SetupBuf2dRec(cnt_1d,dimx,1,32,1)) != NO_ERROR)
    {if (!is_use_cur_img_2d) free_buf_2d_rec(&the_2d);
     return err;}
 TRACE(pr_buf_2d_rec(cnt_1d)) 
 
 Scale2dPixels(_2d,_2d,(double) .0,(double) (dimx - 1),
          0,(double) .0,(double) .0,0);

 Count1dOccurrences(cnt_1d,0,_2d,mask,0,NULL,0);
 result = (unsigned long *) cnt_1d->buf[0];
 min = max = result[1];
 for (lcv = 2; lcv < cnt_1d->dimx; lcv++)
    {
     if (min > result[lcv])
        {minlcv = lcv;min = result[lcv];}
       else if (max < result[lcv]) {maxlcv = lcv;max = result[lcv];}
    }
 PRT2(for (total = 0,lcv = 1; lcv < cnt_1d->dimx; lcv++)
         total += result[lcv];
      printf("total = %d  [0] = %d min = %d minlcv = %d max = %d maxlcv = %d\n",
             total,result[0],min,minlcv,max,maxlcv))

 if (!(cnt_1d->status4 & BUF_MIN_MAX_COMPUTED))
    {cnt_1d->status4 |= BUF_MIN_MAX_COMPUTED;
     cnt_1d->minval = (double) min;
     cnt_1d->maxval = (double) max;}
   else 
    {if (cnt_1d->minval > (double) min) 
        cnt_1d->minval = (double) min;
     if (cnt_1d->maxval < (double) max) 
        cnt_1d->maxval = (double) max;}

 cnt_1d->status4 |= BUF_MIN_MAX_SET;
 cnt_1d->minval_set = cnt_1d->minval;
 cnt_1d->maxval_set = cnt_1d->maxval;
 if (!is_use_cur_img_2d) free_buf_2d_rec(&the_2d);
 return NO_ERROR;
}

/*****************
 cnt_1d = &(img->file->histo_params.cnt_1d);
 indx = img->cur_slice->slice_num + 1;
 if (!(cnt_1d->status4 & BUF_NON_EMPTY) || (indx >= cnt_1d->dimy) ||
      (output_2d->dimx != cnt_1d->dimx) ||
     ((result = (unsigned long *) cnt_1d->buf[indx]) == NULL) ||
     (result[0] == 0))
 struct buf_2d_rec *cnt_1d,_2d;
 unsigned long lcv,*result,indx;
      else if ((result = (unsigned long *) cnt_1d->buf[indx]) == NULL)
       return CANCEL;
 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,cnt_1d->dimx,1,cnt_1d->pixel_depth,0)) 
       != NO_ERROR)
    return err;
 _2d.SetVal(&_2d,0,0,(double) .0);
 for (lcv = 1; lcv < _2d.dimx; lcv++)
    _2d.SetVal(&_2d,0,lcv,(double) result[lcv]);
*****************/



/*--------------------------------------------------------------------------
Get1dHistoBuf - ???
--------------------------------------------------------------------------*/

int
Get1dHistoBuf(output_2d,img,mask,is_use_cur_img_2d)
 struct buf_2d_rec *output_2d,*mask;
 struct img_buf_rec *img;
 int is_use_cur_img_2d;
{
 int err;
 struct buf_2d_rec *cnt_1d;

 if (!(output_2d->status4 & BUF_NON_EMPTY)) return CANCEL;
 TRACE(printf("Get1dHistoBuf...dimx = %d dimy = %d depth = %d\n",
        output_2d->dimx,output_2d->dimy,output_2d->pixel_depth))

 if ((err = Compute1dHistoBuf(img,mask,is_use_cur_img_2d,output_2d->dimx))
             != NO_ERROR)
    return err;
 exclude_bkg_1d_histo(&(img->file->histo_params));
 cnt_1d = &(img->file->histo_params.cnt_1d);
 InitBuf2dRecData(output_2d,(double) .0);
 Histogram2d(output_2d,cnt_1d,0,1,1,(double) 255,0);
 output_2d->status4 &= BUF_FLUSH_DATA_STATUS;
 output_2d->minval = output_2d->minval_set = .0;
 output_2d->maxval = output_2d->maxval_set = 255.0;
 output_2d->status4 |= BUF_MIN_MAX_SET | BUF_MIN_MAX_COMPUTED;
 output_2d->status4 |= BUF_DATA_VALID;
 PRT1(printf("Get1dHistoBuf cnt _2d = %d\n",
        CntValBuf2dRec(output_2d,(double) 0)))

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_2d_histo_buf - ???
--------------------------------------------------------------------------*/

int
get_2d_histo_buf(output_2d,img,mask)
 struct buf_2d_rec *output_2d,*mask;
 struct img_buf_rec *img;
{
 struct img_buf_rec *temp_img;
 unsigned long num_slices;
 int err;

 PRT3(printf("get_2d_histo_buf...\n"))
 PRT3(printf("...output_2d...\n"))
 PRT3(pr_buf_2d_rec(output_2d))
 if (!(output_2d->status4 & BUF_NON_EMPTY)) return ABORT;
 if (img->file->hdr.data_info.num_echoes != 2) return CANCEL;
 num_slices = cnt_img_buf_rec_partners(img);
 if (num_slices != 2) return CANCEL;

 temp_img = pick_first_img_buf_rec_partner(img);
 PRT3(printf("   slice# %d %d  %s   status = %x\n",
                    temp_img->cur_slice->slice_num,
                    temp_img->cur_slice->num,temp_img->cur_slice->img_label,
                    (unsigned long) temp_img->_2d.status4))
 PRT3(printf("   slice# %d %d  %s   status = %x\n",
           temp_img->partner->cur_slice->slice_num,
           temp_img->partner->cur_slice->num,
           temp_img->partner->cur_slice->img_label,
                    (unsigned long) temp_img->partner->_2d.status4))

 if (((err = RdCurSliceEchoes(temp_img,0,0)) != NO_ERROR) ||
     ((err = Scale2dPixels(&(temp_img->_2d),&(temp_img->_2d),
              (double) .0,(double) (output_2d->dimx - 1),
              0,(double) .0,(double) .0,1)) != NO_ERROR) ||
     ((err = Scale2dPixels(&(temp_img->partner->_2d),&(temp_img->partner->_2d),
              (double) .0,(double) (output_2d->dimy - 1),
              0,(double) .0,(double) .0,1)) != NO_ERROR))
    return err;
 PRT3(printf("...get_2d_histo_buf...Count2dOccurrences\n"))
 Count2dOccurrences(output_2d,&(temp_img->_2d),&(temp_img->partner->_2d),mask,0,
                    NULL,0);
 PRT3(MinMax2dValues(output_2d,0,(double) .0,(double) .0,&min,&max);
      printf("...get_2d_histo_buf output_2d min = %f max = %f\n",min,max))

 output_2d->status4 &= ~BUF_MIN_MAX_COMPUTED;
 output_2d->status4 &= ~BUF_MIN_MAX_SET;

 output_2d->status4 &= BUF_FLUSH_DATA_STATUS;
 output_2d->status4 |= BUF_DATA_VALID;
 PRT2(printf("...get_2d_histo_buf...end\n"))

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
GetTheHisto - ???
--------------------------------------------------------------------------*/

/* histo_option
 #define HISTO_1D 1
 #define HISTO_MULTI_D 2
*/
/* roi_option */

int
GetTheHisto(_2d,img,histo_option,roi_option,mask,is_all_slices,image_view_roi,
            is_use_cur_img_2d)
 struct buf_2d_rec *_2d;
 struct img_buf_rec *img;
 int histo_option,roi_option;
 struct draw_mask_rec *mask;
 int is_all_slices;
 struct roi_rec *image_view_roi;
 int is_use_cur_img_2d;
{
 struct int_bound_rec affected;
 int err;
 struct buf_2d_rec *the_mask_2d;

 PRT3(printf("GetTheHisto...img->cur_slice->slice = %u\n",img->cur_slice->slice))
 err = NO_ERROR;
 if (roi_option == WHOLE_SLICE)
    {PRT3(printf("WHOLE_SLICE..."))
     the_mask_2d = NULL;
    }
  else if ((img->cur_slice->slice != NULL) &&
           (img->cur_slice->slice->slice_roi_win != NULL))
   {if ((err = GetRoiMask(&(img->cur_slice->slice->slice_roi_win->slice_roi),
            NULL,img->_2d.dimx,img->_2d.dimy,mask,
            &affected,roi_option,image_view_roi)) != NO_ERROR)
       return err;
     the_mask_2d = &(mask->mask._2d);
    }
  else
   {TRACE(printf("GetTheHisto...CANCEL\n"))
    return CANCEL;}
 TRACE(printf("GetTheHisto...4\n"))
 if (err == NO_ERROR)
    if (histo_option == HISTO_1D)
       {
        if (is_all_slices) err = Compute1dHistoBuf(img,the_mask_2d,0,_2d->dimx);
          else err = Get1dHistoBuf(_2d,img,the_mask_2d,is_use_cur_img_2d);
       }
      else
       err = get_2d_histo_buf(_2d,img,the_mask_2d);

 TRACE(printf("GetTheHisto...end...err = %d\n",err))
 return err;

}


/*--------------------------------------------------------------------------
GetHisto - ???
--------------------------------------------------------------------------*/

int
GetHisto(_2d,img,histo_option,roi_option,image_view_roi,is_use_cur_img_2d)
 struct buf_2d_rec *_2d;
 struct img_buf_rec *img;
 int histo_option,roi_option;
 struct roi_rec *image_view_roi;
 int is_use_cur_img_2d;
{
 int err;
 struct draw_mask_rec mask;

 PRT(printf("GetHisto..."))
 init_draw_mask_rec(&mask);
 if ((err = get_draw_mask_rec(&mask,(unsigned long) img->_2d.dimx,
        (unsigned long) img->_2d.dimy)) != NO_ERROR)
    {PRT(printf("GetHisto...err = %d\n",err))
     return err;}
 PRT(printf("GetHisto...1"))
 err = GetTheHisto(_2d,img,histo_option,roi_option,&mask,0,image_view_roi,
                   is_use_cur_img_2d);
 free_draw_mask_rec(&mask);

 PRT(printf("GetHisto...out...err = %d",err))
 return err;

}


/*--------------------------------------------------------------------------
HistoCurSlice - ???
--------------------------------------------------------------------------*/

int
HistoCurSlice(_2d,win,histo_option,roi_option,image_view_roi,
              is_use_cur_img_2d)
 struct buf_2d_rec *_2d;
 struct win_rec *win;
 int histo_option,roi_option;
 struct roi_rec *image_view_roi;
 int is_use_cur_img_2d;
{
 int err;
 struct img_buf_rec *cur_img;

 TRACE(printf("histo_cur_slice...in\n"))
 if ((cur_img = win_rec_cur_img_buf(win)) == NULL) return CANCEL;

 if ((err = GetHisto(_2d,cur_img,histo_option,roi_option,
           image_view_roi,is_use_cur_img_2d)) == NO_ERROR)
    {if (histo_option != HISTO_1D)
        exclude_bkg_2d_histo(&(cur_img->file->histo_params),_2d);}

 PRT(printf("histo_cur_slice...err = %d end\n",err))

 return err;
}

/***************
cnt_1d_histo(img,mask,dimx)
 struct img_buf_rec *img;
 struct buf_2d_rec *mask;
{
 unsigned long total_pixels;
 int err;
 struct buf_2d_rec *ptr_pixel_cnt;
 struct buf_2d_rec *buf,the_2d;
 unsigned long dimx;

 init_buf_2d_rec(&the_2d);
 if ((err = SetupBuf2dRec(&the_2d,img->_2d.dimx,img->_2d.dimy,
      img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    return err;
 if (((err = RdSlice(img,1,&the_2d,0)) != NO_ERROR) ||
     !(the_2d.status4 & BUF_DATA_VALID))
    {free_buf_2d_rec(&the_2d);
     return CANCEL;}
 buf = &the_2d;
 TRACE(printf("	cnt_1d_histo...dimx = %d dimy = %d depth = %d\n",
        buf->dimx,buf->dimy,buf->pixel_depth))

 if (img->file->hdr.data_info.pixel_depth_bits <= 8) dimx = 256;
   else if (img->file->hdr.data_info.pixel_depth_bits <= 16) dimx = 65536;
   else dimx = (long) buf->maxval_set;

 if ((err = SetupBuf2dRec(&(img->file->histo_params.cnt_1d),dimx,
                      (unsigned long) 1,32,1)) != NO_ERROR)
    {free_buf_2d_rec(&the_2d);
     return err;}

 ptr_pixel_cnt = &(img->file->histo_params.cnt_1d);
 total_pixels = 0;
 RegionalCntOccurrences(&buf,1,&ptr_pixel_cnt,1,
               0,buf->minval_set,buf->maxval_set,
               &total_pixels,mask);
 free_buf_2d_rec(&the_2d);

 return NO_ERROR;
}
**************/


/*--------------------------------------------------------------------------
get_all_1d_histo - ???
--------------------------------------------------------------------------*/

int
get_all_1d_histo(output_2d,histo)
 struct buf_2d_rec *output_2d;
 struct histo_params_rec *histo;
{
 struct buf_2d_rec *cnt_1d;

 exclude_bkg_1d_histo(histo);
 cnt_1d = &(histo->cnt_1d); 
 Scale2dPixels(cnt_1d,cnt_1d,(double) .0,(double) (output_2d->dimy - 1),
         0,(double) .0,(double) .0,0);

 InitBuf2dRecData(output_2d,(double) .0);
 Histogram2d(output_2d,cnt_1d,0,1,1,(double) (output_2d->dimy - 1),0);
 output_2d->status4 &= BUF_FLUSH_DATA_STATUS;
 output_2d->status4 |= BUF_DATA_VALID;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
HistoAllSlices - ???
--------------------------------------------------------------------------*/

int
HistoAllSlices(_2d,win,histo_option,roi_option,image_view_roi)
 struct buf_2d_rec *_2d;
 struct win_rec *win;
 int histo_option,roi_option;
 struct roi_rec *image_view_roi;
{
 struct hdr_scan_entry_rec *cur_slice;
 int err,is_all_echoes;
 struct img_rec the_img;
 struct img_buf_rec *img,*cur_img;
 struct draw_mask_rec mask;
 struct buf_2d_rec _2d1;

 if ((cur_img = win_rec_cur_img_buf(win)) == NULL) return CANCEL;

 init_img_rec(&the_img,cur_img->file);
 if (histo_option == HISTO_MULTI_D) is_all_echoes = 1;
   else is_all_echoes = 0;
 PRT3(printf("HistoAllSlices histo_option = %d HISTO_MULTI_D = %d is_all_echoes = %d\n",
     histo_option,HISTO_MULTI_D,is_all_echoes))
 if (NewImgBuf(&the_img,cur_img->cur_slice,&err,0,0,0,0,0,0,is_all_echoes) == NULL)
    return err;

 img = the_img.data[0];
 init_draw_mask_rec(&mask);
 if ((err = get_draw_mask_rec(&mask,(unsigned long) img->_2d.dimx,
        (unsigned long) img->_2d.dimy)) != NO_ERROR)
    {free_img_rec(&the_img);
     return err;}

 cur_slice = img->cur_slice;
 if (histo_option == HISTO_MULTI_D)
    {init_buf_2d_rec(&_2d1);
     if ((err = SetupBuf2dRec(&_2d1,_2d->dimx,_2d->dimy,32,0)) != NO_ERROR)
        {free_draw_mask_rec(&mask);
         free_img_rec(&the_img);
         return err;}

     Assign2d(_2d,&_2d1);
     free_buf_2d_rec(_2d);
     *_2d = _2d1;
     PRT3(printf("....1...\n"))
    }
 do
    {
     if (img->cur_slice != NULL)
        {PRT3(printf("\n==>slice# %d %d  %s  status = %x\n",
                    img->cur_slice->slice_num,
                    img->cur_slice->num,img->cur_slice->img_label,
                    (unsigned long) img->_2d.status4))
         err = GetTheHisto(_2d,img,histo_option,roi_option,&mask,1,
                      image_view_roi,0);
         if (err == NO_ERROR)
            {get_all_next_slice_echoes(img,img->cur_slice->next_slice);
            }
           else break;
        }
       else
        {err = CANCEL;
         break;}
    }
 while (img->cur_slice != cur_slice);
 PRT3(printf("HistoAllSlices err = %d\n",err))
 if (histo_option == HISTO_1D)
    get_all_1d_histo(_2d,&(cur_img->file->histo_params));
   else if (err == NO_ERROR)
    exclude_bkg_2d_histo(&(img->file->histo_params),_2d);
 free_draw_mask_rec(&mask);
 free_img_rec(&the_img);

 return err;
}


/*--------------------------------------------------------------------------
SetupAllSlicesHisto - ???

if histo_option == 0 then is 1D histo else 2D histo
if (histo_kind == 1) then show the histogram for each slice on different line
--------------------------------------------------------------------------*/

int
SetupAllSlicesHisto(img,is_normalized,_2d,rd_select,histo_option,histo_kind)
 struct img_buf_rec *img;
 int is_normalized;
 struct buf_2d_rec *_2d;
 int rd_select,histo_option,histo_kind;
{
 struct hdr_scan_entry_rec *cur_slice;
 struct buf_2d_rec *buf;
 unsigned long status4;
 int err;

 PRT2(printf("SetupAllSlicesHisto..._2d = %u status4 = %x histo_option = %d kind = %d\n",
        _2d,img->status4,histo_option,histo_kind))
 cur_slice = img->cur_slice;
 status4 = img->status4;
 img->status4 &= ~IMG_HISTO_INITIALIZE_BUF;
 if (histo_option == 0)
    {if (histo_kind == 0) img->status4 |= IMG_HISTO_1D_DISABLE_AUTO_SET;
     img->status4 |= IMG_HISTO_1D_DO_NOT_SETUP_HISTOGRAM;}
 err = NO_ERROR;
 if (_2d != NULL) buf = _2d;
   else buf = &(img->_2d);
 InitBuf2dRecData(buf,(double) .0);

 do
    {
     if ((histo_option == 0) && is_img_histo_ready(img,buf->dimx,NULL))
        {PRT2(printf("SetupAllSlicesHisto is_img_histo_ready...\n"))
         if ((err = Setup1dhistoByOptions(buf,img)) != NO_ERROR)
            break;
        }
       else if ((err = RdSlice(img,is_normalized,_2d,rd_select)) != NO_ERROR)
        {err = CANCEL;
         break;}
     PRT2(printf("==>slice# %d %d  %s  status = %x\n",
                    img->cur_slice->slice_num,
                    img->cur_slice->num,img->cur_slice->img_label,
                    (unsigned long) img->_2d.status4))
     img->cur_slice = img->cur_slice->next_slice;
    }
 while (img->cur_slice != cur_slice);
 if ((histo_option == 0) && (histo_kind == 0))
    {PRT2(printf("SetupAllSlicesHisto...Histogram2d\n"))
     Histogram2d(&(img->_2d),&(img->_2d),0,1,1,(double) 255.0,1);}
 img->cur_slice = cur_slice;
 img->status4 = status4; 
 PRT2(printf("SetupAllSlicesHisto...status4 = %x end\n",img->status4))
 return err;
}
