/****************************************************************************
img_buf_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: img_buf_opr.c,v 1.8 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <X11/Xlib.h>
#include <X11/Xutil.h>         /* For XDestroyImage */

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT3(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT3(x)



/* Functions defined in this file */
void init_sel_buf_2d_rec(struct sel_buf_2d_rec *buf);
void free_sel_buf_2d_rec(struct sel_buf_2d_rec *buf);
void init_img_buf_rec(struct img_buf_rec *cur_img);
void free_img_buf_rec(struct img_buf_rec *img);
int add_img_dst_wids(struct img_buf_rec *img, char *wid);
int drop_img_dst_wids(struct img_buf_rec *img, char *wid);
void free_img_rec(struct img_rec *img);
void init_img_rec(struct img_rec *img, struct input_file_rec *file);
int copy_img_buf_rec(struct img_buf_rec *dest, struct img_buf_rec *source);
int SetupImgBufRecWithWinRec(struct img_buf_rec *img,
    struct input_file_rec *file, struct hdr_scan_entry_rec *last_slice,
    struct hdr_scan_entry_rec *cur_slice, struct img_buf_rec *partner,
    int use_this_buf_dims, unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth_bits, unsigned long data_type);
int SetupImgBufRec(struct img_buf_rec *img, struct input_file_rec *file,
    struct hdr_scan_entry_rec *last_slice,
    struct hdr_scan_entry_rec *cur_slice, struct win_rec *win,
    struct img_buf_rec *partner, int use_this_buf_dims, unsigned long dimx,
    unsigned long dimy, unsigned long pixel_depth_bits,
    unsigned long data_type);
unsigned int find_img_buf_rec(struct img_buf_rec *data, unsigned int num_data,
    struct input_file_rec *file, struct hdr_scan_entry_rec *cur_slice,
    int *found);
int get_img_buf(struct img_buf_rec **cur_img);
struct img_buf_rec *NewImgBuf(struct img_rec *img,
    struct hdr_scan_entry_rec *cur_slice, int *err, int get_win_rec,
    int use_this_buf_dims, unsigned long dimx, unsigned long dimy,
    unsigned long pixel_depth_bits, unsigned long data_type,
    int is_all_echoes);
int is_all_img_partner_wins_closed(struct img_buf_rec *img);
int delete_img_and_partner_bufs(struct img_buf_rec *img);
int delete_img_partner_link(struct img_buf_rec *img);
int delete_img_if_not_use(struct img_buf_rec *img);
int delete_img(struct img_buf_rec *img);
struct img_buf_rec *find_existing_img_buf_rec(struct img_rec *img,
    struct hdr_scan_entry_rec *cur_slice);
int AllActivationEchoesExist(struct img_buf_rec *img);
int all_img_echoes_exist(struct img_buf_rec *img);
void pr_img_rec(struct img_rec *img);



/*--------------------------------------------------------------------------
init_sel_buf_2d_rec - ???
--------------------------------------------------------------------------*/

void
init_sel_buf_2d_rec(buf)
 struct sel_buf_2d_rec *buf;
{
 buf->status = 0;
 setup_int_bound_rec(&(buf->src_bound),0,0,0,0); 
 setup_int_bound_rec(&(buf->dst_bound),0,0,0,0);
 buf->im = NULL; 
 initial_unit_2d_rec(&(buf->src_trans_unit));
 init_pixel_desc_rec(&(buf->pixel),0,0);
 init_buf_2d_rec(&(buf->bitmask));
 init_buf_2d_rec(&(buf->screen_2d));
 init_buf_2d_rec(&(buf->_2d));
 init_buf_2d_rec(&(buf->srcindst_2d));
 init_color_screen_rec(&(buf->src));
 init_color_screen_rec(&(buf->trans_src));
}


/*--------------------------------------------------------------------------
free_sel_buf_2d_rec - ???
--------------------------------------------------------------------------*/

void
free_sel_buf_2d_rec(buf)
 struct sel_buf_2d_rec *buf;
{
 TRACE(printf("buf = %u sizeof(buf->_2d) = %d   size = %d\n",buf,sizeof(buf->_2d),
        sizeof(struct sel_buf_2d_rec)))
 TRACE(pr_buf_2d_rec(&(buf->_2d)))
 buf->status = 0;
 if (buf->im != NULL)
    {buf->im->data = NULL;
     XDestroyImage(buf->im);
     buf->im = NULL;}
 initial_unit_2d_rec(&(buf->src_trans_unit));
 free_pixel_desc_rec(&(buf->pixel));
 free_buf_2d_rec(&(buf->bitmask));
 free_buf_2d_rec(&(buf->screen_2d));
 free_buf_2d_rec(&(buf->_2d));
 free_buf_2d_rec(&(buf->srcindst_2d));
 free_color_screen_rec(&(buf->src));
 free_color_screen_rec(&(buf->trans_src));
}


/*--------------------------------------------------------------------------
init_img_buf_rec - ???
--------------------------------------------------------------------------*/

void
init_img_buf_rec(cur_img)
 struct img_buf_rec *cur_img;
{
 cur_img->status4 = 0;
 cur_img->file = NULL;
 cur_img->previous_slice = cur_img->last_slice = NULL;
 cur_img->cur_slice = NULL;
 cur_img->win = NULL;
 cur_img->partner = NULL;
 cur_img->src_wid = NULL;
 cur_img->total_dst_wids = cur_img->num_dst_wids = 0;
 cur_img->dst_wids = NULL;
 initial_unit_2d_rec(&(cur_img->last_unit));
 initial_unit_2d_rec(&(cur_img->unit));
 init_buf_2d_rec(&(cur_img->_2d));
 init_buf_2d_rec(&(cur_img->move_2d));
 init_sel_buf_2d_rec(&(cur_img->_2d_fusion));
 init_sel_buf_2d_rec(&(cur_img->_3d_fusion));
}



/*--------------------------------------------------------------------------
free_img_buf_rec - ???
--------------------------------------------------------------------------*/

void
free_img_buf_rec(img)
     struct img_buf_rec *img;
{
  int lcv;

  if (img == NULL)
    return;
  PRT1(printf("free_img_buf_rec...mg->win = %u\n",img->win));

  if (img->win != NULL)
  {
    PRT1(printf("free_img_buf_rec...delete_win_rec\n"));
    delete_win_rec(img->win,MANY_SLICES_WINDOWS,0);
  }
  initial_unit_2d_rec(&(img->last_unit));
  initial_unit_2d_rec(&(img->unit));
  free_buf_2d_rec(&(img->_2d));
  free_buf_2d_rec(&(img->move_2d));
  TRACE(printf("free_img_buf_rec...1\n"));

  c_free(img->src_wid);
  if (img->total_dst_wids > 0)
  {
    for (lcv = 0; lcv < img->num_dst_wids; lcv++)
      c_free(img->dst_wids[lcv]);
    c_free(img->dst_wids);
  }

  free_sel_buf_2d_rec(&(img->_2d_fusion));
  TRACE(printf("free_img_buf_rec2\n"));
  free_sel_buf_2d_rec(&(img->_3d_fusion));
  if ((img->cur_slice->slice != NULL) && (img->cur_slice->slice->view != NULL))
  {
    TRACE(printf("free_img_buf_rec...\n"));
    /* DRW 19970821 */
    printf("view=%p\n",(void *)img->cur_slice->slice->view);
    fflush(stdout);
    delete_view_rec(img->file,img->cur_slice->slice->view);
  }
  PRT1(printf("free_img_buf_rec...end\n"));
  init_img_buf_rec(img);

}



/*--------------------------------------------------------------------------
add_img_dst_wids - ???
--------------------------------------------------------------------------*/

int
add_img_dst_wids(img,wid)
 struct img_buf_rec *img;
 char *wid;
{
 long posi,lcv;
 int err;
 char *str;

 PRT(printf("add_img_dst_wids...wid = %s total_dst_wids = %d num_dst_wids = %d\n",wid,img->total_dst_wids,img->num_dst_wids))
 if (obj_binary_search(img->dst_wids,img->num_dst_wids,
      (size_t) sizeof(*(img->dst_wids)),&wid,sort_str_proc,&posi) == NO_ERROR)
    {PRT(printf("add_img_dst_wids found...\n"));
     return NO_ERROR;}
 if (img->num_dst_wids == img->total_dst_wids)
    if ((err = get_ptr(&(img->dst_wids),&(img->total_dst_wids),2,
          (size_t) sizeof(*(img->dst_wids)))) != NO_ERROR)
       return err;
 if ((err = cp_str(&str,wid)) != NO_ERROR) return err;
 for (lcv = img->num_dst_wids; lcv > posi; lcv--)
    img->dst_wids[lcv] = img->dst_wids[lcv - 1];
 PRT(printf("add_img_dst_wids posi = %d...\n",posi));
 img->dst_wids[posi] = str;
 img->num_dst_wids += 1;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
drop_img_dst_wids - ???
--------------------------------------------------------------------------*/

int
drop_img_dst_wids(img,wid)
 struct img_buf_rec *img;
 char *wid;
{
 long posi,lcv;

 if (obj_binary_search(img->dst_wids,img->num_dst_wids,
      (size_t) sizeof(*(img->dst_wids)),&wid,sort_str_proc,&posi) == NO_ERROR)
    {PRT(printf("drop_img_dst_wids posi = %d wid = %s...\n",posi,
            img->dst_wids[posi]));
     c_free(img->dst_wids[posi]);
     for (lcv = posi + 1; lcv < img->num_dst_wids; lcv++)
        img->dst_wids[lcv - 1] = img->dst_wids[lcv];
     img->dst_wids[lcv - 1] = NULL;
     img->num_dst_wids -= 1;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
free_img_rec - ???
--------------------------------------------------------------------------*/

void
free_img_rec(img)
     struct img_rec *img;
{
  struct img_buf_rec *cur_img;
  unsigned long lcv;

  PRT1(printf("free_img_rec img->num_data = %d img->data = %u\n",
	      img->num_data,img->data));
  for (lcv = 0; lcv < img->num_data; lcv++) 
  {
    PRT1(printf("%d) img = %u\n",lcv,img->data[lcv]));
    cur_img = img->data[lcv];
    delete_img_partner_link(cur_img);
    free_img_buf_rec(cur_img);
    c_free(cur_img);
  }

  c_free(img->data);
  init_img_rec(img,NULL);
}


/*--------------------------------------------------------------------------
init_img_rec - ???
--------------------------------------------------------------------------*/

void
init_img_rec(img,file)
 struct img_rec *img;
 struct input_file_rec *file;
{
 img->file = file;
 img->data = NULL;
 img->num_data = 0;
}


/*--------------------------------------------------------------------------
copy_img_buf_rec - ???
--------------------------------------------------------------------------*/

int
copy_img_buf_rec(dest,source)
 struct img_buf_rec *dest,*source;
{
 int err;

 if ((dest == NULL) || (source == NULL)) return CANCEL;
 dest->file = source->file;
 dest->last_slice = source->last_slice;
 dest->cur_slice = source->cur_slice;
 dest->win = source->win;
 init_buf_2d_rec(&(dest->_2d));
 if ((err = copy_buf_2d_rec(&(dest->_2d),&(source->_2d))) != NO_ERROR)
    return err;
 return err;
}


/*--------------------------------------------------------------------------
SetupImgBufRecWithWinRec - ???
--------------------------------------------------------------------------*/

int
SetupImgBufRecWithWinRec(img,file,last_slice,cur_slice,partner,
                         use_this_buf_dims,dimx,dimy,pixel_depth_bits,data_type)
 struct img_buf_rec *img;
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *last_slice;
 struct hdr_scan_entry_rec *cur_slice;
 struct img_buf_rec *partner;
 int use_this_buf_dims;
 unsigned long dimx,dimy,pixel_depth_bits,data_type;
{
 int err;
 unsigned long dimx1,dimy1,pixel_depth,data_type1;

 img->file = file;
 img->last_slice = last_slice;
 img->cur_slice = cur_slice;
 img->previous_slice = cur_slice;
 img->win = get_new_img_win(img,&err);
 if (err != NO_ERROR)
   return err;
 img->partner = partner;
 init_buf_2d_rec(&(img->_2d));
 if (!use_this_buf_dims)
    {pixel_depth = file->hdr.data_info.pixel_depth_bits;
     dimx1 = file->hdr.data_info.dimx;
     dimy1 = file->hdr.data_info.dimy;
     data_type1 = InputDataTypeToBufType(&(file->hdr.data_info));
     PRT2(printf("SetupImgBufRecWithWinRec 1 data_type1 = %x  %x\n",
               data_type1,file->hdr.data_info.var_use_status))
    }
   else
    {pixel_depth = pixel_depth_bits;
     dimx1 = dimx;
     dimy1 = dimy;
     data_type1 = data_type;
     PRT2(printf("SetupImgBufRecWithWinRec 2 data_type1 = %x  %x\n",
               data_type1,file->hdr.data_info.var_use_status))
    }
 if ((err = SetupBuf2dRec(&(img->_2d),dimx1,dimy1,pixel_depth,
                data_type1)) != NO_ERROR)
    return err;

 TRACE(printf("SetupImgBufRecWithWinRec dimx = %d dimy = %d pixel_depth = %d data_type = %x err = %d\n", dimx1,dimy1,pixel_depth,data_type1,err))
 return err;
}


/*--------------------------------------------------------------------------
SetupImgBufRec - ???
--------------------------------------------------------------------------*/

int
SetupImgBufRec(img,file,last_slice,cur_slice,win,partner,
               use_this_buf_dims,dimx,dimy,pixel_depth_bits,data_type)
 struct img_buf_rec *img;
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *last_slice;
 struct hdr_scan_entry_rec *cur_slice;
 struct win_rec *win;
 struct img_buf_rec *partner;
 int use_this_buf_dims;
 unsigned long dimx,dimy,pixel_depth_bits,data_type;
{
 int err;
 unsigned long dimx1,dimy1,pixel_depth,data_type1;

 img->file = file;
 img->last_slice = last_slice;
 img->cur_slice = cur_slice;
 img->win = win;
 img->partner = partner;
 init_buf_2d_rec(&(img->_2d));
 if (!use_this_buf_dims)
    {pixel_depth = file->hdr.data_info.pixel_depth_bits;
     dimx1 = file->hdr.data_info.dimx;
     dimy1 = file->hdr.data_info.dimy;
     data_type1 = InputDataTypeToBufType(&(file->hdr.data_info));
     PRT2(printf("SetupImgBufRec 1 data_type1 = %x  %x\n",
               data_type1,file->hdr.data_info.var_use_status))
    }
   else
    {pixel_depth = pixel_depth_bits;
     dimx1 = dimx;
     dimy1 = dimy;
     data_type1 = data_type;
     PRT2(printf("SetupImgBufRec 2 data_type1 = %x  %x\n",
               data_type1,file->hdr.data_info.var_use_status))
    }
 if ((err = SetupBuf2dRec(&(img->_2d),dimx1,dimy1,
              pixel_depth,data_type1)) != NO_ERROR)
    return err;
 TRACE(printf("SetupImgBufRec pixel_depth = %d data_type = %x err = %d\n",
       pixel_depth,data_type,err))
 return err;
}


/*--------------------------------------------------------------------------
find_img_buf_rec - ???

FIXME:  This function appears to never be used.
--------------------------------------------------------------------------*/

unsigned int 
find_img_buf_rec(data,num_data,file,cur_slice,found)
 struct img_buf_rec *data;
 unsigned int num_data;
 struct input_file_rec *file;
 struct hdr_scan_entry_rec *cur_slice;
 int *found;
{
 unsigned int lcv;

 *found = 0;
 for (lcv = 0; lcv < num_data; lcv++)
    if ((data[lcv].file == file) && (data[lcv].cur_slice == cur_slice))
       {*found = 1;
        return lcv;}
 return ~NO_ERROR; /* FIXME:  Guessed at proper return value.  -PWH 19990414 */
}


/*--------------------------------------------------------------------------
get_img_buf - ???
--------------------------------------------------------------------------*/

int
get_img_buf(cur_img)
 struct img_buf_rec **cur_img;
{
 int err;

 if ((err = get_ptr(cur_img,NULL,(unsigned int) 1,
               (size_t) sizeof(**cur_img))) == NO_ERROR)
    init_img_buf_rec(*cur_img);
 return err;
}


/*--------------------------------------------------------------------------
 - ???

 allocate buffers for the current img_rec and its partners...
--------------------------------------------------------------------------*/

struct img_buf_rec *
NewImgBuf(img,cur_slice,err,get_win_rec,
	  use_this_buf_dims,dimx,dimy,pixel_depth_bits,data_type,
	  is_all_echoes)
     struct img_rec *img;
     struct hdr_scan_entry_rec *cur_slice;
     int *err;
     int get_win_rec;
     int use_this_buf_dims;
     unsigned long dimx,dimy,pixel_depth_bits,data_type;
     int is_all_echoes;
{
  struct img_buf_rec *cur_img,*head,*last;
  struct hdr_scan_entry_rec *next_slice;
  int cnt;
  
  next_slice = cur_slice;
  head = last = NULL;
  *err = NO_ERROR;
  cnt = 0;

  do
  {
    if ((*err = get_img_buf(&cur_img)) != NO_ERROR)
      break;
    if (get_win_rec)
    {
      if ((*err = SetupImgBufRecWithWinRec(cur_img,img->file, 
					   NULL,next_slice,NULL,
					   use_this_buf_dims,dimx,dimy,
					   pixel_depth_bits,data_type))
	  != NO_ERROR)
      {
	free_img_buf_rec(cur_img);
	c_free(cur_img);
	TRACE(printf("get_NewImgBuf..1\n"));
	break;
      }
    }
    else if ((*err = SetupImgBufRec(cur_img,img->file,
				    NULL,next_slice,NULL,NULL,
				    use_this_buf_dims,dimx,dimy,
				    pixel_depth_bits,data_type)) != NO_ERROR)
    {
      free_img_buf_rec(cur_img);
      c_free(cur_img);
      TRACE(printf("get_NewImgBuf..2\n"));
      break;
    }

    get_handle_memory(&(img->data),&(img->num_data),(unsigned int) 1,
		      (size_t) sizeof(struct img_buf_rec *),err);
    if (*err)
    {
      free_img_buf_rec(cur_img);
      c_free(cur_img);
      TRACE(printf("get_NewImgBuf..3\n"));
      break;
    }

    TRACE(printf("%d) slice# %d %d  %s\n",
		 next_slice->slice->physical_indx,
		 next_slice->slice_num,
		 next_slice->num,next_slice->img_label));

    img->data[img->num_data - 1] = cur_img;
    if (head == NULL)
      head = cur_img;
    if (last != NULL)
      last->partner = cur_img;
    last = cur_img;
    if (!is_all_echoes)
    {
      break;
    }
    cnt += 1;
    if (img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION)
    {
      if (cnt == 1)
	cur_img->status4 |= IMAGE_POS_NEG_ACTIVATION;
      else if (cnt == 2)
	cur_img->status4 |= IMAGE_POS_ACTIVATION;
      else
	cur_img->status4 |= IMAGE_NEG_ACTIVATION;
    }
    next_slice = next_slice->partner_slice;
    if (img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION)
    {
      if (cnt == 3)
	break;
    }
    else if (next_slice == cur_slice)
      break;
  }
  while (1);			/* Infinite loop */

  if (head != NULL) 
  {
    last->partner = head;
  }
  return head;
}


/*--------------------------------------------------------------------------
is_all_img_partner_wins_closed - ???
--------------------------------------------------------------------------*/

int
is_all_img_partner_wins_closed(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *temp;

 temp = img->partner;
 while (temp != img)
    {PRT1(printf("is_all_img_partner_wins_closed %u win = %u\n",temp,temp->win))
     if (temp->win != NULL) return 0;
       else temp = temp->partner;
    }
 return 1;
}


/*--------------------------------------------------------------------------
delete_img_and_partner_bufs - ???
--------------------------------------------------------------------------*/

int
delete_img_and_partner_bufs(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *temp,*partner;
 int err;

 temp = img;
 PRT1(printf("delete_img_and_partner_bufs img = %u\n",img))
 do
    {partner = temp->partner;
     if ((err = DropHandleAryPtr(&(temp->file->img.data),
          &(temp->file->img.num_data),temp)) != NO_ERROR)
        {PRT1(printf("delete_img_and_partner_bufs temp NOT found = %u\n",temp))
         return err;}
     PRT1(printf("delete_img_and_partner_bufs temp freed = %u\n",temp))
     free_img_buf_rec(temp);
     c_free(temp);
     temp = partner;
    }
 while (temp != img);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_img_partner_link - ???
--------------------------------------------------------------------------*/

int
delete_img_partner_link(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *last,*partner;

 PRT1(
      partner = img;
      do 
         {printf("delete_img_partner_link before partner  = %u\n",partner);
          partner = partner->partner;
         }
      while (partner != img);
     )

 last = partner = img->partner;
 for (;partner != img;)
    {last = partner;
     partner = partner->partner;
    }
 if (last != img)
    last->partner = img->partner;

 PRT1(
      last = partner = img->partner;
      do 
         {printf("after partner  = %u\n",partner);
          partner = partner->partner;
         }
      while (partner != last);
     )
 img->partner = img;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_img_if_not_use - ???
--------------------------------------------------------------------------*/

int
delete_img_if_not_use(img)
 struct img_buf_rec *img;
{
 if (img == NULL) return NO_ERROR;
 if ((img->win == NULL) ||
     ((img->win->image_display == NULL) && 
            (img->win->histogram == NULL)))
    {
     if (DropHandleAryPtr(&(img->file->img.data),
                &(img->file->img.num_data),img))
        {PRT1(printf("delete_img_if_not_use img NOT found = %u\n",img))
        }
     delete_img_partner_link(img);
     free_img_buf_rec(img);
     c_free(img);
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
delete_img - ???
--------------------------------------------------------------------------*/

int
delete_img(img)
 struct img_buf_rec *img;
{
 if (img == NULL) return NO_ERROR;
 img->win = NULL;
 if (DropHandleAryPtr(&(img->file->img.data),
                &(img->file->img.num_data),img))
    {PRT1(printf("delete_img img NOT found = %u\n",img))
    }
 delete_img_partner_link(img);
 free_img_buf_rec(img);
 c_free(img);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
find_existing_img_buf_rec - ???
--------------------------------------------------------------------------*/

struct img_buf_rec *
find_existing_img_buf_rec(img,cur_slice)
 struct img_rec *img;
 struct hdr_scan_entry_rec *cur_slice;
{
 int lcv;

 for (lcv = 0; lcv < img->num_data; lcv++)
    if (img->data[lcv]->cur_slice == cur_slice)
      {
       return img->data[lcv];
      }
 return NULL;
}


/*--------------------------------------------------------------------------
AllActivationEchoesExist - ???
--------------------------------------------------------------------------*/

int
AllActivationEchoesExist(img)
 struct img_buf_rec *img;
{
 struct img_buf_rec *img1,*imgs[3];
 static unsigned long types[3] =
       {IMAGE_POS_NEG_ACTIVATION,IMAGE_POS_ACTIVATION,IMAGE_NEG_ACTIVATION};
 unsigned long cnt,lcv;
 int err,yes[3];

 if (!(img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION))
    return CANCEL;

 for (lcv = 0; lcv < 3; lcv++)
    {imgs[lcv] = NULL;
     yes[lcv] = 0;}
 cnt = 0;
 img1 = img;
 do 
   {for (lcv = 0; lcv < 3; lcv++)
       if ((img1->status4 & types[lcv]) == types[lcv])
          {imgs[lcv] = img1;
           break;}
    img1 = img1->partner;
    cnt += 1;
   }
 while (img1 != img);
 PRT3(printf("AllActivationEchoesExist...cnt = %d\n",cnt))
 if (cnt == 3) return NO_ERROR;

 for (err = NO_ERROR,lcv = 0; lcv < 3; lcv++)
    if (imgs[lcv] == NULL)
	/* Added a final argument 0 below, guessing the the
	   correct value.  -PWH 19990414 */
       if ((imgs[lcv] = NewImgBuf(&(img->file->img),
                     img->cur_slice,&err,1,0,0,0,0,0,0)) == NULL)
          break;
         else
          {imgs[lcv]->status4 &= ~IMAGE_POS_NEG_ACTIVATION;
           imgs[lcv]->status4 |= types[lcv];
           yes[lcv] = 1;}

 if (err != NO_ERROR)
    {for (lcv = 0; lcv < 3; lcv++)
        if (yes[lcv]) delete_img(imgs[lcv]);
     return err;
    }
 for (lcv = 0; lcv < 3; lcv++)
    {PRT3(printf("%d) status = %x\n",lcv,imgs[lcv]->status4))
     imgs[lcv]->partner = imgs[(lcv + 1) % 3];}

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
all_img_echoes_exist - ???
--------------------------------------------------------------------------*/

int
all_img_echoes_exist(img)
 struct img_buf_rec *img;
{
 struct hdr_scan_entry_rec *partner;
 struct img_buf_rec *new_img,*img1,*prior;
 int err;

 if (img->file->hdr.data_info.var_use_status & CHANGES_ACTIVATION)
    return AllActivationEchoesExist(img);
 img1 = img->partner;
 partner = img->cur_slice->partner_slice;
 prior = img;
 do 
    {TRACE(printf("img1 = %u img_label = %s num = %d img_addr = %u slice = %u\n",
         img1->cur_slice,img1->cur_slice->img_label,img1->cur_slice->num,
         img1->cur_slice->img_addr,img1->cur_slice->slice))
     TRACE(pr_buf_2d_rec(&(img1->_2d)))
     TRACE(printf("partner = %u img_label = %s num = %d img_addr = %u slice = %u\n",
         partner,partner->img_label,partner->num,
         partner->img_addr,partner->slice))

     if (img1->cur_slice != partner)
	 /* FIXME!  Added a final argument 0 below, guessing at the
	    right value.  -PWH 19990414 */
        {if ((new_img = NewImgBuf(&(img->file->img),
                     partner,&err,1,0,0,0,0,0,0)) == NULL)
            return err;
         prior->partner = new_img;
         new_img->partner = img1;
         prior = new_img;
        }
       else
        {prior = img1;
         img1 = img1->partner;}

     partner = partner->partner_slice;
    }
 while (img->cur_slice != partner);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
pr_img_rec - ???
--------------------------------------------------------------------------*/

void
pr_img_rec(img)
 struct img_rec *img;
{
 struct img_buf_rec *cur_img;
 unsigned long lcv;

 printf("pr_img_rec img->num_data = %d\n",img->num_data);
 for (lcv = 0; lcv < img->num_data; lcv++) 
    {cur_img = img->data[lcv];
     printf("%ld) cur_img = %p\n", lcv, cur_img);
     if (cur_img->cur_slice != NULL)
        printf("cur_slice = %p label = %s",
               cur_img->cur_slice,cur_img->cur_slice->img_label);
     if (cur_img->win != NULL)
        printf("win = %p ",cur_img->win);
     printf("\n");
    }
}
