/****************************************************************************
list.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: list.c,v 1.6 1999/07/07 17:41:17 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "geometry.h"
#include "buf_3d_rec.h"
#include "mri_format.h"
#include "nria_procedures.h"



/* Functions defined in this file */
int sort_wid_proc(char **str1, char **str2);
int get_win_list_wids(struct image_display_window *win, struct strs_rec *wids);
int num_continuous_win_list_slices(struct image_display_window *win);
int win_delete_multiple_wins_in_list(struct image_display_window *win);



/*---------------------------------------------------------------------------
sort_wid_proc - ???
---------------------------------------------------------------------------*/

int
sort_wid_proc(str1,str2)
 char **str1,**str2;
{
 int id1,id2;

 sscanf(*str1,"W%d",&id1);
 sscanf(*str2,"W%d",&id2);
 if (id1 > id2) return 1;
 if (id1 < id2) return -1;
 return 0;
}


/*---------------------------------------------------------------------------
get_win_list_wids - ???
---------------------------------------------------------------------------*/

int
get_win_list_wids(win,wids)
 struct image_display_window *win;
 struct strs_rec *wids;
{
 struct image_display_window *nextwin;
 struct list_rec *next,*cur;
 int err;
 char *id;

 cur = next = &(win->list);
 do
    {
     nextwin = (struct image_display_window *) next->item;
     if ((id = WinRecGetWid(nextwin->owner,nextwin->type2)) != NULL)
        if ((err = add_str_to_strs_rec(wids,id)) != NO_ERROR)
           {return err;}
     next = next->next;
    }
 while (cur != next);
 if (wids->num_strs > 1) sort_strs_rec(wids,sort_wid_proc);

 return NO_ERROR;
}


/*---------------------------------------------------------------------------
num_continuous_win_list_slices - ???

 if slices in the list are not the next slice to their respective prior slices,
     0 is returned else the # of slices in the list is returned.
---------------------------------------------------------------------------*/

int
num_continuous_win_list_slices(win)
 struct image_display_window *win;
{
 if (win->status4 & STACK_WIN_COSECUTIVE)
    return cnt_num_list_items(&(win->list));
   else return 1;
}


/********************
 struct image_display_window *curwin,*nextwin;
 struct list_rec *next,*last;
 int err,cnt;
 char *id;
 struct img_buf_rec *cur_img,*next_img;

 next = (struct list_rec *) head_list(&(win->list));
 if (next == next->next) return 1;
 last = next->before;
 cnt = 1;
 do
    {
     curwin = (struct image_display_window *) next->item;
     nextwin = (struct image_display_window *) next->next->item;
     if ((cur_img = win_rec_cur_img_buf(curwin->owner)) == NULL) return 0;
     if ((next_img = win_rec_cur_img_buf(nextwin->owner)) == NULL) return 0;
     if (cur_img->cur_slice->next_slice != next_img->cur_slice) return 0;
     cnt++;
     next = next->next;
    }
 while (last != next);

 return cnt;
}
***************************/


/*---------------------------------------------------------------------------
win_delete_multiple_wins_in_list - ???
---------------------------------------------------------------------------*/

int
win_delete_multiple_wins_in_list(win)
 struct image_display_window *win;
{
 int err,stop;
 struct image_display_window *nextwin;
 struct list_rec *next;
 struct view_rec *view;
 struct img_buf_rec *img;
 int is_3d;

 if (win->type2 & DISPLAY_WINDOW_3D)
    {if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
     if ((view = img->cur_slice->slice->view) == NULL) return CANCEL;
     next = &(view->_3d_list);
     is_3d = 1;
    }
   else
    {is_3d = 0;
     next = &(win->list);}
 stop = 0;
 while (!stop)
    {
     if (is_3d)
        {view = (struct view_rec *) next->item;
         if ((view->img->win == NULL) ||
             ((nextwin = (struct image_display_window *)
                    view->img->win->image_display) == NULL))
            break;
        }
      else if ((nextwin = (struct image_display_window *) next->item) == NULL)
        break;
     if (next->next == next) stop = 1;
       else next = (struct list_rec *) delete_item_from_list(next);
     if ((err = win_delete_multiple_wins(nextwin)) != NO_ERROR)
        return err;
    }
 return NO_ERROR; 
}
