/****************************************************************************
output_image.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: output_image.c,v 1.7 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "nria_procedures.h"



/* Functions defined in this file */
int batch_pr_image(char *pr_driver, char *imgfn, int imgdimx, int imgdimy);
int pr_cur_2d_buf(char *pr_driver, struct buf_2d_rec *_2d, char **err_reason);
int win_pr_cur_slice(struct image_display_window *win);
int win_pr_all_slices(struct image_display_window *win);



/*-------------------------------------------------------------------------
batch_pr_image - ???
-------------------------------------------------------------------------*/

int
batch_pr_image(pr_driver,imgfn,imgdimx,imgdimy)
 char *pr_driver,*imgfn;
{
 char *batchfn,str[250];
 int err;
 FILE *fid;

 if ((err = cp_str(&batchfn,tmpnam(NULL))) == NO_ERROR)
    {if ((fid = fopen(batchfn,"w")) != NULL)
        {fprintf(fid,"%s %s %d %d > /dev/null\n",
              pr_driver,imgfn,imgdimx,imgdimy);
         fprintf(fid,"lpr %s.ps\n",imgfn);
         fprintf(fid,"unalias rm\n");
         fprintf(fid,"rm %s\n",imgfn);
         fprintf(fid,"rm %s.ps\n",imgfn);
         fprintf(fid,"rm %s\n",batchfn);

         fclose(fid);
         sprintf(str,"csh %s\n",batchfn);
         system(str);
         err = NO_ERROR;
        }
       else err = FILE_ACCESS_ERROR;
     c_free(batchfn);
    }
 return err;
}


/*-------------------------------------------------------------------------
pr_cur_2d_buf - ???
-------------------------------------------------------------------------*/

int
pr_cur_2d_buf(pr_driver,_2d,err_reason)
 char *pr_driver;
 struct buf_2d_rec *_2d;
 char **err_reason;
{
 int err;
 char *imgfn;
 FILE *fid;

 if ((err = file_access(pr_driver,1,NULL,err_reason)) == NO_ERROR)
    {
     if ((err = cp_str(&imgfn,tmpnam(NULL))) == NO_ERROR)
        {
         if ((fid = fopen(imgfn,"w")) != NULL)
            {if (fwrite(_2d->buf[0],
                           (size_t) _2d->total_bytes,(size_t) 1,fid) != 1)
                {err = WRITE_ERROR;
                 if (err_reason != NULL) cp_str(err_reason,
                           "Print error : write image error !!!");}
             fclose(fid);
             if (err == NO_ERROR)
                {err = batch_pr_image(pr_driver,imgfn,
                              _2d->dimx,_2d->dimy);
                 if (err != NO_ERROR)
                    {delete_file(imgfn);
                     if (err_reason != NULL)
                        cp_str(err_reason,"Print error !!!");
                    }
                }
               else delete_file(imgfn);
             }
            else if (err_reason != NULL)
             cp_str(err_reason,"Print error : cannot create temp file !!!");
          c_free(imgfn);
         }
     }
 return err;
}


/*-------------------------------------------------------------------------
win_pr_cur_slice - ???
-------------------------------------------------------------------------*/

int
win_pr_cur_slice(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;
 struct buf_2d_rec _2d;
 unsigned long first,num_colors;
 char *err_reason,*str,*pr_driver;

 err = CANCEL;
 pr_driver = NULL;
 err_reason = NULL;
 if (((img = win_rec_cur_img_buf(win->owner)) != NULL) &
     ((pr_driver = get_prog_def_fn(win->owner->root->prog,"raw2ps")) != NULL))
    {
     init_buf_2d_rec(&_2d);
     if (((err = file_access(pr_driver,9,NULL,&err_reason)) != NO_ERROR) ||
         ((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
            img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR))
        {if (err_reason == NULL) str = "MEMORY ERROR";
           else str = err_reason;
         ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "PRINT ERROR...",str,NULL,0);
         c_free(pr_driver);
         c_free(err_reason);
         return err;}
     win_first_and_num_colors(win,&first,&num_colors);
     _2d.minval_set = img->file->hdr.data_info.min_pixel;
     _2d.maxval_set = img->file->hdr.data_info.max_pixel;
     _2d.status4 |= BUF_MIN_MAX_SET;
     err = Scale2dPixels(&_2d,&(img->_2d),
             (double)0.0, (double)(num_colors - 1),
             0,(double)0.0, (double)0.0, 0);
     if (err == NO_ERROR)
        {Map2dPixelValues(&_2d,&_2d,
                 win->intensity->color.color_indxs,
                 win->intensity->color.total_colors,
                 (size_t) (sizeof(*(win->intensity->color.color_indxs)) * 8),first);
         Scale2dPixels(&_2d,&_2d,(double) .0, (double) 255.0,
             0,(double) .0, (double).0, 0);
         err = pr_cur_2d_buf(pr_driver,&_2d,&err_reason);
        }
     free_buf_2d_rec(&_2d);
    }
 if (err != NO_ERROR) 
    {if (err_reason == NULL) str = "";
       else str = err_reason;
     ShowMsgStrs(win->dwin->frame,0,err,0,3,
               "PRINT ERROR...",str,OPERATION_ABORTED,NULL,0);}
 c_free(pr_driver);
 c_free(err_reason);
 return err;
}


/*-------------------------------------------------------------------------
win_pr_all_slices - ???
-------------------------------------------------------------------------*/

int
win_pr_all_slices(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;
 struct buf_2d_rec _2d;
 struct hdr_scan_entry_rec *scans;
 unsigned long lcv;
 char *err_reason,*str,*pr_driver;
 unsigned long first,num_colors;

 err = CANCEL;
 pr_driver = NULL;
 err_reason = NULL;
 if (((img = win_rec_cur_img_buf(win->owner)) != NULL) &
     ((pr_driver = get_prog_def_fn(win->owner->root->prog,"raw2ps")) != NULL))
    {
     init_buf_2d_rec(&_2d);
     if (((err = file_access(pr_driver,9,NULL,&err_reason)) != NO_ERROR) ||
         ((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
            img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR))
        {if (err_reason == NULL) str = "MEMORY ERROR";
           else str = err_reason;
         ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "PRINT ERROR...",str,NULL,0);
         c_free(pr_driver);
         c_free(err_reason);
         return err;}

     scans = img->file->hdr.scans;
     for (lcv = 0; lcv < img->file->hdr.num_scans; lcv++)
        {fseek(img->file->img_fid,scans[lcv].img_addr,0);
         _2d.status4 &= BUF_FLUSH_DATA_STATUS;
         _2d.minval_set = img->file->hdr.data_info.min_pixel;
         _2d.maxval_set = img->file->hdr.data_info.max_pixel;
         _2d.status4 |= BUF_MIN_MAX_SET;
         if (fread(_2d.buf[0],
                 (size_t) _2d.total_bytes,(size_t) 1,img->file->img_fid) != 1)
            {
             ShowMsgStrs(win->dwin->frame,0,err,0,2,
                   "PRINT : READ ERROR...",OPERATION_ABORTED,NULL,0);
             c_free(pr_driver);
             c_free(err_reason);
             return err;
            }
           else
            {
             win_first_and_num_colors(win,&first,&num_colors);
             if ((err = Scale2dPixels(&_2d,&_2d,
                 (double) .0, (double) (num_colors - 1),
                 0,(double) .0, (double) .0,0)) == NO_ERROR)
                {Map2dPixelValues(&_2d,&_2d,
                    win->intensity->color.color_indxs,
                    win->intensity->color.total_colors,
                    (size_t) (sizeof(*(win->intensity->color.color_indxs)) * 8),first);
                 err = pr_cur_2d_buf(pr_driver,&_2d,&err_reason);}
             if (err != NO_ERROR)
                break;
            }
        }
     free_buf_2d_rec(&_2d);
    }
 if (err != NO_ERROR) 
    {if (err_reason == NULL) str = "";
       else str = err_reason;
     ShowMsgStrs(win->dwin->frame,0,err,0,3,
               "PRINT ERROR...",str,OPERATION_ABORTED,NULL,0);}
 c_free(pr_driver);
 c_free(err_reason);
 return err;
}
