/****************************************************************************
rdir.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: rdir.c,v 1.12 1999/07/07 17:41:18 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <memory.h>

#include "ask_file.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define TRACE(x) x;fflush(stdout);
#define PRT(x) x;fflush(stdout);
*/
#define TRACE(x) 
#define PRT(x) 



/* Functions defined in this file */
int open_a_file(struct prog_rec *prog, char *dir, char *fn, char *hdr_suffix,
    char *img_suffix, char *dat_dir, char *dat_fn, char *dat_fn_suffix,
    char *bin_fn_suffix);
char *get_dat_fn(char *hdr_fn, char *dat_patt);
int open_fn_proc(struct prog_rec *prog, struct dir_fn_rec *dir);
int find_mri_file(struct input_rec *input, char *dirfn, char *fn,
    char *hdr_fn_suffix, char *img_fn_suffix, unsigned int *file_indx);
int rd_mri_file(struct input_file_rec *file, char *dirfn, char *fn,
    char *hdr_fn_suffix, char *img_fn_suffix, int is_rd_img, char **reason);
int get_mri_file(struct input_rec *input, char *dirfn, char *fn,
    char *hdr_fn_suffix, char *img_fn_suffix, int batch, int *file_indx,
    unsigned char **reason);
void win_rd_breaker_check(void *dummy1, void *dummy2,
    struct display_win_rec *win1);
int rd_dat_output(struct output_file_rec *output);
int setup_output_file(struct output_file_rec *output, char *dirfn, char *fn,
    char *dat_fn_suffix, char *bin_fn_suffix);
int WrDatOutput(struct output_file_rec *output, int is_quit_file);
int AutoSaveDatOutput(struct output_file_rec *output, int is_quit_file);
int save_pixel_types_1(struct input_file_rec *file);
int save_pixel_types(struct input_file_rec *file, Frame frame, int is_dp_msg);
int FileDeleteMarkRoi(struct input_file_rec *file);
int close_and_delete_file(struct input_file_rec *file, int must_close);
int close_all_files(struct input_rec *input, int must_close);



/****************************

FIXME:  This appears to go with the next routine, which is commented out.

#define GET_FN_MAIN_DIR_FNS_READY 1
#define GET_FN_MAIN_START_OLD 2
#define GET_FN_MAIN_START_NEW 3
#define GET_FN_MAIN_DISPOSE 4
#define GET_FN_MAIN_SHOW_WINDOWS 5

  1) get_fns_main1(frame,GET_FN_MAIN_START_NEW,label,
        user_done_proc,user_done_proc_arg,hdr_dir,hdr_fn,dat_dir,dat_fn)
     starts all over again.
  2) get_fns_main1(frame,GET_FN_MAIN_START_OLD,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL) starts with the previously selected fns.
  3) get_fns_main1(NULL,GET_FN_MAIN_DIR_FNS_READY,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL) returns a NULL ptr
          if the file names to be selected are not currently available.
  4) get_fns_main1(frame,GET_FN_MAIN_DISPOSE,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL) frees up all the memory used
          internally by get_fns_main1, including all the windows.
  5) get_fns_main1(frame,GET_FN_MAIN_SHOW_WINDOWS,NULL,NULL,NULL,
           NULL,NULL,NULL,NULL) makes all the
     windows active.
  Note : user_proc is the user defined routine which has a form as follows :-
             user_proc(the_dir_fn_rec *dir)  and "user_proc" can be any routine
              name.
         frame is the base frame to which the main frame of windows used
             in get_fns_main1 is a subwindow.
******************************/


/********************
struct the_dir_fn_rec *get_fns_main1(frame,option,label,
         user_done_proc,user_done_proc_arg,hdr_dir,hdr_fn,dat_dir,dat_fn)
 Frame frame;
 int option;
 char *label;
 int (*user_done_proc)();
 void *user_done_proc_arg;
 char *hdr_dir,*hdr_fn,*dat_dir,*dat_fn;
{
 static unsigned char first_time = 1;
 static struct select_fns_rec select_items;
 int err;

      TRACE(printf("get_fns_main1...\n"))
 if (option == GET_FN_MAIN_DIR_FNS_READY)
    {
     if (!first_time && select_items.dir.dir_valid)
        {TRACE(printf("return GET_FN_MAIN_DIR_FNS_READY...\n"))
         return (struct the_dir_fn_rec *)
                  setup_the_dir_fn_rec(&(select_items.dir),&err);}
       else return NULL;
    }
   else if (option == GET_FN_MAIN_DISPOSE)
    {if (!first_time)
        {free_select_items(&select_items);
         first_time = 1;}
     return NULL;}
 if (first_time)
    {init_select_items1(&select_items);
     option = GET_FN_MAIN_START_NEW;
     first_time = 0;
    }
   else if (option == GET_FN_MAIN_START_NEW)
    free_select_items(&select_items);

 switch (option)
   {case GET_FN_MAIN_START_NEW :
      if (setup_select_items(frame,&select_items,label,user_done_proc,
                     user_done_proc_arg,NULL) == NO_ERROR)
         err = select_fns(&select_items,hdr_dir,hdr_fn,dat_dir,dat_fn,
                 select_items.dir.cur_dir);

      if ((frame == NULL) && (err == NO_ERROR))
         window_main_loop(select_items.win.frame);
        else if (select_items.win.frame != NULL)
         {win_set_mouse_at_center(select_items.win.frame);
          xv_set(select_items.win.frame,XV_SHOW,TRUE,0);}
      break;
    case GET_FN_MAIN_START_OLD :
      TRACE(printf("GET_FN_MAIN_START_OLD...\n"))
      free_all_selected_fn_recs(&(select_items.dir));
      if (select_items.win.frame == NULL)
         {if (setup_select_items(frame,&select_items,label,user_done_proc,
                     user_done_proc_arg,NULL) != NO_ERROR) return NULL;
             {
              err = select_fns(&select_items,NULL,NULL,NULL,NULL,
                       select_items.dir.cur_dir);}
          if ((frame == NULL) && (err == NO_ERROR))
             window_main_loop(select_items.win.frame);
            else if (select_items.win.frame != NULL)
             {win_set_mouse_at_center(select_items.win.frame);
              xv_set(select_items.win.frame,XV_SHOW,TRUE,0);}
         }
        else show_all_windows(&select_items);
      break;
    case GET_FN_MAIN_SHOW_WINDOWS :
      if (select_items.win.frame != NULL) show_all_windows(&select_items);
      break;
   }
 return NULL;
}
*********************/


/*------------------------------------------------------------------------
open_a_file - ???
------------------------------------------------------------------------*/

int
open_a_file(prog,dir,fn,hdr_suffix,img_suffix,
            dat_dir,dat_fn,dat_fn_suffix,bin_fn_suffix)
     struct prog_rec *prog;
     char *dir,*fn,*hdr_suffix,*img_suffix,
  *dat_dir,*dat_fn,*dat_fn_suffix,*bin_fn_suffix;
{
  unsigned int file_indx;
  struct img_buf_rec *img;
  unsigned int lcv;
  int err,is_redisplay;
  Frame *frame;
  char *tempfn,*reason;
  char str[100],str1[100];
  struct input_file_rec *file;

  TRACE(printf("open_a_file...\n"));
  if (((err = get_mri_file(&(prog->input),dir,fn,hdr_suffix,img_suffix,0,
			   &file_indx,&reason)) == NO_ERROR) ||
      (err == FILE_ALREADY_OPEN))
  {
    TRACE(printf("open_a_file...dat_fn = %s\n",dat_fn));

    file = prog->input.files[file_indx];
    if (err != FILE_ALREADY_OPEN)
      if ((err = setup_output_file(&(file->output),
				   dat_dir,dat_fn,dat_fn_suffix,
				   bin_fn_suffix)) != NO_ERROR)
	ndat_err_msg(file,err,0);

    TRACE(printf("open_a_file..2.\n"));

    AutoRdFilePixmapHdr1(file->output.dirfn,file->output.fn,
			 PIXMAP_SUFFIX,&(file->pixel_type));
    err = NO_ERROR;

    TRACE(printf("open_a_file..2..1.\n"));

    setup_text_output_params(&(prog->input.files[file_indx]->text));

    TRACE(printf("open_a_file..2...2.\n"));

    setup_count_analysis_rec_params( &(prog->input.files[file_indx]->count) );

    PRT(printf("open_a_file..file_indx = %d\n",file_indx));
    PRT(for (lcv = 0; lcv < prog->input.num_files; lcv++)
        printf("%d) FILE = %u\n",lcv,prog->input.files[lcv]));

    for (lcv = 0; lcv < prog->input.files[file_indx]->img.num_data; lcv++)
    {
      img = prog->input.files[file_indx]->img.data[lcv];
      if (img != NULL)
      {
	if (img->win == NULL)
	{
	  img->win = get_new_img_win(img,&err);
	}

	if (err == NO_ERROR)
	{
	  TRACE(printf("open_a_file..%s\n",
		       prog->input.files[file_indx]->hdr.extra_info.
		       color_bundle_label));
	  if (prog->input.files[file_indx]->color_guide == NULL)
	    prog->input.files[file_indx]->color_guide =
	      prog->win.def_color.pallettes[prog->win.def_color.cur_pallette];
	  TRACE(printf("open_a_file..4.\n"));
	  if (!win_is_window_open(img->win->image_display))
	  {
	    TRACE(printf("open_a_file..5.\n"));
	    if ((err = win_setup_windows(img->win,NULL,
					 EAST,DISPLAY_WINDOW)) != NO_ERROR)
	      return err;
	    TRACE(printf("open_a_file..7.\n"));
	    is_redisplay = 0;
	  }
	  else
	  {
	    win_multiple_set_frame_label(img->win->image_display);}
	}
	TRACE(printf("open_a_file..7.\n"));
      }
    }
  }
  else
  {
    frame = (Frame *) main_display(2,NULL,0,0);
    if (err == FILE_NAME_ERROR)
    {
      notice_prompt(*frame,(Event *) NULL,
		    NOTICE_MESSAGE_STRINGS,"Error !!! No File Name...",0,
		    NOTICE_BUTTON_YES,FAILED,0);
    }

    /*  Bug?  Check out empty statement effect on next line... DRW 970225 */
    else if (reason == NULL)  /* ; */
    {
      sprintf(str,"Memory error or file error !!!");
      build_fn(&tempfn,dir,fn,"*");
      sprintf(str1,"When processing %s !!!",tempfn);
      ShowMsgStrs(*frame,0,err,0,2,
		  str,str1,NULL,0);
      c_free(tempfn);
    }
    c_free(reason);
  }
  return err;
}



/*------------------------------------------------------------------------
get_dat_fn - ???
------------------------------------------------------------------------*/

char *
get_dat_fn(hdr_fn,dat_patt)
 char *hdr_fn,*dat_patt;
{
 char *suffix,*str,*result,*str1,*str2;
 int err;

 if ((err = cp_str(&str,dat_patt)) != NO_ERROR) return NULL;
 if ((err = cp_str(&str2,hdr_fn)) != NO_ERROR)
    {c_free(str);
     return NULL;}
 suffix = locate_suffix(str);

 drop_suffix(str);
 result = NULL;
 if (get_strlen(str) == 0) err = concat_strs(&result,2,str2,suffix);
   else
    {replace_substr_by_str(str,"#","*");
     replace_ch_without_duplicate(str,get_strlen(str),'*','*');
     if ((err = replace_ch_by_str(&str1,str,'*',str2)) == NO_ERROR)
        {err = concat_strs(&result,2,str1,suffix);
         c_free(str1);}
    }
 c_free(str);
 c_free(str2);
 c_free(suffix);
 if (err != NO_ERROR)
    {c_free(result);
     result = NULL;}
 return result;
}

/******************
pr_prog(prog,dir,num)
 struct prog_rec *prog;
 struct dir_fn_rec *dir;
 int num;
{
 char *thedatdir;

 printf("%d)   pr_prog prog = %u  sizeof = %d  %u dat_dir = %s  ",
      num,prog,sizeof(*prog),
            prog->defaults.whch.dat_dir,prog->defaults.whch.dat_dir);
 if (dir->cur_dir < dir->num_dirs)
    {thedatdir = dir->dirs[dir->cur_dir]->more_dir_fns.strs[0];
     printf("%u thedatdir = %s\n",
            thedatdir,thedatdir);fflush(stdout);
    }
   else printf("\n");
}
********************/




/*------------------------------------------------------------------------
open_fn_proc - ???

Once an image header file has been selected from the pop-up
filenames dialog, open it up into a subwindow.

FIXME:  It's not clear whether this function should have return typ
int or void, since it is used mostly as an argument to other functions.
------------------------------------------------------------------------*/

int
open_fn_proc(prog,dir)
     struct prog_rec *prog;
     struct dir_fn_rec *dir;
{
  char *fn,*hdr_suffix,*dat_fn_suffix,*datfn,*thedatdir,*thedatfn;
  int err,lcv,cnt;

  TRACE(printf("prog->input.total_files = %d\n",prog->input.total_files));
  if (dir != NULL)
  {
    TRACE(printf("dir->num_dirs = %d\n",dir->num_dirs));

    for (lcv = 0; lcv < dir->num_dirs; lcv++)
    {
      if (dir->dirs[lcv]->fns.num_strs == 0)
	continue;
      TRACE(printf("%d) dir = %s  ",lcv,dir->dirs[lcv]->dir));
      TRACE(printf("hdr_fn = %s\n",dir->dirs[lcv]->fn));
      TRACE(printf("num_strs = %d\n",dir->dirs[lcv]->more_dir_fns.num_strs));
      if (dir->dirs[lcv]->more_dir_fns.num_strs == 2)
      {
	thedatdir = dir->dirs[lcv]->more_dir_fns.strs[0];
	thedatfn = dir->dirs[lcv]->more_dir_fns.strs[1];
      }
      else
      {
	thedatdir = NULL;
	thedatfn = NULL;
      }
      TRACE(printf("thedatdir = %s  thedatfn = %s\n",thedatdir,thedatfn));
      for (cnt = 0; cnt < dir->dirs[lcv]->fns.num_strs; cnt++)
      {
	cp_str(&fn,dir->dirs[lcv]->fns.strs[cnt]);
	hdr_suffix = (char *) locate_suffix(fn);
	TRACE(printf("...fn = %s\n",fn));

	drop_suffix(fn);

	datfn = get_dat_fn(fn,thedatfn);
	TRACE(printf("1...fn = %s datfn = %s\n",fn,datfn));
	dat_fn_suffix = (char *) locate_suffix(datfn);
	drop_suffix(datfn);

	TRACE(printf("fn = %s hdr_suffix = %s\n",fn,hdr_suffix));
	TRACE(printf("datfn = %s dat_fn_suffix = %s\n",
		     datfn,dat_fn_suffix));

	if (fn != NULL)
	  if ((err = open_a_file(prog,dir->dirs[lcv]->dir,fn,
				 hdr_suffix,".img",thedatdir,datfn,
				 dat_fn_suffix,".bin")) != NO_ERROR)
	  {
	  }

	c_free(datfn);
	c_free(dat_fn_suffix);
	c_free(fn);
	c_free(hdr_suffix);
      }
    }

    TRACE(printf("after open_fn_proc...1\n"));
    if (dir->cur_dir < dir->num_dirs)
    {
      thedatdir = dir->dirs[dir->cur_dir]->more_dir_fns.strs[0];
      TRACE(printf("1 prog=%p, sizeof=%d, %u:dat_dir=%s, %u:thedatdir=%s\n",
		   (void *) prog, sizeof( *prog ),
		   (void *) prog->defaults.whch.dat_dir,
		   prog->defaults.whch.dat_dir,
		   (void *) thedatdir,
		   thedatdir));

      if (str_cmp(prog->defaults.whch.dat_dir,thedatdir) != 0)
	str_dealloc_and_cpy(&(prog->defaults.whch.dat_dir),thedatdir);

      TRACE(printf("2 %u  dat_dir = %s  thedatdir = %s\n",
		   prog->defaults.whch.dat_dir,prog->defaults.whch.dat_dir,
		   thedatdir,thedatdir));
    }
  }
}




/*------------------------------------------------------------------------
find_mri_file - ???
------------------------------------------------------------------------*/

int
find_mri_file(input,dirfn,fn,hdr_fn_suffix,img_fn_suffix,file_indx)
 struct input_rec *input;
 char *dirfn,*fn;         /* directory fn & fn */
 char *hdr_fn_suffix,*img_fn_suffix;
 unsigned int *file_indx;
{
 int lcv;

 TRACE(printf("dirfn = %s fn  = %s  hdr_fn_suffix  = %s  img_fn_suffix = %s\n",
        dirfn,fn,hdr_fn_suffix,img_fn_suffix))
 for (lcv = 0; lcv < input->num_files; lcv++)
    {
     if ((str_cmp(input->files[lcv]->dirfn,dirfn) == 0) &&
         (str_cmp(input->files[lcv]->fn,fn) == 0) &&
         ((str_cmp(input->files[lcv]->hdr_fn_suffix,hdr_fn_suffix) == 0) ||
         (str_cmp(input->files[lcv]->img_fn_suffix,img_fn_suffix) == 0)) )
       {*file_indx = lcv;
        TRACE(printf("find_mri_file found indx = %d\n",*file_indx))
        return NO_ERROR;}
    }

 TRACE(printf("new file...\n"))
 
 return NOT_FOUND;
}



/*------------------------------------------------------------------------
rd_mri_file - ???
------------------------------------------------------------------------*/

int
rd_mri_file(file,dirfn,fn,hdr_fn_suffix,img_fn_suffix,is_rd_img,reason)
 struct input_file_rec *file;
 char *dirfn,*fn;         /* directory fn & fn */
 char *hdr_fn_suffix,*img_fn_suffix;
 int is_rd_img;
 char **reason;
{
 char *hdr_fn,*img_fn;
 int err;
 char str[250],str1[100];
 Frame *frame;
 static char *err_str = 
            "Please make sure you have read-write access to this file...";
 struct data_info_rec *info;

 *reason = NULL;
 file->status |= FILE_OPEN_ERROR;
 if ((err = str_dealloc_and_cpy(&(file->dirfn),dirfn)) != NO_ERROR)
    return err;
 trim_str_blanks(file->dirfn);

 if ((err = str_dealloc_and_cpy(&(file->fn),fn)) != NO_ERROR) return err;
 trim_str_blanks(file->fn);
 if (strlen(file->fn) == 0) return FILE_NAME_ERROR;

 if ((err = str_dealloc_and_cpy(&(file->hdr_fn_suffix),hdr_fn_suffix))
       != NO_ERROR) return err;
 trim_str_blanks(file->hdr_fn_suffix);
 if ((err = str_dealloc_and_cpy(&(file->img_fn_suffix),img_fn_suffix))
      != NO_ERROR) return err;
 trim_str_blanks(file->img_fn_suffix);

 if (((err = build_fn(&hdr_fn,file->dirfn,file->fn,file->hdr_fn_suffix))
           == NO_ERROR) &&
     ((err = build_fn(&img_fn,file->dirfn,file->fn,file->img_fn_suffix))
           == NO_ERROR))
    {
     TRACE(printf("rd_mri err = %d...1\n",err))
     if ((err = file_access(hdr_fn,12,NULL,reason)) != NO_ERROR)
        {frame = (Frame *) main_display(2,NULL,0,0);
         sprintf(str,
             "Error opening the .hdr file = %s!!!",hdr_fn);
         ShowMsgStrs(*frame,0,err,0,3,str,*reason,
                    FAILED,NULL,0);
        }
       else if (is_rd_img &&
                ((err = file_access(img_fn,12,NULL,reason)) != NO_ERROR))
        {frame = (Frame *) main_display(2,NULL,0,0);
         sprintf(str,
             "Error opening the .img file = %s!!!",img_fn);
         ShowMsgStrs(*frame,0,err,0,3,str,*reason,
                        FAILED,NULL,0);
        }
       else if ((err = rd_the_hdr(hdr_fn,&(file->hdr))) != NO_ERROR)
        {frame = (Frame *) main_display(2,NULL,0,0);
         sprintf(str,
             "Error reading the .hdr file = %s!!!",hdr_fn);
         ShowMsgStrs(*frame,0,err,0,3,str,err_str,
                    FAILED,NULL,0);}
       else if ((err = ValidateHdrParams(&(file->hdr),3000,3000,10000,2)) != NO_ERROR)
        {frame = (Frame *) main_display(2,NULL,0,0);
         info = &(file->hdr.data_info);
         if (err == 3)
            {sprintf(str,"# of scans setup = %ld  Not equal to  MAX SCANS = %ld",
                         file->hdr.num_scans,info->max_scans);
             ShowMsgStrs(*frame,0,err,0,3,
              "Bad header slice description setup !!!",
              str,FAILED,NULL,0);}
           else if (err == 4)
             ShowMsgStrs(*frame,0,err,0,2,
              "Inconsistent header value setup !!!",
              FAILED,NULL,0);
           else
            {sprintf(str,"DIMX/DIMY (1..3000) = %ld/%ld   MAX SLICES (1..10000)= %ld",
                 info->dimx,info->dimy,info->max_scans);
             sprintf(str1,"#ECHOES (1..2) = %d    PIXEL BITS (1..32) = %ld",
                 info->num_echoes,info->pixel_depth_bits);
             ShowMsgStrs(*frame,0,err,0,4,
              "Bad header parameter values - NOT in the range !!!",
              str,str1,FAILED,NULL,0);}
        }
       else
        {
         file->status &= ~FILE_OPEN_ERROR;
 TRACE(printf("rd_mri dirfn = %s fn = %s suf = %s\n",file->dirfn,file->fn,file->hdr_fn_suffix))

         if (((err = setup_file_attrs(file)) == NO_ERROR) &&
             ((err = setup_default_text_format_fn(file)) == NO_ERROR))
           {TRACE(printf("after build_slice_roi_win_rec\n"))
 TRACE(printf("rd_mri === dirfn = %s fn = %s suf = %s\n",file->dirfn,file->fn,file->hdr_fn_suffix))

            if (is_rd_img) 
               if ((file->img_fid = fopen(img_fn,"r+")) == NULL)
                  {if ((file->img_fid = fopen(img_fn,"r")) == NULL)
                      err = FILE_OPEN_ERROR;
                     else file->status |= FILE_READ;
                  }
                 else file->status |= FILE_READ_WRITE;
            if (err == NO_ERROR) file->status |= FILE_OPEN;}
        }
    }

 c_free(hdr_fn);
 c_free(img_fn);
 TRACE(printf("rd_mri err = %d\n",err))
 return err;

}



/*------------------------------------------------------------------------
get_mri_file - ???
------------------------------------------------------------------------*/

int
get_mri_file( input, dirfn, fn, hdr_fn_suffix, img_fn_suffix, batch,
	      file_indx, reason )
     struct input_rec *input;
     char *dirfn,*fn;         /* directory fn & fn */
     char *hdr_fn_suffix,*img_fn_suffix;
     unsigned char batch,**reason;
     int *file_indx;
{
  struct input_file_rec *file;
  int err;
  unsigned int total_items;

  if ((err = find_mri_file(input,dirfn,fn,hdr_fn_suffix,
			   img_fn_suffix,file_indx)) == NOT_FOUND)
  {
    TRACE(printf("NOT found...\n"));
    total_items = 0;
    if ((err = get_ptr(&file,&total_items,(unsigned int) 1,
		       (size_t) sizeof(*file))) != NO_ERROR)
      return err;

    init_input_file_rec(file,input->prog);
    if ((err = rd_mri_file(file,dirfn,fn,hdr_fn_suffix,img_fn_suffix,1,reason))
	== NO_ERROR)
    {
      if (input->total_files == input->num_files)
      {
	if ((err = get_ptr(&(input->files),
			   &(input->total_files),(unsigned int) 1,
			   (size_t) sizeof(*(input->files)))) != NO_ERROR)
	{
	  free_input_file_rec(file);
	  c_free(file);
	  return err;
	}
      }
      file_def_3d_gravity(file);
      *file_indx = input->num_files;
      input->files[input->num_files] = file;
      input->num_files += 1;
    }
    else
    {
      free_input_file_rec(file);
      c_free(file);
      return err;
    }
    if (batch)
      file->status = FILE_BATCH;
    else
    {
      NewImgBuf(&(file->img),
		&(file->hdr.scans[0]),&err,1,0,0,0,0,0,1);
    }
    TRACE(printf("file_indx = %d   err = %d\n",(int) *file_indx,err));
    return err;
  }
  else
  {
    TRACE(printf("file found...hi there\n"));
    return FILE_ALREADY_OPEN;
  }
}




/*************************************************************************
  PWH 19980420:  The following functions were previously in the nria-lib
  file ndat_v3.c.  They were moved here because they require XView and
  were getting in the way of an attempt to write a non-interactive
  program to read, modify, and write an ndat file (the ROI warper, if
  you must know).
*************************************************************************/


/*------------------------------------------------------------------------
win_rd_breaker_check - ???
------------------------------------------------------------------------*/

void                 /* Was int, but value never checked */
win_rd_breaker_check(dummy1,dummy2,win1)
 void *dummy1,*dummy2;
 struct display_win_rec *win1;
{
 FILE *fid;
 char *dir,*str;
 struct slice_roi_rec slice_roi1;
 int err;
 struct image_display_window *win;

 win = win1->owner;
 dir = get_prog_dir(win->owner->root->prog);
/*
 printf("win_rd_breaker_check dir = %s\n",dir);
*/
 str = NULL;
 if ((err = concat_strs(&str,3,dir,"/","breaker.check")) == NO_ERROR)
    {/* printf("win_rd_breaker_check str = %s\n",str);*/
     if ((fid = fopen(str,"r")) != NULL)
        {init_slice_roi_rec(&slice_roi1);
         /*printf("win_rd_breaker_check 1 slice_roi = %d\n",
                   win->control.sroi.sroi_win->slice_roi.num_rois);*/
         if (((err = v3_rd_slice_roi_rec(fid,&slice_roi1)) == NO_ERROR) &&
             ((err = JoinRois(&(win->control.sroi.sroi_win->slice_roi),
                      &slice_roi1,0,1.0,1.0,NULL,NULL,NULL)) == NO_ERROR))
            win_execute_proc_to_related_wins(win,win_redisplay_all_curves,0,0);
/*
         printf("win_rd_breaker_check 2 slice_roi = %d\n",
                   win->control.sroi.sroi_win->slice_roi.num_rois);
         printf("win_rd_breaker_check err = %d slice_roi1 = %d\n",err,
                   slice_roi1.num_rois);
         pr_slice_roi_rec(&(win->control.sroi.sroi_win->slice_roi));
*/
         free_slice_roi_rec(&slice_roi1);
         fclose(fid);
        }
    }
 c_free(str);
 c_free(dir);
 return;
}





/*------------------------------------------------------------------------
rd_dat_output - ???
------------------------------------------------------------------------*/

int
rd_dat_output(output)
     struct output_file_rec *output;
{
  char *fn;
  int err;

  if (output->fn == NULL)
  {
    TRACE(printf("No output fn supplied...\n"));
    return FILE_NAME_ERROR;
  }
  PRT(printf("rd_dat_output...output->dirfn = %s output->fn = %s output->dat_fn_suffix = %s\n",output->dirfn,output->fn,output->dat_fn_suffix));

  if ((err = get_output_fn(output,&fn)) != NO_ERROR)
    return err;
  PRT(printf("rd_dat_output...1 err = %d\n",err));
  if ((err = rd_dat_file(fn,output)) == NO_ERROR)
  {
    flush_the_text_output(&(output->file->text));
    output->status = FILE_READY;
  }
  c_free(fn);
  PRT(printf("rd_dat_output...end err = %d\n",err));
  return err;
}




/*------------------------------------------------------------------------
setup_output_file - ???
------------------------------------------------------------------------*/

int
setup_output_file(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix)
     struct output_file_rec *output;
     char *dirfn,*fn;         /* directory fn & fn */
     char *dat_fn_suffix,*bin_fn_suffix;
{
  int err;

  if ((err = setup_output_fn(output,dirfn,fn,dat_fn_suffix,bin_fn_suffix))
      != NO_ERROR)
    return err;
  output->status &= ~FILE_TO_BE_SETUP;
  TRACE(printf("setup_output_file.....END\n"));
  err = rd_dat_output(output);
  return err;
}




/*------------------------------------------------------------------------
WrDatOutput - ???
------------------------------------------------------------------------*/

int
WrDatOutput( output, is_quit_file )
     struct output_file_rec *output;
     int is_quit_file;
{
  char *fn,*fn1,*str,*reason;
  int err,err1;
  Frame *frame;
  int result;
  static char *discard = "DISCARD EDIT AND IGNORE SAVE THEN !";

  PRT(printf("WrDatOutput...status = %x is_quit_file = %d\n",
	      (int) output->status,is_quit_file));
  fn = fn1 = NULL;
  if (((err = get_output_fn(output,&fn)) == NO_ERROR) &&
      ((fn1 = UniqueFn("",fn,".temp")) != NULL))
  {
    if ((err = file_access(fn,2,NULL,&reason)) != NO_ERROR)
      str = "Error writing to the .ndat file !!!";
    else if ((err = file_access(fn1,2,NULL,&reason)) != NO_ERROR)
      str = "Error writing to the temp .ndat file !!!";

    err1 = err;

    if (err != NO_ERROR)
    {
      if ((is_quit_file != 2) &&
	  (frame = (Frame *) main_display(2,NULL,0,0)) && (*frame != 0))
      {
	if (is_quit_file)
	{
	  result = notice_prompt(*frame,(Event *) NULL,
				 NOTICE_MESSAGE_STRINGS,str,reason,0,
				 NOTICE_BUTTON_YES,OPERATION_ABORTED,
				 NOTICE_BUTTON_NO,discard,0);
	  if (result == NOTICE_NO)
	    err = NO_ERROR;
	}
	else
	{
	  notice_prompt(*frame,(Event *) NULL,
                        NOTICE_MESSAGE_STRINGS,str,reason,0,
                        NOTICE_BUTTON_YES,OPERATION_ABORTED,
                        0);
	}
      }
      c_free(reason);
    }

    if ((err == NO_ERROR) && (err1 == NO_ERROR))
    {
      if ((err = wr_dat_file(fn1,output)) == NO_ERROR)
      {
	if (rename(fn1,fn) != 0)
	{
	  err = FILE_ACCESS_ERROR;
	  if ((is_quit_file != 2) &&
	      (frame = (Frame *) main_display(2,NULL,0,0)) && (*frame != 0))
	  {
	    concat_strs(&str,2,"Temp file = ",fn);
	    result = notice_prompt(*frame,(Event *) NULL,
				   NOTICE_MESSAGE_STRINGS,
				   "Error : was able to save to a temp file",
				   str,"but failed to rename it to",fn,
				   "You may rename it yourself later...",0,
				   NOTICE_BUTTON_YES,"DELETE TEMP FILE !",
				   NOTICE_BUTTON_NO,"WILL RENAME LATER !",
				   0);
	    if (result == NOTICE_YES)
	      delete_file(fn1);
	  }
	}
      }
      else
      {
	delete_file(fn1);
	if ((is_quit_file != 2) &&
	    (frame = (Frame *) main_display(2,NULL,0,0)) && (*frame != 0))
	{
	  if (is_quit_file)
	  {
	    result =
	      notice_prompt(*frame,(Event *) NULL,
			    NOTICE_MESSAGE_STRINGS,
			    "Write Error : unable to save to the .ndat file =",
			    fn,0,
			    NOTICE_BUTTON_YES,OPERATION_ABORTED,
			    NOTICE_BUTTON_NO,discard,0);
	    if (result == NOTICE_NO)
	      err = NO_ERROR;
	  }
	  else
	    notice_prompt(*frame,(Event *) NULL,
			  NOTICE_MESSAGE_STRINGS,
			  "Write Error : unable to save to the .ndat file =",
			  fn,0,
			  NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
	}
      }
    }
  }
  else
  {
    TRACE(printf("No output fn supplied...\n"));
    if (err == NO_ERROR)
      err = CANCEL;
    if ((is_quit_file != 2) &&
	(frame = (Frame *) main_display(2,NULL,0,0)) && (*frame != 0))
    {
      result =
	notice_prompt(*frame,(Event *) NULL,
		      NOTICE_MESSAGE_STRINGS,
		      "Error : Unable to construct the output file name !!!",
		      "Memory error !!!",
		      0,
		      NOTICE_BUTTON_YES,OPERATION_ABORTED,
		      NOTICE_BUTTON_NO,discard,
		      0);
      if (result == NOTICE_NO)
	err = NO_ERROR;
    }
  }

  c_free(fn);
  c_free(fn1);
  TRACE(printf("WrDatOutput...end err = %d\n",err));

  return err;
}




/*------------------------------------------------------------------------
AutoSaveDatOutput - ???

If .ndat file needs to be saved, then by golly, save it.
------------------------------------------------------------------------*/

int
AutoSaveDatOutput( output, is_quit_file )
     struct output_file_rec *output;
     int is_quit_file;
{
  int err;

  if (!((output->status & FILE_TO_BE_SAVED)
	&& (output->status & FILE_CHANGED)))
    check_file_save(output);

  TRACE(printf("AutoSaveDatOutput status = %x\n",
	       (unsigned long) output->status));

  if ((output->status & FILE_TO_BE_SAVED)
      || (output->status & FILE_CHANGED))
  {
    if ((err = WrDatOutput( output, is_quit_file )) == NO_ERROR)
    {
      flush_output_save_status(output);         
    }
    TRACE(printf("AutoSaveDatOutput....end...err = %d\n",err));
    return err;
  }

  return NO_ERROR;
}





/*------------------------------------------------------------------------
save_pixel_types_1 - ???
------------------------------------------------------------------------*/

int
save_pixel_types_1(file)
     struct input_file_rec *file;
{
  int err;
  char *err_reason;
  Frame *frame;

  if (!(file->pixel_type.status & PIXEL_TYPE_PIXMAP_HDR_VALID))
    err = wr_file_pixmap( file->output.dirfn,
			  file->output.fn,
			  PIXMAP_SUFFIX,
			  &(file->pixel_type),
			  &err_reason );
  else
    err = append_wr_file_pixmap( file->output.dirfn,
				 file->output.fn,
				 PIXMAP_SUFFIX,
				 &(file->pixel_type),
				 file->hdr.data_info.dimx,
				 file->hdr.data_info.dimy,
				 &err_reason );
  if (err != NO_ERROR)
  {
    frame = (Frame *) main_display(2,NULL,0,0);
    if (*frame != 0)
      if (err_reason != NULL)
	notice_prompt(*frame,(Event *) NULL,NOTICE_MESSAGE_STRINGS,
		      "Error saving the pixmap file !!!",err_reason,0,
		      NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
      else
	notice_prompt(*frame,(Event *) NULL,NOTICE_MESSAGE_STRINGS,
		      "Error saving the pixmap file !!!",0,
		      NOTICE_BUTTON_YES,OPERATION_ABORTED,0);
    c_free(err_reason);
  }
  else
    file->status &= ~FILE_SAVE_PIXEL_TYPE;
  return err;
}





/*------------------------------------------------------------------------
save_pixel_types - ???
------------------------------------------------------------------------*/

int
save_pixel_types( file, frame, is_dp_msg )
     struct input_file_rec *file;
     Frame frame;
     int is_dp_msg;
{
  unsigned long lcv;
  Frame *the_frame,win_frame;
  
  if (!(file->status & FILE_SAVE_PIXEL_TYPE))
    return NO_ERROR;
  if ((file->pixel_type.order.num_strs == 0) || 
      (file->pixel_type.num_slice_maps == 0))
    return NO_ERROR;

  for (lcv = 0; lcv < file->pixel_type.num_slice_maps; lcv++)
    if ((file->pixel_type.slice_maps[lcv]->status4 & BUF_NON_EMPTY) &&
        (file->pixel_type.slice_maps[lcv]->status4 & BUF_DATA_VALID))
      break;
  if (lcv == file->pixel_type.num_slice_maps)
    return NO_ERROR;
  if (is_dp_msg)
  {
    if (frame == 0)
    {
      the_frame = (Frame *) main_display(2,NULL,0,0);
      win_frame = *the_frame;
    }
    else
      win_frame = frame;
    if (win_frame != 0)
    {
      ShowMsgStrs(win_frame,1,NO_ERROR,0,2,
		  "1) Saving the pixmap file...",
		  PLEASE_WAIT,save_pixel_types_1,1,file);
      return NO_ERROR;
    }
    else
      return CANCEL;
  }
  else
    return save_pixel_types_1(file);
}




/**********************************************************************
  PWH 19980430: The following functions were previously in the file
  input_file_rec.c.  They were moved here because they require seem to
  involve the NRIA user interface and were getting in the way of an
  attempt to write a non-interactive program to read, modify, and
  write an ndat file (the ROI warper, if you must know).
*************************************************************************/


/*------------------------------------------------------------------------
FileDeleteMarkRoi - ???
------------------------------------------------------------------------*/

int
FileDeleteMarkRoi(file)
 struct input_file_rec *file;
{
 unsigned long lcv;
 struct slice_roi_rec *slice_roi;
 int is_some_deleted;

 PRT(printf("close_and_delete_file FileDeleteMarkRoi\n"))
 for (lcv = 0; lcv < file->hdr.num_scans; lcv++)
    {slice_roi = &(file->hdr.scans[lcv].slice->slice_roi_win->slice_roi);
     PRT(printf("%d) slice_roi->status = %x\n",lcv,(unsigned long) slice_roi->status))
     delete_roi_marked_delete(slice_roi,&is_some_deleted);
    }
 return NO_ERROR;
}




/*------------------------------------------------------------------------
close_and_delete_file - ???
------------------------------------------------------------------------*/

int
close_and_delete_file(file,must_close)
     struct input_file_rec *file;
     int must_close;
{
  struct input_rec *input;
  int err;

  PRT(printf("close_and_delete_file...file = %u must_close = %d\n",
	      file,must_close));
  input = &(file->prog->input);
  FileDeleteMarkRoi(file);
  if (must_close == 2)
  {
    AutoSaveDatOutput(&(file->output),2);

    if (file->status & FILE_SAVE_PIXEL_TYPE)
      save_pixel_types(file,NULL,0);
  }
  else
  {
    PRT(printf("close_and_delete_file...AutoSaveDatOutput\n"));
    if ((err = AutoSaveDatOutput(&(file->output),1)) != NO_ERROR)
      if (!must_close)
	return err;
    PRT(printf("close_and_delete_file...FILE_SAVE_PIXEL_TYPE\n"));
    if (file->status & FILE_SAVE_PIXEL_TYPE)
      if ((err = save_pixel_types(file,NULL,0)) != NO_ERROR)
	if (!must_close)
	  return err;
  }
  PRT(printf("close_and_delete_file...files = %u file = %u total = %d num_files = %d\n",
	      input->files,file,input->total_files,input->num_files));


  PRT(for (cnt = lcv = 0; lcv < input->num_files; lcv++)
       {
	 printf("%u ",input->files[lcv]);
	 if (((cnt + 1) % 10) == 0)
	 {
	   cnt = 0;
	   printf("\n");
	 }
	 else
	   cnt += 1;
       }
       );
  PRT(printf("\n"));
  free_input_file_rec(file);
  PRT(printf("close_and_delete_file...file = %u\n",file));

  c_free(file);

  DropPtrFromHandleAry(input->files,&(input->num_files),file);
  PRT(printf("close_and_delete_file.end.files = %u total = %d num_files = %d\n",
	      input->files,input->total_files,input->num_files));

  return NO_ERROR;
}




/*------------------------------------------------------------------------
close_all_files - ???
------------------------------------------------------------------------*/

int
close_all_files(input,must_close)
     struct input_rec *input;
     int must_close;
{
  int err;

  PRT(printf("\n	close_all_files input->total_files=%d num_files=%d\n",
	      input->total_files,input->num_files));
  PRT(for (lcv = 0; lcv < input->num_files; lcv++)
       {
	 printf("%d) %u\n",lcv,input->files[lcv]);
       }
       );

  while (input->num_files > 0)
  {
    err = close_and_delete_file(input->files[0],must_close);
    if (err != NO_ERROR)
    {
      if (!must_close)
	return err;
    }
  };

  PRT(printf("close_all_files input->total_files = %d...end\n",
	      input->total_files));
  return NO_ERROR;
}
