/****************************************************************************
screen_overlay.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: screen_overlay.c,v 1.12 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>

#include "mri_format.h"
#include "common.h"
#include "nria_procedures.h"

/*
#define PRT9(x)
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);

#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT1(x)
#define PRT2(x)
#define PRT6(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)
#define PRT11(x)



/* Functions defined in this file */
void init_screen_data_overlay_rec(struct screen_data_overlay_rec *over);
void free_screen_data_overlay_rec(struct screen_data_overlay_rec *over,
    struct image_display_window *win);
struct list_rec *WinFindOverlayItem(struct image_display_window *win,
    struct img_buf_rec *img, int color_data_type4);
int win_get_empty_overlay_list(struct image_display_window *win,
    struct list_rec **empty);
int FilterOverlayData(struct color_data_rec *color_data,
    struct buf_2d_rec *_2d);
int WinImgRegisteredBuf(struct image_display_window *win,
    struct color_data_rec *over_color, struct color_data_rec *regcolor_data,
    struct img_buf_rec *regimg, struct buf_2d_rec *the_2d,
    struct buf_2d_rec **_2d);
int WinAddOverlayItem_1(struct image_display_window *win,
    struct image_display_window *imgwin, struct color_data_rec *color_data,
    struct img_buf_rec *img, int is_compute_overlay);
int WinAddOverlayItem(struct image_display_window *win,
    struct image_display_window *imgwin, struct img_buf_rec *img,
    int is_compute_overlay);
int WinDeleteOverlayObject(struct image_display_window *win,
    struct list_rec *obj, int is_delete_img);
int win_delete_overlay_list(struct image_display_window *win,
    int is_delete_img);
int WinOverlayBuf(struct image_display_window *win, struct buf_2d_rec *result,
    struct buf_2d_rec *mask, struct int_bound_rec *bound,
    struct buf_2d_rec *overlayedby_2d, unsigned long *map_2d_indxs,
    unsigned long num_map_2d_indxs, struct color_scale_rec *scale,
    struct color_rec *color);
int win_compute_overlay(struct image_display_window *win, int is_dp_canvas);
int WinMultiEchoComputeOverlay(struct image_display_window *win,
    int is_dp_canvas, int is_processed_draw_list);
int pr_wid(struct image_display_window *win);
int win_overlayed_by_win(struct image_display_window *win,
    struct image_display_window *win1, struct img_buf_rec *img, long select);
int win_overlayed_by_win_stack_it(struct image_display_window *win,
    struct image_display_window *win1, struct hdr_scan_entry_rec **cur_slice,
    long select);
int win_overlayed_by_win_stack(struct image_display_window *win,
    struct image_display_window *win1, struct img_buf_rec *img, long select);
int win_overlayed_by_wid(struct image_display_window *win, char *wid,
    long select);
int WinDeleteOverlay(struct image_display_window *win);
int WinSetOverlayStatus(struct screen_data_overlay_rec *over,
    struct image_display_window *win, void *dummy1, void *dummy2,
    void *dummy3, void *dummy4, void *dummy5, struct list_rec *win_list);
int WinShowHideOverlay(struct image_display_window *win);



/*--------------------------------------------------------------------------
init_screen_data_overlay_rec - ???
---------------------------------------------------------------------------*/

void
init_screen_data_overlay_rec(over)
 struct screen_data_overlay_rec *over;
{
 over->file = NULL;
 over->img = NULL;
 over->host_slice = NULL;
 over->guest_slice = NULL;
 init_buf_2d_rec(&(over->mask));
 init_color_data_rec(&(over->color_data));
 PRT8(printf("init_screen_data_overlay_rec...color_data.status4 = %x\n",
        over->color_data.status4))
}


/*--------------------------------------------------------------------------
free_screen_data_overlay_rec - ???
---------------------------------------------------------------------------*/

void
free_screen_data_overlay_rec(over,win)
 struct screen_data_overlay_rec *over;
 struct image_display_window *win;
{
 PRT8(printf("free_screen_data_overlay_rec...\n"))
 free_buf_2d_rec(&(over->mask));
 if ((over->color_data.status4 & COLOR_DATA_ID_VALID) &&
     (win != NULL))
    {
     PRT8(printf("free_screen_data_overlay_rec...COLOR_DATA_ID_VALID\n"))
     WinDropColorDataRec1(win,over->color_data.gid,0,
              over->color_data.member_id,&(over->color_data),0);
     PRT8(printf("free_screen_data_overlay_rec...after WinDropColorDataRec1\n"))
    }

 free_color_data_rec(&(over->color_data));
 init_screen_data_overlay_rec(over);
}


/*--------------------------------------------------------------------------
WinFindOverlayItem - ???
---------------------------------------------------------------------------*/

struct list_rec *
WinFindOverlayItem(win,img,color_data_type4)
 struct image_display_window *win;
 struct img_buf_rec *img;
{
 struct screen_data_overlay_rec *over;
 struct list_rec *next,*cur;

 cur = next = &(win->overlay);
 do
    {
     if ((over = (struct screen_data_overlay_rec *) next->item) != NULL)
        if ((over->img == img) &&
            ((over->color_data.status4 & COLOR_DATA_POS_NEG_ACTIVATION) ==
               color_data_type4))
           return next;
     next = next->next;
    }
 while (cur != next);
 return NULL;
}


/*--------------------------------------------------------------------------
win_get_empty_overlay_list - ???
---------------------------------------------------------------------------*/

int
win_get_empty_overlay_list(win,empty)
 struct image_display_window *win;
 struct list_rec **empty;
{
 struct screen_data_overlay_rec *over;
 struct list_rec *next,*cur;
 int err;

 PRT(printf("win_get_empty_overlay_list...\n"))
 cur = next = &(win->overlay);
 do
    {
     if ((over = (struct screen_data_overlay_rec *) next->item) == NULL)
        {*empty = next;
          PRT(printf("win_get_empty_overlay_list...NO_ERROR\n"))
         return NO_ERROR;}
     next = next->next;
    }
 while (cur != next);
 if ((err = get_ptr(&next,NULL,1,sizeof(*next))) != NO_ERROR)
    return err;
 setup_list_rec(next,NULL,NULL,NULL,NULL,NULL);
 add_item_after_cur_list(cur->before,next);
 *empty = next;
 PRT(printf("win_get_empty_overlay_list...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
FilterOverlayData - ???
---------------------------------------------------------------------------*/

int
FilterOverlayData(color_data,_2d)
 struct color_data_rec *color_data;
 struct buf_2d_rec *_2d;
{
 double max4;

 PRT(printf("FilterOverlayData...1\n"))
 if (!(color_data->status4 & COLOR_DATA_POS_NEG_ACTIVATION)) return NO_ERROR;
 PRT(MinMax2dValues(_2d,0,(double) .0,(double) .0,&min4,&max4);
     printf("FilterOverlayData min4 = %f max4 = %f\n",min4,max4))

 if (color_data->status4 & COLOR_DATA_POS_ACTIVATION)
    {PRT(printf("FilterOverlayData...COLOR_DATA_POS_ACTIVATION\n"))
     SelectAssign2d(_2d,_2d,0x00000402,
        (double) .0,(double) .0,(double) .0,(double) .0,
        NULL,0,0);
     if (_2d->status4 & BUF_MIN_MAX_SET)
        {if (_2d->minval_set < .0) _2d->minval_set = 0;
         if (_2d->maxval_set < .0) _2d->maxval_set = 0;}
    }
   else
    {PRT(printf("FilterOverlayData...COLOR_DATA_NEG_ACTIVATION\n"))
     SelectAssign2d(_2d,_2d,0x00002401,
        (double) .0,(double) .0,(double) .0,(double) .0,
        NULL,0,0);
     if (_2d->status4 & BUF_MIN_MAX_SET)
        {max4 = _2d->maxval_set;
         if (_2d->minval_set < .0) _2d->maxval_set = -_2d->minval_set;
           else  _2d->maxval_set = 0;
         if (max4 < .0) _2d->minval_set = -max4;
           else _2d->minval_set = 0;
        }
    }
 PRT(MinMax2dValues(_2d,0,(double) .0,(double) .0,&min4,&max4);
     printf("FilterOverlayData after min4 = %f max4 = %f\n",min4,max4))
 PRT(printf("FilterOverlayData...set min = %f  max = %f end\n",
        _2d->minval_set,_2d->maxval_set))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
WinImgRegisteredBuf - ???
---------------------------------------------------------------------------*/

int
WinImgRegisteredBuf(win,over_color,regcolor_data,regimg,the_2d,_2d)
 struct image_display_window *win;
 struct color_data_rec *over_color,*regcolor_data;
 struct img_buf_rec *regimg;
 struct buf_2d_rec *the_2d,**_2d;
{
 struct img_buf_rec *img;
 struct matrix_2d_rec *to_src,mat,mat1;
 struct unit_2d_rec unit;
 struct buf_2d_rec _2d1,_2d2,*ptr;
 struct data_info_rec *info;
 struct file_register_rec fco1;
 struct color_data_rec *color_data;
 int err;

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((color_data = WinCurColorData(win)) == NULL))
   return CANCEL;
 init_buf_2d_rec(&_2d1);
 info = &(regimg->file->hdr.data_info);
 PRT9(printf("WinImgRegisteredBuf...wid = %s status4 = %x\n",
         win->owner->wid,(unsigned long) img->status4))
 PRT9(printf("WinImgRegisteredBuf img->file = %u  regimg->file = %u\n",
                img->file,regimg->file))
 PRT9(printf("regimg = %u ...snum = %d enum = %d scnum = %d\n",regimg,
      regimg->cur_slice->slice_num,regimg->cur_slice->echo_num,regimg->cur_slice->scan_num))
 if (img->file == regimg->file)
    {if (!(img->unit.status2 & UNIT_2D_IN_USE))
        {if ((regcolor_data != NULL) && !(regimg->unit.status2 & UNIT_2D_IN_USE))
            {PRT9(printf("WinImgRegisteredBuf...same file no trans..00\n"))
             *_2d = &(regcolor_data->_2d);
             return NO_ERROR;}
           else
            {PRT9(printf("WinImgRegisteredBuf...same file src trans...01\n"))
             if ((regcolor_data == NULL) && 
                 !(regimg->unit.status2 & UNIT_2D_IN_USE))
                ptr = the_2d;
               else ptr = &_2d1;
             if (((err = SetupBuf2dRec(ptr,info->dimx,info->dimy,
                         info->pixel_depth_bits,
                         InputDataTypeToBufType(info))) != NO_ERROR) ||
                 ((err = RdSliceData(regimg,regimg->cur_slice,0,ptr,0)) != NO_ERROR) ||
                 ((err = FilterOverlayData(over_color,ptr)) != NO_ERROR))
                {if (ptr == &_2d1) free_buf_2d_rec(&_2d1);
                 PRT9(printf("WinImgRegisteredBuf 01 err = %d\n",err))
                 return err;}
             if (ptr == the_2d)
                {PRT9(printf("WinImgRegisteredBuf ptr == the_2d...\n"))
                 if ((err = Scale2dPixels(the_2d,the_2d,
                       (double) over_color->scale.first,
                       (double) (over_color->scale.first + 
                                 over_color->scale.num_colors - 1),
                        0,(double) .0,(double) .0,0)) != NO_ERROR)
                    return err;
                 *_2d = the_2d;
                 return NO_ERROR;}
             PRT9(printf("WinImgRegisteredBuf ptoceed...\n"))
             setup_unit_2d_rec(&unit,regimg->unit.ustartx,regimg->unit.ustarty,
               regimg->unit.unitx,regimg->unit.unity,
               regimg->unit.dimx,regimg->unit.dimy,
               regimg->unit.local_ustartx,regimg->unit.local_ustarty,
               regimg->unit.local_unitx,regimg->unit.local_unity);
             mult_2d_matrix(&mat,&(regimg->unit.tolocal_mat),&(unit.localto_mat));
             to_src = &mat;
/*
             to_src = &(regimg->unit.tolocal_mat);
*/
             err = NO_ERROR;
            }
        }
       else 
        {
         PRT9(printf("WinImgRegisteredBuf...same file dst trans\n"))
         if ((info->var_use_status & POS_NEG_ACTIVATION) && (info->num_echoes == 2))
            {PRT9(printf("WinImgRegisteredBuf...same file act\n"))
             if ((err = RdImgPosNegEchoes(regimg,0,&_2d1,0)) != NO_ERROR)
                {free_buf_2d_rec(&_2d1);
                 return err;}
               else ptr = &_2d1;
            }
           else if (!(regimg->unit.status2 & UNIT_2D_IN_USE))
            {PRT9(printf("WinImgRegisteredBuf...same file dst trans src no\n"))
             ptr = &(regimg->_2d);
            }
           else 
            {PRT9(printf("WinImgRegisteredBuf...same file dst & src trans \n"))
             if (((err = SetupBuf2dRec(&_2d1,info->dimx,info->dimy,
                         info->pixel_depth_bits,
                         InputDataTypeToBufType(info))) != NO_ERROR) ||
              
                 ((err = RdSliceData(regimg,regimg->cur_slice,0,&_2d1,0)) != NO_ERROR) ||
                 ((err = FilterOverlayData(over_color,&_2d1)) != NO_ERROR))
                {free_buf_2d_rec(&_2d1);
                 return err;}
             ptr = &_2d1;}
         if (!(regimg->unit.status2 & UNIT_2D_IN_USE))
            {PRT9(printf("WinImgRegisteredBuf...10\n"))
             identity_2d_matrix(&mat);}
           else
            {PRT9(printf("WinImgRegisteredBuf...11\n"))
             setup_unit_2d_rec(&unit,regimg->unit.ustartx,regimg->unit.ustarty,
               regimg->unit.unitx,regimg->unit.unity,
               regimg->unit.dimx,regimg->unit.dimy,
               regimg->unit.local_ustartx,regimg->unit.local_ustarty,
               regimg->unit.local_unitx,regimg->unit.local_unity);
             mult_2d_matrix(&mat,&(regimg->unit.tolocal_mat),&(unit.localto_mat));
/*
             mult_2d_matrix(&mat,&(unit.tolocal_mat),&(regimg->unit.tolocal_mat));
*/
             }
         setup_unit_2d_rec(&unit,img->unit.ustartx,img->unit.ustarty,
               img->unit.unitx,img->unit.unity,img->unit.dimx,img->unit.dimy,
               img->unit.local_ustartx,img->unit.local_ustarty,
               img->unit.local_unitx,img->unit.local_unity);
         mult_2d_matrix(&mat1,&(img->unit.tolocal_mat),&(unit.localto_mat));
         mult_2d_matrix(&mat,&mat,&mat1);
         to_src = &mat;
        }
    }
  else
   {PRT9(printf("WinImgRegisteredBuf...not same file\n"))
    if ((regcolor_data != NULL) && 
        !(img->unit.status2 & UNIT_2D_IN_USE) &&
        !(regimg->unit.status2 & UNIT_2D_IN_USE) &&
        (img->_2d.dimx == regimg->_2d.dimx) && 
        (img->_2d.dimy == regimg->_2d.dimy))
       {PRT9(printf("DONE ...not same file no trans & same dim  1 00\n"))
        *_2d = &(regcolor_data->_2d);
        return NO_ERROR;
       }

    if ((err = SetupImgRegParams(img,regimg,0,&fco1,NULL)) != NO_ERROR)
       {PRT9(printf("WinImgRegisteredBuf...no paramter\n"))
        if ((err = SetupImgRegParams(img,regimg,0,&fco1,NULL)) != NO_ERROR)
           return err;
       }
    if ((info->var_use_status & POS_NEG_ACTIVATION) && (info->num_echoes == 2))
       {PRT9(printf("WinImgRegisteredBuf...act\n"))
        if ((err = RdImgPosNegEchoes(regimg,0,&_2d1,0)) != NO_ERROR)
           {free_buf_2d_rec(&_2d1);
            return err;}
       }
      else
       {PRT9(printf("WinImgRegisteredBuf..._2d1\n"))
        if (((err = SetupBuf2dRec(&_2d1,info->dimx,info->dimy,
                         info->pixel_depth_bits,
                         InputDataTypeToBufType(info))) != NO_ERROR) ||
            ((err = RdSliceData(regimg,regimg->cur_slice,0,&_2d1,0)) != NO_ERROR) ||
            ((err = FilterOverlayData(over_color,&_2d1)) != NO_ERROR))
           {PRT9(printf("WinImgRegisteredBuf.error .._2d1\n"))
            PRT9(pr_buf_2d_rec(&_2d1);)
            free_buf_2d_rec(&_2d1);
            return err;}
        PRT2(pr_buf_2d_rec(&_2d1);)
        PRT9(printf("regimg->_2d.pixel_depth = %d..._2d1.pixel_depth = %d\n",
                      regimg->_2d.pixel_depth,_2d1.pixel_depth))
       }
    ptr = &_2d1;
    if (!(regimg->unit.status2 & UNIT_2D_IN_USE))
       {PRT9(printf("...regimg 0...\n"))
        matrix_3d_to_2d(&mat,&(fco1.co.coreg.planetoxyz));
        matrix_3d_to_2d(&mat1,&(fco1.co.reg.xyztoplane));
        mult_2d_matrix(&mat,&mat,&mat1);
       }
      else
       {PRT9(printf("...regimg 1...=====localto_mat & tolocal_mat\n"))
        PRT9(pr_2d_matrix(&(regimg->unit.localto_mat)))
        PRT9(pr_2d_matrix(&(regimg->unit.tolocal_mat)))
        matrix_3d_to_2d(&mat,&(fco1.co.coreg.planetoxyz));
        matrix_3d_to_2d(&mat1,&(fco1.co.reg.xyztoplane));
        mult_2d_matrix(&mat,&mat,&mat1);

        setup_unit_2d_rec(&unit,regimg->unit.ustartx,regimg->unit.ustarty,
          regimg->unit.unitx,regimg->unit.unity,regimg->unit.dimx,regimg->unit.dimy,
          regimg->unit.local_ustartx,regimg->unit.local_ustarty,
          regimg->unit.local_unitx,regimg->unit.local_unity);
        mult_2d_matrix(&mat,&(unit.localto_mat),&mat);
        mult_2d_matrix(&mat,&(regimg->unit.tolocal_mat),&mat);
       }
    if (img->unit.status2 & UNIT_2D_IN_USE)
       {PRT9(printf("...img 1...\n"))
        setup_unit_2d_rec(&unit,img->unit.ustartx,img->unit.ustarty,
               img->unit.unitx,img->unit.unity,img->unit.dimx,img->unit.dimy,
               img->unit.local_ustartx,img->unit.local_ustarty,
               img->unit.local_unitx,img->unit.local_unity);
        mult_2d_matrix(&mat1,&(img->unit.tolocal_mat),&(unit.localto_mat));
        mult_2d_matrix(&mat,&mat,&mat1);
       }
      else
       {PRT9(printf("...img 0...\n"))}
     to_src = &mat;
    PRT(printf("WinImgRegisteredBuf...xyztoplane planetoxyz\n"))
    PRT(pr_3d_matrix(&(fco1.co.reg.xyztoplane)))
    PRT(pr_3d_matrix(&(fco1.co.reg.planetoxyz)))
    PRT(printf("WinImgRegisteredBuf...coreg. xyztoplane planetoxyz\n"))
    PRT(pr_3d_matrix(&(fco1.co.coreg.xyztoplane)))
    PRT(pr_3d_matrix(&(fco1.co.coreg.planetoxyz)))
   }

 PRT9(printf("WinImgRegisteredBuf...to_src\n"))
 PRT(pr_2d_matrix(to_src))
 init_buf_2d_rec(&_2d2);
 if (((err = ResizeBuf2dRec(&_2d2,ptr,img->_2d.dimx,img->_2d.dimy,to_src)) == NO_ERROR) &&
     ((err = SetupBuf2dRec(the_2d,img->_2d.dimx,img->_2d.dimy,
                 color_data->_2d.pixel_depth,
                 color_data->_2d.status4 & BUF_VALUE_TYPE)) == NO_ERROR))
    {
     PRT9(printf("_2d2 & the_2d...first = %d num_colors = %d\n",
                 over_color->scale.first,over_color->scale.num_colors))
     PRT2(pr_buf_2d_rec(&_2d2))
     PRT2(pr_buf_2d_rec(the_2d))
     if ((info->var_use_status & POS_NEG_ACTIVATION) && (info->num_echoes == 2))
        {PRT2(printf("WinImgRegisteredBuf...ExtractImgPosOrNegEcho\n"))
         ExtractImgPosOrNegEcho(regimg,&_2d2,NULL);}
     if ((err = Scale2dPixels(the_2d,&_2d2,
           (double) over_color->scale.first,
           (double) (over_color->scale.first + over_color->scale.num_colors - 1),
                       0,(double) .0,(double) .0,0)) == NO_ERROR)
        *_2d = the_2d;
    }
 free_buf_2d_rec(&_2d1);
 free_buf_2d_rec(&_2d2);
 PRT9(printf("WinImgRegisteredBuf...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
WinAddOverlayItem_1 - ???
---------------------------------------------------------------------------*/

int
WinAddOverlayItem_1(win,imgwin,color_data,img,is_compute_overlay)
 struct image_display_window *win,*imgwin;
 struct color_data_rec *color_data;
 struct img_buf_rec *img;
 int is_compute_overlay;
{
 struct img_buf_rec *cur_img,*img1;
 struct screen_data_overlay_rec *over;
 struct color_data_rec *color_data1;
 struct list_rec *cur;
 int err;
 struct buf_2d_rec the_2d,*_2d;
 struct color_scale_rec *scale,*scale1;
 unsigned long *color_indxs,num_color_indxs;

 PRT9(printf("WinAddOverlayItem_1...wid = %s imgwid = %s img = %u\n",
            win->owner->wid,imgwin->owner->wid,img))
 if ((cur_img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((img1 = win_rec_cur_img_buf(imgwin->owner)) == NULL) return CANCEL;

 if ((scale1 = win_cur_scale(win)) == NULL) return CANCEL;
 if ((cur = WinFindOverlayItem(win,img,
                color_data->status4 & COLOR_DATA_POS_NEG_ACTIVATION)) == NULL)
    {
     if (((err = win_get_empty_overlay_list(win,&cur)) != NO_ERROR) ||
         ((err = get_ptr(&over,NULL,1,sizeof(*over))) != NO_ERROR))
        return err;
     init_screen_data_overlay_rec(over);
     over->img = img;
     PRT9(printf("WinAddOverlayItem_1...new screen_data_overlay_rec\n"))
     cur->item = over;
    }
   else
    {over = cur->item;
     PRT9(printf("***...found status4 = %d\n",
                over->color_data.status4))
    }
 over->file = img->file;
 over->host_slice = cur_img->cur_slice;
 over->guest_slice = img->cur_slice;
 PRT2(printf("WinAddOverlayItem_1...4\n"))
 err = NO_ERROR;
 if (((err = WinCurScaleAndColorIndxs(imgwin,color_data,&scale,
         &color_indxs,&num_color_indxs)) == NO_ERROR) &&
     ((err = SetupLocalScale(&(over->color_data),scale,
             color_indxs,num_color_indxs)) == NO_ERROR))
    {
     PRT2(printf("WinAddOverlayItem_1...num_color_indxs = %d\n",
               over->color_data.num_color_indxs))
     if (is_compute_overlay)
        {over->color_data.status4 |= color_data->status4 & 
                           COLOR_DATA_POS_NEG_ACTIVATION;
         PRT2(printf("color_data.status4 = %x......first = %d\n",
                   over->color_data.status4,over->color_data.scale.first))
         PRT11(printf("****img1 = %u img = %u slice_num = %d sc# = %d e# =%d\n",
                 img1,img,img->cur_slice->slice_num,
                  img->cur_slice->scan_num,img->cur_slice->echo_num))
         init_buf_2d_rec(&the_2d);
         if (img1 != img) color_data1 = NULL;
           else color_data1 = color_data;
         if (((err = WinImgRegisteredBuf(win,&(over->color_data),color_data1,
                         img,&the_2d,&_2d)) == NO_ERROR) &&
             ((err = WinOverlayBuf(win,&(over->color_data._2d),
                 NULL,NULL,_2d,
                 over->color_data.color_indxs,over->color_data.num_color_indxs,
                 &(over->color_data.scale),&(imgwin->intensity->color))) == NO_ERROR) &&
             ((err = WinAddColorDataRec(win,&(over->color_data),1)) == NO_ERROR))
            {if (!(scale1->status & COLOR_LOCAL))
                over->color_data.num_color_indxs = 0;
             over->color_data.status4 |= COLOR_DATA_DONT_DELETE;}
         free_buf_2d_rec(&the_2d);
         if (err != NO_ERROR) return err;
        }
       else over->status |= OVERLAY_MUST_COMPUTE;
    }
 if (err != NO_ERROR) 
    WinDeleteOverlayObject(win,cur,0);
 PRT9(printf("WinAddOverlayItem_1...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
WinAddOverlayItem - ???
---------------------------------------------------------------------------*/

int
WinAddOverlayItem(win,imgwin,img,is_compute_overlay)
 struct image_display_window *win,*imgwin;
 struct img_buf_rec *img;
 int is_compute_overlay;
{
 unsigned long lcv;
 struct color_data_rec *color_data;
 struct img_buf_rec *img1;
 int err,is_create;

 PRT9(printf("WinAddOverlayItem...wid = %s imgwid = %s img = %u\n",
            win->owner->wid,imgwin->owner->wid,img))
 err = NO_ERROR;
 for (is_create = 0,lcv = 0; lcv < imgwin->data.num_color_datas; lcv++)
    {color_data = imgwin->data.color_datas[lcv];
     if ((color_data->status4 & COLOR_DATA_DEFAULT_AND_ID_VALID)
             == COLOR_DATA_DEFAULT_AND_ID_VALID)
        {PRT9(printf("%d) id = %d status = %x\n",lcv,color_data->id,color_data->status4))
         PRT9(pr_color_scale_rec(&(color_data->scale)))
         if (is_create)
            {if ((img1 = NewImgBuf(&(img->file->img),img->cur_slice,
                      &err,0,0,0,0,0,0,0)) == NULL)
                return err;}
           else img1 = img;
         PRT11(printf("WinAddOverlayIte...img1 = %u   img = %u\n",img1,img))
         if ((err = WinAddOverlayItem_1(win,imgwin,color_data,img1,
                           is_compute_overlay)) != NO_ERROR)
            {if (is_create) delete_img(img1);
             return err;}
           else is_create = 1;
        }
    }
 PRT9(printf("WinAddOverlayIte...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
WinDeleteOverlayObject - ???
---------------------------------------------------------------------------*/

int
WinDeleteOverlayObject(win,obj,is_delete_img)
 struct image_display_window *win;
 struct list_rec *obj;
 int is_delete_img;
{
 struct screen_data_overlay_rec *over;

 PRT9(printf("WinDeleteOverlayObject...1\n"))
 if ((over = (struct screen_data_overlay_rec *) obj->item) != NULL)
    {if (is_delete_img && win_is_file_img_valid(win,over->file,over->img))
        delete_img_if_not_use(over->img);
     free_screen_data_overlay_rec(over,win);
    }
 if (obj != &(win->overlay)) delete_item_from_list(obj);
 PRT9(printf("WinDeleteOverlayObject...end\n"))
 return NO_ERROR;
}

/**************
win_delete_overlay_item(win,img,is_delete_img)
 struct image_display_window *win;
 struct img_buf_rec *img;
 int is_delete_img;
{
 struct list_rec *cur;

 if ((cur = WinFindOverlayItem(win,img,0)) != NULL)
    {WinDeleteOverlayObject(win,cur,is_delete_img);
    }
 return NO_ERROR;
}
*****************/


/*--------------------------------------------------------------------------
win_delete_overlay_list - ???
---------------------------------------------------------------------------*/

int
win_delete_overlay_list(win,is_delete_img)
 struct image_display_window *win;
 int is_delete_img;
{
 struct screen_data_overlay_rec *over;
 struct list_rec *next,*cur,*before;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 cur = next = &(win->overlay);
 PRT(printf("win_delete_overlay_list...is_delete_img = %d\n",is_delete_img))
 do
    {
     if ((over = (struct screen_data_overlay_rec *) next->item) != NULL)
        {
         PRT(printf("win_delete_overlay_list...over = %u\n",over))
         if (is_delete_img && win_is_file_img_valid(win,over->file,over->img))
            delete_img_if_not_use(over->img);
         PRT(printf("win_delete_overlay_list...2\n"))
         free_screen_data_overlay_rec(over,win);
        }
     if (cur != next)
        {before = next->before;
         PRT(printf("win_delete_overlay_list...next = %u  cur = %u\n",next,cur))
         delete_item_from_list(next);
         next = before;
        }
       else
        {next->item = NULL;
         next = next->next;}
    }
 while (cur != next);
 PRT(printf("win_delete_overlay_list...end\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
WinOverlayBuf - ???
---------------------------------------------------------------------------*/

int
WinOverlayBuf(win,result,mask,bound,overlayedby_2d,
              map_2d_indxs,num_map_2d_indxs,scale,color)
 struct image_display_window *win;
 struct buf_2d_rec *result,*mask,*overlayedby_2d;
 struct int_bound_rec *bound;
 unsigned long *map_2d_indxs,num_map_2d_indxs;
 struct color_scale_rec *scale;
 struct color_rec *color;
{
 int err;
 struct color_data_rec *color_data;

 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;

 PRT9(printf("\nWinOverlayBuf...overlayedby_2d\n"))
 PRT9(pr_buf_2d_rec(overlayedby_2d))
 if (!(result->status4 & BUF_NON_EMPTY) || 
      (overlayedby_2d->pixel_depth != result->pixel_depth))
    {if ((err = SetupBuf2dRec(result,color_data->_2d.dimx,
           color_data->_2d.dimy,overlayedby_2d->pixel_depth,
           color_data->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
       return err;
     PRT9(printf("WinOverlayBuf reinit result...\n"))
     PRT9(pr_buf_2d_rec(result))
    }
 PRT9(printf("result...result\n"))
 PRT9(pr_buf_2d_rec(result))
 PRT9(printf("...map_2d_indxs = %u num_map_2d_indxs = %d color = %u scale = %u\n",
         map_2d_indxs,num_map_2d_indxs,color,scale);
      if (scale != NULL) pr_color_scale_rec(scale);
     )
 if (num_map_2d_indxs > 0)
    {
     PRT9(MinMax2dValues(overlayedby_2d,0,(double) .0,(double) .0,&min4,&max4);
         printf("WinOverlayBuf overlayedby_2d min4 = %f max4 = %f\n",min4,max4))
     Set2dBackgroundColor(result,overlayedby_2d,NULL,color,
                 map_2d_indxs,num_map_2d_indxs,scale->first,(double) .0,2);
    }
 PRT8(printf("WinOverlayBuf...end\n"))
 return NO_ERROR;
} 


/*--------------------------------------------------------------------------
win_compute_overlay - ???
---------------------------------------------------------------------------*/

int
win_compute_overlay(win,is_dp_canvas)
 struct image_display_window *win;
 int is_dp_canvas;
{
 struct screen_data_overlay_rec *over;
 struct list_rec *next,*cur;
 struct buf_2d_rec the_2d,*_2d;
 struct img_buf_rec *img;
 int err,is_dp;

 PRT10(printf("\nwin_compute_overlay...wid = %s is_dp = %d status4 = %x process_status4 = %x\n",
       win->owner->wid,is_dp_canvas,win->status4,(unsigned long) win->process_status4))
 win->process_status4 |= WIN_OVERLAY_DATA_PROCESSED;
 if (!(win->status4 & RECOMPUTE_OVERLAY)) return NO_ERROR;
 win->status4 &= ~RECOMPUTE_OVERLAY;
 PRT1(printf("win_compute_overlay...1\n"))
 if (win->overlay.item == NULL) return NO_ERROR;
 cur = next = &(win->overlay);
 PRT9(printf("win_compute_overlay...next + %u\n",next))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 do
    {
     if ((over = (struct screen_data_overlay_rec *) next->item) != NULL)
        {if (win_is_file_img_valid(win,over->file,over->img))
            {ImgAdvanceRelative(over->img,img);

             init_buf_2d_rec(&the_2d);
             if ((err = WinImgRegisteredBuf(win,&(over->color_data),NULL,
                        over->img,&the_2d,&_2d)) == NO_ERROR)
                {if (over->color_data.num_color_indxs != 
                         over->color_data.scale.num_colors)
                    err = SetupLocalColorScale(win->intensity,
                                     &(over->color_data));
                 if (err == NO_ERROR)
                    {err = WinOverlayBuf(win,&(over->color_data._2d),NULL,NULL,
                        _2d,over->color_data.color_indxs,
                        over->color_data.num_color_indxs,
                        &(over->color_data.scale),&(win->intensity->color));

                     if (!(over->color_data.scale.status & COLOR_LOCAL))
                        over->color_data.num_color_indxs = 0;

                    }
                }
             free_buf_2d_rec(&the_2d);
             if (err != NO_ERROR)
                {PRT(printf("win_compute_overlay...WinOverlayBuf...err = %d\n",err))
                 return err;}
            }
         }
     next = next->next;
    }
 while (cur != next);
 if (is_dp && is_dp_canvas) WinScreenCanvas(win);
 PRT10(printf("win_compute_overlay...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
WinMultiEchoComputeOverlay - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoComputeOverlay(win,is_dp_canvas,is_processed_draw_list)
 struct image_display_window *win;
 int is_dp_canvas,is_processed_draw_list;
{
 int err;

 PRT8(printf("WinMultiEchoComputeOverlay wid = %s\n",win->owner->wid))
 err = WinMultiEchoRunProc(win,win_compute_overlay,is_dp_canvas,0);
 win->process_status4 |= WIN_OVERLAY_DATA_PROCESSED;
 if (is_processed_draw_list &&
     (win->draw_list.item != NULL) &&
     (WinRunProcInList(WIN_DRAW_LIST | WIN_DO_NOT_PROCESS_CUR_WIN,win,
        WinSliceProcessed,
        WIN_PROCESSED_ERROR_STATUS | WIN_OVERLAY_DATA_PROCESSED,0,0,0,0,0)
      != NO_ERROR))
    {PRT8(printf("WinMultiEchoComputeOverlay again...\n"))
     WinRunProcInList(WIN_DRAW_LIST | WIN_DO_NOT_PROCESS_CUR_WIN,win,
               WinMultiEchoComputeOverlay,is_dp_canvas,0,0,0,0,0);
    }
 PRT8(printf("WinMultiEchoComputeOverlay err = %d\n",err))

 return err;
}


/*--------------------------------------------------------------------------
pr_wid - ???
---------------------------------------------------------------------------*/

int
pr_wid(win)
 struct image_display_window *win;
{
 PRT9(printf("pr_wid wid = %s\n",win->owner->wid);)
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_overlayed_by_win - ???
---------------------------------------------------------------------------*/

int
win_overlayed_by_win(win,win1,img,select)
 struct image_display_window *win,*win1;
 struct img_buf_rec *img;
 long select;
{
 struct image_display_window *win2;
 struct img_buf_rec *img1;
 int err;

 PRT9(printf("wid = %s win_overlayed_by_win...wid = %s  select = %d\n",
           win->owner->wid,win1->owner->wid,select))
 if ((err = WinAddOverlayItem(win,win1,img,1)) == NO_ERROR)
    {PRT9(printf("win_overlayed_by_win find_item\n"))
     /* FIXME!  The definition of find_item() requires three argument,
	I added a final argument "0" as a guess.  -PWH 19990610 */
     if (find_item(&(win->link),win1,0) == 0)
        {PRT9(printf("_cur_list_tail...wid = %s  wid1 = %s  head = %u\n",
                win->owner->wid,win1->owner->wid,win1->link.head))
         PRT9(pr_list_rec(&(win1->link),pr_wid);)
         add_item_as_cur_list_tail(&(win->link),&(win1->link));
         PRT9(printf("...after add_item_as_cur_list_tail\n"))
         PRT9(pr_list_rec(&(win1->link),pr_wid);)
        }
     
     if (select == OVERLAYED_BY_ALL_ECHO_WID_VALUE)
        {PRT11(printf("win_overlayed_by_win...OVERLAYED_BY_ALL_ECHO_WID_VALUE\n"))
         if (((img1 = win_rec_cur_img_buf(win1->owner)) != img) ||
             ((win2 = WinFindAvailNextEchoWin(win1)) == NULL))
            {PRT8(printf("img not belong to win1\n"))
             win2 = win1;
             if ((err = all_img_echoes_exist(img)) != NO_ERROR) img1 = NULL;
               else img1 = img->partner;}
            else 
             img1 = win_rec_cur_img_buf(win2->owner);
         if ((win2 != NULL) && (img1 != NULL))
            {PRT9(printf("===_cur_list_tail...wid = %s  win2 = %s\n",
                win->owner->wid,win2->owner->wid))
             if ((err = WinAddOverlayItem(win,win2,img1,1)) != NO_ERROR)
                if (win1 != win2)
                   /* FIXME!  The definition of find_item() requires three
                      argument,	I added a final argument "0" as a guess.
                      -PWH 19990610 */
                   if (find_item(&(win->link),win2,0) == 0)
                      {PRT9(printf("add_item win->link),&(win2->link\n"))
                       add_item_as_cur_list_tail(&(win->link),&(win2->link));}
            }
           else err = CANCEL;
        }
     WinScreenCanvas(win);
    }
 return err;
}


/*--------------------------------------------------------------------------
win_overlayed_by_win_stack_it - ???
---------------------------------------------------------------------------*/

int
win_overlayed_by_win_stack_it(win,win1,cur_slice,select)
 struct image_display_window *win,*win1;
 struct hdr_scan_entry_rec **cur_slice;
 long select;
{
 int err;
 struct img_buf_rec *img,*img1;

 PRT9(printf("win_overlayed_by_win_stack_it...win = %s win1 = %s select = %d\n",
         win->owner->wid,win1->owner->wid,select))
 if ((img = win_rec_cur_img_buf(win1->owner)) == NULL) return CANCEL;

 if ((img1 = NewImgBuf(&(img->file->img),*cur_slice,&err,0,0,0,0,0,0,0)) == NULL)
    return err;
 PRT9(printf("win_overlayed_by_win_stack_it...snum = %d enum = %d scnum = %d\n",
      img1->cur_slice->slice_num,img1->cur_slice->echo_num,img1->cur_slice->scan_num))
 if ((err = win_overlayed_by_win(win,win1,img1,select)) == NO_ERROR)
    {
     *cur_slice = (*cur_slice)->next_slice;
     PRT11(printf("===== next_slice = %u slice_num = %d sc# = %d e# =%d\n",
            *cur_slice,(*cur_slice)->slice_num,
            (*cur_slice)->scan_num,(*cur_slice)->echo_num))
    }
   else delete_img(img1);

 return err;
}


/*--------------------------------------------------------------------------
win_overlayed_by_win_stack - ???
---------------------------------------------------------------------------*/

int
win_overlayed_by_win_stack(win,win1,img,select)
 struct image_display_window *win,*win1;
 struct img_buf_rec *img;
 long select;
{
 struct hdr_scan_entry_rec *cur;
 long sel;
 int err;

 PRT9(printf("win_overlayed_by_win_stack...\n"))

 if (select == OVERLAYED_BY_WID_STACK_VALUE) sel = OVERLAYED_BY_WID_VALUE;
   else sel = OVERLAYED_BY_ALL_ECHO_WID_VALUE;
 if ((err = win_overlayed_by_win(win,win1,img,select)) == NO_ERROR)
    if (win->list.next != &(win->list))
       {cur = img->cur_slice->next_slice;
        err = WinRunProcInList(WIN_LIST | WIN_DO_NOT_PROCESS_CUR_WIN,
             win,win_overlayed_by_win_stack_it,win1,&cur,sel,0,0,0);
       }
 return err;
}


/*--------------------------------------------------------------------------
win_overlayed_by_wid - ???
---------------------------------------------------------------------------*/

int
win_overlayed_by_wid(win,wid,select)
 struct image_display_window *win;
 char *wid;
 long select;
{
 struct win_rec *rwin;
 struct image_display_window *win1;
 struct img_buf_rec *cur_img,*img,*img1;
 int err;

 PRT9(printf("win_overlayed_by_wid...wid = %s select = %d\n",wid,select));
 if ((cur_img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     ((img = win_rec_cur_img_buf(rwin)) != NULL) &&
     ((win1 = rwin->image_display) != NULL))
    {if ((img1 = NewImgBuf(&(img->file->img),img->cur_slice,
                      &err,0,0,0,0,0,0,0)) == NULL)
            return err;
     if ((select == OVERLAYED_BY_WID_STACK_VALUE) ||
         (select == OVERLAYED_BY_ALL_ECHO_WID_STACK_VALUE))
        err = win_overlayed_by_win_stack(win,win1,img1,select);
       else
        err = win_overlayed_by_win(win,win1,img1,select);
     if (err != NO_ERROR)
        delete_img(img1);
    }
   else err = CANCEL;
 if (err != NO_ERROR)
    {
     ShowMsgStrs(win->dwin->frame,0,err,0,2,
                  "Sorry...An error occurred ",
                  "during the overlay !!!",NULL,0);
    }
 win_update_contrast(win);
 return err;
}


/*--------------------------------------------------------------------------
WinDeleteOverlay - ???
---------------------------------------------------------------------------*/

int
WinDeleteOverlay(win)
 struct image_display_window *win;
{
 PRT9(printf("WinDeleteOverlay...\n"));
 win_delete_overlay_list(win,1);
 delete_item_from_list(&(win->link));
 WinScreenCanvas(win);
 win_update_contrast(win);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
WinSetOverlayStatus - ???
---------------------------------------------------------------------------*/

int
WinSetOverlayStatus(over,win,dummy1,dummy2,dummy3,dummy4,dummy5,win_list)
 struct screen_data_overlay_rec *over;
 struct image_display_window *win;
 void *dummy1,*dummy2,*dummy3,*dummy4,*dummy5;
 struct list_rec *win_list;
{
 struct color_data_rec *color_data;

 PRT9(printf("WinSetOverlayStatus...win wid = %s  %d\n",win->owner->wid,
            over->color_data.id));
 if (WinFindColorDataRec1(win,over->color_data.gid,over->color_data.member_id,
           &color_data,NULL) == NO_ERROR)
    if (color_data->status4 & COLOR_DATA_DISABLED)
       WinSetColorDataStatus(win,over->color_data.gid,~COLOR_DATA_DISABLED,0);
      else WinSetColorDataStatus(win,over->color_data.gid,0xffffffff,COLOR_DATA_DISABLED);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
WinShowHideOverlay - ???
---------------------------------------------------------------------------*/
int
WinShowHideOverlay(win)
 struct image_display_window *win;
{
 if (win->overlay.item != NULL)
    {WinRunProcInList(WIN_OVERLAY,win,WinSetOverlayStatus,win,0,0,0,0,0);
     WinScreenCanvas(win);}
 return NO_ERROR;
}
