/****************************************************************************
segment_2_echo.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: segment_2_echo.c,v 1.10 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include "mri_format.h"
#include "segment.h"
#include "edge.h"
#include "nria_procedures.h"

/*
#define PRINT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define TIME(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRINT(x)
*/
#define PRT1(x)
#define PRT(x)
#define TRACE(x)
#define TIME(x)
#define PRT2(x)



/* Functions defined in this file */
void init_grow_rec(struct grow_rec *grow);
void free_grow_rec(struct grow_rec *grow);
void init_segment_rec(struct segment_rec *seg);
void free_segment_rec(struct segment_rec *seg);
void init_all_segment_rec(struct all_segment_rec *allseg);
void free_all_segment_rec(struct all_segment_rec *allseg);
int sort_2_echo_type_val_rec_proc(struct type_val_rec **set1,
    struct type_val_rec **set2);
int sort_2_echo_stack_list_rec_ptr_proc(struct stack_list_rec **list1,
    struct stack_list_rec **list2);
int setup_2_echo_stack_list_rec(struct pixel_stack_rec_ptr *resolve,
    long valx, long valy, struct stack_list_rec **list, long add_max_items);
void cnt_histo_types(struct buf_2d_rec *histo_types);
int setup_segment_rec(struct segment_rec *seg, struct histo_params_rec *histo,
    struct strs_rec *order, struct roi_rec *image_seg_roi, int img_dimx,
    int img_dimy);
void view_quadrant_xys(long dimx, long dimy, long *x1, long *y1, long *x2,
    long *y2, int which_quadrant);
int setup_all_segment_rec(struct all_segment_rec *allseg,
    struct histo_params_rec *histo, int is_quadrant,
    struct strs_rec *quadrant_label, unsigned long img_dimx,
    unsigned long img_dimy);
int _2_echo_statistics(struct pixel_type_ave_rec *type_aves,
    unsigned long num_type_aves, struct buf_2d_rec *histo_types,
    struct buf_2d_rec *image_mask, struct buf_2d_rec *_2dx,
    struct buf_2d_rec *_2dy, struct pixel_neighbor_type_rec **pix_neighs,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *neigh_2d);
void check_pixel_stack_rec_ptr(struct pixel_stack_rec_ptr *grown);
int solve_2_echo_shared_pixel_types(struct pixel_type_ave_rec *type_aves,
    unsigned long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *image_mask);
int type_xys(struct buf_2d_rec *_2d_types, struct buf_2d_rec *neigh_2d,
    struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2,
    struct histo_params_rec *histo);
int resolve_xys(struct pixel_stack_rec_ptr *resolve,
    struct buf_2d_rec *neigh_2d, struct histo_params_rec *histo);
void cnt_2_echoes(struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2);
int cnt_neigh_2d(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve);
int incompatible_pixels_by_neighbors(struct pixel_type_ave_rec *type_aves,
    long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve);
int incompatible_pixels_by_ave(struct pixel_type_ave_rec *type_aves,
    long num_type_aves, struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve);
int compute_2_echo_weights(struct neighbor_type_rec *neigh,
    struct buf_2d_rec *_2d1, struct buf_2d_rec *_2d2, long x, long y);
int define_type_distance(struct segment_rec *seg, struct buf_2d_rec *_2dx,
    struct buf_2d_rec *_2dy, struct buf_2d_rec *image_mask);
int get_type_xys(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *image_mask,
    int type);
int recompute_neigh_weights(struct buf_2d_rec *neigh_2d,
    struct pixel_stack_rec_ptr *resolve, struct buf_2d_rec *image_mask);
int setup_pixel_type_ave_rec(struct pixel_type_ave_rec **type_aves,
    long *num_type_aves, long num_types);
int segment_2_echo_pixels(struct segment_rec *seg, struct buf_2d_rec *_2d1,
    struct buf_2d_rec *_2d2, struct buf_2d_rec *pixel_map,
    struct histo_params_rec *histo, int option);
int SetupHistoPixelTypeOrder(struct histo_params_rec *histo,
    struct strs_rec *priority, int is_quadrant_allow, int *is_quadrant,
    struct strs_rec *quadrant_label, int histo_type2);
int setup_segment_2_echo(struct histo_params_rec *histo,
    struct all_segment_rec *allseg, struct pixel_type_rec *pixel_type,
    struct strs_rec *priority, unsigned long num_slice_maps,
    unsigned long img_dimx, unsigned long img_dimy);



/*--------------------------------------------------------------------------
init_grow_rec - ???
---------------------------------------------------------------------------*/

void
init_grow_rec(grow)
 struct grow_rec *grow;
{
 grow->status = 0;
 grow->label = NULL;
 init_pixel_type_ave_rec(&(grow->type_ave));
 grow->is_done_grow = 0;
 init_buf_2d_rec(&(grow->done_grown));
 init_pixel_stack_rec_ptr(&(grow->grow_stack));
}


/*--------------------------------------------------------------------------
free_grow_rec - ???
---------------------------------------------------------------------------*/

void
free_grow_rec(grow)
 struct grow_rec *grow;
{
 c_free(grow->label);
 free_buf_2d_rec(&(grow->done_grown));
 free_pixel_stack_rec_ptr(&(grow->grow_stack),1);
 init_grow_rec(grow);
}


/*--------------------------------------------------------------------------
init_segment_rec - ???
---------------------------------------------------------------------------*/

void
init_segment_rec(seg)
 struct segment_rec *seg;
{
 seg->status = 0;
 init_buf_2d_rec(&(seg->image_mask));
 seg->num_types = 0;
 seg->types = NULL;
 init_buf_2d_rec(&(seg->histo_types));
}


/*--------------------------------------------------------------------------
free_segment_rec - ???
---------------------------------------------------------------------------*/

void
free_segment_rec(seg)
 struct segment_rec *seg;
{
 unsigned long lcv,row,col;
 struct type_val_rec *type;

 free_buf_2d_rec(&(seg->image_mask));
 if (seg->num_types > 0)
    {for (lcv = 0; lcv < seg->num_types; lcv++)
        free_grow_rec(&(seg->types[lcv]));
     c_free(seg->types);}
 if (seg->histo_types.status4 & BUF_NON_EMPTY)
    {
     for (row = 0; row < seg->histo_types.dimy; row++)
        for (col = 0; col < seg->histo_types.dimx; col++)
           if (type = (struct type_val_rec *) get_1d_buf_value(seg->histo_types.buf[row],col,
                     seg->histo_types.pixel_depth))
              {free_type_val_rec(type);
               c_free(type);}
    }
 free_buf_2d_rec(&(seg->histo_types));
 init_segment_rec(seg);
}


/*--------------------------------------------------------------------------
init_all_segment_rec - ???
---------------------------------------------------------------------------*/

void
init_all_segment_rec(allseg)
 struct all_segment_rec *allseg;
{
 allseg->num_segs = 0;
 allseg->segs = NULL;
}


/*--------------------------------------------------------------------------
free_all_segment_rec - ???
---------------------------------------------------------------------------*/

void
free_all_segment_rec(allseg)
 struct all_segment_rec *allseg;
{
 unsigned long lcv;

 if (allseg->num_segs > 0)
    {for (lcv = 0; lcv < allseg->num_segs; lcv++)
        free_segment_rec(&(allseg->segs[lcv]));
     c_free(allseg->segs);
     init_all_segment_rec(allseg);}
}


/*--------------------------------------------------------------------------
sort_2_echo_type_val_rec_proc - ???
---------------------------------------------------------------------------*/

int
sort_2_echo_type_val_rec_proc(set1,set2)
 struct type_val_rec **set1,**set2;
{
 if ((*set1)->valx > (*set2)->valx) return 1;
 if ((*set1)->valx < (*set2)->valx) return -1;
 if ((*set1)->valy > (*set2)->valy) return 1;
 if ((*set1)->valy < (*set2)->valy) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
sort_2_echo_stack_list_rec_ptr_proc - ???
---------------------------------------------------------------------------*/

int
sort_2_echo_stack_list_rec_ptr_proc(list1,list2)
 struct stack_list_rec **list1,**list2;
{
 if ((*list1)->valx > (*list2)->valx) return 1;
 if ((*list1)->valx < (*list2)->valx) return -1;
 if ((*list1)->valy > (*list2)->valy) return 1;
 if ((*list1)->valy < (*list2)->valy) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
setup_2_echo_stack_list_rec - ???

FIXME:  The argument add_max_items is never used.
---------------------------------------------------------------------------*/

int
setup_2_echo_stack_list_rec(resolve,valx,valy,list,add_max_items)
 struct pixel_stack_rec_ptr *resolve;
 long valx,valy;
 struct stack_list_rec **list;
 long add_max_items;
{
 struct stack_list_rec key,*the_key,*item;
 long indx,lcv,last;
 int err;

/* TRACE(printf("setup_2_echo_stack_list_rec...1\n"))*/
 if (resolve->num_lists > 0)
    {the_key = &key;
     key.valx = valx;
     key.valy = valy;
     if (obj_binary_search(resolve->lists,resolve->num_lists,
          sizeof(*(resolve->lists)),
          &the_key,sort_2_echo_stack_list_rec_ptr_proc,&indx) == NO_ERROR)
        {*list = resolve->lists[indx];
         return NO_ERROR;}
    }
   else indx = 0;
 *list = NULL;
 if (resolve->num_lists >= resolve->total_lists)
    {
     if ((err = get_ptr(&(resolve->lists),&(resolve->total_lists),50,
            (size_t) sizeof(*(resolve->lists)))) != NO_ERROR)
        return err;
    }
 lcv = 0;
 if ((err = get_ptr(&item,&lcv,1,(size_t) sizeof(*item))) != NO_ERROR)
    return err;
 *list = item;
 init_stack_list_rec(item);
 if (resolve->num_lists > 0)
    {last = resolve->num_lists - 1;
     for (lcv = resolve->num_lists; lcv > indx; )
        {resolve->lists[lcv] = resolve->lists[last];
         lcv = last;
         last -= 1;}
    }
 resolve->lists[indx] = item;
 resolve->lists[indx]->valx = valx;
 resolve->lists[indx]->valy = valy;
 resolve->num_lists++;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cnt_histo_types - ???
---------------------------------------------------------------------------*/

void
cnt_histo_types(histo_types)
 struct buf_2d_rec *histo_types;
{
 long row,col,none,p0,p1,p2;
 struct type_val_rec *cur_pix;

 none = p0 = p1 = p2 = 0;
 for (row = 0; row < histo_types->dimy; row++)
    for (col = 0; col < histo_types->dimx; col++)
       {cur_pix = (struct type_val_rec *) get_1d_buf_value(
                          histo_types->buf[row],col,histo_types->pixel_depth);
        if (cur_pix == 0) none += 1;
          else if (cur_pix->num_types == 0) p0 += 1;
          else if (cur_pix->num_types == 1) p1 += 1;
          else p2 += 1;
       }
 printf("cnt_histo_types none = %ld p0 = %ld p1 = %ld p2 = %ld\n",
	none,p0,p1,p2);
}



/*--------------------------------------------------------------------------
setup_segment_rec - ???
---------------------------------------------------------------------------*/

int
setup_segment_rec(seg,histo,order,image_seg_roi,img_dimx,img_dimy)
 struct segment_rec *seg;
 struct histo_params_rec *histo;
 struct strs_rec *order;
 struct roi_rec *image_seg_roi;
 int img_dimx,img_dimy;
{
 struct stack_list_rec *list;
 long cnt,lcv,row,col,x,y,num_types,num_indxs,
           histo_dimx,histo_dimy,pixel_depth,total;
 struct type_val_rec *type,all_types;
 int err,add;
 struct buf_2d_rec *_2d;
 struct roi_rec *roi;
 struct slice_roi_win_rec *slice_roi_win;
 static int cntz = 0;

 PRT(printf("setup_segment_rec...pixel_type_order\n");
       pr_strs_rec(&(histo->pixel_type_order));)
 PRT(printf("setup_segment_rec...order\n");
       pr_strs_rec(order);)
 if (order->num_strs == 0) return CANCEL;
 if (image_seg_roi != NULL)
    {if (((err = SetupBuf2dRec(&(seg->image_mask),img_dimx,img_dimy,1,0)) != NO_ERROR) ||
         ((err = FillROi(image_seg_roi,NULL,
                &(seg->image_mask),1,1,0)) != NO_ERROR))
        return err;
     PRT(printf("image_seg_roi != NULL mask = %d\n",
                  CntNonValBuf2dRec(&(seg->image_mask),(double) 0)))}

 num_types = order->num_strs;
 cntz += 1;
 if ((err = get_ptr(&(seg->types),&(seg->num_types),num_types,
               sizeof(*(seg->types)))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < num_types; lcv++)
    init_grow_rec(&(seg->types[lcv]));

 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_MULTI_D);
 for (lcv = 0; lcv < num_types; lcv++)
    if ((err = SetupBuf2dRec(&(seg->types[lcv].done_grown),
            histo_dimx,histo_dimy,1,1)) != NO_ERROR)
       return err;
 if ((err = SetupBuf2dRec(&(seg->histo_types),
            histo_dimx,histo_dimy,sizeof(void *) * 8,1)) != NO_ERROR)
    return err;
 TRACE(printf("setup_segment_rec...2\n");)

 slice_roi_win = (struct slice_roi_win_rec *) 
                   GetHistoSliceRoiWinRec(histo,HISTO_MULTI_D);
 for (lcv = 0; lcv < num_types; lcv++)
    {if (((roi = get_roi(&(slice_roi_win->slice_roi),
                  order->strs[lcv])) == NULL) ||
         !is_roi_non_empty(roi))
        {seg->types[lcv].is_done_grow = 1;
         PRT(printf("roi = %s not exist\n",order->strs[lcv]);)
         continue;}
     if (((err = FillROi(roi,NULL,
             &(seg->types[lcv].done_grown),1,1,0)) != NO_ERROR) ||
         ((err = cp_str(&(seg->types[lcv].label),roi->label)) != NO_ERROR))
        return err;
     TRACE(printf("roi->label = %s\n",roi->label))
     if (roi->status & HISTO_EDITED_ROI)
        {seg->types[lcv].status |= TISSUE_TYPE_EDITED;
         seg->types[lcv].is_done_grow = 1;}
    }

 PRT(printf("setup_segment_rec...4\n"))
 PRT(for (lcv = 0; lcv < num_types; lcv++)
    {printf("%d) cnt = %d\n",lcv,CntValBuf2dRec(&(seg->types[lcv].done_grown),(double) 0));}
    )

 init_type_val_rec(&all_types);
 total = 0;
 if ((err = get_ptr(&(all_types.types),&total,num_types,
                sizeof(*(all_types.types)))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < total; lcv++)
    all_types.types[lcv].dist = 1;
 all_types.num_types = total;
 PRT(printf("all_types.num_types = %d\n",(long) all_types.num_types);)
 for (row = 0; row < histo_dimy; row++)
    for (col = 0; col < histo_dimx; col++)
       {for (num_indxs = 0,lcv = 0; lcv < num_types; lcv++)
           if (get_1d_buf_value(seg->types[lcv].done_grown.buf[row],col,
                    seg->types[lcv].done_grown.pixel_depth))
              {all_types.types[num_indxs].indx = lcv;
               num_indxs += 1;}
        if (num_indxs != 0)
           {total = 0;
            if ((err = get_ptr(&type,&total,1,sizeof(*type))) == NO_ERROR)
               {init_type_val_rec(type);
                type->valx = col;
                type->valy = row;
                total = 0;
                if ((err = get_ptr(&(type->types),&total,  
                         num_indxs,sizeof(*(type->types)))) == NO_ERROR)
                   {type->num_types = total;
                    for (lcv = 0; lcv < num_indxs; lcv++)
                       type->types[lcv] = all_types.types[lcv];
                    set_1d_buf_value(seg->histo_types.buf[row],col,
                                seg->histo_types.pixel_depth,type);
                   }
                  else
                   {c_free(type);
                    free_type_val_rec(&all_types);
                    return err;}
               }
              else 
               {free_type_val_rec(&all_types);
                return err;}
           }
       }
 TRACE(printf("setup_segment_rec..5\n"))
 TRACE(pr_buf_2d_rec(&(seg->histo_types)))
 TRACE(printf("histo_types = %d\n",
         CntValBuf2dRec(&(seg->histo_types),(double) 0)))
 free_type_val_rec(&all_types);
 PRT(printf("setup_segment_rec..5...1\n"))
 PRT(for (lcv = 0; lcv < num_types; lcv++)
    {printf("%d) cnt = %d\n",lcv,CntValBuf2dRec(&(seg->types[lcv].done_grown),(double) 0));
    }
    )
 seg->bound.left = histo_dimx;
 seg->bound.right = 0;
 seg->bound.top = histo_dimx;
 seg->bound.bottom = 0;
 for (row = 0; row < histo_dimy; row++)
    for (col = 0; col < histo_dimx; col++)
       if ((type = (struct type_val_rec *) get_1d_buf_value(seg->histo_types.buf[row],col,
                      seg->histo_types.pixel_depth)))
          {
           if (seg->bound.left > col) seg->bound.left = col;
           if (seg->bound.right < col) seg->bound.right = col;
           if (seg->bound.top > row) seg->bound.top = row;
           if (seg->bound.bottom < row) seg->bound.bottom = row;

           for (add = 0,lcv = 0; lcv < (unsigned long) type->num_types; lcv++)
              {
               if (!(seg->types[type->types[lcv].indx].is_done_grow))
                  {_2d = &(seg->types[type->types[lcv].indx].done_grown);
                   for (cnt = 0; cnt < 8; cnt++)
                      {x = col + neighbor_Offset[cnt][0];
                       if ((x < 0) || (x >= _2d->dimx)) continue;
                       y = row + neighbor_Offset[cnt][1];
                       if ((y < 0) || (y >= _2d->dimy)) continue;
                       if (get_1d_buf_value(_2d->buf[y],x,_2d->pixel_depth) == 0)
                          {add = 1;
                           break;}
                      }
                  }
               if (add || (type->num_types > 1))
                  {add = 0;

                   if ((err = setup_2_echo_stack_list_rec(
                       &(seg->types[type->types[lcv].indx].grow_stack),col,row,&list,200))
                             != NO_ERROR)
                      return err;
                  }
              }
          }

 TRACE(printf("setup_segment_rec..6...\n");pr_int_bound_rec(&(seg->bound));)

 TRACE(for (lcv = 0; lcv < num_types; lcv++)
          {printf("%d) cnt = %d\n",lcv,CntValBuf2dRec(&(seg->types[lcv].done_grown),(double) 0));
          }
    )

 _2d = &(seg->types[0].done_grown);
 for (lcv = 1; lcv < num_types; lcv++)
    OrBitmaps(_2d,_2d,&(seg->types[lcv].done_grown));
 for (lcv = 1; lcv < num_types; lcv++)
    if ((err = copy_buf_2d_rec_content(&(seg->types[lcv].done_grown),_2d))
        != NO_ERROR)
      return err;
 PRT(for (lcv = 0; lcv < num_types; lcv++)
    {printf("OR %d) cnt = %d\n",lcv,CntValBuf2dRec(&(seg->types[lcv].done_grown),(double) 0));
     /*pr_pixel_stack_rec_ptr(&(seg->types[lcv].grow_stack),0,2);*/
    }
    )
 
 TRACE(cnt_histo_types(&(seg->histo_types));printf("setup_segment_rec..7\n"))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
view_quadrant_xys - ???
---------------------------------------------------------------------------*/

void
view_quadrant_xys(dimx,dimy,x1,y1,x2,y2,which_quadrant)
 long dimx,dimy,*x1,*y1,*x2,*y2;
 int which_quadrant;
{
 if (which_quadrant == 0)
    {*x1 = *y1 = 0;
     *x2 = dimx / 2 - 1;
     *y2 = dimy / 2 - 1;}
   else if (which_quadrant == 1)
    {*x1 = dimx / 2;
     *y1 = 0;
     *x2 = dimx - 1;
     *y2 = dimy / 2 - 1;}
   else if (which_quadrant == 2)
    {*x1 = 0;
     *y1 = dimy / 2;
     *x2 = dimx / 2 - 1;
     *y2 = dimy - 1;}
   else
    {*x1 = dimx / 2;
     *y1 = dimy / 2;
     *x2 = dimx - 1;
     *y2 = dimy - 1;}
}


/*--------------------------------------------------------------------------
setup_all_segment_rec - ???
---------------------------------------------------------------------------*/

int
setup_all_segment_rec(allseg,histo,is_quadrant,quadrant_label,img_dimx,img_dimy)
 struct all_segment_rec *allseg;
 struct histo_params_rec *histo;
 int is_quadrant;
 struct strs_rec *quadrant_label;
 unsigned long img_dimx,img_dimy;
{
#define NUM_ELEMS 5
 int err,use[NUM_ELEMS];
 long lcv,start_indx,indx,cnt,total,num;
 char **quads,*str;
 struct strs_rec ptr;
 struct roi_rec roi,*the_roi;
 long x1,y1,x2,y2;
 unsigned short status;

 PRT(printf("setup_all_segment_rec..is_quadrant = %d num_segs = %d \n",is_quadrant,allseg->num_segs))
 PRT(printf("histo->pixel_type_order...\n"))
 PRT(pr_strs_rec(&(histo->pixel_type_order)))
 PRT(printf("quadrant_label...\n"))
 PRT(pr_strs_rec(quadrant_label))
 if (!is_quadrant)
    {
     if ((err = get_ptr(&(allseg->segs),&(allseg->num_segs),1,
          (size_t) sizeof(*(allseg->segs)))) != NO_ERROR)
        return err;
     init_segment_rec(&(allseg->segs[0]));
     return setup_segment_rec(&(allseg->segs[0]),histo,&(histo->pixel_type_order),
              NULL,img_dimx,img_dimy);
    }
 total = 0;
 num = histo->pixel_type_order.num_strs * NUM_ELEMS;
 if ((err = get_ptr(&quads,&total,num,(size_t) sizeof(*quads))) != NO_ERROR)
    return err;
 PRT(printf("setup_all_segment_rec..1...num = %d\n",num))

 for (lcv = 0; lcv < num; lcv++)
    quads[lcv] = NULL;
 for (lcv = 0; lcv < quadrant_label->num_strs; lcv++)
    {str = quadrant_label->strs[lcv];
     if ((find_sub_str(str,":Q",&start_indx) == NO_ERROR) &&
         (str[start_indx + 2] >= '1') && 
         (str[start_indx + 2] <= '4'))
        {str[start_indx] = '\0';
         if ((err = find_str_in_strs_rec(&(histo->pixel_type_order),str,&cnt)) != NO_ERROR)
            break;
         str[start_indx] = ':';
         indx = str[start_indx + 2] - '1';
         quads[indx * histo->pixel_type_order.num_strs + cnt] = str;}
       else
        {if ((err = find_str_in_strs_rec(&(histo->pixel_type_order),str,&cnt)) != NO_ERROR)
            break;
         quads[(NUM_ELEMS - 1) * histo->pixel_type_order.num_strs + cnt] = str;}
    }
 PRT(printf("setup_all_segment_rec..2..err = %d\n",err))

 if (err != NO_ERROR)
    {c_free(quads);
     return err;}
 for (lcv = 0; lcv < NUM_ELEMS; lcv++)
    use[lcv] = 0;
 for (indx = 0,lcv = 0; lcv < NUM_ELEMS; lcv++,indx += histo->pixel_type_order.num_strs)
    {for (cnt = 0; cnt < histo->pixel_type_order.num_strs; cnt++)
        if (quads[indx + cnt] != NULL)
           {use[lcv] = 1;
            for (cnt = 0; cnt < histo->pixel_type_order.num_strs; cnt++)
               if (quads[indx + cnt] == NULL)
                  quads[indx + cnt] = histo->pixel_type_order.strs[cnt];
            break;}
    }
 PRT(for (lcv = 0; lcv < num; lcv++)
     printf("quads[%d] = %s\n",lcv,quads[lcv]);
    )
 PRT(printf("setup_all_segment_rec..3..err = %d\n",err))
 for (total = 0,lcv = 0; lcv < NUM_ELEMS; lcv++)
    if (use[lcv]) total += 1;

 PRT(printf("setup_all_segment_rec..total = %d\n",total))
 if ((err = get_ptr(&(allseg->segs),&(allseg->num_segs),total,
          (size_t) sizeof(*(allseg->segs)))) != NO_ERROR)
    {c_free(quads);
     return err;}
 PRT(printf("setup_all_segment_rec..3.1\n"))
 for (lcv = 0; lcv < total; lcv++)
    init_segment_rec(&(allseg->segs[lcv]));
 PRT(printf("setup_all_segment_rec..3.2\n"))
 init_strs_rec(&ptr);
 init_roi_rec(&roi,NULL);
 PRT(printf("setup_all_segment_rec..3.4\n"))
 for (total = indx = 0,lcv = 0; lcv < NUM_ELEMS; lcv++,
                               indx += histo->pixel_type_order.num_strs)
    if (use[lcv]) 
       {for (cnt = 0; cnt < histo->pixel_type_order.num_strs; cnt++)
           if ((err = add_str_ptr_to_strs_rec(&ptr,quads[indx + cnt])) != NO_ERROR)
              break;
        if (err != NO_ERROR) break;
        if (lcv <= 3)
           {view_quadrant_xys(img_dimx,img_dimy,&x1,&y1,&x2,&y2,lcv);
            if ((err = EnterPtsIntoRoiRec(&roi,
                   (unsigned long) DRAW_RECT,&status,NULL,1,2,
                  (float) x1,(float) y1,(float) x2,(float) y2)) != NO_ERROR)
               break;
            the_roi = &roi;}
          else the_roi = NULL;
        if ((err = setup_segment_rec(&(allseg->segs[total]),histo,&ptr,
                 the_roi,img_dimx,img_dimy)) != NO_ERROR)
           break;
        if (lcv <= 3)
           free_roi_rec(&roi);

        total += 1;
        free_strs_rec_ptrs(&ptr);
       }
 PRT(printf("setup_all_segment_rec..4\n"))
 for (indx = 0,lcv = 0; lcv < 4; lcv++)
    if (use[lcv]) indx++;
 for (; lcv < NUM_ELEMS; lcv++)
    if (use[lcv])
       {if ((err = SetupBuf2dRec(&(allseg->segs[indx].image_mask),
                 img_dimx,img_dimy,1,0)) != NO_ERROR)
           break;
        InitBuf2dRecData(&(allseg->segs[indx].image_mask),(double) 1);
        for (total = 0,cnt = 0; cnt < 4; cnt++)
           if (use[cnt])
              {PRT(printf("indx = %d  total = %d\n",indx,total);)
               Set2d(&(allseg->segs[indx].image_mask),0,0,
                      &(allseg->segs[total].image_mask),NULL,(double) .0);
               total += 1;}
        indx += 1;}
 PRT(printf("setup_all_segment_rec..5\n"))
 PRT(for (indx = 0,lcv = 0; lcv < NUM_ELEMS; lcv++)
        if (use[lcv])
           {printf("%d) image_mask = %d\n",lcv,
              CntNonValBuf2dRec(&(allseg->segs[indx].image_mask),(double) 0));
            indx += 1;}
    )
 free_strs_rec_ptrs(&ptr);
 free_roi_rec(&roi);
 c_free(quads);
 return err;
}


/*--------------------------------------------------------------------------
_2_echo_statistics - ???
---------------------------------------------------------------------------*/

int
_2_echo_statistics(type_aves,num_type_aves,histo_types,image_mask,_2dx,_2dy,pix_neighs,
                   resolve,neigh_2d)
 struct pixel_type_ave_rec *type_aves;
 unsigned long num_type_aves;
 struct buf_2d_rec *histo_types,*image_mask,*_2dx,*_2dy;
 struct pixel_neighbor_type_rec **pix_neighs;
 struct pixel_stack_rec_ptr *resolve;
 struct buf_2d_rec *neigh_2d;
{
 long lcv,row,col,total,valx,valy;
 struct type_val_rec *pix;
 struct stack_list_rec *list;
 struct stack_xy_rec *xy;
 double val;
 int err;
 int p1,p2;

 TRACE(printf("_2_echo_statistics...num_type_aves = %d\n",num_type_aves))
 total = 0;
 *pix_neighs = 0;
 if ((err = get_ptr(pix_neighs,&total,neigh_2d->dimx * neigh_2d->dimy,
                (size_t) sizeof(**pix_neighs))) != NO_ERROR)
    return err;
 TRACE(printf("_2_echo_statistics...num_type_aves = %d\n",num_type_aves))
 p1 = p2 = 0;
 for (lcv = 0,row = 0; row < _2dx->dimy; row++)
    for (col = 0; col < _2dx->dimx; col++,lcv++)
       {
        set_1d_buf_value(neigh_2d->buf[row],col,neigh_2d->pixel_depth,
            &((*pix_neighs)[lcv]));
        (*pix_neighs)[lcv].neigh = NULL;
        if ((image_mask != NULL) && (image_mask->status4 & BUF_NON_EMPTY))
           {if (get_1d_buf_value(image_mask->buf[row],col,image_mask->pixel_depth) == 0)
               {(*pix_neighs)[lcv].pix = NULL;
                continue;}
           }
        val = _2dx->GetVal(_2dx,row,col);
        valx = (unsigned long) (val + .5);
        val = _2dy->GetVal(_2dy,row,col);
        valy = (unsigned long) (val + .5);
        pix = (struct type_val_rec *) get_1d_buf_value(
                  histo_types->buf[valy],valx,histo_types->pixel_depth);
        (*pix_neighs)[lcv].pix = pix;
        if (pix->num_types == 1)
           {p1 += 1;
            type_aves[pix->types[0].indx].x += valx;
            type_aves[pix->types[0].indx].y += valy;
            type_aves[pix->types[0].indx].num_freqs += 1;
           }
          else
           {p2 += 1;
	    /* FIXME:  Added final argument 200 in line below by analogy
	       with other calls to this function, but could not immediately
	       verify that this is correct.  -PWH 19990426 */
            if (((err = setup_2_echo_stack_list_rec(resolve,(long) pix->valx,(long) pix->valy,
                         &list,200)) != NO_ERROR) ||
                ((err = setup_stack_xy_rec(list,col,row,&xy)) != NO_ERROR))
               return err; 
            xy->pix_neigh = &((*pix_neighs)[lcv]);
           }
       }

 TRACE(for (lcv = 0; lcv < num_type_aves; lcv++)
    {printf("%d) _2_echo_statistics...avex = %f avey = %f num_freqs = %d\n",lcv,
                   type_aves[lcv].x / (float) type_aves[lcv].num_freqs,
                   type_aves[lcv].y / (float) type_aves[lcv].num_freqs,
                   type_aves[lcv].num_freqs);
    }
   )
 TRACE(printf("_2_echo_statistics...p1 = %d  p2 = %d\n",p1,p2))
 return NO_ERROR;
}



/*--------------------------------------------------------------------------
check_pixel_stack_rec_ptr - ???

FIXME:  Apparently never used.
---------------------------------------------------------------------------*/

void
check_pixel_stack_rec_ptr(grown)
 struct pixel_stack_rec_ptr *grown;
{
 unsigned long num,lcv;
 int cmp;

 if (grown->num_lists == 0)
    {printf("check_pixel_stack_rec_ptr no list...\n");
    return /*NO_ERROR*/;}
 for (num = 0,lcv = 1;lcv < grown->num_lists; )
    if ((cmp = sort_2_echo_stack_list_rec_ptr_proc(
                 &(grown->lists[num]),&(grown->lists[lcv]))) < 0)
       {num += 1;
        lcv += 1;}
      else break;
 if (lcv == grown->num_lists)
    printf("check_pixel_stack_rec_ptr all sorted...\n");
   else
    {if (cmp > 0)
        printf("check_pixel_stack_rec_ptr  %ld > %ld not sorted...\n",num,lcv);
       else
        printf("check_pixel_stack_rec_ptr  %ld == %ld duplicate...\n",num,lcv);
     printf("...#%ld top = %p vx = %ld vy = %ld total = %ld\n",
              num,grown->lists[num]->top.next,(long) grown->lists[num]->valx,
                  (long) grown->lists[num]->valy,
             cnt_stack_xy_rec(grown->lists[num]->top.next));
      printf("...#%ld top = %p vx = %ld vy = %ld total = %ld\n",
              lcv,grown->lists[lcv]->top.next,(long) grown->lists[lcv]->valx,
                  (long) grown->lists[lcv]->valy,
             cnt_stack_xy_rec(grown->lists[lcv]->top.next));
    }
}


/*--------------------------------------------------------------------------
solve_2_echo_shared_pixel_types - ???
---------------------------------------------------------------------------*/

int
solve_2_echo_shared_pixel_types(type_aves,num_type_aves,neigh_2d,resolve,image_mask)
 struct pixel_type_ave_rec *type_aves;
 unsigned long num_type_aves;
 struct buf_2d_rec *neigh_2d,*image_mask;
 struct pixel_stack_rec_ptr *resolve;
{
 unsigned long num, indx;
 struct type_val_rec *cur_pix;
 struct stack_xy_rec *top,*next;
 struct pixel_neighbor_type_rec *pix_neigh;
 long whch,type;
 float diff,diff1,diffx,diffy;
 int err,is_segment,done,is_drop,ok;
 unsigned long total,cnt_type;
 struct neighbor_type_rec *neigh;
 float leftover,dist;
 long over,total_over,act;
 unsigned char done_neighs;
 int times;

 TRACE(printf("solve_2_echo_shared_pixel_types...resolve->num_lists = %d\n",
           resolve->num_lists))
 is_drop = 0;
 done = 0;
 err = NO_ERROR;
 TRACE(printf("+++++++++...\n");cnt_neigh_2d(neigh_2d,resolve);)
 times = 0;
 while ((resolve->num_lists > 0) && !done)
    {
     total_over = cnt_pixel_stack_rec_ptr(resolve);
     PRT(printf(" ...num_lists = %d tot = %d\n",resolve->num_lists,total_over);)
     do 
        {total = 0;
         is_segment = 0;
         act = 0;
         over = 0;
         for (num = 0; num < resolve->num_lists; num++)
            {
             if ((top = resolve->lists[num]->top.next) == NULL) continue;
             while (top != NULL)
                {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(
                        neigh_2d->buf[top->y],(long) top->x,neigh_2d->pixel_depth);
                 neigh = pix_neigh->neigh;
                 if ((neigh->status & LEFT_OVER_WEIGHTS_CHECKED) || (neigh->num_neighs == 0))
                    {act += 1;
                     top = top->next;
                     continue;}
                 neigh->status |= LEFT_OVER_WEIGHTS_CHECKED;
                 cur_pix = pix_neigh->pix;
                 done_neighs = neigh->done_neighs;
                 if (_0Edge[done_neighs][0] > 0)
                    {for (ok = 1,cnt_type = 0; cnt_type < cur_pix->num_types; cnt_type++)
                        if (cur_pix->types[cnt_type].indx != neigh->neighs[0].type)
                           {dist = 1.0 / (float) cur_pix->types[cnt_type].dist;
                            for (leftover = .0,indx = 1; indx <= (long) _0Edge[done_neighs][0]; indx++)
                               leftover += neigh->weights[_0Edge[done_neighs][indx]] * dist;
                            for (indx = 1; indx < neigh->num_neighs; indx++)
                               if (neigh->neighs[indx].type == cur_pix->types[cnt_type].indx)
                                  {leftover += neigh->neighs[indx].conn_fac;
                                   break;}
                            if (leftover > neigh->neighs[0].conn_fac)
                               {/*PRT1(if (neigh->num_neighs > 1)  
                                   printf("===%d/%d num = %d l = %f [0] = %f [1] = %f\n",
                                    (long) top->y,(long) top->x,(long) neigh->num_neighs,leftover,
                                   neigh->neighs[0].conn_fac,neigh->neighs[1].conn_fac);
                                 else printf("===%d/%d num = %d l = %f [0] = %f\n",
                                   (long) top->y,(long) top->x,(long) neigh->num_neighs,leftover,
                                     neigh->neighs[0].conn_fac);)
*/
                                ok = 0;
                                break;}
                           }
                     if (!ok) 
                        {top = top->next;
                         over += 1;
                         continue;}
                    }
                 whch = 0;

                 if ((neigh->num_neighs > 1) &&
                     (neigh->neighs[0].conn_fac == neigh->neighs[1].conn_fac))
                    {diffx = type_aves[neigh->neighs[whch].type].x /
                                (float) type_aves[neigh->neighs[whch].type].num_freqs - 
                             cur_pix->valx;
                     diffx = diffx * diffx;
                     diffy = type_aves[neigh->neighs[whch].type].y /
                                (float) type_aves[neigh->neighs[whch].type].num_freqs - 
                             cur_pix->valy;
                     diffy = diffy * diffy;
                     diff = (float) sqrt((double) (diffx + diffy));
                     for (indx = 1; indx < neigh->num_neighs; indx++)
                        if (neigh->neighs[whch].conn_fac == 
                                           neigh->neighs[indx].conn_fac)
                           {diffx = type_aves[neigh->neighs[indx].type].x /
                                      (float) type_aves[neigh->neighs[indx].type].num_freqs - 
                                    cur_pix->valx;
                            diffx = diffx * diffx;
                            diffy = type_aves[neigh->neighs[indx].type].y /
                                      (float) type_aves[neigh->neighs[indx].type].num_freqs - 
                                    cur_pix->valy;
                            diffy = diffy * diffy;
                            diff1 = (float) sqrt((double) (diffx + diffy));
                            if (diff1 < diff)
                               {whch = indx;
                                diff = diff1;}
                           }
                    }
                 type = neigh->neighs[whch].type;
                 neigh->neighs[0].type = type;
                 neigh->num_neighs = 1;
                 neigh->status |= TYPE_RESOLVED;
                 type_aves[type].x += cur_pix->valx;
                 type_aves[type].y += cur_pix->valy;
                 type_aves[type].num_freqs += 1;
                 update_neighs(neigh,neigh_2d,(long) top->y,(long) top->x,
                                      type);
                 is_segment = 1;
                 if (top->next != NULL) top->next->last = top->last;
                 if (top->last != NULL) top->last->next = top->next;
                 next = top->next;
                 c_free(top);
                 top = next;
                 is_segment = 1;
                 total += 1;
                }
             if (resolve->lists[num]->top.next == NULL) 
                {is_drop = 1;}
             if (err != NO_ERROR) break;
            }
         PRT(printf("solve_2_echo_shared_pixel_types...is_drop = %d\n",is_drop))
         if (is_drop)
            {is_drop = 0;
             drop_empty_stack_lists(resolve);
            }
         PRT(printf("is_segment = %d total_over = %d not-act = %d over = %d segmented = %d resolve.num_lists = %d\n",
           is_segment,total_over,act,over,total,resolve->num_lists);)
        }
     while (is_segment && (resolve->num_lists > 0));
     if (err != NO_ERROR) break;
/*

     break;
     times += 1;
*/

     if ((resolve->num_lists == 0) ||
         ((err = solve_deadlock_pixels(type_aves,num_type_aves,
                         neigh_2d,resolve,image_mask,&done)) != NO_ERROR))
        break;
/*
     if (times == 1) done = 1;
*/
    }
 TRACE(printf("solve_2_echo_shared_pixel_types...err = %d done = %d\n",err,done))
 drop_empty_stack_lists(resolve);
 TRACE(printf("    resolve_2 total = %d\n",cnt_pixel_stack_rec_ptr(resolve)))

 TRACE(for (lcv = 0; lcv < num_type_aves; lcv++)
    {printf("%d) solve_2_echo_shared_pixel_types...avex = %f avey = %f num_freqs = %d\n",lcv,
                   type_aves[lcv].x / (float) type_aves[lcv].num_freqs,
                   type_aves[lcv].y / (float) type_aves[lcv].num_freqs,
                   type_aves[lcv].num_freqs);
    }
   )
 TRACE(printf("solve_2_echo_shared_pixel_types...8\n"))

 return err;
}


/*--------------------------------------------------------------------------
type_xys - ???
---------------------------------------------------------------------------*/

int
type_xys(_2d_types,neigh_2d,_2d1,_2d2,histo)
 struct buf_2d_rec *_2d_types,*neigh_2d,*_2d1,*_2d2;
 struct histo_params_rec *histo;
{
 struct slice_roi_win_rec *slice_roi_win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 struct type_val_rec *cur_pix;
 struct neighbor_type_rec *neigh;
 int err;
 int none,p1,p0,p2,p10,p20;
 long row,col;
 double v1,v2;

 slice_roi_win = (struct slice_roi_win_rec *) 
                  GetHistoSliceRoiWinRec(histo,HISTO_MULTI_D);
 slice_roi = &(slice_roi_win->slice_roi);
 TRACE(printf("type_xys...\n");)
 none = p0 = p1 = p2 = p10 = p20 = 0;
 for (row = 0; row < _2d_types->dimy; row++)
    for (col = 0; col < _2d_types->dimx; col++)
       {cur_pix = (struct type_val_rec *) get_1d_buf_value(
                          _2d_types->buf[row],col,_2d_types->pixel_depth);
        if (cur_pix == 0)
           {none += 1;
            continue;}
          else if (cur_pix->num_types == 1)
           {if (cur_pix->types[0].indx != 0) continue;
            v1 = _2d1->GetVal(_2d1,row,col);
            v2 = _2d2->GetVal(_2d2,row,col);
            if ((v1 != .0) || (v2 != .0))
               {if ((err = EnterSliceRoiRecPt(slice_roi,NULL,"bbb",
                    (unsigned short) DRAW_POINT,0,(float) col,(float) row)) != NO_ERROR)
                   return err;
                TRACE(printf("=%d/%d = %f %f  vy = %d vx = %d\n",row,col,v1,v2,(long) cur_pix->valy,(long)cur_pix->valx
                             );)
                p1 += 1;
                if (v1 == .0) p10 += 1;
                if (v2 == .0) p20 += 1;}
           }
          else
           {neigh = (struct neighbor_type_rec *)
                 get_1d_buf_value(neigh_2d->buf[row],col,neigh_2d->pixel_depth);
            if (neigh->status & TYPE_RESOLVED)
               {if (neigh->neighs[0].type != 0) continue;
                v1 = _2d1->GetVal(_2d1,row,col);
                v2 = _2d2->GetVal(_2d2,row,col);
                if ((v1 != .0) || (v2 != .0))
                   {if ((err = EnterSliceRoiRecPt(slice_roi,NULL,"ccc",
                        (unsigned short) DRAW_POINT,0,(float) col,(float) row)) != NO_ERROR)
                       return err; 
                    TRACE(printf("==%d/%d = %f %f\n",row,col,v1,v2);)
                    p2 += 1;
                    if (v1 == 0) p10 += 1;
                    if (v2 == 0) p20 += 1;}
               }
              else
               {
                p0 += 1;}
           }
       }
 if ((roi = get_roi(&(slice_roi_win->slice_roi),"bbb")) != NULL)
    roi->status |= ROI_MARKER;
 if ((roi = get_roi(&(slice_roi_win->slice_roi),"ccc")) != NULL)
    roi->status |= ROI_MARKER;

 TRACE(printf("type_xys...none = %d p0 = %d p1 = %d  p10 = %d  p2 = %d p20 = %d  \n",
              none,p0,p1,p10,p2,p20))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
resolve_xys - ???
---------------------------------------------------------------------------*/

int
resolve_xys(resolve,neigh_2d,histo)
 struct pixel_stack_rec_ptr *resolve;
 struct buf_2d_rec *neigh_2d;
 struct histo_params_rec *histo;
{
 struct slice_roi_win_rec *slice_roi_win;
 struct slice_roi_rec *slice_roi;
 struct roi_rec *roi;
 struct type_val_rec *pix;
 unsigned long lcv,cnt,indx;
 char str[30];
 struct stack_xy_rec *top;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 int err;
 int none,p1,p0,nnone,n1,n0;

 PRT1(printf("resolve_xys...histo = %u num_lists = %d\n",histo,
             resolve->num_lists));
 slice_roi_win = (struct slice_roi_win_rec *) 
             GetHistoSliceRoiWinRec(histo,HISTO_MULTI_D);
 slice_roi = &(slice_roi_win->slice_roi);
 PRT1(printf("slice_roi = %u  \n",slice_roi));
 if ((roi = get_roi(slice_roi,"TTT")) != NULL)
    delete_roi(slice_roi,roi);
 if ((roi = get_roi(slice_roi,"none")) != NULL)
    delete_roi(slice_roi,roi);
 if ((roi = get_roi(slice_roi,"p0")) != NULL)
    delete_roi(slice_roi,roi);
 if ((roi = get_roi(slice_roi,"1")) != NULL)
    delete_roi(slice_roi,roi);
 if ((roi = get_roi(slice_roi,"2")) != NULL)
    delete_roi(slice_roi,roi);
 if ((roi = get_roi(slice_roi,"3")) != NULL)
    delete_roi(slice_roi,roi);
 none = p1 = p0 = 0;
 nnone = n1 = n0 = 0;
 for (cnt = 0,lcv = 0; lcv < resolve->num_lists; lcv++)
    {if (resolve->lists[lcv]->top.next == NULL) continue;
     if ((err = EnterSliceRoiRecPt(slice_roi,NULL,"TTT",
                (unsigned short) DRAW_POINT,0,
                (float) resolve->lists[lcv]->valx,
                (float) resolve->lists[lcv]->valy)) != NO_ERROR)
        return err; 
     for (top = resolve->lists[lcv]->top.next;top != NULL; top = top->next,cnt++)
        {pix_neigh = (struct pixel_neighbor_type_rec *) 
              get_1d_buf_value(neigh_2d->buf[top->y],(long) top->x,neigh_2d->pixel_depth);
         if ((neigh = pix_neigh->neigh) == NULL)
            nnone += 1;
           else if (neigh->num_neighs == 0)
            n0 += 1;
           else
            {PRT1(if (neigh->status & TYPE_RESOLVED) 
                     printf("%d/%d TYPE_RESOLVED\n",(long) top->y,(long) top->x);)
             n1 += 1;}
         pix = pix_neigh->pix;
         if (pix == NULL)
            {none += 1;
             if ((err = EnterSliceRoiRecPt(slice_roi,NULL,"none",
                 (unsigned short) DRAW_POINT,0,(float) top->x,
                 (float) top->y)) != NO_ERROR)
               return err;
            }
           else if (pix->num_types == 0)
            {p0 += 1;
             if ((err = EnterSliceRoiRecPt(slice_roi,NULL,"p0",
                 (unsigned short) DRAW_POINT,0,(float) top->x,
                 (float) top->y)) != NO_ERROR)
                return err;}
           else
            {p1 += 1;
             for (indx = 0; indx < pix->num_types; indx++)
                {sprintf(str,"%ld",(long) pix->types[indx].indx + 1);
                 if ((err = EnterSliceRoiRecPt(slice_roi,NULL,str,
                    (unsigned short) DRAW_POINT,0,(float) top->x,
                    (float) top->y)) != NO_ERROR)
                   return err;
                 if ((roi = get_roi(&(slice_roi_win->slice_roi),str)) != NULL)
                    roi->status |= ROI_MARKER;
                }
            }
        }
   }
 if ((roi = get_roi(&(slice_roi_win->slice_roi),"TTT")) != NULL)
    roi->status |= ROI_MARKER;
 if ((roi = get_roi(&(slice_roi_win->slice_roi),"none")) != NULL)
    roi->status |= ROI_MARKER;
 if ((roi = get_roi(&(slice_roi_win->slice_roi),"p0")) != NULL)
    roi->status |= ROI_MARKER;
 PRT1(printf("resolve_xys none = %d p0 = %d p1 = %d \n",none,p0,p1);
       printf("resolve_xys nnone = %d n0 = %d n1 = %d \n",nnone,n0,n1))
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
cnt_2_echoes - ???
---------------------------------------------------------------------------*/

void
cnt_2_echoes(_2d1,_2d2)
 struct buf_2d_rec *_2d1,*_2d2;
{
 long row,col,none,p1,p2,p3,p10,p20;
 double v1,v2;

 none = p3 = p1 = p2 = p10 = p20 = 0;
 for (row = 0; row < _2d1->dimy; row++)
    for (col = 0; col < _2d1->dimx; col++)
       {if ((v1 = _2d1->GetVal(_2d1,row,col)) != .0)
           {p1 += 1;
            p3 += 1;}

        if ((v2 = _2d2->GetVal(_2d2,row,col)) != .0)
           {p2 += 1;
            p3 += 1;}
        if ((v1 == 0) && (v2 == 0)) none += 1;
          else if (v1 == 0) p10 += 1;
          else if (v2 == 0) p20 += 1;
       }
 printf("cnt_2_echoes none = %ld p3 = %ld p1 = %ld p10 = %ld  p2 = %ld p20 = %ld\n",
           none,p3,p1,p10,p2,p20);
}


/*--------------------------------------------------------------------------
cnt_neigh_2d - ???
---------------------------------------------------------------------------*/

int
cnt_neigh_2d(neigh_2d,resolve)
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 struct stack_xy_rec *top;
 int none,n0,n1;

 none = n0 = n1 = 0;
 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;

     while (top != NULL)
        {pix_neigh = (struct pixel_neighbor_type_rec *) 
                   get_1d_buf_value(neigh_2d->buf[top->y],
                         (long) top->x,neigh_2d->pixel_depth);
         neigh = pix_neigh->neigh;
         if (neigh == NULL)
            none += 1;
           else if (neigh->num_neighs == 0) n0 += 1;
           else n1 += 1;
         top = top->next;
        }
    }
 printf("cnt_neigh_2d none = %d n0 = %d n1 = %d\n",
           none,n0,n1);
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
incompatible_pixels_by_neighbors - ???
---------------------------------------------------------------------------*/

int
incompatible_pixels_by_neighbors(type_aves,num_type_aves,neigh_2d,resolve)
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num;
 struct stack_xy_rec *top,*next;
 long type;
 int err,is_segment,is_drop_empty;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;

 PRT1(printf("incompatible_pixels_by_neighbors...\n");)
 is_drop_empty = 0;
 err = NO_ERROR;
 while (resolve->num_lists > 0)
    {do
       {is_segment = 0;
        for (num = 0; num < resolve->num_lists; num++)
           {if ((top = resolve->lists[num]->top.next) == NULL) continue;
            while (top != NULL)
               {pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(
                        neigh_2d->buf[(long) top->y],(long) top->x,
                        neigh_2d->pixel_depth);
                TRACE(printf("...y = %d x = %d ",(long) top->y,(long) top->x);)
                neigh = pix_neigh->neigh;
                incompatible_type_by_neighbors(neigh,pix_neigh->pix,(long) top->x,
                        (long) top->y,neigh_2d);
                if (neigh->num_neighs > 0)
                   {type = neigh->neighs[0].type;
                    update_neighs(neigh,neigh_2d,(unsigned long) top->y,(long) top->x,
                                      type);
                    if (top->next != NULL) top->next->last = top->last;
                    if (top->last != NULL) top->last->next = top->next;
                    next = top->next;
                    c_free(top);
                    is_segment = 1;
                    top = next;
                   }
                  else top = top->next;
                }
            if (resolve->lists[num]->top.next == NULL) is_drop_empty = 1;
            if (err != NO_ERROR) break;
           }
         if (is_drop_empty)
            {is_drop_empty = 0;
             if ((err = drop_empty_stack_lists(resolve)) != NO_ERROR)
                break;
            }
        }
     while (is_segment && (resolve->num_lists > 0));
     if (err != NO_ERROR) break;
    }
 return err;
}


/*--------------------------------------------------------------------------
incompatible_pixels_by_ave - ???
---------------------------------------------------------------------------*/

int
incompatible_pixels_by_ave(type_aves,num_type_aves,neigh_2d,resolve)
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;
 struct buf_2d_rec *neigh_2d;
 struct pixel_stack_rec_ptr *resolve;
{
 long num,indx,whch;
 struct type_val_rec *cur_pix;
 struct stack_xy_rec *top;
 float diff,diff1,diffx,diffy;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 int err;

 PRT1(printf("incompatible_pixels_by_ave...\n");)
 err = NO_ERROR;
 PRT1(p0 = p1 = p2 = 0;)
 for (num = 0; num < resolve->num_lists; num++)
    {if ((top = resolve->lists[num]->top.next) == NULL) continue;
     while (top != NULL)
        {
         pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[top->y],
                        (long) top->x,neigh_2d->pixel_depth);
         cur_pix = pix_neigh->pix;
         whch = 0;
         diffx = type_aves[0].x /
                      (float) type_aves[0].num_freqs - cur_pix->valx;
         diffx = diffx * diffx;
         diffy = type_aves[0].y /
                      (float) type_aves[0].num_freqs - cur_pix->valy;
         diffy = diffy * diffy;
         diff = (float) sqrt((double) (diffx + diffy));
         for (indx = 1; indx < num_type_aves; indx++)
            {diffx = type_aves[indx].x /
                      (float) type_aves[indx].num_freqs - cur_pix->valx;
             diffx = diffx * diffx;
             diffy = type_aves[indx].y /
                      (float) type_aves[indx].num_freqs - cur_pix->valy;
             diffy = diffy * diffy;
             diff1 = (float) sqrt((double) (diffx + diffy));
             if (diff1 < diff)
                {whch = indx;
                 diff = diff1;}
            }
         TRACE(if (whch == 0) p0 += 1;
           else if (whch == 1) p1 += 1;
           else p2 += 1;
           )
         neigh = pix_neigh->neigh;
         neigh->status |= TYPE_RESOLVED;
         neigh->neighs[0].type = whch;
         neigh->num_neighs = 1;
         top = top->next;
        }
    }
 return err;
}


/*--------------------------------------------------------------------------
compute_2_echo_weights - ???
---------------------------------------------------------------------------*/

int
compute_2_echo_weights(neigh,_2d1,_2d2,x,y)
 struct neighbor_type_rec *neigh;
 struct buf_2d_rec *_2d1,*_2d2;
 long x,y;
{
 long lcv,cnt,x1,y1;
 double vx,vy,v1[8],v2[8];
 unsigned char valid,indx;
 float temp,dist,diffx,diffy,temp1;

 vx = _2d1->GetVal(_2d1,y,x);
 vy = _2d2->GetVal(_2d2,y,x);
 for (valid = 0,lcv = 0; lcv < 8; lcv++)
    {
     x1 = x + neighbor_Offset[lcv][0];
     if ((x1 < 0) || (x1 >= _2d1->dimx)) continue;
     y1 = y + neighbor_Offset[lcv][1];
     if ((y1 < 0) || (y1 >= _2d1->dimy)) continue;
     valid |= _EdgeBit[lcv];
     v1[lcv] = _2d1->GetVal(_2d1,y1,x1);
     v2[lcv] = _2d2->GetVal(_2d2,y1,x1);
    }
 for (lcv = 0; lcv < 8; lcv++)
    {if (valid & _EdgeBit[lcv])
        {if ((vx == v1[lcv]) && (vy == v2[lcv])) 
            neigh->weights[lcv] = _EdgeDistanceWeights[lcv % 2];
           else
            {diffx = (float) (vx - v1[lcv]);
             diffy = (float) (vy - v2[lcv]);
             dist = diffx * diffx + diffy * diffy;
             dist = (float) sqrt((double) dist);
             temp1 = _EdgeDistance[lcv % 2] * dist;
             if (temp1 < .0) temp1 = -temp1;
             neigh->weights[lcv] = temp1;
             for (cnt = 0; cnt < 2; cnt++)
                {indx = _EdgeGroupIndxs[lcv][cnt];
                 if (valid & _EdgeBit[indx])
                    {diffx = (float) (vx - v1[indx]);
                     diffy = (float) (vy - v2[indx]);
                     dist = diffx * diffx + diffy * diffy;
                     dist = (float) sqrt((double) dist);
                     temp = _EdgeDistance[indx % 2] * dist;
                     if (temp < .0) temp = -temp;
                     neigh->weights[lcv] += temp;
                    }
                }
             neigh->weights[lcv] = neigh->weights[lcv] * temp1 + _EdgeDistance[lcv % 2];
             neigh->weights[lcv] = 1.0 / neigh->weights[lcv];
            }
         }
        else neigh->weights[lcv] = .0;
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
define_type_distance - ???
---------------------------------------------------------------------------*/

int
define_type_distance(seg,_2dx,_2dy,image_mask)
 struct segment_rec *seg;
 struct buf_2d_rec *_2dx,*_2dy,*image_mask;
{
 long indx,total_grown_pixels,cnt,row,col,lcv,total,whch,x,y,cnt_pixels;
 unsigned long valx,valy;
 struct type_val_rec *cur_type,*type;
 struct stack_list_rec *list;
 int err;
 struct buf_2d_rec *done_grown;
 struct pixel_stack_rec_ptr *grow,new;
 float dist;
 struct buf_2d_rec mask;
 double val;

 init_buf_2d_rec(&mask);
 if ((err = SetupBuf2dRec(&mask,seg->histo_types.dimx,seg->histo_types.dimy,1,1))
        != NO_ERROR)
    return err;

 for (total_grown_pixels = 0,row = 0; row < _2dx->dimy; row++)
    for (col = 0; col < _2dx->dimx; col++)
       {
        if ((image_mask != NULL) && (image_mask->status4 & BUF_NON_EMPTY))
           {if (get_1d_buf_value(image_mask->buf[row],col,image_mask->pixel_depth) == 0)
               {
                continue;}
           }
        val = _2dx->GetVal(_2dx,row,col);
        valx = (unsigned long) (val + .5);
        val = _2dy->GetVal(_2dy,row,col);
        valy = (unsigned long) (val + .5);
        if (type = (struct type_val_rec *) get_1d_buf_value(
               seg->histo_types.buf[valy],valx,
               seg->histo_types.pixel_depth))
           continue;
        if (get_1d_buf_value(mask.buf[valy],valx,mask.pixel_depth) == 0)
           {set_1d_buf_value(mask.buf[valy],valx,mask.pixel_depth,1);
            total_grown_pixels += 1;}
       }
 if ((err != NO_ERROR) || (total_grown_pixels == 0))
    {free_buf_2d_rec(&mask);
     return err;}
 PRT2(printf(" total_grown_pixels = %d\n",total_grown_pixels);)
 for (whch = 0; whch < seg->num_types; whch++)
    {cnt_pixels = total_grown_pixels;
     if (seg->types[whch].is_done_grow) continue;
     grow = &(seg->types[whch].grow_stack);
     done_grown = &(seg->types[whch].done_grown);
     do
        {
         init_pixel_stack_rec_ptr(&new);
         PRT2(printf("whch = %d num_lists = %d\n",whch,(long) grow->num_lists))
         for (cnt = 0; cnt < grow->num_lists; cnt++)
            {list = grow->lists[cnt];
             if ((cur_type = (struct type_val_rec *) get_1d_buf_value(
                     seg->histo_types.buf[list->valy],(long) list->valx,
                     seg->histo_types.pixel_depth)) == 0)
                 continue;
/*
             PRT(for (lcv = 0; lcv < cur_type->num_types; lcv++)
                printf("%d) vy/vx = %d/%d type/dist = %d/%d\n",lcv,
                    (long) list->valy,(long) list->valx,(long) cur_type->types[lcv].indx,
                    (long) cur_type->types[lcv].dist))
*/
             for (lcv = 0; lcv < (unsigned long) cur_type->num_types; lcv++)
                if (cur_type->types[lcv].indx == whch)
                   {dist = cur_type->types[lcv].dist;
                    break;}

             dist += 1;
             for (lcv = 0; lcv < 8; lcv++)
                {x = list->valx + neighbor_Offset[lcv][0];
                 if ((x < 0) || (x >= done_grown->dimx)) continue;
                 y = list->valy + neighbor_Offset[lcv][1];
                 if ((y < 0) || (y >= done_grown->dimy)) continue;
                 if (get_1d_buf_value(done_grown->buf[y],x,done_grown->pixel_depth))
                    continue;
                 set_1d_buf_value(done_grown->buf[y],x,done_grown->pixel_depth,1);
                 if (type = (struct type_val_rec *) get_1d_buf_value(
                        seg->histo_types.buf[y],x,seg->histo_types.pixel_depth))
                    {
                     for (indx = 0; indx < (unsigned long) type->num_types; indx++)
                        if (type->types[indx].indx == whch)
                           {break;}
                     if (indx != type->num_types) continue;
                    }
                   else
                    {total = 0;
                     if ((err = get_ptr(&type,&total,1,sizeof(*type))) != NO_ERROR)
                        break;
                     init_type_val_rec(type);
                     type->valy = y;
                     type->valx = x;
                     set_1d_buf_value(seg->histo_types.buf[y],x,
                                seg->histo_types.pixel_depth,type);
                    }
                 total = type->num_types;
                 if ((err = get_ptr(&(type->types),&total,  
                             (long) 1,sizeof(*(type->types)))) != NO_ERROR)
                    {free_pixel_stack_rec_ptr(&new,1);
                     free_buf_2d_rec(&mask);
                     return err;}
                 type->types[type->num_types].dist = dist;
                 type->types[type->num_types].indx = whch;
                 type->num_types += 1;
                 if ((cnt_pixels > 0) && get_1d_buf_value(mask.buf[y],x,mask.pixel_depth))
                    cnt_pixels -= 1;

                 if ((err = setup_2_echo_stack_list_rec(&new,x,y,&list,200)) != NO_ERROR)
                    {free_pixel_stack_rec_ptr(&new,1);
                     free_buf_2d_rec(&mask);
                     return err;}
                }
            }
         free_pixel_stack_rec_ptr(grow,1);
         *grow = new;
         PRT2(printf("...NEXT whch = %d grow->num_lists = %d cnt_pixels = %d\n",whch,(long) grow->num_lists,cnt_pixels))
        }
     while ((cnt_pixels > 0) && (grow->num_lists > 0));
     if (grow->num_lists == 0) seg->types[whch].is_done_grow = 1;
     PRT2(printf("  whch = %d cnt(done_grow) = %d\n",whch,CntValBuf2dRec(done_grown,(double) 0)))
    }
 free_buf_2d_rec(&mask);
 PRT2(printf("wwww  define_type_distance...done\n");)
                            
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
get_type_xys - ???
---------------------------------------------------------------------------*/

int
get_type_xys(neigh_2d,resolve,image_mask,type)
 struct buf_2d_rec *neigh_2d,*image_mask;
 struct pixel_stack_rec_ptr *resolve;
 int type;
{
 long lcv,row,col;
 struct type_val_rec *pix;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;
 struct stack_list_rec *list;
 struct stack_xy_rec *xy;
 int err;

 err = NO_ERROR;
 for (lcv = 0,row = 0; row < neigh_2d->dimy; row++)
    for (col = 0; col < neigh_2d->dimx; col++,lcv++)
       {
        if ((image_mask != NULL) && (image_mask->status4 & BUF_NON_EMPTY))
           {if (get_1d_buf_value(image_mask->buf[row],col,image_mask->pixel_depth) == 0)
               continue;
           }
        pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[row],
                         col,neigh_2d->pixel_depth);
        pix = pix_neigh->pix;
        neigh = pix_neigh->neigh;
        if ((neigh != NULL) && (neigh->neighs[0].type == type))
	    /* FIXME:  Added final argument 200 in line below by analogy
	       with other calls to this function, but could not immediately
	       verify that this is correct.  -PWH 19990426 */
           {if (((err = setup_2_echo_stack_list_rec(resolve,(long) pix->valx,(long) pix->valy,
                         &list,200)) != NO_ERROR) ||
                ((err = setup_stack_xy_rec(list,col,row,&xy)) != NO_ERROR))
               return err; 
           }
       }
 return err;
}


/*--------------------------------------------------------------------------
recompute_neigh_weights - ???
---------------------------------------------------------------------------*/

int
recompute_neigh_weights(neigh_2d,resolve,image_mask)
 struct buf_2d_rec *neigh_2d,*image_mask;
 struct pixel_stack_rec_ptr *resolve;
{
 long num;
 struct stack_xy_rec *top;
 struct neighbor_type_rec *neigh;
 struct pixel_neighbor_type_rec *pix_neigh;

 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {
         pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[top->y],
                         (long) top->x,neigh_2d->pixel_depth);
         neigh = pix_neigh->neigh;
         neigh->status = 0;
         top = top->next;
        }
    }

 for (num = 0; num < resolve->num_lists; num++)
    {top = resolve->lists[num]->top.next;
     while (top != NULL)
        {
         pix_neigh = (struct pixel_neighbor_type_rec *) get_1d_buf_value(neigh_2d->buf[top->y],
                         (long) top->x,neigh_2d->pixel_depth);
         neigh = pix_neigh->neigh;
         neigh->xy_ptr = top;
         neighbor_weights(neigh,pix_neigh->pix,(long) top->x,(long) top->y,
                           neigh_2d,image_mask);               
         top = top->next;
        }
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
setup_pixel_type_ave_rec - ???
---------------------------------------------------------------------------*/

int
setup_pixel_type_ave_rec(type_aves,num_type_aves,num_types)
 struct pixel_type_ave_rec **type_aves;
 long *num_type_aves,num_types;
{
 int err;
 long lcv;

 *num_type_aves = 0;
 if ((err = get_ptr(type_aves,num_type_aves,num_types,
          (size_t) sizeof(**type_aves))) != NO_ERROR)
    return err;
 for (lcv = 0; lcv < num_types; lcv++)
    init_pixel_type_ave_rec(&((*type_aves)[lcv]));
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
segment_2_echo_pixels - ???
---------------------------------------------------------------------------*/

int
segment_2_echo_pixels(seg,_2d1,_2d2,pixel_map,histo,option)
 struct segment_rec *seg;
 struct buf_2d_rec *_2d1,*_2d2,*pixel_map;
 struct histo_params_rec *histo;
 int option;
{
 struct pixel_neighbor_type_rec *pix_neighs;
 struct pixel_stack_rec_ptr resolve;
 struct buf_2d_rec neigh_2d,*image_mask;
 long depth;
 struct pixel_type_ave_rec *type_aves;
 long num_type_aves;
 int err;

 TRACE(printf("segment_2_echo_pixels option = %x\n",option))
 if (seg->image_mask.status4 & BUF_NON_EMPTY)
    {if (CntNonValBuf2dRec(&(seg->image_mask),(double) 0) == 0) return NO_ERROR;
     image_mask = &(seg->image_mask);
    }
   else image_mask = NULL;
/*
 image_polarity(_2d1,_2d2,2,2);
*/
 pixel_map->status4 &= ~BUF_DATA_VALID;
 if ((err = define_type_distance(seg,_2d1,_2d2,image_mask)) != NO_ERROR)
    {
     return err;}

 PRT(printf("segment_2_echo_pixels 2\n"))
 pix_neighs = NULL;
 init_pixel_stack_rec_ptr(&resolve);
 init_buf_2d_rec(&neigh_2d);
 if (((err = setup_pixel_type_ave_rec(&type_aves,&num_type_aves,seg->num_types))
                == NO_ERROR) &&
     ((err = SetupBuf2dRec(&neigh_2d,_2d1->dimx,_2d1->dimy, 
                   sizeof(void *) * 8,1))  == NO_ERROR) &&
     ((err = _2_echo_statistics(type_aves,num_type_aves,&(seg->histo_types),
                   image_mask,_2d1,_2d2,&pix_neighs,&resolve,&neigh_2d)) == NO_ERROR))
    {
     TRACE(printf("segment_2_echo 5 resolve.num_lists = %d\n",resolve.num_lists))
     if ((resolve.num_lists > 0) &&
         ((err = setup_neighbor_type_rec(&neigh_2d,&resolve,
                        _2d1,_2d2,image_mask,2)) == NO_ERROR))
        {TRACE(cnt_neigh_2d(&neigh_2d,&resolve);)
         PRT1(printf("before resolve_2 total = %d  s resolve.num_lists = %d\n",
                cnt_pixel_stack_rec_ptr(&resolve),resolve.num_lists);)

         err = solve_2_echo_shared_pixel_types(type_aves,num_type_aves,
                              &neigh_2d,&resolve,image_mask);
/*
         suggest_types(neigh_2d,resolve,image_mask);
*/
         PRT1(printf("after resolve_2 err = %d total = %d  s resolve.num_lists = %d\n",
                       err,cnt_pixel_stack_rec_ptr(&resolve),resolve.num_lists);)

         if ((err == NO_ERROR) && (resolve.num_lists > 0))
            {
             /*PRT1(resolve_xys(&resolve,&neigh_2d,histo);)*/

             if (option & INCOMPATIBLE_TYPE_BY_NEIGHBOR)
                incompatible_pixels_by_neighbors(type_aves,num_type_aves,
                                     &neigh_2d,&resolve);
               else 
                incompatible_pixels_by_ave(type_aves,num_type_aves,
                                     &neigh_2d,&resolve);
            }


/*
         free_pixel_stack_rec_ptr(&resolve,1);
         PRT1(printf("2nd white = %d\n");)
         if ((err = get_type_xys(&neigh_2d,&resolve,image_mask,2)) == NO_ERROR)
            {PRT1(printf("2nd resolve_2 total = %d  s resolve.num_lists = %d\n",
                cnt_pixel_stack_rec_ptr(&resolve),resolve.num_lists);)
             recompute_neigh_weights(&neigh_2d,&resolve,image_mask);
             err = solve_2_echo_shared_pixel_types(type_aves,num_type_aves,
                              &neigh_2d,&resolve,image_mask);
            }

*/
        }

     if (err == NO_ERROR)
        {depth = find_num_bits_needed(seg->num_types + 1);
         if ((err = SetupBuf2dRec(pixel_map,_2d1->dimx,_2d1->dimy,depth,1)) == 
                        NO_ERROR)
            if ((err = segment_pixel_map(pixel_map,&neigh_2d,image_mask)) ==
                     NO_ERROR)
               pixel_map->status4 |= BUF_DATA_VALID;
        
        }
    }
 free_pixel_stack_rec_ptr(&resolve,1);
 if (neigh_2d.status4 & BUF_NON_EMPTY) free_neighbor_type_rec(&neigh_2d);
 free_buf_2d_rec(&neigh_2d);
 c_free(pix_neighs);
 if (num_type_aves > 0) c_free(type_aves);
 TRACE(printf("segment_2_echo_pixels...err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
SetupHistoPixelTypeOrder - ???
---------------------------------------------------------------------------*/

int
SetupHistoPixelTypeOrder(histo,priority,is_quadrant_allow,is_quadrant,quadrant_label,histo_type2)
 struct histo_params_rec *histo;
 struct strs_rec *priority;
 int is_quadrant_allow,*is_quadrant;
 struct strs_rec *quadrant_label;
 unsigned short histo_type2;
{
 unsigned long indx,total,lcv,start_indx,start_indx1;
 char *str;
 int err;
 struct roi_rec *roi,*cur_roi;
 struct slice_roi_win_rec *slice_roi_win;
 struct slice_roi_rec *slice_roi;
 struct str_value_rec *ptr;

 TRACE(printf("\n\nSetupHistoPixelTypeOrder...1\n"))

 free_strs_rec(&(histo->pixel_type_order));
 slice_roi_win = (struct slice_roi_win_rec *) 
                GetHistoSliceRoiWinRec(histo,histo_type2);
 slice_roi = &(slice_roi_win->slice_roi);
  TRACE(printf("SetupHistoPixelTypeOrder...slice_roi = %u\n",slice_roi))
 if ((cur_roi = exclude_roi_of_type(slice_roi,ROI_MARKER,1)) == NULL)
    return CANCEL;
 roi = cur_roi;
 err = NO_ERROR;
 if (is_quadrant != NULL) *is_quadrant = 0;
 do
    {if ((roi != NULL) && ((roi->status & HISTO_EDITED_ROI) || !(roi->status & ROI_TYPE)) &&
         is_roi_non_empty(roi))
        {
         if (is_quadrant_allow)
            {
             if ((find_sub_str(roi->label,":Q",&start_indx) == NO_ERROR) &&
                 (roi->label[start_indx + 2] >= '1') && 
                 (roi->label[start_indx + 2] <= '4'))
                {indx = quadrant_label->num_strs;
                 if ((err = add_str_to_strs_rec(quadrant_label,roi->label)) == NO_ERROR)
                    {*is_quadrant = 1;
                     quadrant_label->strs[indx][start_indx] = '\0';
 PRT(printf("start_indx = %d roi = %s lab = %s\n",start_indx,roi->label,
             quadrant_label->strs[indx]);)
                     if (find_str_in_strs_rec(&(histo->pixel_type_order),
                          quadrant_label->strs[indx],&start_indx1) != NO_ERROR)
                        err = add_str_to_strs_rec(&(histo->pixel_type_order),
                                 quadrant_label->strs[indx]);
                     quadrant_label->strs[indx][start_indx] = ':';
                    }
                }
               else if ((err = add_str_to_strs_rec(quadrant_label,roi->label)) == NO_ERROR)
                if (find_str_in_strs_rec(&(histo->pixel_type_order),
                          roi->label,&start_indx1) != NO_ERROR)
                   err = add_str_to_strs_rec(&(histo->pixel_type_order),roi->label);
            }
           else err = add_str_to_strs_rec(&(histo->pixel_type_order),roi->label);
         if (err != NO_ERROR)
            {free_strs_rec(&(histo->pixel_type_order));
             return err;}
   
         TRACE(printf("roi->label = %s\n",roi->label))
        }
     roi = next_roi(slice_roi,0);
    }
 while ((roi != NULL) && (roi != cur_roi));

 TRACE(printf("SetupHistoPixelTypeOrder..2..\n");
       pr_strs_rec(&(histo->pixel_type_order));)

 if (histo->pixel_type_order.num_strs == 0) return CANCEL;

 if ((histo->pixel_type_order.num_strs > 1) && (priority != NULL))
    {
     total = 0;
     if ((err = get_ptr(&ptr,&total,histo->pixel_type_order.num_strs,
            (size_t) sizeof(*ptr))) != NO_ERROR)
        {free_strs_rec(&(histo->pixel_type_order));
         return err;}
     sort_strs_rec_ascendingly(&(histo->pixel_type_order));
     TRACE(printf("SetupHistoPixelTypeOrder..5..\n"))
     
     for (lcv = 0; lcv < histo->pixel_type_order.num_strs; lcv++)
        {str = histo->pixel_type_order.strs[lcv];
         if (find_str_in_strs_rec(priority,str,&indx) == NOT_FOUND)
            {ptr[lcv].value = priority->num_strs;
             if ((err = add_str_to_strs_rec(priority,str)) != NO_ERROR)
                break;
             priority->status |= SAVE_STRS_REC;
            }
           else ptr[lcv].value = indx;
         ptr[lcv].str = str;
        }
     TRACE(printf("SetupHistoPixelTypeOrder..6..err = %d\n",err))
     if (err == NO_ERROR) 
        {qsort(ptr,total,(size_t) sizeof(*ptr),sort_str_value_rec_proc);
         for (lcv = 0; lcv < histo->pixel_type_order.num_strs; lcv++)
            histo->pixel_type_order.strs[lcv] = ptr[lcv].str;}
     c_free(ptr);
     TRACE(printf("SetupHistoPixelTypeOrder..7..\n");
     pr_strs_rec(&(histo->pixel_type_order));)
    }

 TRACE(printf("SetupHistoPixelTypeOrder err = %d\n\n",err);)
 if (err != NO_ERROR) free_strs_rec(&(histo->pixel_type_order));
   else DeleteRoisOfType(&(slice_roi_win->slice_roi),HISTO_SEGMENTED_ROI,1);
 return err;
}


/*--------------------------------------------------------------------------
setup_segment_2_echo - ???
---------------------------------------------------------------------------*/

int
setup_segment_2_echo(histo,allseg,pixel_type,priority,num_slice_maps,img_dimx,img_dimy)
 struct histo_params_rec *histo;
 struct all_segment_rec *allseg;
 struct pixel_type_rec *pixel_type;
 struct strs_rec *priority;
 unsigned long num_slice_maps,img_dimx,img_dimy;
{
 int err;
 long is_quadrant;
 struct strs_rec quadrant_label;

 TRACE(printf("setup_segment_2_echo...\n"))
 init_strs_rec(&quadrant_label);
 if (((err = SetupHistoPixelTypeOrder(histo,priority,1,&is_quadrant,
                    &quadrant_label,HISTO_MULTI_D)) != NO_ERROR) ||
     ((err = setup_pixel_type_maps(pixel_type,num_slice_maps)) != NO_ERROR))
    {free_strs_rec(&quadrant_label);
     return err;}
 free_all_segment_rec(allseg);
 if ((err = setup_all_segment_rec(allseg,histo,is_quadrant,&quadrant_label,
              img_dimx,img_dimy)) == NO_ERROR)
    err = setup_pixel_type_order(pixel_type,histo);
 TRACE(pr_strs_rec(&(pixel_type->order));
       printf("setup_segment_2_echo...err = %d\n",err))
 free_strs_rec(&quadrant_label);
 return err;
}
