/****************************************************************************
segment_echo.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: segment_echo.c,v 1.6 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <sys/timeb.h>

#include "mri_format.h"
#include "segment.h"
#include "nria_procedures.h"


/*
#define TIME(x) x; fflush(stdout);
#define PRINT(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TIME(x)
#define PRT(x)
#define TRACE(x)
#define PRT1(x)



/* Functions defined in this file */
int segment_1_echo(struct histo_params_rec *histo, struct img_buf_rec *img,
    struct pixel_type_rec *pixel_type, struct strs_rec *priority,
    unsigned long num_slice_maps);
int segment_1_echo_1(struct histo_params_rec *histo, struct img_buf_rec *img,
    struct pixel_type_rec *pixel_type);
int segment_2_echo(struct histo_params_rec *histo, struct img_buf_rec *img,
    struct pixel_type_rec *pixel_type, struct strs_rec *priority,
    unsigned long num_slice_maps);
int segment_2_echo_1(struct histo_params_rec *histo, struct img_buf_rec *img,
    struct all_segment_rec *allseg, struct pixel_type_rec *pixel_type);



/*--------------------------------------------------------------------------
segment_1_echo - ???
--------------------------------------------------------------------------*/

int
segment_1_echo(histo,img,pixel_type,priority,num_slice_maps)
 struct histo_params_rec *histo;
 struct img_buf_rec *img;
 struct pixel_type_rec *pixel_type;
 struct strs_rec *priority;
 unsigned long num_slice_maps;
{
 int err;
 long histo_dimx,histo_dimy,pixel_depth,num;
 struct buf_2d_rec _2d;
 struct slice_roi_win_rec *slice_roi_win;

 TRACE(printf("segment_1_echo...%d  %d\n",pixel_type->num_slice_maps,
             (long) img->cur_slice->num))
 TRACE(printf("segment_1_echo...num_slice_maps = %d\n",pixel_type->num_slice_maps))

 if ((err = SetupHistoPixelTypeOrder(histo,priority,0,NULL,NULL,
                  HISTO_1D)) != NO_ERROR) return err;

 if ((err = setup_pixel_type_maps(pixel_type,num_slice_maps)) != NO_ERROR) return err;
 num = img->cur_slice->num - 1;
 if ((num < 0) || (num >= pixel_type->num_slice_maps))
    return CANCEL;

 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,img->_2d.dimx,img->_2d.dimy,
        img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR)
    return err;
 TRACE(printf("segment_1_echo...sl# = %d\n",img->cur_slice->num))

 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 TRACE(printf("histo_dimx = %d  histo_dimy = %d\n",histo_dimx,histo_dimy);)
 slice_roi_win = (struct slice_roi_win_rec *) 
       GetHistoSliceRoiWinRec(histo,HISTO_1D);

 free_histo_pixel_tissue_type_rec(histo);
 if ((err = setup_segment_rois(&(histo->types),&(histo->total_types),
           &(histo->num_types),&(histo->pixel_type_order),
           &(slice_roi_win->slice_roi),1,0,histo_dimx - 1)) == NO_ERROR)
    {if ((err = RdSlice(img,1,&_2d,4)) == NO_ERROR)
        if ((err = Scale2dPixels(&_2d,&_2d,
               (double) .0,(double) (histo_dimx - 1),
               0,(double) .0,(double) 0,0)) == NO_ERROR)
           {
            err = segment_1_echo_pixels(histo->types,
                histo->num_types,&_2d,pixel_type->slice_maps[num],histo,
                (unsigned long) pixel_type->status);
            if (err == NO_ERROR)
              {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
               pixel_type->status |= PIXEL_TYPE_GROW_REGION;
               TRACE(ptr_2d = pixel_type->slice_maps[num];
                  for (indx = 0; indx < histo->pixel_type_order.num_strs + 1; indx++)
                     printf("1 echo %d = %d\n",indx,cnt_val_buf_2d_rec(ptr_2d,indx));
                  printf("\n\n");
                 )
              }
           }
    }

 if (err == NO_ERROR)
    if ((err = setup_1_echo_histo_pixel_type_order(histo)) == NO_ERROR)
       err = setup_pixel_type_order(pixel_type,histo);

 free_buf_2d_rec(&_2d);
 TRACE(printf("segment_1_echo...err = %d\n",err))
 return err;

}


/*--------------------------------------------------------------------------
segment_1_echo_1 - ???
--------------------------------------------------------------------------*/

int
segment_1_echo_1(histo,img,pixel_type)
 struct histo_params_rec *histo;
 struct img_buf_rec *img; 
 struct pixel_type_rec *pixel_type;
{
 int err;
 long histo_dimx,histo_dimy,pixel_depth,num;

 num = img->cur_slice->num - 1;
 TRACE(printf("segment_1_echo_1...%d  %d\n",pixel_type->num_slice_maps,
             (long) img->cur_slice->num))
 
 if ((num < 0) || (num >= pixel_type->num_slice_maps))
    return CANCEL;
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 TRACE(printf("==histo_dimx = %d  histo_dimy = %d\n",histo_dimx,histo_dimy);)

 if ((err = RdSlice(img,1,&(img->_2d),4)) == NO_ERROR)
    if ((err = Scale2dPixels(&(img->_2d),&(img->_2d),
              (double) .0,(double) (histo_dimx - 1),
              0,(double) .0,(double) .0,0)) == NO_ERROR)
       {
        PRT1(printf("img slice# = %d total_bytes = %d\n",img->cur_slice->slice_num,
               img->_2d.total_bytes))
        err = segment_1_echo_pixels(histo->types,
                histo->num_types,&(img->_2d),
                pixel_type->slice_maps[num],histo,
                (unsigned long) pixel_type->status);
        if (err == NO_ERROR)
           {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
            pixel_type->status |= PIXEL_TYPE_GROW_REGION;
            TRACE(ptr_2d = pixel_type->slice_maps[num];
               for (indx = 0; indx < histo->pixel_type_order.num_strs + 1; indx++)
                 printf("1 echo %d = %d\n",indx,cnt_val_buf_2d_rec(ptr_2d,indx));
               printf("\n\n");
              )
           }
       }
 TRACE(printf("segment_1_echo_1...err = %d\n",err))
 return err;

}



/*--------------------------------------------------------------------------
segment_2_echo - ???
--------------------------------------------------------------------------*/

int
segment_2_echo(histo,img,pixel_type,priority,num_slice_maps)
 struct histo_params_rec *histo;
 struct img_buf_rec *img; 
 struct pixel_type_rec *pixel_type;
 struct strs_rec *priority;
 unsigned long num_slice_maps;
{
 int err,is_quadrant;
 long lcv,histo_dimx,histo_dimy,pixel_depth,num;
 struct buf_2d_rec _2d1,_2d2;
 struct img_buf_rec *img1; 
 struct all_segment_rec allseg;
 struct strs_rec quadrant_label;
 TIME(struct timeb the_time)

 TRACE(printf("segment_2_echo...%d  %d\n",pixel_type->num_slice_maps,
             (long) img->cur_slice->num))
 num = img->cur_slice->num - 1;
 TIME(ftime(&the_time))
 TIME(printf("segment_2_echo sec = %d  msecs = %d num = %d\n",
         (int) the_time.time,the_time.millitm,num))
 init_strs_rec(&quadrant_label);
 if (((err = SetupHistoPixelTypeOrder(histo,priority,1,&is_quadrant,
           &quadrant_label,HISTO_MULTI_D)) != NO_ERROR) ||
     ((err = setup_pixel_type_maps(pixel_type,num_slice_maps)) != NO_ERROR))
    {free_strs_rec(&quadrant_label);
     return err;}
 TRACE(printf("segment_2_echo ===...%d\n",pixel_type->num_slice_maps))
 init_buf_2d_rec(&_2d1);
 init_buf_2d_rec(&_2d2);
 if (((err = SetupBuf2dRec(&_2d1,img->_2d.dimx,img->_2d.dimy,
      img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&_2d2,img->_2d.dimx,img->_2d.dimy,
      img->_2d.pixel_depth,img->_2d.status4 & BUF_VALUE_TYPE)) != NO_ERROR))
    {free_buf_2d_rec(&_2d1);
     free_buf_2d_rec(&_2d2);
     free_strs_rec(&quadrant_label);
     return err;}
 TRACE(printf("segment_2_echo...sl# = %d slice_num = %d\n",
   img->cur_slice->num,img->cur_slice->slice_num))

 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_MULTI_D);
 img1 = pick_first_img_buf_rec_partner(img);
 TRACE(printf("1)label = %s  num = %d\n",img1->cur_slice->img_label,img1->cur_slice->num);)
 TRACE(printf("2)label = %s  num = %d\n",
          img1->partner->cur_slice->img_label,img1->partner->cur_slice->num);)
 init_all_segment_rec(&allseg);
 if ((err = setup_all_segment_rec(&allseg,histo,is_quadrant,&quadrant_label,
                    img->_2d.dimx,img->_2d.dimy)) == NO_ERROR)
    {if (((err = RdSlice(img1,1,&_2d1,4)) == NO_ERROR) &&
         ((err = RdSlice(img1->partner,1,&_2d2,4)) == NO_ERROR))
        {TRACE(
         if (_2d1.status4 & BUF_MIN_MAX_SET) printf("2d1 min max set...\n");
         if (_2d2.status4 & BUF_MIN_MAX_SET) printf("2d2 min max set...\n");
         printf("2d1 minval_set = %f max = %f   2d2 minval_set = %f max = %f\n",
              _2d1.minval_set,_2d1.maxval_set,_2d2.minval_set,_2d2.maxval_set);)
         if (((err = Scale2dPixels(&_2d1,&_2d1,
                    (double) .0,(double) (histo_dimx - 1),
                    0,(double) .0,(double) .0,0)) == NO_ERROR) &&
             ((err = Scale2dPixels(&_2d2,&_2d2,
                    (double) .0,(double) (histo_dimy - 1),
                    0,(double) .0,(double) .0,0)) == NO_ERROR))
            {
             for (lcv = 0; lcv < allseg.num_segs; lcv++)
                if ((err = segment_2_echo_pixels(&(allseg.segs[lcv]),
                    &_2d1,&_2d2,pixel_type->slice_maps[num],histo,
                    (unsigned long) pixel_type->status)) != NO_ERROR)
                   break;
             if (err == NO_ERROR)
                {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
                 pixel_type->status |= PIXEL_TYPE_GROW_REGION;
                 PRT(ptr_2d = pixel_type->slice_maps[num];
                    for (indx = 0; indx < histo->pixel_type_order.num_strs + 1; indx++)
                     printf("2 echo %d = %d\n",indx,cnt_val_buf_2d_rec(ptr_2d,indx));
                   printf("\n\n");
                  )
                }
             }
         }
    }

 if (err == NO_ERROR)
    err = setup_pixel_type_order(pixel_type,histo);

 free_buf_2d_rec(&_2d1);
 free_buf_2d_rec(&_2d2);
 free_all_segment_rec(&allseg);
 free_strs_rec(&quadrant_label);
 TIME(ftime(&the_time);
       printf("segment_2_echo sec = %d  msecs = %d  num = %d end\n",
         (int) the_time.time,the_time.millitm,num))
 TRACE(pr_strs_rec(&(pixel_type->order));
       printf("segment_2_echo...err = %d\n",err))
 return err;

}


/*--------------------------------------------------------------------------
segment_2_echo_1 - ???
--------------------------------------------------------------------------*/

int
segment_2_echo_1(histo,img,allseg,pixel_type)
 struct histo_params_rec *histo;
 struct img_buf_rec *img; 
 struct all_segment_rec *allseg;
 struct pixel_type_rec *pixel_type;
{
 int err;
 long lcv,histo_dimx,histo_dimy,pixel_depth,num;
 struct img_buf_rec *img1; 
 TIME(struct timeb the_time)

 TRACE(printf("segment_2_echo_1...%d  %d\n",pixel_type->num_slice_maps,
             (long) num))
 num = img->cur_slice->num - 1;
 TIME(ftime(&the_time))
 TIME(printf("segment_2_echo sec = %d  msecs = %d num = %d\n",
         (int) the_time.time,the_time.millitm,num))
 
 if ((num < 0) || (num >= pixel_type->num_slice_maps))
    return CANCEL;
 get_histo_dim(histo,&histo_dimx,&histo_dimy,&pixel_depth,HISTO_1D);
 img1 = pick_first_img_buf_rec_partner(img);

 TRACE(printf("1)label = %s  num = %d\n",img1->cur_slice->img_label,img1->cur_slice->num);)
 TRACE(printf("2)label = %s  num = %d\n",
          img1->partner->cur_slice->img_label,img1->partner->cur_slice->num);)

 if ((err = RdCurSliceEchoes(img1,1,4)) == NO_ERROR)
    {
     if (((err = Scale2dPixels(&(img1->_2d),&(img1->_2d),
                    (double) .0,(double) (histo_dimx - 1),
                    0,(double) .0,(double) .0,0)) == NO_ERROR) &&
        ((err = Scale2dPixels(&(img1->partner->_2d),&(img1->partner->_2d),
                    (double) .0,(double) (histo_dimy - 1),
                    0,(double) .0,(double) .0,0)) == NO_ERROR))
       {
        for (lcv = 0; lcv < allseg->num_segs; lcv++)
           if ((err = segment_2_echo_pixels(&(allseg->segs[lcv]),&(img1->_2d),
                &(img1->partner->_2d),pixel_type->slice_maps[num],histo,
                (unsigned long) pixel_type->status)) != NO_ERROR)
              break;
        if (err == NO_ERROR)
          {pixel_type->status &= ~PIXEL_TYPE_SEGMENTED;
           pixel_type->status |= PIXEL_TYPE_GROW_REGION;
           TRACE(ptr_2d = pixel_type->slice_maps[num];
              for (indx = 0; indx < histo->pixel_type_order.num_strs + 1; indx++)
                 printf("2 echo %d = %d\n",indx,cnt_val_buf_2d_rec(ptr_2d,indx));
              printf("\n\n");
             )
          }
       }
    }
 TIME(ftime(&the_time);
       printf("segment_2_echo_1 sec = %d  msecs = %d  num = %d\n",
         (int) the_time.time,the_time.millitm,num))
 TRACE(printf("segment_2_echo_1...err = %d\n",err))
 return err;
}

