/****************************************************************************
show_color_screen.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: show_color_screen.c,v 1.12 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

/* FIXME:  Not needed?
   #include <sys/timeb.h>  */

#include "mri_format.h"
#include "debug.h"
#include "nria_procedures.h"



/* Functions defined in this file */
int WinNewColorRequest(struct image_display_window *win);
int WinImgToColorData(struct image_display_window *win);
int WinGetColorData(struct image_display_window *win);
int WinColorData(struct image_display_window *win);
int WinColorCanvas(struct image_display_window *win);
int WinNewColorData(struct image_display_window *win);
int WinColorScreen(struct image_display_window *win);
int WinNewColorScreen(struct image_display_window *win);
int WinNewColorMultiScreen(struct image_display_window *win);
int WinNewColorScreenForSliceRoiWins(struct image_display_window *win);
int WinNewColorCanvas(struct image_display_window *win);
int WinNewColorMultiCanvas(struct image_display_window *win);
int WinScreen(struct image_display_window *win);
int WinMultiScreen(struct image_display_window *win);
int WinMultiCanvas(struct image_display_window *win);
int WinHistoMultiCanvas(struct image_display_window *win);
int WinScreenCanvas(struct image_display_window *win);
int WinMultiScreenCanvas(struct image_display_window *win);
int WinMultiEchoMultiScreen(struct image_display_window *win);
int WinMultiEchoMultiScreenCanvas(struct image_display_window *win);
int WinHistoNewColorMultiCanvas(struct image_display_window *win);
int WinMultiEchoMultiCanvas(struct image_display_window *win);
int WinMultiEchoNewColorMultiCanvas(struct image_display_window *win);
int win_view_roi_filter(struct image_display_window *win);
int win_filter_image_data(struct image_display_window *win);
int WinNewImgMultiCanvas(struct image_display_window *win);
int WinMultiEchoNewImgMultiCanvas(struct image_display_window *win);



/*---------------------------------------------------------------------------
WinNewColorRequest - ???
---------------------------------------------------------------------------*/

int
WinNewColorRequest(win)
     struct image_display_window *win;
{
  unsigned long lcv;

  if (win->data.num_color_datas == 0)
    return CANCEL;
  for (lcv = 0; lcv < win->data.num_color_datas; lcv++)
    if ((win->data.color_datas[lcv]->status4 & COLOR_DATA_DEFAULT_AND_ID_VALID) &&
        (win->data.color_datas[lcv]->_2d.status4 & BUF_NON_EMPTY))
      win->data.color_datas[lcv]->_2d.status4 &= ~BUF_DATA_VALID;
  return NO_ERROR;
}



/*---------------------------------------------------------------------------
WinImgToColorData - ???
---------------------------------------------------------------------------*/

int
WinImgToColorData(win)
 struct image_display_window *win;
{
 struct buf_2d_rec *_2d,*cur_2d,*_2d1;
 struct color_data_rec *color_data;
 struct img_buf_rec *img;
 unsigned long first,num_colors,lcv,cnt;
 int err,yes,exclude_range;
 double min,max,tempmin,tempmax;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT(printf("WinImgToColorData...wid = %s  num_color_datas = %d\n",win->owner->wid,
         win->data.num_color_datas))
 err = NO_ERROR;
 _2d1 = cur_2d = win_rec_cur_data_buf(win->owner,win->type2);
 PRT3(pr_buf_2d_rec(cur_2d))
 tempmin = cur_2d->minval_set;
 tempmax = cur_2d->maxval_set;
 PRT3(printf("tempmin = %f tempmax = %f\n",tempmin,tempmax))
 for (yes = 0,cnt = lcv = 0; lcv < win->data.num_color_datas; lcv++)
    {PRT2(printf("%d) status4 = %x\n",
          lcv,win->data.color_datas[lcv]->status4))
     color_data = win->data.color_datas[lcv];
     if ((color_data->status4 & COLOR_DATA_DEFAULT_AND_ID_VALID)
             == COLOR_DATA_DEFAULT_AND_ID_VALID)
        {PRT2(printf("...COLOR_DATA_DEFAULT_AND_ID_VALID\n"))
         if (!(color_data->_2d.status4 & BUF_NON_EMPTY))
            {err = CANCEL;
             break;}
         if (!(color_data->_2d.status4 & BUF_DATA_VALID))
            {yes = 1;
             _2d = &(color_data->_2d);
             PRT3(printf("_2d....\n"))
             PRT3(pr_buf_2d_rec(_2d))
             first = color_data->scale.first;
             num_colors = color_data->scale.num_colors;

             if (color_data->status4 & COLOR_DATA_POS_NEG_ACTIVATION)
                {exclude_range =  2;
                 if ((win->status4 & WIN_POS_NEG_ACTIVATION) == WIN_POS_NEG_ACTIVATION)
                    {cnt += 1;
                     if (cnt == 2) exclude_range = 8;}

                 if (color_data->status4 & COLOR_DATA_POS_ACTIVATION)
                    {PRT3(printf("SelectAssign2d COLOR_DATA_POS_ACTIVATION\n"))
                     if (cur_2d->status4 & BUF_MIN_MAX_SET)
                        {if (tempmin > 0) min = 0;
                           else min = tempmin;
                         max = 0;
                         cur_2d->minval_set = 0;
                         if (tempmax < 0) 
                            cur_2d->maxval_set = 0;
                           else cur_2d->maxval_set = tempmax;
                        }
                    }
                   else
                    {PRT3(printf("SelectAssign2d COLOR_DATA_NEG_ACTIVATION\n"))
                     if (cur_2d->status4 & BUF_MIN_MAX_SET)
                        {if (tempmax < 0) max = 0;
                           else max = tempmax;
                         min = 0;
                         if (tempmin > 0) 
                            cur_2d->maxval_set = 0;
                           else cur_2d->maxval_set = tempmin;
                         cur_2d->minval_set = 0;
                        }
                    }
                }
               else exclude_range = 0;
             PRT3(printf("cur_2d minval_set = %f maxval_set = %f\n",
                  cur_2d->minval_set,cur_2d->maxval_set))
             PRT3(if (exclude_range)
                      printf("exclude_range = %d min = %f max = %f\n",
                           exclude_range,min,max))

             if ((err = Scale2dPixels(_2d,cur_2d,
                   (double) first,(double) (first + num_colors - 1),
                   exclude_range,min,max,0)) != NO_ERROR)
                break;
             PRT3(printf("minval_set = %f maxval_set = %f\n",
                  _2d->minval_set,_2d->maxval_set))
             _2d->status4 |= BUF_DATA_VALID;
            }
        }
    }
 cur_2d->minval_set = tempmin;
 cur_2d->maxval_set = tempmax;
 PRT(printf("WinImgToColorData...1...yes = %d err = %d\n",yes,err))

 if ((err == NO_ERROR) && yes)
    {PRT(printf("WinGetColorData ..img->_2d_fusion.status = %x prog_status2 = %x\n",
         img->_2d_fusion.status,(unsigned long) cur_2d->prog_status2))

     if ((img->_2d_fusion.status & FUSION_DYNAMIC) &&
         (img->_2d_fusion.status & FUSION_METHOD) &&
         (cur_2d->prog_status2 & BUF_DATA_NEW))
        {if (img->status4 & IMAGE_2D_SUPERIMPOSED_READY)
            WinDynamicForwardFusion1(win,0);
           else
            {img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
             PRT(printf(" 2 FUSION_FORWARD_READY...\n"));
                   img->_2d_fusion.status |= FUSION_FORWARD_READY;}
         PRT(printf("WinGetColorData ..BUF_DATA_NEW\n"))
        }
     if (cur_2d->prog_status2 & BUF_DATA_NEW)
        cur_2d->prog_status2 &= ~BUF_DATA_NEW;

     if ((img->status4 & IMAGE_3D_SUPERIMPOSED_READY) &&
         (img->status4 & IMAGE_3D_SUPERIMPOSED) &&
         (img->_3d_fusion._2d.status4 & BUF_NON_EMPTY) &&
         (img->_3d_fusion._2d.status4 & BUF_DATA_VALID))
     {
       _2d = &(win->data.color_datas[0]->_2d);
       PRT1(MinMax2dValues(&(img->_3d_fusion._2d),0,(double) .0,(double) .0,&min,&max););

#if 0
       PRT1(printf("_3d_fusion._2d startx = %d starty = %d srcmin = %d srcmax = %d min = %f  max = %f\n",
		   img->_3d_fusion._2d.startx,img->_3d_fusion._2d.starty,
		   img->_3d_fusion.srcmin,img->_3d_fusion.srcmax,min,max));
#endif

       Cp2dByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
		   img->_3d_fusion._2d.startoffx,
		   img->_3d_fusion._2d.startoffy,
		   &(img->_3d_fusion._2d),0,0,
		   img->_3d_fusion._2d.dimx - 1,
		   img->_3d_fusion._2d.dimy - 1,
		   1,(double) img->_3d_fusion.srcmin,
		   (double) img->_3d_fusion.srcmax,0);
     }

     if (win->status4 & WIN_COLOR_DATA_UNCHANGED)
        {PRT(printf("&= ~WIN_COLOR_DATA_UNCHANGED...\n"))
         win->status4 &= ~WIN_COLOR_DATA_UNCHANGED;}
       else if (img->num_dst_wids > 0)
        {PRT(printf("WinDynamicBackwardFusion...\n"))
         WinDynamicBackwardFusion(win);}
    }
 PRT(printf("WinImgToColorData ..err = %d img->num_dst_wids = %d   end\n",err,img->num_dst_wids))

 return err;
}



/*---------------------------------------------------------------------------
WinGetColorData - ???
---------------------------------------------------------------------------*/

int
WinGetColorData(win)
     struct image_display_window *win;
{
  int err;


  TRACE(printf("WinGetColorData\n"););
  if ((err = setup_color_data_rec(win)) == NO_ERROR)
    err = WinImgToColorData(win);

  if (err != NO_ERROR)
    win->process_status4 |= WIN_COLOR_DATA_ERROR;
  win->process_status4 |= WIN_COLOR_DATA_PROCESSED;
  PRT3(printf("WinGetColorData err = %d\n",err););
  return err;
}



/*---------------------------------------------------------------------------
WinColorData - ???
---------------------------------------------------------------------------*/

int
WinColorData(win)
     struct image_display_window *win;
{
  int err,screen_depth;

  PRT(printf("********WinColorData...win->dwin = %u\n",win->dwin));
  if (((err = WinGetColorData(win)) == NO_ERROR) && (win->dwin != NULL))
  {
    screen_depth = (int) xv_get(win->dwin->frame,WIN_DEPTH);
    err = win_execute_proc_to_multiple_wins(win, WinInitScreenBuffer,
					    screen_depth,0,0,0,0);
    PRT3(printf("********WinColorData... screen_depth = %d err = %d\n",
		screen_depth,err));
  }
  PRT(printf("********WinColorData...err = %d\n",err));
  return err;
}


/*---------------------------------------------------------------------------
WinColorCanvas - ???
---------------------------------------------------------------------------*/

int
WinColorCanvas(win)
 struct image_display_window *win;
{
 int err;

 if ((err = WinColorScreen(win)) == NO_ERROR)
    err = WinCanvas(win,1);
 return err;
}



/*---------------------------------------------------------------------------
WinNewColorData - ???
---------------------------------------------------------------------------*/

int
WinNewColorData(win)
     struct image_display_window *win;
{
  int err;
  
  WinNewColorRequest(win);
  if ((err = WinColorData(win)) != NO_ERROR)
  {
    win_error_exit_cur_win(win,err);
    PRT(printf("WinNewColorData win_error_exit_cur_win err = %d\n",err));
    return err;
  }
  return NO_ERROR;
}



/*---------------------------------------------------------------------------
WinColorScreen - ???
---------------------------------------------------------------------------*/

int
WinColorScreen(win)
 struct image_display_window *win;
{
 int err,screen_depth;

 TRACE(printf("WinColorScreen...win = %u\n",win))
 if (((err = WinGetColorData(win)) == NO_ERROR) && (win->dwin != NULL))
    {screen_depth = (int) xv_get(win->dwin->frame,WIN_DEPTH);
     if ((err = WinInitScreenBuffer(win,screen_depth)) == NO_ERROR)
        {TRACE(printf("WinColorScreen WinScreen\n"))
         err = WinScreen(win);}
       else return win_error_exit_cur_win(win,err);
    }
 TRACE(printf("WinColorScreen...2\n"))
 return err;
}


/*---------------------------------------------------------------------------
WinNewColorScreen - ???
---------------------------------------------------------------------------*/

int
WinNewColorScreen(win)
 struct image_display_window *win;
{
 int err;

 if ((err = WinNewColorData(win)) == NO_ERROR)
    err = WinScreen(win);
 return err;
}



/*---------------------------------------------------------------------------
WinNewColorMultiScreen - ???
---------------------------------------------------------------------------*/

int
WinNewColorMultiScreen(win)
     struct image_display_window *win;
{
  unsigned int cnt;
  struct display_win_rec *dwin;
  int err;

  if ((err = WinNewColorData(win)) == NO_ERROR)
  {
    dwin = win->dwin;
    for (cnt = 0; cnt < win->num_display_wins; cnt++)
    {
      win->dwin = win->dwins[cnt];
      WinScreen(win);
    }
    win->dwin = dwin;
  }
  PRT3(printf("WinNewColorMultiScreen err = %d\n",err));
  return err;
}



/*---------------------------------------------------------------------------
WinNewColorScreenForSliceRoiWins - ???
---------------------------------------------------------------------------*/

int
WinNewColorScreenForSliceRoiWins(win)
 struct image_display_window *win;
{
 unsigned int lcv;

 for (lcv = 0; lcv < win->control.sroi.sroi_win->num_wins;lcv++)
    WinNewColorMultiScreen(win->control.sroi.sroi_win->wins[lcv]);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinNewColorCanvas - ???
---------------------------------------------------------------------------*/

int
WinNewColorCanvas(win)
 struct image_display_window *win;
{
 int err;

 if ((err = WinNewColorScreen(win)) == NO_ERROR)
    err = WinCanvas(win,1);
 return err;
}



/*---------------------------------------------------------------------------
WinNewColorMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinNewColorMultiCanvas(win)
     struct image_display_window *win;
{
  int err;

  PRT(printf("WinNewColorMultiCanvas...1\n"));
  if ((err = WinNewColorData(win)) == NO_ERROR)
  {
    win_execute_proc_to_multiple_wins(win,WinScreen,0,0,0,0,0);
    return WinMultiCanvas(win);
  }
  else
  {
    PRT1(printf("WinNewColorMultiCanvas...err = %d\n",err));
  }

  return err;
}


/*************
WinMultiEchoNewColorMultiScreen(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img,*temp_img;

 if (win->type2 & HISTOGRAM_WINDOW)
    WinNewColorMultiScreen(win);
   else
    {temp_img = img = win_rec_cur_img_buf(win->owner);
     do
       {
        if (temp_img != NULL)
           {
            if ((temp_img->win != NULL) ||
                (temp_img->_2d.status4 & BUF_OVERWRITE))
            WinNewColorMultiScreen(temp_img->win->image_display);
            temp_img = temp_img->partner;
           }
          else return;
       }
    while (temp_img != img);
   }
}

WinMultiEchoNewColorMultiScreen(win)
 struct image_display_window *win;
{
 return WinMultiEchoRunProc(win,WinNewColorMultiScreen,0,0);
}
****************/




/*---------------------------------------------------------------------------
WinScreen - ???
---------------------------------------------------------------------------*/

int
WinScreen(win)
 struct image_display_window *win;
{
 int err;

 TRACE(printf("WinScreen()\n"););
 if (win->dwin->display_status & DISPLAY_PIXEL_TYPE)
    WinSlicePixelTypeOverlayOn(win);
 win_refresh_screen_data(win);

 clear_draw_masks(win->data.draw_masks,win->data.num_draw_masks);

 err = win_paint_all_curves(win);

 return err;
}


/*---------------------------------------------------------------------------
WinMultiScreen - ???
---------------------------------------------------------------------------*/

int
WinMultiScreen(win)
 struct image_display_window *win;
{
 struct display_win_rec *dwin;
 unsigned int lcv;

 PRT(printf("WinMultiScreen \n"))
 dwin = win->dwin;
 PRT(printf("WinMultiScreen num_display_wins = %d\n",
          win->num_display_wins))
 for (lcv = 0; lcv < win->num_display_wins; lcv++)
    {win->dwin = win->dwins[lcv];
     WinScreen(win);
    }
 win->dwin = dwin;
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiCanvas(win)
 struct image_display_window *win;
{
 unsigned int lcv;
 struct display_win_rec *dwin;
 int (*proc)();

 PRT(printf("WinMultiCanvas...status = %x  = %d\n",
      (unsigned int) win->type2,win->num_display_wins))
 if (win->num_display_wins == 0) return NO_ERROR;
 WinCanvas(win,1);
 if (win->num_display_wins > 1)
    {dwin = win->dwin;
     for (lcv = 0; lcv < win->num_display_wins; lcv++)
        {if ((dwin != win->dwins[lcv]) &&
             is_int_region_rect_intersect(&(dwin->screen.dimension),
                   &(win->dwins[lcv]->screen.dimension)))
           {win->dwin = win->dwins[lcv];
            WinCanvas(win,1);
           }
        }
     win->dwin = dwin;
    }
 if (win->proc_after_dp.item != NULL)
    {
     proc = (int (*)()) win->proc_after_dp.item;
     proc(win->proc_after_dp.item1);
     win->proc_after_dp.item = win->proc_after_dp.item1 = NULL;
    }
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinHistoMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinHistoMultiCanvas(win)
 struct image_display_window *win;
{
 struct buf_2d_rec *_2d;
 struct color_data_rec *color_data;
 struct image_display_window *win1;

 _2d = win_rec_cur_data_buf(win->owner,win->type2);
 if ((_2d != NULL) && ((win1 = win->owner->histogram) != NULL) &&
     (win1->data.num_colors > 0) &&
     ((color_data = WinCurColorData(win1)) != NULL) &&
     (color_data->_2d.status4 & BUF_DATA_VALID))
    {
     return WinMultiCanvas(win1);
    }
   else return CANCEL;
}


/*---------------------------------------------------------------------------
WinScreenCanvas - ???
---------------------------------------------------------------------------*/

int
WinScreenCanvas(win)
 struct image_display_window *win;
{
 WinScreen(win);
 WinCanvas(win,1);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinMultiScreenCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiScreenCanvas(win)
 struct image_display_window *win;
{
 WinMultiScreen(win);
 WinMultiCanvas(win);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinMultiEchoMultiScreen - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoMultiScreen(win)
 struct image_display_window *win;
{
 return WinMultiEchoRunProc(win,WinMultiScreen,0,0);
}


/*---------------------------------------------------------------------------
WinMultiEchoMultiScreenCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoMultiScreenCanvas(win)
 struct image_display_window *win;
{
 return WinMultiEchoRunProc(win,WinMultiScreenCanvas,0,0);
}



/*---------------------------------------------------------------------------
WinHistoNewColorMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinHistoNewColorMultiCanvas(win)
 struct image_display_window *win;
{
 int err;

 TRACE(printf("WinHistoNewColorMultiCanvas...1\n"))
 if (win->owner->histogram == NULL) return CANCEL;
 if ((err = WinNewColorData(win->owner->histogram)) == NO_ERROR)
    {win_execute_proc_to_multiple_wins(win->owner->histogram,WinScreen,
				       0,0,0,0,0);
     TRACE(printf("WinHistoNewColorMultiCanvas...ready\n"))
     return WinMultiCanvas(win->owner->histogram);
    }
 return err;
}


/*---------------------------------------------------------------------------
WinMultiEchoMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoMultiCanvas(win)
 struct image_display_window *win;
{
 return WinMultiEchoRunProc(win,WinMultiCanvas,0,0);
}



/*---------------------------------------------------------------------------
WinMultiEchoNewColorMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoNewColorMultiCanvas(win)
     struct image_display_window *win;
{
  int err;
  
  if ((err = WinMultiEchoRunProc(win,WinNewColorMultiScreen,0,0)) == NO_ERROR)
  {
    PRT3(printf("WinMultiEchoNewColorMultiCanvas err = %d\n",err););
    err = WinMultiEchoRunProc(win,WinMultiCanvas,0,0);
  }
  PRT3(printf("WinMultiEchoNewColorMultiCanvas err = %d\n",err););
  return err;
}


/*---------------------------------------------------------------------------
win_view_roi_filter - ???

FIXME!! This function is almost certainly broken and has been patched to
compile without a fatal error but without fixing the problem; see below for 
details.  -PWH 19990519
---------------------------------------------------------------------------*/

int
win_view_roi_filter(win)
 struct image_display_window *win;
{
 struct int_bound_rec bound;
 struct img_buf_rec *img;

 if (!(win->status4 & VIEW_ROI_FILTER_ON)) return NO_ERROR;
 if (is_roi_non_empty(&(win->image_view_roi)) &&
     (win->image_view_2d.status4 & BUF_NON_EMPTY) &&
     ((img = win_rec_cur_img_buf(win->owner)) != NULL))
    if (win->image_view_roi.status & ROI_EXCLUDE)
       {
        /* FIXME!!  The number of arguments in the function call below
	   is not even close to correct.  Commented it out to prevent
	   a fatal compile error until someone has time to figure it out.
	   -PWH 19990519 */
	/* FindRoiLongMinMax(&(win->image_view_roi),NULL,&(bound.left),
	   &(bound.right),&(bound.top),&(bound.bottom),1); */
        Set2d(&(img->_2d),0,0,&(win->image_view_2d),&bound,(double)0.0);}
      else
       Set2dByNotMask(&(img->_2d),0,0,&(win->image_view_2d),NULL,(double)0.0);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
win_filter_image_data - ???
---------------------------------------------------------------------------*/

int
win_filter_image_data(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if (!(win->status4 & FILTER_ON)) return NO_ERROR;
 win_view_roi_filter(win);
 if (win->type2 & DISPLAY_WINDOW_3D) return NO_ERROR;
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->unit.status2 & UNIT_2D_IN_USE) &&
     (win->status4 & DISPLAY_TISSUE_TYPE))
    return win_filter_image_tissue_types(win);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinNewImgMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinNewImgMultiCanvas(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 RdSlice(img,0,NULL,0);

 if (win->status4 & FILTER_ON) win_filter_image_data(win);
 WinNewColorMultiCanvas(win);
 win_multiple_set_frame_label(win);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinMultiEchoNewImgMultiCanvas - ???
---------------------------------------------------------------------------*/

int
WinMultiEchoNewImgMultiCanvas(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

 img = win_rec_cur_img_buf(win->owner);
 if ((err = RdCurSliceEchoes(img,0,0)) == NO_ERROR)
    win_execute_proc_to_partner_wins(win,win_filter_image_data,0,0);
 WinMultiEchoNewColorMultiCanvas(win);
 WinMultiEchoRunProc(win,win_multiple_set_frame_label,0,0);
 return err;
}

