/****************************************************************************
superimpose.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: superimpose.c,v 1.10 1999/07/07 17:41:19 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "geometry.h"
#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRT(x) x; fflush(stdout);
#define TRACE(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
#define PRT6(x) x; fflush(stdout);
#define PRT7(x) x; fflush(stdout);
#define PRT8(x) x; fflush(stdout);
#define PRT9(x) x; fflush(stdout);
#define PRT10(x) x; fflush(stdout);
#define PRT11(x) x; fflush(stdout);
#define PRT12(x) x; fflush(stdout);
#define PRT21(x) x; fflush(stdout);
#define PRT22(x) x; fflush(stdout);
#define PRT23(x) x; fflush(stdout);
#define PRT23(x) x; fflush(stdout);
*/
#define PRT(x)
#define TRACE(x)
#define PRT1(x)
#define PRT2(x)
#define PRT6(x)
#define PRT7(x)
#define PRT8(x)
#define PRT9(x)
#define PRT10(x)
#define PRT11(x)
#define PRT12(x)
#define PRT21(x)
#define PRT22(x)
#define PRT23(x)



#define SHOW_HIDE_STR "SHOW/HIDE-D"
#define SHOW_STR "SHOW-Sh S"
#define CLEAN_UP_OR_MENU 0
#define SETUP_OR_MENU 1
#define GET_ALL_OR_MENU_PTR 2

struct or_menu_rec
   {
    unsigned short status;
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    Panel panel;
    Panel_item dst_left,dst_top,src_left,src_top,src_width,src_height,
               cur_srcminmax,cur_srcdim,dstminmax,centered,
               window,opr,dynamic,cur_group,movexy_msg;
   };
               /*srcmin,srcmax,dstmin,dstmax,unselected,src_size,*/

struct all_or_menu_recs
   {
    int numors;
    struct or_menu_rec **ors;
   };


/* Functions defined in this file */
void init_or_menu_rec(struct or_menu_rec *or);
void free_or_menu_rec(struct or_menu_rec *or);
void init_all_or_menu_recs(struct all_or_menu_recs *all_ors);
void dst_msg(struct or_menu_rec *or);
void cur_src_msg(struct or_menu_rec *or);
void setup_source_msg(struct or_menu_rec *or);
int movexy_msg(struct or_menu_rec *or);
int dst_left_top(struct image_display_window *dst_win,
    struct image_display_window *src_win, long *left, long *top);
void wid_proc(Panel_item item, char *str, caddr_t client_data,
    Panel_list_op op, Event *event);
int win_clear_last_2d_fusion(struct image_display_window *win);
unsigned long fusion_method(int opr);
int FusionSrc1AndSrc2Bound(struct or_menu_rec *or,
    struct image_display_window *win, struct image_display_window *src_win,
    struct int_bound_rec *dst_bound, struct int_bound_rec *src_bound);
void image_fusion_proc(Panel_item item, Event *event);
int win_show_fusion(struct image_display_window *win);
int win_hide_fusion(struct image_display_window *win);
int win_show_fusion_src(struct image_display_window *win);
int win_move_show_hide_fusion(struct image_display_window *win, int select);
int win_show_hide_fusion(struct image_display_window *win);
int win_delete_fusion(struct image_display_window *win);
int win_fusion_last_left_top(struct image_display_window *win);
void show_or_proc(Panel_item item, Event *event);
void show_hide_or_proc(Panel_item item, Event *event);
void delete_or_image_proc(Panel_item item, Event *event);
int WinFusionMove3d(struct image_display_window *win,
    int use_this_apply_option, int apply);
int win_fusion_move_img(struct image_display_window *win);
void fusion_move_proc(Panel_item item, Event *event);
int fusion_event_action_proc(struct image_display_window *win, Event *event);
int WinSetupWindowListItem(struct image_display_window *win, Panel_item item,
    int select, int win_type2);
void win_add_or_drop_dynamic_fusion(struct image_display_window *win,
    int is_add);
void dynamic_fusion_proc(Panel_item item, int value, Event *event);
void fusion_method_proc(Panel_item item, int value, Event *event);
int WinRedefineFusionParams(struct image_display_window *win,
    struct image_display_window *src_win, char *src_wid,
    int add_this_move_offset, int left_offset, int top_offset,
    struct int_bound_rec *src_bound, struct int_bound_rec *dst_bound,
    int *opr, int *is_dynamic);
int win_redefine_fusion_bounds(struct image_display_window *win,
    struct image_display_window *src_win, char *src_wid);
int win_fusion(struct image_display_window *win,
    struct image_display_window *src_win, char *src_wid,
    int add_this_move_offset, int left_offset, int top_offset);
int win_fusion_which_win_proc(struct image_display_window *win, char *wid);
int win_fusion_which_win(struct image_display_window *win);
int win_fusion_switching_src_to_dst(struct image_display_window *win);
void win_fusion_switching(struct image_display_window *win);
void win_set_redefine_dst_fusion_params(struct image_display_window *win);
void fusion_more_proc(Panel_item item, Event *event);
void initial_dst_left_top(struct or_menu_rec *or);
void move_left_proc(Panel_item item, int val, Event *event);
void move_top_proc(Panel_item item, int val, Event *event);
void or_done_proc(Frame frame);
int win_fusion_def_params(struct image_display_window *win);
int setup_or_menu_rec(struct or_menu_rec *or,
    struct image_display_window *win);
void update_fusion_menu(struct image_display_window *win);
struct or_menu_rec *find_or_menu_rec_win(struct all_or_menu_recs *all_ors,
    struct image_display_window *win);
void setup_fusion_menu(struct image_display_window *win);


/* (Known) local functions */
static struct all_or_menu_recs *enter_fusion_menu(
    struct image_display_window *win, int status);



/*---------------------------------------------------------------------------
init_or_menu_rec - ???
---------------------------------------------------------------------------*/

void
init_or_menu_rec(or)
 struct or_menu_rec *or;
{
 or->status = 0;
 or->win = NULL;
 or->frame  = 0;
}


/*---------------------------------------------------------------------------
free_or_menu_rec - ???
---------------------------------------------------------------------------*/

void
free_or_menu_rec(or)
 struct or_menu_rec *or;
{
 struct all_or_menu_recs *all_ors;

 TRACE(printf("free_or_menu_rec...\n"))
 if (or->frame != 0) xv_destroy_safe(or->frame);
 all_ors = enter_fusion_menu(NULL, GET_ALL_OR_MENU_PTR);
 c_free(or);
 DropHandleAryPtr(&(all_ors->ors),&(all_ors->numors),or);
}


/*---------------------------------------------------------------------------
init_all_or_menu_recs - ???
---------------------------------------------------------------------------*/

void
init_all_or_menu_recs(all_ors)
 struct all_or_menu_recs *all_ors;
{
 all_ors->numors = 0;
 all_ors->ors = NULL;
}

/***********
set_minmax_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;
 int value;
 int val1;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 value = (int) xv_get(item,PANEL_VALUE);
 if (item == or->srcmin)
    {val1 = (int) xv_get(or->srcmax,PANEL_VALUE);
     if (value > val1) xv_set(or->srcmax,PANEL_VALUE,value,0);
    }
   else if (item == or->srcmax)
    {val1 = (int) xv_get(or->srcmin,PANEL_VALUE);
     if (value < val1) xv_set(or->srcmin,PANEL_VALUE,value,0);
    }
   else if (item == or->dstmin)
    {val1 = (int) xv_get(or->dstmax,PANEL_VALUE);
     if (value > val1) xv_set(or->dstmax,PANEL_VALUE,value,0);
    }
   else if (item == or->dstmax)
    {val1 = (int) xv_get(or->dstmin,PANEL_VALUE);
     if (value < val1) xv_set(or->dstmin,PANEL_VALUE,value,0);
    }
}
**********/


/*---------------------------------------------------------------------------
dst_msg - ???
---------------------------------------------------------------------------*/

void
dst_msg(or)
 struct or_menu_rec *or;
{
 struct img_buf_rec *img;
 char str[150];
 char *cur_wid;

 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 cur_wid = WinRecGetWid(or->win->owner,or->win->type2);
 sprintf(str,"DEST = %s...",cur_wid);
/*
 sprintf(str,"DEST = %s...& opaque min/max = %d/%d",cur_wid,
    img->_2d_fusion.dstmin,img->_2d_fusion.dstmax);
*/
 xv_set(or->dstminmax,PANEL_LABEL_STRING,str,0);
}


/*---------------------------------------------------------------------------
cur_src_msg - ???
---------------------------------------------------------------------------*/

void
cur_src_msg(or)
 struct or_menu_rec *or;
{
 struct img_buf_rec *img;
 char str[150],str1[100];
 char *cur_wid;
 struct win_rec *rwin;

 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 if ((img->src_wid == NULL) || !(img->_2d_fusion.status & FUSION_METHOD) ||
     ((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) == NULL))
    {
/*
     sprintf(str,"CUR SOURCE = none...opaque min/max = %d/%d",
           img->_2d_fusion.srcmin,img->_2d_fusion.srcmax);
*/
     sprintf(str,"CUR SOURCE = none...");

     sprintf(str1,"   LEFT/TOP = 0/0  RIGHT/BOTTOM = 0/0");
    }
   else
    {PRT1(printf("cur_src_msg rwin = %u\n",rwin))
     cur_wid = WinRecGetWid(rwin,or->win->type2);
/*
     PRT1(printf("CUR SOURCE = %s...opaque min/max = %d/%d",cur_wid,
           img->_2d_fusion.srcmin,img->_2d_fusion.srcmax);)
     sprintf(str,"CUR SOURCE = %s...opaque min/max = %d/%d",cur_wid,
           img->_2d_fusion.srcmin,img->_2d_fusion.srcmax);
*/
     sprintf(str,"CUR SOURCE = %s...",cur_wid);
     sprintf(str1,"   LEFT/TOP = %-d/%-d  RIGHT/BOTTOM = %-d/%-d",
          img->_2d_fusion.src_bound.left,img->_2d_fusion.src_bound.top,
          img->_2d_fusion.src_bound.right,img->_2d_fusion.src_bound.bottom);}

 xv_set(or->cur_srcminmax,PANEL_LABEL_STRING,str,0);
 xv_set(or->cur_srcdim,PANEL_LABEL_STRING,str1,0);
}


/*---------------------------------------------------------------------------
setup_source_msg - ???
---------------------------------------------------------------------------*/

void
setup_source_msg(or)
 struct or_menu_rec *or;
{
 int selected_indx,lastx,lasty;
 char *str;
 struct buf_2d_rec *_2d;
 struct img_buf_rec *img;
 struct win_rec *win;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 if (next_selected_item(or->window,0,&selected_indx) == NO_ERROR)
    {if ((str = (char *) xv_get(or->window,PANEL_LIST_STRING,selected_indx)) != NULL) 
        {if (((win = get_win_rec_by_wid_str(img->win,str)) != NULL) &&
             (win->image_display != NULL) &&
              ((color_data = WinCurColorData(win->image_display)) != NULL))
            {_2d = &(color_data->_2d);
             if ((_2d->status4 & BUF_NON_EMPTY) && (_2d->status4 & BUF_DATA_VALID))
                {lastx = _2d->dimx - 1;
                 lasty = _2d->dimy - 1;
                 xv_set(or->src_left,PANEL_MAX_VALUE,lastx,0);
                 xv_set(or->src_top,PANEL_MAX_VALUE,lasty,0);
                 xv_set(or->src_width,PANEL_VALUE,_2d->dimx,
                      PANEL_MAX_VALUE,_2d->dimx,0);
                 xv_set(or->src_height,PANEL_VALUE,_2d->dimy,
                      PANEL_MAX_VALUE,_2d->dimy,0);
                 return /*NO_ERROR*/;
                }
            }
        }
     xv_set(or->window,PANEL_LIST_DELETE,selected_indx,0);
     xv_set(or->window,PANEL_LIST_SELECTED,0,0);
    }
}


/*---------------------------------------------------------------------------
movexy_msg - ???
---------------------------------------------------------------------------*/

int
movexy_msg(or)
 struct or_menu_rec *or;
{
 char str[80];
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL) return CANCEL;
 if (!(img->_2d_fusion.status & FUSION_METHOD))
    {xv_set(or->movexy_msg,PANEL_LABEL_STRING,"",0);
     return CANCEL;}
 sprintf(str,"Move X/Y = %ld/%ld",
     img->_2d_fusion.dst_bound.left - img->_2d_fusion.def_dst_left,
     img->_2d_fusion.dst_bound.top - img->_2d_fusion.def_dst_top);
 xv_set(or->movexy_msg,PANEL_LABEL_STRING,str,0);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
dst_left_top - ???
---------------------------------------------------------------------------*/

int
dst_left_top(dst_win,src_win,left,top)
 struct image_display_window *dst_win,*src_win;
 long *left,*top;
{
 float center;
 struct color_data_rec *color_data,*color_data1;

 if ((color_data = WinCurColorData(dst_win)) == NULL) return CANCEL;
 if ((color_data1 = WinCurColorData(src_win)) == NULL) return CANCEL;
 center = ((float) color_data->_2d.dimx - 
               (float) color_data1->_2d.dimx) / 2.0 + .5;
 center = (float) floor((double) center);
 *left = (long) center;
 center = ((float) color_data->_2d.dimy - 
               (float) color_data1->_2d.dimy) / 2.0 + .5;
 center = (float) floor((double) center);
 *top = (long) center;
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
wid_proc - ???
---------------------------------------------------------------------------*/

void
wid_proc(item,str,client_data,op,event)
 Panel_item item;
 char *str;
 caddr_t client_data;
 Panel_list_op op;
 Event *event;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 TRACE(printf("op = %d\n",op))
 if (op) 
    setup_source_msg(or);
}


/*---------------------------------------------------------------------------
win_clear_last_2d_fusion - ???
---------------------------------------------------------------------------*/

int
win_clear_last_2d_fusion(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

     PRT(printf("\nwin_clear_last_2d_fusion...***********\n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((img->_2d_fusion.status & FUSION_ACCUMULATED) ||
     !(img->status4 & IMAGE_2D_SUPERIMPOSED_READY) ||
     !(img->_2d_fusion.status & FUSION_METHOD) ||
     !(img->_2d_fusion._2d.status4 & BUF_NON_EMPTY))
    return NO_ERROR;
   else
    {img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
     win->status4 |= WIN_COLOR_DATA_UNCHANGED;
     PRT(printf("win_clear_last_2d_fusion...\n");)
     err = WinNewColorData(win);
     img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
     return err;
    }
}


/*---------------------------------------------------------------------------
fusion_method - ???
---------------------------------------------------------------------------*/

unsigned long 
fusion_method(opr)
 int opr;
{
 if      (opr == 0) return METHOD_BLEND_SUPERIMPOSE;
 else if (opr == 1) return METHOD_BLEND_3_BY_3;
 else if (opr == 2) return METHOD_BLEND_6_BY_6;
 else if (opr == 3) return METHOD_BLEND_9_BY_9;
 /* FIXME:  What is opr is none of the above?  -PWH 19990427 */
}


/*---------------------------------------------------------------------------
FusionSrc1AndSrc2Bound - ???
---------------------------------------------------------------------------*/

int
FusionSrc1AndSrc2Bound(or,win,src_win,dst_bound,src_bound)
 struct or_menu_rec *or;
 struct image_display_window *win,*src_win;
 struct int_bound_rec *dst_bound,*src_bound;
{
 struct color_data_rec *color_data1;

 PRT2(printf("FusionSrc1AndSrc2Bound...\n"))
 if ((color_data1 = WinCurColorData(src_win)) == NULL) return CANCEL;
 src_bound->left = (int) xv_get(or->src_left,PANEL_VALUE);

 src_bound->right = src_bound->left + (int) xv_get(or->src_width,PANEL_VALUE) - 1;
 if (src_bound->right >= color_data1->_2d.dimx)
    src_bound->right = color_data1->_2d.dimx - 1;
 src_bound->top = (int) xv_get(or->src_top,PANEL_VALUE);
 src_bound->bottom = src_bound->top + (int) xv_get(or->src_height,PANEL_VALUE) - 1;
 if (src_bound->bottom >= color_data1->_2d.dimy)
    src_bound->bottom = color_data1->_2d.dimy - 1;

 dst_bound->left = (int) xv_get(or->dst_left,PANEL_VALUE);
 dst_bound->top = (int) xv_get(or->dst_top,PANEL_VALUE);
 dst_bound->right = dst_bound->left + (src_bound->right - src_bound->left);
 dst_bound->bottom = dst_bound->top + (src_bound->bottom - src_bound->top);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
image_fusion_proc - ???
---------------------------------------------------------------------------*/

void
image_fusion_proc(item,event)
 Panel_item item;
 Event *event;
{
 char *wid,str1[100];
 int opr,err,indx;
 struct or_menu_rec *or;
 struct img_buf_rec *img,*img1;
 struct win_rec *rwin;
 struct image_display_window *win1;
 struct int_bound_rec src_bound,dst_bound;
 long left,top;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 if ((err = next_selected_item(or->window,0,&indx)) != NO_ERROR)
     return /*err*/;
 if ((wid = (char *) xv_get(or->window,PANEL_LIST_STRING,indx)) == NULL)
     return /*CANCEL*/;

/*
 PRT(printf("\nimage_fusion_proc wid = %s img->win = %u\n",wid,img->win))
*/
 if (((rwin = get_win_rec_by_wid_str(img->win,wid)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(rwin)) == NULL)  ||
     ((win1 = rwin->image_display) == NULL))
    {PRT(printf("image_fusion_proc 2\n"))

     sprintf(str1,"%s is not available !!!",wid);
     PRT(printf("image_fusion_proc 2\n"))
     notice_prompt(or->frame,(Event *) NULL,
              NOTICE_MESSAGE_STRINGS,str1,
                 "Please pick another image !!!!",0,
              NOTICE_BUTTON_YES," OK !",0);
     xv_set(or->window,PANEL_LIST_DELETE,indx,0);
     return /*CANCEL*/;
    }
 if (((int) xv_get(or->centered,PANEL_VALUE)) &&
      (str_cmp(wid,img->src_wid) != 0))
    {dst_left_top(or->win,win1,&left,&top);
     xv_set(or->dst_left,PANEL_VALUE,left,0);
     xv_set(or->dst_top,PANEL_VALUE,top,0);
    }
 PRT(printf("image_fusion_proc win1 = %u wid = %s\n",win1,wid))
 if ((err = FusionSrc1AndSrc2Bound(or,or->win,win1,
          &dst_bound,&src_bound)) != NO_ERROR)
    {notice_prompt(or->frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,"Empty intersected region for fusion !!!",
                 "No operation...",
                 NOTICE_BUTTON_YES," OK !",0);
    return /*err*/;}


 opr = (int) xv_get(or->opr,PANEL_VALUE);
 PRT(printf("image_fusion_proc...\n");
     printf("SRC opr = %d\n",opr))
 err = WinImageFusion1(or->win,&src_bound,&dst_bound,opr,wid);
 PRT(printf("image_fusion_proc...1\n");)
 PRT(printf("image_fusion_proc...2\n");)

 if (err == NO_ERROR)
    {dst_msg(or);
     cur_src_msg(or);
     if (xv_get(or->dynamic,PANEL_VALUE))
        win_add_or_drop_dynamic_fusion(or->win,1);
     img->_2d_fusion.status &= ~FUSION_MOVE_SELF;
    }
   else
    {notice_prompt(or->frame,(Event *) NULL,
                  NOTICE_MESSAGE_STRINGS,"Sorry !!! Error occurred when",
                 "constructing the fusion imag...",
                 "It is either of memory or bad parameters !!!",0,
                 NOTICE_BUTTON_YES," OK !",0);}

}


/*---------------------------------------------------------------------------
win_show_fusion - ???
---------------------------------------------------------------------------*/

int
win_show_fusion(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT23(printf("win_show_fusion ...status = %x\n",
         (unsigned long) img->_2d_fusion.status);)

 if (img->_2d_fusion.status & FUSION_METHOD)
    {
     if (img->_2d_fusion.status & FUSION_MUST_RECOMPUTE)
        {PRT23(printf("win_show_fusion ...WinDynamicForwardFusion\n");)
         if ((err = WinDynamicForwardFusion1(win,0)) == NO_ERROR)
            img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
        }
       else
        {if ((img->_2d_fusion.status & FUSION_SHOW_ONLY_SRC) |
             !(img->status4 & IMAGE_2D_SUPERIMPOSED_READY))
            if ((err = WinMoveFusion2dToSuperimpose2d(win)) != NO_ERROR)
               return err;
        img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;}

     img->_2d_fusion.status &= ~(FUSION_SHOW_ONLY_SRC | FUSION_MOVE_CLEARED);
     PRT23(printf("win_show_fusion ...WinEnableDisableColorData\n");)
     WinEnableDisableColorData(win,SUPERIMPOSE_ID,0);
     PRT23(printf("win_show_fusion ...WinMultiScreenCanvas\n");)
     WinMultiScreenCanvas(win);
    }
 PRT23(printf("win_show_fusion ...2\n");)
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
win_hide_fusion - ???
---------------------------------------------------------------------------*/

int
win_hide_fusion(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 PRT11(printf("win_hide_fusion ...\n");)
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->_2d_fusion.status & FUSION_METHOD)
    {img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
     img->_2d_fusion.status &= ~(FUSION_SHOW_ONLY_SRC | FUSION_MOVE_CLEARED);
     PRT11(printf("win_hide_fusion ...WinEnableDisableColorData\n");)
     WinEnableDisableColorData(win,SUPERIMPOSE_ID,1);
     WinMultiScreenCanvas(win);
    }
 PRT11(printf("win_hide_fusion ...2\n");)
 return NO_ERROR;
}

/**********
         if (((err = SrcOnlyColorData(_2d,rwin->image_display->intensity,
             &(win->data),
             0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
             img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top,
             &(rwin->image_display->data),
             src_bound->left,src_bound->top,src_bound->right,src_bound->bottom))
                == NO_ERROR) &&
*************/


/*---------------------------------------------------------------------------
win_show_fusion_src - ???
---------------------------------------------------------------------------*/

int
win_show_fusion_src(win)
 struct image_display_window *win;
{
 struct win_rec *rwin;
 struct img_buf_rec *img;
 struct int_bound_rec *src_bound;
 struct buf_2d_rec *_2d,*_2d1;
 long vs1left,vs1top,vs1right,vs1bottom,vs2left,vs2top,vs2right,vs2bottom;
 struct color_data_rec *new_color_data;
 int err;

 PRT11(printf("win_show_fusion_src...\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ( ((rwin = get_win_rec_by_wid_str(win->owner,img->src_wid)) != NULL) &&
      (rwin->image_display != NULL) )
    {err = NO_ERROR;
     src_bound = &(img->_2d_fusion.src_bound);
     if (img->_2d_fusion.srcindst_2d.status4 & BUF_NON_EMPTY)
        {img->_2d_fusion.status |= FUSION_SHOW_ONLY_SRC;
/* | FUSION_MUST_RECOMPUTE;*/
         img->_2d_fusion.status &= ~FUSION_MOVE_CLEARED;
         img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
         PRT11(printf("win_show_fusion_src...Cp2dByBound\n");)
         _2d1 = &(img->_2d_fusion.srcindst_2d);
         if (((err = ValidDstAndSrcBound(0,0,img->_2d.dimx - 1,img->_2d.dimy - 1,
                 img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top,
                 src_bound->left,src_bound->top,
                 src_bound->right,src_bound->bottom,
                 &vs1left,&vs1top,&vs1right,&vs1bottom,
                 &vs2left,&vs2top,&vs2right,&vs2bottom)) == NO_ERROR) &&
             ((err = WinSetupColorDataRec2(win,0,SUPERIMPOSE_ID,0,0,0,0,
                    _2d1->pixel_depth,0,&new_color_data,0)) == NO_ERROR))
            {_2d = &(new_color_data->_2d);
             InitBuf2dRecData(_2d,(double) .0);

             PRT23(printf("win_show_fusion_src _2d dimx = %d dimy = %d offx = %d offy = %d\n",
                  _2d->dimx,_2d->dimy,
                  _2d->startoffx,_2d->startoffy);)

             PRT23(printf("win_show_fusion_src _2d1 dimx = %d dimy = %d offx = %d offy = %d l = %d t = %d\n",
                  _2d1->dimx,_2d1->dimy,
                  _2d1->startoffx,_2d1->startoffy,
                  img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top);)
             Set2dStartOffsetXY(_2d,0,0);
             Cp2dByBound(_2d,0,0,_2d->dimx - 1,_2d->dimy - 1,
                      0,0,_2d1,vs2left,vs2top,vs2right,vs2bottom,
                      4,(double) .0,(double) 0,0);
             Set2dStartOffsetXY(_2d,vs1left,vs1top);
             PRT23(printf("win_show_fusion_src....new_color_data = %u _2d dimx = %d dimy = %d offx = %d offy = %d\n",
                 new_color_data,_2d->dimx,_2d->dimy,vs1left,vs1top))
             PRT23(printf("vs2left = %d vs2top = %d vs2right = %d vs2bottom = %d\n",
                 vs2left,vs2top,vs2right,vs2bottom))

             WinMultiScreenCanvas(win);
            }
        }
    }
   else err = CANCEL;
 PRT23(printf("win_show_fusion_src...err = %d  status = %x\n\n",err,
         (unsigned long) img->_2d_fusion.status);)
 return err;
}


/*---------------------------------------------------------------------------
win_move_show_hide_fusion - ???
---------------------------------------------------------------------------*/

int
win_move_show_hide_fusion(win,select)
 struct image_display_window *win;
 int select;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 img->_2d_fusion.status &= ~FUSION_MOVE_PERFORMED;
 if ((img->_2d_fusion.def_dst_left != img->_2d_fusion.dst_bound.left) ||
     (img->_2d_fusion.def_dst_top != img->_2d_fusion.dst_bound.top))
    {img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
    }
 if (select == 1)
    return win_show_fusion(win);
   else if (select == 2)
    return win_show_fusion_src(win);
   else return win_hide_fusion(win);
}


/*---------------------------------------------------------------------------
win_show_hide_fusion - ???
---------------------------------------------------------------------------*/

int
win_show_hide_fusion(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->_2d_fusion.status & FUSION_SHOW_ONLY_SRC)
    return win_move_show_hide_fusion(win,0);
   else if (!(img->status4 & IMAGE_2D_SUPERIMPOSED_READY))
    return win_move_show_hide_fusion(win,1);
    else
     return win_move_show_hide_fusion(win,2);
}


/*---------------------------------------------------------------------------
win_delete_fusion - ???
---------------------------------------------------------------------------*/

int
win_delete_fusion(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct all_or_menu_recs *all_ors;
 struct or_menu_rec *or;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 img->status4 &= ~IMAGE_2D_SUPERIMPOSED_READY;
 if (img->_2d_fusion.status & FUSION_METHOD)
    {PRT22(printf("win_delete_fusion...\n"))
     win_add_or_drop_dynamic_fusion(win,0);
     free_sel_buf_2d_rec(&(img->_2d_fusion));
     WinEnableDisableColorData(win,SUPERIMPOSE_ID,1);
     WinMultiScreenCanvas(win);
     PRT22(printf("win_delete_fusion...1\n"))
     PRT(printf("win->control.last_which_cursor...last_which_cursor = %d\n",
             win->control.last_which_cursor))
     win_select_cursor(win,win->control.last_which_cursor);
     if (((all_ors = enter_fusion_menu(NULL, GET_ALL_OR_MENU_PTR)) != NULL) &&
         ((or = find_or_menu_rec_win(all_ors,win)) != NULL))
        cur_src_msg(or);
    PRT22(printf("win_delete_fusion...2\n"))
    }
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
win_fusion_last_left_top - ???
---------------------------------------------------------------------------*/

int
win_fusion_last_left_top(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 long left,top;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 PRT2(printf("win_fusion_last_left_top...status = %x\n",
          (unsigned long) img->_2d_fusion.status))
 if (!(img->_2d_fusion.status & FUSION_LAST_LEFT_TOP_VALID)) return CANCEL;
 PRT2(printf("win_fusion_last_left_top last left = %d top = %d\n",
      img->_2d_fusion.last_dst_left,img->_2d_fusion.last_dst_top))
 PRT2(printf("dst_bound  left = %d top = %d\n",
      img->_2d_fusion.dst_bound.left,img->_2d_fusion.dst_bound.top))
 if ((img->_2d_fusion.dst_bound.left == img->_2d_fusion.last_dst_left) &&
     (img->_2d_fusion.dst_bound.top == img->_2d_fusion.last_dst_top))
    return CANCEL;
 PRT2(printf("win_fusion_last_left_top...1\n"))
 left = img->_2d_fusion.dst_bound.left;
 top = img->_2d_fusion.dst_bound.top;
 img->_2d_fusion.dst_bound.left = img->_2d_fusion.last_dst_left;
 img->_2d_fusion.dst_bound.top = img->_2d_fusion.last_dst_top;

 img->_2d_fusion.last_dst_left = left;
 img->_2d_fusion.last_dst_top = top;
 img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
 win_show_fusion(win);
 update_fusion_menu(win);
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
show_or_proc - ???
---------------------------------------------------------------------------*/

void
show_or_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_show_fusion(or->win);
}


/*---------------------------------------------------------------------------
show_hide_or_proc - ???
---------------------------------------------------------------------------*/

void
show_hide_or_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_show_hide_fusion(or->win);
}


/*---------------------------------------------------------------------------
delete_or_image_proc - ???
---------------------------------------------------------------------------*/

void
delete_or_image_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_delete_fusion(or->win);
}


/*---------------------------------------------------------------------------
WinFusionMove3d - ???
---------------------------------------------------------------------------*/

int
WinFusionMove3d(win,use_this_apply_option,apply)
 struct image_display_window *win;
 int use_this_apply_option,apply;
{
 struct all_or_menu_recs *all_ors;
 struct or_menu_rec *or;
 struct img_buf_rec *img;
 int x,y,err,is_cur_group,is_rotated;
 struct win_rec *rwin;
 struct image_display_window *nextwin;

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     (img->src_wid == NULL) ||
     ((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) == NULL) ||
     ((nextwin = rwin->image_display) == NULL) ||
     !(img->_2d_fusion.status & FUSION_METHOD)) 
    return CANCEL;
 x = img->_2d_fusion.dst_bound.left - img->_2d_fusion.def_dst_left;
 y = img->_2d_fusion.dst_bound.top - img->_2d_fusion.def_dst_top;
 PRT23(printf("WinFusionMove3d dst_bound...\n");pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
 PRT23(printf("...defleft = %d deftop = %d x = %d y = %d\n",
               img->_2d_fusion.def_dst_left,img->_2d_fusion.def_dst_top,x,y))
 PRT23(printf("src_bound...\n");pr_int_bound_rec(&(img->_2d_fusion.src_bound));)

 if (img->_2d_fusion.src_trans_unit.status2 & UNIT_2D_IN_USE)
    {;
     img->_2d_fusion.src_trans_unit.status2 &= ~UNIT_2D_IN_USE;
     is_rotated = 1;}
   else is_rotated = 0;
 if ((x == 0) && (y == 0) && (is_rotated == 0)) 
    {
     ShowMsgStrs(win->dwin->frame,3,NO_ERROR,2,2,
               "Superimposing position unchanged !!!",
               "No need to move...",NULL,0);
     return NO_ERROR;}
 move_int_bound_rec(&(img->_2d_fusion.dst_bound),-x,-y);
 img->_2d_fusion._2d.startoffx -= x;
 img->_2d_fusion._2d.startoffy -= y;
 img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
 PRT23(printf("after dst_bound...\n");
      pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
 PRT23(printf("...startx = %d starty = %d\n",
               img->_2d_fusion._2d.startoffx,img->_2d_fusion._2d.startoffy))

 if (use_this_apply_option) is_cur_group = apply;
 if (((all_ors = enter_fusion_menu(NULL, GET_ALL_OR_MENU_PTR)) != NULL) &&
     ((or = find_or_menu_rec_win(all_ors,win)) != NULL))
    {if (!use_this_apply_option)
        is_cur_group = (int) xv_get(or->cur_group,PANEL_VALUE);
    }
   else
    {if (!use_this_apply_option) is_cur_group = 1;
     or = NULL;}
 PRT10(printf("WinFusionMove3d...is_cur_group = %d\n",
            is_cur_group))
 if ((err = WinMove3dPlane(nextwin,is_rotated,
        &(img->_2d_fusion.src_trans_unit.localto_mat),
        x,y,1,is_cur_group,1)) == NO_ERROR)
    {if (or != NULL)
        {xv_set(or->dst_left,PANEL_VALUE,img->_2d_fusion.dst_bound.left,0);
         xv_set(or->dst_top,PANEL_VALUE,img->_2d_fusion.dst_bound.top,0);
         if (or->movexy_msg != 0) movexy_msg(or);}
    }
   else 
    {
     ShowMsgStrs(win->dwin->frame,3,err,1,1,
               "Error occurred during the move !!!",NULL,0);
     if (img->_2d_fusion.status & FUSION_METHOD)
        {move_int_bound_rec(&(img->_2d_fusion.dst_bound),x,y);
         img->_2d_fusion._2d.startoffx += x;
         img->_2d_fusion._2d.startoffy += y;}
    }
 PRT23(printf("WinFusionMove3d...err = %d\n",err))
 return err;

}


/*---------------------------------------------------------------------------
win_fusion_move_img - ???
---------------------------------------------------------------------------*/

int
win_fusion_move_img(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;
 struct win_rec *rwin;
 int x,y,err;

 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     !(img->_2d_fusion.status & FUSION_METHOD))
    return CANCEL;
 if (((rwin = get_win_rec_by_wid_str(win->owner,img->src_wid)) == NULL) ||
     ((win1 = rwin->image_display) == NULL) ||
     ((img1 = win_rec_cur_img_buf(rwin)) == NULL))
    return CANCEL;

 PRT11(printf("move_img...def_dst_left = %d t = %d\n",
      img->_2d_fusion.def_dst_left,img->_2d_fusion.def_dst_top))
 x = img->_2d_fusion.dst_bound.left - img->_2d_fusion.def_dst_left;
 y = img->_2d_fusion.dst_bound.top - img->_2d_fusion.def_dst_top;
 PRT11(printf("before dst_bound...x = %d y = %d\n",x,y);
          pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
 PRT11(printf("before src_bound...\n");
          pr_int_bound_rec(&(img->_2d_fusion.src_bound));)

 if ((x == 0) && (y == 0)) return NO_ERROR;

 if (img->file == img1->file)
    {
     move_int_bound_rec(&(img->_2d_fusion.dst_bound),-x,-y);
/*
move_int_bound_rec(&(img->_2d_fusion.dst_bound),-x,-y);
     img->_2d_fusion._2d.startx -= x;
     img->_2d_fusion._2d.starty -= y;
*/
     img->_2d_fusion._2d.startoffx = 0;
     img->_2d_fusion._2d.startoffy = 0;
     img->status4 |= IMAGE_2D_SUPERIMPOSED_READY;
     PRT11(printf("after dst_bound...\n");
          pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
    }
 if ((err = win_move_img(win1,(float) x,(float) y)) != NO_ERROR)
    {
     ShowMsgStrs(win->dwin->frame,3,err,1,1,
               "Error occurred during the move !!!",NULL,0);
     if ((img->_2d_fusion.status & FUSION_METHOD) &&
         (img->file == img1->file))
        {move_int_bound_rec(&(img->_2d_fusion.dst_bound),x,y);
         img->_2d_fusion._2d.startoffx -= x;
         img->_2d_fusion._2d.startoffy -= y;}
    }
   else img->_2d_fusion.status |= FUSION_MOVE_UPDATE;
/*
   else if (img->file != img1->file)
    win_delete_fusion(win);
*/
 PRT11(printf("last dst_bound...status = %x\n",
        img->_2d_fusion.status);
          pr_int_bound_rec(&(img->_2d_fusion.dst_bound));)
 PRT11(printf("last src_bound...\n");
          pr_int_bound_rec(&(img->_2d_fusion.src_bound));)
 PRT11(printf("last startx = %d starty = %d\n",
               img->_2d_fusion._2d.startx,img->_2d_fusion._2d.starty))
 PRT11(printf("move_img...err = %d\n\n",err))
 return err;

}


/*---------------------------------------------------------------------------
fusion_move_proc - ???
---------------------------------------------------------------------------*/

void
fusion_move_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;
 int select;

 PRT(printf("fusion_move_proc...\n"))
 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
/*
 x = (int) xv_get(or->dst_left,PANEL_VALUE);
 y = (int) xv_get(or->dst_top,PANEL_VALUE);
 PRT(printf("...x = %d y = %d\n",x,y))
*/
 select = (int) xv_get(item,XV_KEY_DATA,1);
 if (select == 1)
     /* FIXME:  Removed a final 0 argment from the line below, to
	conform to the actual calling sequence.  -PWH 1990427 */
    WinFusionMove3d(or->win,1,0);
 else win_fusion_move_img(or->win);
}


/*---------------------------------------------------------------------------
fusion_event_action_proc - ???
---------------------------------------------------------------------------*/

int
fusion_event_action_proc(win,event)
 struct image_display_window *win;
 Event *event;
{
 struct img_buf_rec *img;
 int sel;

 sel = 0;
 if (event_shift_is_down(event)) sel = 1;
   else if (event_ctrl_is_down(event)) sel = 2;
 PRT11(printf("fusion_event_action_proc...sel = %d\n",sel))
 if (sel)
    {if (win->type2 & DISPLAY_WINDOW)
        {
         return win_fusion_move_img(win);}
     if (!(win->type2 & DISPLAY_WINDOW_3D)) return NO_ERROR;
     if (sel == 1)
        ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,3,
          "Moving/Rotating all the 3d images in the same group...,",
          "For all co-registered wids...,",
          "reco-register them !!!",
          WinFusionMove3d,3,win,1,1);
       else
        ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,3,
          "Moving/Rotating the cur 3d image...,",
          "For all co-registered wids in the same group...,",
          "reco-register them !!!",
          WinFusionMove3d,3,win,1,0);
     }
    else 
     {if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
         return CANCEL;
      if (img->_2d_fusion.status & FUSION_MOVE_PERFORMED)
         {PRT11(printf("fusion_event_action_proc...win_move_show_hide_fusion\n"))
          win_move_show_hide_fusion(win,1);}
        else 
         {PRT12(printf("fusion_event_action_proc...move_superimpose_proc\n"))
          move_superimpose_proc(win,0,.0,.0);}
      img->_2d_fusion.status |= FUSION_MOVE_IGNORED_EVENT_UP;
     }
 PRT11(printf("fusion_event_action_proc...end\n\n"))
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
WinSetupWindowListItem - ???
---------------------------------------------------------------------------*/

int
WinSetupWindowListItem(win,item,select,win_type2)
 struct image_display_window *win;
 Panel_item item;
 int select;
 unsigned short win_type2;
{
 struct img_buf_rec *img;
 int err;
 struct strs_rec wids;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 TRACE(printf("img->win->root->total_wins = %d\n",
        img->win->root->total_wins))
 init_strs_rec(&wids);
 if ((err = AllWids(win->owner,&wids,1,select,win_type2)) == NO_ERROR)
    {setup_list_items(&wids,item,0);
    }
 free_strs_rec(&wids);
 return err;
}


/*---------------------------------------------------------------------------
win_add_or_drop_dynamic_fusion - ???
---------------------------------------------------------------------------*/

void
win_add_or_drop_dynamic_fusion(win,is_add)
 struct image_display_window *win;
 int is_add;
{
 struct img_buf_rec *img,*img1;
 struct image_display_window *win1;
 struct win_rec *rwin;
 char *wid;
 int err;

 PRT(printf("win_add_or_drop_dynamic_fusion...1\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     return /*CANCEL*/;
 if ((img->src_wid != NULL) &&
     ((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) != NULL) &&
     ((win1 = rwin->image_display) != NULL) &&
     ((img1 = win_rec_cur_img_buf(win1->owner)) != NULL))
    {if (img->_2d_fusion.status & FUSION_METHOD)
        {if ((wid = WinRecGetWid(img->win,win1->type2)) != NULL)
            {if (is_add)
                if ((err = add_img_dst_wids(img1,wid)) == NO_ERROR)
                  img->_2d_fusion.status |= FUSION_DYNAMIC;
               else if ((err = drop_img_dst_wids(img1,wid)) == NO_ERROR)
                  img->_2d_fusion.status &= ~FUSION_DYNAMIC;
            }
        }
    }
}


/*---------------------------------------------------------------------------
dynamic_fusion_proc - ???
---------------------------------------------------------------------------*/

void
dynamic_fusion_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct or_menu_rec *or;

 PRT(printf("dynamic_fusion_proc value = %d\n",value);)
 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 win_add_or_drop_dynamic_fusion(or->win,value);
}


/*---------------------------------------------------------------------------
fusion_method_proc - ???
---------------------------------------------------------------------------*/

void
fusion_method_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct or_menu_rec *or;
 struct img_buf_rec *img;
 unsigned long method,method1;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 if ((img->_2d_fusion.status & FUSION_METHOD) &&
     (img->status4 |= IMAGE_2D_SUPERIMPOSED_READY))
    {method1 = fusion_method(value);
     method = img->_2d_fusion.status & FUSION_METHOD;
     if (method1 == method)
	 return /*NO_ERROR*/;
     img->_2d_fusion.status |= FUSION_MUST_RECOMPUTE;
     img->_2d_fusion.status &= ~FUSION_METHOD;
     img->_2d_fusion.status |= method1;
     win_show_fusion(or->win);
    }
}

/***********
accum_fusion_proc(item,value,event)
 Panel_item item;
 int value;
 Event *event;
{
 struct or_menu_rec *or;
 struct img_buf_rec *img;

 PRT(printf("accum_fusion_proc value = %d\n",value);)
 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL) return CANCEL;
 if (value) img->_2d_fusion.status |= FUSION_ACCUMULATED;
   else img->_2d_fusion.status &= ~FUSION_ACCUMULATED;
}
*************/


/*---------------------------------------------------------------------------
WinRedefineFusionParams - ???
---------------------------------------------------------------------------*/

int
WinRedefineFusionParams(win,src_win,src_wid,
                        add_this_move_offset,left_offset,top_offset,
                        src_bound,dst_bound,opr,is_dynamic)
 struct image_display_window *win,*src_win;
 char *src_wid;
 int add_this_move_offset,left_offset,top_offset;
 struct int_bound_rec *src_bound,*dst_bound;
 int *opr,*is_dynamic;
{
 struct all_or_menu_recs *all_ors;
 struct or_menu_rec *or;
 struct img_buf_rec *img;
 struct img_buf_rec *img1;
 struct buf_2d_rec *src,*dst;
 long left,top;
 struct color_data_rec *color_data,*color_data1;

 PRT21(printf("WinRedefineFusionParams...1\n"))
 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((color_data = WinCurColorData(win)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(src_win->owner)) == NULL) ||
     ((color_data1 = WinCurColorData(src_win)) == NULL))
    return CANCEL;
 dst = &(color_data->_2d);
 src = &(color_data1->_2d);
 PRT21(printf("WinRedefineFusionParams...2\n"))
 if (((all_ors = enter_fusion_menu(NULL, GET_ALL_OR_MENU_PTR)) != NULL) &&
     ((or = find_or_menu_rec_win(all_ors,win)) != NULL))
    {
     FusionSrc1AndSrc2Bound(or,win,src_win,dst_bound,src_bound);
     *opr = (int) xv_get(or->opr,PANEL_VALUE);
     select_list_str_item(src_wid,or->window,1);
     if (xv_get(or->dynamic,PANEL_VALUE)) *is_dynamic = 1;
       else *is_dynamic = 0;
    }
   else
    {
     win_fusion_def_params(win);
     dst_left_top(win,src_win,&left,&top);
     PRT21(printf("left = %d  top = %d...\n",left,top);)
     img->_2d_fusion.def_dst_left = left;
     img->_2d_fusion.def_dst_top = top;
     setup_int_bound_rec(src_bound,0,0,src->dimx - 1,src->dimy - 1);
     setup_int_bound_rec(dst_bound,left,top,left + src->dimx - 1,left + src->dimy - 1);
     *is_dynamic = 1;
     *opr = 0;
    }
 if (add_this_move_offset)
    {dst_bound->left += left_offset;
     dst_bound->top += top_offset;}
 PRT21(printf("WinRedefineFusionParams...end\n"))

 return NO_ERROR;
}


/*---------------------------------------------------------------------------
win_redefine_fusion_bounds - ???
---------------------------------------------------------------------------*/

int
win_redefine_fusion_bounds(win,src_win,src_wid)
 struct image_display_window *win,*src_win;
 char *src_wid;
{
 struct int_bound_rec src_bound,dst_bound;
 int opr,err,is_dynamic;
 struct img_buf_rec *img;

 PRT(printf("win_redefine_dst_fusion...1\n"))
 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((err = WinRedefineFusionParams(win,src_win,src_wid,0,
               0,0,&src_bound,&dst_bound,
               &opr,&is_dynamic)) != NO_ERROR)
    return err;
 img->_2d_fusion.src_bound = src_bound;
 img->_2d_fusion.dst_bound = dst_bound;
 img->_2d_fusion.status &= ~FUSION_MOVE_PERFORMED;
 img->_2d_fusion.status |= FUSION_MOVE_UPDATE;
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
win_fusion - ???
---------------------------------------------------------------------------*/

int
win_fusion(win,src_win,src_wid,add_this_move_offset,left_offset,top_offset)
 struct image_display_window *win,*src_win;
 char *src_wid;
 int add_this_move_offset,left_offset,top_offset;
{
 struct int_bound_rec src_bound,dst_bound;
 int opr,err,is_dynamic;
 struct img_buf_rec *img,*img1;

 PRT21(printf("win_fusion(...\n"))
 if (((img = win_rec_cur_img_buf(win->owner)) == NULL) ||
     ((img1 = win_rec_cur_img_buf(src_win->owner)) == NULL))
    return CANCEL;
 PRT21(printf("win_fusion(...src_win = %u  src_wid = %s\n",src_win,src_wid))

 if (((err = WinRedefineFusionParams(win,src_win,src_wid,add_this_move_offset,
               left_offset,top_offset,
               &src_bound,&dst_bound,&opr,&is_dynamic)) != NO_ERROR) ||
     ((err = WinImageFusion1(win,&src_bound,&dst_bound,opr,src_wid)) != NO_ERROR))
    ShowMsgStrs(win->dwin->frame,1,err,0,2,
               "An error occurred when performing",
               "the image fusion !!!",NULL,0);
   else
    {
     PRT21(printf("win_fusion(...is_dynamic = %d\n",is_dynamic))
     img->_2d_fusion.status &= ~FUSION_MOVE_SELF;
     if (is_dynamic) 
        {win_add_or_drop_dynamic_fusion(win,1);
         PRT8(printf("win_fusion..CURSOR_MOVE_SUPERIMPOSE...win = %u\n",win))
         PRT8(printf("win_fusion..which_cursor = %d\n",win->control.which_cursor))
         win_select_cursor(win,CURSOR_MOVE_SUPERIMPOSE);
         PRT8(printf("1..which_cursor = %d\n",win->control.which_cursor))}
    }
 PRT21(printf("win_fusion(...2\n"))
 PRT21(printf("win_fusion...err = %d\n",err))
 return err;
}


/*---------------------------------------------------------------------------
win_fusion_which_win_proc - ???
---------------------------------------------------------------------------*/

int
win_fusion_which_win_proc(win,wid)
 struct image_display_window *win;
 char *wid;
{
 int err;
 struct win_rec *rwin;

 PRT21(printf("win_fusion_which_win_proc...wid = %s\n",wid))
 if (wid == NULL) return NO_ERROR;
 if (((rwin = get_win_rec_by_wid_str(win->owner,wid)) != NULL) &&
     (rwin->image_display != NULL))
    {err = win_fusion(win,rwin->image_display,wid,0,0,0);
     PRT21(printf("win_fusion_which_win_proc...err = %d\n",err))
     return err;
    }
   else
    {ShowMsgStrs(win->dwin->frame,1,NO_ERROR,0,4,
               "Image display window of",
               wid,"doesn't exist !!!",
               "Cannot superimpose !!!",NULL,0);
     return CANCEL;}
}


/*---------------------------------------------------------------------------
win_fusion_which_win - ???
---------------------------------------------------------------------------*/

int
win_fusion_which_win(win)
 struct image_display_window *win;
{
 int err;
 struct strs_rec *wids;
 Xv_Window window;
 char *str;

 PRT21(printf("win_fusion_which_win...\n"))
 if ((err = setup_strs_rec(&wids,0,0)) == NO_ERROR)
    {if ((err = AllWids(win->owner,wids,1,1,MANY_SLICES_WINDOWS)) == NO_ERROR)
        {if (wids->num_strs == 0)
            add_str_to_strs_rec(wids,"NO OTHER WIDs !!!");
         window = canvas_paint_window(win->dwin->frame_canvas.canvas);
         concat_strs(&str,2,win->owner->wid,"IMAGE FUSION WITH");
         ShowMenuStrsProc(window,NULL,str,
			  wids,USER_MENU_FREE_STRS_AND_PTR,
			  win_fusion_which_win_proc,win,1,0,0);
         c_free(str);
        }
       else
        {free_strs_rec(wids);
         c_free(wids);}
    }
 PRT21(printf("win_fusion_which_win...end err = %d\n",err))
 return err;
}


/*---------------------------------------------------------------------------
win_fusion_switching_src_to_dst - ???
---------------------------------------------------------------------------*/

int
win_fusion_switching_src_to_dst(win)
 struct image_display_window *win;
{
 struct image_display_window *nextwin;
 struct win_rec *rwin;
 struct img_buf_rec *img,*img1;
 int err;
 long left_offset,top_offset;
 char *src_wid;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((img->_2d_fusion.status & FUSION_METHOD) &&
     (img->src_wid != NULL) &&
     ((rwin = get_win_rec_by_wid_str(img->win,img->src_wid)) != NULL) &&
     ((nextwin = rwin->image_display) != NULL) &&
     ((img1 = win_rec_cur_img_buf(rwin)) != NULL) &&
     ((src_wid = WinRecGetWid(win->owner,nextwin->type2)) != NULL))
    {err = NO_ERROR;
     left_offset = img->_2d_fusion.dst_bound.left - 
                       img->_2d_fusion.def_dst_left;
     top_offset = img->_2d_fusion.dst_bound.top - 
                       img->_2d_fusion.def_dst_top;
     win_delete_fusion(win);
     if ((err = win_fusion(nextwin,win,src_wid,1,-left_offset,-top_offset))
               != NO_ERROR)
        ShowMsgStrs(win->dwin->frame,0,err,0,1,
                    "Error...unable to switch fusion !!!",NULL,0);
    }
   else
    {err = CANCEL;
     ShowMsgStrs(win->dwin->frame,0,0,0,1,
                    "Error...unable to switch fusion !!!",NULL,0);
    }
 return err;
}


/*---------------------------------------------------------------------------
win_fusion_switching - ???

FIXME:  This routine looks like it ought to return int, but no one ever
looks at the return value, so I changed it to void.  -PWH 19990427
---------------------------------------------------------------------------*/

void
win_fusion_switching(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 struct win_rec *rwin;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     return /*CANCEL*/;
 if ((img->_2d_fusion.status & FUSION_METHOD) && (img->src_wid != NULL)) {
    win_fusion_switching_src_to_dst(win);
    return; }
   else if (img->num_dst_wids > 0)
    if (((rwin = get_win_rec_by_wid_str(img->win,img->dst_wids[0])) != NULL) &&
        (rwin->image_display != NULL)) {
    win_fusion_switching_src_to_dst(rwin->image_display);
    return; }
   else
    {ShowMsgStrs(win->dwin->frame,0,0,0,1,
                    "Sorry...unable to switch fusion !!!",NULL,0);
    return /*CANCEL*/;}
}


/*---------------------------------------------------------------------------
win_set_redefine_dst_fusion_params - ???
---------------------------------------------------------------------------*/

void
win_set_redefine_dst_fusion_params(win)
 struct image_display_window *win;
{
 struct image_display_window *win1;
 struct img_buf_rec *img,*img1;
 struct win_rec *rwin;
 long lcv;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
     return /*CANCEL*/;
 PRT(printf("win_redefine_dst_fusion...num_dst_wids = %d\n",img->num_dst_wids))
 for (lcv = 0; lcv < img->num_dst_wids; lcv++)
    if (((rwin = get_win_rec_by_wid_str(img->win,img->dst_wids[lcv])) != NULL) &&
        ((win1 = rwin->image_display) != NULL) &&
        ((img1 = win_rec_cur_img_buf(win1->owner)) != NULL) &&
        (img1->_2d_fusion.status & FUSION_METHOD))
       img1->status4 |= IMG_REDEFINE_FUSION_PARAMS;
}


/*---------------------------------------------------------------------------
fusion_more_proc - ???
---------------------------------------------------------------------------*/

void
fusion_more_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 notice_prompt(or->frame,(Event *) NULL,
            NOTICE_MESSAGE_STRINGS,
	       "Ctrl A - 1) Enable the \"hand\" cursor to move the fusion image",
               "         2) Disable the fusion if the \"hand\" cursor is current",
               "         3) Enable to move the current image",
	       "<> A - superimpose the co-reg image, only",
	       "       applicable for the 3d-window",
	       "Ctrl F - select a wid with which the fusion is to be performed",
	       "Sh F - switch fusion between the destination & source",
	       "F - same as Sh F, but only applicable to the 3d windows",
	       "Ctrl S - Last superimposed image left & top",
               "D - 1) show the source image only",
               "    2) hide the source image",
               "    3) show the fusion image",
               "",
               "When the \"hand\" cursor is enabled...",
               "Sh middle-button - move the 3d image by the relative new image position",
               "           for the whole group",
               "Ctrl middle-button - move the 3d image by the relative new image position",
               "           for the current wid only",
               "middle-button - 1) show the fusion image when it is highlighted",
               "              - 2) show the fusion image",
               "right-button - like \"D\" described above",
               "",
               "Rotate-Plane if invoked actually rotates the superimposed image",
               "",
               "..1) <>1..9/<Sh><>1..9",
               "--- move forward/backward by 1..9 in the x direction",
               "..2) [<>/<Sh><>] <KEYPAD-digit>",
               "--- move forward/backward by <digit> pixel in the y direction",
               "",
              0,
            NOTICE_BUTTON_YES," OK !",
            0);
}


/*---------------------------------------------------------------------------
initial_dst_left_top - ???
---------------------------------------------------------------------------*/

void
initial_dst_left_top(or)
 struct or_menu_rec *or;
{
 struct win_rec *rwin;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 PRT1(printf("initial_dst_left_top...top = %d left = %d src_wid = %s\n",
       img->_2d_fusion.dst_bound.top,img->_2d_fusion.dst_bound.left,img->src_wid))
 if (img->_2d_fusion.status & FUSION_METHOD)
    {xv_set(or->dst_top,PANEL_VALUE,img->_2d_fusion.dst_bound.top,0);
     xv_set(or->dst_left,PANEL_VALUE,img->_2d_fusion.dst_bound.left,0);
     PRT1(printf("initial_dst_left_top...1\n"))
    }
   else if ((img->src_wid == NULL) ||
     ((rwin = get_win_rec_by_wid_str(or->win->owner,img->src_wid)) == NULL) ||
     (rwin->image_display != NULL))
    {xv_set(or->dst_top,PANEL_VALUE,0,0);
     xv_set(or->dst_left,PANEL_VALUE,0,0);
     PRT1(printf("initial_dst_left_top...2\n"))
    }
   else
    {dst_left_top(or->win,rwin->image_display,
           &(img->_2d_fusion.def_dst_left),&(img->_2d_fusion.def_dst_top));
     img->_2d_fusion.dst_bound.top = img->_2d_fusion.def_dst_top;
     img->_2d_fusion.dst_bound.left = img->_2d_fusion.def_dst_left;
     xv_set(or->dst_top,PANEL_VALUE,img->_2d_fusion.dst_bound.top,0);
     xv_set(or->dst_left,PANEL_VALUE,img->_2d_fusion.dst_bound.left,0);
     img->_2d_fusion.status |= FUSION_LAST_LEFT_TOP_VALID;
     img->_2d_fusion.last_dst_left = img->_2d_fusion.dst_bound.left;
     img->_2d_fusion.last_dst_top = img->_2d_fusion.dst_bound.top;
     PRT1(printf("initial_dst_left_top...3\n"))
    }
}


/*---------------------------------------------------------------------------
move_left_proc - ???
---------------------------------------------------------------------------*/

void
move_left_proc(item,val,event)
 Panel_item item;
 int val;
 Event *event;
{
 struct or_menu_rec *or;
 struct img_buf_rec *img;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 img->_2d_fusion.status |= FUSION_LAST_LEFT_TOP_VALID;
 img->_2d_fusion.last_dst_left = img->_2d_fusion.dst_bound.left;
 img->_2d_fusion.last_dst_top = img->_2d_fusion.dst_bound.top;

 img->_2d_fusion.dst_bound.left = val;
 if (or->movexy_msg != 0) movexy_msg(or);
 win_move_show_hide_fusion(or->win,1);
}


/*---------------------------------------------------------------------------
move_top_proc - ???
---------------------------------------------------------------------------*/

void
move_top_proc(item,val,event)
 Panel_item item;
 int val;
 Event *event;
{
 struct or_menu_rec *or;
 struct img_buf_rec *img;

 or = (struct or_menu_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if ((img = win_rec_cur_img_buf(or->win->owner)) == NULL)
     return /*CANCEL*/;
 img->_2d_fusion.status |= FUSION_LAST_LEFT_TOP_VALID;
 img->_2d_fusion.last_dst_left = img->_2d_fusion.dst_bound.left;
 img->_2d_fusion.last_dst_top = img->_2d_fusion.dst_bound.top;
 img->_2d_fusion.dst_bound.top = val;
 if (or->movexy_msg != 0) movexy_msg(or);
 win_move_show_hide_fusion(or->win,1);
}


/*---------------------------------------------------------------------------
or_done_proc - ???
---------------------------------------------------------------------------*/

void
or_done_proc(frame)
 Frame frame;
{
 struct or_menu_rec *or;

 or = (struct or_menu_rec *)
                     xv_get(frame,WIN_CLIENT_DATA);
 free_or_menu_rec(or);
}


/*---------------------------------------------------------------------------
win_fusion_def_params - ???
---------------------------------------------------------------------------*/

int
win_fusion_def_params(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 unsigned long first,max,num_colors;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (img->_2d_fusion.status & FUSION_METHOD) return NO_ERROR;
 win_first_and_num_colors(win,&first,&num_colors);
 max = num_bit_values(img->_2d.pixel_depth) - 1;

 if (!(img->_2d_fusion.status & FUSION_DST_MINMAX_DEFINED))
    {img->_2d_fusion.dstmin = first + 7;
     img->_2d_fusion.dstmax = max;
     img->_2d_fusion.status |= FUSION_DST_MINMAX_DEFINED;}
 if (!(img->_2d_fusion.status & FUSION_SRC_MINMAX_DEFINED))
    {img->_2d_fusion.srcmin = first + 7;
     img->_2d_fusion.srcmax = max;
     img->_2d_fusion.status |= FUSION_SRC_MINMAX_DEFINED;}
 return NO_ERROR;
}


/*---------------------------------------------------------------------------
setup_or_menu_rec - ???
---------------------------------------------------------------------------*/

int
setup_or_menu_rec(or,win)
 struct or_menu_rec *or;
 struct image_display_window *win;
{
 Panel_item item;
 int row,offset,temp;
 unsigned long max;
 struct img_buf_rec *img;
 char *str;
 Rect *rr,*rr1;
 unsigned long first,num_colors;
 struct color_data_rec *color_data;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((color_data = WinCurColorData(win)) == NULL) return CANCEL;
 or->frame = xv_create(win->dwin->frame, FRAME,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_INHERIT_COLORS,TRUE,
              WIN_CLIENT_DATA,or,
              0);
 if (or->frame == 0)
    {free_or_menu_rec(or);
     return ~NO_ERROR;}
 TRACE(printf("setup_or_menu_rec...1\n"))

 or->win = win;
 or->dwin = win->dwin;
 str = win_rec_win_id_title(win->owner,IMAGE_FUSION_MENU);
 xv_set(or->frame,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              FRAME_DONE_PROC,or_done_proc,
              0);
 c_free(str);
 xv_set(or->frame,FRAME_CLOSED,FALSE,0);
 TRACE(printf("setup_or_menu_rec...2\n"))

 or->panel = xv_create(or->frame,PANEL,
               FRAME_INHERIT_COLORS,TRUE,
               0);

 if (or->panel == 0)
    {free_or_menu_rec(or);
     return ~NO_ERROR;}

 row = 2;
 offset = xv_rows(or->panel,1) - xv_rows(or->panel,0) - 13;
 item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"FUSION",
	PANEL_NOTIFY_PROC,image_fusion_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 or->dynamic = xv_create(or->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"DYNAMIC",NULL,
	PANEL_NOTIFY_PROC,dynamic_fusion_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row - 2,
        PANEL_VALUE,1,
        PANEL_CLIENT_DATA,or,
	0);
 TRACE(printf("setup_or_menu_rec...3\n"))

 img->_2d_fusion.status |= FUSION_DYNAMIC;
 rr = (Rect *) xv_get(or->dynamic,XV_RECT);
 or->opr = xv_create(or->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,"OR","BLEND 3X3",
               "BLEND 6X6","BLEND 9X9",NULL,
        PANEL_VALUE,0,
	PANEL_NOTIFY_PROC,fusion_method_proc,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row - 1,
        0);
/*
 rr = (Rect *) xv_get(or->opr,XV_RECT);
 item = xv_create(or->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"ACCUMULATE",NULL,
	PANEL_NOTIFY_PROC,accum_fusion_proc,
        XV_X,rr->r_left + rr->r_width + 5,XV_Y,row - 2,
        PANEL_VALUE,0,
        PANEL_CLIENT_DATA,or,
	0);

 row += offset - 3;

 or->unselected = xv_create(or->panel,PANEL_CHOICE_STACK,
	PANEL_LABEL_STRING,"WHERE UNSELECTED =",
        PANEL_CHOICE_STRINGS,"DYNAMIC DEST","CUR DEST",NULL,
        PANEL_VALUE,0,
        XV_X,20,XV_Y,row,
        0);
*/
 TRACE(printf("setup_or_menu_rec...4\n"))
 win_fusion_def_params(win);
 TRACE(printf("setup_or_menu_rec...5\n"))

 row += offset + 2;
 max = num_bit_values(img->_2d.pixel_depth) - 1;
 win_first_and_num_colors(win,&first,&num_colors);

 or->dstminmax = xv_create(or->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row,
	              PANEL_LABEL_STRING,"",0);
 dst_msg(or);
 row += offset - 5;
 or->dst_left = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"LEFT",
        PANEL_SHOW_RANGE,FALSE,
        PANEL_VALUE,0,
            PANEL_MIN_VALUE,-(int) color_data->_2d.dimy - 1,
            PANEL_MAX_VALUE,(int) color_data->_2d.dimy - 1,
	PANEL_SLIDER_WIDTH,40,
        PANEL_CLIENT_DATA,or,
	PANEL_NOTIFY_PROC,move_left_proc,
        XV_X,10,XV_Y,row,
        0);
 rr = (Rect *) xv_get(or->dst_left,XV_RECT);
 or->dst_top = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"TOP",
        PANEL_SHOW_RANGE,FALSE,
        PANEL_VALUE,0,
            PANEL_MIN_VALUE,-(int) color_data->_2d.dimy - 1,
            PANEL_MAX_VALUE,(int) color_data->_2d.dimy - 1,
	PANEL_NOTIFY_PROC,move_top_proc,
	PANEL_SLIDER_WIDTH,40,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 TRACE(printf("setup_or_menu_rec...6\n"))
 initial_dst_left_top(or);
 TRACE(printf("setup_or_menu_rec...6...0\n"))

 row += offset;
 item = xv_create(or->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"NEW SOURCE...",
        XV_X,5,XV_Y,row,
        0);
 rr = (Rect *) xv_get(item,XV_RECT);
 or->centered = xv_create(or->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"CENTERED",NULL,
        XV_X,rr->r_left + rr->r_width,XV_Y,row - 2,
        PANEL_VALUE,1,
	0);
/*
 rr = (Rect *) xv_get(or->centered,XV_RECT);
 or->src_size = xv_create(or->panel,PANEL_CHECK_BOX,
	PANEL_CHOICE_STRINGS,"SIZE OF SRC = DEST",NULL,
        XV_X,rr->r_left + rr->r_width,XV_Y,row - 2,
        PANEL_VALUE,1,
	0);
 TRACE(printf("setup_or_menu_rec...7\n"))
*/
 temp = row;
 row += offset - 6;
 or->window = xv_create(or->panel,PANEL_LIST,
        PANEL_LIST_DISPLAY_ROWS,4,
        PANEL_LIST_WIDTH,60,
        PANEL_LAYOUT,PANEL_VERTICAL,
        XV_X,5,XV_Y,row,
	PANEL_NOTIFY_PROC,wid_proc,
        PANEL_CLIENT_DATA,or,
                   0);
 TRACE(printf("setup_or_menu_rec...8..1\n"))

 WinSetupWindowListItem(or->win,or->window,1,MANY_SLICES_WINDOWS);
 TRACE(printf("setup_or_menu_rec...mg->src_wid = %s\n",img->src_wid))
 if (img->src_wid != NULL)
    select_list_str_item(img->src_wid,or->window,1);

 row += offset - 5;
 rr = (Rect *) xv_get(or->window,XV_RECT);
 or->cur_srcminmax = xv_create(or->panel,PANEL_MESSAGE,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_LABEL_STRING,"",0);
 row += offset - 5;
 or->cur_srcdim = xv_create(or->panel,PANEL_MESSAGE,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	PANEL_LABEL_STRING,"",0);
 TRACE(printf("setup_or_menu_rec...6...1\n"))
 cur_src_msg(or);
 TRACE(printf("setup_or_menu_rec...6...2\n"))

 row += offset - 5;

 or->src_left = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"LEFT",
        PANEL_SHOW_RANGE,FALSE,
	PANEL_SLIDER_WIDTH,40,
        PANEL_MIN_VALUE,0,PANEL_MAX_VALUE,0,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 
 rr1 = (Rect *) xv_get(or->src_left,XV_RECT);
 or->src_top = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"TOP",
        PANEL_SHOW_RANGE,FALSE,
        PANEL_MIN_VALUE,0,PANEL_MAX_VALUE,0,
	PANEL_SLIDER_WIDTH,40,
        PANEL_CLIENT_DATA,or,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
        0);

 row += offset;
 or->src_width = xv_create(or->panel,PANEL_NUMERIC_TEXT,
	PANEL_LABEL_STRING,"WIDTH",
        PANEL_VALUE_DISPLAY_LENGTH,4,
        PANEL_MIN_VALUE,0,PANEL_MAX_VALUE,0,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr1 = (Rect *) xv_get(or->src_width,XV_RECT);
 or->src_height = xv_create(or->panel,PANEL_NUMERIC_TEXT,
	PANEL_LABEL_STRING," HEIGHT",
        PANEL_VALUE_DISPLAY_LENGTH,4,
        PANEL_MIN_VALUE,0,PANEL_MAX_VALUE,0,
        PANEL_CLIENT_DATA,or,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
 row += offset;

 TRACE(printf("setup_or_menu_rec...9\n"))
/*
 or->srcmin = xv_create(or->panel,PANEL_SLIDER,
        PANEL_SHOW_RANGE,FALSE,
	PANEL_LABEL_STRING,"Min",
	PANEL_VALUE,img->_2d_fusion.srcmin,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_minmax_proc,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 TRACE(printf("setup_or_menu_rec...10\n"))
 rr1 = (Rect *) xv_get(or->srcmin,XV_RECT);
 or->srcmax = xv_create(or->panel,PANEL_SLIDER,
        PANEL_SHOW_RANGE,FALSE,
	PANEL_LABEL_STRING,"Max",
	PANEL_VALUE,img->_2d_fusion.srcmax,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_minmax_proc,
        PANEL_CLIENT_DATA,or,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
row += offset;
 item = xv_create(or->panel,PANEL_MESSAGE,
	PANEL_LABEL_STRING,"NEW DEST...opaque min/max",
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        0);
 row += offset - 4;
 TRACE(printf("setup_or_menu_rec...11\n"))
 or->dstmin = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"Min",
        PANEL_SHOW_RANGE,FALSE,
	PANEL_VALUE,img->_2d_fusion.dstmin,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_minmax_proc,
        PANEL_CLIENT_DATA,or,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
	0);
 rr1 = (Rect *) xv_get(or->dstmin,XV_RECT);
 or->dstmax = xv_create(or->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"Max",
        PANEL_SHOW_RANGE,FALSE,
	PANEL_VALUE,img->_2d_fusion.dstmax,
	PANEL_MIN_VALUE,first,
	PANEL_MAX_VALUE,max,
	PANEL_SLIDER_WIDTH,40,
	PANEL_NOTIFY_PROC,set_minmax_proc,
        PANEL_CLIENT_DATA,or,
        XV_X,rr1->r_left + rr1->r_width,XV_Y,row,
	0);
*/
 
 TRACE(printf("setup_or_menu_rec...5..3\n"))
 row = rr->r_top + rr->r_height;
 item = xv_create(or->panel,PANEL_MESSAGE,
                      XV_X,5,XV_Y,row + 3,
	              PANEL_LABEL_STRING,"FUSION",0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"DELETE",
	PANEL_NOTIFY_PROC,delete_or_image_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,SHOW_STR,
	PANEL_NOTIFY_PROC,show_or_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,SHOW_HIDE_STR,
	PANEL_NOTIFY_PROC,show_hide_or_proc,
        XV_X,rr->r_left + rr->r_width,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
 TRACE(printf("slice = %u   view = %u\n",img->cur_slice->slice,
           img->cur_slice->slice->view);)
 row += offset + 2;
 if ((img->cur_slice->slice != NULL) && (img->cur_slice->slice->view != NULL))
    {
     item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"MOVE 3D BY X/Y FOR",
        XV_KEY_DATA,1,1,
	PANEL_NOTIFY_PROC,fusion_move_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
     rr = (Rect *) xv_get(item,XV_RECT);
     or->cur_group = xv_create(or->panel,PANEL_CHOICE_STACK,
        PANEL_CHOICE_STRINGS,"CUR PLANE","CUR GROUP PLANES",NULL,
        PANEL_VALUE,1,
        XV_X,rr->r_left + rr->r_width,XV_Y,row - 2,
        0);
    }
   else
    {
     item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"MOVE DST IMAGE BY X/Y - [Ctrl|Sh] Mid-Button",
        XV_KEY_DATA,1,0,
	PANEL_NOTIFY_PROC,fusion_move_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
    }

 row += offset;

 item = xv_create(or->panel,PANEL_BUTTON,
	PANEL_LABEL_STRING,"MORE...",
	PANEL_NOTIFY_PROC,fusion_more_proc,
        XV_X,5,XV_Y,row,
        PANEL_CLIENT_DATA,or,
	0);
 rr = (Rect *) xv_get(item,XV_RECT);
 temp = rr->r_left + rr->r_width + 2;
 or->movexy_msg = xv_create(or->panel,PANEL_MESSAGE,
        XV_X,temp,XV_Y,row,
        0);
 movexy_msg(or);
 setup_source_msg(or);

 window_fit(or->panel);
 rr = (Rect *) xv_get(or->panel,XV_RECT);
 xv_set(or->panel,XV_WIDTH,rr->r_width - 10,0);

 rr = (Rect *) xv_get(or->panel,XV_RECT);
 xv_set(or->panel,XV_HEIGHT,rr->r_height - 15,0);
 window_fit(or->frame);
 make_2_wins_adjacent(or->frame,win->dwin->frame,0);
 win_set_mouse_at_center(or->frame);
 TRACE(printf("setup_or_menu_rec..7\n"))

 return NO_ERROR;
}


/*---------------------------------------------------------------------------
update_fusion_menu - ???
---------------------------------------------------------------------------*/

void
update_fusion_menu(win)
 struct image_display_window *win;
{
 struct all_or_menu_recs *all_ors;
 struct or_menu_rec *or;
 struct img_buf_rec *img;

 if (((all_ors = enter_fusion_menu(win, GET_ALL_OR_MENU_PTR)) != NULL) &&
     ((or = find_or_menu_rec_win(all_ors,win)) != NULL))
    {
     if ((img = win_rec_cur_img_buf(win->owner)) == NULL)
	 return /*CANCEL*/;
     xv_set(or->dst_top,PANEL_VALUE,img->_2d_fusion.dst_bound.top,0);
     xv_set(or->dst_left,PANEL_VALUE,img->_2d_fusion.dst_bound.left,0);
     if (or->movexy_msg != 0) movexy_msg(or);
    }
}


/*---------------------------------------------------------------------------
find_or_menu_rec_win - ???
---------------------------------------------------------------------------*/

struct or_menu_rec *
find_or_menu_rec_win(all_ors,win)
 struct all_or_menu_recs *all_ors;
 struct image_display_window *win;
{
 int lcv;

 for (lcv = 0; lcv < all_ors->numors; lcv++)
    if (all_ors->ors[lcv]->win == win)
       return all_ors->ors[lcv];
 return NULL;
}


/*---------------------------------------------------------------------
setup_fusion_menu - ???

Wrapper for those who don't need to know the internal data structures used
in enter_fusion_menu.
---------------------------------------------------------------------*/

void
setup_fusion_menu(
    struct image_display_window *win)
{
    enter_fusion_menu(win, 1);
    return;
}


/*---------------------------------------------------------------------
enter_fusion_menu - ???

BEWARE: The pre-19990224 version of this function could return either
NULL, a pointer to a structure, or an integer error code.  Since the
last two of these cannot be reliably distinguished and since no one
ever seems to check for an error code, I replaced the error code by
NULL.  Of course, it is now impossible to distinguish between NO_ERROR
and NULL (=> error), but I don't think anyone ever looks at the error
code returned.  -PWH
-----------------------------------------------------------------------*/

static struct all_or_menu_recs *
enter_fusion_menu(
    struct image_display_window *win,
    int status)
{
 static struct all_or_menu_recs all_ors;
 static char first_time = 1;
 int err;
 struct or_menu_rec *or;

 err = NO_ERROR;
 if (status == GET_ALL_OR_MENU_PTR)
    {if (first_time) return NULL;
       else return &all_ors;}
  else if (status == CLEAN_UP_OR_MENU)
   {if (!first_time)
       if ((or = find_or_menu_rec_win(&all_ors,win)) != NULL)
          free_or_menu_rec(or);
    return NO_ERROR;}

 if (first_time)
    {init_all_or_menu_recs(&all_ors);
     first_time = 0;}
   else
    {
     if ((or = find_or_menu_rec_win(&all_ors,win)) != NULL)
        {
         xv_set(or->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,WIN_ALARM,0);
         wmgr_top(or->frame);
         win_set_mouse_at_center(or->frame);
         return NO_ERROR;}
    }
 TRACE(printf("enter_fusion_menu...all_ors.numors = %d\n",all_ors.numors))
 get_handle_memory(&(all_ors.ors),&(all_ors.numors),1,
     (size_t) sizeof(struct or_menu_rec),&err);
 if (err != NO_ERROR) return NULL;    /* Was: return err */
 or = all_ors.ors[all_ors.numors - 1];
 init_or_menu_rec(or);
 if ((err = setup_or_menu_rec(or,win)) == NO_ERROR)
    xv_set(or->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);
 return NULL;    /* Was: return err */
}
