/****************************************************************************
win_opr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: win_opr.c,v 1.6 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "nria_procedures.h"


/*
#define TRACE(x) x; fflush(stdout);
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
#define PRT2(x) x; fflush(stdout);
*/
#define TRACE(x)
#define PRT(x)
#define PRT1(x)
#define PRT2(x)



/* Functions defined in this file */
unsigned long win_total_slice_cuts(struct win_rec *win);
unsigned long win_total_slice_scans(struct win_rec *win);
struct img_buf_rec *win_rec_cur_img_buf(struct win_rec *win);
struct strs_rec *win_rec_roi_labels_PTR(struct win_rec *win);
struct strs_rec *win_rec_pixel_types_PTR(struct win_rec *win);
struct strs_rec *win_rec_sec_roi_labels_PTR(struct win_rec *win);
struct strs_rec *win_rec_sec_pixel_types_PTR(struct win_rec *win);
struct strs_rec *win_rec_get_roi_labels_PTR(struct win_rec *win, int win_type);
struct strs_rec *win_rec_get_sec_roi_labels_PTR(struct win_rec *win,
    int win_type);
void win_rec_get_label_fns(struct win_rec *win, int win_type, char **main,
    char **sub);
int win_rec_rd_label_fns(struct win_rec *win, int win_type, char *main,
    char *sub);
int win_rec_wr_label_fns(struct win_rec *win, int win_type, char *main,
    char *sub);
char *WinRecGetWid(struct win_rec *win, int win_type2);
char *win_rec_win_id_title(struct win_rec *win, char *subtitle);
char *get_img_whch_minmax(struct img_buf_rec *img);
char *win_rec_get_frame_label(struct win_rec *win, char *extra_label);
char *win_rec_get_pixel_type_label(struct win_rec *win, int win_type,
    unsigned long x, unsigned long y);
struct buf_2d_rec *win_rec_cur_data_buf(struct win_rec *win, int win_type);
int win_rec_save_labels(struct win_rec *win, int win_type,
    struct strs_rec *labels, int is_replace, int is_sec);
int win_rec_label_file_access(struct win_rec *win, int is_which_label_file,
    int mode, char **reason);
char *win_rec_get_histo_label1(struct win_rec *win, int win_type);
struct hdr_scan_entry_rec *win_rec_cur_slice(struct win_rec *win);
void win_rec_set_cur_slice(struct win_rec *win,
    struct hdr_scan_entry_rec *cur_slice);
struct image_display_window *win_rec_get_last_open_window1(
   struct win_rec *win, int win_type);
struct slice_roi_rec *win_rec_get_breaker(struct win_rec *win);
struct slice_roi_rec *win_rec_get_clipboard(struct win_rec *win);
struct image_display_window *win_rec_get_breaker_win(struct win_rec *win);
void win_rec_set_breaker_win(struct win_rec *win,
    struct image_display_window *breaker_win);
struct image_display_window *win_rec_get_clipboard_win(struct win_rec *win);
void win_rec_set_clipboard_win(struct win_rec *win,
    struct image_display_window *clipboard_win);
struct draw_mask_rec *win_rec_get_breaker_mask(struct win_rec *win);
struct draw_mask_rec *win_rec_get_clipboard_mask(struct win_rec *win);
int win_rec_get_wids(struct win_rec *win, struct strs_rec *wids);
struct image_display_window *win_rec_get_display_window(struct win_rec *win,
    int wid, int status);
struct win_rec *get_win_rec_by_wid_str(struct win_rec *win, char *wid_str);
int AllWids(struct win_rec *win, struct strs_rec *wids, int is_sorted,
    int select, int win_type2);



/*--------------------------------------------------------------------------
win_total_slice_cuts - ???
--------------------------------------------------------------------------*/

unsigned long 
win_total_slice_cuts(win)
 struct win_rec *win;
{
 unsigned long  cnt;

 cnt = total_slice_cuts(win->img_bufs[win->cur_img]);
 TRACE(printf("cnt slice = %d\n",cnt))
 return cnt;
}


/*--------------------------------------------------------------------------
win_total_slice_scans - ???
--------------------------------------------------------------------------*/

unsigned long 
win_total_slice_scans(win)
 struct win_rec *win;
{
 unsigned long  cnt;

 cnt = total_slice_scans(win->img_bufs[win->cur_img]);
 TRACE(printf("cnt slice = %d\n",cnt))
 return cnt;
}



/*--------------------------------------------------------------------------
win_rec_cur_img_buf - ???
--------------------------------------------------------------------------*/

struct img_buf_rec *
win_rec_cur_img_buf( win )
 struct win_rec *win;
{
  if ((win == NULL) ||
      (win->img_bufs == NULL) ||
      (win->cur_img >= win->num_img_bufs))
    return NULL;

  return win->img_bufs[win->cur_img];
}


/*--------------------------------------------------------------------------
win_rec_roi_labels_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_roi_labels_PTR(win)
 struct win_rec *win;
{
 if ((win->image_display != NULL) &&
     (win->image_display->dwin != NULL) &&
     (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
    return &(win->root->cv_roi_labels);
   else return &(win->root->roi_labels);
}


/*--------------------------------------------------------------------------
win_rec_pixel_types_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_pixel_types_PTR(win)
 struct win_rec *win;
{
 return &(win->root->pixel_types);
}


/*--------------------------------------------------------------------------
win_rec_sec_roi_labels_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_sec_roi_labels_PTR(win)
 struct win_rec *win;
{
 if ((win->image_display != NULL) &&
     (win->image_display->dwin != NULL) &&
     (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
    return &(win->root->cv_sec_roi_labels);
   else return &(win->root->sec_roi_labels);
}


/*--------------------------------------------------------------------------
win_rec_sec_pixel_types_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_sec_pixel_types_PTR(win)
 struct win_rec *win;
{
 return &(win->root->sec_pixel_types);
}


/*--------------------------------------------------------------------------
win_rec_get_roi_labels_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_get_roi_labels_PTR(win,win_type)
 struct win_rec *win;
 unsigned short win_type;
{
 if (win_type & HISTOGRAM_WINDOW) 
    return win_rec_pixel_types_PTR(win);
   else return win_rec_roi_labels_PTR(win);
}


/*--------------------------------------------------------------------------
win_rec_get_sec_roi_labels_PTR - ???
--------------------------------------------------------------------------*/

struct strs_rec *
win_rec_get_sec_roi_labels_PTR(win,win_type)
 struct win_rec *win;
 unsigned short win_type;
{
 if (win_type & HISTOGRAM_WINDOW) 
    return win_rec_sec_pixel_types_PTR(win);
   else return win_rec_sec_roi_labels_PTR(win);
}


/*--------------------------------------------------------------------------
win_rec_get_label_fns - ???
--------------------------------------------------------------------------*/

void
win_rec_get_label_fns(win,win_type,main,sub)
 struct win_rec *win;
 unsigned short win_type;
 char **main,**sub;
{
 struct all_win_rec *win1;

 win1 = win->root;
 if ((win->image_display != NULL) &&
     (win->image_display->dwin != NULL) &&
     (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
     {*main = win1->cv_roi_label_fn;
      *sub = win1->cv_sec_roi_label_fn;
     }
    else if (win_type & HISTOGRAM_WINDOW)
     {*main = win1->pixel_type_fn;
      *sub = win1->sec_pixel_type_fn;
     }
    else
     {*main = win1->roi_label_fn;
      *sub = win1->sec_roi_label_fn;
     }
}


/*--------------------------------------------------------------------------
win_rec_rd_label_fns - ???
--------------------------------------------------------------------------*/

int
win_rec_rd_label_fns(win,win_type,main,sub)
 struct win_rec *win;
 unsigned short win_type;
 char *main,*sub;
{
 int err;
 struct all_win_rec *win1;

 err = NO_ERROR;
 win1 = win->root;
 if ((win->image_display != NULL) &&
     (win->image_display->dwin != NULL) &&
     (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
     {free_strs_rec(&(win1->cv_roi_labels));
      c_free(win1->cv_roi_label_fn);
      if ((err = setup_roi_labels(&(win1->cv_roi_label_fn),&(win1->cv_roi_labels),
           main,&(win1->status),WIN_REC_SAVE_CV_ROI_LABELS)) == NO_ERROR)
         {free_strs_rec(&(win1->cv_sec_roi_labels));
          c_free(win1->cv_sec_roi_label_fn);
          err = setup_roi_labels(&(win1->cv_sec_roi_label_fn),
               &(win1->cv_sec_roi_labels),sub,&(win1->status),0);}
     }
    else if (win_type & HISTOGRAM_WINDOW)
     {free_strs_rec(&(win1->pixel_types));
      c_free(win1->pixel_type_fn);
      if ((err = setup_roi_labels(&(win1->pixel_type_fn),&(win1->pixel_types),main,
           &(win1->status),0)) == NO_ERROR)
         {free_strs_rec(&(win1->sec_pixel_types));
          c_free(win1->sec_pixel_type_fn);
          err = setup_roi_labels(&(win1->sec_pixel_type_fn),
               &(win1->sec_pixel_types),sub,&(win1->status),0);}
     }
    else
     {free_strs_rec(&(win1->roi_labels));
      c_free(win1->roi_label_fn);
      if ((err = setup_roi_labels(&(win1->roi_label_fn),&(win1->roi_labels),main,
           &(win1->status),WIN_REC_SAVE_ROI_LABELS)) == NO_ERROR)
         {free_strs_rec(&(win1->sec_roi_labels));
          c_free(win1->sec_roi_label_fn);
          err = setup_roi_labels(&(win1->sec_roi_label_fn),
               &(win1->sec_roi_labels),sub,&(win1->status),0);
         }
     }
 return err;
}


/*--------------------------------------------------------------------------
win_rec_wr_label_fns - ???
--------------------------------------------------------------------------*/

int
win_rec_wr_label_fns(win,win_type,main,sub)
 struct win_rec *win;
 unsigned short win_type;
 char *main,*sub;
{
 int err;
 struct all_win_rec *win1;

 err = NO_ERROR;
 win1 = win->root;
 printf("win_rec_wr_label_fns main = %s sub = %s\n",main,sub);
 if ((win->image_display != NULL) &&
     (win->image_display->dwin != NULL) &&
     (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
     {
      c_free(win1->cv_roi_label_fn);
      if (((err = cp_str(&(win1->cv_roi_label_fn),main)) == NO_ERROR) &&
          ((err = write_labels(win1->cv_roi_label_fn,win1->cv_roi_labels.strs,
               win1->cv_roi_labels.num_strs)) == NO_ERROR))
         {c_free(win1->cv_sec_roi_label_fn);
          if ((err = cp_str(&(win1->cv_sec_roi_label_fn),sub)) == NO_ERROR)
             err = write_labels(win1->cv_sec_roi_label_fn,
               win1->cv_sec_roi_labels.strs,win1->cv_sec_roi_labels.num_strs);}
     }
    else if (win_type & HISTOGRAM_WINDOW)
     {
      c_free(win1->pixel_type_fn);
      if (((err = cp_str(&(win1->pixel_type_fn),main)) == NO_ERROR) &&
          ((err = write_labels(win1->pixel_type_fn,win1->pixel_types.strs,
               win1->pixel_types.num_strs)) == NO_ERROR))
         {c_free(win1->sec_pixel_type_fn);
          if ((err = cp_str(&(win1->sec_pixel_type_fn),sub)) == NO_ERROR)
             err = write_labels(win1->sec_pixel_type_fn,
               win1->sec_pixel_types.strs,win1->sec_pixel_types.num_strs);}
     }
    else
     {
      c_free(win1->roi_label_fn);
      if (((err = cp_str(&(win1->roi_label_fn),main)) == NO_ERROR) &&
          ((err = write_labels(win1->roi_label_fn,win1->roi_labels.strs,
               win1->roi_labels.num_strs)) == NO_ERROR))
         {c_free(win1->sec_roi_label_fn);
          if ((err = cp_str(&(win1->sec_roi_label_fn),sub)) == NO_ERROR)
             err = write_labels(win1->sec_roi_label_fn,
               win1->sec_roi_labels.strs,win1->sec_roi_labels.num_strs);}
     }
 return err;
}


/*--------------------------------------------------------------------------
WinRecGetWid - ???
--------------------------------------------------------------------------*/

char *
WinRecGetWid(win,win_type2)
 struct win_rec *win;
 unsigned short win_type2;
{
 int err;
 char win_id_str[15];
 unsigned long lcv,cnt;

 if (!(win->status & WIN_REC_ID_DEFINED))
    {for (lcv = 1; lcv <= win->root->total_wins; lcv++)
        {for (cnt = 0; cnt < win->root->total_wins; cnt++)
            if (win->root->wins[cnt]->status & WIN_REC_ID_DEFINED)
               if (lcv == win->root->wins[cnt]->win_id)
                  break;
         if (cnt == win->root->total_wins) break;
        }
     win->win_id = lcv;
     win->status |= WIN_REC_ID_DEFINED;
     if (win_type2 & HISTOGRAM_WINDOW)
        sprintf(win_id_str,"HW%ld:",win->win_id);
       else sprintf(win_id_str,"W%ld:",win->win_id);
     if ((err = cp_str(&(win->wid),win_id_str)) == NO_ERROR)
        return win->wid;
    }
   else if (win->wid != NULL) return win->wid;
 return NULL;
}


/*--------------------------------------------------------------------------
win_rec_win_id_title - ???
--------------------------------------------------------------------------*/

char *
win_rec_win_id_title(win,subtitle)
 struct win_rec *win;
 char *subtitle;
{
 char *str2;

 str2 = NULL;
 if (win->wid != NULL)
    {concat_strs(&str2,2,win->wid,subtitle);}
   else cp_str(&str2,subtitle);
 return str2;
}


/*--------------------------------------------------------------------------
get_img_whch_minmax - ???
--------------------------------------------------------------------------*/

char *
get_img_whch_minmax(img)
 struct img_buf_rec *img;
{
 char *whch_minmax;

 if (img->status4 & IMAGE_USE_SLICE_MIN_MAX)
    whch_minmax = "S:";
   else if (img->status4 & IMAGE_USE_SET_MIN_MAX)
    whch_minmax = "U:";
   else if (img->file->hdr.status & GLOBAL_MIN_MAX_UNDEFINED)
    whch_minmax = "g:";
   else whch_minmax = "G:";
 return whch_minmax;
}


/*--------------------------------------------------------------------------
win_rec_get_frame_label - ???
--------------------------------------------------------------------------*/

char *
win_rec_get_frame_label(win,extra_label)
 struct win_rec *win;
 char *extra_label;
{
 struct img_buf_rec *img;
 char *img_fn,*img_label,*dat,*edited,*whch_minmax,
      total_slices_str[15],slice_num_str[15],logical_slice_num_str[15],
      scan_num_str[20],*frame_label;
 unsigned long num_scans,scan_num,slice_num,logical_slice_num,total_slices;
 int err;

 img = win_rec_cur_img_buf(win);
 img_fn = get_img_fn(img);
 drop_dirfn(img_fn);
 img_label = get_img_label(img);
 slice_num = img->cur_slice->num;
 logical_slice_num = get_img_slice_num(img);
 total_slices = total_slice_cuts(img);
 sprintf(logical_slice_num_str,"%ld",logical_slice_num);
 sprintf(total_slices_str,"%ld",total_slices);

 num_scans = total_slice_scans(img);
 if (num_scans > 1)
    {scan_num = get_img_scan_num(img);
     sprintf(scan_num_str,"%-ld/%-ld:",scan_num,num_scans);}
   else scan_num_str[0] = '\0';

 whch_minmax = get_img_whch_minmax(img);
 if (img->file->output.status & FILE_CHANGED)
    {
     edited = "+";}
   else edited = NULL;
 if (img->file->output.status & FILE_READY) dat = "(.dat)";
   else dat = NULL;

 if (logical_slice_num == slice_num)
    err = concat_strs(&frame_label,13,img_label,extra_label,":",whch_minmax,win->wid,
                       scan_num_str,logical_slice_num_str,"/",
                       total_slices_str,":",edited,dat,img_fn);
   else
    {sprintf(slice_num_str,"%ld",slice_num);
     err = concat_strs(&frame_label,15,img_label,extra_label,":",
		       whch_minmax,win->wid,
                       scan_num_str,slice_num_str,"-",logical_slice_num_str,
		       "/", total_slices_str,":",edited,dat,img_fn);}
 c_free(img_fn);
 c_free(img_label);
 if (err == NO_ERROR) return frame_label;
   else return NULL;
}


/*--------------------------------------------------------------------------
win_rec_get_pixel_type_label - ???
--------------------------------------------------------------------------*/

char *
win_rec_get_pixel_type_label(win,win_type,x,y)
 struct win_rec *win;
 unsigned short win_type;
 unsigned long  x,y;
{
 if (win_type & HISTOGRAM_WINDOW)
    return GetHistoPixelTypeLabel(win_rec_cur_img_buf(win),x,y,win_type);
 return get_pixel_type_label(win_rec_cur_img_buf(win),x,y);
}


/*--------------------------------------------------------------------------
win_rec_cur_data_buf - ???
--------------------------------------------------------------------------*/

struct buf_2d_rec *
win_rec_cur_data_buf(win,win_type)
 struct win_rec *win;
 unsigned short win_type;
{
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win)) == NULL) return NULL;
 PRT1(printf("win_rec_cur_data_buf win_type = %x\n",win_type))
 if (win_type & MANY_SLICES_WINDOWS)
    return &(img->_2d);
   else if (win_type & HISTOGRAM_1D_WINDOWS)
    {
     return &(img->file->histo_params._2d_1d);}
   else if (win_type & HISTOGRAM_2D_WINDOWS)
    {
     return &(img->file->histo_params._2d);}
   else return NULL;
}


/*--------------------------------------------------------------------------
win_rec_save_labels - ???

 is_replace <> 0 use the current strs & replace the old ones
--------------------------------------------------------------------------*/

int
win_rec_save_labels(win,win_type,labels,is_replace,is_sec)
 struct win_rec *win;
 unsigned short win_type;
 struct strs_rec *labels;
 int is_replace,is_sec;
{
 struct strs_rec temp,*ptr;
 int err;

 if (is_sec) ptr = win_rec_get_sec_roi_labels_PTR(win,win_type);
   else ptr = win_rec_get_roi_labels_PTR(win,win_type);
 if (is_replace == 0) 
    {init_strs_rec(&temp);
     if ((err = cp_strs_rec(&temp,labels)) == NO_ERROR)
        {free_strs_rec(ptr);
         *ptr = temp;}
       else
        {free_strs_rec(&temp);
         return err;}
    }
   else
    {free_strs_rec(ptr);
     *ptr = *labels;}
 if (win_type & IMAGE_WINDOWS) 
    {if ((win->image_display != NULL) &&
         (win->image_display->dwin != NULL) &&
         (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
        {if (is_sec) 
            win->root->status |= WIN_REC_SAVE_CV_SEC_ROI_LABELS;
           else win->root->status |= WIN_REC_SAVE_CV_ROI_LABELS;
        }
       else if (is_sec) 
        win->root->status |= WIN_REC_SAVE_SEC_ROI_LABELS;
       else win->root->status |= WIN_REC_SAVE_ROI_LABELS;
    }
   else if (win_type & HISTOGRAM_WINDOW)
    if (is_sec) win->root->status |= WIN_REC_SAVE_SEC_PIXEL_TYPES;
       else win->root->status |= WIN_REC_SAVE_PIXEL_TYPES;
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_rec_label_file_access - ???

  is_which_label_file = 1 = roi_labels
  is_which_label_file = 2 = sec_roi_labels
  is_which_label_file = 3 = pixel_types
  is_which_label_file = 4 = sec_pixel_types
  is_which_label_file = 5 = pixel_type_priority
--------------------------------------------------------------------------*/

int
win_rec_label_file_access(win,is_which_label_file,mode,reason)
 struct win_rec *win;
 int is_which_label_file;
 int mode;
 char **reason;
{
 TRACE(printf("roi_labels = %s sec_roi_labels = %s pixel_types = %s sec_pixel_types = %s  pixel_type_priority_fn = %s\n",
    win->root->roi_label_fn,win->root->sec_roi_label_fn,
    win->root->pixel_type_fn,win->root->sec_pixel_type_fn,
    win->root->pixel_type_priority_fn))

 if ((is_which_label_file == 1) || (is_which_label_file == 2))
    {if ((win->image_display != NULL) &&
         (win->image_display->dwin != NULL) &&
         (win->image_display->dwin->analysis_status &
                    PIXEL_COUNT_VALUE_ANALYSIS))
        {if (is_which_label_file == 1) 
            return file_access(win->root->cv_roi_label_fn,mode,NULL,reason);
           else return file_access(win->root->cv_sec_roi_label_fn,mode,NULL,reason);
        }
       else if (is_which_label_file == 1)
        return file_access(win->root->roi_label_fn,mode,NULL,reason);
       else
        return file_access(win->root->sec_roi_label_fn,mode,NULL,reason);
    }
   else if (is_which_label_file == 3)
    return file_access(win->root->pixel_type_fn,mode,NULL,reason);
   else if (is_which_label_file == 4)
    return file_access(win->root->sec_pixel_type_fn,mode,NULL,reason);
   else
    return file_access(win->root->pixel_type_priority_fn,mode,NULL,reason);
}


/*--------------------------------------------------------------------------
win_rec_get_histo_label1 - ???
--------------------------------------------------------------------------*/

char *
win_rec_get_histo_label1(win,win_type)
 struct win_rec *win;
 unsigned short win_type;
{
 struct img_buf_rec *temp_img,*img;
 char *img_fn,*img_label,*str1,*str2,*frame_label,str3[10]; 
 char *dat,*edited;
 int err,cnt_d;

 img = win_rec_cur_img_buf(win);
 if (img == NULL) return NULL;
 if (win_type & HISTOGRAM_MULTI_D_WINDOW)
    img = pick_first_img_buf_rec_partner(img);
 img_fn = get_img_fn(img);

 img_label = get_img_label(img);
 err = NO_ERROR;
 cnt_d = 1;
 if (win_type & HISTOGRAM_MULTI_D_WINDOW)
    for (temp_img = img->partner;((temp_img != NULL) && (temp_img != img));
         temp_img = temp_img->partner)
       {cnt_d += 1;
        str1 = get_img_label(temp_img);
        if ((err = concat_strs(&str2,3,img_label,"/",str1)) != NO_ERROR)
           break;
        c_free(img_label);
        c_free(str1);
        img_label = str2;}
 if (img->file->output.status & FILE_CHANGED)
    edited = "+";
   else edited = NULL;
 if (img->file->output.status & FILE_READY) dat = "(.dat)";
   else dat = NULL;

 sprintf(str3,"%d",cnt_d);
 if (err == NO_ERROR)
    err = concat_strs(&frame_label,10,
                       img_label,":",str3,"D-HISTOGRAM",":",win->wid,
                       edited,dat,":",img_fn);
 c_free(img_fn);
 c_free(img_label);
 if (err == NO_ERROR) return frame_label;
   else return NULL;

}



/*--------------------------------------------------------------------------
win_rec_cur_slice - ???

possible value for select
--------------------------------------------------------------------------*/

struct hdr_scan_entry_rec *
win_rec_cur_slice(win)
 struct win_rec *win;
{
 return win->img_bufs[win->cur_img]->cur_slice;
}


/*--------------------------------------------------------------------------
win_rec_set_cur_slice - ???
--------------------------------------------------------------------------*/

void
win_rec_set_cur_slice(win,cur_slice)
 struct win_rec *win;
 struct hdr_scan_entry_rec *cur_slice;
{
 win->img_bufs[win->cur_img]->cur_slice = cur_slice;
}


/*--------------------------------------------------------------------------
win_rec_get_last_open_window1 - ???
--------------------------------------------------------------------------*/

struct image_display_window *
win_rec_get_last_open_window1(win,win_type)
 struct win_rec *win;
 unsigned short win_type;
{
 unsigned long  lcv;
 unsigned long  indx;
 int err;

 if (win->root->total_wins <= 1) return NULL;
 if (win_type & DISPLAY_WINDOW_3D) return NULL;
 indx = find_handle_element(win->root->wins,win->root->total_wins,
                            win,&err);
 if (err == NO_ERROR)
    {if (win_type & HISTOGRAM_WINDOW)
        if (win_is_window_open(win->image_display)) return win->image_display;

     for (lcv = indx; ;)
        {if (lcv == 0) break;
         lcv--;
         if (win_is_window_open(win->root->wins[lcv]->image_display))
            return win->root->wins[lcv]->image_display;
        }
     for (lcv = win->root->total_wins; lcv > indx + 1;)
        {if (lcv == 0) break;
         lcv--;
         if (win_is_window_open_show(win->root->wins[lcv]->image_display))
            return win->root->wins[lcv]->image_display;
        }
    }

 return NULL;

}


/*--------------------------------------------------------------------------
win_rec_get_breaker - ???
--------------------------------------------------------------------------*/

struct slice_roi_rec *
win_rec_get_breaker(win)
 struct win_rec *win;
{
 return &(win->root->breaker);
}


/*--------------------------------------------------------------------------
win_rec_get_clipboard - ???
--------------------------------------------------------------------------*/

struct slice_roi_rec *
win_rec_get_clipboard(win)
 struct win_rec *win;
{
 return &(win->root->clipboard);
}


/*--------------------------------------------------------------------------
win_rec_get_breaker_win - ???
--------------------------------------------------------------------------*/

struct image_display_window *
win_rec_get_breaker_win(win)
 struct win_rec *win;
{
 return win->root->breaker_win;
}


/*--------------------------------------------------------------------------
win_rec_set_breaker_win - ???
--------------------------------------------------------------------------*/

void
win_rec_set_breaker_win(win,breaker_win)
 struct win_rec *win;
 struct image_display_window *breaker_win;
{
 win->root->breaker_win = breaker_win;
}


/*--------------------------------------------------------------------------
win_rec_get_clipboard_win - ???
--------------------------------------------------------------------------*/

struct image_display_window *
win_rec_get_clipboard_win(win)
 struct win_rec *win;
{
 return win->root->clipboard_win;
}


/*--------------------------------------------------------------------------
win_rec_set_clipboard_win - ???
--------------------------------------------------------------------------*/

void
win_rec_set_clipboard_win(win,clipboard_win)
 struct win_rec *win;
 struct image_display_window *clipboard_win;
{
 win->root->clipboard_win = clipboard_win;
}


/*--------------------------------------------------------------------------
win_rec_get_breaker_mask - ???
--------------------------------------------------------------------------*/

struct draw_mask_rec *
win_rec_get_breaker_mask(win)
 struct win_rec *win;
{
 return &(win->root->breaker_mask);
}


/*--------------------------------------------------------------------------
win_rec_get_clipboard_mask - ???
--------------------------------------------------------------------------*/

struct draw_mask_rec *
win_rec_get_clipboard_mask(win)
 struct win_rec *win;
{
 return &(win->root->clipboard_mask);
}

/*********************
win_rec_get_file_histogram(win,histogram)
 struct win_rec *win;
 struct image_display_window **histogram;
{
 struct img_buf_rec *img;
 unsigned long  lcv;

 if ((img = win_rec_cur_img_buf(win)) == NULL)
    {*histogram = NULL;
     return CANCEL;}
 for (lcv = 0; lcv < img->file->img.num_data; lcv++)
    if ((img->file->img.data[lcv] != NULL) &&
        (img->file->img.data[lcv]->win != NULL) &&
        (img->file->img.data[lcv]->win->histogram != NULL))
       {*histogram = img->file->img.data[lcv]->win->histogram;
        return NO_ERROR;}
 *histogram = NULL;
 return NO_ERROR;
}
*******************/

/******************
win_histogram_in_use(win,histogram,is_check_cur_win)
 struct win_rec *win;
 struct image_display_window *histogram;
{
 unsigned long  lcv;

 PRT2(printf("win_histogram_in_use....begin\n"))
 for (lcv = 0; lcv < win->root.total_wins; lcv++)
    if (win->root.wins[lcv] != NULL)
       {if (!is_check_cur_win)
           if (win->root.wins[lcv] == win) continue;
        if (win->root.wins[lcv]->histogram == histogram)
           {PRT2(printf("win_histogram_in_use....1\n"))
            return 1;}
       }
 PRT2(printf("win_histogram_in_use....end 0\n"))
 return 0;
}
*********************/


/*--------------------------------------------------------------------------
win_rec_get_wids - ???
--------------------------------------------------------------------------*/

int
win_rec_get_wids(win,wids)
 struct win_rec *win;
 struct strs_rec *wids;
{
 int lcv,err;
 char str[30];

 init_strs_rec(wids);
 for (lcv = 0; lcv < win->root->total_wins; lcv++)
    {sprintf(str,"W%d",lcv + 1);
     if ((err = add_str_to_strs_rec(wids,str)) != NO_ERROR)
        {free_strs_rec(wids);
         return err;
        }
    }
 return NO_ERROR;
}


/*--------------------------------------------------------------------------
win_rec_get_display_window - ???
--------------------------------------------------------------------------*/

struct image_display_window *
win_rec_get_display_window(win,wid,status)
 struct win_rec *win;
 int wid;
 unsigned short status;
{
 if (wid >= win->root->total_wins) return NULL;
 if (status & HISTOGRAM_WINDOW)
    return win->root->wins[wid]->histogram;
   else return win->root->wins[wid]->image_display;
}


/*--------------------------------------------------------------------------
get_win_rec_by_wid_str - ???
--------------------------------------------------------------------------*/

struct win_rec *
get_win_rec_by_wid_str(win,wid_str)
 struct win_rec *win;
 char *wid_str;
{
 int wid;
 long lcv;

 if (wid_str == NULL) return NULL;
 if ((int) sscanf(wid_str,"W%d:",&wid) != 1) return NULL;
 for (lcv = 0; lcv < win->root->total_wins; lcv++)
    if (win->root->wins[lcv]->win_id == wid)
       return win->root->wins[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
AllWids - ???

if (select & 1) then include the current window
if (select & 2) then include the window only if it belongs to another file
if (select & 4) then include the window only if it belongs to the same file
--------------------------------------------------------------------------*/

int
AllWids(win,wids,is_sorted,select,win_type2)
 struct win_rec *win;
 struct strs_rec *wids;
 int is_sorted;
 int select;
 unsigned short win_type2;
{
 int err;
 long lcv;
 char *cur_str;
 struct win_rec *rwin;

 PRT(printf("AllWids(...total_wins = %d\n",win->root->total_wins);)
 for (cur_str = NULL,lcv = 0; lcv < win->root->total_wins; lcv++)
    {if (((rwin = win->root->wins[lcv]) != NULL) &&
         (rwin->image_display != NULL) &&
         (rwin->image_display->type2 & win_type2) &&
         ((rwin != win) || select))
        {if (select & 6)
            {if ((win->num_img_bufs == 0) || (rwin->num_img_bufs == 0))
                continue;
             if (select & 2)
                {if (win->img_bufs[0]->file == rwin->img_bufs[0]->file)
                    continue;}
               else if (win->img_bufs[0]->file != rwin->img_bufs[0]->file)
                continue;
            }
         if (win->root->wins[lcv]->wid != NULL)
            {if ((err = add_str_to_strs_rec(wids,
                           win->root->wins[lcv]->wid)) != NO_ERROR)
                {return err;}
            }
           else
            {PRT(printf("AllWids(...CANCEL\n");)
             return CANCEL;}
         if (win->root->wins[lcv] == win)
            {wids->cur_str = wids->num_strs - 1;
             cur_str = wids->strs[wids->cur_str];}
        }
    }
 PRT(printf("AllWids(...1...num_strs = %d\n",wids->num_strs);)

 if (is_sorted)
    {sort_strs_rec_ascendingly(wids);
     if (cur_str != NULL)
        {lcv = find_handle_element(wids->strs,wids->num_strs,cur_str,&err);
         if (err == NO_ERROR) wids->cur_str = lcv;
           else wids->cur_str = 0;}
       else wids->cur_str = 0;
    }
 return NO_ERROR;
}

