/****************************************************************************
wr_bin.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: wr_bin.c,v 1.12 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";


/* FIXME:  Not needed?
#include <time.h>
#include <sys/timeb.h>
*/

#include <xview/xview.h>
#include <xview/cms.h>
#include <xview/canvas.h>
#include <xview/panel.h>
#include <xview/notice.h>
#include <xview/wmgr.h>

#include "mri_format.h"
#include "nria_procedures.h"

/*
#define PRINT(x) printf(x); fflush(stdout);
#define TRACE(x) x; fflush(stdout);
*/
#define PRINT(x)
#define TRACE(x)



struct pixel_type_and_roi_rec
   {
    unsigned int pixel_type_indx;
    unsigned long *roi_offsets;
   };

#define CLEAN_UP_WR_BIN 0
#define SETUP_WR_BIN 1
#define GET_ALL_WR_BIN_PTR 2
#define WR_BIN_TITLE "OUTPUT .bin"

#define WR_BIN_PROCEEDING 1
struct wr_bin_rec
   {
    struct image_display_window *win;
    struct display_win_rec *dwin;
    Frame frame;
    struct strs_rec pixel_types,rois;
    Panel_item pixel_type_item,roi_item;

    Frame subframe;
    Panel panel;
    Panel_item total_processed_slices,roi_label,pixel_type_label;

    unsigned short status;
    struct buf_2d_rec map,*map_ptr,_2d;
    struct draw_mask_rec mask;
    struct hdr_scan_entry_rec *cur_slice;
    int cnt_slice;
    struct strs_rec do_pixel_types,do_rois;
    struct pixel_type_and_roi_rec *types;
    char *fn;
    FILE *fid;
    unsigned long file_size;
   };


struct all_wr_bin_recs
   {
    int num_bins;
    struct wr_bin_rec **bins;
   };


/* Functions defined in this file */
void init_wr_bin_rec(struct wr_bin_rec *bin);
void free_wr_bin_rec(struct wr_bin_rec *bin);
void init_all_wr_bin_recs(struct all_wr_bin_recs *all_bins);
void bin_cancel_it(struct wr_bin_rec *bin, int which);
void wr_bin_abort(struct wr_bin_rec *bin, int select);
void wr_bin_done_proc(Frame frame);
void cancel_wr_bin_proc(Panel_item item, Event *event);
int setup_wr_bin_subframe(struct wr_bin_rec *bin);
void wr_bin_ready_proc(Panel_item item, Event *event);
void wr_bin_cancel_proc(Panel_item item, Event *event);
void wr_bin_help_proc(Panel_item item, Event *event);
int setup_wr_bin_rec(struct wr_bin_rec *bin, struct image_display_window *win);
int setup_wr_bin_labels(struct wr_bin_rec *bin);
static Notify_value wr_bin(struct wr_bin_rec *bin, int which);
int get_wr_bin_types(struct wr_bin_rec *bin);
void free_wr_bin_types(struct wr_bin_rec *bin);
int wr_the_bin(struct wr_bin_rec *bin, int which);
struct wr_bin_rec *find_wr_bin_rec(struct all_wr_bin_recs *all_bins,
    struct image_display_window *win, struct display_win_rec *dwin);
struct wr_bin_rec *find_same_bin_file_rec(struct all_wr_bin_recs *all_bins,
    struct image_display_window *win);
int enter_wr_bin(struct image_display_window *win, int status);



/*--------------------------------------------------------------------------
init_wr_bin_rec - ???
--------------------------------------------------------------------------*/

void
init_wr_bin_rec(bin)
 struct wr_bin_rec *bin;
{
 bin->frame = 0;
 bin->win = NULL;
 init_strs_rec(&(bin->pixel_types));
 init_strs_rec(&(bin->rois));

 bin->status = 0;

 init_buf_2d_rec(&(bin->map));
 init_draw_mask_rec(&(bin->mask));
 init_buf_2d_rec(&(bin->_2d));
 bin->cur_slice = NULL;
 bin->cnt_slice = 0;
 bin->types = NULL;
 init_strs_rec(&(bin->do_pixel_types));
 init_strs_rec(&(bin->do_rois));
 bin->fn = NULL;
 bin->fid = NULL;
 bin->file_size = 0;
}


/*--------------------------------------------------------------------------
free_wr_bin_rec - ???
--------------------------------------------------------------------------*/

void
free_wr_bin_rec(bin)
 struct wr_bin_rec *bin;
{
 struct all_wr_bin_recs *all_bins;

 TRACE(("free_wr_bin_rec...\n"))
 if (bin->frame != 0) xv_destroy_safe(bin->frame);
 free_strs_rec_ptrs(&(bin->pixel_types));
 free_strs_rec_ptrs(&(bin->rois));

 free_wr_bin_types(bin);
 free_buf_2d_rec(&(bin->map));
 free_draw_mask_rec(&(bin->mask));
 free_buf_2d_rec(&(bin->_2d));

 all_bins = (struct all_wr_bin_recs *) enter_wr_bin(NULL,GET_ALL_WR_BIN_PTR);
 c_free(bin);
 DropHandleAryPtr(&(all_bins->bins),&(all_bins->num_bins),bin);
}


/*--------------------------------------------------------------------------
init_all_wr_bin_recs - ???
--------------------------------------------------------------------------*/

void
init_all_wr_bin_recs(all_bins)
 struct all_wr_bin_recs *all_bins;
{
 all_bins->num_bins = 0;
 all_bins->bins = NULL;
}



/*--------------------------------------------------------------------------
bin_cancel_it - ???
--------------------------------------------------------------------------*/

void
bin_cancel_it(bin,which)
 struct wr_bin_rec *bin;
 int which;
{

 (void) notify_set_itimer_func((Notify_client) bin,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 free_wr_bin_rec(bin);
}


/*--------------------------------------------------------------------------
wr_bin_abort - ???
--------------------------------------------------------------------------*/

#define WR_BIN_NO_ERROR 0
#define WR_BIN_ERROR 1
#define WR_BIN_NO_PIXEL_TYPES_SELECTED 2
#define WR_BIN_NO_ROIS_SELECTED 3
#define WR_BIN_WRITE_ERROR 4
#define WR_BIN_CANCEL 5

void
wr_bin_abort(bin,select)
 struct wr_bin_rec *bin;
 int select;
{
 (void) notify_set_itimer_func((Notify_client) bin,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 switch (select)
    {case WR_BIN_ERROR :
        ShowMsgStrs(bin->frame,0,NO_ERROR,0,2,
               "An error occurred when processing the binary images !!!",
               "Operation is aborted !!!",NULL,0);
        break;
     case WR_BIN_WRITE_ERROR :
        ShowMsgStrs(bin->frame,0,NO_ERROR,0,2,
               "An error occurred when writing the binary images !!!",
               "Operation is aborted !!!",NULL,0);
        break;
     case WR_BIN_NO_PIXEL_TYPES_SELECTED :
        ShowMsgStrs(bin->frame,0,NO_ERROR,0,2,
               "No pixel types have been selected !!!",
               "Operation is aborted !!!",NULL,0);
        break;
     case WR_BIN_NO_ROIS_SELECTED :
        ShowMsgStrs(bin->frame,0,NO_ERROR,0,2,
               "No ROIs have been selected !!!",
               "Operation is aborted !!!",NULL,0);
        break;
     }
 if (select)
    if (bin->fid != NULL)
       {fclose(bin->fid);
        bin->fid = NULL;
        delete_file(bin->fn);}
 notify_set_itimer_func((Notify_client) bin,(Notify_func) bin_cancel_it,
             ITIMER_REAL,&NOTIFY_POLLING_ITIMER,
             (struct itimerval *) 0);
}



/*--------------------------------------------------------------------------
wr_bin_done_proc - ???
--------------------------------------------------------------------------*/

void
wr_bin_done_proc(frame)
 Frame frame;
{
 struct wr_bin_rec *bin;

 bin = (struct wr_bin_rec *) xv_get(frame,WIN_CLIENT_DATA);
 if (!(bin->status & WR_BIN_PROCEEDING))
    free_wr_bin_rec(bin);
   else wr_bin_abort(bin,WR_BIN_CANCEL);
}


/*--------------------------------------------------------------------------
cancel_wr_bin_proc - ???
--------------------------------------------------------------------------*/

void
cancel_wr_bin_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct wr_bin_rec *bin;

 bin = (struct wr_bin_rec *) xv_get(item,PANEL_CLIENT_DATA);
 wr_bin_abort(bin,WR_BIN_CANCEL);
}


/*--------------------------------------------------------------------------
setup_wr_bin_subframe - ???
--------------------------------------------------------------------------*/

int
setup_wr_bin_subframe(bin)
 struct wr_bin_rec *bin;
{
 struct img_buf_rec *img;
 char *str;

 if ((img = win_rec_cur_img_buf(bin->win->owner)) == NULL)
    return ~NO_ERROR;
 bin->subframe = xv_create(bin->frame,FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              FRAME_DONE_PROC,wr_bin_done_proc,
              WIN_CLIENT_DATA,bin,
              FRAME_NO_CONFIRM,TRUE,0);
 if (bin->frame == 0) return NO_ERROR;
 xv_set(bin->subframe,
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,"PIXEL TYPE ANALYSIS",
              0);

 bin->panel = xv_create(bin->subframe,PANEL,
                         FRAME_INHERIT_COLORS,TRUE,
                         0);
 if (bin->panel == 0)
    {xv_destroy_safe(bin->subframe);
     bin->subframe = 0;
     return NO_ERROR;}
 bin->total_processed_slices =
     xv_create(bin->panel,PANEL_SLIDER,
	PANEL_LABEL_STRING,"# OF SLICES PROCESSED",
	PANEL_VALUE,0,PANEL_MIN_VALUE,0,
	PANEL_MAX_VALUE,img->file->slice_info.num_sroi_wins,
	PANEL_SLIDER_WIDTH,150,
        XV_X,0,XV_Y,5,
	0);
 bin->roi_label = xv_create(bin->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"CURRENT ROI LABEL = ",
              PANEL_VALUE,"",
              PANEL_VALUE_STORED_LENGTH,60,
              PANEL_VALUE_DISPLAY_LENGTH,25,
              XV_X,0,
              XV_Y,xv_rows(bin->panel,1),0);


 bin->pixel_type_label = xv_create(bin->panel,PANEL_TEXT,
              PANEL_LABEL_STRING,"PIXEL TYPE = ",
              PANEL_VALUE,"",
              PANEL_VALUE_STORED_LENGTH,60,
              PANEL_VALUE_DISPLAY_LENGTH,25,
              XV_X,0,
              XV_Y,xv_rows(bin->panel,2),0);

 str = "CANCEL";
 xv_create(bin->panel,PANEL_BUTTON,
 	           PANEL_LABEL_STRING, str,
                   PANEL_NOTIFY_PROC,cancel_wr_bin_proc,
                   PANEL_CLIENT_DATA,bin,
                   XV_X,xv_cols(bin->panel,43),
                   XV_Y,xv_rows(bin->panel,2),
                   0);

 window_fit(bin->panel);
 window_fit(bin->subframe);
 center_window(bin->subframe);
 xv_set(bin->subframe,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
wr_bin_ready_proc - ???
--------------------------------------------------------------------------*/

void
wr_bin_ready_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct wr_bin_rec *bin;
 int err;

 bin = (struct wr_bin_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (!(bin->status & WR_BIN_PROCEEDING))
    if ((err = setup_wr_bin_subframe(bin)) == NO_ERROR)
       {(void) notify_set_itimer_func((Notify_client) bin,
             (Notify_func) wr_the_bin,
             ITIMER_REAL,&NOTIFY_POLLING_ITIMER,
             (struct itimerval *) 0);
       }
}


/*--------------------------------------------------------------------------
wr_bin_cancel_proc - ???
--------------------------------------------------------------------------*/

void
wr_bin_cancel_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct wr_bin_rec *bin;

 bin = (struct wr_bin_rec *) xv_get(item,PANEL_CLIENT_DATA);
 if (!(bin->status & WR_BIN_PROCEEDING))
    (void) notify_set_itimer_func((Notify_client) bin,
             (Notify_func) bin_cancel_it,ITIMER_REAL,
             &NOTIFY_POLLING_ITIMER,
             (struct itimerval *) 0);
   else wr_bin_abort(bin,WR_BIN_CANCEL);
}


/*--------------------------------------------------------------------------
wr_bin_help_proc - ???
--------------------------------------------------------------------------*/

void
wr_bin_help_proc(item,event)
 Panel_item item;
 Event *event;
{
 struct wr_bin_rec *bin;

 bin = (struct wr_bin_rec *) xv_get(item,PANEL_CLIENT_DATA);
 ShowMsgStrs(bin->frame,0,NO_ERROR,0,5,
       "The .bin output format is M stacks of N binary images for each",
       "selected pixel type for each selected ROI, where N is the total",
       "slices and M is the total selected ROIs.",
       "The output file name is the prefix of the .dat file name",
       "concatenated with the suffix .bin",
       NULL,0);

}



/*--------------------------------------------------------------------------
setup_wr_bin_rec - ???
--------------------------------------------------------------------------*/

int
setup_wr_bin_rec(bin,win)
 struct wr_bin_rec *bin;
 struct image_display_window *win;
{
 int err;
 char *str;
 Panel panel;
/*
 Cms cms;
 struct color_rec *color;
*/
 int row,offset;

 bin->win = win;
 bin->dwin = win->dwin;
 TRACE(printf("setup_wr_bin_rec...\n"))
 if ((err = setup_wr_bin_labels(bin)) != NO_ERROR)
    {free_wr_bin_rec(bin);
     return err;}
 TRACE(printf("setup_wr_bin_rec...1\n"))
 str = win_rec_win_id_title(win->owner,WR_BIN_TITLE);
 bin->frame = xv_create(win->dwin->frame, FRAME,
              FRAME_INHERIT_COLORS,TRUE,
              /*WIN_DYNAMIC_VISUAL,TRUE,*/
              FRAME_SHOW_LABEL, TRUE,
              XV_LABEL,str,
              FRAME_NO_CONFIRM,TRUE,
              WIN_CLIENT_DATA,bin,
              FRAME_DONE_PROC,wr_bin_done_proc,
              0);
 c_free(str);
 if (bin->frame == 0)
    {free_wr_bin_rec(bin);
     return ~NO_ERROR;}
 TRACE(printf("setup_wr_bin_rec...2\n"))

 panel = xv_create(bin->frame,PANEL,0);
 if (panel == 0)
    {free_wr_bin_rec(bin);
     return ~NO_ERROR;}
 row = 5;
 offset = xv_rows(panel,1) - xv_rows(panel,0) - 10;

 xv_create(panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,bin,
           PANEL_LABEL_STRING,"OUTPUT BINARY",
           XV_X,5,XV_Y,row,
           PANEL_NOTIFY_PROC,wr_bin_ready_proc,0);
 bin->pixel_type_item = xv_create(panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_LABEL_STRING,"PIXEL TYPES",
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,5,
        PANEL_LIST_WIDTH,100,
        XV_Y,row,
        PANEL_CLIENT_DATA,bin,0);
 setup_list_items(&(bin->pixel_types),bin->pixel_type_item,0);
 bin->roi_item = xv_create(panel,PANEL_LIST,
        PANEL_LAYOUT,PANEL_VERTICAL,
        PANEL_LABEL_STRING,"ROIS",
        PANEL_CHOOSE_ONE,FALSE,
        PANEL_LIST_DISPLAY_ROWS,5,
        PANEL_LIST_WIDTH,100,
        XV_Y,row,
        PANEL_CLIENT_DATA,bin,0);
 setup_list_items(&(bin->rois),bin->roi_item,0);
 row += offset;
 TRACE(printf("setup_wr_bin_rec...3\n"))
 xv_create(panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,bin,
           PANEL_LABEL_STRING,"HELP",
           XV_X,5,XV_Y,row,
           PANEL_NOTIFY_PROC,wr_bin_help_proc,0);

 row += offset;
 xv_create(panel,PANEL_BUTTON,
           PANEL_CLIENT_DATA,bin,
           PANEL_LABEL_STRING,"Cancel",
           XV_X,5,XV_Y,row,
           PANEL_NOTIFY_PROC,wr_bin_cancel_proc,0);
 TRACE(printf("setup_wr_bin_rec...4\n"))
 window_fit(panel);
 window_fit(bin->frame);
 make_2_wins_adjacent(bin->frame,win->dwin->frame,0);
 win_set_mouse_at_center(bin->frame);
 xv_set(bin->frame,XV_SHOW,TRUE,FRAME_CLOSED,FALSE,0);

 return NO_ERROR;

}


/*--------------------------------------------------------------------------
setup_wr_bin_labels - ???
--------------------------------------------------------------------------*/

int
setup_wr_bin_labels(bin)
 struct wr_bin_rec *bin;
{
 struct img_buf_rec *img;

 TRACE(printf("setup_wr_bin_labels...\n"))
 if ((img = win_rec_cur_img_buf(bin->win->owner)) == NULL) return CANCEL;

 free_strs_rec_ptrs(&(bin->pixel_types));
 free_strs_rec_ptrs(&(bin->rois));
 cp_strs_rec_ptrs(&(bin->pixel_types),&(img->file->pixel_type.order));

 WinGetAllRoiLabelPtrs(bin->win,&(bin->rois),0,1);

 if (bin->pixel_types.num_strs == 0)
    {ShowMsgStrs(bin->win->dwin->frame,0,0,0,2,
               "Pixel types undefined yet...",
               "Opeartion to output binary images aborted !!!",NULL,0);
     return CANCEL;}
 if (bin->rois.num_strs == 0)
    add_str_ptr_to_strs_rec(&(bin->rois),WHOLE_SLICE_STR);
   else
    {add_str_ptr_to_strs_rec(&(bin->rois),ALL_ROIS_STR);
     add_str_ptr_to_strs_rec(&(bin->rois),WHOLE_SLICE_STR);}
 if (bin->rois.num_strs == 0)
    {ShowMsgStrs(bin->win->dwin->frame,0,0,0,2,
               "ROIS undefined yet...",
               "Operation to output binary images aborted !!!",NULL,0);
     return CANCEL;}
 TRACE(printf("setup_wr_bin_labels...3\n"))
 return NO_ERROR;

}


/*--------------------------------------------------------------------------
wr_bin - ???

FIXME:  This function probably needs to be typed as Notify_value and return
a value each time it is called.  -PWH 19990429
--------------------------------------------------------------------------*/

static Notify_value
wr_bin(bin,which)
 struct wr_bin_rec *bin;
 int which;
{
 struct img_buf_rec *img;
 unsigned int cnt,lcv,lb,ub;
 struct slice_roi_rec *slice_roi;
 struct int_bound_rec affected;
 int err,is_map_computed;
 struct roi_rec *roi;

 TRACE(printf("bin->cnt_slice = %d\n",bin->cnt_slice))
 if (((img = win_rec_cur_img_buf(bin->win->owner)) == NULL) ||
     (bin->cnt_slice == img->file->slice_info.num_sroi_wins))
    {wr_bin_abort(bin,WR_BIN_ERROR);
     return CANCEL;}
 xv_set(bin->total_processed_slices,PANEL_VALUE,bin->cnt_slice + 1,0);
 slice_roi = &(img->file->slice_info.sroi_wins[bin->cnt_slice]->slice_roi);
 xv_set(bin->roi_label,PANEL_VALUE,"",0);
 xv_set(bin->pixel_type_label,PANEL_VALUE,"",0);
 for (is_map_computed = 0,cnt = 0; cnt < bin->do_rois.num_strs; cnt++)
    {
     if (bin->do_rois.strs[cnt][0] == (char) 1)
        {xv_set(bin->roi_label,PANEL_VALUE,WHOLE_SLICE_STR,0);
         InitBuf2dRecData(&(bin->mask.mask._2d),(double) 1);
         setup_int_bound_rec(&affected,0,0,img->_2d.dimx - 1,img->_2d.dimy - 1);
        }
       else if (bin->do_rois.strs[cnt][0] == (char) 2)
        {xv_set(bin->roi_label,PANEL_VALUE,ALL_ROIS_STR,0);
	 /* FIXME! Removed the terminal argument below to conform to
	    the number of arguments actually expected according to
	    the definition of the function.  -PWH 19990527 */
	 GetFilledAllRoisMask(slice_roi,NULL,&(bin->mask)/*,&affected*/);
        }
       else if ((roi = get_roi(slice_roi,bin->do_rois.strs[cnt])) != NULL)
        {xv_set(bin->roi_label,PANEL_VALUE,bin->do_rois.strs[cnt],0);
         if ((err = GetFilledRoiMask(roi,NULL,
                        &(bin->mask),&affected)) != NO_ERROR)
            {wr_bin_abort(bin,WR_BIN_ERROR);
             return err;}
        }
       else
        {xv_set(bin->roi_label,PANEL_VALUE,"",0);
         xv_set(bin->pixel_type_label,PANEL_VALUE,"",0);
         continue;}
     if (!is_map_computed &&
         ((err = setup_cur_slice_map(&(bin->map),&(bin->map_ptr),img->file,
                       bin->cur_slice)) != NO_ERROR))
        {wr_bin_abort(bin,WR_BIN_ERROR);
         return err;}
       else is_map_computed = 1;

     for (lcv = 0; lcv < bin->do_pixel_types.num_strs; lcv++)
        {
         lb = ub = bin->types[lcv].pixel_type_indx;
         xv_set(bin->pixel_type_label,PANEL_VALUE,
                bin->do_pixel_types.strs[lcv],0);
         InitBuf2dRecData(&(bin->_2d),(double) .0);
         Select2dByMask(bin->map_ptr,0,0,&(bin->mask.mask._2d),
                        &affected,(double) lb,(double) ub,
                        &(bin->_2d),0,(double) 0,0,(double) 0);
         fseek(bin->fid,bin->types[lcv].roi_offsets[cnt],0);

         if (fwrite(bin->_2d.buf[0],bin->_2d.total_bytes,
                        (size_t) 1,bin->fid) != 1)
            {wr_bin_abort(bin,WR_BIN_WRITE_ERROR);
             return WRITE_ERROR;}
         bin->types[lcv].roi_offsets[cnt] += bin->_2d.total_bytes;
        }
    }
 TRACE(printf("wr_bin...end\n\n"))
 bin->cnt_slice += 1;
 bin->cur_slice = bin->cur_slice->next_slice;
}


/*--------------------------------------------------------------------------
get_wr_bin_types - ???
--------------------------------------------------------------------------*/

int
get_wr_bin_types(bin)
 struct wr_bin_rec *bin;
{
 unsigned int total,lcv,total_bytes,offset,cnt;
 int err;
 int num_rois,num_pixel_types;
 char *str;
 struct img_buf_rec *img;
 static char all_rois_str[] = {(char) 2};
 static char whole_slice_str[] = {(char) 1};

 if ((img = win_rec_cur_img_buf(bin->win->owner)) == NULL)
    {wr_bin_abort(bin,WR_BIN_ERROR);
     return CANCEL;}

 num_pixel_types = (int) xv_get(bin->pixel_type_item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_pixel_types; lcv++)
    if (xv_get(bin->pixel_type_item,PANEL_LIST_SELECTED,lcv))
       {str = (char *) xv_get(bin->pixel_type_item,PANEL_LIST_STRING,lcv);
        FindStrInHandleAryByContent(
              img->file->pixel_type.order.strs,
              img->file->pixel_type.order.num_strs,str,&err);
        if (err == NO_ERROR)
           add_str_ptr_to_strs_rec(&(bin->do_pixel_types),str);
       }
 if (bin->do_pixel_types.num_strs == 0)
    {wr_bin_abort(bin,WR_BIN_NO_PIXEL_TYPES_SELECTED);
     return CANCEL;}

 num_rois = (int) xv_get(bin->roi_item,PANEL_LIST_NROWS);
 for (lcv = 0; lcv < num_rois; lcv++)
    if (xv_get(bin->roi_item,PANEL_LIST_SELECTED,lcv))
       {str = (char *) xv_get(bin->roi_item,PANEL_LIST_STRING,lcv);
        if (str_cmp(str,ALL_ROIS_STR) == 0)
           add_str_ptr_to_strs_rec(&(bin->do_rois),all_rois_str);
          else if (str_cmp(str,WHOLE_SLICE_STR) == 0)
           add_str_ptr_to_strs_rec(&(bin->do_rois),whole_slice_str);
          else add_str_ptr_to_strs_rec(&(bin->do_rois),str);
       }
 if (bin->do_rois.num_strs == 0)
    {wr_bin_abort(bin,WR_BIN_NO_ROIS_SELECTED);
     return CANCEL;}

 total = 0;
 get_ptr_memory(&(bin->types),&total,bin->do_pixel_types.num_strs,
            (size_t) sizeof(struct pixel_type_and_roi_rec),&err);
 if (err != NO_ERROR) return err;
 for (lcv = 0; lcv < bin->do_pixel_types.num_strs; lcv++)
    bin->types[lcv].roi_offsets = NULL;

 for (lcv = 0; lcv < bin->do_pixel_types.num_strs; lcv++)
    {total = 0;
     get_ptr_memory(&(bin->types[lcv].roi_offsets),&total,
                    bin->do_rois.num_strs,(size_t) sizeof(unsigned long),&err);
     if (err != NO_ERROR) return err;
    }

 total_bytes = (unsigned int) GetRowBytes(img->_2d.dimx,1) * img->_2d.dimy *
                              img->file->slice_info.num_sroi_wins;
 for (offset = 0,lcv = 0; lcv < bin->do_pixel_types.num_strs; lcv++)
    {
     bin->types[lcv].pixel_type_indx = FindStrInHandleAryByContent(
              img->file->pixel_type.order.strs,
              img->file->pixel_type.order.num_strs,
              bin->do_pixel_types.strs[lcv],&err) + 1;
     for (cnt = 0; cnt < bin->do_rois.num_strs; cnt++)
        {bin->types[lcv].roi_offsets[cnt] = offset;
         offset += total_bytes;
        }
    }
 bin->file_size = offset;
 if (((err = build_fn(&(bin->fn),img->file->output.dirfn,
         img->file->output.fn,".bin")) != NO_ERROR) ||
     ((bin->fid = fopen(bin->fn,"w")) == NULL) ||
     (file_set_size(bin->fid,bin->file_size) != NO_ERROR))
    {wr_bin_abort(bin,WR_BIN_ERROR);
     return CANCEL;}

 return NO_ERROR;
}


/*--------------------------------------------------------------------------
free_wr_bin_types - ???
--------------------------------------------------------------------------*/

void
free_wr_bin_types(bin)
 struct wr_bin_rec *bin;
{
 unsigned int lcv;

 if (bin->types != NULL)
    {
     for (lcv = 0; lcv < bin->do_pixel_types.num_strs; lcv++)
        if (bin->types[lcv].roi_offsets != NULL)
           c_free(bin->types[lcv].roi_offsets);
     /* FIXME:  Whatever bin->pixel_types points at should be freed, but
	c_free(bin->pixel_types); is not the right method. -PWH 19990226 */
    }
 free_strs_rec_ptrs(&(bin->do_pixel_types));
 free_strs_rec_ptrs(&(bin->do_rois));
 if (bin->fid != NULL) fclose(bin->fid);
 c_free(bin->fn);

}


/*--------------------------------------------------------------------------
wr_the_bin - ???
--------------------------------------------------------------------------*/

int
wr_the_bin(bin,which)
 struct wr_bin_rec *bin;
 int which;
{
 struct img_buf_rec *img;
 int err;

 (void) notify_set_itimer_func((Notify_client) bin,NOTIFY_FUNC_NULL,ITIMER_REAL,
             (struct itimerval *) 0,(struct itimerval *) 0);
 (void) notify_set_itimer_func((Notify_client) bin,(Notify_func) wr_bin,
             ITIMER_REAL,&NOTIFY_POLLING_ITIMER,
             (struct itimerval *) 0);

 if ((img = win_rec_cur_img_buf(bin->win->owner)) == NULL)
    {wr_bin_abort(bin,WR_BIN_ERROR);
     return CANCEL;}
 bin->status |= WR_BIN_PROCEEDING;
 get_wr_bin_types(bin);
 /* FIXME!!  Added a final argument "0" to the following line so that
    it matches the number of arguments in the definition. I make o
    promises that this is the correct value.  -PWH 19990603 */
 get_slice_info("a",img,0,&(bin->cur_slice),0);
 bin->cnt_slice = 0;
 if (((err = get_draw_mask_rec(&(bin->mask),
                     img->_2d.dimx,img->_2d.dimy)) != NO_ERROR) ||
     ((err = SetupBuf2dRec(&(bin->_2d),
                 img->_2d.dimx,img->_2d.dimy,1,1)) != NO_ERROR))
    {wr_bin_abort(bin,WR_BIN_ERROR);
    }
 return err;
}


/*--------------------------------------------------------------------------
find_wr_bin_rec - ???
--------------------------------------------------------------------------*/

struct wr_bin_rec *
find_wr_bin_rec(all_bins,win,dwin)
 struct all_wr_bin_recs *all_bins;
 struct image_display_window *win;
 struct display_win_rec *dwin;
{
 int lcv;

 for (lcv = 0; lcv < all_bins->num_bins; lcv++)
    if ((all_bins->bins[lcv]->win == win) &&
        (all_bins->bins[lcv]->dwin == dwin))
       return all_bins->bins[lcv];
 return NULL;
}


/*--------------------------------------------------------------------------
find_same_bin_file_rec - ???
--------------------------------------------------------------------------*/

struct wr_bin_rec *
find_same_bin_file_rec(all_bins,win)
 struct all_wr_bin_recs *all_bins;
 struct image_display_window *win;
{
 int lcv;
 struct input_file_rec *f1;
 struct img_buf_rec *img;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return NULL;
 f1 = img->file;
 for (lcv = 0; lcv < all_bins->num_bins; lcv++)
    {if ((img = win_rec_cur_img_buf(all_bins->bins[lcv]->win->owner)) != NULL)
        if (img->file == f1)
           return all_bins->bins[lcv];
    }
 return NULL;
}


/*--------------------------------------------------------------------------
enter_wr_bin - ???
--------------------------------------------------------------------------*/

int
enter_wr_bin(win,status)
 struct image_display_window *win;
 int status;
{
 static struct all_wr_bin_recs all_bins;
 struct wr_bin_rec *bin;
 static char first_time = 1;
 int err,define;
 struct img_buf_rec *img;

 TRACE(printf("enter_wr_bin....\n"))
 err = NO_ERROR;
 if (status == GET_ALL_WR_BIN_PTR)
    {if (first_time) return 0;
       else return (unsigned long) &all_bins;}     /* FIXME:  ptr as long */
  else if (status == CLEAN_UP_WR_BIN)
   {if (!first_time)
       if ((bin = find_wr_bin_rec(&all_bins,win,win->dwin)) != NULL)
          free_wr_bin_rec(bin);
    return NO_ERROR;}

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if ((define = is_all_pixel_type_map_ready(img->file)) != 2)
    {if (define == 1)
        ShowMsgStrs(win->dwin->frame,0,0,0,2,
               "Pixel types for all slice are not all defined yet...",
               OPERATION_ABORTED,NULL,0);
       else ShowMsgStrs(win->dwin->frame,0,0,0,2,
               "Pixel types are defined for only some slices...",
               OPERATION_ABORTED,NULL,0);
     return CANCEL;}

 if (first_time)
    {init_all_wr_bin_recs(&all_bins);
     first_time = 0;}
   else
    {if ((bin = find_wr_bin_rec(&all_bins,win,win->dwin)) != NULL)
        {xv_set(bin->frame,XV_SHOW,TRUE,WIN_ALARM,0);
         win_set_mouse_at_center(bin->frame);
         wmgr_top(bin->frame);
         return NO_ERROR;}

     if ((bin = find_same_bin_file_rec(&all_bins,win)) != NULL)
        free_wr_bin_rec(bin);
/*
        {if (bin->status & WR_BIN_PROCEEDING)
            {xv_set(bin->frame,WIN_ALARM,0);
             return NO_ERROR;}
         bin->win = win;
         bin->dwin = win->dwin;
         xv_set(bin->frame,XV_OWNER,win->dwin->frame,XV_SHOW,TRUE,WIN_ALARM,0);
         str = win_rec_win_id_title(win->owner,WR_BIN_TITLE);
         xv_set(bin->frame,XV_LABEL,str,0);
         c_free(str);
         wmgr_top(bin->frame);
         win_set_mouse_at_center(bin->frame);

         return NO_ERROR;
        }
*/
    }

 get_handle_memory(&(all_bins.bins),&(all_bins.num_bins),1,
     (size_t) sizeof(struct wr_bin_rec),&err);
 if (err != NO_ERROR) return err;
 bin = all_bins.bins[all_bins.num_bins - 1];
 /* FIXME!!  The function init_bin_rec is defined elsewhere to take
    a struct bin_rec as an argument, not a wr_bin_rec.  -PWH 19990706 */
 init_bin_rec(bin);
 if ((err = setup_wr_bin_rec(bin,win)) != NO_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when setting up",
               "   the output .bin window !!!",NULL,0);
    }

 return err;
}

