/****************************************************************************
wr_ntxt.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: wr_ntxt.c,v 1.6 1999/07/07 17:41:20 hughett Exp $ Release $Name: nria_1_0_6 $";

#include "mri_format.h"
#include "text_format.h"
#include "nria_procedures.h"



/* Functions defined in this file */
int file_save_pixel_type_text_to_file(struct input_file_rec *file,
    int to_printer);
int win_save_pixel_type_text_to_file(struct image_display_window *win,
    int to_printer);
int show_temp_text_file(struct image_display_window *win);
int win_print_text_to_temp_file(struct image_display_window *win);
int win_save_text_to_file(struct image_display_window *win);
int win_save_text_to_file_and_printer(struct image_display_window *win);



/*--------------------------------------------------------------------------
file_save_pixel_type_text_to_file - ???
--------------------------------------------------------------------------*/

int
file_save_pixel_type_text_to_file(file,to_printer)
 struct input_file_rec *file;
 int to_printer;
{
 char *fn,*str;
 int err;

 if ((err = build_fn(&fn,file->output.dirfn,file->output.fn,
          TXT_SUFFIX)) != NO_ERROR)
    return FILE_NAME_ERROR;

 file->text.file = file;
 if ((err = save_pixel_type_text_to_file(fn,&(file->text))) == NO_ERROR)
    {if (to_printer)
       {if (concat_strs(&str,2,"lpr ",fn) == NO_ERROR)
          {
           system(str);
           c_free(str);}
       }
    }

 c_free(fn);
 return err;

}


/*--------------------------------------------------------------------------
win_save_pixel_type_text_to_file - ???
--------------------------------------------------------------------------*/

int
win_save_pixel_type_text_to_file(win,to_printer)
 struct image_display_window *win;
 int to_printer;
{
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (!(img->file->text.format.status & OUT_FORMAT_DEFINED))
    {ShowMsgStrs(win->dwin->frame,0,CANCEL,0,3,
               "Sorry....txt file has not been computed !!!",
               "Use the option \"analyze all slices\" to compute it first",
               "The operation is aborted !!!",NULL,0);
     return CANCEL;}
 if ((err = file_save_pixel_type_text_to_file(img->file,to_printer)) ==
       FILE_NAME_ERROR)
    {ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "Bad .txt file name !!!",
               "The operation is aborted !!!",NULL,0);
     return err;}
   else if (err == CANCEL)
    ShowMsgStrs(win->dwin->frame,0,err,0,3,
               "Unable to save the text file !!!",
               "Check your text output format !!!",
               "The operation is aborted !!!",NULL,0);
   else if (err != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,2,
               "An error occured when saving the text file!!!",
               "The operation is aborted !!!",NULL,0);

 return err;

}


/*--------------------------------------------------------------------------
show_temp_text_file - ???
--------------------------------------------------------------------------*/

int
show_temp_text_file(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 char *str1,*str,*suffix,*text_temp_fn;
 void *fmt;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 str = str1 = NULL;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    {text_temp_fn = img->file->count.text_temp_fn;
     fmt = &(img->file->count);
     suffix = COUNT_SUFFIX;}
   else
    {suffix = TXT_SUFFIX;
     fmt = &(img->file->text);
     text_temp_fn = img->file->text.analysis.text_temp_fn;}
 if (((err = build_fn(&str,img->file->dirfn,img->file->fn,"")) == NO_ERROR) &&
     ((err = concat_strs(&str1,2,str,suffix)) == NO_ERROR))
    err = enter_edit_file(win->dwin->frame,fmt,
                   str1,text_temp_fn,0,NULL,NULL,1);
 c_free(str);
 c_free(str1);
 return err;
}


/*--------------------------------------------------------------------------
win_print_text_to_temp_file - ???
--------------------------------------------------------------------------*/

int
win_print_text_to_temp_file(win)
 struct image_display_window *win;
{
 struct img_buf_rec *img;
 int err;

 if ((img = win_rec_cur_img_buf(win->owner)) == NULL) return CANCEL;
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    err = PrintCountOutputToTempFile(&(img->file->count));
   else err = print_pixel_type_text_to_temp_file(&(img->file->text));
 if (err != NO_ERROR)
    ShowMsgStrs(win->dwin->frame,0,err,0,3,
               "Unable to generate the text file !!!",
               "Check your text output format !!!",
               "The operation is aborted !!!",NULL,0);

 return err;
}


/*--------------------------------------------------------------------------
win_save_text_to_file - ???
--------------------------------------------------------------------------*/

int
win_save_text_to_file(win)
 struct image_display_window *win;
{
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    return win_save_count_output_to_file(win,0);
   else return win_save_pixel_type_text_to_file(win,0);
}


/*--------------------------------------------------------------------------
win_save_text_to_file_and_printer - ???
--------------------------------------------------------------------------*/

int
win_save_text_to_file_and_printer(win)
 struct image_display_window *win;
{
 if (win->dwin->analysis_status & PIXEL_COUNT_VALUE_ANALYSIS)
    return win_save_count_output_to_file(win,1);
   else return win_save_pixel_type_text_to_file(win,1);
}
