/****************************************************************************
getrange.c - ???

Author:  DRW 960215

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.

This program searches an image file for the largest values.  Currently it
assumes that the image is made of short-sized pixels (2-byte data).

To compile, use "cc -o `uname -r`/getrange.bin getrange.c".
To make the object file, use "cc -c `uname -r`/getrange.o getrange.c"
                         and "cc `uname -r`/getrange `uname -r`/getrange.o"
****************************************************************************/

static const char rcsid[] = "$Id: getrange.c,v 1.5 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>

#include <sys/fcntl.h>

#define MY_BUFSIZ 65536

#define NUMTOSAVE 10


/*--------------------------------------------------------------------------
main - ???
---------------------------------------------------------------------------*/

int
main (int argc, char *argv[]) {
  FILE *fp;
  unsigned short maxvals[NUMTOSAVE];
  unsigned short slices[NUMTOSAVE];
  unsigned short minval = 65535;
  unsigned short minslice = 0;
  unsigned short curval;
  unsigned char buf[MY_BUFSIZ * 2];
  int curptr = 0;
  int buflen = 0;
  int slicenum = 0;
  int filearg = 1;
  int pixelbytes = 2;

  if (strcmp(argv[1], "-8") == 0) {
    pixelbytes = 1;
    filearg = 2;
  }

  if ((fp = fopen(argv[filearg], "rb")) == NULL) {
    perror(argv[filearg]);
    exit(1);
  }

#if 0
  printf ("filename = \"%s\"\n", argv[filearg]);
  printf ("fp = %p\n", (void *) fp);
  printf ("buf = %p\n", (void *) buf);
  printf ("sizeof(short) = %d\n", sizeof(unsigned short));
  printf ("*fp = %d\n", *fp);
#endif

  for (curptr = 0; curptr < NUMTOSAVE; curptr++) {
    maxvals[curptr] = 0; slices[curptr] = 0;
  }

  while ((buflen = fread(buf, pixelbytes, MY_BUFSIZ, fp)) > 0) {
    slicenum++;
    for (curptr = 0; curptr < buflen; curptr += pixelbytes) {
      if (pixelbytes == 1) {
	curval = (unsigned short) buf[curptr];
      } else {
	curval = (buf[curptr] * 256 + buf[curptr+1]);
      }
      if (curval > maxvals[0]) {
	maxvals[9] = maxvals[8]; slices[9] = slices[8];
	maxvals[8] = maxvals[7]; slices[8] = slices[7];
	maxvals[7] = maxvals[6]; slices[7] = slices[6];
	maxvals[6] = maxvals[5]; slices[6] = slices[5];
	maxvals[5] = maxvals[4]; slices[5] = slices[4];
	maxvals[4] = maxvals[3]; slices[4] = slices[3];
	maxvals[3] = maxvals[2]; slices[3] = slices[2];
	maxvals[2] = maxvals[1]; slices[2] = slices[1];
	maxvals[1] = maxvals[0]; slices[1] = slices[0];
	maxvals[0] = curval; slices[0] = slicenum;
/*	printf ("New max val. %d on slice %d.\n", maxvals[0], slicenum); */
      }
      if (buf[curptr] < minval)
	minval = curval; minslice = slicenum;
    }

  }

  for (curptr = 0; curptr < 10; curptr++) {
    printf ("	Max value #%d = %d on slice #%d.%s\n", curptr, maxvals[curptr], slices[curptr],
	    (maxvals[curptr] > 2000 ? "   ** ALERT: Check image (value > 2000) **" : ""));
  }  
  printf ("	Min value = %d on slice #%d.\n", minval, minslice);

  fclose (fp);
  exit(0);
}

