/****************************************************************************
nria_hdr.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: nria_hdr.c,v 1.5 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <math.h>

#include <sys/types.h>

#include "typedef.h"
#include "analyze_hdr.h"
#include "ia_hdr.h"
#include "error_constants.h"
#include "debug.h"
#include "nria_lib.h"

/* nria_hdr.c */
int nriaHdrToAnalyzeHdr(struct hdr_rec *nhdr, struct dsr *dsr);



/*--------------------------------------------------------------------------
nriaHdrToAnalyzeHdr - ???
--------------------------------------------------------------------------*/

int
nriaHdrToAnalyzeHdr( nhdr, dsr )
     struct hdr_rec * nhdr;
     struct dsr * dsr;
{
  initAnalyzeHdr( dsr );

  if (nhdr->data_info.default_datafn != NULL)
    str_ncpy( dsr->hk.db_name,
	      sizeof( dsr->hk.db_name ),
	      nhdr->data_info.default_datafn );

  dsr->dime.dim[1] = nhdr->data_info.dimx;
  dsr->dime.dim[2] = nhdr->data_info.dimy;
  dsr->dime.dim[3] = nhdr->data_info.max_scans;

  if (nhdr->data_info.var_use_status & INPUT_DATA_FLOAT)
    dsr->dime.datatype = DT_FLOAT;
  else if (nhdr->data_info.var_use_status & INPUT_DATA_DOUBLE)
    dsr->dime.datatype = DT_DOUBLE;
  else if (nhdr->data_info.pixel_depth_bits == 8)
    dsr->dime.datatype = DT_UNSIGNED_CHAR;
  else
    dsr->dime.datatype = DT_SIGNED_SHORT;

  dsr->dime.bitpix = nhdr->data_info.pixel_depth_bits;

  dsr->dime.pixdim[1] = nhdr->data_info.xpixel_size;
  dsr->dime.pixdim[2] = nhdr->data_info.ypixel_size;
  dsr->dime.pixdim[3] = nhdr->data_info.pixel_thickness;

#if 0
  /*  For MRVBR, not SPM  */
  dsr->dime.pixdim[4] = nhdr->data_info.spacing;
  dsr->dime.plane_type = nhdr->data_info.plane_type;
  dsr->dime.unused2 = nhdr->data_info.unused2;
  dsr->dime.var_use_status = nhdr->data_info.var_use_status;
  dsr->dime.num_echoes = nhdr->data_info.num_echoes;
  dsr->dime.unused3 = nhdr->data_info.unused3;
  dsr->dime.unused4 = nhdr->data_info.unused4;
  dsr->dime.unused5 = nhdr->data_info.unused5;
  dsr->dime.unused6 = nhdr->data_info.unused6;
  dsr->dime.unused7 = nhdr->data_info.unused7;
  dsr->dime.tr = nhdr->data_info.tr;
  if (nhdr->data_info.te != NULL)
    str_ncpy(dsr->dime.te,sizeof(dsr->dime.te),nhdr->data_info.te);
#endif

  dsr->dime.glmax = (unsigned long) nhdr->data_info.max_pixel;
  dsr->dime.glmin = (unsigned long) nhdr->data_info.min_pixel;

#if 0
  /*  For MRVBR, not SPM  */
  if (nhdr->data_info.patient.name != NULL)
    str_ncpy( dsr->hist.patient.name,
	      sizeof(dsr->hist.patient.name),
	      nhdr->data_info.patient.name );
  if (nhdr->data_info.patient.ssnum != NULL)
    str_ncpy( dsr->hist.patient.ssnum,
	      sizeof(dsr->hist.patient.ssnum),
	      nhdr->data_info.patient.ssnum );
  if (nhdr->data_info.patient.patient_id != NULL)
    str_ncpy( dsr->hist.patient.patient_id,
	      sizeof(dsr->hist.patient.patient_id),
	      nhdr->data_info.patient.patient_id );
  if (nhdr->data_info.patient.study_num != NULL)
    str_ncpy(dsr->hist.patient.study_num,
	     sizeof(dsr->hist.patient.study_num),
	     nhdr->data_info.patient.study_num);
  if (nhdr->data_info.patient.patient_num != NULL)
    str_ncpy(dsr->hist.patient.patient_num,
	     sizeof(dsr->hist.patient.patient_num),
	     nhdr->data_info.patient.patient_num);
  dsr->hist.patient.age = nhdr->data_info.patient.age;
  dsr->hist.patient.sex = nhdr->data_info.patient.sex;
  dsr->hist.patient.height = nhdr->data_info.patient.height;
  dsr->hist.patient.weight = nhdr->data_info.patient.weight;
  if (nhdr->data_info.description != NULL)
    str_ncpy( dsr->hist.comment,
	      sizeof( dsr->hist.comment ),
	      nhdr->data_info.description );
#endif

  if (nhdr->data_info.date_of_study != NULL)
    str_ncpy( dsr->hist.exp_date,
	      sizeof( dsr->hist.exp_date ),
	      nhdr->data_info.date_of_study );
  if (nhdr->data_info.time_of_study != NULL)
    str_ncpy( dsr->hist.exp_time,
	      sizeof( dsr->hist.exp_time ),
	      nhdr->data_info.time_of_study );

  return NO_ERROR;
}


