/****************************************************************************
ria2pixmap.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: ria2pixmap.c,v 1.10 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";


#include <stdio.h>
#include <sys/types.h>

#include "ia_hdr.h"
#include "common.h"
#include "error_constants.h"
#include "mark_hdr.h"
#include "str_def.h"
#include "input.h"

/* FIXME:  This program needs to know all sorts of nria internals.
   Including the whole header files is easy but not really right.
   -PWH 19990706 */
#include "mri_format.h"
#include "nria_procedures.h"

/* FIXME:  Next header must follow mri_format.h to get the ndat_v3
   prototypes.  -PWH 19990706 */
#include "nria_lib.h"

#include <math.h>        /* Placed late to avoid BITSPERBYTE problem */

/*
csh lria2pixmap.com
#define PRT(x) x; fflush(stdout);
#define PRT1(x) x; fflush(stdout);
*/
#define PRT(x)
#define PRT1(x)




/* ria2pixmap.c */
int sort_val_proc(const void *val1, const void *val2);
int mri2pixmap(FILE *fid, char *imgfn, struct hdr_rec *hdr,
    struct buf_2d_rec **slice_maps, unsigned long num_slice_maps,
    struct strs_rec *labels);
int process_mri2pixmap(char *pixmapfn, char *imgfn, struct hdr_rec *hdr,
    struct strs_rec *labels);
int process(char *mrihdrfn, char *prefix, char *pixfn);
void prog_usage(int argc, char *argv[]);
void main(int argc, char *argv[]);
void free_img_rec(struct img_rec *img);
void init_img_rec(struct img_rec *img, struct input_file_rec *file);


/* Required by NRIA library if DEBUG defined; controls debugging output */
int debugFlag = 0;


/*--------------------------------------------------------------------------
sort_val_proc - ???
--------------------------------------------------------------------------*/

int 
sort_val_proc(val1,val2)
 const void *val1,*val2;
{
 if (*((double *) val1) > *((double *) val2)) return 1;
 if (*((double *) val1) < *((double *) val2)) return -1;
 return 0;
}


/*--------------------------------------------------------------------------
mri2pixmap - ???
--------------------------------------------------------------------------*/

int
mri2pixmap(fid,imgfn,hdr,slice_maps,num_slice_maps,labels)
 FILE *fid;	
 char *imgfn;
 struct hdr_rec *hdr;
 struct buf_2d_rec **slice_maps;
 unsigned long num_slice_maps;
 struct strs_rec *labels;
{
 unsigned long lcv,num_types,total_types,row,col,cnt,indx;
 double val,*types;
 struct buf_2d_rec _2d;
 int err;

 PRT(printf("mri2pixmap  num_slice_maps = %d num_strs = %d\n",
            num_slice_maps,labels->num_strs))
 num_types = total_types = 0;
 if ((err = get_ptr(&types,&total_types,labels->num_strs,
             (size_t) sizeof(*types))) != NO_ERROR)
    {printf("memory error when setting up the type buffer...err = %d !!!\n",err);
     return err;}
 PRT(printf("mri2pixmap end 1\n"))

 init_buf_2d_rec(&_2d);
 if ((err = SetupBuf2dRec(&_2d,hdr->data_info.dimx,hdr->data_info.dimy,
        hdr->data_info.pixel_depth_bits,
        InputDataTypeToBufType(&(hdr->data_info)))) != NO_ERROR)
    {printf("memory error when setting up the image buffer...err = %d !!!\n",err);
     c_free(types);
     return err;}
 PRT(printf("mri2pixmap *** num_types = %d\n",num_types))

 printf("Processing : Checking slice pixel types...Please wait...\n");
 for (lcv = 0; (lcv < num_slice_maps) && (err == NO_ERROR); lcv++)
    {
     fseek(fid,hdr->scans[lcv].img_addr,0);
     if (fread(_2d.buf[0],(size_t) _2d.total_bytes,(size_t) 1,fid) != 1)
    	{printf("Error reading mri slice #%ld from %s\n",lcv + 1,imgfn);
         err = READ_ERROR;
         break;
        }
     PRT(printf("processing slice# %d\n",lcv+1);)
     for (row = 0; (row < _2d.dimy) && (err == NO_ERROR); row++)
        for (col = 0; col < _2d.dimx; col++)
            {val = _2d.GetVal(&_2d,row,col);
             if (num_types == 0) indx = 0;
               else if (obj_binary_search(types,num_types,sizeof(*types),&val,
                    sort_val_proc,&indx) == NO_ERROR)
                continue;
             if (num_types == total_types)
                {printf("Sorry !!! The # of pixel types must be = %ld\n",
			total_types);
                 printf("Too many pixel types...index = %ld\n",indx);
                 printf("row = %ld col = %ld current pixel type = %f\n",
			row,col,val);
                 printf("Currently defined pixel type values...\n");
                 for (cnt = 0; cnt < num_types; cnt++)
                    {printf("%ld) pixel type = %f\n",cnt + 1,types[cnt]);
                    }
                 PRT(for (cnt = 0; cnt < num_types; cnt++)
                        if (val == types[cnt])
                           {printf("val = %f == types[%d] = %f\n",val,cnt,types[cnt]);
                            break;}
                     printf("cnt = %d\n",cnt);)

                 printf("\n");
                 err = CANCEL;
                 break;}
             for (cnt = num_types; cnt > indx; cnt--)
                types[cnt] = types[cnt - 1];
             types[indx] = val;
             num_types += 1;

             PRT(printf("\n%d) indx = %d val = %f\n",num_types,indx,val);
                 for (cnt = 0; cnt < num_types; cnt++)
                    {printf("%d) val = %f\n",cnt + 1,types[cnt]);
                    }
                 printf("\n");)

            }
    }
 if (err == NO_ERROR)
    {printf("Processing : Setting slice pixel types...Please wait...\n");
     printf("num_types = %ld\n",num_types);
     for (cnt = 0; cnt < num_types; cnt++)
         {printf("%ld) val = %f  TYPE = %s\n",cnt + 1,types[cnt],
               labels->strs[cnt]);
         }
     printf("\n");

     for (lcv = 0; (lcv < num_slice_maps) && (err == NO_ERROR); lcv++)
        {
         fseek(fid,hdr->scans[lcv].img_addr,0);
         if (fread(_2d.buf[0],(size_t) _2d.total_bytes,(size_t) 1,fid) != 1)
    	    {printf("Error reading mri slice #%ld from %s\n",lcv + 1,imgfn);
             err = READ_ERROR;
             break;
            }
         for (row = 0; (row < _2d.dimy) && (err == NO_ERROR); row++)
            for (col = 0; col < _2d.dimx; col++)
               {val = _2d.GetVal(&_2d,row,col);
                if (obj_binary_search(types,num_types,sizeof(*types),&val,
                    sort_val_proc,&indx) == NO_ERROR)
                   {slice_maps[lcv]->SetVal(slice_maps[lcv],row,col,
                         (double) (indx + 1));
                   }
                  else 
                   {printf("Illegal pixel types...\n");
                    err = CANCEL;
                    break;}
               }
         if (err == NO_ERROR) 
            {slice_maps[lcv]->status4 |= BUF_DATA_VALID;
             PRT1(MinMax2dValues(slice_maps[lcv],
                   0,(double) .0,(double) .0,
                    &min4,&max4);
                  printf("lcv = %d min4 = %f max4 = %f\n",
                        lcv,min4,max4);)
            }
        }
    }
 free_buf_2d_rec(&_2d);
 c_free(types);
 PRT(printf("mri2pixmap end err = %d\n",err))
 return err;
}


/*--------------------------------------------------------------------------
process_mri2pixmap - ???
--------------------------------------------------------------------------*/

int
process_mri2pixmap(pixmapfn,imgfn,hdr,labels)
 char *pixmapfn,*imgfn;
 struct hdr_rec *hdr;
 struct strs_rec *labels;
{
 int err;
 FILE *fid,*fout;	
 unsigned long lcv,num_slice_maps,depth;
 struct buf_2d_rec **slice_maps;
 struct pixmap_hdr_rec pixmaphdr;

 PRT(printf("process_mri2pixmap  1\n"))
 if ((fid = fopen(imgfn,"r")) == NULL)
    {
     printf("error opening mri input img file %s...\n",imgfn);
     return FILE_ACCESS_ERROR;
    }
 if ((fout = fopen(pixmapfn,"w")) == NULL)
    {fclose(fid);
     printf("error creating the pixmap file %s...\n",pixmapfn);
     return FILE_ACCESS_ERROR;
    }
   else fclose(fout);
 num_slice_maps = NumberOfSliceCuts(&(hdr->data_info));
 PRT(printf("process_mri2pixmap  num_slice_maps = %d\n",num_slice_maps))
 if ((err = get_handle(&slice_maps,NULL,num_slice_maps,
               sizeof(**(slice_maps)))) != NO_ERROR)
    {fclose(fid);
     
     delete_file(pixmapfn);
     printf("memory error when setting up slices = %d !!!\n",err);
     return err;}
 for (lcv = 0; lcv < num_slice_maps; lcv++)
    init_buf_2d_rec(slice_maps[lcv]);
 PRT(printf("process_mri2pixmap  3\n"))
 depth = find_num_bits_needed((unsigned long) labels->num_strs + 1);

 for (lcv = 0; lcv < num_slice_maps; lcv++)
    if ((err = SetupBuf2dRec(slice_maps[lcv],
                    hdr->data_info.dimx,hdr->data_info.dimy,
                    depth,0)) != NO_ERROR)
       {printf("memory error when setting up slices = %d !!!\n",err);
        break;}
 PRT(printf("process_mri2pixmap  depth = %d\n",depth))
 if (err == NO_ERROR)
    if ((err = mri2pixmap(fid,imgfn,hdr,slice_maps,num_slice_maps,labels)) == NO_ERROR)
       {init_pixmap_hdr_rec(&pixmaphdr);
        pixmaphdr.status |= PIXEL_TYPE_SETUP_USER;
        PRT(printf("process_mri2pixmap  5\n"))
        if ((err = WrPixmap(pixmapfn,labels,
             slice_maps,num_slice_maps,&pixmaphdr)) != NO_ERROR)
           printf("error writing to the pixmap file = %s !!!\n",pixmapfn);
          else printf("pixmap file = %s created !!!\n",pixmapfn);
        free_pixmap_hdr_rec(&pixmaphdr);}

 PRT(printf("process_mri2pixmap  err = %d\n",err))
 for (lcv = 0; lcv < num_slice_maps; lcv++)
    {if (slice_maps[lcv] != NULL) 
        {free_buf_2d_rec(slice_maps[lcv]);
         c_free(slice_maps[lcv]);}
    }
 c_free(slice_maps);

 fclose(fid);
 if (err != NO_ERROR)
    delete_file(pixmapfn);
 PRT(printf("process_mri2pixmap end err = %d\n",err))

 return err;
}


/*--------------------------------------------------------------------------
process - ???
--------------------------------------------------------------------------*/

int
process(mrihdrfn,prefix,pixfn)
 char *mrihdrfn,*prefix,*pixfn;
{
 int err;
 struct hdr_rec hdr;
 struct mark_hdr mark_hdr;
 struct strs_rec labels;
 char *imgfn,*str,*pixmapfn;

 PRT(printf("process 1\n"))
 init_hdr_rec(&hdr);
 if ((err = rd_the_hdr(mrihdrfn,&hdr)) != NO_ERROR)
    {free_hdr_rec(&hdr);
     init_mark_hdr(&mark_hdr);
     if ((err = load_hdr_file(mrihdrfn,&mark_hdr)) != NO_ERROR)
        {printf("Error reading %s : neither a *.nhdr file nor a *.hdr file...\n",
             mrihdrfn);
         return READ_ERROR;}
       else if ((err = SetupHdrFromMarkHdr(&hdr,&mark_hdr)) != NO_ERROR)
        {printf("Error setting up the header file %s : ...\n",mrihdrfn);
         free_hdr_rec(&hdr);
         return CANCEL;}
    }
 if (hdr.data_info.num_echoes != 1)
    {printf("Invalid header...the # of echoes must be 1 !!!\n");
     free_hdr_rec(&hdr);
     return CANCEL;}
 PRT(printf("process 2\n"))
 init_strs_rec(&labels);
 if (pixfn == NULL)
    {if ((err = build_strs_rec(&labels,0,4,"BACKGROUND","csf.TYPE",
               "white matter","gray matter")) != NO_ERROR)
        {free_strs_rec(&labels);
         free_hdr_rec(&hdr);
         return err;}
    }
   else if ((err = rd_ascii_file_strs_to_strs_rec(pixfn,&labels,0)) != NO_ERROR)
    {printf("Error reading the pixel type labels from %s\n",pixfn);
     printf("For the pixel type labels separated by blanks,\n");
     printf("please enclose them with double quotes...\n");
     free_strs_rec(&labels);
     free_hdr_rec(&hdr);
     return err;}

 PRT(printf("process 3\n"))
 PRT(pr_strs_rec(&labels))
 str = imgfn = pixmapfn = NULL;
 if (((err = cp_str(&str,mrihdrfn)) != NO_ERROR) ||
     ((err = drop_suffix(str)) != NO_ERROR) ||
     ((err = concat_strs(&imgfn,2,str,".img")) != NO_ERROR) ||
     ((err = drop_dirfn(str)) != NO_ERROR) ||
     ((err = concat_strs(&pixmapfn,3,prefix,str,".pixmap")) != NO_ERROR))
    {
     printf("memory error = %d !!!\n",err);
    }
   else err = process_mri2pixmap(pixmapfn,imgfn,&hdr,&labels);

 PRT(printf("process err = %d\n",err))
 c_free(str);
 c_free(imgfn);
 c_free(pixmapfn);
 free_strs_rec(&labels);
 free_hdr_rec(&hdr);
 return err;
}


/*--------------------------------------------------------------------------
prog_usage - ???
--------------------------------------------------------------------------*/

void
prog_usage(argc,argv)
 int argc;
 char *argv[];
{
 if ((argc != 3) && (argc != 4))
    {printf("\nUsage : %s ria.nhdr prefix [pixel-type-labels.fn]\n",argv[0]);
     printf("\n");
     printf("if pixel-type-labels.fn is missing then\n");
     printf("   4 pixel types are assumed in the following sequence :-\n");
     printf("     a. BACKGROUND\n");
     printf("     b. csf\n");
     printf("     c. white matter\n");
     printf("     d. gray matter\n");
     printf("  else\n");
     printf("   pixel-type-labels.fn has the pixel type labels each on a line\n");
     printf("   the # of pixel types depends on the # of labels in the file\n");
     printf("\n");
     printf("Example 1 : %s ria.nhdr new\n",argv[0]);
     printf("   Output ==> newria.pixmap\n\n");
     printf("\n");
     printf("Example 2 : %s \"*.nhdr\" new\n",argv[0]);
     printf("   Output ==> new*.pixmap\n\n");
     printf("\n");
     printf("Example 3 : %s \"*.hdr\" new\n",argv[0]);
     printf("   Output ==> new*.pixmap\n\n");
     printf("\n");
     printf("Example 4 : %s \"*.*hdr\" new pixel-type-labels.fn\n",argv[0]);
     printf("   Output ==> new*.pixmap\n\n");
     printf("\n");
     printf("The *.*hdr file must be 1-echo *.*hdr file !!!\n");
     printf("\n");
     printf("Note : if you use '*' in the file specification, please\n");
     printf("       enclose that file specification by double quotes.\n");
     exit(1);}
}


/*--------------------------------------------------------------------------
main - ???
--------------------------------------------------------------------------*/

void
main(argc,argv)
 int	argc;
 char	*argv[];
{
 int err;
 char **fns;
 unsigned int num_fns;
 unsigned long lcv;
 char *dirfn,fn[200],*pixfn;

 prog_usage(argc,argv);
 dirfn = (char *) locate_dirfn(argv[1]);
 drop_dirfn(argv[1]);
 if (dirfn == NULL) dirfn = ".";
 if ((err = get_fns(dirfn,NULL,0,0,NULL,&fns,&num_fns,1,argv[1],
         NULL,0,0,NULL)) != NO_ERROR)
    exit(err);

 if (num_fns == 0)
    {printf("Sorry...No file names...\n");
     sprintf(fn,"%s/%s",dirfn,argv[1]);
     printf("...Fn specification processed = %s\n",fn);
    }
   else
    {printf("\n");
     if (argc == 4) pixfn = argv[3];
       else pixfn = NULL;
     for (lcv = 0; lcv < num_fns; lcv++)
        {sprintf(fn,"%s/%s",dirfn,fns[lcv]);
         printf("%ld) reading %s\n",lcv,fn);
         if ((err = process(fn,argv[2],pixfn)) != NO_ERROR)
            {printf("error = %d processing fn = %s...\n",err,fn);
            }
        }
    }

 exit(0);
}



/********************************************************************** 
The following two routines are copied from the NRIA file img_buf_opr.c
with sufficient modifications so that they do not require XView or the
GUI to serve the present purpose.  In particular, free_img_rec is not
needed here, so it is just converted to a stub that will complain if
called; it is called from the NRIA source file input_file_rec.c, which
we need for other functions.  On the other hand, init_img_rec needs no
changes at all.
************************************************************************/


/*--------------------------------------------------------------------------
free_img_rec - ???
--------------------------------------------------------------------------*/

void
free_img_rec(
   struct img_rec *img)
{  
   fprintf(stderr, "The function free_img_rec is not yet implemented.\n");
   exit(EXIT_FAILURE);
}



/*--------------------------------------------------------------------------
init_img_rec - ???
--------------------------------------------------------------------------*/

void
init_img_rec(
   struct img_rec *img,
   struct input_file_rec *file)
{
   img->file = file;
   img->data = NULL;
   img->num_data = 0;
}
