/****************************************************************************
text2ria.c - ???

Copyright (c) 1998 Trustees of the University of Pennsylvania
See the file COPYING for license terms.
****************************************************************************/

static const char rcsid[] = "$Id: text2ria.c,v 1.6 1999/07/07 18:07:14 hughett Exp $ Release $Name: nria_1_0_6 $";

#include <stdio.h>
#include <sys/types.h>

#include "typedef.h"
#include "mark_hdr.h"
#include "ia_hdr.h"
#include "error_constants.h"
#include "common_constants.h"
#include "nria_lib.h"


/* text2ria.c */
void prog_usage(int argc, char *argv[]);
void main(int argc, char *argv[]);


/*--------------------------------------------------------------------------
prog_usage - explain how to use this program
--------------------------------------------------------------------------*/

void
prog_usage(argc,argv)
    int argc;
    char *argv[];
{
    if ((argc != 3) && (argc != 4)) {
	printf("Usage : %s text_spec_file output [input.hdr]\n",argv[0]);
	printf("Example 1 : %s text_to_hdr.dat new_mri10010a\n",argv[0]);
	printf("\n");
	printf("Example 2 : %s text_to_hdr.dat new_mri10010a mri10010a.nhdr\n",
	       argv[0]);
	printf("Input text specification file : text_to_hdr.dat\n");
	printf("Input .hdr file : mri10010a.nhdr....optional\n");
	printf("\n");
	printf("Output .hdr file : new_mri10010a.hdr --- mrvbr header\n");
	printf("Output .hdr file : new_mri10010a.nhdr --- ria header\n");
	exit(1); }
}


/*--------------------------------------------------------------------------
main
---------------------------------------------------------------------------*/

void
main(argc,argv)
    int argc;
    char *argv[];
{
    int err;

    prog_usage(argc, argv);
    if (argc == 3) {
	if ((err = construct_hdr_from_text(argv[1],argv[2],NULL)) != NO_ERROR)
	    printf("error id = %d....hdr not constructed...\n",err);
    }
    else if ((err = construct_hdr_from_text(argv[1],argv[2],argv[3])) != NO_ERROR)
	printf("error id = %d....hdr not constructed...\n",err);

    exit(err);
}
